/**
 * Copyright (c) 2014, 2016, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */

define(['./DvtToolkit', './DvtAxis', './DvtLegend', './DvtOverview'], function(dvt) {
  // Internal use only.  All APIs and functionality are subject to change at any time.

!function(e){e.Chart=function(e,t,i){this.Init(e,t,i)},e.Obj.createSubclass(e.Chart,e.BaseComponent),e.Chart.newInstance=function(t,i,r){return new e.Chart(t,i,r)},e.Chart.getDefaults=function(e){return(new o).getDefaults(e)},e.Chart.prototype.Init=function(t,r,a){e.Chart.superclass.Init.call(this,t,r,a),this.Defaults=new o(t),this.EventManager=new i(this),this.EventManager.addListeners(this),e.Agent.isTouchDevice()||this.EventManager.setKeyboardHandler(this.CreateKeyboardHandler(this.EventManager)),this.setId("chart1000"+Math.floor(1e9*Math.random())),this.legend=null,this.xAxis=null,this.yAxis=null,this.y2Axis=null,this.overview=null,this.xScrollbar=null,this.yScrollbar=null,this.dragButtons=null,this.pieChart=null,this.pieCenterDiv=null,this.Peers=[],this.SeriesStyleArray=[],this._numFrontObjs=0,this._numSelectedObjsInFront=0,this._dataLabels=null,this._rawOptions=null},e.Chart.prototype.GetComponentDescription=function(){var t=this.getOptions(),i=e.Bundle.getTranslation(t,"componentName",e.Bundle.UTIL_PREFIX,"CHART"),r="",a=e.Bundle.getTranslatedString(e.Bundle.UTIL_PREFIX,"ARIA_LABEL_DESC_DELIMITER");return t.title.text&&(r+=this.Options.title.text,t.subtitle.text&&(r+=a+this.Options.subtitle.text)),t.footnote.text&&(r=0==r.length?this.Options.footnote.text:r.concat(a,this.Options.footnote.text)),r.length>0?e.Bundle.getTranslation(t,"labelAndValue",e.Bundle.UTIL_PREFIX,"COLON_SEP_LIST",[i,r]):i},e.Chart.prototype.SetOptions=function(t){t?(this._rawOptions=t,this.Options=this.Defaults.calcOptions(t),this.getOptionsCache().clearCache(),H.processDataObject(this),(e.Agent.isEnvironmentTest()||z.isScatterBubble(this)&&H.getSeriesCount(this)*H.getGroupCount(this)>te.FILTER_THRESHOLD_SCATTER_BUBBLE)&&(this.Options.animationOnDisplay="none",this.Options.animationOnDataChange="none")):this.Options||(this.Options=this.GetDefaults());var i=this.Options.selectionMode;this._selectionHandler="single"==i?new e.SelectionHandler(this.getCtx(),e.SelectionHandler.TYPE_SINGLE):"multiple"==i?new e.SelectionHandler(this.getCtx(),e.SelectionHandler.TYPE_MULTIPLE):null,this.EventManager.setSelectionHandler(this._selectionHandler);var r=this.Options._spb;if(r)for(var a in this._popupBehaviors={},r)for(var s=r[a],n=0;n<s.length;n++){this._popupBehaviors[a]||(this._popupBehaviors[a]=[]);var o=s[n],l=o.popupId,h=o.triggerType,u=o.alignId,g=o.align;this._popupBehaviors[a].push(new e.ShowPopupBehavior(l,h,u,g))}},e.Chart.prototype.render=function(t,i,r){this.getCache().clearCache();var a=this.getCtx(),s=this.Options?this.Options.animationOnDataChange:"none",n="none"!=s?new D(this):null,o=this.__cacheChartFocus();this._container&&this.__cleanUp(),this.SetOptions(t),isNaN(i)||isNaN(r)||(this.Width=i,this.Height=r);var l=new e.Container(a);this.addChild(l),J.render(this,l,new e.Rectangle(0,0,this.Width,this.Height)),z.isSpark(this)&&this.EventManager.removeListeners(this),this.StopAnimation();var h=V.getAnimationOnDisplay(this),u=V.getAnimationDuration(this),g=new e.Rectangle(0,0,this.Width,this.Height),d=!1;if(this._container){if("none"!=s&&t)if(this.Animation=e.BlackBoxAnimationHandler.getCombinedAnimation(a,s,this._container,l,g,u),this.Animation)d=!0;else if("auto"==s&&this.getPlotArea()){var c=this.__getPlotAreaSpace();this._delContainer=te.createClippedGroup(this,this._container,new e.Rectangle(0,0,c.w,c.h)),this.Animation=E.createAnimation(n,this,s,u,this._delContainer),this._delContainer.getNumChildren()>0&&this.getPlotArea().addChild(this._delContainer)}}else"none"!=h&&(this.Animation=e.BlackBoxAnimationHandler.getInAnimation(a,h,l,g,u),this.Animation||"auto"!=h||(this.Animation=T.createAnimation(this,h,u)));this.Animation?(this.EventManager.removeListeners(this),e.Playable.appendOnEnd(this.Animation,this._onAnimationEnd,this),this.Animation.play(),this._oldContainer=this._container,!d&&this._oldContainer&&this._oldContainer.removeFromParent()):this._container&&(this._container.removeFromParent(),this._container.destroy(),this._container=null),this._container=l,this._dataCursor=J.renderDataCursor(this),this.UpdateAriaAttributes(),this.__restoreChartFocus(o),this.Animation||this.RenderComplete()},e.Chart.prototype.__cleanUp=function(){this._dataCursor&&(this.removeChild(this._dataCursor),this._dataCursor=null),this.EventManager&&(this.EventManager.hideHoverFeedback(),this.EventManager.setPanZoomHandler(null),this.EventManager.setMarqueeZoomHandler(null),this.EventManager.setMarqueeSelectHandler(null),this.EventManager.panButton=null,this.EventManager.zoomButton=null,this.EventManager.selectButton=null),this.pieCenterDiv&&(this.getCtx().getContainer().removeChild(this.pieCenterDiv),this.pieCenterDiv=null),this.Peers=[],this.xScrollbar=null,this.yScrollbar=null,this.dragButtons&&(this.removeChild(this.dragButtons),this.dragButtons.destroy(),this.dragButtons=null),this._plotArea=null,this._areaContainer=null,this._dataLabels=null,this.getCache().clearCache()},e.Chart.prototype.__cleanUpAxisAndPlotArea=function(){this.EventManager.hideHoverFeedback(),this.Peers=[],this.xAxis&&(this._container.removeChild(this.xAxis),this.xAxis.destroy()),this.yAxis&&(this._container.removeChild(this.yAxis),this.yAxis.destroy()),this.y2Axis&&(this._container.removeChild(this.y2Axis),this.y2Axis.destroy()),this._plotArea&&this._plotArea==this._panZoomTarget?this._plotArea.setVisible(!1):this._plotArea&&(this._container.removeChild(this._plotArea),this._plotArea.destroy()),this._plotArea=null,this.getCache().clearCache()},e.Chart.prototype._onAnimationEnd=function(){this._oldContainer&&(this._oldContainer.removeFromParent(),this._oldContainer.destroy(),this._oldContainer=null),this._delContainer&&(this._delContainer.removeFromParent(),this._delContainer.destroy(),this._delContainer=null),this.AnimationStopped||this.RenderComplete(),this.EventManager.addListeners(this),this.Animation=null,this.AnimationStopped=!1},e.Chart.prototype.CreateKeyboardHandler=function(e){return new r(e,this)},e.Chart.prototype.getAutomation=function(){return new t(this)},e.Chart.prototype.getValuesAt=function(e,t){var i=this.__getPlotAreaSpace(),r=e-i.x,a=t-i.y,s=z.isPolar(this),n=z.isHorizontal(this);if(s){r-=i.w/2,a-=i.h/2;var o=Math.sqrt(r*r+a*a),l=Math.atan2(r,-a);return l<0&&(l+=2*Math.PI),{x:this.xAxis?this.xAxis.getValueAt(l):null,y:this.yAxis?this.yAxis.getValueAt(o):null}}return{x:this.xAxis?this.xAxis.getValueAt(n?a:r):null,y:this.yAxis?this.yAxis.getValueAt(n?r:a):null,y2:this.y2Axis?this.y2Axis.getValueAt(n?r:a):null}},e.Chart.prototype.filter=function(e,t){var i="out"==t?"hidden":"visible";G.setVisibility(this,e,i),this.render(this.Options)},e.Chart.prototype.highlight=function(t){this.getOptions().highlightedCategories=e.JsonUtils.clone(t),e.CategoryRolloverHandler.highlight(t,this.getObjects(),"any"==this.getOptions().highlightMatch),this.legend&&this.legend.highlight(t),this.pieChart&&this.pieChart.highlight(t),this.overview&&this.overview.getBackgroundChart().highlight(t)},e.Chart.prototype.select=function(t){this.getOptions().selection=e.JsonUtils.clone(t);var i=H.getInitialSelection(this);G.setInitialSelection(this,i),this.pieChart&&this.pieChart.setInitialSelection()},e.Chart.prototype.positionDataCursor=function(t){var i=this.getEventManager().getDataCursorHandler();if(i){if(t){var r=this.xAxis&&null!=t.x?this.xAxis.getCoordAt(t.x):null,a=null;if(z.isBLAC(this)?this.yAxis&&null!=t.y?a=this.yAxis.getBoundedCoordAt(t.y):this.y2Axis&&null!=t.y2&&(a=this.yAxis.getBoundedCoordAt(t.y2)):a=this.yAxis&&null!=t.y?this.yAxis.getCoordAt(t.y):null,null!=r&&null!=a){var s=this.__getPlotAreaSpace(),n=te.convertAxisCoord(this,new e.Point(r,a),s);return void i.processMove(new e.Point(s.x+n.x,s.y+n.y),!0)}}i.processEnd(!0)}},e.Chart.prototype.processEvent=function(t,i){var r=t.type;if("categoryHide"==r||"categoryShow"==r)this.filter(t.category,"categoryHide"==r?"out":"in");else if("categoryHighlight"==r)this!=i&&this.highlight(t.categories),this.legend&&this.legend!=i&&this.legend.processEvent(t,i);else if("selection"==r)t=this._processSelectionEvent(t);else if(r==e.PanZoomEvent.TYPE)t=this._processPanZoomEvent(t);else if(r==e.MarqueeEvent.TYPE)t=this._processMarqueeEvent(t);else if(r==e.OverviewEvent.TYPE){var a=t.getSubType();if(a==e.OverviewEvent.SUBTYPE_PRE_RANGECHANGE)return;var s=a==e.OverviewEvent.SUBTYPE_SCROLL_TIME||a==e.OverviewEvent.SUBTYPE_SCROLL_END||a==e.OverviewEvent.SUBTYPE_RANGECHANGE;t=this._processScrollbarEvent(t.getNewX1(),t.getNewX2(),s,i)}else if(r==e.SimpleScrollbarEvent.TYPE)t=this._processScrollbarEvent(t.getNewMin(),t.getNewMax(),t.getSubtype()==e.SimpleScrollbarEvent.SUBTYPE_END,i);else{if("ready"==r&&this!=i)return;"adfShowPopup"==r&&(t=this._processShowPopupEvent(t))}if(t){if("selection"==(r=t.type)){var n,o,l=this.getOptions(),h=l.selection,u=H.getCurrentSelection(this);t.complete&&(l.selection=u),h=h||[],u=u||[];var g={};for(n=0;n<h.length;n++)g[h[n].id]=!0;var d={};for(o=0;o<u.length;o++)d[u[o].id]=!0;var c={};for(o=0;o<u.length;o++){var p=u[o].id;g[p]||(c[p]=!0)}var _={};for(n=0;n<h.length;n++){var f=h[n].id;d[f]||(_[f]=!0)}t.addedSet=c,t.removedSet=_;for(var S=0;S<t.selection.length;S++)G.addEventData(this,t.selection[S]);t.component=this.getOptions()._widgetConstructor}else"drill"==r&&(G.addEventData(this,t),t.component=this.getOptions()._widgetConstructor);this.dispatchEvent(t)}},e.Chart.prototype._processSelectionEvent=function(t){var i=G.processIds(this,t.selection);return this._updateOverviewSelection(),e.EventFactory.newChartSelectionEvent(i,!0)},e.Chart.prototype._processPanZoomEvent=function(t){var i=t.getSubtype();return i==e.PanZoomEvent.SUBTYPE_PAN_START||i==e.PanZoomEvent.SUBTYPE_PINCH_START?(e.Agent.isTouchDevice()&&this._panZoomTarget!=this._plotArea&&(this._container.removeChild(this._panZoomTarget),this._panZoomTarget=this._plotArea),null):(this._lastPanZoomEvent?(t.dxMin+=this._lastPanZoomEvent.dxMin,t.dxMax+=this._lastPanZoomEvent.dxMax,t.dyMin+=this._lastPanZoomEvent.dyMin,t.dyMax+=this._lastPanZoomEvent.dyMax):e.Context.requestAnimationFrame(e.Obj.createCallback(this,this._animatePanZoomEvent)),this._lastPanZoomEvent=t,null)},e.Chart.prototype._animatePanZoomEvent=function(){var t=this._lastPanZoomEvent;this._lastPanZoomEvent=null;var i,r,a=t.getSubtype(),s=a==e.PanZoomEvent.SUBTYPE_PAN_END||a==e.PanZoomEvent.SUBTYPE_ZOOM||a==e.PanZoomEvent.SUBTYPE_PINCH_END;(G.isLiveScroll(this)?(i=G.getAxisBoundsByDelta(this,t.dxMin,t.dxMax,t.dyMin,t.dyMax),this._setScrollbarViewport(i),this._setViewport(i,s)):(i=G.getAxisBoundsByDelta(this,t.dxMinTotal,t.dxMaxTotal,t.dyMinTotal,t.dyMaxTotal),this._setScrollbarViewport(i),s&&this._setViewport(i,s)),s&&(J._setEventHandlers(this),this._panZoomTarget!=this._plotArea&&(this._container.removeChild(this._panZoomTarget),this._panZoomTarget=null)),s||!i.unchanged)&&(r=z.isBLAC(this)?e.EventFactory.newChartViewportChangeEvent(s,i.xMin,i.xMax,i.startGroup,i.endGroup,null,null):e.EventFactory.newChartViewportChangeEvent(s,i.xMin,i.xMax,null,null,i.yMin,i.yMax),this.dispatchEvent(r))},e.Chart.prototype._processMarqueeEvent=function(t){var r,a=t.getSubtype(),s=this.EventManager;if(G.adjustBounds(t),s.getDragMode()==i.DRAG_MODE_SELECT){var n=s.getSelectionHandler();if(a==e.MarqueeEvent.SUBTYPE_START)this._initSelection=t.ctrlKey?n.getSelectedIds():[];else{var o=G.getBoundedObjects(this,t);n.processInitialSelections(this._initSelection,this.getChartObjPeers()),n.processGroupSelection(o,!0)}var l=n.getSelectedIds();r=G.getAxisBounds(this,t,!1);var h=a==e.MarqueeEvent.SUBTYPE_END,u=e.EventFactory.newChartSelectionEvent(l,h,r.xMin,r.xMax,r.startGroup,r.endGroup,r.yMin,r.yMax,r.y2Min,r.y2Max);return a==e.MarqueeEvent.SUBTYPE_END&&this._updateOverviewSelection(),u}return s.getDragMode()==i.DRAG_MODE_ZOOM?a!=e.MarqueeEvent.SUBTYPE_END?null:(r=G.getAxisBounds(this,t,!0),this._setViewport(r,!0),this._setScrollbarViewport(r),J._setEventHandlers(this),z.isBLAC(this)?e.EventFactory.newChartViewportChangeEvent(!0,r.xMin,r.xMax,r.startGroup,r.endGroup,null,null):e.EventFactory.newChartViewportChangeEvent(!0,r.xMin,r.xMax,null,null,r.yMin,r.yMax)):null},e.Chart.prototype._processScrollbarEvent=function(t,i,r,a){return this._lastScrollbarEvent||e.Context.requestAnimationFrame(e.Obj.createCallback(this,this._animateScrollbarEvent)),this._lastScrollbarEvent={start:t,end:i,actionDone:r,source:a},null},e.Chart.prototype._animateScrollbarEvent=function(){var t=this._lastScrollbarEvent.start,i=this._lastScrollbarEvent.end,r=this._lastScrollbarEvent.actionDone,a=this._lastScrollbarEvent.source;this._lastScrollbarEvent=null;var s=a==this.yScrollbar?this.yAxis:this.xAxis,n=G.getActualMinMax(s,t,i);if(t=n.min,i=n.max,(G.isLiveScroll(this)||r)&&(a==this.yScrollbar?this._setViewport({yMin:t,yMax:i},r):this._setViewport({xMin:t,xMax:i,unchanged:n.unchanged},r)),r||!n.unchanged){var o;if(a==this.yScrollbar)o=e.EventFactory.newChartViewportChangeEvent(r,null,null,null,null,t,i,null,null);else{var l=G.getAxisStartEndGroup(this.xAxis,t,i);o=e.EventFactory.newChartViewportChangeEvent(r,t,i,l.startGroup,l.endGroup,null,null,null,null)}this.dispatchEvent(o)}},e.Chart.prototype._processShowPopupEvent=function(t){if("mouseHover"!=t.triggerType&&this.isSelectionSupported()&&this.getSelectionHandler().getSelectedCount()>0){var i=G.processIds(this,this.getSelectionHandler().getSelectedIds());(t=e.EventFactory.newAdfShowPopupEvent(t.showPopupBehavior,t.launcherBounds,t.launcherId))[e.BaseComponentEvent.CLIENT_ROW_KEY]=i}return t},e.Chart.prototype._updateOverviewSelection=function(){if(this.overview){var e=this.overview.getBackgroundChart();e.getOptions().selection=H.getCurrentSelection(this),e.render()}},e.Chart.prototype.changeOption=function(t,i,r){this.getOptions()[t]=i,this.dispatchEvent(e.EventFactory.newOptionChangeEvent(t,i,r))},e.Chart.prototype.registerObject=function(e){this.Peers.push(e)},e.Chart.prototype.getObjects=function(){return this.Peers},e.Chart.prototype.getChartObjPeers=function(){for(var e=[],t=0;t<this.Peers.length;t++)this.Peers[t]instanceof a&&e.push(this.Peers[t]);return e},e.Chart.prototype.getRefObjPeers=function(){for(var e=[],t=0;t<this.Peers.length;t++)this.Peers[t]instanceof s&&e.push(this.Peers[t]);return e},e.Chart.prototype.getObject=function(e,t){for(var i=0;i<this.Peers.length;i++)if(this.Peers[i]instanceof a&&this.Peers[i].getSeriesIndex()==e&&this.Peers[i].getGroupIndex()==t)return this.Peers[i];return null},e.Chart.prototype.getWidth=function(){return this.Width},e.Chart.prototype.getHeight=function(){return this.Height},e.Chart.prototype.getSeriesStyleArray=function(){return this.SeriesStyleArray},e.Chart.prototype.getPlotArea=function(){return this._plotArea},e.Chart.prototype.setPlotArea=function(e){this._plotArea=e},e.Chart.prototype.getType=function(){return this.getOptions().type},e.Chart.prototype.getSkin=function(){return this.getOptions().skin},e.Chart.prototype.getGapWidthRatio=function(){var e=this.getOptions();return null!==e.layout.gapWidthRatio?e.layout.gapWidthRatio:Math.min(this.Width/400,1)},e.Chart.prototype.getGapHeightRatio=function(){var e=this.getOptions();return null!==e.layout.gapHeightRatio?e.layout.gapHeightRatio:Math.min(this.Height/300,1)},e.Chart.prototype.getSelectionHandler=function(){return this._selectionHandler},e.Chart.prototype.isSelectionSupported=function(){return!!this._selectionHandler},e.Chart.prototype.getShowPopupBehaviors=function(e){return this._popupBehaviors?this._popupBehaviors[e]:null},e.Chart.prototype.bringToFrontOfSelection=function(e){var t=e.getParent();if(t){var i=t.getNumChildren();if(i-this._numFrontObjs>1){t.removeChild(e);var r=i-this._numFrontObjs-1;t.addChildAt(e,r)}}e.isSelected()&&e.isHoverEffectShown()||this._numSelectedObjsInFront++},e.Chart.prototype.pushToBackOfSelection=function(e){this._numSelectedObjsInFront>0&&this._numSelectedObjsInFront--;var t=e.getParent();if(t){var i=t.getNumChildren()-this._numFrontObjs-1-this._numSelectedObjsInFront;i>=0&&(t.removeChild(e),t.addChildAt(e,i))}},e.Chart.prototype.setNumFrontObjs=function(e){this._numFrontObjs=e},e.Chart.prototype.getShapesForViewSwitcher=function(e){var t={};if(this._currentMarkers&&this.Peers)for(var i=0;i<this._currentMarkers.length;i++){var r=this._currentMarkers[i];if(r)for(var a=0;a<r.length;a++){var s=r[a];if(s)for(var n=0;n<this.Peers.length;n++){var o=this.Peers[n],l=o.getDisplayables();if(l&&l.length>0&&l[0]==s){var h=o.getId();if(h){var u=h.getId();if(u){t[u]=s;break}}}}}}else this.pieChart&&(t=this.pieChart.getShapesForViewSwitcher(e));return t},e.Chart.prototype._setViewport=function(e,t){!t&&e.unchanged||(null!=e.xMax&&(this.Options.xAxis.viewportMax=e.xMax),null!=e.xMin&&(this.Options.xAxis.viewportMin=e.xMin),z.isBLAC(this)?(this.Options.xAxis.viewportStartGroup=null,this.Options.xAxis.viewportEndGroup=null,this.Options._initialZoomed=!1):(null!=e.yMax&&(this.Options.yAxis.viewportMax=e.yMax),null!=e.yMin&&(this.Options.yAxis.viewportMin=e.yMin)),this.Options._duringZoomAndScroll=!t,J.rerenderAxisAndPlotArea(this,this._container))},e.Chart.prototype._setScrollbarViewport=function(e){if(this.xAxis&&null!=e.xMin&&null!=e.xMax){var t=this.xAxis.actualToLinear(e.xMin),i=this.xAxis.actualToLinear(e.xMax);this.overview&&this.overview.setViewportRange(t,i),this.xScrollbar&&this.xScrollbar.setViewportRange(t,i)}if(this.yAxis&&null!=e.yMin&&null!=e.yMax){var r=this.yAxis.actualToLinear(e.yMin),a=this.yAxis.actualToLinear(e.yMax);this.yScrollbar&&this.yScrollbar.setViewportRange(r,a)}},e.Chart.prototype.__setAxisSpace=function(e){var t,i;this._axisSpace=e,N.isAxisRendered(this,"x")?(t=.8*e.w,i=e.h-4*N.getTickLabelHeight(this,"x")):N.isAxisRendered(this,"y")?(t=e.w,i=e.h-N.getTickLabelHeight(this,"y")):(t=e.w,i=e.h),this._radius=Math.min(t,i)/2},e.Chart.prototype.__getAxisSpace=function(){return this._axisSpace},e.Chart.prototype.__setPlotAreaSpace=function(e){this._plotAreaSpace=e},e.Chart.prototype.__getPlotAreaSpace=function(){return this._plotAreaSpace},e.Chart.prototype.__setAreaContainer=function(e){this._areaContainer=e},e.Chart.prototype.__getAreaContainer=function(){return this._areaContainer},e.Chart.prototype.getRadius=function(){return this._radius},e.Chart.prototype.showDragButtons=function(){this.dragButtons&&this.dragButtons.setVisible(!0)},e.Chart.prototype.hideDragButtons=function(){this.dragButtons&&this.dragButtons.setVisible(!1)},e.Chart.prototype.addDataLabel=function(e){this.getDataLabels().push(e)},e.Chart.prototype.getDataLabels=function(){return this._dataLabels||(this._dataLabels=[]),this._dataLabels},e.Chart.prototype.__cacheChartFocus=function(){var e=this.EventManager.getFocus();if(e)var t=e.isShowingKeyboardFocusEffect();if(this.xAxis){var i=this.xAxis.getKeyboardFocus();if(i)var r=i.isShowingKeyboardFocusEffect()}if(this.legend){var a=this.legend.getKeyboardFocus();if(a)var s=a.isShowingKeyboardFocusEffect()}return{chartFocus:e,chartShowingFocusEffect:t,axisFocus:i,axisShowingFocusEffect:r,legendFocus:a,legendShowingFocusEffect:s}},e.Chart.prototype.__restoreChartFocus=function(e){if(!z.isOverview(this)&&!z.isSpark(this)){var t=[this];if(this.xAxis&&this.xAxis.isNavigable()&&t.push(this.xAxis),this.legend&&this.legend.isNavigable()&&t.push(this.legend),this.getCtx().setKeyboardFocusArray(t),e.chartFocus){for(var i=G.getKeyboardNavigables(this),r=!1,a=0;a<i.length;a++){var s=i[a].getId();if(s instanceof n&&s.equals(e.chartFocus.getId())){this.EventManager.setFocusObj(i[a]),e.chartShowingFocusEffect&&i[a].showKeyboardFocusEffect(),r=!0;break}}r||this.EventManager.setFocusObj(this.EventManager.getKeyboardHandler().getDefaultNavigable(i))}e.axisFocus&&(this.xAxis.setKeyboardFocus(e.axisFocus,e.axisShowingFocusEffect),e.axisShowingFocusEffect&&this.getCtx().setCurrentKeyboardFocus(this.xAxis)),e.legendFocus&&(this.legend.setKeyboardFocus(e.legendFocus,e.legendShowingFocusEffect),e.legendShowingFocusEffect&&this.getCtx().setCurrentKeyboardFocus(this.legend))}},e.Chart.prototype.getRawOptions=function(){return this._rawOptions},e.Chart.prototype.processActiveDataChanges=function(t){for(var i=e.JsonUtils.clone(this.Options),r=this.Options,a=0;a<t.length;a++)this._processActiveDataChange(t[a]);this.Options=i,this.render(r)},e.Chart.prototype._processActiveDataChange=function(e){var t=e.type;"u"==t?this._processActiveDataUpdate(e):"ia"==t||"ib"==t?this._processActiveDataInsert(e):"d"==t&&this._processActiveDataDelete(e)},e.Chart.prototype._processActiveDataUpdate=function(e){for(var t=e.data,i=0;i<t.length;i++){var r=this._findDataItemById(e.id,t[i]._id);if(r)for(var a in t[i])"_id"!=a&&(r.item[a]=t[i][a])}},e.Chart.prototype._processActiveDataInsert=function(t){for(var i=t.data,r=0;r<i.length;r++){this.clearCache();var a=t.insertId,s=i[r].group,n=i[r].series,o=H.getSeriesCount(this),l=H.getGroupCount(this),h=H.getSeriesIndex(this,n),u=H.getGroupIndex(this,s);if(h>=0&&u>=0)(p=H.getSeriesItem(this,h).items)[u]={id:t.id},e.Chart._copyActiveDataProperties(i[r],p[u]);else if(u>=0){var g=new Array(l);g[u]={id:t.id},e.Chart._copyActiveDataProperties(i[r],g[u]),this.Options.series.push({name:n,items:g})}else{var d=this._findDataItemById(a);u=d?"ia"==t.type?d.groupIndex+1:d.groupIndex:0,h<0&&(this.Options.series.push({name:n,items:new Array(l)}),h=o,o++);for(var c=0;c<o;c++){var p;(p=H.getSeriesItem(this,c).items).splice(u,0,{id:t.id}),c==h&&e.Chart._copyActiveDataProperties(i[r],p[u])}this.Options.groups.splice(u,0,s)}}},e.Chart.prototype._processActiveDataDelete=function(e){this.clearCache();var t=this._findDataItemById(e.id);if(t){var i;for(var r in t.item)t.item[r]=null;t.item._deleted=!0;for(var a=H.getSeriesCount(this),s=H.getGroupCount(this),n=!0,o=0;o<a;o++)if((i=H.getDataItem(this,o,t.groupIndex))&&!i._deleted){n=!1;break}for(var l=!0,h=0;h<s;h++)if((i=H.getDataItem(this,t.seriesIndex,h))&&!i._deleted){l=!1;break}if(n){for(o=0;o<a;o++){H.getSeriesItem(this,o).items.splice(t.groupIndex,1)}this.Options.groups.splice(t.groupIndex,1)}l&&this.Options.series.splice(t.seriesIndex,1),this._processActiveDataDelete(e)}},e.Chart._copyActiveDataProperties=function(e,t){for(var i in e)t[i]=e[i]},e.Chart.prototype._findDataItemById=function(e,t){if(null==e)return null;for(var i=H.getSeriesCount(this),r=H.getGroupCount(this),a=0;a<i;a++)for(var s=0;s<r;s++){var n=H.getDataItem(this,a,s);if(null!=n&&n.id===e&&(null==t||t===n._id))return{item:n,seriesIndex:a,groupIndex:s}}return null};var t=function(e){this._chart=e,this._options=this._chart.getOptions(),this._legend=this._chart.legend,this._xAxis=this._chart.xAxis,this._yAxis=this._chart.yAxis,this._y2Axis=this._chart.y2Axis,this._legendAutomation=this._legend?this._legend.getAutomation():null,this._xAxisAutomation=this._xAxis?this._xAxis.getAutomation():null,this._yAxisAutomation=this._yAxis?this._yAxis.getAutomation():null,this._y2AxisAutomation=this._y2Axis?this._y2Axis.getAutomation():null};e.Obj.createSubclass(t,e.Automation),t.PLOT_AREA_SUBID="plotArea",t.PIE_CENTER_LABEL_SUBID="pieCenterLabel",t.prototype.GetSubIdForDomElement=function(i){var r=null;if(i.isDescendantOf(this._xAxis))return(r=this._xAxisAutomation.GetSubIdForDomElement(i))?this._convertAxisSubIdToChartSubId(r,"xAxis"):null;if(i.isDescendantOf(this._yAxis))return(r=this._yAxisAutomation.GetSubIdForDomElement(i))?this._convertAxisSubIdToChartSubId(r,"yAxis"):null;if(i.isDescendantOf(this._y2Axis))return(r=this._y2AxisAutomation.GetSubIdForDomElement(i))?this._convertAxisSubIdToChartSubId(r,"y2Axis"):null;if(i.isDescendantOf(this._legend)){var n=this._legendAutomation.GetSubIdForDomElement(i);return n?this._convertLegendSubIdToChartSubId(n):null}var o=this._chart.getEventManager().GetLogicalObject(i);if(!o)return null;if(o instanceof e.SimpleObjPeer){var l=o.getParams().type;if("pieCenterLabel"==l)return t.PIE_CENTER_LABEL_SUBID;if("plotArea"==l)return t.PLOT_AREA_SUBID}if(o instanceof I)return"dataItem["+o.getSeriesIndex()+"]";if(o instanceof a){var h=o.getSeriesIndex(),u=o.getGroupIndex();if(null!=h&&u>=0&&("funnel"!=this._options.type||"pyramid"!=this._options.type))return"dataItem["+h+"]["+u+"]";if(null!=h&&u==ie._GROUP_INDEX&&("funnel"==this._options.type||"pyramid"==this._options.type))return"dataItem["+h+"]";if(null!=h&&(null==u||u<0))return"series["+h+"]"}else if(o instanceof s){var g=o.getAxisType(),d=o.getIndex();return g&&d>=0?g+":referenceObject["+d+"]":null}return null},t.prototype._convertLegendSubIdToChartSubId=function(e){var t=this._legend.getOptions(),i=this._legendAutomation.getLegendItem(t,e);if(i){for(var r=0;r<this._options.series.length;r++){if(this._options.series[r].name==i.text)return"series["+r+"]"}return"legend:"+e}return null},t.prototype._convertAxisSubIdToChartSubId=function(e,t){if("title"==e&&t)return t+":"+e;var i=e.substring(e.indexOf("["));return i?"group"+i:null},t.prototype.getDomElementForSubId=function(i){if(i==e.Automation.TOOLTIP_SUBID)return this.GetTooltipElement(this._chart,W.isDataCursorEnabled(this._chart)?v.TOOLTIP_ID:null);if(i==t.PIE_CENTER_LABEL_SUBID)return this._chart.pieChart.getCenterLabel().getElem();if(i==t.PLOT_AREA_SUBID)return this._chart.getPlotArea().getElem();var r,a,s,n=i.indexOf("["),o=i.indexOf("]"),l=i.indexOf(":");if(n>0&&o>0||l>0){var h=l<0?i.substring(0,n):i.substring(0,l);if("group"==h)return this._xAxisAutomation.getDomElementForSubId(i);if("series"==h)return i=this._convertToLegendSubId(i),this._legendAutomation.getDomElementForSubId(i);if("legend"==i.substring(0,l))return i=i.substring(l+1),this._legendAutomation.getDomElementForSubId(i);var u,g=i.substring(n+1,o);if("xAxis"==h||"yAxis"==h||"y2Axis"==h){var d=i.substring(l+1);if("title"==d){if("xAxis"==h)return this._xAxisAutomation.getDomElementForSubId(d);if("yAxis"==h)return this._yAxisAutomation.getDomElementForSubId(d);if("y2Axis"==h)return this._y2AxisAutomation.getDomElementForSubId(d)}else if(r=d.indexOf("["),a=d.indexOf("]"),"referenceObject"==d.substring(0,r)){var c=d.substring(r+1,a);if(s=this._getRefObjPeer(c))return s.getDisplayables()[0].getElem()}}if("pie"==this._options.type){var p=this._chart.pieChart.getSliceDisplayable(g);if(p)return p.getElem()}if("funnel"==this._options.type?u=ie._GROUP_INDEX:"pyramid"==this._options.type?u=re._GROUP_INDEX:(r=(i=i.substring(o+1)).indexOf("["),a=i.indexOf("]"),r>=0&&a>=0&&(u=i.substring(r+1,a))),s=this._getChartObjPeer(g,u))return s.getDisplayables()[0].getElem()}return null},t.prototype._getChartObjPeer=function(e,t){for(var i=this._chart.getChartObjPeers(),r=0;r<i.length;r++){var a=i[r].getSeriesIndex(),s=i[r].getGroupIndex();if(a==e&&s==t)return i[r]}return null},t.prototype._getRefObjPeer=function(e){for(var t=this._chart.getRefObjPeers(),i=0;i<t.length;i++)if(e==t[i].getIndex())return t[i];return null},t.prototype._convertToLegendSubId=function(e){var t=e.indexOf("["),i=e.indexOf("]"),r=e.substring(t+1,i),a=this._legend.getOptions(),s=this._options.series[r];return"section"+this._legendAutomation.getIndicesFromSeries(s,a)},t.prototype.getDataItem=function(e,t){"pie"!=this._options.type&&"funnel"!=this._options.type&&"pyramid"!=this._options.type||(t=0);var i=H.getDataItem(this._chart,e,t);return i?{borderColor:V.getBorderColor(this._chart,e,t),color:V.getColor(this._chart,e,t),label:H.getDataLabel(this._chart,e,t),targetValue:H.getTargetValue(this._chart,e,t),tooltip:W.getDatatip(this._chart,e,t,null,!1),value:H.getValue(this._chart,e,t),open:i.open,close:i.close,high:H.getHighValue(this._chart,e,t),low:H.getLowValue(this._chart,e,t),volume:i.volume,x:H.getXValue(this._chart,e,t),y:i.y,z:i.z,min:i.min,max:i.max,group:H.getGroup(this._chart,t),series:H.getSeries(this._chart,e),selected:H.isDataSelected(this._chart,e,t)}:null},t.prototype.getGroup=function(e){return H.getGroup(this._chart,e)},t.prototype.getSeries=function(e){return this._options.series[e].name},t.prototype.getGroupCount=function(){return H.getGroupCount(this._chart)},t.prototype.getSeriesCount=function(){return this._options.series.length},t.prototype.getTitle=function(){return this._options.title.text},t.prototype.getLegend=function(){var t=this._legend.__getBounds(),i=this._legend.localToStage(new e.Point(t.x,t.y));return{bounds:{x:i.x,y:i.y,width:t.w,height:t.h},title:this._legend.getOptions().title}},t.prototype.getPlotArea=function(){var e=this._chart.__getPlotAreaSpace();return{bounds:{x:e.x,y:e.y,width:e.w,height:e.h}}},t.prototype.getXAxis=function(){return this._getAxis("x")},t.prototype.getYAxis=function(){return this._getAxis("y")},t.prototype.getY2Axis=function(){return this._getAxis("y2")},t.prototype._getAxis=function(t){var i="x"==t?this._xAxis:"y"==t?this._yAxis:this._y2Axis;if(i){var r=i.__getBounds(),a=i.localToStage(new e.Point(r.x,r.y)),s={x:a.x,y:a.y,width:r.w,height:r.h},n=this._chart;return{bounds:s,title:this._options[t+"Axis"].title,getPreferredSize:function(e,r){var a,s=i.getOptions(),o=s.position,l=N.getTickLabelGapSize(n,t),h=z.isStandaloneXAxis(n)||z.isStandaloneYAxis(n)||z.isStandaloneY2Axis(n)?2:0;return"top"==o||"bottom"==o?(a=i.getPreferredSize(s,e,r-l-h)).h=Math.ceil(a.h+l+h):(a=i.getPreferredSize(s,e-l-h,r)).w=Math.ceil(a.w+l+h),{width:a.w,height:a.h}}}}return null},e.Automation.prototype.IsTooltipElement=function(t){var i=t.getAttribute("id");return!(!i||0!=i.indexOf(v.TOOLTIP_ID)&&0!=i.indexOf(e.HtmlTooltipManager._TOOLTIP_DIV_ID))},e.Bundle.addDefaultStrings(e.Bundle.CHART_PREFIX,{DEFAULT_GROUP_NAME:"Group {0}",LABEL_SERIES:"Series",LABEL_GROUP:"Group",LABEL_VALUE:"Value",LABEL_TARGET_VALUE:"Target",LABEL_X:"X",LABEL_Y:"Y",LABEL_Z:"Z",LABEL_PERCENTAGE:"Percentage",LABEL_MIN:"Min",LABEL_MAX:"Max",LABEL_HIGH:"High",LABEL_LOW:"Low",LABEL_OPEN:"Open",LABEL_CLOSE:"Close",LABEL_VOLUME:"Volume",LABEL_Q1:"Q1",LABEL_Q2:"Q2",LABEL_Q3:"Q3",LABEL_OTHER:"Other",MARQUEE_SELECT:"Marquee select",MARQUEE_ZOOM:"Marquee zoom",PAN:"Pan"});var i=function(t){i.superclass.Init.call(this,t.getCtx(),t.processEvent,t),this._chart=t,this._dragMode=null,this._dragButtonsVisible=e.Agent.isTouchDevice(),this.panButton=null,this.zoomButton=null,this.selectButton=null,this._dataCursorHandler=null,this._panZoomHandler=null,this._marqueeZoomHandler=null,this._marqueeSelectHandler=null};e.Obj.createSubclass(i,e.EventManager),i.DRAG_MODE_PAN="pan",i.DRAG_MODE_ZOOM="zoom",i.DRAG_MODE_SELECT="select",i.DRAG_MODE_OFF="off",i.prototype.getComponent=function(){return this._chart},i.prototype.addListeners=function(t){e.SvgDocumentUtils.addDragListeners(this._chart,this._onDragStart,this._onDragMove,this._onDragEnd,this),i.superclass.addListeners.call(this,t),e.Agent.isTouchDevice()||t.addEvtListener(e.MouseEvent.MOUSEWHEEL,this.OnMouseWheel,!1,this)},i.prototype.RemoveListeners=function(t){i.superclass.RemoveListeners.call(this,t),e.Agent.isTouchDevice()||t.removeEvtListener(e.MouseEvent.MOUSEWHEEL,this.OnMouseWheel,!1,this)},i.prototype.getLogicalObject=function(e){return this.GetLogicalObject(e,!0)},i.prototype._getDragHandler=function(e){return e&&"user"==this._chart.getOptions().dragMode&&z.isBLAC(this._chart)&&(this._dragMode==i.DRAG_MODE_PAN||this._dragMode==i.DRAG_MODE_ZOOM)&&(this._panZoomHandler&&this._panZoomHandler.isWithinBounds(e)?this._dragMode=i.DRAG_MODE_PAN:this._dragMode=i.DRAG_MODE_ZOOM),this._dragMode==i.DRAG_MODE_PAN?this._panZoomHandler:this._dragMode==i.DRAG_MODE_ZOOM?this._marqueeZoomHandler:this._dragMode==i.DRAG_MODE_SELECT?this._marqueeSelectHandler:null},i.prototype._onDragStart=function(t){return e.Agent.isTouchDevice()?this._onTouchDragStart(t):this._onMouseDragStart(t)},i.prototype._onDragMove=function(t){return e.Agent.isTouchDevice()?this._onTouchDragMove(t):this._onMouseDragMove(t)},i.prototype._onDragEnd=function(t){return e.Agent.isTouchDevice()?this._onTouchDragEnd(t):this._onMouseDragEnd(t)},i.prototype._onMouseDragStart=function(e){var t,i=this._context.pageToStageCoords(e.pageX,e.pageY),r=this._getDragHandler(i),a=this.GetLogicalObject(this.GetCurrentTargetForEvent(e));return!(a&&a.isSelectable&&a.isSelectable())&&0==e.button&&r&&((t=r.processDragStart(i,e.ctrlKey))&&this._callback.call(this._callbackObj,t),this._chart.setCursor(r.getCursor(i)),this.setDragButtonsVisible(!1),this._chart!=this.getCtx().getCurrentKeyboardFocus()&&this.getCtx().setCurrentKeyboardFocus(this._chart)),!!t&&(this._dataCursorHandler&&this._dataCursorHandler.processEnd(),!0)},i.prototype._onMouseDragMove=function(e){var t,i=this._context.pageToStageCoords(e.pageX,e.pageY),r=this._getDragHandler();r&&(t=r.processDragMove(i,e.ctrlKey))&&(this._callback.call(this._callbackObj,t),this.setDragButtonsVisible(!1)),t&&e.stopPropagation()},i.prototype._onMouseDragEnd=function(e){var t,i=this._context.pageToStageCoords(e.pageX,e.pageY),r=this._getDragHandler();if(r){(t=r.processDragEnd(i,e.ctrlKey))&&(this._callback.call(this._callbackObj,t),this.autoToggleZoomButton()),this._chart.setCursor(r.getCursor(i));var a=this._chart.__getAxisSpace();a&&this.setDragButtonsVisible(a.containsPoint(i.x,i.y))}},i.prototype.OnMouseMove=function(t){i.superclass.OnMouseMove.call(this,t);var r=this._context.pageToStageCoords(t.pageX,t.pageY);this._dataCursorHandler&&(this.GetCurrentTargetForEvent(t)instanceof e.Button?this._dataCursorHandler.processEnd():this._dataCursorHandler.processMove(r));var a=this._getDragHandler(r);a?this._chart.setCursor(a.getCursor(r)):this._chart.setCursor("default")},i.prototype.OnMouseOut=function(e){i.superclass.OnMouseOut.call(this,e);var t=this._context.pageToStageCoords(e.pageX,e.pageY),r=this._chart.__getAxisSpace();r&&this.setDragButtonsVisible(r.containsPoint(t.x,t.y)),this._dataCursorHandler&&this._dataCursorHandler.processOut(t);this.GetLogicalObject(e.target)},i.prototype.OnMouseWheel=function(e){if(G.isZoomable(this._chart)){var t=null!=e.wheelDelta?e.wheelDelta:0,i=this._context.pageToStageCoords(e.pageX,e.pageY);if(this._panZoomHandler){var r=this._panZoomHandler.processMouseWheel(i,t);r&&(e.preventDefault(),e.stopPropagation(),this._callback.call(this._callbackObj,r),this._dataCursorHandler&&this._dataCursorHandler.processMove(i))}}},i.prototype.ShowFocusEffect=function(t,r){if(this._dataCursorHandler){var a=r.getDataPosition();if(a){var s=this._chart.__getPlotAreaSpace();this._dataCursorHandler.processMove(new e.Point(a.x+s.x,a.y+s.y))}}i.superclass.ShowFocusEffect.call(this,t,r)},i.prototype.OnBlur=function(e){this._dataCursorHandler&&this._dataCursorHandler.processEnd(),i.superclass.OnBlur.call(this,e)},i.prototype.OnClickInternal=function(e){var t=this.GetLogicalObject(e.target),i=this._context.pageToStageCoords(e.pageX,e.pageY);this.SeriesFocusHandler&&this.SeriesFocusHandler.processSeriesFocus(i,t),t&&(this.processActionEvent(t),t.isSelectable&&t.isSelectable()||this.processDrillEvent(t))},i.prototype.OnDblClickInternal=function(e){var t=this.GetLogicalObject(e.target);t&&t.isSelectable&&t.isSelectable()&&this.processDrillEvent(t)},i.prototype.HandleTouchHoverStartInternal=function(e){if(this._dataCursorHandler&&!this.isTouchResponseTouchStart()){var t=this._context.pageToStageCoords(e.touch.pageX,e.touch.pageY);return this._dataCursorHandler.processMove(t),!1}var i=this.GetLogicalObject(e.target);return this.TouchManager.setTooltipEnabled(e.touch.identifier,this.getTooltipsEnabled(i)),!1},i.prototype.HandleTouchHoverMoveInternal=function(e){if(this._dataCursorHandler&&!this.isTouchResponseTouchStart()){var t=this._context.pageToStageCoords(e.touch.pageX,e.touch.pageY);return this._dataCursorHandler.processMove(t),!1}var i=this.GetLogicalObject(e.target);return this.TouchManager.setTooltipEnabled(e.touch.identifier,this.getTooltipsEnabled(i)),!1},i.prototype.HandleTouchHoverEndInternal=function(e){this.endDrag();var t=this.GetLogicalObject(e.target);t&&(this.processActionEvent(t),t.isSelectable&&t.isSelectable()||this.processDrillEvent(t))},i.prototype.HandleTouchClickInternal=function(e){var t=this.GetLogicalObject(e.target);t&&(this.processActionEvent(t),t.isSelectable&&t.isSelectable()||this.processDrillEvent(t))},i.prototype.HandleTouchDblClickInternal=function(e){var t=this.GetLogicalObject(e.target);t&&t.isSelectable&&t.isSelectable()&&(e.preventDefault(),e.stopPropagation(),this.processDrillEvent(t))},i.prototype.processActionEvent=function(t){t&&t.getAction&&t.getAction()&&this.FireEvent(e.EventFactory.newActionEvent("action",t.getAction(),t.getId()))},i.prototype.processDrillEvent=function(t){if(t&&t.isDrillable&&t.isDrillable()){var i=t.getId();t instanceof a?this.FireEvent(e.EventFactory.newChartDrillEvent(i.getId?i.getId():i,t.getSeries(),t.getGroup())):t instanceof I&&this.FireEvent(e.EventFactory.newChartDrillEvent(i.getId(),i.getSeries(),i.getGroup()))}},i.prototype.ProcessRolloverEvent=function(t,i,r){var a=this._chart.getOptions();if("dim"==G.getHoverBehavior(this._chart)){var s=i.getCategories?i.getCategories():[];a.highlightedCategories=r?s.slice():null;var n=e.EventFactory.newCategoryHighlightEvent(a.highlightedCategories,r),o=V.getHoverBehaviorDelay(this._chart),l=this._chart.getObjects();this._chart.pieChart&&(l=l.concat(this._chart.pieChart.__getSlices())),this.RolloverHandler.processEvent(n,l,o,"any"==a.highlightMatch)}},i.prototype._onTouchDragStart=function(e){var t,i,r=e.touches;if(1==r.length){var a=this._context.pageToStageCoords(r[0].pageX,r[0].pageY),s=this._getDragHandler();s?t=s.processDragStart(a,!0):this._dataCursorHandler&&this.isTouchResponseTouchStart()&&(this._dataCursorHandler.processMove(a),i=!0)}else if(2==r.length&&this._panZoomHandler&&G.isZoomable(this._chart)){this.endDrag();var n=this._context.pageToStageCoords(r[0].pageX,r[0].pageY),o=this._context.pageToStageCoords(r[1].pageX,r[1].pageY);t=this._panZoomHandler.processPinchStart(n,o)}return t&&(this._callback.call(this._callbackObj,t),this.getCtx().getTooltipManager().hideTooltip()),!(!t&&!i)&&(e.preventDefault(),e.stopPropagation(),this.setDragButtonsVisible(!1),!0)},i.prototype._onTouchDragMove=function(e){var t,i,r=e.touches;if(1==r.length){var a=this._context.pageToStageCoords(r[0].pageX,r[0].pageY),s=this._getDragHandler();s?t=s.processDragMove(a,!0):this._dataCursorHandler&&this.isTouchResponseTouchStart()&&(this._dataCursorHandler.processMove(a),i=!0)}else if(2==r.length&&this._panZoomHandler&&G.isZoomable(this._chart)){var n=this._context.pageToStageCoords(r[0].pageX,r[0].pageY),o=this._context.pageToStageCoords(r[1].pageX,r[1].pageY);t=this._panZoomHandler.processPinchMove(n,o)}(t||i)&&e.preventDefault(),t&&(this._callback.call(this._callbackObj,t),this.getCtx().getTooltipManager().hideTooltip())},i.prototype._onTouchDragEnd=function(e){var t,i=this.endDrag();if(this._panZoomHandler&&G.isZoomable(this._chart)&&(t=this._panZoomHandler.processPinchEnd())&&this._callback.call(this._callbackObj,t),i||t){e.preventDefault(),this.getCtx().getTooltipManager().hideTooltip();var r=this.getTouchManager(),a=1==e.changedTouches.length?e.changedTouches[0].identifier:null,s=null!=a?r.getTouchInfo(a):null;s&&!s.touchMoved||r.reset()}this.setDragButtonsVisible(!0)},i.prototype.endDrag=function(){var e,t=this._getDragHandler();return t&&(e=t.processDragEnd(null,!0)),this._dataCursorHandler&&this._dataCursorHandler.processEnd(),e&&this._callback.call(this._callbackObj,e),e},i.prototype.zoomBy=function(e){if(this._panZoomHandler&&G.isZoomable(this._chart)){var t=this._panZoomHandler.zoomBy(e);t&&this._callback.call(this._callbackObj,t)}},i.prototype.panBy=function(e,t){if(this._panZoomHandler&&G.isScrollable(this._chart)){var i=this._panZoomHandler.panBy(e,t);i&&this._callback.call(this._callbackObj,i)}},i.prototype.hideHoverFeedback=function(){this.hideTooltip(),this._dataCursorHandler&&this._dataCursorHandler.processEnd()},i.prototype.hideTooltip=function(){this._dataCursorHandler&&this._dataCursorHandler.isDataCursorShown()||i.superclass.hideTooltip.call(this)},i.prototype.getTooltipsEnabled=function(e){return(!this._dataCursorHandler||!(e instanceof a||e instanceof s||this._dataCursorHandler.isDataCursorShown()))&&i.superclass.getTooltipsEnabled.call(this)},i.prototype.getDataCursorHandler=function(){return this._dataCursorHandler},i.prototype.setDataCursorHandler=function(e){this._dataCursorHandler=e},i.prototype.setPanZoomHandler=function(e){this._panZoomHandler=e},i.prototype.setMarqueeZoomHandler=function(e){this._marqueeZoomHandler=e},i.prototype.setMarqueeSelectHandler=function(e){this._marqueeSelectHandler=e},i.prototype.getMarqueeGlassPane=function(){return this._dragMode==i.DRAG_MODE_ZOOM?this._marqueeZoomHandler.getGlassPane():this._dragMode==i.DRAG_MODE_SELECT?this._marqueeSelectHandler.getGlassPane():null},i.prototype.cancelMarquee=function(e){this._dragMode==i.DRAG_MODE_ZOOM?this._marqueeZoomHandler.cancelMarquee()&&e.preventDefault():this._dragMode==i.DRAG_MODE_SELECT&&this._marqueeSelectHandler&&this._marqueeSelectHandler.cancelMarquee()&&this._chart.render()},i.prototype.getDragMode=function(){return this._dragMode},i.prototype.setDragMode=function(e){this._dragMode=null==e?this._getDefaultDragMode():e,!this._chart.xAxis.isFullViewport()||this._chart.yAxis&&!this._chart.yAxis.isFullViewport()||this.autoToggleZoomButton()},i.prototype._getDefaultDragMode=function(){return e.Agent.isTouchDevice()?i.DRAG_MODE_OFF:G.isScrollable(this._chart)?i.DRAG_MODE_PAN:"multiple"==this._chart.getOptions().selectionMode?i.DRAG_MODE_SELECT:null},i.prototype.onZoomButtonClick=function(e){this.zoomButton.isToggled()?(this.selectButton&&this.selectButton.setToggled(!1),this.setDragMode(i.DRAG_MODE_ZOOM)):this.setDragMode(null)},i.prototype.onPanButtonClick=function(e){this.panButton.isToggled()?(this.selectButton&&this.selectButton.setToggled(!1),this.setDragMode(i.DRAG_MODE_PAN)):this.setDragMode(null)},i.prototype.onSelectButtonClick=function(e){this.selectButton.isToggled()?(this.zoomButton&&this.zoomButton.setToggled(!1),this.panButton&&this.panButton.setToggled(!1),this.setDragMode(i.DRAG_MODE_SELECT)):this.setDragMode(null)},i.prototype.setDragButtonsVisible=function(e){e&&!this._dragButtonsVisible?(this._chart.showDragButtons(),this._dragButtonsVisible=!0):!e&&this._dragButtonsVisible&&(this._chart.hideDragButtons(),this._dragButtonsVisible=!1)},i.prototype.areDragButtonsVisible=function(){return this._dragButtonsVisible},i.prototype.autoToggleZoomButton=function(){!e.Agent.isTouchDevice()&&this.zoomButton&&(this._chart.xAxis.isFullViewport()&&this._chart.yAxis.isFullViewport()?this._dragMode==i.DRAG_MODE_PAN&&(this.zoomButton.setToggled(!0),this.onZoomButtonClick(null)):this._dragMode==i.DRAG_MODE_ZOOM&&(this.zoomButton.setToggled(!1),this.onZoomButtonClick(null)))},i.prototype.GetTouchResponse=function(){return this._dragMode&&this._dragMode!=i.DRAG_MODE_OFF?e.EventManager.TOUCH_RESPONSE_TOUCH_HOLD:this._chart.getOptions().touchResponse},i.prototype.isDndSupported=function(){return!0},i.prototype.GetDragSourceType=function(e){var t=this.DragSource.getDragObject();return t instanceof a&&t.getSeriesIndex()>=0&&t.getGroupIndex()>=0||t instanceof I?"items":null},i.prototype.GetDragDataContexts=function(){if(this._chart.isSelectionSupported()&&this._chart.getSelectionHandler().getSelectedCount()>1){for(var e=this._chart.getSelectionHandler().getSelection(),t=[],i=0;i<e.length;i++){var r=H.getDataContext(this._chart,e[i].getSeriesIndex(),e[i].getGroupIndex(),e[i].getNestedDataItemIndex());t.push(r)}return t}var s=this.DragSource.getDragObject();return s instanceof a?[H.getDataContext(this._chart,s.getSeriesIndex(),s.getGroupIndex(),s.getNestedDataItemIndex())]:s instanceof I?[H.getDataContext(this._chart,s.getSeriesIndex(),0)]:null},i.prototype.GetDropOffset=function(t){var i=this.DragSource.getDragObject();if(i instanceof a){var r=i.getDataPosition();if(r){r=this._chart.getPlotArea().localToStage(r);var s=this._context.pageToStageCoords(t.pageX,t.pageY);return new e.Point(r.x-s.x,r.y-s.y)}}return null},i.prototype.GetDropTargetType=function(e){var t=this._context.pageToStageCoords(e.pageX,e.pageY),i=this._chart.getOptions().dnd.drop,r=this._chart.__getPlotAreaSpace();return Object.keys(i.plotArea).length>0&&r.containsPoint(t.x,t.y)?"plotArea":Object.keys(i.xAxis).length>0&&N.isAxisRendered(this._chart,"x")&&N.axisContainsPoint(this._chart.xAxis,t)?"xAxis":Object.keys(i.yAxis).length>0&&N.isAxisRendered(this._chart,"y")&&N.axisContainsPoint(this._chart.yAxis,t)?"yAxis":Object.keys(i.y2Axis).length>0&&N.isAxisRendered(this._chart,"y2")&&N.axisContainsPoint(this._chart.y2Axis,t)?"y2Axis":null},i.prototype.GetDropEventPayload=function(t){var i=t.getNativeEvent().dataTransfer,r=Number(i.getData(e.EventManager.DROP_OFFSET_X_DATA_TYPE))||0,a=Number(i.getData(e.EventManager.DROP_OFFSET_Y_DATA_TYPE))||0,s=this._context.pageToStageCoords(t.pageX,t.pageY);return this._chart.getValuesAt(s.x+r,s.y+a)},i.prototype.ShowDropEffect=function(e){var t=this._getDropObject(e);t&&(t.setClassName("oj-active-drop"),t.setSolidFill(this._chart.getOptions()._dropColor))},i.prototype.ClearDropEffect=function(){var t=this._chart.getCache().getFromCache("plotAreaBackground");if(t){var i=V.getBackgroundColor(this._chart);i?t.setSolidFill(i):t.setInvisibleFill(),e.ToolkitUtils.removeClassName(t.getElem(),"oj-invalid-drop"),e.ToolkitUtils.removeClassName(t.getElem(),"oj-active-drop")}var r=function(t){if(t){var i=t.getCache().getFromCache("background");i&&(i.setInvisibleFill(),e.ToolkitUtils.removeClassName(i.getElem(),"oj-invalid-drop"),e.ToolkitUtils.removeClassName(i.getElem(),"oj-active-drop"))}};r(this._chart.xAxis),r(this._chart.yAxis),r(this._chart.y2Axis)},i.prototype.ShowRejectedDropEffect=function(e){var t=this._getDropObject(e);t&&t.setClassName("oj-invalid-drop")},i.prototype._getDropObject=function(e){var t,i=this.GetDropTargetType(e);return"plotArea"==i?t=this._chart.getCache().getFromCache("plotAreaBackground"):"xAxis"==i?t=this._chart.xAxis.getCache().getFromCache("background"):"yAxis"==i?t=this._chart.yAxis.getCache().getFromCache("background"):"y2Axis"==i&&(t=this._chart.y2Axis.getCache().getFromCache("background")),t},i.prototype.isClearMenuAllowed=function(e){return e&&e.getParams&&"plotArea"==e.getParams().type};var r=function(e,t){this.Init(e,t)};e.Obj.createSubclass(r,e.KeyboardHandler),r.prototype.Init=function(e,t){r.superclass.Init.call(this,e),this._chart=t},r.prototype.isSelectionEvent=function(e){return this.isNavigationEvent(e)&&!e.ctrlKey},r.prototype.isMultiSelectEvent=function(t){return t.keyCode==e.KeyboardEvent.SPACE&&t.ctrlKey},r.prototype.processKeyDown=function(t){var i=t.keyCode;if(i==e.KeyboardEvent.TAB){if(s=this._eventManager.getFocus())return e.EventManager.consumeEvent(t),s;var a=G.getKeyboardNavigables(this._chart);if(a.length>0)return e.EventManager.consumeEvent(t),this.getDefaultNavigable(a)}else if(i==e.KeyboardEvent.ENTER){var s;if(s=this._eventManager.getFocus())return this._eventManager.processActionEvent(s),this._eventManager.processDrillEvent(s),e.EventManager.consumeEvent(t),s}else i==e.KeyboardEvent.ESCAPE?this._eventManager.cancelMarquee(t):i==e.KeyboardEvent.PAGE_UP?((t.ctrlKey||t.shiftKey||z.isBLAC(this._chart))&&z.isVertical(this._chart)?this._eventManager.panBy(-.25,0):this._eventManager.panBy(0,-.25),e.EventManager.consumeEvent(t)):i==e.KeyboardEvent.PAGE_DOWN?((t.ctrlKey||t.shiftKey||z.isBLAC(this._chart))&&z.isVertical(this._chart)?this._eventManager.panBy(.25,0):this._eventManager.panBy(0,.25),e.EventManager.consumeEvent(t)):e.KeyboardEvent.isEquals(t)||e.KeyboardEvent.isPlus(t)?this._eventManager.zoomBy(1.5):(e.KeyboardEvent.isMinus(t)||e.KeyboardEvent.isUnderscore(t))&&this._eventManager.zoomBy(1/1.5);return r.superclass.processKeyDown.call(this,t)},r.prototype.getDefaultNavigable=function(e){if(!e||e.length<=0)return null;for(var t,i,r,a,s=z.isPie(this._chart),n=0;n<e.length;n++)a=e[n],!t||a.getSeriesIndex()<i?(t=a,i=a.getSeriesIndex(),s||(r=a.getGroupIndex())):!s&&a.getGroupIndex()<r&&(t=a,i=a.getSeriesIndex(),r=a.getGroupIndex());return t};var a=function(e,t,i,r,a,s){this.Init(e,t,i,r,a,s)};e.Obj.createSubclass(a,e.Obj),a.prototype.Init=function(t,i,r,a,s,n){if(this._chart=t,this._displayables=i,this._seriesIndex=null!=r&&r>=0?r:-1,this._groupIndex=null!=a&&a>=0?a:-1,this._itemIndex=null!=s&&s>=0?s:-1,this._dataPos=n,this._isSelected=!1,this._isShowingKeyboardFocusEffect=!1,this._series=H.getSeries(t,r),this._group=H.getGroup(t,a),this._categories=H.getCategories(t,r,a,s),-1!=this._itemIndex)this._dataItemId=H.getNestedDataItemId(t,r,a,s),this._drillable=G.isDataItemDrillable(t,r,a,s);else if(-1!=this._groupIndex){var o=H.getDataItem(t,r,a);o&&(this._dataItemId=H.getDataItemId(t,r,a),this._action=o.action,this._drillable=G.isDataItemDrillable(t,r,a),this._stampId=o._id)}else{var l=H.getSeriesItem(t,r);l&&(this._action=l.action,this._drillable=G.isSeriesDrillable(t,r),this._stampId=l._id)}if(this._action||this._drillable)for(var h=0;h<this._displayables.length;h++)this._displayables[h].setCursor(e.SelectionEffectUtils.getSelectingCursor());for(var u=0;u<i.length;u++){var g=i[u];g instanceof f||g.setAriaRole("img"),this._updateAriaLabel(g)}},a.associate=function(e,t,i,r,s,n){if(e&&!t.getOptions()._duringZoomAndScroll){var o=new a(t,[e],i,r,s,n);t.registerObject(o),t.getEventManager().associate(e,o)}},a.prototype.getId=function(){return this._seriesIndex>=0&&this._groupIndex>=0?new n(this._dataItemId,this.getSeries(),this.getGroup(),this._chart.getCtx()):this._seriesIndex>=0?this.getSeries():null},a.prototype.getDataItemId=function(){return this._dataItemId},a.prototype.getNestedDataItemIndex=function(){return this._itemIndex},a.prototype.getSeries=function(){return this._series},a.prototype.getSeriesIndex=function(){return this._seriesIndex},a.prototype.getGroup=function(){return this._group},a.prototype.getGroupIndex=function(){return this._groupIndex},a.prototype.getAction=function(){return this._action},a.prototype.isDrillable=function(){return this._drillable},a.prototype.isDoubleClickable=function(){return this.isSelectable()&&this.isDrillable()},a.prototype.getChart=function(){return this._chart},a.prototype.getSeriesType=function(){return V.getSeriesType(this._chart,this._seriesIndex)},a.prototype.getSeriesItem=function(){return H.getSeriesItem(this._chart,this._seriesIndex)},a.prototype.getDatatip=function(e){return W.getDatatip(this._chart,this._seriesIndex,this._groupIndex,this._itemIndex,!0)},a.prototype.getDatatipColor=function(){return W.getDatatipColor(this._chart,this._seriesIndex,this._groupIndex,this._itemIndex)},a.prototype.isSelectable=function(){return V.isSelectable(this.getChart(),this.getSeriesIndex(),this.getGroupIndex())},a.prototype.isSelected=function(){return this._isSelected},a.prototype.setSelected=function(e){this._isSelected=e;for(var t=0;t<this._displayables.length;t++)this._displayables[t].setSelected&&(this._displayables[t].setSelected(e),this._updateAriaLabel(this._displayables[t]))},a.prototype.showHoverEffect=function(){for(var e=0;e<this._displayables.length;e++)this._displayables[e].showHoverEffect&&this._displayables[e].showHoverEffect()},a.prototype.hideHoverEffect=function(){for(var e=0;e<this._displayables.length;e++)this._displayables[e].hideHoverEffect&&this._displayables[e].hideHoverEffect()},a.prototype.getShowPopupBehaviors=function(){return this._chart.getShowPopupBehaviors(this._stampId)},a.prototype.getDisplayables=function(){return this._displayables},a.prototype.getAriaLabel=function(){var t=[],i=this.getChart().getOptions();this.isSelectable()&&t.push(e.Bundle.getTranslation(i,this.isSelected()?"stateSelected":"stateUnselected",e.Bundle.UTIL_PREFIX,this.isSelected()?"STATE_SELECTED":"STATE_UNSELECTED")),this.isDrillable()&&t.push(e.Bundle.getTranslation(i,"stateDrillable",e.Bundle.UTIL_PREFIX,"STATE_DRILLABLE"));var r=W.getDatatip(this._chart,this._seriesIndex,this._groupIndex,this._itemIndex,!1);return null==r&&this._groupIndex<0&&t.length>0&&(r=H.getSeriesLabel(this._chart,this._seriesIndex)),e.Displayable.generateAriaLabel(r,t)},a.prototype._updateAriaLabel=function(t){e.Agent.deferAriaCreation()||t.setAriaProperty("label",this.getAriaLabel())},a.prototype.getCategories=function(e){return this._categories},a.prototype.getDataPosition=function(){return this._dataPos},a.prototype.getNextNavigable=function(t){var i,r;if(i=t.keyCode,t.type==e.MouseEvent.CLICK)return this;if(i==e.KeyboardEvent.SPACE&&t.ctrlKey)return this;for(var a=this._chart,s=a.getChartObjPeers(),n=[],o=0;o<s.length;o++)s[o].isNavigable()&&n.push(s[o]);var l=t.keyCode==e.KeyboardEvent.UP_ARROW||t.keyCode==e.KeyboardEvent.DOWN_ARROW,h=z.isHorizontal(a),u=e.Agent.isRightToLeft(a.getCtx());return z.isScatterBubble(a)||z.isBoxPlot(a)&&(l&&!h||!l&&h)?r=e.KeyboardHandler.getNextAdjacentNavigable(this,t,n):z.isLineArea(a)||z.isStacked(a)||z.isPolar(a)?r=this._findNextNavigable(t):z.isFunnel(a)&&l?(t.keyCode=u?t.keyCode==e.KeyboardEvent.UP_ARROW?e.KeyboardEvent.RIGHT_ARROW:e.KeyboardEvent.LEFT_ARROW:t.keyCode-1,r=e.KeyboardHandler.getNextNavigable(this,t,n)):z.isPyramid(a)&&!l?(t.keyCode=u?t.keyCode==e.KeyboardEvent.RIGHT_ARROW?e.KeyboardEvent.DOWN_ARROW:e.KeyboardEvent.UP_ARROW:t.keyCode==e.KeyboardEvent.RIGHT_ARROW?e.KeyboardEvent.UP_ARROW:e.KeyboardEvent.DOWN_ARROW,r=e.KeyboardHandler.getNextNavigable(this,t,n)):r=e.KeyboardHandler.getNextNavigable(this,t,n,!0),r},a.prototype.getKeyboardBoundingBox=function(t){return this._displayables[0]?this._displayables[0].getDimensions(t):new e.Rectangle(0,0,0,0)},a.prototype.getTargetElem=function(){return this._displayables[0]?this._displayables[0].getElem():null},a.prototype.showKeyboardFocusEffect=function(){this.isNavigable()&&(this._isShowingKeyboardFocusEffect=!0,this.showHoverEffect())},a.prototype.hideKeyboardFocusEffect=function(){this.isNavigable()&&(this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect())},a.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},a.prototype.isNavigable=function(){return-1!=this.getGroupIndex()&&-1!=this.getSeriesIndex()},a.prototype._findNextNavigable=function(t){var i,r,a=t.keyCode,s=this._chart,n=s.getCtx(),o=this.getSeriesIndex(),l=this.getGroupIndex(),h=H.getGroupCount(s),u=z.isHorizontal(s),g=z.isPolar(s),d=e.Agent.isRightToLeft(n),c=u?d?a==e.KeyboardEvent.LEFT_ARROW:a==e.KeyboardEvent.RIGHT_ARROW:a==e.KeyboardEvent.UP_ARROW,p=u?d?a==e.KeyboardEvent.RIGHT_ARROW:a==e.KeyboardEvent.LEFT_ARROW:a==e.KeyboardEvent.DOWN_ARROW,_=u?a==e.KeyboardEvent.UP_ARROW:d?a==e.KeyboardEvent.RIGHT_ARROW:a==e.KeyboardEvent.LEFT_ARROW,f=u?a==e.KeyboardEvent.DOWN_ARROW:d?a==e.KeyboardEvent.LEFT_ARROW:a==e.KeyboardEvent.RIGHT_ARROW;if(c)r=l,i=this._findNextUpSeries(s,o,l);else if(p)r=l,i=this._findNextDownSeries(s,o,l);else if(f){i=o,r=l;do{r++,g&&r>=h&&(r=0)}while(null==s.getObject(i,r)&&r<h)}else if(_){i=o,r=l;do{r--,g&&r<0&&(r=h-1)}while(null==s.getObject(i,r)&&r>-1)}var S=s.getObject(i,r);return S&&S.isNavigable()?S:this},a.prototype._findNextUpSeries=function(e,t,i){for(var r=H.getSeriesCount(e),a=H.getCumulativeValue(e,t,i),s=null,n=null,o=0;o<r;o++)if(V.isSeriesRendered(e,o)){var l=H.getCumulativeValue(e,o,i);(l>a||l==a&&o>t)&&(null!==s&&l<s||null==s)&&(s=l,n=o)}return n},a.prototype._findNextDownSeries=function(e,t,i){for(var r=H.getSeriesCount(e),a=H.getCumulativeValue(e,t,i),s=null,n=null,o=r-1;o>=0;o--)if(V.isSeriesRendered(e,o)){var l=H.getCumulativeValue(e,o,i);(l<a||l==a&&o<t)&&(null!==s&&l>s||null==s)&&(s=l,n=o)}return n},a.prototype.isDragAvailable=function(e){return!0},a.prototype.getDragTransferable=function(e,t){return[this.getId()]},a.prototype.getDragFeedback=function(e,t){if(this._chart.isSelectionSupported()&&this._chart.getSelectionHandler().getSelectedCount()>1){for(var i=this._chart.getSelectionHandler().getSelection(),r=[],a=0;a<i.length;a++)r=r.concat(i[a].getDisplayables());return r}return this._displayables};var s=function(e,t,i,r,a){this.Init(e,t,i,r,a)};e.Obj.createSubclass(s,e.Obj),s.prototype.Init=function(e,t,i,r,a){this._chart=e,this._displayables=t,this._refObj=i,this._categories=U.getRefObjCategories(this._refObj),this._index=r,this._axisType=a;for(var s=0;s<t.length;s++){var n=t[s];n.setAriaRole("img"),n.setAriaProperty("label",i.shortDesc)}},s.prototype.getCategories=function(){return this._categories},s.prototype.getDisplayables=function(){return this._displayables},s.prototype.getIndex=function(){return this._index},s.prototype.getAxisType=function(){return this._axisType},s.prototype.getDatatip=function(e){return W.getRefObjTooltip(this._chart,this._refObj,this._axisType,this._index)},s.prototype.getDatatipColor=function(){return U.getColor(this._refObj)};var n=function(e,t,i,r){this.id=e,this.series=t,this.group=i,this.context=r};e.Obj.createSubclass(n,e.Obj),n.prototype.getId=function(){return this.id},n.prototype.getSeries=function(){return this.series},n.prototype.getGroup=function(){return this.group},n.prototype.equals=function(e){return e instanceof n&&(null!=this.id||null!=e.id?H.isEqualId(this.id,e.id,this.context):H.isEqualId(this.series,e.series,this.context)&&H.isEqualId(this.group,e.group,this.context))},n.prototype.toString=function(){return null!=this.id&&"object"!=typeof this.id?this.id.toString():H.createDataItemId(this.series,this.group)},n.prototype.valueOf=function(){return this.toString()};var o=function(e){this.Init({skyros:o.VERSION_1,alta:o.SKIN_ALTA,next:o.SKIN_NEXT},e)};e.Obj.createSubclass(o,e.BaseComponentDefaults),o.SKIN_NEXT={skin:e.CSSStyle.SKIN_NEXT,styleDefaults:{dataItemGaps:"auto",markerSize:10,marqueeColor:"rgba(255,255,255,0.4)",marqueeBorderColor:"#0572ce"},yAxis:{axisLine:{rendered:"auto"}},y2Axis:{axisLine:{rendered:"auto"}},layout:{titlePlotAreaGap:16,footnoteGap:10,legendGapWidth:15,legendGapHeight:10,tickLabelGapHeight:8,tickLabelGapWidth:9}},o.SKIN_ALTA={skin:e.CSSStyle.SKIN_ALTA,title:{style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_13+"color: #252525;")},subtitle:{style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA+"color: #252525;")},footnote:{style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_11)},_statusMessageStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_13+"color: #252525; font-weight: normal"),pieCenter:{labelStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA)},styleDefaults:{seriesEffect:"color",colors:e.CSSStyle.COLORS_ALTA,dataLabelStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA),stackLabelStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_BOLD),stockRisingColor:"#6b6f74",stockFallingColor:"#ED6647"}},o.VERSION_1={skin:e.CSSStyle.SKIN_SKYROS,emptyText:null,type:"bar",stack:"off",stackLabel:"off",orientation:"vertical",polarGridShape:"circle",selectionMode:"none",hideAndShowBehavior:"none",hoverBehavior:"none",zoomAndScroll:"off",zoomDirection:"auto",initialZooming:"none",dragMode:"user",sorting:"off",otherThreshold:0,animationOnDataChange:"none",animationOnDisplay:"none",__sparkBarSpacing:"subpixel",__spark:!1,dataCursor:"auto",dataCursorBehavior:"auto",drilling:"off",highlightMatch:"all",series:[],groups:[],title:{style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_SKYROS+"font-size: 12px; color: #003d5b; font-weight: bold"),halign:"start"},subtitle:{style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_SKYROS+"font-size: 12px; color: #003d5b;")},footnote:{style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_SKYROS+"font-size: 10px; color: #333333;"),halign:"start"},titleSeparator:{upperColor:"#74779A",lowerColor:"#FFFFFF",rendered:"off"},touchResponse:"auto",_statusMessageStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_SKYROS+"font-size: 12px; color: #003d5b; font-weight: bold"),_dropColor:"#D9F4FA",xAxis:{tickLabel:{rendered:"on"},majorTick:{rendered:"auto"},minorTick:{rendered:"auto"},axisLine:{rendered:"on"},scale:"linear"},yAxis:{tickLabel:{rendered:"on"},majorTick:{rendered:"auto"},minorTick:{rendered:"auto"},axisLine:{rendered:"on"},scale:"linear"},y2Axis:{tickLabel:{rendered:"on"},majorTick:{rendered:"auto"},minorTick:{rendered:"auto"},axisLine:{rendered:"on"},scale:"linear",alignTickMarks:"on"},zAxis:{},pieCenter:{labelStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_SKYROS)},plotArea:{backgroundColor:null},legend:{position:"auto",rendered:"auto",layout:{gapRatio:1},seriesSection:{},referenceObjectSection:{},sections:[]},overview:{rendered:"off"},dnd:{drag:{items:{},series:{},groups:{}},drop:{plotArea:{},xAxis:{},yAxis:{},y2Axis:{},legend:{}}},styleDefaults:{colors:e.CSSStyle.COLORS_SKYROS,borderColor:"auto",borderWidth:"auto",patterns:["smallDiagonalRight","smallChecker","smallDiagonalLeft","smallTriangle","smallCrosshatch","smallDiamond","largeDiagonalRight","largeChecker","largeDiagonalLeft","largeTriangle","largeCrosshatch","largeDiamond"],shapes:["square","circle","diamond","plus","triangleDown","triangleUp"],seriesEffect:"gradient",threeDEffect:"off",selectionEffect:"highlight",animationDuration:1e3,animationIndicators:"all",animationUpColor:"#0099FF",animationDownColor:"#FF3300",lineStyle:"solid",lineType:"auto",markerDisplayed:"auto",markerColor:null,markerShape:"auto",markerSize:8,marqueeColor:"rgba(255,255,255,0.5)",marqueeBorderColor:"rgba(0,0,0,0.2)",pieFeelerColor:"#BAC5D6",pieInnerRadius:0,selectedInnerColor:"#ffffff",selectedOuterColor:"#5a5a5a",sliceLabelType:"percent",otherColor:"#4b4b4b",stockRisingColor:"#006666",stockFallingColor:"#CC3300",stockRangeColor:"#B8B8B8",dataItemGaps:"0%",dataLabelStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_SKYROS+e.BaseComponentDefaults.FONT_SIZE_11),dataLabelPosition:"auto",funnelBackgroundColor:"#EDEDED",x1Format:{},y1Format:{},y2Format:{},zFormat:{},_defaultSliceLabelColor:"#333333",_scrollbarHeight:3,_scrollbarTrackColor:"#F0F0F0",_scrollbarHandleColor:"#9E9E9E",hoverBehaviorDelay:200,dataCursor:{markerSize:8,markerDisplayed:"on",lineColor:"#5a5a5a",lineWidth:2,lineStyle:"solid"},groupSeparators:{rendered:"on",color:"rgba(138,141,172,0.4)"},padding:"auto",_tooltipStyle:new e.CSSStyle("border-collapse: separate; border-spacing: 2px; overflow: hidden; display: block;"),tooltipLabelStyle:new e.CSSStyle("color: #666666; padding: 0px 2px; white-space: nowrap;"),tooltipValueStyle:new e.CSSStyle("color: #333333; padding: 0px 2px;"),stackLabelStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_SKYROS+e.BaseComponentDefaults.FONT_SIZE_11),boxPlot:{whiskerSvgStyle:{},whiskerEndSvgStyle:{strokeWidth:2},whiskerEndLength:9,medianSvgStyle:{strokeWidth:3}}},layout:{gapWidthRatio:null,gapHeightRatio:null,outerGapWidth:10,outerGapHeight:8,titleSubtitleGapWidth:14,titleSubtitleGapHeight:4,titleSeparatorGap:6,titlePlotAreaGap:10,footnoteGap:7,verticalAxisGap:6,legendGapWidth:10,legendGapHeight:10,tickLabelGapHeight:5,tickLabelGapWidth:7},_locale:"en-us",_resources:{}},o.getGapWidth=function(e,t){return Math.ceil(t*e.getGapWidthRatio())},o.getGapHeight=function(e,t){return Math.ceil(t*e.getGapHeightRatio())},o.isSkyrosSkin=function(t){return t.getSkin()==e.CSSStyle.SKIN_SKYROS},o.isPostAltaSkin=function(t){return t.getSkin()!=e.CSSStyle.SKIN_SKYROS&&t.getSkin()!=e.CSSStyle.SKIN_ALTA},o.prototype.getNoCloneObject=function(e){return{}};var l=function(e,t){this.Init(e,t)};e.Obj.createSubclass(l,e.Obj),l.prototype.Init=function(e,t){this._context=e.getCtx(),this._dataCursorShown=!1,this._dataCursor=t,this._chart=e},l.prototype.processMove=function(e,t){var i=this._chart.__getPlotAreaSpace();return i&&i.containsPoint(e.x,e.y)&&!this._chart.getOptions()._duringZoomAndScroll?(this._showDataCursor(i,e.x,e.y,t),!0):(this._removeDataCursor(t),!1)},l.prototype.processEnd=function(e){this._removeDataCursor(e)},l.prototype.processOut=function(e,t){var i=this._chart.__getPlotAreaSpace();i&&!i.containsPoint(e.x,e.y)&&this._removeDataCursor(t)},l.prototype._showDataCursor=function(e,t,i,r){if(this._context.isOffscreen(!0))this._removeDataCursor(r);else{var a=this._dataCursor,s=this._getClosestMatch(t,i);if(null!=s){var n=s.matchRegion.getCenter(),o=t,l=i;a.getBehavior()==v.BEHAVIOR_SNAP&&(a.isHorizontal()?l=Math.min(Math.max(n.y,e.y),e.y+e.h):o=Math.min(Math.max(n.x,e.x),e.x+e.w));var h=s.logicalObject,u=W.getDatatip(this._chart,h.getSeriesIndex(),h.getGroupIndex(),h.getNestedDataItemIndex(),!0);if(null!=u){a.setVisible(!0);var g=W.getDatatipColor(this._chart,h.getSeriesIndex(),h.getGroupIndex(),h.getNestedDataItemIndex()),d=a.isHorizontal()?l:o;if(a.render(e,n.x,n.y,d,u,g),this._dataCursorShown=!0,!r){var c=this._chart.getValuesAt(t,i);this._chart.changeOption("dataCursorPosition",c)}}else a.setVisible(!1)}else this._removeDataCursor(r)}},l.prototype._removeDataCursor=function(e){this._dataCursor.getVisible()&&this._dataCursor.setVisible(!1),this._context.getTooltipManager(v.TOOLTIP_ID).hideTooltip(),this._dataCursorShown=!1,e||this._chart.changeOption("dataCursorPosition",null)},l.prototype.isDataCursorShown=function(){return this._dataCursorShown},l._getClosestMatchSecondDirection=function(e,t,i,r){for(var a=null,s=1/0,n=0;n<e.length;n++){var o=e[n],l=t?i:r,h=((t?o.matchRegion.x:o.matchRegion.y)+(t?o.matchRegion.x+o.matchRegion.w:o.matchRegion.y+o.matchRegion.h))/2,u=Math.round(Math.abs(h-l));u<s&&(s=u,a=o)}return a},l._getClosestMatchesFirstDirection=function(e,t,i,r,a){for(var s=1/0,n=new Array,o=0;o<e.length;o++){var l=e[o];if(a(l.logicalObject)){var h=l.matchRegion,u=t?r:i,g=((t?h.y:h.x)+(t?h.y+h.h:h.x+h.w))/2,d=Math.round(Math.abs(g-u));d<=s&&(d<s&&(n=new Array),n.push(l),s=d)}}return n},l.prototype._findMatches=function(){var e=this._context.getStage(),t=this._chart.getEventManager(),i=[];if(!this._chart._currentMarkers)return null;for(var r=0;r<this._chart._currentMarkers.length;r++)for(var a=this._chart._currentMarkers[r],s=a.length,n=0;n<s;n++){var o=a[n],l=t.GetLogicalObject(o),h={matchRegion:o.getDimensionsSelf?o.getDimensionsSelf(e):o.getDimensions(e),logicalObject:l};i.push(h)}return i},l.prototype._getClosestMatch=function(t,i){var r=z.isHorizontal(this._chart),a=z.isLineArea(this._chart)&&!N.isMixedFrequency(this._chart),s=this._findMatches(),n=V.getHighlightedCategories(this._chart),o="all"==this._chart.getOptions().highlightMatch,h=n.length>0?o?e.ArrayUtils.hasAllItems:e.ArrayUtils.hasAnyItem:null,u=function(e){return!h||h(e.getCategories(),n)},g=l._getClosestMatchesFirstDirection(s,r,t,i,u);if(!z.isScatterBubble(this._chart)){for(var d=1/0,c=-1/0,p=null,_=0;_<g.length;_++){var f=g[_];d=Math.min(d,r?f.matchRegion.y:f.matchRegion.x),c=Math.max(c,r?f.matchRegion.y+f.matchRegion.h:f.matchRegion.x+f.matchRegion.w),p=f.logicalObject.getGroupIndex()}for(_=0;_<s.length;_++){var S=s[_];if(u(S.logicalObject))if(a)S.logicalObject.getGroupIndex()==p&&g.push(S);else{var C=((r?S.matchRegion.y:S.matchRegion.x)+(r?S.matchRegion.y+S.matchRegion.h:S.matchRegion.x+S.matchRegion.w))/2;c>=C&&d<=C&&g.push(S)}}}return l._getClosestMatchSecondDirection(g,r,t,i)};var h=function(e,t,i,r,a,s,n,o,l,h){this.Init(e,null,h),this.setWedgeParams(t,i,r,a,s,n,o,l)};e.Obj.createSubclass(h,e.Path),h._OUTER_BORDER_WIDTH=2,h._OUTER_BORDER_WIDTH_HOVER=1.25,h._INNER_BORDER_WIDTH=1,h.prototype.Init=function(e,t,i){h.superclass.Init.call(this,e,t,i)},h.prototype.setWedgeParams=function(e,t,i,r,a,s,n,o){this._cx=e,this._cy=t,this._rx=i,this._ry=r,this._sa=a,this._ae=s,this._gap=n,this._ir=o;var l=this._makeWedgePath(0);this.setCmds(l)},h.prototype._makeWedgePath=function(t){var i,r=Math.max(this._rx-t,0),a=Math.max(this._ry-t,0),s=360==this._ae||r<t?0:this._gap+2*t,n=this._ir?this._ir+t:0,o=360==this._ae?e.Math.degreesToRads(359.99):e.Math.degreesToRads(this._ae),l=e.Math.degreesToRads(this._sa),h=s/2,u=h<r?Math.asin(h/r):0,g=-o/2-l,d=Math.min(5*h,o>0?Math.abs(h/Math.sin(o/2)):0),c=0==r?d:d*a/r,p=this._cx+Math.cos(g)*d,_=this._cy+Math.sin(g)*c,f=this._cx+Math.cos(-u-l)*r,S=this._cy+Math.sin(-u-l)*a,C=this._cx+Math.cos(-l-o+u)*r,m=this._cy+Math.sin(-l-o+u)*a,y=e.Math.calculateAngleBetweenTwoVectors(C-this._cx,m-this._cy,f-this._cx,S-this._cy);if(y=Math.min(y,o),n>0){var v=h<n?Math.asin(h/n):0,A=this._cx+Math.cos(-v-l)*n,x=this._cy+Math.sin(-v-l)*n,b=this._cx+Math.cos(-l-o+v)*n,I=this._cy+Math.sin(-l-o+v)*n,T=e.Math.calculateAngleBetweenTwoVectors(b-this._cx,I-this._cy,A-this._cx,x-this._cy);T=Math.min(T,y,o),360==this._ae?(i=e.PathUtils.moveTo(C,m),i+=e.PathUtils.arcTo(r,a,o,1,f,S),i+=e.PathUtils.lineTo(C,m),i+=e.PathUtils.moveTo(A,x),i+=e.PathUtils.arcTo(n,n,o,0,b,I)):(i=e.PathUtils.moveTo(b,I),i+=e.PathUtils.lineTo(C,m),i+=e.PathUtils.arcTo(r,a,y,1,f,S),i+=e.PathUtils.lineTo(A,x),i+=e.PathUtils.arcTo(n,n,T,0,b,I))}else 360==this._ae?(i=e.PathUtils.moveTo(C,m),i+=e.PathUtils.arcTo(r,a,o,1,f,S)):(i=e.PathUtils.moveTo(p,_),i+=e.PathUtils.lineTo(C,m),i+=e.PathUtils.arcTo(r,a,y,1,f,S));return i+=e.PathUtils.closePath()},h.prototype._initializeSelectionEffects=function(){var t=this.isSelected()?h._OUTER_BORDER_WIDTH:h._OUTER_BORDER_WIDTH_HOVER,i=this._makeWedgePath(t),r=this._makeWedgePath(t+h._INNER_BORDER_WIDTH);if(this.OuterChild)return this.OuterChild.setCmds(i),void this.InnerChild.setCmds(r);this.OuterChild=new e.Path(this.getCtx(),i),this.OuterChild.setInvisibleFill(),this.OuterChild.setMouseEnabled(!0),this.addChild(this.OuterChild),this.InnerChild=new e.Path(this.getCtx(),r),this.InnerChild.setInvisibleFill(),this.InnerChild.setMouseEnabled(!0),this.addChild(this.InnerChild)},h.prototype._showNestedBorders=function(e,t){this._initializeSelectionEffects(),t?(this.setSolidFill(e),this.setStroke(null),this.setClassName().setStyle(),this.OuterChild.setSolidFill(t),this.OuterChild.setClassName().setStyle(),this.InnerChild.setFill(this._fill),this.InnerChild.setClassName(this._shapeClassName).setStyle(this._shapeStyle)):e?(this.setSolidFill(e),this.setStroke(null),this.setClassName().setStyle(),this.OuterChild.setFill(this._fill),this.OuterChild.setClassName(this._shapeClassName).setStyle(this._shapeStyle),this.InnerChild.setInvisibleFill(),this.InnerChild.setClassName().setStyle()):(this.setFill(this._fill),this.setStroke(this._shapeStroke),this.setClassName(this._shapeClassName).setStyle(this._shapeStyle),this.OuterChild.setInvisibleFill(),this.OuterChild.setClassName().setStyle(),this.InnerChild.setInvisibleFill(),this.InnerChild.setClassName().setStyle())},h.prototype.setStyleProperties=function(t,i,r,a,s,n,o){this._fill=t,this._shapeStroke=i,this._hoverColor=e.SelectionEffectUtils.getHoverBorderColor(r),this._innerColor=a,this._outerColor=s,this._shapeClassName=n,this._shapeStyle=o,this.setStyle(o).setClassName(n),this.setFill(t),i&&this.setStroke(i)},h.prototype.showHoverEffect=function(){this.IsShowingHoverEffect=!0,this._showNestedBorders(this._hoverColor,this._innerColor)},h.prototype.hideHoverEffect=function(){this.IsShowingHoverEffect=!1,this.isSelected()?this._showNestedBorders(this._outerColor,this._innerColor):this._showNestedBorders()},h.prototype.setSelected=function(e){this.IsSelected!=e&&(this.IsSelected=e,this.isHoverEffectShown()?this._showNestedBorders(this._hoverColor,this._innerColor):this.isSelected()?this._showNestedBorders(this._outerColor,this._innerColor):this._showNestedBorders())},h.prototype.UpdateSelectionEffect=function(){};var u=function(e,t,i){this._x1=Math.min(t[0],t[4]),this._x2=Math.max(t[0],t[4]),this._y1=Math.min(t[1],t[5]),this._y2=Math.max(t[1],t[5]),this.Init(e,[this._x1,this._y1,this._x2,this._y1,this._x2,this._y2,this._x1,this._y2],i)};e.Obj.createSubclass(u,e.Polygon),u.OUTER_BORDER_WIDTH=2,u.OUTER_BORDER_WIDTH_HOVER=1.25,u.INNER_BORDER_WIDTH=1,u.prototype.setStyleProperties=function(t,i,r,a,s,n,o){this._fill=t,this._borderStroke=i,this._hoverColor=e.SelectionEffectUtils.getHoverBorderColor(r),this._innerColor=a,this._outerColor=s,this._shapeClassName=n,this._shapeStyle=o,this.setStyle(o).setClassName(n),this.setFill(t),i&&this.setStroke(i)},u.prototype.setAnimationParams=function(e){this._x1=Math.min(e[0],e[4]),this._x2=Math.max(e[0],e[4]),this._y1=Math.min(e[1],e[5]),this._y2=Math.max(e[1],e[5]),this.setPoints(e),this._initializeSelectionEffects()},u.prototype.showHoverEffect=function(){this.IsShowingHoverEffect||(this.IsShowingHoverEffect=!0,this._showNestedBorders(this._hoverColor,this._innerColor))},u.prototype.hideHoverEffect=function(){this.IsShowingHoverEffect&&(this.IsShowingHoverEffect=!1,this.isSelected()?this._showNestedBorders(this._outerColor,this._innerColor):this._showNestedBorders())},u.prototype.setSelected=function(e){this.IsSelected!=e&&(this.IsSelected=e,this.isHoverEffectShown()?this._showNestedBorders(this._hoverColor,this._innerColor):this.isSelected()?this._showNestedBorders(this._outerColor,this._innerColor):this._showNestedBorders())},u.prototype.UpdateSelectionEffect=function(){},u.prototype.getPrimaryFill=function(){return this._fill},u.prototype._initializeSelectionEffects=function(){var t=this.isSelected()?u.OUTER_BORDER_WIDTH:u.OUTER_BORDER_WIDTH_HOVER,i=this._createPointsArray(t),r=this._createPointsArray(t+u.INNER_BORDER_WIDTH);if(this.OuterChild)return this.OuterChild.setPoints(i),void this.InnerChild.setPoints(r);this.OuterChild=new e.Polygon(this.getCtx(),i),this.OuterChild.setInvisibleFill(),this.OuterChild.setMouseEnabled(!0),this.addChild(this.OuterChild),this.InnerChild=new e.Polygon(this.getCtx(),r),this.InnerChild.setInvisibleFill(),this.InnerChild.setMouseEnabled(!0),this.addChild(this.InnerChild)},u.prototype._showNestedBorders=function(e,t){this._initializeSelectionEffects(),t?(this.setSolidFill(e),this.setStroke(null),this.setClassName().setStyle(),this.OuterChild.setSolidFill(t),this.OuterChild.setClassName().setStyle(),this.InnerChild.setFill(this._fill),this.InnerChild.setClassName(this._shapeClassName).setStyle(this._shapeStyle)):e?(this.setSolidFill(e),this.setStroke(null),this.setClassName().setStyle(),this.OuterChild.setFill(this._fill),this.OuterChild.setClassName(this._shapeClassName).setStyle(this._shapeStyle),this.InnerChild.setInvisibleFill(),this.InnerChild.setClassName().setStyle()):(this.setFill(this._fill),this.setStroke(this._borderStroke),this.setClassName(this._shapeClassName).setStyle(this._shapeStyle),this.OuterChild.setInvisibleFill(),this.OuterChild.setClassName().setStyle(),this.InnerChild.setInvisibleFill(),this.InnerChild.setClassName().setStyle())},u.prototype._createPointsArray=function(e){var t=this._x1+e,i=this._x2-e,r=this._y1+e,a=this._y2-e;return[t,r,i,r,i,a,t,a]};var g=function(e,t,i){this.Init(e,t,i)};e.Obj.createSubclass(g,e.Axis),g.prototype.axisToPlotArea=function(e){if("tangential"==this.getOptions().position)return e;if(null==e)return null;var t=e-this.getLeftOverflow();return Math.round(10*t)/10},g.prototype.plotAreaToAxis=function(e,t){if("tangential"==this.getOptions().position)return e;if(null==e)return null;var i=e+this.getLeftOverflow();return!1===t?i:Math.round(i)},g.prototype.linearToActual=function(e){return this.Info.linearToActual(e)},g.prototype.actualToLinear=function(e){return this.Info.actualToLinear(e)},g.prototype.getValueAt=function(e){return this.Info.getValueAt(this.plotAreaToAxis(e))},g.prototype.getCoordAt=function(e){return this.axisToPlotArea(this.Info.getCoordAt(e))},g.prototype.getBoundedValueAt=function(e){return this.Info.getBoundedValueAt(this.plotAreaToAxis(e))},g.prototype.getBoundedCoordAt=function(e){return this.axisToPlotArea(this.Info.getBoundedCoordAt(e))},g.prototype.getUnboundedValueAt=function(e){return this.Info.getUnboundedValueAt(this.plotAreaToAxis(e))},g.prototype.getUnboundedCoordAt=function(e){return this.axisToPlotArea(this.Info.getUnboundedCoordAt(e))},g.prototype.getBaselineCoord=function(){return this.axisToPlotArea(this.Info.getBaselineCoord())},g.prototype.getPosition=function(){return this.getOptions().position},g.prototype.isGroupAxis=function(){return this.Info instanceof e.GroupAxisInfo},g.prototype.isTimeAxis=function(){return this.Info instanceof e.TimeAxisInfo},g.prototype.isDataAxis=function(){return this.Info instanceof e.DataAxisInfo},g.prototype.getMajorTickCoords=function(){for(var e=this.Info?this.Info.getMajorTickCoords():[],t=0;t<e.length;t++)e[t]=this.axisToPlotArea(e[t]);return e},g.prototype.getMinorTickCoords=function(){for(var e=this.Info?this.Info.getMinorTickCoords():[],t=0;t<e.length;t++)e[t]=this.axisToPlotArea(e[t]);return e},g.prototype.getBaselineCoord=function(){return this.axisToPlotArea(this.Info.getBaselineCoord())},g.prototype.getLinearGlobalMin=function(){return this.actualToLinear(this.Info.getGlobalMin())},g.prototype.getLinearGlobalMax=function(){return this.actualToLinear(this.Info.getGlobalMax())},g.prototype.getLinearViewportMin=function(){return this.actualToLinear(this.Info.getViewportMin())},g.prototype.getLinearViewportMax=function(){return this.actualToLinear(this.Info.getViewportMax())},g.prototype.getUnboundedLinearValueAt=function(e){return this.Info.actualToLinear(this.getUnboundedValueAt(e))},g.prototype.isFullViewport=function(){return this.Info.getViewportMin()==this.Info.getGlobalMin()&&this.Info.getViewportMax()==this.Info.getGlobalMax()},g.prototype.getLeftOverflow=function(){return e.Agent.isRightToLeft(this.getCtx())?this.Info.getEndOverflow():this.Info.getStartOverflow()},g.prototype.getRightOverflow=function(){return e.Agent.isRightToLeft(this.getCtx())?this.Info.getStartOverflow():this.Info.getEndOverflow()},g.prototype.getLength=function(){return Math.abs(this.Info.getStartCoord()-this.Info.getEndCoord())},g.prototype.getMinCoord=function(){return this.axisToPlotArea(Math.min(this.Info.getStartCoord(),this.Info.getEndCoord()))},g.prototype.getMaxCoord=function(){return this.axisToPlotArea(Math.max(this.Info.getStartCoord(),this.Info.getEndCoord()))};var d=function(e,t,i,r,a,s,n){n||this.Init(e.getCtx()),this._bHoriz=z.isHorizontal(e),this._bStacked=z.isStacked(e),this._barGapRatio=V.getBarGapRatio(e),this._dataItemGaps=V.getDataItemGaps(e),this._axisCoord=t,this._doNotRender=!!n,this._setBarCoords(i,r,a,s,!0)};e.Obj.createSubclass(d,u),d._INDICATOR_OFFSET=8,d._MIN_BAR_WIDTH_FOR_GAPS=5,d._MIN_BAR_WIDTH_FOR_GAPS_PIXEL_HINTING=15,d._MIN_BAR_LENGTH_FOR_GAPS=5,d._MAX_GAP_SIZE=2,d.prototype.setSelected=function(e){this.IsSelected!=e&&(this.IsSelected=e,this.isSelected()?(this._tempX1=this._x1,this._tempX2=this._x2,this._tempBaselineCoord=this._baselineCoord,this._x1=this._origX1,this._x2=this._origX2,this._baselineCoord=this._origBaselineCoord,this.setPoints(this._createPointsArray()),this._showNestedBorders(this.isHoverEffectShown()?this._hoverColor:this._outerColor,this._innerColor)):(this._x1=this._tempX1,this._x2=this._tempX2,this._baselineCoord=this._tempBaselineCoord,this.setPoints(this._createPointsArray()),this._showNestedBorders(this.isHoverEffectShown()?this._hoverColor:null)))},d.prototype.getAnimationParams=function(e){return e?this._bHoriz?[this._x2,this._x1,this._baselineCoord,this._endCoord]:[this._x1,this._x2,this._endCoord,this._baselineCoord]:[this._baselineCoord,this._endCoord,this._x1,this._x2]},d.prototype.setAnimationParams=function(e,t){if(this._setBarCoords(e[0],e[1],e[2],e[3],!1),t){var i=this.getIndicatorPosition();t.setTranslate(i.x,i.y),t.setAlpha(1),t.getParent().addChild(t)}},d.prototype.getDisplayAnimation=function(t){var i=this.getAnimationParams();this.setAnimationParams([this._axisCoord,this._axisCoord,this._x1,this._x2]);var r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r},d.prototype.getDeleteAnimation=function(t){var i=[this._baselineCoord,this._baselineCoord,this._x1,this._x2],r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,0),r},d.prototype.getInsertAnimation=function(t){this.setAlpha(0);var i=this.getDisplayAnimation(t);return i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,1),i},d.prototype.getIndicatorPosition=function(){var t,i,r=(this._x1+this._x2)/2;if(this._bStacked){var a=(this._endCoord+this._baselineCoord)/2;t=this._bHoriz?a:r,i=this._bHoriz?r:a}else{var s=this._endCoord>=this._baselineCoord?this._endCoord+d._INDICATOR_OFFSET:this._endCoord-d._INDICATOR_OFFSET;t=this._bHoriz?s:r,i=this._bHoriz?r:s}return new e.Point(t,i)},d.prototype._setBarCoords=function(t,i,r,a,s){this._baselineCoord=t,this._endCoord=i,this._x1=r,this._x2=a;var n=this._x2-this._x1;if(n<1&&(this._x1=Math.floor(this._x1),this._x2=this._x1+1,n=1),this._origX1=this._x1,this._origX2=this._x2,this._origBaselineCoord=this._baselineCoord,this._origSize=this._x2-this._x1,this._dataItemGaps>0&&s&&!this.isSelected()){var o=Math.ceil(d._MAX_GAP_SIZE*this._dataItemGaps),l=Math.abs(this._baselineCoord-this._endCoord),h=this._axisCoord==this._baselineCoord;l>=d._MIN_BAR_LENGTH_FOR_GAPS&&this._bStacked&&!h&&(this._baselineCoord+=this._endCoord>this._baselineCoord?o:-o),n>=d._MIN_BAR_WIDTH_FOR_GAPS&&(1==e.Agent.getDevicePixelRatio()&&this._barGapRatio>0&&n>d._MIN_BAR_WIDTH_FOR_GAPS_PIXEL_HINTING?(e.Agent.isPlatformGecko()||this._doNotRender||this.setPixelHinting(!0),this._x1=Math.round(this._x1),this._x2=Math.round(this._x2),this._origX1=this._x1,this._origX2=this._x2,this._x2-=o):(this._x1+=o/2,this._x2-=o/2),this._origSize-=o)}if(!this._doNotRender){var g=this._createPointsArray();this.setPoints(g),this.OuterChild&&this.OuterChild.setPoints(this._createPointsArray(u.OUTER_BORDER_WIDTH)),this.InnerChild&&this.InnerChild.setPoints(this._createPointsArray(u.OUTER_BORDER_WIDTH+u.INNER_BORDER_WIDTH))}},d.prototype._createPointsArray=function(e){var t=this._baselineCoord,i=this._endCoord,r=this._x1,a=this._x2;if(e>0){if(Math.abs(r-a)<2*e||Math.abs(t-i)<2*e)return[];r+=e,a-=e,i<t?(t-=e,i+=e):(t+=e,i-=e)}return this._bHoriz?[i,r,i,a,t,a,t,r]:[r,i,a,i,a,t,r,t]},d.prototype.getBoundingBox=function(){var t=Math.min(this._x2,this._x1),i=Math.min(this._endCoord,this._baselineCoord),r=Math.abs(this._x2-this._x1),a=Math.abs(this._endCoord-this._baselineCoord);return this._bHoriz?new e.Rectangle(i,t,a,r):new e.Rectangle(t,i,r,a)},d.prototype.getOriginalBarSize=function(){return this._origSize},d.prototype.getDimensionsSelf=function(e){return this.ConvertCoordSpaceRect(this.getBoundingBox(),e)};var c=function(t,i,r,a,s,n,o,l,h){this.Init(t.getCtx()),this._chart=t,this._bHoriz=z.isHorizontal(t),this._styleOptions=h,this._innerColor=V.getSelectedInnerColor(this._chart),this._outerColor=V.getSelectedOuterColor(this._chart),this._hoverColor=e.SelectionEffectUtils.getHoverBorderColor(this._styleOptions._color);var u=i-r/2,g=i+r/2;V.getDataItemGaps(t)>0&&r>d._MIN_BAR_WIDTH_FOR_GAPS&&g--,this._render(u,g,a,s,n,o,l)};e.Obj.createSubclass(c,e.Shape),c.prototype._render=function(t,i,r,a,s,n,o){this._cleanUp();var l=this.getCtx();this._x1=Math.round(t),this._x2=Math.round(i),this._low=Math.round(r),this._q1=Math.round(a),this._q2=Math.round(s),this._q3=Math.round(n),this._high=Math.round(o);var h=i-t,u=V.getSizeInPixels(this._styleOptions.whiskerEndLength,h);u=Math.min(h,u),u=2*Math.floor((u-1)/2)+1;var g=Math.floor((t+i)/2)+.5,d=g-Math.floor(u/2)-.5,c=g+Math.floor(u/2)+.5;this._drawLine(g,this._low,g,this._high,"whisker"),this._drawLine(d,this._low,c,this._low,"whiskerEnd"),this._drawLine(d,this._high,c,this._high,"whiskerEnd"),this._q2Box=new e.Polygon(l,this._createQ2PointsArray(0));var p=Y.getRectangleFill(this._chart,this._styleOptions.q2Color,this._styleOptions._q2Pattern,h);this._q2Box.setFill(p),this._applyCustomStyle(this._q2Box,"q2"),this.addChild(this._q2Box),this._q3Box=new e.Polygon(l,this._createQ3PointsArray(0));var _=Y.getRectangleFill(this._chart,this._styleOptions.q3Color,this._styleOptions._q3Pattern,h);this._q3Box.setFill(_),this._applyCustomStyle(this._q3Box,"q3"),this.addChild(this._q3Box),this._drawMedianLine(0),this._borderColor=this._styleOptions.borderColor,this._borderColor&&(this._borderWidth=this._styleOptions.borderWidth,this._drawBorders(this._borderColor,this._borderWidth)),this.IsSelected&&(this.IsSelected=!1,this.setSelected(!0))},c.prototype.showHoverEffect=function(){this.IsShowingHoverEffect||(this.IsShowingHoverEffect=!0,this.isSelected()?this._drawBorders(this._hoverColor,u.OUTER_BORDER_WIDTH,this._innerColor,u.INNER_BORDER_WIDTH):this._drawBorders(this._hoverColor,u.OUTER_BORDER_WIDTH_HOVER,this._innerColor,u.INNER_BORDER_WIDTH))},c.prototype.hideHoverEffect=function(){this.IsShowingHoverEffect&&(this.IsShowingHoverEffect=!1,this.isSelected()?this._drawBorders(this._outerColor,u.OUTER_BORDER_WIDTH,this._innerColor,u.INNER_BORDER_WIDTH):this._drawBorders(this._borderColor,this._borderWidth))},c.prototype.setSelected=function(e){this.IsSelected!=e&&(this.IsSelected=e,this.isHoverEffectShown()?e?this._drawBorders(this._hoverColor,u.OUTER_BORDER_WIDTH,this._innerColor,u.INNER_BORDER_WIDTH):this._drawBorders(this._hoverColor,u.OUTER_BORDER_WIDTH_HOVER,this._innerColor,u.INNER_BORDER_WIDTH):e?this._drawBorders(this._outerColor,u.OUTER_BORDER_WIDTH,this._innerColor,u.INNER_BORDER_WIDTH):this._drawBorders(this._borderColor,this._borderWidth))},c.prototype.UpdateSelectionEffect=function(){},c.prototype.getDisplayAnimation=function(e){return this.getInsertAnimation(e)},c.prototype.getDeleteAnimation=function(t){var i=new e.CustomAnimation(this.getCtx(),this,t),r=[this._x1,this._x2,this._q2,this._q2,this._q2,this._q2,this._q2];return i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,r),i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,0),i},c.prototype.getInsertAnimation=function(t){var i=new e.CustomAnimation(this.getCtx(),this,t),r=this._getAnimationParams();return this._setAnimationParams([this._x1,this._x2,this._q2,this._q2,this._q2,this._q2,this._q2]),i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,r),this.setAlpha(0),i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,1),i},c.prototype.getUpdateAnimation=function(t,i){var r=new e.CustomAnimation(this.getCtx(),this,t),a=i._getQ2Fill(),s=this._getQ2Fill();a.equals(s)||(this._setQ2Fill(a),r.getAnimator().addProp(e.Animator.TYPE_FILL,this,this._getQ2Fill,this._setQ2Fill,s));var n=i._getQ3Fill(),o=this._getQ3Fill();n.equals(o)||(this._setQ3Fill(n),r.getAnimator().addProp(e.Animator.TYPE_FILL,this,this._getQ3Fill,this._setQ3Fill,o));var l=this._getAnimationParams();return this._setAnimationParams(i._getAnimationParams()),r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,l),r},c.prototype._getAnimationParams=function(){return[this._x1,this._x2,this._low,this._q1,this._q2,this._q3,this._high]},c.prototype._setAnimationParams=function(e){this._render(e[0],e[1],e[2],e[3],e[4],e[5],e[6])},c.prototype._getQ2Fill=function(){return new e.SolidFill(this._styleOptions.q2Color)},c.prototype._setQ2Fill=function(e){this._styleOptions.q2Color=e.getColor()},c.prototype._getQ3Fill=function(){return new e.SolidFill(this._styleOptions.q3Color)},c.prototype._setQ3Fill=function(e){this._styleOptions.q3Color=e.getColor()},c.prototype._drawLine=function(t,i,r,a,s){var n=this._bHoriz?new e.Line(this.getCtx(),i,t,a,r):new e.Line(this.getCtx(),t,i,r,a);return this._applyCustomStyle(n,s),n.setPixelHinting(!0),this.addChild(n),n},c.prototype._drawMedianLine=function(t){if(!this._medianLine){var i=new e.Line(this.getCtx(),0,0,0,0);this._applyCustomStyle(i,"median"),i.setPixelHinting(!0),this.addChild(i),this._medianLine=i}var r=this._x1+t,a=this._x2-t,s=this._q2;this._bHoriz?(this._medianLine.setX1(s),this._medianLine.setX2(s),this._medianLine.setY1(r),this._medianLine.setY2(a)):(this._medianLine.setY1(s),this._medianLine.setY2(s),this._medianLine.setX1(r),this._medianLine.setX2(a))},c.prototype._drawBorders=function(t,i,r,a){if(!this._outerBorderShape){var s=this.getChildIndex(this._q2Box);this._innerBorderShape=new e.Polygon(this.getCtx()),this._innerBorderShape.setInvisibleFill(),this.addChildAt(this._innerBorderShape,s),this._outerBorderShape=new e.Polygon(this.getCtx()),this._outerBorderShape.setInvisibleFill(),this.addChildAt(this._outerBorderShape,s)}var n=0;i?(this._outerBorderShape.setPoints(this._createBoxPointsArray(0)),this._outerBorderShape.setSolidFill(t),n+=i,a?(this._innerBorderShape.setPoints(this._createBoxPointsArray(i)),this._innerBorderShape.setSolidFill(r),n+=a):this._innerBorderShape.setInvisibleFill()):(this._outerBorderShape.setInvisibleFill(),this._innerBorderShape.setInvisibleFill()),this._q2Box.setPoints(this._createQ2PointsArray(n)),this._q3Box.setPoints(this._createQ3PointsArray(n)),this._drawMedianLine(n)},c.prototype._createBoxPointsArray=function(e){var t,i,r=this._x1+e,a=this._x2-e;return this._q1<this._q3?(t=this._q1+e,i=this._q3-e):(t=this._q1-e,i=this._q3+e),this._createPointsArray(r,a,t,i)},c.prototype._createQ3PointsArray=function(e){var t,i=this._x1+e,r=this._x2-e,a=this._q2;return t=this._q2<this._q3?this._q3-e:this._q3+e,this._createPointsArray(i,r,a,t)},c.prototype._createQ2PointsArray=function(e){var t,i=this._x1+e,r=this._x2-e,a=this._q2;return t=this._q2<this._q1?this._q1-e:this._q1+e,this._createPointsArray(i,r,t,a)},c.prototype._createPointsArray=function(e,t,i,r){return this._bHoriz?[i,e,i,t,r,t,r,e]:[e,i,t,i,t,r,e,r]},c.prototype._applyCustomStyle=function(e,t){e.setStyle(this._styleOptions[t+"Style"]||this._styleOptions[t+"SvgStyle"],!0),e.setClassName(this._styleOptions[t+"ClassName"]||this._styleOptions[t+"SvgClassName"],!0)},c.prototype._cleanUp=function(){this.removeChildren(),this._q2Box=null,this._q3Box=null,this._medianLine=null,this._outerBorderShape=null,this._innerBorderShape=null};var p=function(e,t,i,r,a,s,n){this.Init(e),i=Math.max(2*Math.round(i/2),1);var o=Math.min(2*Math.ceil(p._BAR_WIDTH*i/2),i),l=Math.round(t)-i/2,h=l+i;if(null!=s&&null!=n){var g=Math.round(t)-o/2,d=g+o;this._rangeShape=new u(e,[g,s,d,s,d,n,g,n]),this.addChild(this._rangeShape)}this._changeShape=new u(e,[l,r,h,r,h,a,l,a]),this.addChild(this._changeShape),this.setPixelHinting(!0)};e.Obj.createSubclass(p,e.Container),p._BAR_WIDTH=.3,p.prototype.setChangeStyle=function(e,t,i,r,a){this._changeShape.setStyleProperties(e,t,i,r,a)},p.prototype.setRangeStyle=function(e,t,i,r){this._rangeShape&&this._rangeShape.setStyleProperties(e,t,i,null,r)},p.prototype.setSelected=function(e){this._changeShape.setSelected(e),this._rangeShape&&this._rangeShape.setSelected(e)},p.prototype.showHoverEffect=function(){this._changeShape.showHoverEffect(),this._rangeShape&&this._rangeShape.showHoverEffect()},p.prototype.hideHoverEffect=function(){this._changeShape.hideHoverEffect(),this._rangeShape&&this._rangeShape.hideHoverEffect()},p.prototype.getDisplayAnimation=function(t){var i=new e.CustomAnimation(this.getCtx(),this,t),r=this._changeShape.getPoints();if(this._changeShape.setPoints(p._getInitialPoints(r)),i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._changeShape,this._changeShape.getPoints,this._changeShape.setAnimationParams,r),this._rangeShape){var a=this._rangeShape.getPoints();this._rangeShape.setPoints(p._getInitialPoints(a)),i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._rangeShape,this._rangeShape.getPoints,this._rangeShape.setAnimationParams,a)}return i},p.prototype.getDeleteAnimation=function(t){var i=new e.CustomAnimation(this.getCtx(),this,t),r=p._getInitialPoints(this._changeShape.getPoints());if(i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._changeShape,this._changeShape.getPoints,this._changeShape.setAnimationParams,r),this._rangeShape){var a=p._getInitialPoints(this._rangeShape.getPoints());i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._rangeShape,this._rangeShape.getPoints,this._rangeShape.setAnimationParams,a)}return i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,0),i},p.prototype.getInsertAnimation=function(t){this.setAlpha(0);var i=this.getDisplayAnimation(t);return i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,1),i},p.prototype.getUpdateAnimation=function(t,i){var r=new e.CustomAnimation(this.getCtx(),this,t),a=this._changeShape.getPoints();this._changeShape.setPoints(i._changeShape.getPoints()),r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._changeShape,this._changeShape.getPoints,this._changeShape.setAnimationParams,a);var s=i._changeShape.getPrimaryFill().clone(),n=this._changeShape.getPrimaryFill();if(i._changeShape.isSelected()||this._changeShape.isSelected()||s.equals(n)||(this._changeShape.setFill(s),r.getAnimator().addProp(e.Animator.TYPE_FILL,this._changeShape,this._changeShape.getFill,this._changeShape.setFill,n)),this._rangeShape&&i._rangeShape){var o=this._rangeShape.getPoints();this._rangeShape.setPoints(i._rangeShape.getPoints()),r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._rangeShape,this._rangeShape.getPoints,this._rangeShape.setAnimationParams,o)}return r},p.prototype.UpdateSelectionEffect=function(){},p._getInitialPoints=function(e){var t=e[0],i=e[2],r=(e[1]+e[5])/2;return[t,r,i,r,i,r,t,r]};var _=function(e,t,i,r,a,s){this.x=e,this.y1=t,this.y2=i,this.groupIndex=r,this.group=a,this.filtered=s};e.Obj.createSubclass(_,e.Obj),_.prototype.isUpstep=function(e){return Math.abs(this.y2-e)>Math.abs(this.y1-e)},_.prototype.clone=function(){return new _(this.x,this.y1,this.y2,this.groupIndex,this.group,this.filtered)};var f=function(e,t,i,r,a,s,n,o,l,h,u,g){this.Init(e.getCtx()),this._chart=e,this._bArea=t,this._availSpace=i,this._baseline=r,this._style=a,this._className=s,this._fill=n,this._stroke=o,this._type=l,this._baseType=u||l,this._indicatorMap={},this.setCoords(h,g)};e.Obj.createSubclass(f,e.Container),f._INDICATOR_OFFSET=8,f.prototype.setCoords=function(e,t){this._arCoord=e,t&&(this._arBaseCoord=t),this.removeChildren(),this._bArea?this._renderAreas():this._renderLines(),this._positionIndicators()},f.prototype.getCoords=function(){return this._arCoord},f.prototype.getBaseCoords=function(){return this._arBaseCoord},f.prototype.getBaseline=function(){return this._baseline},f.prototype.isArea=function(){return this._bArea},f.prototype._getPointArrays=function(t,i){var r=[],a=[];r.push(a),t=f._convertToPointCoords(t);var s,n,o,l,h,u=z.isPolar(this._chart),g="centeredStepped"==i||"centeredSegmented"==i,d=g||"stepped"==i||"segmented"==i,c=V.getGroupWidth(this._chart),p=e.Agent.isRightToLeft(this.getCtx())&&z.isVertical(this._chart)?-1:1;u&&(s=t[t.length-1]);for(var _=!1,S=0;S<t.length;S++)null!=t[S]?(n=t[S],l=t[S]._isY2,o=g?n.x-c/2*p:n.x,l&&(_&&d&&(o+=c*p),_=!_),"curved"==i&&l&&a.push(null,null),s&&d&&this._pushCoord(a,o,s.y),this._bArea||"segmented"!=i&&"centeredSegmented"!=i||(a=[],r.push(a)),this._pushCoord(a,o,n.y),s=n):(N.isMixedFrequency(this._chart)||d&&!u&&s&&!l&&(h=g?s.x+.5*c*p:s.x+c*p,this._pushCoord(a,h,s.y)),"jet"!=this._chart.getOptions()._environment&&N.isMixedFrequency(this._chart)||(a=[],r.push(a),s=null));if(d&&!u&&s&&!l&&(h=g?s.x+.5*c*p:s.x+c*p,this._pushCoord(a,h,s.y)),u&&r.length>1){var C=r.pop();r[0]=C.concat(r[0])}return r},f.prototype._pushCoord=function(t,i,r){var a=te.convertAxisCoord(this._chart,new e.Point(i,r),this._availSpace);t.push(Math.round(10*a.x)/10,Math.round(10*a.y)/10)},f.prototype._isRing=function(){if(!z.isPolar(this._chart)||!N.hasGroupAxis(this._chart)||this._arCoord.length<H.getGroupCount(this._chart))return!1;for(var e=0;e<this._arCoord.length;e++)if(null==this._arCoord[e].x)return!1;return!0},f.prototype._getSplineType=function(){return z.isScatterBubble(this._chart)?e.PathUtils.SPLINE_TYPE_CARDINAL:z.isPolar(this._chart)?this._isRing()?e.PathUtils.SPLINE_TYPE_CARDINAL_CLOSED:e.PathUtils.SPLINE_TYPE_CARDINAL:z.isHorizontal(this._chart)?e.PathUtils.SPLINE_TYPE_MONOTONE_HORIZONTAL:e.PathUtils.SPLINE_TYPE_MONOTONE_VERTICAL},f.prototype._renderLines=function(){for(var t,i=this._getPointArrays(this._arCoord,this._type),r=0;r<i.length;r++){var a=i[r];if(a&&a.length>1){if("curved"==this._type){var s=f._getCurvedPathCommands(a,!1,this._getSplineType());(t=new e.Path(this.getCtx(),s)).setFill(null)}else this._isRing()?(t=new e.Polygon(this.getCtx(),a)).setFill(null):t=new e.Polyline(this.getCtx(),a);t.setStroke(this._stroke),t.setClassName(this._className).setStyle(this._style),this.addChild(t)}}},f.prototype._renderAreas=function(){var t=this._arCoord,i=this._arBaseCoord;!z.isPolar(this._chart)&&t.length>0&&i.length>0&&(t=t.slice(0),i=i.slice(0),null!=t[0].x&&null!=i[0].x&&(f._removeAreaEdge(t,0,this._baseline),f._removeAreaEdge(i,0,this._baseline),i[0].x=t[0].x),null!=t[t.length-1].x&&null!=i[i.length-1].x&&(f._removeAreaEdge(t,t.length-1,this._baseline),f._removeAreaEdge(i,i.length-1,this._baseline),i[i.length-1].x=t[t.length-1].x));var r=this._getPointArrays(t,this._type),a=this._getPointArrays(i,this._baseType);if(r.length==a.length)for(var s,n=0;n<r.length;n++){var o=r[n],l=a[n];if(!(o.length<2)){var h="curved"==this._type,u="curved"==this._baseType;this._isRing()&&(h||o.push(o[0],o[1]),l.length>=2&&!u&&l.push(l[0],l[1]));for(var g=[],d=0;d<l.length;d+=2)g.unshift(l[d],l[d+1]);if(h||u){var c=this._getSplineType(),p=h?f._getCurvedPathCommands(o,!1,c):e.PathUtils.polyline(o,!1);p+=u?f._getCurvedPathCommands(g,!0,c):e.PathUtils.polyline(g,!0),p+=e.PathUtils.closePath(),s=new e.Path(this.getCtx(),p)}else{var _=g.concat(o);s=new e.Polygon(this.getCtx(),_)}s.setFill(this._fill),s.setClassName(this._className).setStyle(this._style),this._stroke&&s.setStroke(this._stroke),this.addChild(s)}}},f.prototype._positionIndicators=function(){for(var t,i,r,a,s,n=0;n<this._arCoord.length;n++)s=this._arCoord[n],(t=this._indicatorMap[s.groupIndex])&&t.indicator&&(a=(s.isUpstep(this._baseline)?s.y2:s.y1)+f._INDICATOR_OFFSET*(t.direction==B.DIR_UP?-1:1),r=te.convertAxisCoord(this._chart,new e.Point(s.x,a),this._availSpace),(i=t.indicator).setTranslate(r.x,r.y),i.setAlpha(1),i.getParent().addChild(i))},f.prototype.getAnimationParams=function(e){return f._coordsToAnimationParams(this._arCoord,e?e._arCoord:null,this._baseline)},f.prototype.setAnimationParams=function(e){var t=f._animationParamsToCoords(e);this.setCoords(t)},f.prototype.getBaseAnimationParams=function(e){return f._coordsToAnimationParams(this._arBaseCoord,e?e._arBaseCoord:null,this._baseline)},f.prototype.setBaseAnimationParams=function(e){this._arBaseCoord=f._animationParamsToCoords(e)},f.prototype.getCommonGroupIndices=function(e){for(var t=[],i=0;i<this._arCoord.length;i++)if(!this._arCoord[i].filtered&&null!=this._arCoord[i].x)for(var r=0;r<e._arCoord.length;r++)if(!e._arCoord[r].filtered&&null!=e._arCoord[r].x&&this._arCoord[i].group==e._arCoord[r].group){t.push(this._arCoord[i].groupIndex);break}return t},f.prototype.addIndicator=function(e,t,i){i.setAlpha(0),this._indicatorMap[e]={direction:t,indicator:i}},f.prototype.removeIndicators=function(){for(var e in this._indicatorMap){var t=this._indicatorMap[e].indicator;t&&t.getParent().removeChild(t)}this._indicatorMap={}},f._convertToPointCoords=function(t){for(var i=[],r=0;r<t.length;r++)if(!t[r].filtered)if(null==t[r].x)i.push(null);else if(i.push(new e.Point(t[r].x,t[r].y1)),t[r].y1!=t[r].y2){var a=new e.Point(t[r].x,t[r].y2);a._isY2=!0,i.push(a)}return i},f._coordsToAnimationParams=function(t,i,r){if(i&&i.length>0)if(t&&t.length>0){t=t.slice(0);for(var a,s,n,o=f._coordsToGroups(i),l=f._coordsToGroups(t),h=t.length,u=o.length-1;u>=0;u--)a=o[u],-1==(s=e.ArrayUtils.getIndex(l,a))?(0==h?(n=t[0].clone(),t[0]=t[0].clone(),f._removeCoordJump(n,t[0],r)):(n=t[h-1].clone(),t[h-1]=t[h-1].clone(),f._removeCoordJump(t[h-1],n,r)),n.groupIndex=-1,t.splice(h,0,n)):h=s}else{t=[];for(u=0;u<i.length;u++)t.push(new _(i[u].x,r,r))}for(var g=[],d=0;d<t.length;d++)t[d].filtered||(null==t[d].x?(g.push(1/0),g.push(1/0),g.push(1/0)):(g.push(t[d].x),g.push(t[d].y1),g.push(t[d].y2)),g.push(t[d].groupIndex));return g},f._animationParamsToCoords=function(e){for(var t=[],i=0;i<e.length;i+=4)e[i]==1/0||isNaN(e[i])?t.push(new _(null,null,null,e[i+3])):t.push(new _(e[i],e[i+1],e[i+2],e[i+3]));return t},f._coordsToGroups=function(e){for(var t=[],i=0;i<e.length;i++)e[i].filtered||t.push(e[i].group);return t},f._removeCoordJump=function(e,t,i){e.isUpstep(i)?t.y1=t.y2:e.y2=e.y1},f._getCurvedPathCommands=function(t,i,r){var a=[],s=[];a.push(s);for(var n=0;n<t.length;n+=2)null==t[n]?(s=[],a.push(s)):s.push(t[n],t[n+1]);if(r==e.PathUtils.SPLINE_TYPE_CARDINAL_CLOSED&&a.length>1){var o=a.pop();a[0]=o.concat(a[0]),r=e.PathUtils.SPLINE_TYPE_CARDINAL}var l="";for(n=0;n<a.length;n++)s=a[n],l+=e.PathUtils.curveThroughPoints(s,i,r),i=!0;return l},f._removeAreaEdge=function(e,t,i){var r=e[t].clone();r.isUpstep(i)?r.y1=r.y2:r.y2=r.y1,e[t]=r};var S=function(e,t,i,r,a,s){this.Init(e,t,null,i,r,a,a,null,null,!0),s&&this.setStroke(S.DEFAULT_STROKE)};e.Obj.createSubclass(S,e.SimpleMarker),S.DEFAULT_STROKE=new e.SolidStroke("none"),S.SELECTED_FILL=new e.SolidFill("#FFFFFF"),S.SELECTED_STROKE=new e.SolidStroke("#5A5A5A",1,1.5),S.prototype.setDataColor=function(t){this._dataColor=t,this._hoverStroke=new e.SolidStroke(t,1,1.5)},S.prototype.getDataColor=function(){return this._dataColor},S.prototype.showHoverEffect=function(){this.IsShowingHoverEffect=!0,this.setStroke(this._hoverStroke)},S.prototype.hideHoverEffect=function(){this.IsShowingHoverEffect=!1,this.setStroke(this.isSelected()?S.SELECTED_STROKE:S.DEFAULT_STROKE)},S.prototype.setSelected=function(e){this.IsSelected!=e&&(this.IsSelected=e,this.isSelected()?(this.setFill(S.SELECTED_FILL),this.setStroke(this.isHoverEffectShown()?this._hoverStroke:S.SELECTED_STROKE)):(this.setInvisibleFill(),this.setStroke(this.isHoverEffectShown()?this._hoverStroke:S.DEFAULT_STROKE)))},S.prototype.UpdateSelectionEffect=function(){};var C=function(e){this.Init(e.getCtx(),e.processEvent,e),this._parentChart=e,this._chart=e.overview?e.overview.getBackgroundChart():null,this._id=e.getId()+"_overview"};e.Obj.createSubclass(C,e.Overview),C.prototype._renderChart=function(t,i,r){this._chartContainer=new e.Container(this.getCtx()),this.addChild(this._chartContainer);t=e.JsonUtils.merge({legend:{rendered:"off",size:null},xAxis:{viewportMin:null,viewportMax:null,viewportStartGroup:null,viewportEndGroup:null,axisLine:{rendered:"off"},size:null,maxSize:.5,title:null},yAxis:{rendered:"off",size:null},y2Axis:{rendered:"off",size:null},splitDualY:"off",title:{text:null},subtitle:{text:null},footnote:{text:null},titleSeparator:{rendered:"off"},styleDefaults:{animationIndicators:"none"},layout:{outerGapWidth:0,outerGapHeight:0},_isOverview:!0},t),N.hasGroupAxis(this._parentChart)&&(t.xAxis.tickLabel.rendered="off"),z.isStock(this._parentChart)&&t.series&&t.series[0]&&(t.series=[t.series[0]],t.series[0].type="lineWithArea");var a=this._parentChart.getOptions().overview.content;(t=e.JsonUtils.merge(a,t)).zoomAndScroll="off",this._chart||(this._chart=e.Chart.newInstance(this.getCtx()),this._chart.setId(this._id)),this._chartContainer.addChild(this._chart),this._chart.render(t,i,r);var s=new e.Rect(this.getCtx(),0,0,i,r);return s.setInvisibleFill(),this._chartContainer.addChild(s),this._chart.getEventManager().setKeyboardHandler(null),this._chart.__getPlotAreaSpace().h},C.prototype.render=function(e,t,i){e.style={overviewBackgroundColor:"rgba(0,0,0,0)",windowBackgroundColor:"rgba(0,0,0,0)",windowBorderTopColor:"#333333",windowBorderRightColor:"#333333",windowBorderBottomColor:"#333333",windowBorderLeftColor:"#333333",leftFilterPanelColor:"rgba(5,65,135,0.1)",rightFilterPanelColor:"rgba(5,65,135,0.1)",handleBackgroundImage:e.chart._resources.overviewGrippy,handleWidth:3,handleHeight:15,handleFillColor:"rgba(0,0,0,0)"},e.animationOnClick="off";var r=this._renderChart(e.chart,t,i);C.superclass.render.call(this,e,t,r)},C.prototype.destroy=function(){C.superclass.destroy.call(this),this._parentChart=null,this._chart=null},C.prototype.getBackgroundChart=function(){return this._chart},C.prototype.isBackgroundRendered=function(){return!1},C.prototype.isLeftAndRightFilterRendered=function(){return!0},C.prototype.HandleKeyDown=function(e){},C.prototype.HandleKeyUp=function(e){};var m=function(e,t,i,r,a,s,n){this.Init(e.getCtx()),this._axisCoord=t,this._availSpace=n.clone(),this._bbox=null,this._dataItemGaps=V.getDataItemGaps(e)*m._MAX_DATA_ITEM_GAP,this._setBarCoords(i,r,a,s)};e.Obj.createSubclass(m,h),m._MIN_BAR_LENGTH_FOR_GAPS=4,m._MAX_DATA_ITEM_GAP=3,m.prototype.getAnimationParams=function(){return[this._baselineCoord,this._endCoord,this._x1,this._x2]},m.prototype.setAnimationParams=function(e,t){this._setBarCoords(e[0],e[1],e[2],e[3])},m.prototype.getPrimaryFill=function(){return this.getFill()},m.prototype.getDisplayAnimation=function(t){var i=this.getAnimationParams();this.setAnimationParams([this._axisCoord,this._axisCoord,0,0]);var r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r},m.prototype.getDeleteAnimation=function(t){var i=[this._baselineCoord,this._baselineCoord,this._x1,this._x2],r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,0),r},m.prototype.getInsertAnimation=function(t){this.setAlpha(0);var i=this.getAnimationParams();this.setAnimationParams([this._baselineCoord,this._baselineCoord,this._x1,this._x2]);var r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,1),r},m.prototype._setBarCoords=function(t,i,r,a){var s=this._availSpace.x+this._availSpace.w/2,n=this._availSpace.y+this._availSpace.h/2,o=Math.max(i,t),l=Math.abs(i-t)>=m._MIN_BAR_LENGTH_FOR_GAPS&&this._axisCoord!=t?Math.min(i,t)+this._dataItemGaps:Math.min(i,t),h=360-e.Math.radsToDegrees(Math.max(r,a))+90,u=e.Math.radsToDegrees(Math.abs(a-r));this.setWedgeParams(s,n,o,o,h,u,this._dataItemGaps,l);var g=te.polarToCartesian(t,r,this._availSpace),d=te.polarToCartesian(t,a,this._availSpace),c=te.polarToCartesian(i,r,this._availSpace),p=te.polarToCartesian(i,a,this._availSpace),_=Math.min(g.x,d.x,c.x,p.x),f=Math.max(g.x,d.x,c.x,p.x),S=Math.min(g.y,d.y,c.y,p.y),C=Math.max(g.y,d.y,c.y,p.y);this._bbox=new e.Rectangle(_,S,f-_,C-S),this._baselineCoord=t,this._endCoord=i,this._x1=r,this._x2=a},m.prototype.getBoundingBox=function(){return this._bbox},m.prototype.getOriginalBarSize=function(){return this._bbox.w};var y=function(e,t,i,r,a,s,n){this.Init(e),this._markerSize=s,this._isInvisible=n,this._drawPath(t,i,r,a)};e.Obj.createSubclass(y,e.Path),y.prototype._drawPath=function(t,i,r,a){var s=Math.atan2(a-i,r-t),n=this._markerSize/2,o=Math.PI/8,l=e.PathUtils.moveTo(t+n*Math.cos(s+o),i+n*Math.sin(s+o))+e.PathUtils.arcTo(n,n,2*(Math.PI-o),1,t+n*Math.cos(s-o),i+n*Math.sin(s-o))+e.PathUtils.lineTo(r-n*Math.cos(s+o),a-n*Math.sin(s+o))+e.PathUtils.arcTo(n,n,2*(Math.PI-o),1,r-n*Math.cos(s-o),a-n*Math.sin(s-o))+e.PathUtils.closePath();this.setCmds(l),this._x1=t,this._y1=i,this._x2=r,this._y2=a},y.prototype.setStyleProperties=function(t,i,r,a,s){this._dataColor=r;var n=e.SelectionEffectUtils.getHoverBorderColor(r);this._isInvisible?(this.setInvisibleFill(),this._hoverStroke=new e.SolidStroke(n,1,1.5)):(this.setFill(t),this.setStroke(i),this.setHoverStroke(new e.SolidStroke(a,1,1),new e.SolidStroke(n,1,3.5)),this.setSelectedStroke(new e.SolidStroke(a,1,1.5),new e.SolidStroke(s,1,4.5)),this.setSelectedHoverStroke(new e.SolidStroke(a,1,1.5),new e.SolidStroke(n,1,4.5)))},y.prototype.getDataColor=function(){return this._dataColor},y.prototype.showHoverEffect=function(){this._isInvisible?(this.IsShowingHoverEffect=!0,this.setStroke(this._hoverStroke)):y.superclass.showHoverEffect.call(this)},y.prototype.hideHoverEffect=function(){this._isInvisible?(this.IsShowingHoverEffect=!1,this.setStroke(this.isSelected()?S.SELECTED_STROKE:S.DEFAULT_STROKE)):y.superclass.hideHoverEffect.call(this)},y.prototype.setSelected=function(e){if(this._isInvisible){if(this.IsSelected==e)return;this.IsSelected=e,this.isSelected()?(this.setFill(S.SELECTED_FILL),this.setStroke(this.isHoverEffectShown()?this._hoverStroke:S.SELECTED_STROKE)):(this.setInvisibleFill(),this.setStroke(this.isHoverEffectShown()?this._hoverStroke:S.DEFAULT_STROKE))}else y.superclass.setSelected.call(this,e)},y.prototype.UpdateSelectionEffect=function(){this._isInvisible||y.superclass.UpdateSelectionEffect.call(this)},y.prototype.getAnimationParams=function(){return[this._x1,this._y1,this._x2,this._y2]},y.prototype.setAnimationParams=function(e){this._drawPath(e[0],e[1],e[2],e[3])},y.prototype.isInvisible=function(){return this._isInvisible},y.prototype.getBoundingBox=function(){return this.getBoundingBox1().getUnion(this.getBoundingBox2())},y.prototype.getBoundingBox1=function(){return new e.Rectangle(this._x1-this._markerSize/2,this._y1-this._markerSize/2,this._markerSize,this._markerSize)},y.prototype.getBoundingBox2=function(){return new e.Rectangle(this._x2-this._markerSize/2,this._y2-this._markerSize/2,this._markerSize,this._markerSize)};var v=function(e,t,i){this.Init(e,t,i)};e.Obj.createSubclass(v,e.Container),v.BEHAVIOR_SNAP="SNAP",v.BEHAVIOR_SMOOTH="SMOOTH",v.BEHAVIOR_AUTO="AUTO",v.TOOLTIP_ID="_dvtDataCursor",v.prototype.Init=function(t,i,r){v.superclass.Init.call(this,t),this._bHoriz=r,this._options=i,this.setMouseEnabled(!1),this.setVisible(!1);var a=i.lineWidth,s=i.lineColor,n=e.Stroke.convertTypeString(i.lineStyle),o=new e.SolidStroke(s,1,a);if(o.setStyle(n),this._cursorLine=new e.Line(this.getCtx(),0,0,0,0,"dcLine"),this._cursorLine.setStroke(o),this.addChild(this._cursorLine),"off"!=i.markerDisplayed){this._marker=new e.Container(this._context),this._marker.setMouseEnabled(!1),this.addChild(this._marker);var l=i.markerSize,h=new e.SimpleMarker(this._context,e.SimpleMarker.CIRCLE,null,0,0,l+4*a,l+4*a);h.setSolidFill(s),this._marker.addChild(h);var u=new e.SimpleMarker(this._context,e.SimpleMarker.CIRCLE,null,0,0,l+2*a,l+2*a);u.setSolidFill("white"),this._marker.addChild(u),this._markerInnerCircle=new e.SimpleMarker(this._context,e.SimpleMarker.CIRCLE,null,0,0,l,l),this._marker.addChild(this._markerInnerCircle)}},v.prototype.render=function(t,i,r,a,s,n){var o,l=this.isHorizontal(),h=e.Agent.isRightToLeft(this.getCtx());if(null!=s&&""!=s){var u=this.getCtx().getStageAbsolutePosition(),g=this.getCtx().getTooltipManager(v.TOOLTIP_ID);g.showDatatip(i+u.x,r+u.y,s,n,!1),o=g.getTooltipBounds();var d,c,p=this._options.markerSize+4*this._options.lineWidth;l?(d=h?t.x-.75*o.w:t.x+t.w-o.w/4,c=a-o.h/2,!h&&d-i<p?d=i+p:h&&i-(d+o.w)<p&&(d=i-p-o.w)):(d=a-o.w/2,r-((c=t.y-.75*o.h)+o.h)<p&&(c=r-p-o.h)),g.positionTip(d+u.x,c+u.y),(o=g.getTooltipBounds()).x-=u.x,o.y-=u.y}if(l?(this._cursorLine.setTranslateY(a),h?(this._cursorLine.setX1(o?o.x+o.w-1:t.x),this._cursorLine.setX2(t.x+t.w)):(this._cursorLine.setX1(t.x),this._cursorLine.setX2(o?o.x+1:t.x+t.w))):(this._cursorLine.setTranslateX(a),this._cursorLine.setY1(o?o.y+o.h-1:t.y),this._cursorLine.setY2(t.y+t.h)),this._marker){this._marker.setTranslate(i,r);var _=this._options.markerColor;this._markerInnerCircle.setSolidFill(_||n),e.Agent.workaroundFirefoxRepaint(this._marker)}},v.prototype.isHorizontal=function(){return this._bHoriz},v.prototype.getBehavior=function(){return this._behavior?this._behavior:v.BEHAVIOR_AUTO},v.prototype.setBehavior=function(e){this._behavior=e};var A=function(e,t,i,r,a,s,n,o,l){this.Init(e,t,i,r,a,s,n,o,l)};e.Obj.createSubclass(A,e.Path),A.prototype.Init=function(t,i,r,a,s,n,o,l,h){A.superclass.Init.call(this,t.getCtx()),this._chart=t;var u=t.getOptions().styleDefaults;this._seriesIndex=i,this._numDrawnSeries=r,this._funnelWidth=a,this._funnelHeight=s,this._startPercent=n,this._valuePercent=o,this._fillPercent=l,this._3dRatio="on"==u.threeDEffect?1:0,this._gap=h;var g=this._getPath();this._dataColor=V.getColor(this._chart,this._seriesIndex,0),this._backgroundColor=u.backgroundColor?u.backgroundColor:u.funnelBackgroundColor,this.setCmds(g.slice),g.bar&&(this._bar=new e.Path(this.getCtx(),g.bar),this.addChild(this._bar),this._bar.setMouseEnabled(!1)),this._setColorProperties(g.sliceBounds),this._label=this._getSliceLabel(g.sliceBounds,g.barBounds),null!=this._label&&(this._label.setMouseEnabled(!1),this.addChild(this._label))},A._FUNNEL_3D_WIDTH_RATIO=.08,A._FUNNEL_ANGLE_2D=36,A._FUNNEL_RATIO=1/3,A._BORDER_COLOR="#FFFFFF",A._MIN_CHARS_DATA_LABEL=3,A._LINE_FRACTION=2/3,A._AREA_FRACTION=.41,A._HEIGHT_FRACTION=.28,A._LINE_FRACTION_2=.4,A._AREA_FRACTION_2=.8,A._HEIGHT_FRACTION_2=.7,A.prototype._getPath=function(){var t=e.Agent.isRightToLeft(this.getCtx()),i=H.getSeriesCount(this._chart),r=(this._numDrawnSeries+1)*this._gap,a=e.Math.degreesToRads(A._FUNNEL_ANGLE_2D-2*this._3dRatio),s=this._funnelWidth-i*this._gap,n=s/Math.sin(e.Math.degreesToRads(A._FUNNEL_ANGLE_2D)),o=this._funnelHeight/Math.sin(a),l=this._3dRatio*this._funnelWidth/this._funnelHeight*A._FUNNEL_3D_WIDTH_RATIO;l<1e-5&&(l=0);var h,u,g,d,c,p,_,f,S,C,m,y,v=this._funnelHeight,x=this._funnelHeight*A._FUNNEL_RATIO;this._startPercent<A._AREA_FRACTION?(h=this._startPercent,g=v,c=this._funnelHeight*A._LINE_FRACTION,_=A._AREA_FRACTION,S=s*A._HEIGHT_FRACTION,m=s*(1-A._HEIGHT_FRACTION)):this._startPercent<A._AREA_FRACTION_2?(h=this._startPercent-A._AREA_FRACTION,g=this._funnelHeight*A._LINE_FRACTION,c=this._funnelHeight*A._LINE_FRACTION_2,_=A._AREA_FRACTION_2-A._AREA_FRACTION,S=s*(A._HEIGHT_FRACTION_2-A._HEIGHT_FRACTION),m=s*(1-A._HEIGHT_FRACTION_2)):(h=this._startPercent-A._AREA_FRACTION_2,g=this._funnelHeight*A._LINE_FRACTION_2,c=x,_=1-A._AREA_FRACTION_2,S=s*(1-A._HEIGHT_FRACTION_2),m=0),this._startPercent+this._valuePercent<A._AREA_FRACTION?(d=v,p=this._funnelHeight*A._LINE_FRACTION,u=this._startPercent+this._valuePercent,f=A._AREA_FRACTION,C=s*A._HEIGHT_FRACTION,y=s*(1-A._HEIGHT_FRACTION)):this._startPercent+this._valuePercent<A._AREA_FRACTION_2?(d=this._funnelHeight*A._LINE_FRACTION,p=this._funnelHeight*A._LINE_FRACTION_2,u=this._startPercent+this._valuePercent-A._AREA_FRACTION,f=A._AREA_FRACTION_2-A._AREA_FRACTION,C=s*(A._HEIGHT_FRACTION_2-A._HEIGHT_FRACTION),y=s*(1-A._HEIGHT_FRACTION_2)):(d=this._funnelHeight*A._LINE_FRACTION_2,p=x,u=this._startPercent+this._valuePercent-A._AREA_FRACTION_2,f=1-A._AREA_FRACTION_2,C=s*(1-A._HEIGHT_FRACTION_2),y=0);var b,I,T,E=Math.sqrt((_-h)/_*g*g+h/_*c*c),D=Math.sqrt((f-u)/f*d*d+u/f*p*p),O=.98*Math.asin(((E-c)*S/(g-c)+m)/n),P=.98*Math.asin(((D-p)*C/(d-p)+y)/n),M=(1+A._FUNNEL_RATIO)/2*this._funnelHeight+o,R=(1-A._FUNNEL_RATIO)/2*this._funnelHeight-o;t?(b=[n*Math.sin(O)+r,M-o*Math.cos(O),n*Math.sin(P)+r,M-o*Math.cos(P),n*Math.sin(P)+r,R+o*Math.cos(P),n*Math.sin(O)+r,R+o*Math.cos(O)],I=0,T=1):(b=[this._funnelWidth-r-n*Math.sin(O),M-o*Math.cos(O),this._funnelWidth-r-n*Math.sin(P),M-o*Math.cos(P),this._funnelWidth-r-n*Math.sin(P),R+o*Math.cos(P),this._funnelWidth-r-n*Math.sin(O),R+o*Math.cos(O)],I=1,T=0);var w=e.PathUtils.moveTo(b[0],b[1]),L=null;w+=e.PathUtils.arcTo(l*(b[1]-b[7])/2,(b[1]-b[7])/2,Math.PI,T,b[6],b[7]),w+=e.PathUtils.arcTo(l*(b[1]-b[7])/2,(b[1]-b[7])/2,Math.PI,T,b[0],b[1]),w+=e.PathUtils.arcTo(n,o,a,I,b[2],b[3]),w+=e.PathUtils.arcTo(l*(b[3]-b[5])/2,(b[3]-b[5])/2,Math.PI,T,b[4],b[5]),w+=e.PathUtils.arcTo(n,o,a,I,b[6],b[7]);var B=new e.Rectangle(Math.min(b[0],b[2]),b[5],Math.abs(b[0]-b[2]),Math.abs(b[3]-b[5]));if(null!=this._fillPercent){var F=Math.max(Math.min(this._fillPercent,1),0),k=t?-F*Math.PI:F*Math.PI;L=e.PathUtils.moveTo(b[0],b[1]),L+=e.PathUtils.arcTo(n,o,a,I,b[2],b[3]),L+=e.PathUtils.arcTo(l*(b[3]-b[5])/2,(b[3]-b[5])/2,k,T,b[2]+l*(b[3]-b[5])/2*Math.sin(k),(b[5]+b[3])/2+(b[3]-b[5])/2*Math.cos(k)),this._fillPercent>.95?L+=e.PathUtils.arcTo(n,o,a,I,b[6],b[1]+F*(b[7]-b[1])):this._fillPercent<.05?L+=e.PathUtils.arcTo(n,o,a,T,b[6],b[1]+F*(b[7]-b[1])):L+=e.PathUtils.lineTo(b[6]+l*(b[1]-b[7])/2*Math.sin(k),(b[7]+b[1])/2+(b[1]-b[7])/2*Math.cos(k)),L+=e.PathUtils.arcTo(l*(b[1]-b[7])/2,(b[1]-b[7])/2,k,I,b[0],b[1]),L+=e.PathUtils.closePath();var N=new e.Rectangle(Math.min(b[0],b[2]),b[5]+Math.abs(b[3]-b[5])*(1-F),Math.abs(b[0]-b[2]),Math.abs(b[3]-b[5])*F)}return{slice:w,bar:L,sliceBounds:B,barBounds:L?N:B}},A.prototype._getSliceLabel=function(t,i){var r=H.getDataLabel(this._chart,this._seriesIndex,0);if(r||(r=H.getSeriesLabel(this._chart,this._seriesIndex)),r&&"none"!=V.getDataLabelPosition(this._chart,this._seriesIndex,0)){var a=new e.MultilineText(this.getCtx(),r,0,0),s=null!=V.getPattern(this._chart,this._seriesIndex,0),n=[this._chart.getOptions().styleDefaults.dataLabelStyle,new e.CSSStyle(H.getDataItem(this._chart,this._seriesIndex,0).labelStyle)],o=e.CSSStyle.mergeStyles(n);if(a.setCSSStyle(o),e.TextUtils.fitText(a,t.h-this._3dRatio*(.8-this._valuePercent)*50,t.w,this,A._MIN_CHARS_DATA_LABEL)){var l=a.getDimensions(),h=this._getLabelPosition(t);if(s){var u=.15*l.h,g=e.Agent.isRightToLeft(this.getCtx())?.5:-.5,d=e.PathUtils.roundedRectangle(l.x-u,l.y,l.w+2*u,l.h,2,2,2,2),c=new e.Path(this.getCtx(),d);c.setSolidFill("#FFFFFF",.9),h.translate(g*l.h,-g*l.w),c.setMatrix(h),this.addChild(c)}var p=s?"#000000":i.containsPoint(t.x,t.y+(t.h-l.w)/2)?e.ColorUtils.getContrastingTextColor(this._dataColor):e.ColorUtils.getContrastingTextColor(this._backgroundColor);return o.getStyle("color")&&!e.Agent.isHighContrast()||a.setCSSStyle(o.setStyle("color",p)),a.setMatrix(this._getLabelPosition(t)),a.alignCenter(),a.alignMiddle(),a}}},A.prototype._getLabelPosition=function(t){var i=this._3dRatio*(t.h*this._funnelWidth/this._funnelHeight*A._FUNNEL_3D_WIDTH_RATIO/2),r=new e.Matrix;return e.Agent.isRightToLeft(this.getCtx())?(r.rotate(Math.PI/2),r.translate(t.x+t.w/2-i,t.y+t.h/2)):(r.rotate(3*Math.PI/2),r.translate(t.x+t.w/2+i,t.y+t.h/2)),r},A.prototype._setColorProperties=function(t){var i=Y.getFunnelPyramidSliceFill(this._chart,this._seriesIndex,this._dataColor,t),r=V.getBorderColor(this._chart,this._seriesIndex,0);null==r&&this._3dRatio>0&&(r=A._BORDER_COLOR);var a=V.getBorderWidth(this._chart,this._seriesIndex,0),s=e.SelectionEffectUtils.getHoverBorderColor(this._dataColor),n=Y.getFunnelPyramidSliceFill(this._chart,this._seriesIndex,this._backgroundColor,t,!0);this._bar?(this.setFill(n),this._bar.setFill(i),this._bar.setStyle(V.getStyle(this._chart,this._seriesIndex,0)),this._bar.setClassName(V.getClassName(this._chart,this._seriesIndex,0))):(this.setFill(i),this.setStyle(V.getStyle(this._chart,this._seriesIndex,0)),this.setClassName(V.getClassName(this._chart,this._seriesIndex,0))),r&&this.setSolidStroke(r,null,a),this.OriginalStroke=this.getStroke();var o=null!=this._bar?this._bar:this;if(o.setHoverStroke(new e.SolidStroke(s,1,2)),this._chart.isSelectionSupported()){var l=V.getSelectedInnerColor(this._chart),h=V.getSelectedOuterColor(this._chart)?V.getSelectedOuterColor(this._chart):this._dataColor;o.setSelectedStroke(new e.SolidStroke(l,1,1.5),new e.SolidStroke(h,1,4.5)),o.setSelectedHoverStroke(new e.SolidStroke(l,1,1.5),new e.SolidStroke(s,1,4.5)),this.setCursor(e.SelectionEffectUtils.getSelectingCursor())}},A.prototype.getAnimationParams=function(){return[this._startPercent,this._valuePercent,this._fillPercent,this.getAlpha(),this._3dRatio]},A.prototype.setAnimationParams=function(e){this._startPercent=e[0],this._valuePercent=e[1],this._fillPercent=null!=this._fillPercent?e[2]:null,this.setAlpha(e[3]),this._3dRatio=e[4];var t=this._getPath();this.setCmds(t.slice),t.bar&&this._bar&&this._bar.setCmds(t.bar),this._label&&this._label.setMatrix(this._getLabelPosition(t.sliceBounds))},A.prototype.setSelected=function(e){if(null!=this._bar){if(this.IsSelected==e)return;this.IsSelected=e,this._bar.setSelected(e)}else A.superclass.setSelected.call(this,e);var t=this.getDimensions(),i=null!=this._bar?this._bar:this,r=t.w;e?(i.setScaleX((r-3)/r),i.setTranslateX(Math.ceil(1.5)+3/r*t.x)):(i.setScaleX(1),i.setTranslateX(0))},A.prototype.showHoverEffect=function(){null!=this._bar?this._bar.showHoverEffect():A.superclass.showHoverEffect.call(this)},A.prototype.hideHoverEffect=function(){null!=this._bar?this._bar.hideHoverEffect():A.superclass.hideHoverEffect.call(this)},A.prototype.copyShape=function(){return new A(this._chart,this._seriesIndex,this._numDrawnSeries,this._funnelWidth,this._funnelHeight,this._startPercent,this._valuePercent,this._fillPercent,this._gap)};var x=function(e,t,i,r,a,s,n,o){this.Init(e,t,i,r,a,s,n,o)};e.Obj.createSubclass(x,e.Path),x.prototype.Init=function(t,i,r,a,s,n,o,l){x.superclass.Init.call(this,t.getCtx()),this._chart=t;var h=t.getOptions().styleDefaults;this._seriesIndex=i,this._numDrawnSeries=r,this._pyramidWidth=a,this._pyramidHeight=s,this._startPercent=n,this._valuePercent=o,this._3dRatio="on"==h.threeDEffect?1:0,this._gap=l;var u=this._getPath();this._dataColor=V.getColor(this._chart,this._seriesIndex,0),this._3dRatio>0?(this.setCmds(u.threeDPathTop),this._threeDPathSide=new e.Path(this.getCtx(),u.threeDPathSide),this._mainFace=new e.Path(this.getCtx(),u.slice),this.addChild(this._threeDPathSide),this.addChild(this._mainFace)):this.setCmds(u.slice),this._setColorProperties(u.sliceBounds),this._label=this._getSliceLabel(u.sliceBounds),null!=this._label&&(this._label.setMouseEnabled(!1),this.addChild(this._label))},x._BORDER_COLOR="#FFFFFF",x._MIN_CHARS_DATA_LABEL=3,x._SLICE_LABEL_HORIZONTAL_PADDING=4,x._3D_WIDTH_FACTOR=.2,x.prototype._getPath=function(){var t,i,r,a,s,n,o=e.Agent.isRightToLeft(this.getCtx()),l=H.getSeriesCount(this._chart),h=(l-this._numDrawnSeries-1)*this._gap,u=this._3dRatio*x._3D_WIDTH_FACTOR*.98*this._pyramidWidth,g=this._chart.getOptions(),d=Math.sqrt(Math.pow(this._pyramidHeight-(l-1)*this._gap,2)*(1-this._startPercent)),c=this._startPercent+this._valuePercent>=1?0:Math.sqrt(Math.pow(this._pyramidHeight-(l-1)*this._gap,2)*(1-this._startPercent-this._valuePercent)),p=.98*(1-this._3dRatio*x._3D_WIDTH_FACTOR)*this._pyramidWidth*(c/this._pyramidHeight),_=0==this._numDrawnSeries?d:d-this._gap,f=.98*(1-this._3dRatio*x._3D_WIDTH_FACTOR)*this._pyramidWidth*(_/this._pyramidHeight);if(o?(i=[this._pyramidWidth-.5*this._pyramidWidth+u/2-p/2,h+c],a=[this._pyramidWidth-.5*this._pyramidWidth+u/2-f/2,h+d],r=[this._pyramidWidth-.5*this._pyramidWidth+u/2+f/2,h+d],t=[this._pyramidWidth-.5*this._pyramidWidth+u/2+p/2,h+c]):(t=[.5*this._pyramidWidth-u/2-p/2,h+c],r=[.5*this._pyramidWidth-u/2-f/2,h+d],a=[.5*this._pyramidWidth-u/2+f/2,h+d],i=[.5*this._pyramidWidth-u/2+p/2,h+c]),"on"==g.styleDefaults.threeDEffect){var S=this._3dRatio*x._3D_WIDTH_FACTOR*f*Math.sqrt(2)/2,C=this._3dRatio*x._3D_WIDTH_FACTOR*p*Math.sqrt(2)/2;s=e.PathUtils.moveTo(i[0],i[1]),s+=e.PathUtils.lineTo(i[0]+(o?-1:1)*Math.max(C,1),i[1]-Math.max(C,.5)),s+=e.PathUtils.lineTo(t[0]+(o?-1:1)*Math.max(C,1),t[1]-Math.max(C,.5)),s+=e.PathUtils.lineTo(t[0],t[1]),s+=e.PathUtils.closePath(),n=e.PathUtils.moveTo(i[0],i[1]),n+=e.PathUtils.lineTo(i[0]+(o?-1:1)*Math.max(C,1),i[1]-Math.max(C,.5)),n+=e.PathUtils.lineTo(a[0]+(o?-1:1)*S,a[1]-S),n+=e.PathUtils.lineTo(a[0],a[1]),n+=e.PathUtils.closePath()}var m=e.PathUtils.moveTo(i[0],i[1]);m+=e.PathUtils.lineTo(a[0],a[1]),m+=e.PathUtils.lineTo(r[0],r[1]),m+=e.PathUtils.lineTo(t[0],t[1]),m+=e.PathUtils.closePath();var y=p/f,v=.5*Math.abs(t[1]-r[1])*(1+y),A=.5*Math.abs(a[0]-r[0])*(1+y)-x._SLICE_LABEL_HORIZONTAL_PADDING,b=r[1]-v,I=r[0]+(f-A)/2*(o?-1:1);return{slice:m,sliceBounds:new e.Rectangle(I,b,A,v),threeDPathTop:s,threeDPathSide:n}},x.prototype._getSliceLabel=function(t){var i=H.getDataLabel(this._chart,this._seriesIndex,0);if(i||(i=H.getSeriesLabel(this._chart,this._seriesIndex)),i&&"none"!=V.getDataLabelPosition(this._chart,this._seriesIndex,0)){var r=new e.MultilineText(this.getCtx(),i,0,0),a=null!=V.getPattern(this._chart,this._seriesIndex,0),s=[this._chart.getOptions().styleDefaults.dataLabelStyle,new e.CSSStyle(H.getDataItem(this._chart,this._seriesIndex,0).labelStyle)],n=e.CSSStyle.mergeStyles(s);if(r.setCSSStyle(n),e.TextUtils.fitText(r,t.w,t.h,this,x._MIN_CHARS_DATA_LABEL)){var o=r.getDimensions(),l=this._getLabelPosition(t);if(a){var h=.15*o.h,u=e.PathUtils.roundedRectangle(o.x-h,o.y,o.w+2*h,o.h,2,2,2,2),g=new e.Path(this.getCtx(),u);g.setSolidFill("#FFFFFF",.9),l.translate(-.5*o.w,-.5*o.h),g.setMatrix(l),this.addChild(g)}var d=a?"#000000":t.containsPoint(t.x+(t.w-o.w)/2,t.y)?e.ColorUtils.getContrastingTextColor(this._dataColor):e.ColorUtils.getContrastingTextColor(null);return n.getStyle("color")&&!e.Agent.isHighContrast()||r.setCSSStyle(n.setStyle("color",d)),r.setMatrix(this._getLabelPosition(t)),r.alignCenter(),r.alignMiddle(),r}}},x.prototype._getLabelPosition=function(t){var i=new e.Matrix;return e.Agent.isRightToLeft(this.getCtx())?i.translate(t.x-t.w/2,t.y+t.h/2):i.translate(t.x+t.w/2,t.y+t.h/2),i},x.prototype._setColorProperties=function(t){var i=Y.getFunnelPyramidSliceFill(this._chart,this._seriesIndex,this._dataColor,t),r=V.getBorderColor(this._chart,this._seriesIndex,0);null==r&&this._3dRatio>0&&(r=x._BORDER_COLOR);var a=V.getBorderWidth(this._chart,this._seriesIndex,0),s=e.SelectionEffectUtils.getHoverBorderColor(this._dataColor);if(this._3dRatio>0){var n=!i.getPattern&&!i.getAlphas;this._mainFace.setFill(i),this._mainFace.setStyle(V.getStyle(this._chart,this._seriesIndex,0)),this._mainFace.setClassName(V.getClassName(this._chart,this._seriesIndex,0)),this._threeDPathSide.setFill(n?new e.SolidFill(e.ColorUtils.getDarker(i.getColor(),.3)):i),this._threeDPathSide.setStyle(V.getStyle(this._chart,this._seriesIndex,0)),this._threeDPathSide.setClassName(V.getClassName(this._chart,this._seriesIndex,0)),this.setFill(n?new e.SolidFill(e.ColorUtils.getDarker(i.getColor(),.3)):i),this.setStyle(V.getStyle(this._chart,this._seriesIndex,0)),this.setClassName(V.getClassName(this._chart,this._seriesIndex,0))}else this.setFill(i),this.setStyle(V.getStyle(this._chart,this._seriesIndex,0)),this.setClassName(V.getClassName(this._chart,this._seriesIndex,0));if(r&&(this.setSolidStroke(r,null,a),this._3dRatio>0&&(this._threeDPathSide.setSolidStroke(r,null,a),this._mainFace.setSolidStroke(r,null,a))),this.OriginalStroke=this.getStroke(),this.setHoverStroke(new e.SolidStroke(s,1,2)),this._3dRatio>0&&(this._threeDPathSide.setHoverStroke(new e.SolidStroke(s,1,2)),this._mainFace.setHoverStroke(new e.SolidStroke(s,1,2))),this._chart.isSelectionSupported()){var o=V.getSelectedInnerColor(this._chart),l=V.getSelectedOuterColor(this._chart)?V.getSelectedOuterColor(this._chart):this._dataColor;this._3dRatio>0?(this._mainFace.setSelectedStroke(new e.SolidStroke(o,1,1.5),new e.SolidStroke(l,1,4.5)),this._mainFace.setSelectedHoverStroke(new e.SolidStroke(o,1,1.5),new e.SolidStroke(s,1,4.5)),this._mainFace.setCursor(e.SelectionEffectUtils.getSelectingCursor()),this._threeDPathSide.setCursor(e.SelectionEffectUtils.getSelectingCursor()),this.setCursor(e.SelectionEffectUtils.getSelectingCursor())):(this.setSelectedStroke(new e.SolidStroke(o,1,1.5),new e.SolidStroke(l,1,4.5)),this.setSelectedHoverStroke(new e.SolidStroke(o,1,1.5),new e.SolidStroke(s,1,4.5)),this.setCursor(e.SelectionEffectUtils.getSelectingCursor()))}},x.prototype.getAnimationParams=function(){return[this._startPercent,this._valuePercent,this.getAlpha(),this._3dRatio]},x.prototype.setAnimationParams=function(e){this._startPercent=e[0],this._valuePercent=e[1],this.setAlpha(e[2]),this._3dRatio=e[3];var t=this._getPath();this._threeDPathSide&&this._mainFace?(this.setCmds(t.threeDPathTop),this._threeDPathSide.setCmds(t.threeDPathSide),this._mainFace.setCmds(t.slice)):this.setCmds(t.slice),this._label&&this._label.setMatrix(this._getLabelPosition(t.sliceBounds))},x.prototype.setSelected=function(e){if(this._3dRatio>0)if(this._mainFace.setSelected(e),e){var t=this.getDimensions(),i=t.w,r=t.h,a=(i-3)/i,s=(r-5)/r;this._mainFace.setScaleX(a),this._mainFace.setScaleY(s),this._mainFace.setTranslateX(Math.ceil(1.5)+3/i*t.x),this._mainFace.setTranslateY(Math.ceil(2.5)+5/r*t.y)}else this._mainFace.setScaleX(1),this._mainFace.setScaleY(1),this._mainFace.setTranslateX(0),this._mainFace.setTranslateY(0);else x.superclass.setSelected.call(this,e)},x.prototype.showHoverEffect=function(){x.superclass.showHoverEffect.call(this),this._3dRatio>0&&(this._threeDPathSide.showHoverEffect(),this._mainFace.showHoverEffect())},x.prototype.hideHoverEffect=function(){x.superclass.hideHoverEffect.call(this),this._3dRatio>0&&(this._threeDPathSide.hideHoverEffect(),this._mainFace.hideHoverEffect())},x.prototype.copyShape=function(){return new x(this._chart,this._seriesIndex,this._numDrawnSeries,this._pyramidWidth,this._pyramidHeight,this._startPercent,this._valuePercent,this._gap)},x.prototype.getPrimaryFill=function(){return this._mainFace?this._mainFace.getFill():this.getFill()};var b=function(e,t,i,r){this.Init(e,t,i,r)};b._THREED_TILT=.59,b._THREED_DEPTH=.1,b._RADIUS=.45,b._RADIUS_LABELS=.38,b._MIN_ARC_LENGTH=1.5,e.Obj.createSubclass(b,e.Container),b.prototype.Init=function(t,i,r,a){b.superclass.Init.call(this,t.getCtx()),this.chart=t,this._options=t.getOptions(),this._frame=i.clone(),t.pieChart=this;for(var s=this.getLabelPosition(),n=H.getSeriesCount(t),o=0;o<n;o++){var l=H.getDataItem(t,o,0);!l||"center"!=s&&"none"!=s||"outsideSlice"!=l.labelPosition||(s="outsideSlice")}this._center=new e.Point(i.x+Math.floor(i.w/2),i.y+Math.floor(i.h/2));var h="center"==s||"none"==s?b._RADIUS:b._RADIUS_LABELS;this._radiusX=Math.floor(Math.min(i.w,i.h)*h),this._radiusY=this._radiusX,this._depth=0,this._anchorOffset=90,this.is3D()&&(this._depth=i.h*b._THREED_DEPTH,this._center.y-=Math.floor(this._depth/2),this._radiusY*=b._THREED_TILT),this._slices=this._createSlices(),this._centerLabel=null,this._shapesContainer=new e.Container(this.getCtx()),this._numFrontObjs=0,this._numSelectedObjsInFront=0},b.prototype.getOptions=function(){return this._options},b.prototype.highlight=function(t){e.CategoryRolloverHandler.highlight(t,this._slices,"any"==this.getOptions().highlightMatch)},b.prototype._createSlices=function(){for(var t,i,r=[],a=Z.getRenderedSeriesIndices(this.chart),s=Z.getOtherValue(this.chart),n=0;n<a.length;n++)if(i=a[n],V.isDataItemRendered(this.chart,i)){var o=(t=new I(this,i)).getValue();null==o||o<=0||r.push(t)}var l=V.getHiddenCategories(this.chart),h=e.ArrayUtils.getIndex(l,Z.OTHER_SLICE_SERIES_ID)>=0;if(s>0&&!h){var u=new I(this);"ascending"==this.chart.getOptions().sorting?r.unshift(u):r.push(u)}return e.Agent.isRightToLeft(this.getCtx())&&r.reverse(),r},b.prototype.setInitialSelection=function(){var e=this.chart.getSelectionHandler();if(e){for(var t=H.getInitialSelection(this.chart),i=[],r=0;r<t.length;r++)for(var a=0;a<this._slices.length;a++){var s=this._slices[a].getId();s&&(t[r].id&&s.getId()==t[r].id||s.getSeries()==t[r].series&&s.getGroup()==t[r].group)&&i.push(s)}if(Z.isOtherSliceSelected(this.chart,t)){var n=Z.getOtherSliceId(this.chart);i.push(n)}e.processInitialSelections(i,this._slices)}},b.prototype.render=function(){var t;if(G.addPlotAreaDnDBackground(this.chart,this,this._frame,!0),!this.contains(this._shapesContainer)&&(this._shapesContainer||(this._shapesContainer=new e.Container(this.getCtx())),this.addChild(this._shapesContainer),!this.is3D()&&this.getSkin()==e.CSSStyle.SKIN_SKYROS)){var i=e.ColorUtils.makeRGBA(78,87,101,.45);t=new e.Shadow(i,4,7,7,54,2,3,!1,!1,!1)}b._layoutSlices(this._slices,this._anchorOffset);for(var r=2*Math.PI*this.getRadiusX(),a=0,s={},n=this.chart.getOptionsCache().getFromCache("hasLargeSeriesCount"),o=0;o<this._slices.length;o++){if(n){var l=this._slices[o].getAngleExtent(),h=l/360*r,u=(this._slices[o].getAngleStart()+l)/360*r;if(h<b._MIN_ARC_LENGTH&&Math.abs(a-u)<b._MIN_ARC_LENGTH){s[this._slices[o].getSeriesIndex()]=!0;continue}a=u}this._slices[o].preRender()}var g=b._orderSlicesForRendering(this._slices);this._duringDisplayAnim||(Q.createPieCenter(this),Q.layoutLabelsAndFeelers(this));for(o=0;o<g.length;o++)s[g[o].getSeriesIndex()]||g[o].render(this._duringDisplayAnim);e.Agent.isPlatformWebkit()||t&&this._shapesContainer.addDrawEffect(t),this.setInitialSelection(),this.highlight(V.getHighlightedCategories(this.chart))},b.prototype.getTotalValue=function(){for(var e=0,t=0;t<this._slices.length;t++){var i=this._slices[t].getValue();i>=0&&(e+=i)}return e},b._layoutSlices=function(e,t){var i,r,a=0,s=e?e.length:0;t>360&&(t-=360),t<0&&(t+=360);var n=0;s>0&&(n=e[0].getPieChart().getTotalValue());for(var o=0;o<s;o++){var l=(i=e[o]).getValue();(r=t-(a=3.6*(l==n?100:0==n?0:Math.min(l/n*100,99.99))))<0&&(r+=360),i.setAngleStart(r),i.setAngleExtent(a),t=i.getAngleStart()}},b._orderSlicesForRendering=function(e){for(var t,i,r,a,s=[],n=e?e.length:0,o=-1,l=0;l<n;l++)if((r=(i=(t=e[l]).getAngleStart())+t.getAngleExtent())>360&&(r-=360),r<0&&(r+=360),90==r||i<90&&r>90){o=l,a=r-90;break}var h=[];for(l=o;l<n;l++)h.push(e[l]);for(l=0;l<o;l++)h.push(e[l]);var u=0,g=0,d=180+a;for(l=0;l<n;l++)if(t=h[l]){if(u+t.getAngleExtent()>d){g=l;break}s.push(t),u+=t.getAngleExtent()}for(l=n-1;l>=g;l--)(t=h[l])&&s.push(t);return s},b.prototype.is3D=function(){return"on"==this._options.styleDefaults.threeDEffect},b.prototype.__calcMaxExplodeDistance=function(){var e=.5/b._RADIUS-1;return this._radiusX*e},b.prototype.getAnimationDuration=function(){return V.getAnimationDuration(this.chart)},b.prototype.getDisplayAnimation=function(){this._duringDisplayAnim=!0;var t=new e.DataAnimationHandler(this.getCtx(),this),i=this.getAnimationDuration(),r=I.createFillerSlice(this,this.getTotalValue());this._slices.push(r);var a=new e.CustomAnimation(this.getCtx(),r,i);a.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.GetAnimationParams,r.SetAnimationParams,r.getDeletedAnimationParams()),a.setOnEnd(r._removeDeletedSlice,r),t.add(a,0);for(var s=0;s<this._slices.length-1;s++)this._slices[s].animateInsert(t);var n=new e.CustomAnimation(this.getCtx(),this,i);n.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,this._getAnimationParams()),t.add(n,0);var o=[];for(s=0;s<this._slices.length;s++)o=o.concat(this._slices[s].getLabelAndFeeler());var l=new e.AnimFadeIn(this._context,o,i);t.add(l,0),this._setAnimationParams();var h=t.getAnimation(!0);return h.setOnEnd(this._onEnd,this),h},b.prototype._onEnd=function(){this._duringDisplayAnim=!1,this._setAnimationParams()},b.prototype.getCenter=function(){return this._center},b.prototype.getId=function(){return"chart/pie"},b.prototype.getInnerRadius=function(){return this.is3D()?0:this._options.styleDefaults.pieInnerRadius*Math.min(this._radiusX,this._radiusY)*.95},b.prototype.__getFrame=function(){return this._frame},b.prototype.getRadiusX=function(){return this._radiusX},b.prototype.getRadiusY=function(){return this._radiusY},b.prototype.getDepth=function(){return this._depth},b.prototype.getSliceDisplayable=function(e){var t=Z.getSliceBySeriesIndex(this.chart,e);return t?t.getTopDisplayable():null},b.prototype.__getShapesContainer=function(){return this._shapesContainer},b.prototype.__getSlices=function(){return this._slices},b.prototype.animateUpdate=function(t,i){var r=new e.DataAnimationHandler(this.getCtx(),this);r.constructAnimation(i.__getSlices(),this.__getSlices());var a=r.getAnimation(!0),s=new e.CustomAnimation(this.getCtx(),this,this.getAnimationDuration());s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,this._getAnimationParams());var n=new e.ParallelPlayable(this.getCtx(),a,s);n.setOnEnd(this._setAnimationParams,this),t.add(n,0),this._setAnimationParams([i.getDepth(),i.getRadiusY(),i.getCenter().y])},b.prototype.animateInsert=function(e){},b.prototype.animateDelete=function(e,t){},b.prototype._getAnimationParams=function(){return[this._depth,this._radiusY,this._center.y]},b.prototype._setAnimationParams=function(e){this.removeChildren(),this._shapesContainer&&this._shapesContainer.destroy(),this._shapesContainer=null,e&&(this._depth=e[0],this._radiusY=e[1],this._center.y=e[2]),this.render()},b.prototype.bringToFrontOfSelection=function(e){var t=e.getPieChart()._shapesContainer;if(t){var i=t.getNumChildren();if(i-this._numFrontObjs>1){t.removeChild(e._topSurface[0]);var r=i-this._numFrontObjs-1;t.addChildAt(e._topSurface[0],r)}}},b.prototype.pushToBackOfSelection=function(e){for(var t=this._slices.length,i=0,r=0;r<t;r++)this._slices[r].isSelected()&&i++;this._numSelectedObjsInFront=i;var a=e.getPieChart()._shapesContainer;if(a){var s=a.getNumChildren()-this._numFrontObjs-1-this._numSelectedObjsInFront;s>=0&&(a.removeChild(e._topSurface[0]),a.addChildAt(e._topSurface[0],s))}},b.prototype.setNumFrontObjs=function(e){this._numFrontObjs=e},b.prototype.getShapesForViewSwitcher=function(e){var t={};if(this._slices)for(var i=0;i<this._slices.length;i++){var r=this._slices[i];if(r){var a=r.getId();if(a){var s=a.getId();if(s&&r._topSurface&&r._topSurface.length>0){var n=r._topSurface[0];t[s]=n}}}}return t},b.prototype.getLabelPosition=function(){return b.parseLabelPosition(this._options.styleDefaults.dataLabelPosition)},b.prototype.getSeriesLabelPosition=function(e){var t=this.getLabelPosition(),i=H.getDataItem(this.chart,e,0);return i&&i.labelPosition&&(t=i.labelPosition),b.parseLabelPosition(t)},b.parseLabelPosition=function(e){return"center"==e||"inside"==e?"center":"outsideSlice"==e||"outside"==e?"outsideSlice":"none"==e?"none":"auto"},b.prototype.getSkin=function(){return this._options.skin},b.prototype.setCenterLabel=function(e){this._centerLabel=e},b.prototype.getCenterLabel=function(){return this._centerLabel};var I=function(e,t){this.Init(e,t)};e.Obj.createSubclass(I,e.Obj),I.prototype.Init=function(t,i){this._pieChart=t,this._chart=t.chart,this._angleStart=0,this._angleExtent=0,this._topSurface=null,this._leftSurface=null,this._rightSurface=null,this._crustSurface=null,this._explodeOffsetX=0,this._explodeOffsetY=0,this._sliceLabel=null,this._sliceLabelString=null,this._hasFeeler=!1,this._feelerRad=null,this._feelerHoriz=null,this._outsideFeelerStart=null,this._outsideFeelerMid=null,this._outsideFeelerEnd=null,this._selected=!1,this._selecting=!1,this._centerX=this._pieChart.getCenter().x,this._centerY=this._pieChart.getCenter().y,this._radiusX=this._pieChart.getRadiusX(),this._radiusY=this._pieChart.getRadiusY(),this._depth=this._pieChart.getDepth();var r=this._chart.getOptions();if(null!=i){var a=H.getDataItem(this._chart,i,0);this._value=H.getValue(this._chart,i,0),this._explode=Z.getSliceExplode(this._chart,i),this._fillColor=V.getColor(this._chart,i,0),this._fillPattern=V.getPattern(this._chart,i,0),this._strokeColor=V.getBorderColor(this._chart,i),this._borderWidth=V.getBorderWidth(this._chart,i),this._customLabel=a?a.label:null,this._seriesLabel=H.getSeries(this._chart,i),this._action=a?a.action:null,this._drillable=G.isDataItemDrillable(this._chart,i,0),this._showPopupBehaviors=a?this._chart.getShowPopupBehaviors(a._id):null,this._id=Z.getSliceId(this._chart,i),this._seriesIndex=i,this._categories=H.getCategories(this._chart,i,0)}else this._value=Z.getOtherValue(this._chart),this._explode=0,this._fillColor=r.styleDefaults.otherColor,this._fillPattern=null,this._strokeColor=r.styleDefaults.borderColor,this._borderWidth=r.styleDefaults.borderWidth,this._customLabel=null,this._seriesLabel=e.Bundle.getTranslatedString(e.Bundle.CHART_PREFIX,"LABEL_OTHER",null),this._action=null,this._drillable=!1,this._showPopupBehaviors=Z.getOtherSliceShowPopupBehaviors(this._chart),this._id=Z.getOtherSliceId(this._chart)},I.prototype.getPieChart=function(){return this._pieChart},I.prototype.render=function(t){for(var i=I._sortPieSurfaces(this._topSurface,this._leftSurface,this._rightSurface,this._crustSurface,this._angleStart,this._angleExtent),r=i.length,a=0;a<r;a++)for(var s=i[a],n=s.length,o=0;o<n;o++){this._pieChart.__getShapesContainer().addChild(s[o]),s[o].render&&s[o].render()}if(this._sliceLabel&&(this._pieChart.addChild(this._sliceLabel),K.associate(this,[this._sliceLabel]),t?(this._pieChart.addChild(this._feelerRad),this._pieChart.addChild(this._feelerHoriz)):this._renderOutsideFeeler()),this._explodeSlice(),this._action||this._drillable||this._pieChart.chart.isSelectionSupported()){var l=this.getDisplayables();for(a=0;a<l.length;a++)l[a].setCursor(e.SelectionEffectUtils.getSelectingCursor())}var h=this.getTopDisplayable();h&&(h.setAriaRole("img"),this._updateAriaLabel())},I.prototype._feelerFromPts=function(t,i){var r=new e.Line(this._pieChart.getCtx(),t.x,t.y,i.x,i.y),a=this._pieChart.getOptions().styleDefaults.pieFeelerColor,s=new e.SolidStroke(a);return r.setStroke(s),this._pieChart.addChild(r),r},I.prototype._renderOutsideFeeler=function(){if(this._hasFeeler){var e=this._feelerFromPts(this._outsideFeelerStart,this._outsideFeelerMid),t=this._feelerFromPts(this._outsideFeelerMid,this._outsideFeelerEnd);this._feelerRad=e,this._feelerHoriz=t}},I.prototype.preRender=function(){var t,i=this._bFillerSlice?"color":V.getSeriesEffect(this._chart),r=this.getFillColor(),a=this.getFillPattern();if("pattern"==i||null!=a)t=new e.PatternFill(a,r),i="pattern";else if("gradient"==i){var s=this._pieChart.getSkin(),n=s==e.CSSStyle.SKIN_SKYROS?297:270,o=this._pieChart.is3D()?"3D":"2D",l=K.getGradientColors(e.ColorUtils.getRGB(r),o,s),h=K.getGradientAlphas(e.ColorUtils.getAlpha(r),o),u=K.getGradientRatios(o,s),g=[Math.floor(this._centerX-this._radiusX),Math.floor(this._centerY-this._radiusY),Math.ceil(2*this._radiusX),Math.ceil(2*this._radiusY)];t=new e.LinearGradientFill(n,l,h,u,g)}else t=new e.SolidFill(r);if(this._topSurface=K.createTopSurface(this,t),this._depth>0||this._radiusX!=this._radiusY){var d="gradient"==i,c=new e.SolidFill(e.ColorUtils.getDarker(r,.4)),p=d?K.generateLateralGradientFill(this,K.SIDE):c,_=d?K.generateLateralGradientFill(this,K.CRUST):c;this._leftSurface=K.createLateralSurface(this,K.SURFACE_LEFT,p),this._rightSurface=K.createLateralSurface(this,K.SURFACE_RIGHT,p),this._crustSurface=K.createLateralSurface(this,K.SURFACE_CRUST,_)}this.setSliceLabel(null),this.setNoOutsideFeeler()},I._sortPieSurfaces=function(e,t,i,r,a,s){var n=[];return t&&i&&r&&(a<=270&&a+s>270?(n.push(t),n.push(i),n.push(r)):a>270||a+s<=90?(n.push(t),n.push(r),n.push(i)):(n.push(i),n.push(r),n.push(t))),n.push(e),n},I.oppositeDirection=function(e,t,i){return e-t>0!=e-i>0},I.prototype._explodeSlice=function(){if(0!=this._explode){var t=this._angleExtent,i=(360-(this._angleStart+t/2))*e.Math.RADS_PER_DEGREE,r=this._pieChart.is3D()?b._THREED_TILT:1,a=this._explode*this._pieChart.__calcMaxExplodeDistance();this._explodeOffsetX=Math.cos(i)*a,this._explodeOffsetY=Math.sin(i)*r*a,e.Agent.isPlatformWebkit()&&(this._explodeOffsetX=Math.round(this._explodeOffsetX),this._explodeOffsetY=Math.round(this._explodeOffsetY))}else this._explodeOffsetX=0,this._explodeOffsetY=0;if(this._topSurface){var s=this._pieChart.is3D()&&this._topSurface[0].getSelectionOffset?this._topSurface[0].getSelectionOffset():[];I._translateShapes(this._topSurface,s[0]?s[0]+this._explodeOffsetX:this._explodeOffsetX,s[1]?s[1]+this._explodeOffsetY:this._explodeOffsetY)}if(this._rightSurface&&I._translateShapes(this._rightSurface,this._explodeOffsetX,this._explodeOffsetY),this._leftSurface&&I._translateShapes(this._leftSurface,this._explodeOffsetX,this._explodeOffsetY),this._crustSurface&&I._translateShapes(this._crustSurface,this._explodeOffsetX,this._explodeOffsetY),this._hasFeeler){var n=this._outsideFeelerStart.x,o=this._outsideFeelerStart.y,l=n+this._explodeOffsetX,h=o+this._explodeOffsetY;this._feelerRad.setX1(l),this._feelerRad.setY1(h);var u=this._outsideFeelerMid.x,g=this._outsideFeelerMid.y;I.oppositeDirection(u,n,l)?(this._feelerRad.setX2(l),this._feelerHoriz.setX1(l)):(this._feelerRad.setX2(u),this._feelerHoriz.setX1(u)),I.oppositeDirection(g,o,h)?(this._feelerRad.setY2(h),this._feelerHoriz.setY1(h)):(this._feelerRad.setY2(g),this._feelerHoriz.setY1(g))}this._sliceLabel&&!this._hasFeeler&&this._sliceLabel.setTranslate(this._explodeOffsetX,this._explodeOffsetY)},I._translateShapes=function(e,t,i){if(e)for(var r=e.length,a=0;a<r;a++){e[a].setTranslate(t,i)}},I.prototype.getRadiusX=function(){return this._radiusX},I.prototype.getRadiusY=function(){return this._radiusY},I.prototype.getCenter=function(){return new e.Point(this._centerX,this._centerY)},I.prototype.getDepth=function(){return this._depth},I.prototype.getAngleExtent=function(){return this._angleExtent},I.prototype.setAngleExtent=function(e){this._angleExtent=e},I.prototype.getAngleStart=function(){return this._angleStart},I.prototype.setAngleStart=function(e){this._angleStart=e},I.prototype.__getExplodeOffsetX=function(){return this._explodeOffsetX},I.prototype.__getExplodeOffsetY=function(){return this._explodeOffsetY},I.prototype.setOutsideFeelerPoints=function(e,t,i){this._outsideFeelerStart=e,this._outsideFeelerMid=t,this._outsideFeelerEnd=i,this._hasFeeler=!0},I.prototype.setNoOutsideFeeler=function(){this._outsideFeelerStart=null,this._outsideFeelerMid=null,this._outsideFeelerEnd=null,this._hasFeeler=!1},I.prototype.getLabelAndFeeler=function(){var e=[];return this._sliceLabel&&e.push(this._sliceLabel),this._feelerRad&&e.push(this._feelerRad),this._feelerHoriz&&e.push(this._feelerHoriz),e},I.prototype.getSliceLabel=function(){return this._sliceLabel},I.prototype.setSliceLabel=function(e){this._sliceLabel=e},I.prototype.getSliceLabelString=function(){return this._sliceLabelString},I.prototype.setSliceLabelString=function(e){this._sliceLabelString=e},I.prototype.getTopSurface=function(){return this._topSurface},I.prototype.getValue=function(){return this._value},I.prototype.getId=function(){return this._id},I.prototype.getSeriesIndex=function(){return this._seriesIndex},I.containsRect=function(e,t){return t.contains(e.x,e.y)&&t.contains(e.x+e.w,e.y)&&t.contains(e.x+e.w,e.y+e.h)&&t.contains(e.x,e.y+e.h)},I._shapeIsSelectable=function(e){return e instanceof h},I.prototype.contains=function(e,t){for(var i=this._pieChart.getInnerRadius(),r=this._pieChart.getCenter(),a=(e-r.x)/this._radiusX,s=(t-r.y)/this._radiusY,n=-Math.atan2(s,a)*(180/Math.PI);n<this._angleStart;)n+=360;for(;n-this._angleStart>=360;)n-=360;var o=Math.pow(a,2)+Math.pow(s,2),l=Math.sqrt(o)>i/this._radiusX&&o<=1,h=n<=this._angleStart+this._angleExtent;return l&&h},I.prototype.GetAnimationParams=function(){var t=e.ColorUtils.getRed(this._fillColor),i=e.ColorUtils.getGreen(this._fillColor),r=e.ColorUtils.getBlue(this._fillColor),a=e.ColorUtils.getAlpha(this._fillColor);return[this._value,this._radiusX,this._radiusY,this._explode,this._centerX,this._centerY,this._depth,t,i,r,a]},I.prototype.SetAnimationParams=function(t){this._value=t[0],this._radiusX=t[1],this._radiusY=t[2],this._explode=t[3],this._centerX=t[4],this._centerY=t[5],this._depth=t[6];var i=Math.round(t[7]),r=Math.round(t[8]),a=Math.round(t[9]),s=Math.round(t[10]);this._fillColor=e.ColorUtils.makeRGBA(i,r,a,s)},I.prototype.getDeletedAnimationParams=function(){var e=this.GetAnimationParams();return e[0]=0,e[1]=this.getInnerRadius(),e[2]=this.getInnerRadius(),e[3]=0,e},I.prototype.animateUpdate=function(t,i){var r=i.GetAnimationParams(),a=this.GetAnimationParams();if(!e.ArrayUtils.equals(r,a)){var s=new e.CustomAnimation(this._pieChart.getCtx(),this,this.getPieChart().getAnimationDuration());s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.GetAnimationParams,this.SetAnimationParams,a),t.add(s,0),this.SetAnimationParams(r)}},I.prototype.animateInsert=function(t){var i=new e.CustomAnimation(this._pieChart.getCtx(),this,this.getPieChart().getAnimationDuration());i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.GetAnimationParams,this.SetAnimationParams,this.GetAnimationParams()),t.add(i,0),this.SetAnimationParams(this.getDeletedAnimationParams())},I.prototype.animateDelete=function(t,i){var r=i.__getSlices(),a=this.getPieChart().__getSlices(),s=e.ArrayUtils.getIndex(a,this)-1;if(s>=0){for(var n=a[s].getId(),o=0;o<r.length;o++)if(r[o].getId().equals(n)){r.splice(o+1,0,this);break}}else r.splice(0,0,this);this._pieChart=i;var l=new e.CustomAnimation(i.getCtx(),this,this.getPieChart().getAnimationDuration());l.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.GetAnimationParams,this.SetAnimationParams,this.getDeletedAnimationParams()),l.setOnEnd(this._removeDeletedSlice,this),t.add(l,0)},I.prototype._removeDeletedSlice=function(){var t=this.getPieChart().__getSlices(),i=e.ArrayUtils.getIndex(t,this);i>=0&&t.splice(i,1)},I.prototype.getDisplayables=function(){var e=new Array;return this._topSurface&&(e=e.concat(this._topSurface)),this._leftSurface&&(e=e.concat(this._leftSurface)),this._rightSurface&&(e=e.concat(this._rightSurface)),this._crustSurface&&(e=e.concat(this._crustSurface)),this._sliceLabel&&e.push(this._sliceLabel),this._feelerRad&&e.push(this._feelerRad),this._feelerHoriz&&e.push(this._feelerHoriz),e},I.prototype.getAriaLabel=function(){var t;t=null==this._seriesIndex?W.getOtherSliceDatatip(this._chart,this._value,!1):W.getDatatip(this._chart,this._seriesIndex,0,null,!1);var i=e.Bundle.getTranslatedString(e.Bundle.CHART_PREFIX,"LABEL_PERCENTAGE",null),r=Q.generateSlicePercentageString(this);t+="; "+e.Bundle.getTranslatedString(e.Bundle.UTIL_PREFIX,"COLON_SEP_LIST",[i,r]);var a=[];return this.isSelectable()&&a.push(e.Bundle.getTranslatedString(e.Bundle.UTIL_PREFIX,this.isSelected()?"STATE_SELECTED":"STATE_UNSELECTED")),G.isDataItemDrillable(this._chart,this._seriesIndex,this._groupIndex)&&a.push(e.Bundle.getTranslation(this._pieChart.getOptions(),"stateDrillable",e.Bundle.UTIL_PREFIX,"STATE_DRILLABLE")),e.Displayable.generateAriaLabel(t,a)},I.prototype._updateAriaLabel=function(){var t=this.getTopDisplayable();t&&!e.Agent.deferAriaCreation()&&t.setAriaProperty("label",this.getAriaLabel())},I.prototype.getTopDisplayable=function(){return this._topSurface&&this._topSurface.length>0?this._topSurface[0]:null},I.prototype.isSelectable=function(){return this._chart.isSelectionSupported()},I.prototype.isSelected=function(){return this._selected},I.prototype.setSelected=function(t,i){if(this._selected=t,this.getTopSurface()){if(this._selected?this._pieChart.bringToFrontOfSelection(this):this._selecting||this._pieChart.pushToBackOfSelection(this),V.isSelectionHighlighted(this._chart))for(var r=this.getDisplayables(),a=0;a<r.length;a++)I._shapeIsSelectable(r[a])&&r[a].setSelected(t);if(V.isSelectionExploded(this._chart)){var s=t?1:0;if(i||"none"==V.getAnimationOnDataChange(this._chart))this.setExplode(s);else{var n=new e.CustomAnimation(this._pieChart.getCtx(),this,this._pieChart.getAnimationDuration()/2);n.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getExplode,this.setExplode,s),n.play()}}this._updateAriaLabel()}},I.prototype.showHoverEffect=function(){this._selecting=!0,this._pieChart.bringToFrontOfSelection(this);for(var e=this.getDisplayables(),t=0;t<e.length;t++)I._shapeIsSelectable(e[t])&&e[t].showHoverEffect()},I.prototype.hideHoverEffect=function(){this._selecting=!1,this._selected||this._pieChart.pushToBackOfSelection(this);for(var e=this.getDisplayables(),t=0;t<e.length;t++)I._shapeIsSelectable(e[t])&&e[t].hideHoverEffect()},I.prototype.getDatatip=function(e,t,i){return e==this._sliceLabel&&this._sliceLabel&&this._sliceLabel.isTruncated()?this.getSliceLabelString():this.getTooltip()},I.prototype.getDatatipColor=function(){return this.getFillColor()},I.prototype.getCategories=function(){return this._categories&&this._categories.length>0?this._categories:[this.getId().getSeries()]},I.prototype.getNextNavigable=function(t){var i=t.keyCode;if(t.type==e.MouseEvent.CLICK)return this;if(i==e.KeyboardEvent.SPACE&&t.ctrlKey)return this;var r=e.Agent.isRightToLeft(this._chart.getCtx()),a=this._pieChart.__getSlices(),s=e.ArrayUtils.getIndex(a,this),n=null;return i==e.KeyboardEvent.RIGHT_ARROW||i==e.KeyboardEvent.DOWN_ARROW&&!r||i==e.KeyboardEvent.UP_ARROW&&r?n=s<a.length-1?a[s+1]:a[0]:(i==e.KeyboardEvent.LEFT_ARROW||i==e.KeyboardEvent.DOWN_ARROW&&r||i==e.KeyboardEvent.UP_ARROW&&!r)&&(n=0==s?a[a.length-1]:a[s-1]),n},I.prototype.getKeyboardBoundingBox=function(t){var i=this.getDisplayables();return i[0]?i[0].getDimensions(t):new e.Rectangle(0,0,0,0)},I.prototype.getTargetElem=function(){var e=this.getDisplayables();return e[0]?e[0].getElem():null},I.prototype.showKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!0,this.showHoverEffect()},I.prototype.hideKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect()},I.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},I.prototype.isDragAvailable=function(e){return!0},I.prototype.getDragTransferable=function(e,t){return[this.getId()]},I.prototype.getDragFeedback=function(e,t){if(this._chart.isSelectionSupported()&&this._chart.getSelectionHandler().getSelectedCount()>1){for(var i=this._chart.getSelectionHandler().getSelection(),r=[],a=0;a<i.length;a++)r=r.concat(i[a].getDisplayables());return r}return this.getDisplayables()},I.prototype.getExplode=function(){return this._explode},I.prototype.setExplode=function(e){this._explode=e,this._explodeSlice()},I.prototype.getCustomLabel=function(){return this._customLabel},I.prototype.getSeriesLabel=function(){return this._seriesLabel},I.prototype.getFillColor=function(){return this._fillColor},I.prototype.getFillPattern=function(){return this._fillPattern},I.prototype.getStrokeColor=function(){return this._strokeColor},I.prototype.getBorderWidth=function(){return this._borderWidth},I.prototype.getSliceGaps=function(){return 0==this._depth?3*V.getDataItemGaps(this._chart):0},I.prototype.getInnerRadius=function(){return this._pieChart.getInnerRadius()},I.prototype.getTooltip=function(){return null==this._seriesIndex?W.getOtherSliceDatatip(this._chart,this._value,!0):W.getDatatip(this._chart,this._seriesIndex,0,null,!0)},I.prototype.getAction=function(){return this._action},I.prototype.isDrillable=function(){return this._drillable},I.prototype.getShowPopupBehaviors=function(){return this._showPopupBehaviors},I.createFillerSlice=function(e,t){var i=new I(e);return i._value=t,i._bFillerSlice=!0,i._centerX=e.getCenter().x,i._centerY=e.getCenter().y,i._fillColor="rgba(255,255,255,0)",i._strokeColor="rgba(255,255,255,0)",i._id=new n(null,null,null,null),i},I.prototype.getSeriesIndex=function(){return this._seriesIndex};var T=function(){};e.Obj.createSubclass(T,e.Obj),T.createAnimation=function(t,i,r){var a=[];if(z.isBLAC(t))T._animBarLineArea(t,r,a);else if(z.isScatterBubble(t)||z.isFunnel(t)||z.isPyramid(t))T._animBubbleScatterFunnelPyramid(t,r,a);else if(z.isPie(t)&&t.pieChart)return t.pieChart.getDisplayAnimation();return a.length>0?new e.ParallelPlayable(t.getCtx(),a):null},T._animBarLineArea=function(t,i,r){var a=t.getChartObjPeers(),s=a?a.length:0;if(s)for(var n,o,l,h=0;h<s;h++){n=(o=a[h]).getDisplayables()[0];var u=o.getSeriesType();if(l=null,n instanceof d||n instanceof m||n instanceof p||n instanceof c)l=n.getDisplayAnimation(i);else if(n instanceof f)l="line"==u?T._getLinePlayable(t,n,i):T._getAreaPlayable(t,n,i);else if(n instanceof e.SimpleMarker||n instanceof y){if(n instanceof S&&!n.isSelected())continue;l=new e.AnimFadeIn(t.getCtx(),n,i-.8,.8)}l&&r.push(l)}},T._animBubbleScatterFunnelPyramid=function(t,i,r){var a=t.getObjects(),s=a?a.length:0;if(s)for(var n,o,l=0;l<s;l++)(n=a[l].getDisplayables()[0])instanceof e.SimpleMarker?o=new e.AnimPopIn(t.getCtx(),n,!0,i):(n instanceof A||n instanceof x)&&(o=T._getFunnelPyramidPlayable(t,n,i)),o&&r.push(o)},T._getAreaPlayable=function(t,i,r){var a,s=t.getCtx(),n=i.getBaseline();if(i.isArea()){for(var o=i.getBaseCoords(),l=i.getBaseAnimationParams(),h=l.slice(0),u=0;u<l.length;u++)u%4!=1&&u%4!=2||(l[u]=n);i.setBaseAnimationParams(l),(a=new e.CustomAnimation(s,i,r)).getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getBaseAnimationParams,i.setBaseAnimationParams,h)}var g=i.getCoords(),d=i.getAnimationParams(),c=d.slice(0);for(u=0;u<d.length;u++)u%4!=1&&u%4!=2||(d[u]=n);i.setAnimationParams(d);var p=new e.CustomAnimation(s,i,r);p.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,c);var _=new e.ParallelPlayable(t.getCtx(),a,p);return _.setOnEnd(function(){i.setCoords(g,o)}),_},T._getFunnelPyramidPlayable=function(t,i,r){var a=t.getCtx(),s=i.getAnimationParams(),n=s.slice(0),o=s.slice(0);s[0]=0,z.isFunnel(t)&&(s[2]=0,n[2]=0),i.setAnimationParams(s);var l=new e.CustomAnimation(a,i,r/2);l.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,n);var h=new e.CustomAnimation(a,i,r/2);return h.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,o),new e.SequentialPlayable(a,[l,h])},T._getLinePlayable=function(t,i,r){var a=i.getCoords(),s=i.getAnimationParams(),n=s.slice(0);T._getMeanPoints(s),i.setAnimationParams(s);var o=new e.CustomAnimation(t.getCtx(),i,r);return o.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,n),o.setOnEnd(function(){i.setCoords(a)}),o},T._getMeanPoints=function(e){var t,i=0,r=Number.MAX_VALUE,a=Number.MIN_VALUE,s=e.length;for(t=0;t<s;t++){var n=e[t];t%4!=0&&t%4!=3&&n!=1/0&&(n<r&&(r=n),n>a&&(a=n),i+=n)}for(s>8?(i-=2*r,i-=2*a,i/=s/2-4):i/=s/2,t=0;t<s;t++)t%4!=1&&t%4!=2||(e[t]=i)};var E=function(){};e.Obj.createSubclass(E,e.Obj),E.createAnimation=function(t,i,r,a,s){if(!E._canAnimate(t,i))return null;var n,o=i.getCtx(),l=[],h=[];z.isPie(i)?(l.push(t.pieChart),h.push(i.pieChart)):E._buildAnimLists(o,l,t,h,i,a);var u=new e.DataAnimationHandler(o,s);u.constructAnimation(l,h),u.getNumPlayables()>0&&(n=u.getAnimation(!0));var g=i.getDataLabels();if(n&&g.length>0){for(var d=0;d<g.length;d++)g[d].setAlpha(0);n=new e.SequentialPlayable(o,n,new e.AnimFadeIn(o,g,a/4))}return n},E._buildAnimLists=function(t,i,r,a,s,n){var o,l,h,u,g,_=r.getChartObjPeers(),C=i,v=s.getCache().getFromCache("dataFiltered");for(o=0;o<2;o++){var b={},I={};for(l=0;l<_.length;l++){if(g=null,(u=(h=_[l]).getDisplayables()[0])instanceof A)g=new F(h,n);else if(u instanceof x)g=new k(h,n);else if(u instanceof d||u instanceof m){if(g=new P(h,n),v){var T=h.getSeries();b[T]=b[T]?b[T]+1:1,g.setId(T+"/"+b[T]+"/bar")}}else if(u instanceof f){var E=(g=new R(h,n)).getId();I[E]=I[E]?I[E]+1:1,g.setId(E+"/"+I[E])}else if(u instanceof e.SimpleMarker){if(u instanceof S&&!u.isSelected())continue;g=new w(h,n)}else if(u instanceof y){if(u.isInvisible()&&!u.isSelected())continue;g=new L(h,n)}else u instanceof p?g=new O(h,n):u instanceof c&&(g=new M(h,n));g&&(C.push(g),g.setOldChart(r))}C=a,_=s.getChartObjPeers()}},E._canAnimate=function(e,t){return z.isPie(e)&&z.isPie(t)?e&&t:z.isPolar(e)==z.isPolar(t)&&(!(!z.isBLAC(e)||!z.isBLAC(t))||(!(!z.isScatterBubble(e)||!z.isScatterBubble(t))||e.getType()==t.getType()))};var D=function(t){this.Options=t.Options,this.Peers=t.Peers,this.SeriesStyleArray=t.SeriesStyleArray,this.Cache=t.Cache,this.pieChart=t.pieChart,this._optionsCache=new e.BaseComponentCache,this._cache=new e.BaseComponentCache};e.Obj.createSubclass(D,e.Chart),D.prototype.getCache=function(){return this._cache},D.prototype.getOptionsCache=function(){return this._optionsCache};var O=function(e,t){this.Init(e,t)};e.Obj.createSubclass(O,e.Obj),O.prototype.animateUpdate=function(e,t){var i=t._shape;this._shape&&this._shape.getUpdateAnimation&&e.add(this._shape.getUpdateAnimation(this._updateDuration,i),1)},O.prototype.animateInsert=function(t){if(this._shape&&this._shape.getInsertAnimation)t.add(this._shape.getInsertAnimation(this._insertDuration),2);else{var i=new e.AnimFadeIn(this._shape.getCtx(),this._shape,this._insertDuration);t.add(i,0)}},O.prototype.animateDelete=function(t,i){if(i.addChild(this._shape),this._shape&&this._shape.getDeleteAnimation)t.add(this._shape.getDeleteAnimation(this._deleteDuration),0);else{var r=new e.AnimFadeOut(this._shape.getCtx(),this._shape,this._deleteDuration);t.add(r,0)}},O.prototype.getId=function(){return this._animId},O.prototype.setId=function(e){this._animId=e},O.prototype.Init=function(e,t){this._peer=e,this._updateDuration=.75*t,this._insertDuration=.5*t,this._deleteDuration=.5*t,this._shape=e.getDisplayables()[0],this._animId=e.getDataItemId()||e.getSeries()+"/"+e.getGroup()},O.prototype.setOldChart=function(e){this._oldChart=e};var P=function(e,t){this.Init(e,t)};e.Obj.createSubclass(P,O),P.prototype.Init=function(e,t){P.superclass.Init.call(this,e,t),this._indicator=null,this._animId+="/bar"},P.prototype.animateInsert=function(e){var t=this._shape.getInsertAnimation(this._insertDuration);e.add(t,2)},P.prototype.animateDelete=function(e,t){t.addChild(this._shape);var i=this._shape.getDeleteAnimation(this._deleteDuration);e.add(i,0)},P.prototype.animateUpdate=function(t,i){var r=this._oldChart,a=this._peer.getChart(),s=z.isHorizontal(r)!=z.isHorizontal(a),n=i._getAnimationParams(s),o=this._getAnimationParams(),l=i._shape.getPrimaryFill().clone(),h=this._shape.getPrimaryFill(),u=i._shape.isSelected()||this._shape.isSelected()||l.equals(h);if(!e.ArrayUtils.equals(n,o)||!l.equals(h)){var g=this._peer.getSeriesIndex(),d=i._peer.getSeriesIndex(),c=this._peer.getGroupIndex(),p=i._peer.getGroupIndex();"none"!==V.getAnimationIndicators(a)&&(this._indicator=B.makeIndicator(r,d,p,a,g,c)),this._setAnimationParams(n),u||this._shape.setFill(l);var _=new e.CustomAnimation(this._shape.getCtx(),this,this._updateDuration);_.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,o),u||_.getAnimator().addProp(e.Animator.TYPE_FILL,this._shape,this._shape.getFill,this._shape.setFill,h),this._indicator&&(_.setOnEnd(this._onEndAnimation,this),this._indicator.setAlpha(0)),t.add(_,1)}},P.prototype._getAnimationParams=function(e){return this._shape.getAnimationParams(e)},P.prototype._setAnimationParams=function(e){this._shape.setAnimationParams(e,this._indicator)},P.prototype._onEndAnimation=function(){this._indicator&&(this._indicator.getParent().removeChild(this._indicator),this._indicator=null)};var M=function(e,t){this.Init(e,t)};e.Obj.createSubclass(M,O),M.prototype.Init=function(e,t){M.superclass.Init.call(this,e,t),this._animId+="/boxAndWhisker"};var R=function(e,t){this.Init(e,t)};e.Obj.createSubclass(R,O),R.prototype.animateUpdate=function(t,i){this._baseCoords=this._shape.getBaseCoords(),this._coords=this._shape.getCoords();var r,a,s=this._shape.isArea(),n=this._oldChart,o=this._chart,l=this._peer.getSeriesIndex(),h=i._peer.getSeriesIndex(),u=this._shape.getCommonGroupIndices(i._shape),g=i._shape.getCommonGroupIndices(this._shape);if(s){var d=i._getBaseAnimationParams(this._shape),c=this._getBaseAnimationParams(i._shape);R._matchGroupIndices(d,c),e.ArrayUtils.equals(d,c)||(this._setBaseAnimationParams(d),(r=new e.CustomAnimation(this._context,this,this._updateDuration)).getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getBaseAnimationParams,this._setBaseAnimationParams,c))}var p=i._getAnimationParams(this._shape),_=this._getAnimationParams(i._shape);if(R._matchGroupIndices(p,_),e.ArrayUtils.equals(p,_)||(this._setAnimationParams(p),(a=new e.CustomAnimation(this._context,this,this._updateDuration)).getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,_)),"none"!==V.getAnimationIndicators(o)&&(!s||"lineWithArea"!=this._peer.getSeriesType()))for(var f,S,C=0;C<u.length;C++)f=B.getDirection(n,h,g[C],o,l,u[C]),(S=B.makeIndicator(n,h,g[C],o,l,u[C]))&&this._shape.addIndicator(u[C],f,S);if(r||a){var m=new e.ParallelPlayable(this._context,r,a);m.setOnEnd(this._onAnimationEnd,this),t.add(m,1)}},R.prototype.animateInsert=function(t){this._shape.setAlpha(0);var i=new e.AnimFadeIn(this._context,this._shape,this._insertDuration);t.add(i,2)},R.prototype.animateDelete=function(t,i){var r;if("area"==V.getSeriesType(this._oldChart,this._peer.getSeriesIndex())){var a=this._chart.__getAreaContainer();if(this._deletedAreas=this._shape.getParent().getParent(),!a)return;a.addChild(this._deletedAreas),(r=new e.AnimFadeOut(this._context,this._deletedAreas,this._deleteDuration)).setOnEnd(this._removeDeletedAreas,this),t.add(r,0)}else i.addChild(this._shape),r=new e.AnimFadeOut(this._context,this._shape,this._deleteDuration),t.add(r,0)},R.prototype._removeDeletedAreas=function(){var e=this._chart.__getAreaContainer();e&&e.removeChild(this._deletedAreas)},R.prototype._getAnimationParams=function(e){return this._shape.getAnimationParams(e)},R.prototype._setAnimationParams=function(e){this._shape.setAnimationParams(e)},R.prototype._getBaseAnimationParams=function(e){return this._shape.getBaseAnimationParams(e)},R.prototype._setBaseAnimationParams=function(e){this._shape.setBaseAnimationParams(e)},R.prototype._onAnimationEnd=function(){this._shape.removeIndicators(),this._shape.setCoords(this._coords,this._baseCoords)},R._matchGroupIndices=function(e,t){for(var i=3;i<e.length;i+=4)e[i]=t[i]},R.prototype.Init=function(e,t){R.superclass.Init.call(this,e,t),this._context=this._shape.getCtx(),this._chart=this._peer.getChart(),this._animId+="/"+(this._shape.isArea()?"area":"line")};var w=function(e,t){this.Init(e,t)};e.Obj.createSubclass(w,O),w.prototype.animateUpdate=function(t,i){var r=i._shape.getCenterDimensions(),a=this._shape.getCenterDimensions();if(!a.equals(r)){this._shape.setCenterDimensions(r);var s=new e.CustomAnimation(this._shape.getCtx(),this,this._updateDuration);s.getAnimator().addProp(e.Animator.TYPE_RECTANGLE,this._shape,this._shape.getCenterDimensions,this._shape.setCenterDimensions,a);var n=this._peer.getChart();if(this.isValueChange(i)&&"none"!=V.getAnimationIndicators(n)&&z.isScatterBubble(n)){var o=i._shape;o.setSolidFill("#FFFF2B",.9),o.setCenterDimensions(r),this._peer.getChart().getPlotArea().addChild(o),s.getAnimator().addProp(e.Animator.TYPE_RECTANGLE,o,o.getCenterDimensions,o.setCenterDimensions,a),s.getAnimator().addProp(e.Animator.TYPE_NUMBER,o,o.getAlpha,o.setAlpha,0),this._overlay=o,s.setOnEnd(this._onEndAnimation,this)}t.add(s,1)}},w.prototype.animateInsert=function(t){this._shape.setAlpha(0);var i=new e.AnimFadeIn(this._shape.getCtx(),this._shape,this._insertDuration);t.add(i,2)},w.prototype.animateDelete=function(t,i){i.addChild(this._shape);var r=new e.AnimFadeOut(this._shape.getCtx(),this._shape,this._deleteDuration);t.add(r,0)},w.prototype.isValueChange=function(e){var t=!1;if(e){var i=e._peer.getSeriesIndex(),r=e._peer.getGroupIndex(),a=this._peer.getSeriesIndex(),s=this._peer.getGroupIndex(),n=e._oldChart.getOptions(),o=this._peer.getChart().getOptions(),l=n.series[i].items[r].x,h=n.series[i].items[r].y,u=n.series[i].items[r].z,g=o.series[a].items[s].x,d=o.series[a].items[s].y,c=o.series[a].items[s].z;t=g!==l||d!==h||c!==u}return t},w.prototype._onEndAnimation=function(){this._overlay&&(this._peer.getChart().getPlotArea().removeChild(this._overlay),this._overlay=null)},w.prototype.Init=function(e,t){w.superclass.Init.call(this,e,t),this._animId+="/marker"};var L=function(e,t){this.Init(e,t)};e.Obj.createSubclass(L,O),L.prototype.Init=function(e,t){L.superclass.Init.call(this,e,t),this._animId+="/rangeMarker"},L.prototype.animateInsert=function(t){this._shape.setAlpha(0);var i=new e.AnimFadeIn(this._shape.getCtx(),this._shape,this._insertDuration);t.add(i,2)},L.prototype.animateDelete=function(t,i){i.addChild(this._shape);var r=new e.AnimFadeOut(this._shape.getCtx(),this._shape,this._deleteDuration);t.add(r,0)},L.prototype.animateUpdate=function(t,i){var r=i._shape.getAnimationParams(),a=this._shape.getAnimationParams();this._shape.setAnimationParams(r);var s=new e.CustomAnimation(this._shape.getCtx(),this,this._updateDuration);s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._shape,this._shape.getAnimationParams,this._shape.setAnimationParams,a),t.add(s,1)};var B=new Object;e.Obj.createSubclass(B,e.Obj),B.DIR_UP=0,B.DIR_DOWN=1,B.DIR_NOCHANGE=2,B.makeIndicator=function(e,t,i,r,a,s){if(z.isPolar(r))return null;var n=B.getDirection(e,t,i,r,a,s);if(n==B.DIR_NOCHANGE)return null;var o=n===B.DIR_DOWN,l=o?V.getAnimationDownColor(r):V.getAnimationUpColor(r),h=B._drawIndicator(r.getCtx(),o,z.isHorizontal(r),l);return r.getPlotArea().addChild(h),h},B.getDirection=function(e,t,i,r,a,s){var n=H.getValue(e,t,i),o=H.getValue(r,a,s);return null==o||null==n||o==n?B.DIR_NOCHANGE:o>n?B.DIR_UP:B.DIR_DOWN},B._drawIndicator=function(t,i,r,a){var s;r?s=(e.Agent.isRightToLeft(t)?!i:i)?"M3.5,-5L3.5,5L-3.5,0L3.5,-5":"M-3.5,-5L-3.5,5L3.5,0L-3.5,-5":s=i?"M-5,-3.5L5,-3.5L0,3.5L-5,-3.5Z":"M-5,3.5L5,3.5L0,-3.5L-5,3.5Z";var n=new e.Path(t,s);return n.setSolidFill(a),n};var F=function(e,t){this.Init(e,t)};e.Obj.createSubclass(F,O),F.prototype.animateUpdate=function(t,i){var r=this._shape,a=i._shape.getAnimationParams(),s=r.getAnimationParams(),n=i._shape.getFill().clone(),o=this._shape.getFill();if(!e.ArrayUtils.equals(a,s)||!n.equals(o)){r.setAnimationParams(a);var l=new e.CustomAnimation(r.getCtx(),this,this._updateDuration);l.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.getAnimationParams,r.setAnimationParams,s),n.equals(o)||(this._shape.setFill(n),l.getAnimator().addProp(e.Animator.TYPE_FILL,r,r.getFill,r.setFill,o)),this._indicator&&l.setOnEnd(this._onEndAnimation,this),t.add(l,1)}},F.prototype.animateInsert=function(t){var i=this._shape,r=i.getAnimationParams(),a=r.slice(0);a[0]+=a[1]/2,a[1]=0,a[3]=0,i.setAnimationParams(a);var s=new e.CustomAnimation(i.getCtx(),this,this._insertDuration);s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,r),t.add(s,2)},F.prototype.animateDelete=function(t,i){var r=this._shape;i.setClipPath(null),i.addChild(r);var a=r.getAnimationParams(),s=a.slice(0);s[0]+=a[1]/2,s[1]=0,s[3]=0;var n=new e.CustomAnimation(r.getCtx(),this,this._deleteDuration);n.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.getAnimationParams,r.setAnimationParams,s),t.add(n,0)},F.prototype.Init=function(e,t){F.superclass.Init.call(this,e,t),this._animId+="/funnel"};var k=function(e,t){this.Init(e,t)};e.Obj.createSubclass(k,O),k.prototype.animateUpdate=function(t,i){var r=this._shape,a=i._shape.getAnimationParams(),s=r.getAnimationParams(),n=i._shape.getPrimaryFill(),o=this._shape.getPrimaryFill();if(!e.ArrayUtils.equals(a,s)||!n.equals(o)){r.setAnimationParams(a);var l=new e.CustomAnimation(r.getCtx(),this,this._updateDuration);l.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.getAnimationParams,r.setAnimationParams,s),n.equals(o)||(this._shape.setFill(n),l.getAnimator().addProp(e.Animator.TYPE_FILL,r,r.getFill,r.setFill,o)),t.add(l,1)}},k.prototype.animateInsert=function(t){var i=this._shape,r=i.getAnimationParams(),a=r.slice(0);a[1]=0,a[2]=0,i.setAnimationParams(a);var s=new e.CustomAnimation(i.getCtx(),this,this._insertDuration);s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,r),t.add(s,2)},k.prototype.animateDelete=function(t,i){var r=this._shape;i.setClipPath(null),i.addChild(r);var a=r.getAnimationParams().slice(0);a[1]=0,a[2]=0;var s=new e.CustomAnimation(r.getCtx(),this,this._deleteDuration);s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.getAnimationParams,r.setAnimationParams,a),t.add(s,0)},k.prototype.Init=function(e,t){k.superclass.Init.call(this,e,t),this._animId+="/pyramid"};var N=new Object;e.Obj.createSubclass(N,e.Obj),N.getXAxisPosition=function(t){return z.isPolar(t)?"tangential":z.isHorizontal(t)?e.Agent.isRightToLeft(t.getCtx())?"right":"left":"bottom"},N.getBaselineScaling=function(e,t){var i=t+"Axis",r=e.getOptions()[i].baselineScaling;return!r||"zero"!=r&&"min"!=r?z.isStock(e)?"min":"zero":r},N.getYAxisPosition=function(t){var i=t.getOptions().yAxis.position;return z.isPolar(t)?"radial":z.isHorizontal(t)?!i||"top"!=i&&"bottom"!=i?"bottom":i:(z.isStock(t)&&(i=i||"end"),e.Agent.isRightToLeft(t.getCtx())?i&&"end"==i?"left":"right":i&&"end"==i?"right":"left")},N.getY2AxisPosition=function(t){var i=t.getOptions().y2Axis.position;return z.isHorizontal(t)?!i||"top"!=i&&"bottom"!=i?"top":i:e.Agent.isRightToLeft(t.getCtx())?i&&"start"==i?"right":"left":i&&"start"==i?"left":"right"},N.hasTimeAxis=function(e){return z.isBLAC(e)&&"disabled"!=N.getTimeAxisType(e)},N.hasGroupAxis=function(e){return z.isBLAC(e)&&"disabled"==N.getTimeAxisType(e)},N.getTimeAxisType=function(e){var t=e.getOptions().timeAxisType;return t&&"auto"!=t&&z.isBLAC(e)&&!z.isPolar(e)?t:z.isStock(e)?"skipGaps":"disabled"},N.isMixedFrequency=function(e){return"mixedFrequency"==N.getTimeAxisType(e)},N.getAxisOffset=function(e){var t=e.getCache().getFromCache("axisOffset");if(null!=t)return t;var i=e.getOptions().styleDefaults.groupSeparators;if(N.hasGroupAxis(e)&&H.getNumLevels(e)>1&&"on"==i.rendered)t=.5;else if(z.hasBarSeries(e)||z.hasCenteredSeries(e)||z.hasCandlestickSeries(e)||z.hasBoxPlotSeries(e)||z.isBLAC(e)&&1==H.getGroupCount(e))t=.5;else if(!o.isPostAltaSkin(e)||z.isSpark(e)||G.isScrollable(e)||z.isOverview(e))t=0;else{var r=z.isHorizontal(e)?.2:.5;t=r-r/Math.sqrt(H.getGroupCount(e))}return e.getCache().putToCache("axisOffset",t),t},N.isGridShifted=function(e){if(!z.isBLAC(e))return!1;if(H.getNumLevels(e)>1)return!0;for(var t=H.getSeriesCount(e),i=0;i<t;i++)if(V.isSeriesRendered(e,i)){var r=V.getSeriesType(e,i),a=V.getLineType(e,i);if("bar"!=r&&"centeredSegmented"!=a&&"centeredStepped"!=a)return!1}return!0},N.isGridPolygonal=function(e){return!(!z.isBLAC(e)||z.hasBarSeries(e))&&"polygon"==e.getOptions().polarGridShape},N.isAxisRendered=function(e,t){if("y"==t&&z.hasY2DataOnly(e))return!1;if("y2"==t&&!z.hasY2Data(e))return!1;var i=e.getOptions()[t+"Axis"];return"off"!=i.rendered&&!("off"==i.tickLabel.rendered&&!i.title)},N.isAxisLineRendered=function(e,t){var i=e.getOptions()[t+"Axis"];return"off"!=i.rendered&&"off"!=i.axisLine.rendered&&!("auto"==i.axisLine.rendered&&"x"!=t&&z.isBLAC(e)&&!z.isPolar(e))},N.isMajorTickRendered=function(e,t){var i=e.getOptions()[t+"Axis"];return"off"!=i.rendered&&"off"!=i.majorTick.rendered&&!("auto"==i.majorTick.rendered&&"x"==t&&z.isBLAC(e)&&!z.isPolar(e))},N.isMinorTickRendered=function(e,t){var i=e.getOptions()[t+"Axis"];return"off"!=i.rendered&&"off"!=i.minorTick.rendered&&("on"==i.minorTick.rendered||N.isLog(e,t))},N.isLog=function(e,t){return"log"==e.getOptions()[t+"Axis"].scale},N.getTickLabelHeight=function(t,i){var r=t.getOptions(),a=r[i+"Axis"].tickLabel.style;return a instanceof e.CSSStyle||(a=new e.CSSStyle(a)),a.mergeUnder(e.Axis.getDefaults(r.skin).tickLabel.style),e.TextUtils.getTextStringHeight(t.getCtx(),a)},N.getTickLabelGapSize=function(e,t){if(N.isTickLabelInside(e,t))return 0;var i=e.getOptions(),r=z.isHorizontal(e),a=N.getGapScalingFactor(e,t),s=Math.ceil(i.layout.tickLabelGapWidth*a),n=Math.ceil(i.layout.tickLabelGapHeight*a);return"x"==t?r?s:n:r?n:s},N.getGapScalingFactor=function(e,t){return N.isAxisRendered(e,t)?N.getTickLabelHeight(e,t)/14:0},N.isTickLabelInside=function(e,t){return!(z.isPolar(e)||z.isScatterBubble(e)||z.isBLAC(e)&&"x"==t)&&"inside"==e.getOptions()[t+"Axis"].tickLabel.position},N.getXAxisViewportMinMax=function(e,t){var i=t?"xAxisViewportMinMaxUG":"xAxisViewportMinMax",r=e.getCache().getFromCache(i);if(r)return r;var a=e.getOptions().xAxis,s=N.hasGroupAxis(e),n=N.getAxisOffset(e);if(t)var o=N.getXAxisGlobalMinMax(e);var l=null;null!=a.viewportMin?l=a.viewportMin:null!=a.viewportStartGroup?l=s?H.getGroupIndex(e,a.viewportStartGroup)-n:a.viewportStartGroup:t&&(l=o.min);var h=null;return null!=a.viewportMax?h=a.viewportMax:null!=a.viewportEndGroup?h=s?H.getGroupIndex(e,a.viewportEndGroup)+n:a.viewportEndGroup:t&&(h=o.max),r={min:l,max:h},e.getCache().putToCache(i,r),r},N.getXAxisGlobalMinMax=function(e){var t=e.getOptions().xAxis,i=N.hasGroupAxis(e),r=N.getAxisOffset(e);if(!i)var a=H.getMinMaxValue(e,"x");return{min:null!=t.min?t.min:i?0-r:a.min,max:null!=t.max?t.max:i?H.getGroupCount(e)-1+r:a.max}},N.applyInitialZooming=function(e,t){var i=e.getOptions(),r=i.xAxis,a=i.initialZooming;if(z.isBLAC(e)&&"off"!=i.zoomAndScroll&&"none"!=a){i._initialZoomed&&("last"==a?r.viewportMin=null:r.viewportMax=null);var s=N.getXAxisViewportMinMax(e,!1),n=s.min,o=s.max;if(!("last"==a&&null!=n||"first"==a&&null!=o)){var l=z.isHorizontal(e)?t.h:t.w,h=Math.floor(l/(2*N.getTickLabelHeight(e,"x")))+N.getAxisOffset(e),u=H.getGroupCount(e)-1;if(!(u<=h)){var g,d;if(N.hasGroupAxis(e))g=0,d=u;else{var c=H.getMinMaxValue(e,"x");g=c.min,d=c.max}var p=h/u*(d-g);"last"==i.initialZooming?(null==o&&(o=d),r.viewportMin=Math.max(o-p,g)):(null==n&&(n=g),r.viewportMax=Math.min(n+p,d)),i._initialZoomed=!0}}}},N.getGroupWidthRatios=function(t){if(!z.hasBarSeries(t)&&!z.hasCandlestickSeries(t)&&!z.hasBoxPlotSeries(t))return null;var i=t.getOptions(),r=V.getBarGapRatio(t);if(r>=1)return i._averageGroupZ=1/0,null;i._averageGroupZ=0;var a,s,n,o,l,h,u=H.getGroupCount(t),g=z.isSplitDualY(t),d=H.getStackCategories(t,"bar"),c=d.y.length,p=d.y2.length;if(t.getOptionsCache().getFromCache("hasConstantZValue")){var _=t.getOptionsCache().getFromCache("constantZValue")*(g?Math.max(c,p):c+p);h=(l=_*u)*r/(1-r),a=null}else{for(var f=[],S=0;S<u;S++){for(s=0,o=0;o<c;o++)s+=H.getBarCategoryZ(t,d.y[o],S,!1);for(n=0,o=0;o<p;o++)n+=H.getBarCategoryZ(t,d.y2[o],S,!0);f.push(g?Math.max(s,n):s+n)}l=e.ArrayUtils.reduce(f,function(e,t){return e+t}),h=l*r/(1-r),a=e.ArrayUtils.map(f,function(e){return e+h/u})}return i._averageGroupZ=(l+h)/u,a},N.isYAdjustmentNeeded=function(e){var t=e.getOptions().styleDefaults.dataLabelPosition,i=V.isStackLabelRendered(e);return!(!z.hasBarSeries(e)||"outsideBarEdge"!=t&&!i)},N.axisContainsPoint=function(e,t){if(!e)return!1;var i=e.getOptions().position,r="top"==i||"bottom"==i,a=r?4:10,s=r?10:4,n=e.__getBounds().clone();n.x-=s,n.y-=a,n.w+=2*s,n.h+=2*a;var o=e.stageToLocal(t);return n.containsPoint(o.x,o.y)};var H=new Object;e.Obj.createSubclass(H,e.Obj),H.hasData=function(e){var t=e.getOptions();if(!t||!t.series||t.series.length<1)return!1;for(var i=H.getSeriesCount(e),r=0;r<i;r++){var a=H.getSeriesItem(e,r);if(a&&a.items&&a.items.length>=1)return!0}return!1},H.hasInvalidData=function(e){return!H.hasData(e)||H.hasInvalidTimeData(e)},H.hasInvalidTimeData=function(e){if(z.isFunnel(e)||z.isPie(e)||z.isPyramid(e))return!1;var t,i,r=e.getOptions(),a=H.getGroupCount(e);if(!r||!r.series||r.series.length<1)return!0;if(a<1)return!0;var s=H.getSeriesCount(e);if(N.isMixedFrequency(e))for(t=0;t<s;t++)for(i=0;i<a;i++){var n=H.getDataItem(e,t,i);if(n&&(null==n.x||isNaN(n.x)))return!0}else if(N.hasTimeAxis(e))for(i=0;i<a;i++){var o=H.getGroup(e,i);if(null==o||isNaN(o))return!0}return!1},H.hasSeriesData=function(e,t){var i=H.getSeriesItem(e,t).items;if(i)for(var r=0;r<i.length;r++)if(null!=i[r])return!0;return!1},H.processDataObject=function(t){if(H.hasData(t)){var i=t.getOptions(),r=t.getOptionsCache(),a=H.getSeriesCount(t);z.isValidType(t)||(i.type="bar");var s=!1,n=!1,o=!0,l=null,h=!1,u=!1,g=z.isStock(t);g&&a>1&&(i.series=i.series.slice(0,1),a=1);var d=N.isMixedFrequency(t),c=a>100;r.putToCache("hasLargeSeriesCount",c);for(var p=0,_=t.getSeriesStyleArray(),f=0;f<a;f++){var S=H.getSeries(t,f);!c&&null!=S&&e.ArrayUtils.getIndex(_,S)<0&&_.push(S);var C=H.getSeriesItem(t,f);if(C.items&&C.items.length>p&&(p=C.items.length),"hidden"==C.visibility){var m=V.getHiddenCategories(t);e.ArrayUtils.getIndex(m,S)<0&&m.push(S)}if(C.visibility=null,"on"==C.assignedToY2&&(s=!0),C&&C.items)for(var y=C.items,v=0;v<y.length;v++)null!=y[v]&&("object"!=typeof(E=y[v])&&(E={y:E},y[v]=E),d||null==E.x||(E.x=Number(E.x)),null!=E.y&&(E.y=Number(E.y),E.y<0&&(u=!0)),null!=E.z?(E.z=Number(E.z),null==l?l=E.z:l!=E.z&&(o=!1)):l=1,null!=E.value&&(E.value=Number(E.value),E.value<0&&(u=!0)),null!=E.targetValue&&(E.targetValue=Number(E.targetValue)),null!=E.open&&(E.open=Number(E.open),h=!0),null!=E.close&&(E.close=Number(E.close),h=!0,E.close<0&&(u=!0)),null!=E.low&&(E.low=Number(E.low),h=!0),null!=E.high&&(E.high=Number(E.high),h=!0),null!=E.volume&&(E.volume=Number(E.volume),n=!0),(E.color||E.borderColor||E.borderWidth||E.style||E.svgStyle||E.className||E.svgClassName)&&r.putToCachedMap("itemStyleSet",f,!0))}if(r.putToCache("hasVolume",n),r.putToCache("hasConstantZValue",o),r.putToCache("constantZValue",o?l:null),r.putToCache("hasLowHighSeries",h),r.putToCache("hasNegativeValues",u),g&&H.hasVolumeSeries(t)&&!z.isOverview(t)){var A=e.JsonUtils.clone(H.getSeriesItem(t,0));A.assignedToY2="on",s=!0,A.type="bar",A.categories=H.getCategories(t,0),A.id="_volume",A._selectable="off",A.items=[];for(var x=0;x<C.items.length;x++){var b={};b.color=V.getStockVolumeColor(t,0,x),b.x=C.items[x].x,b.value=C.items[x].volume,b.drilling="off",A.items.push(b)}i.series.push(A),r.putToCachedMap("itemStyleSet",i.series.length-1,!0)}r.putToCache("hasY2Assignment",s);for(var I=U.getRefObjs(t),T=0;T<I.length;T++){if(y=I[T].items)for(v=0;v<y.length;v++){var E;(E=y[v])&&("object"!=typeof E?y[v]=Number(E):(!N.isMixedFrequency(t)&&E.x&&(E.x=Number(E.x)),E.max&&(E.max=Number(E.max)),E.min&&(E.min=Number(E.min)),E.value&&(E.value=Number(E.value))))}}i.groups||(i.groups=new Array);var D=H.getGroupCount(t);for(T=0;T<p-D;T++){var O=e.Bundle.getTranslation(i,"labelDefaultGroupName",e.Bundle.CHART_PREFIX,"DEFAULT_GROUP_NAME",i.groups.length+1);i.groups.push(O)}r.putToCache("groupsArray",null),H._processTimeAxis(t);var P=i.sorting;if(P="on"==P?"descending":"ascending"!=P&&"descending"!=P?"off":P,z.isBLAC(t)&&N.hasGroupAxis(t)&&"off"!=P&&1==H.getNumLevels(t)){var M=H.getGroups(t),R={};for(v=0;v<M.length;v++){var w=0;for(T=0;T<=a;T++)if(V.isSeriesRendered(t,T)&&!H.isAssignedToY2(t,T)){var L=H.getValue(t,T,v);w+=null==L||isNaN(L)?0:L}R[M[v]]={index:v,total:w,group:i.groups[v]}}"ascending"==P?M.sort(function(e,t){return R[e].total-R[t].total}):M.sort(function(e,t){return R[t].total-R[e].total});for(T=0;T<a;T++){var B=[];for(v=0;v<M.length;v++)B.push(H.getDataItem(t,T,R[M[v]].index));i.series[T].items=B}var F=[];for(v=0;v<M.length;v++)F.push(R[M[v]].group);i.groups=F,r.putToCache("groupsArray",null),r.putToCache("value",null)}H._sanitizeAxis(i.xAxis),H._sanitizeAxis(i.yAxis),H._sanitizeAxis(i.y2Axis)}},H._sanitizeAxis=function(e){e.min==e.max&&(e.min=null,e.max=null)},H._sanitizeDateTime=function(e,t){var i=null,r=e.getLocaleHelpers().isoToDateConverter;if(r){try{i=r(t)}catch(e){i=null}i=null!=i&&i.getTime?i.getTime():null}return null==i&&(i=Date.parse(t)),isNaN(i)&&(i=Number(t)),i},H._processTimeAxis=function(e){var t,i,r=e.getCtx(),a=e.getOptions(),s=H.getSeriesCount(e),n=H.getGroupCount(e);if(N.isMixedFrequency(e))for(t=0;t<s;t++)for(i=0;i<n;i++){var o=H.getDataItem(e,t,i);null!=o&&"string"==typeof o.x&&null!=o.x&&(o.x=H._sanitizeDateTime(r,o.x))}else if(N.hasTimeAxis(e)){for(i=0;i<n;i++){var l=H.getGroup(e,i);null!=l&&(a.groups[i]=H._sanitizeDateTime(r,l))}e.getOptionsCache().putToCache("groupsArray",null)}if(N.hasTimeAxis(e)){var h=a.xAxis;null!=h.dataMin&&(h.dataMin=H._sanitizeDateTime(r,h.dataMin)),null!=h.dataMax&&(h.dataMax=H._sanitizeDateTime(r,h.dataMax)),null!=h.min&&(h.min=H._sanitizeDateTime(r,h.min)),null!=h.max&&(h.max=H._sanitizeDateTime(r,h.max)),null!=h.viewportMin&&(h.viewportMin=H._sanitizeDateTime(r,h.viewportMin)),null!=h.viewportMax&&(h.viewportMax=H._sanitizeDateTime(r,h.viewportMax)),null!=h.viewportStartGroup&&(h.viewportStartGroup=H._sanitizeDateTime(r,h.viewportStartGroup)),null!=h.viewportEndGroup&&(h.viewportEndGroup=H._sanitizeDateTime(r,h.viewportEndGroup));for(var u=U.getRefObjs(e),g=0;g<u.length;g++){var d=u[g].items;if(d)for(var c=0;c<d.length;c++)d[c]&&null!=d[c].x&&(d[c].x=H._sanitizeDateTime(r,d[c].x))}}},H.isEqualId=function(t,i,r){return null!=t&&null!=i&&e.Obj.compareValues(r,t,i)},H.getSeriesCount=function(e){var t=e.getOptions().series;return t?t.length:0},H.getY2SeriesCount=function(e,t,i){for(var r=0,a=H.getSeriesCount(e),s=0;s<a;s++)t&&V.getSeriesType(e,s)!=t||(i||V.isSeriesRendered(e,s))&&H.isAssignedToY2(e,s)&&r++;return r},H.getSeries=function(e,t){var i=H.getSeriesItem(e,t);return i?i.id?i.id:i.name||""===i.name?i.name:String(t):null},H.getSeriesLabel=function(e,t){var i=H.getSeriesItem(e,t);return i&&(i.name||""===i.name)?i.name:null},H.getSeriesIndex=function(e,t){for(var i=H.getSeriesCount(e),r=0;r<i;r++){if(H.getSeries(e,r)==t)return r}return-1},H.getSeriesStyleIndex=function(t,i){if(t.getOptionsCache().getFromCache("hasLargeSeriesCount"))return i;var r=H.getSeries(t,i);return null==r?i:e.ArrayUtils.getIndex(t.getSeriesStyleArray(),r)},H.getSeriesItem=function(e,t){if(isNaN(t)||null==t||t<0)return null;var i=e.getOptions();return i.series&&i.series.length>t?i.series[t]:void 0},H.getDataItem=function(e,t,i){if(isNaN(i)||null==i||i<0)return null;var r=H.getSeriesItem(e,t);return r&&r.items&&r.items.length>i?r.items[i]:null},H.getDataItemId=function(e,t,i){var r=H.getDataItem(e,t,i);return r?null!=r.id?r.id:H.createDataItemId(H.getSeries(e,t),H.getGroup(e,i)):null},H.createDataItemId=function(e,t){return e+"; "+t},H.getNestedDataItem=function(e,t,i,r){if(isNaN(r)||null==r||r<0)return null;var a=H.getDataItem(e,t,i);return a&&a.items&&a.items.length>r?a.items[r]:null},H.getNestedDataItemCount=function(e,t,i){var r=H.getDataItem(e,t,i);return r&&r.items?r.items.length:0},H.getNestedDataItemId=function(e,t,i,r){var a=H.getNestedDataItem(e,t,i,r);return a?null!=a.id?a.id:H.getDataItemId(e,t,i)+"; "+String(r):null},H.getNestedDataItemIndex=function(e,t,i,r){for(var a=H.getNestedDataItemCount(e,t,i),s=0;s<a;s++){var n=H.getNestedDataItemId(e,t,i,s);if(H.isEqualId(n,r,e.getCtx()))return s}return-1},H.getGroupCount=function(e){return H._getGroupsArray(e).length},H.getGroup=function(e,t){if(null!=t&&t>=0&&t<H.getGroupCount(e)){var i=H._getGroupsArray(e)[t];if(i)return null!=i.id?i.id:null!=i.name?i.name:String(t)}return null},H.getGroupIndex=function(t,i){for(var r=H.getGroups(t),a=0;a<r.length;a++)if(i instanceof Array&&r[a]instanceof Array?e.ArrayUtils.equals(i,r[a]):i===r[a])return a;return-1},H.getGroupLabel=function(e,t){if(t>=0&&t<H.getGroupCount(e)){var i=H._getGroupsArray(e)[t];if(i)return null!=i.name?i.name:null!=i.id||"string"!=typeof i?"":i}return null},H.getGroups=function(e){var t=e.getOptionsCache().getFromCache("groups");if(!t){var i=H.getGroupCount(e);t=[];for(var r=0;r<i;r++)t.push(H.getGroup(e,r));e.getOptionsCache().putToCache("groups",t)}return t},H._getGroupsArray=function(e){var t=e.getOptions(),i=e.getOptionsCache().getFromCache("groupsArray");if(!i){i=[],t.groups&&(i=H._getNestedGroups(t.groups,i));for(var r=0;r<i.length;r++)1==i[r].id.length&&(i[r].id=i[r].id[0],i[r].name=i[r].name[0]);e.getOptionsCache().putToCache("groupsArray",i)}return i},H._getNestedGroups=function(e,t){if(!e||e&&0==e.length)return[];for(var i=0;i<e.length;i++){var r=e[i],a=null,s=null;if(null!=r&&(a=r.id?r.id:r.name?r.name:r,s=r.name?r.name:r),"object"==typeof a&&(a=null),"object"==typeof s&&(s=null),r&&r.groups){var n=H._getNestedGroups(r.groups,[]);0==n.length&&n.push({id:[],name:[]});for(var o=0;o<n.length;o++)n[o].id.unshift(a),n[o].name.unshift(s);t=t.concat(n)}else t.push({id:[a],name:[s]})}return t},H.getNumLevels=function(t){var i=t.getOptionsCache().getFromCache("groupsNumLevels");if(null!=i)return i;i=0;for(var r=H._getGroupsArray(t),a=0;a<r.length;a++){var s=r[a];if(s&&s.id){var n=e.ArrayUtils.isArray(s.id)?s.id.length:1;i=Math.max(i,n)}}return t.getOptionsCache().putToCache("groupsNumLevels",i),i},H.getValue=function(e,t,i,r){var a,s="number"==typeof r&&r>=0;if(!s&&void 0!==(a=e.getOptionsCache().getFromCachedMap2D("value",t,i)))return a;var n=s?H.getNestedDataItem(e,t,i,r):H.getDataItem(e,t,i);return a=null,null!=n&&("object"!=typeof n?a=n:z.isStock(e)&&null!=n.close?a=n.close:null!=n.value?a=n.value:null!=n.y&&(a=n.y)),a=a||(0===a?0:null),s||e.getOptionsCache().putToCachedMap2D("value",t,i,a),a},H.getCumulativeValue=function(e,t,i,r){if(!z.isStacked(e))return H.getValue(e,t,i);var a=r?"cumValueH":"cumValue",s=e.getCache().getFromCachedMap2D(a,t,i);if(void 0!==s)return s;var n=V.getSeriesType(e,t),o=H.isAssignedToY2(e,t),l=H.getValue(e,t,i),h=H.getStackCategory(e,t),u="bar"==n?l<0:H.isSeriesNegative(e,t);s=0;for(var g=t;g>=0;g--)if((r||V.isDataItemRendered(e,g,i))&&n==V.getSeriesType(e,g)&&o==H.isAssignedToY2(e,g)&&H.getStackCategory(e,g)==h){var d=H.getValue(e,g,i),c="bar"==n?d<0:H.isSeriesNegative(e,g);if(u&&c||!u&&!c){var p=e.getCache().getFromCachedMap2D(a,g,i);if(void 0!==p){s=l+(p||0);break}s+=null==d||isNaN(d)?0:d}}return e.getCache().putToCachedMap2D(a,t,i,s),s},H.getLowValue=function(e,t,i){var r=H.getDataItem(e,t,i);return null==r?null:"candlestick"==V.getSeriesType(e,t)?null==r.low&&null!=r.close?null!=r.open?Math.min(r.close,r.open):r.close:r.low:null!=r.low&&null==r.close?r.low:null},H.getHighValue=function(e,t,i){var r=H.getDataItem(e,t,i);return null==r?null:"candlestick"==V.getSeriesType(e,t)?null==r.high?null!=r.open?Math.max(r.close,r.open):r.close:r.high:null!=r.high&&null==r.close?r.high:null},H.getXValue=function(e,t,i){var r=H.getDataItem(e,t,i);return H.getXValueFromItem(e,r,i)},H.getXValueFromItem=function(e,t,i){return null!=t&&null!=t.x?t.x:N.hasGroupAxis(e)?i:N.hasTimeAxis(e)&&!N.isMixedFrequency(e)?H.getGroupLabel(e,i):null},H.getTargetValue=function(e,t){var i=H.getDataItem(e,t,0);return null==i||"object"!=typeof i?null:i.targetValue},H.getZValue=function(e,t,i,r){var a=H.getDataItem(e,t,i);return null==a||"object"!=typeof a?r:null!=a.z?Math.max(0,a.z):r},H.isStockValueRising=function(e,t,i){var r=H.getDataItem(e,t,i);return!r||r.open<=r.close},H.getCategories=function(e,t,i,r){var a=H.getNestedDataItem(e,t,i,r);if(a&&a.categories)return a.categories;var s=H.getDataItem(e,t,i);if(s&&s.categories)return s.categories;var n=H.getSeriesItem(e,t);if(n&&n.categories)return n.categories;var o=H.getSeries(e,t);return null!=o?[o]:[]},H.getViewportMinMaxGroupIndex=function(e,t){var i=N.getXAxisViewportMinMax(e,!0),r=N.hasGroupAxis(e),a=H.getGroupCount(e),s=i.min,n=0;if(null!=s)if(r)n=Math.ceil(s);else for(var o=0;o<a;o++){if(H.getXValue(e,t,o)>=s){n=o;break}}var l=i.max,h=a-1;if(null!=h)if(r)h=Math.floor(l);else for(o=a-1;o>=n;o--){if(H.getXValue(e,t,o)<=l){h=o;break}}return{min:n,max:h}},H.getViewportGroupCount=function(e){var t=N.getXAxisViewportMinMax(e,!0),i=N.getXAxisGlobalMinMax(e),r=(t.max-t.min)/(i.max-i.min);return isNaN(r)?1:r*H.getGroupCount(e)},H._computeYAlongLine=function(t,i,r,a,s,n){t&&(r=e.Math.log10(r),s=e.Math.log10(s));var o=r+(s-r)*(n-i)/(a-i);return t?Math.pow(10,o):o},H.getMinMaxValue=function(e,t,i){var r=t+(i?"MinMaxDO":"MinMax"),a=e.getCache().getFromCache(r);if(a)return a;var s=e.getOptions()[t+"Axis"];if(null!=s.dataMax&&null!=s.dataMin&&i)return a={min:s.dataMin,max:s.dataMax},e.getCache().putToCache(r,a),a;var n=N.hasTimeAxis(e);if(null!=s.max&&null!=s.min&&!i&&!n)return a={min:s.min,max:s.max},e.getCache().putToCache(r,a),a;var o="z"!=t&&N.isLog(e,t),l="y2"==t;l&&(t="y");for(var h="y"==t,u=!i&&h&&z.isBLAC(e),g="withoutRescale"==G.getHideAndShowBehavior(e)||"x"==t&&N.hasTimeAxis(e),d=-1/0,c=1/0,p=H.getSeriesCount(e),_=0;_<p;_++){var f=H.getSeriesItem(e,_),S=V.getSeriesType(e,_),C=h&&(V.isRangeSeries(e,_)||"candlestick"==S||"boxPlot"==S);if(g||V.isSeriesRendered(e,_)){var m=H.isAssignedToY2(e,_);if(!h||l==m){var y=f.items;if(y){var v=0,A=y.length-1;if(u){var x=H.getViewportMinMaxGroupIndex(e,_);v=x.min,A=x.max}for(var b=v;b<=A;b++)if(g||V.isDataItemRendered(e,_,b)){var I=y[b],T=null;if(h?C||(T=H.getCumulativeValue(e,_,b,g)):"x"==t&&n&&!N.isMixedFrequency(e)?(T=H.getGroupLabel(e,b),null!=I&&(I.x=T)):null!=I&&(T=I[t]),!("z"==t&&T<=0)){if(!(C||null==T||"number"!=typeof T||o&&T<=0)){var E=0;z.isBubble(e)&&!i&&"z"!=t&&(E=X.getBubbleAxisRadius(e,t,I.markerSize)),d=Math.max(d,o?T*Math.pow(10,E):T+E),c=Math.min(c,o?T/Math.pow(10,E):T-E)}if(C){var D=H.getHighValue(e,_,b),O=H.getLowValue(e,_,b);o&&(D<=0||O<=0)||(d=Math.max(d,D,O),c=Math.min(c,D,O))}if(u&&!C){var P=null,M=null;if(v>0&&b==v?(P=b-1,M=N.getXAxisViewportMinMax(e,!0).min):A<y.length-1&&b==A&&(P=b+1,M=N.getXAxisViewportMinMax(e,!0).max),null!=P){var R=H.getXValue(e,_,b),w=H.getXValue(e,_,P),L=H.getCumulativeValue(e,_,P),B=H._computeYAlongLine(o,R,T||0,w,L||0,M);d=Math.max(d,B),c=Math.min(c,B)}}}}}}}}var F=null;if("x"==t?F=U.getAxisRefObjs(e,"x"):l?F=U.getAxisRefObjs(e,"y2"):h&&(F=U.getAxisRefObjs(e,"y")),null!=F)for(var k=0;k<F.length;k++){var Y=F[k],j=Y.items,W="withRescale"==G.getHideAndShowBehavior(e)&&"hidden"==Y.visibility;if(!W)if(j&&!W){var Z=0,K=j.length-1;if(u){var q=U.getViewportMinMaxIndex(e,j);Z=q.min,K=q.max}for(var Q=Z;Q<=K;Q++)if(null!=j[Q]){O=U.getLowValue(j[Q]),D=U.getHighValue(j[Q]);var J=isNaN(j[Q])?j[Q].value:j[Q];null!=O&&isFinite(O)&&(c=Math.min(c,O),d=Math.max(d,O)),null!=D&&isFinite(D)&&(c=Math.min(c,D),d=Math.max(d,D)),null!=J&&isFinite(J)&&(c=Math.min(c,J),d=Math.max(d,J))}}else{O=U.getLowValue(Y),D=U.getHighValue(Y),J=Y.value;null!=O&&isFinite(O)&&(c=Math.min(c,O),d=Math.max(d,O)),null!=D&&isFinite(D)&&(c=Math.min(c,D),d=Math.max(d,D)),null!=J&&isFinite(J)&&(c=Math.min(c,J),d=Math.max(d,J))}}return a={min:c,max:d},e.getCache().putToCache(r,a),a},H.isAssignedToY2=function(e,t){if(!e.getOptionsCache().getFromCache("hasY2Assignment"))return!1;var i=H.getSeriesItem(e,t);return!(!i||"on"!=i.assignedToY2||!z.isDualY(e))},H.getInitialSelection=function(e){var t=e.getOptions().selection,i=null!=e.getOptions().data;t||(t=[]);for(var r=e.getChartObjPeers(),a=0;a<t.length;a++){var s=t[a].id&&!i?t[a].id:t[a];if(t[a].id||t[a].series||t[a].group||(t[a]={id:s}),!(null==s||t[a].series&&t[a].group))for(var n=0;n<r.length;n++){var o=r[n];if(H.isEqualId(s,o.getDataItemId(),e.getCtx())){t[a].series=o.getSeries(),t[a].group=o.getGroup();break}}}return t},H.getCurrentSelection=function(e){var t=[],i=e.getSelectionHandler();if(i)for(var r=i.getSelectedIds(),a=0;a<r.length;a++){var s=r[a];t.push({series:s.getSeries(),group:s.getGroup(),id:s.getId()})}return t},H.hasVolumeSeries=function(e){var t=e.getOptionsCache().getFromCache("hasVolume");return t||!1},H.isDataSelected=function(e,t,i,r){var a=!isNaN(r)&&null!=r&&r>=0?H.getNestedDataItemId(e,t,i,r):H.getDataItemId(e,t,i),s=H.getSeries(e,t),n=H.getGroup(e,i),o=e.getOptions().selection;o||(o=[]);for(var l=0;l<o.length;l++){if(H.isEqualId(a,o[l],e.getCtx())||H.isEqualId(a,o[l].id,e.getCtx()))return!0;if(null==o[l].id&&H.isEqualId(s,o[l].series,e.getCtx())&&H.isEqualId(n,o[l].group,e.getCtx()))return!0}return!1},H.getDataLabel=function(e,t,i,r,a,s){var n,o=H.getDefaultDataLabel(e,t,i,r,a,s),l=e.getOptions().dataLabel;if(l&&!s){var h=H.getDataContext(e,t,i,r);if(h.label=o,"number"==typeof(n=l(h))){var u=W.getValueFormat(e,"label");n=W.formatValue(e.getCtx(),u,n)}}return n||o},H.getDefaultDataLabel=function(e,t,i,r,a,s){var n;if(s)n=H.getCumulativeValue(e,t,i);else{var o=!isNaN(r)&&null!=r&&r>=0?H.getNestedDataItem(e,t,i,r):H.getDataItem(e,t,i);if(!o)return null;n=o.label,"low"==a?n=n instanceof Array?n[0]:n:"high"==a&&(n=n instanceof Array?n[1]:null)}if(null!=n){if("number"==typeof n){var l,h,u,g=H.isAssignedToY2(e,t)&&e.y2Axis?e.y2Axis:e.yAxis;if(g){var d=g.getInfo();l=d.getGlobalMin(),h=d.getGlobalMax(),u=d.getMajorIncrement()}var c=W.getValueFormat(e,"label");return W.formatValue(e.getCtx(),c,n,l,h,u)}return n}return null},H.getStackCategory=function(e,t){var i=e.getCache().getFromCachedMap("stackCategory",t);return void 0!==i?i:(i=z.isStacked(e)?H.getSeriesItem(e,t).stackCategory||null:H.getSeries(e,t)||null,e.getCache().putToCachedMap("stackCategory",t,i),i)},H.getStackCategories=function(e,t,i){var r=[],a=[],s={},n={},o=e.getCache().getFromCachedMap2D("stackCategories",t,i);if(o)return o;for(var l=H.getSeriesCount(e),h=0;h<l;h++)if(V.isSeriesRendered(e,h)||i){if(t){var u=V.getSeriesType(e,h);if("candlestick"!=u&&"boxPlot"!=u||(u="bar"),t!=u)continue}var g=H.getStackCategory(e,h);H.isAssignedToY2(e,h)?n[g]||(a.push(g),n[g]=!0):s[g]||(r.push(g),s[g]=!0)}return o={y:r,y2:a},e.getCache().putToCachedMap2D("stackCategories",t,i,o),o},H.getBarCategoryZ=function(e,t,i,r){for(var a=0,s=H.getSeriesCount(e),n=0;n<s;n++){var o=V.getSeriesType(e,n);if(("bar"==o||"candlestick"==o||"boxPlot"==o)&&H.getStackCategory(e,n)==t&&V.isSeriesRendered(e,n)){var l=H.isAssignedToY2(e,n);(r&&l||!r&&!l)&&(a=Math.max(a,H.getZValue(e,n,i,1)))}}return a},H.getBarInfo=function(t,i,r,a){var s,n,o=z.isHorizontal(t),l=z.isStacked(t),h=e.Agent.isRightToLeft(t.getCtx()),u=t.xAxis,g=V.isRangeSeries(t,i),d=V.getBarCategoryOffsetMap(t,r),c=H.getXValue(t,i,r),p=u.getUnboundedCoordAt(c),_=H.isAssignedToY2(t,i),f=_?t.y2Axis:t.yAxis,S=f.getBaselineCoord();if(g){var C=H.getLowValue(t,i,r),m=H.getHighValue(t,i,r);if(null==C||isNaN(C)||null==m||isNaN(m))return null;if((s=f.getBoundedCoordAt(C))==(n=f.getBoundedCoordAt(m))&&null==f.getCoordAt(C))return null}else{var y=H.getValue(t,i,r),v=H.getCumulativeValue(t,i,r);if(null==y||isNaN(y))return null;if((s=f.getBoundedCoordAt(v))==(n=l?f.getBoundedCoordAt(v-y):S)&&null==f.getCoordAt(v))return null}var A=H.getStackCategory(t,i),x=V.getBarWidth(t,i,r),b=l?V.getBarStackWidth(t,A,r,_):x;if("pixel"==V.getBarSpacing(t)&&e.Agent.isPlatformGecko()){var I=x/(1-V.getBarGapRatio(t));x>1&&I-x<2&&(b=--x)}var T=d[_?"y2":"y"][A]+.5*(b-x),E=h&&!o?p-T-x:p+T,D=E+x,O=(E+D)/2,P=g?(s+n)/2:s;return{x1:E,x2:D,axisCoord:S,baseCoord:n,yCoord:s,dataPos:te.convertAxisCoord(t,new e.Point(O,P),a),barWidth:x}},H.getMarkerPosition=function(t,i,r,a,s){var n,o,l=t.xAxis,h=H.isAssignedToY2(t,i)?t.y2Axis:t.yAxis,u=z.isPolar(t),g=V.isRangeSeries(t,i),d=!isNaN(a)&&null!=a&&a>=0,c=H.getXValue(t,i,r),p=d?H.getValue(t,i,r,a):H.getCumulativeValue(t,i,r);if(z.isBubble(t)){if(u&&p<h.getInfo().getViewportMin())return null;n=u?l.getCoordAt(c):l.getUnboundedCoordAt(c),o=h.getUnboundedCoordAt(p)}else if(g){var _=h.getCoordAt(H.getLowValue(t,i,r)),f=h.getCoordAt(H.getHighValue(t,i,r));n=l.getCoordAt(H.getXValue(t,i,r)),o=(_+f)/2}else n=l.getCoordAt(c),o=h.getCoordAt(p);return null==n||null==o?null:te.convertAxisCoord(t,new e.Point(n,o),s)},H.getScatterBubbleMarkerPosition=function(t,i,r){var a=t.xAxis,s=t.yAxis,n=H.getXValue(t,i,r),o=H.getValue(t,i,r),l=a.getCoordAt(n),h=s.getCoordAt(o);return null==l||null==h?null:new e.Point(l,h)},H.isSeriesNegative=function(e,t){if(!e.getOptionsCache().getFromCache("hasNegativeValues"))return!1;var i=e.getOptionsCache().getFromCachedMap("isSeriesNegative",t);if(null!=i)return i;var r=H.getGroupCount(e);i=!0;for(var a=0;a<r;a++){if(H.getValue(e,t,a)>0){i=!1;break}}return e.getOptionsCache().putToCachedMap("isSeriesNegative",t,i),i},H.getDataContext=function(t,i,r,a){var s,n=H.getSeriesItem(t,i),o=H.getDataItem(t,i,r),l=H.getNestedDataItem(t,i,r,a),h=t.getRawOptions(),u=z.isPie(t)&&(null==i||i<0),g=t.getOptions();if(u){var d=e.Bundle.getTranslatedString(e.Bundle.CHART_PREFIX,"LABEL_OTHER",null);s={id:d,series:d,value:Z.getOtherValue(t),color:g.styleDefaults.otherColor}}else if(l){delete(c=h.series[i].items[r])._itemData,s={id:H.getNestedDataItemId(t,i,r,a),data:[c,c.items[a]],value:H.getValue(t,i,r,a),y:H.getValue(t,i,r,a),color:V.getMarkerColor(t,i,r,a),itemData:g.series[i].items[r]._itemData}}else if(o){var c;delete(c=h.series[i].items[r])._itemData,s={id:H.getDataItemId(t,i,r),data:c,value:H.getValue(t,i,r),targetValue:H.getTargetValue(t,i,r),x:H.getXValue(t,i,r),y:H.getValue(t,i,r),z:H.getZValue(t,i,r),low:H.getLowValue(t,i,r),high:H.getHighValue(t,i,r),open:o.open,close:o.close,volume:o.volume,color:V.getColor(t,i,r),itemData:g.series[i].items[r]._itemData}}else n&&(s={id:H.getSeries(t,i),color:V.getColor(t,i)});if(s){s.component=g._widgetConstructor,(u||l||o)&&(s.group=H.getGroup(t,r),s.groupData=H.getGroupsDataForContext(t)[r]),!u&&(l||o||n)&&(s.series=H.getSeries(t,i),s.seriesData=h.series[i]),z.isPie(t)&&t.pieChart&&(s.totalValue=t.pieChart.getTotalValue());var p=t.getOptionsCache().getFromCachedMap2D("barDims",i,r);p&&(s.dimensions=p)}return s||{}},H.getGroupsDataForContext=function(e){var t=e.getOptionsCache().getFromCache("groupsDataArray");if(!t){var i=e.getRawOptions();t=H._getNestedGroupsData(i.groups),e.getOptionsCache().putToCache("groupsDataArray",t)}return t},H._getNestedGroupsData=function(e){if(!e)return[];for(var t=[],i=0;i<e.length;i++){var r=e[i];if(r.groups){for(var a=H._getNestedGroupsData(r.groups),s=0;s<a.length;s++)a[s].unshift(r);t=t.concat(a)}else t.push([r])}return t},H._computeOutermostBarMap=function(e){if(!e.getOptionsCache().getFromCache("outermostBar")){for(var t={},i=H.getSeriesCount(e),r=e.getOptionsCache().getFromCache("hasNegativeValues"),a=i-1;a>=0;a--)if(V.isSeriesRendered(e,a)&&"bar"==V.getSeriesType(e,a)){var s=(H.getStackCategory(e,a)||"")+H.isAssignedToY2(e,a);t[s]?t[s].push(a):t[s]=[a]}var n=H.getGroupCount(e);for(var o in t)for(var l=t[o],h=0;h<n;h++)for(var u=!1,g=!1,d=0;d<l.length&&!(!r&&u||u&&g);d++)if(a=l[d],V.isDataItemRendered(e,a,h)){var c=H.getValue(e,a,h);!u&&c>=0?(u=!0,e.getOptionsCache().putToCachedMap2D("outermostBar",a,h,!0)):!g&&c<0&&(g=!0,e.getOptionsCache().putToCachedMap2D("outermostBar",a,h,!0))}}},H.isOutermostBar=function(e,t,i){return H._computeOutermostBarMap(e),e.getOptionsCache().getFromCachedMap2D("outermostBar",t,i)||!1},H.isDataItemFiltered=function(e,t,i){var r=H.getDataItem(e,t,i);return!(!r||!r._filtered)},H.getFilteredChartObjPeers=function(e){if(!e.getCache().getFromCache("dataFiltered"))return[];var t=e.getCache().getFromCache("filteredChartObjPeers");if(!t){t=[];for(var i=0;i<H.getSeriesCount(e);i++)for(var r=0;r<H.getGroupCount(e);r++){var s;if(H.isDataItemFiltered(e,i,r))s="bar"==V.getSeriesType(e,i)?H.getBarInfo(e,i,r).dataPos:H.getMarkerPosition(e,i,r),t.push(new a(e,[],i,r,null,s))}e.getCache().putToCache("filteredChartObjPeers",t)}return t};var G=new Object;e.Obj.createSubclass(G,e.Obj),G.getHideAndShowBehavior=function(e){return e.getOptions().hideAndShowBehavior},G.getHoverBehavior=function(e){return e.getOptions().hoverBehavior},G.setVisibility=function(t,i,r){var a=U.getRefObj(t,i);null!=a&&(a.visibility=r);var s=V.getHiddenCategories(t),n=e.ArrayUtils.getIndex(s,i);"hidden"==r&&n<0?s.push(i):"visible"==r&&n>=0&&s.splice(n,1);var o=t.getOptions();if(o&&o.legend&&o.legend.sections){for(var l=0;l<o.legend.sections.length;l++){var h=o.legend.sections[l];if(h&&h.items)for(var u=0;u<h.items.length;u++)h.items[u].id==i&&(h.items[u].categoryVisibility=r)}return!0}return!1},G.isScrollable=function(e){return!!z.isScrollSupported(e)&&"off"!=e.getOptions().zoomAndScroll},G.isZoomable=function(e){if(!z.isScrollSupported(e))return!1;var t=e.getOptions().zoomAndScroll;return"live"==t||"delayed"==t},G.getZoomDirection=function(e){return z.isScatterBubble(e)?e.getOptions().zoomDirection:"auto"},G.isLiveScroll=function(e){if(!z.isScrollSupported(e))return!1;var t=e.getOptions().zoomAndScroll;return"live"==t||"liveScrollOnly"==t},G.isDelayedScroll=function(e){if(!z.isScrollSupported(e))return!1;var t=e.getOptions().zoomAndScroll;return"delayed"==t||"delayedScrollOnly"==t},G.processIds=function(e,t){for(var i=[],r=0;r<t.length;r++){var a=t[r];if(a.getSeries()==Z.OTHER_SLICE_SERIES_ID){var s=Z.getOtherSliceIds(e);i=i.concat(s)}else i.push(a)}return i},G.adjustBounds=function(e){null!=e.x&&(e.x-=1),null!=e.w&&(e.w+=2),null!=e.y&&(e.y-=1),null!=e.h&&(e.h+=2)},G.getBoundedObjects=function(e,t){for(var i=e.getChartObjPeers().concat(H.getFilteredChartObjPeers(e)),r=[],a=0;a<i.length;a++){var s=i[a],n=s.getDataPosition();if(n){n=e.getPlotArea().localToStage(n);var o=null==t.x||n.x>=t.x&&n.x<=t.x+t.w,l=null==t.y||n.y>=t.y&&n.y<=t.y+t.h;o&&l&&r.push(s)}}return r},G.getAxisBounds=function(t,i,r){var a=t.getPlotArea(),s=a.stageToLocal(new e.Point(i.x,i.y)),n=a.stageToLocal(new e.Point(i.x+i.w,i.y+i.h));null==i.x&&(s.x=null,n.x=null),null==i.y&&(s.y=null,n.y=null);var o=G._convertToAxisCoord(t,s.x,n.x,s.y,n.y),l={},h={},u={},g={};return t.xAxis&&(l=G._getAxisMinMax(t.xAxis,o.xMin,o.xMax,r),g=G.getAxisStartEndGroup(t.xAxis,l.min,l.max)),t.yAxis&&(h=G._getAxisMinMax(t.yAxis,o.yMin,o.yMax,r)),t.y2Axis&&(u=G._getAxisMinMax(t.y2Axis,o.yMin,o.yMax,r)),{xMin:l.min,xMax:l.max,unchanged:l.unchanged,yMin:h.min,yMax:h.max,y2Min:u.min,y2Max:u.max,startGroup:g.startGroup,endGroup:g.endGroup}},G._getAxisMinMax=function(e,t,i,r){if(null==t||null==i)return{min:null,max:null};var a=e.getUnboundedLinearValueAt(t),s=e.getUnboundedLinearValueAt(i);if(r){var n=e.getInfo().getMinimumExtent();if(s-a<n){var o=(s+a)/2;s=o+n/2,a=o-n/2}return G._limitToGlobal(e,a,s)}return G.getActualMinMax(e,a,s)},G.getAxisBoundsByDelta=function(e,t,i,r,a){var s=G._convertToAxisCoord(e,t,i,r,a),n=G.getZoomDirection(e),o={},l={},h={},u={};return e.xAxis&&"y"!=n&&(o=G._getAxisMinMaxByDelta(e.xAxis,s.xMin,s.xMax),u=G.getAxisStartEndGroup(e.xAxis,o.min,o.max)),e.yAxis&&"x"!=n&&(l=G._getAxisMinMaxByDelta(e.yAxis,s.yMin,s.yMax)),e.y2Axis&&(h=G._getAxisMinMaxByDelta(e.y2Axis,s.yMin,s.yMax)),{xMin:o.min,xMax:o.max,unchanged:o.unchanged,yMin:l.min,yMax:l.max,y2Min:h.min,y2Max:h.max,startGroup:u.startGroup,endGroup:u.endGroup}},G._getAxisMinMaxByDelta=function(e,t,i){var r=e.getLinearViewportMin(),a=e.getLinearViewportMax();if(i==t&&e.isFullViewport())return G.getActualMinMax(e,r,a);var s=e.getUnboundedLinearValueAt(t)-e.getUnboundedLinearValueAt(0),n=e.getUnboundedLinearValueAt(i)-e.getUnboundedLinearValueAt(0),o=1,l=a+n-(r+s),h=e.getInfo().getMinimumExtent();return t!=i&&l<h&&(o=(a-r-h)/(s-n)),r+=s*o,a+=n*o,G._limitToGlobal(e,r,a)},G._convertToAxisCoord=function(t,i,r,a,s){var n={},o=e.Agent.isRightToLeft(t.getCtx());return z.isHorizontal(t)?(n.xMin=a,n.xMax=s,n.yMin=o?r:i,n.yMax=o?i:r):(n.xMin=o?r:i,n.xMax=o?i:r,n.yMin=s,n.yMax=a),n},G._limitToGlobal=function(e,t,i){var r=e.getLinearGlobalMin(),a=e.getLinearGlobalMax();return i-t>=a-r?(t=r,i=a):t<r?(i+=r-t,t=r):i>a&&(t-=i-a,i=a),G.getActualMinMax(e,t,i)},G.getActualMinMax=function(e,t,i){var r={min:e.linearToActual(t),max:e.linearToActual(i)};if(e.isGroupAxis()){var a=e.getLinearViewportMin(),s=e.getLinearViewportMax();Math.abs(t-a)<1e-4&&Math.abs(i-s)<1e-4&&(r.unchanged=!0)}return r},G.getAxisStartEndGroup=function(e,t,i){if(e.isGroupAxis()&&null!=t&&null!=i){var r=Math.ceil(t),a=Math.floor(i);if(a>=r)return{startGroup:e.getInfo().getGroup(r),endGroup:e.getInfo().getGroup(a)}}return{startGroup:null,endGroup:null}},G.setInitialSelection=function(e,t){var i=e.getSelectionHandler();if(i)if(t&&0!=t.length){for(var r=[],a=0;a<t.length;a++)null!=t[a].id?r.push(t[a].id):null!=t[a].series&&null!=t[a].group&&r.push(H.createDataItemId(t[a].series,t[a].group));for(var s=new(e.getCtx().KeySetImpl)(r),n=e.getChartObjPeers(),o=[],l=0;l<n.length;l++){var h=n[l];if(h.isSelectable()){var u=h.getDataItemId(),g=H.createDataItemId(h.getSeries(),h.getGroup());(s.has(u)||s.has(g))&&o.push(h.getId())}}i.processInitialSelections(o,n)}else i.clearSelection()},G.getKeyboardNavigables=function(e){var t=[];if(z.isPie(e))for(var i=e.pieChart.__getSlices(),r=0;r<i.length;r++)V.isSeriesRendered(e,i[r].getSeriesIndex())&&t.push(i[r]);else{var a=e.getChartObjPeers();for(r=0;r<a.length;r++)a[r].isNavigable()&&t.push(a[r])}return t},G.isSeriesDrillable=function(e,t){var i=H.getSeriesItem(e,t),r=null!=i?i.drilling:"inherit";return"on"==r||"off"!=r&&("on"==(r=e.getOptions().drilling)||"seriesOnly"==r)},G.isDataItemDrillable=function(e,t,i,r){var a=H.getNestedDataItem(e,t,i,r);a||(a=H.getDataItem(e,t,i));var s=null!=a?a.drilling:"inherit";return"on"==s||"off"!=s&&"on"==(s=e.getOptions().drilling)},G.addEventData=function(e,t){var i=H.getSeriesIndex(e,t.series),r=H.getGroupIndex(e,t.group),a=H.getNestedDataItemIndex(e,i,r,t.id),s=H.getDataContext(e,i,r,a);s&&(t.data=s.data,t.itemData=s.itemData,t.seriesData=s.seriesData,s.groupData?t.groupData=s.groupData:null!=r&&(t.groupData=H.getGroupsDataForContext(e)[r]))},G.isPlotAreaDraggable=function(e){var t=e.getOptions(),i=t.dnd?t.dnd.drag.items:{};return Object.keys(i).length>0},G.isPlotAreaDropTarget=function(e){var t=e.getOptions(),i=t.dnd?t.dnd.drop.plotArea:{};return Object.keys(i).length>0},G.addPlotAreaDnDBackground=function(t,i,r,a){var s=G.isPlotAreaDraggable(t);(G.isPlotAreaDropTarget(t)||s)&&(background=new e.Rect(t.getCtx(),0,0,a?r.w:r.h,a?r.h:r.w),background.setInvisibleFill(),i.addChild(background),t.getCache().putToCache("plotAreaBackground",background),s&&background.setClassName("oj-draggable"))};var U=new Object;e.Obj.createSubclass(U,e.Obj),U.getRefObjs=function(e){var t=U.getAxisRefObjs(e,"x"),i=U.getAxisRefObjs(e,"y"),r=U.getAxisRefObjs(e,"y2");return t.concat(i,r)},U.getAxisRefObjs=function(e,t){var i=e.getOptions();return i&&i[t+"Axis"]&&i[t+"Axis"].referenceObjects?i[t+"Axis"].referenceObjects:[]},U.getType=function(e){return"area"==e.type?"area":"line"},U.getLocation=function(e){return"front"==e.location?"front":"back"},U.getColor=function(e){return e.color?e.color:"#333333"},U.getLineWidth=function(e){return e.lineWidth?e.lineWidth:1},U.getLineType=function(e){return e.lineType?e.lineType:"straight"},U.isObjectRendered=function(t,i){var r=V.getHiddenCategories(t);if(r.length>0){var a=U.getRefObjCategories(i);if(a&&e.ArrayUtils.hasAnyItem(r,a))return!1}return!("hidden"==i.visibility)},U.getId=function(e){return null!=e.id?e.id:e.text},U.getRefObjCategories=function(e){return e.categories?e.categories:[U.getId(e)]},U.getRefObj=function(e,t){for(var i=U.getRefObjs(e),r=0;r<i.length;r++)if(U.getId(i[r])==t)return i[r]},U.getLowValue=function(e){return null==e?null:e.low},U.getHighValue=function(e){return null==e?null:e.high},U.getXValue=function(e,t,i){return H.getXValueFromItem(e,t[i],i)},U.getViewportMinMaxIndex=function(e,t){var i=N.getXAxisViewportMinMax(e,!0),r=N.hasGroupAxis(e),a=i.min,s=0;if(null!=a)if(r)s=Math.ceil(a);else for(var n=0;n<t.length;n++){if(U.getXValue(e,t,n)>=a){s=n;break}}var o=i.max,l=t.length-1;if(null!=l)if(r)l=Math.floor(o);else for(n=t.length-1;n>=s;n--){if(H.getXValue(e,t,n)<=o){l=n;break}}return{min:s,max:l}};var Y=new Object;e.Obj.createSubclass(Y,e.Obj),Y.getBarFill=function(e,t,i,r){var a=V.getColor(e,t,i),s=V.getPattern(e,t,i);return Y.getRectangleFill(e,a,s,r)},Y.getRectangleFill=function(t,i,r,a){var s=V.getSeriesEffect(t);if(r)return new e.PatternFill(r,i);if("gradient"==s&&a>3){var n,o,l=z.isHorizontal(t)?270:0;return Y._useAltaGradients(t)?(n=[e.ColorUtils.adjustHSL(i,0,-.09,.04),e.ColorUtils.adjustHSL(i,0,-.04,-.05)],o=[0,1]):(n=[e.ColorUtils.getBrighter(i,.15),e.ColorUtils.getBrighter(i,.45),e.ColorUtils.getBrighter(i,.25),i,e.ColorUtils.getBrighter(i,.15),e.ColorUtils.getDarker(i,.1)],o=[0,.15,.3,.65,.85,1]),new e.LinearGradientFill(l,n,null,o)}return new e.SolidFill(i)},Y.getAreaFill=function(t,i){var r,a="lineWithArea"==V.getSeriesType(t,i),s=H.getSeriesItem(t,i);s&&s.areaColor?r=s.areaColor:(r=V.getColor(t,i),a&&(r=e.ColorUtils.setAlpha(r,.2)));var n=V.getPattern(t,i),o=V.getSeriesEffect(t);if(n)return new e.PatternFill(n,r);if("gradient"==o){var l,h,u=z.isHorizontal(t)?180:270;if(a){var g=e.ColorUtils.getAlpha(r);l=[e.ColorUtils.setAlpha(r,Math.min(g+.2,1)),e.ColorUtils.setAlpha(r,Math.max(g-.15,0))],h=[0,1]}else Y._useAltaGradients(t)?(l=[e.ColorUtils.adjustHSL(r,0,-.09,.04),e.ColorUtils.adjustHSL(r,0,-.04,-.05)],h=[0,1]):z.isSpark(t)?(l=[e.ColorUtils.getDarker(r,.5),r,e.ColorUtils.getBrighter(r,.5)],h=[0,.5,1]):(l=[e.ColorUtils.getBrighter(r,.5),r,e.ColorUtils.getDarker(r,.3)],h=[0,.5,1]);return new e.LinearGradientFill(u,l,null,h)}return new e.SolidFill(r)},Y.getMarkerFill=function(t,i,r,a){var s=V.getMarkerColor(t,i,r,a),n=V.getPattern(t,i,r,a);if(n)return new e.PatternFill(n,s);if(z.isBubble(t)&&"gradient"==V.getSeriesEffect(t)){if(Y._useAltaGradients(t)){var o=[e.ColorUtils.adjustHSL(s,0,-.09,.04),e.ColorUtils.adjustHSL(s,0,-.04,-.05)];return new e.LinearGradientFill(270,o,null,[0,1])}if("human"==V.getMarkerShape(t,i,r,a)){var l=[e.ColorUtils.getBrighter(s,.2),e.ColorUtils.getBrighter(s,.1),s,e.ColorUtils.getDarker(s,.2)];return new e.LinearGradientFill(315,l,null,[0,.3,.7,1])}var h=[e.ColorUtils.getBrighter(s,.15),s,e.ColorUtils.getDarker(s,.1),e.ColorUtils.getDarker(s,.2)];return new e.RadialGradientFill(h,null,[0,.5,.75,1])}return new e.SolidFill(s)},Y.getFunnelPyramidSliceFill=function(t,i,r,a,s){var n=V.getPattern(t,i,0),o=V.getSeriesEffect(t);if(n&&!s){var l=new e.PatternFill(n,r);return("vertical"==t.getOptions().orientation||z.isPyramid(t))&&(e.Agent.isRightToLeft(t.getCtx())?l.setMatrix(new e.Matrix(0,-1,1,0)):l.setMatrix(new e.Matrix(0,1,-1,0))),l}if("gradient"==o){var h,u,g=z.isPyramid(t)?180:90;return"on"==t.getOptions().styleDefaults.threeDEffect?(h=[e.ColorUtils.adjustHSL(r,0,0,-.1),e.ColorUtils.adjustHSL(r,0,0,.12),r],u=[0,.65,1]):(h=[e.ColorUtils.adjustHSL(r,0,-.09,.04),e.ColorUtils.adjustHSL(r,0,-.04,-.05)],u=[0,1]),new e.LinearGradientFill(g,h,null,u,[a.x,a.y,a.w,a.h])}return new e.SolidFill(r)},Y._useAltaGradients=function(e){return!o.isSkyrosSkin(e)};var V=new Object;e.Obj.createSubclass(V,e.Obj),V._SERIES_TYPE_RAMP=["bar","line","area"],V.getSeriesType=function(e,t){var i=e.getOptionsCache().getFromCachedMap("seriesType",t);if(i)return i;if(!z.isBLAC(e))return e.getOptionsCache().putToCachedMap("seriesType",t,"auto"),"auto";var r=H.getSeriesItem(e,t);if(i=r?r.type:null,z.isStock(e)||"candlestick"!=i||(i="auto"),!i||"auto"==i)if(z.isBar(e))i="bar";else if(z.isLine(e))i="line";else if(z.isArea(e))i="area";else if(z.isLineWithArea(e))i="lineWithArea";else if(z.isStock(e))i="candlestick";else if(z.isBoxPlot(e))i="boxPlot";else if(z.isCombo(e)){var a=H.getSeriesStyleIndex(e,t)%V._SERIES_TYPE_RAMP.length;i=V._SERIES_TYPE_RAMP[a]}return e.getOptionsCache().putToCachedMap("seriesType",t,i),i},V.isRangeSeries=function(e,t){var i=e.getOptionsCache();if(!i.getFromCache("hasLowHighSeries"))return!1;var r=i.getFromCachedMap("isRange",t);if(null!=r)return r;r=!1;var a=V.getSeriesType(e,t);if("bar"==a||"area"==a)for(var s=0;s<H.getGroupCount(e);s++)if(null!=H.getLowValue(e,t,s)||null!=H.getHighValue(e,t,s)){r=!0;break}return e.getOptionsCache().putToCachedMap("isRange",t,r),r},V.getSeriesEffect=function(e){return e.getOptions().styleDefaults.seriesEffect},V.getColor=function(e,t,i){var r=H.getDataItem(e,t,i);if(r&&r.color)return r.color;var a=H.getSeriesItem(e,t);if(a&&a.color)return a.color;if("candlestick"==V.getSeriesType(e,t))return V.getStockItemColor(e,t,i);var s=e.getOptions().styleDefaults.colors;return s[H.getSeriesStyleIndex(e,t)%s.length]},V.getStockItemColor=function(e,t,i){var r=e.getOptions();return H.isStockValueRising(e,t,i)?r.styleDefaults.stockRisingColor:r.styleDefaults.stockFallingColor},V.getStockVolumeColor=function(e,t,i){var r=H.getDataItem(e,t,i);if(r&&r.color)return r.color;var a=e.getOptions();return a.styleDefaults.stockVolumeColor?a.styleDefaults.stockVolumeColor:V.getStockItemColor(e,t,i)},V.getSplitterPosition=function(e){var t=e.getOptions().splitterPosition;return null!=t?t:z.isStock(e)?.8:.5},V.getPattern=function(t,i,r,a){var s=H.getNestedDataItem(t,i,r,a);if(s&&s.pattern&&"auto"!=s.pattern)return s.pattern;var n=H.getDataItem(t,i,r);if(n&&n.pattern&&"auto"!=n.pattern)return n.pattern;var o=V.getSeriesType(t,i);if(("line"==o||"area"==o)&&null!=r)return null;var l=H.getSeriesItem(t,i);if(l&&l.pattern&&"auto"!=l.pattern)return l.pattern;if("pattern"==V.getSeriesEffect(t)){if(z.isStock&&"candlestick"==V.getSeriesType(t,i)){var h=H.isStockValueRising(t,i,r),u=e.Agent.isRightToLeft(t.getCtx());return h?u?"smallDiagonalLeft":"smallDiagonalRight":u?"smallDiagonalRight":"smallDiagonalLeft"}var g=t.getOptions().styleDefaults.patterns;return g[H.getSeriesStyleIndex(t,i)%g.length]}return null},V.getMarkerBorderColor=function(t,i,r,a){var s=V.getBorderColor(t,i,r,a);if(s)return s;if(V.getDataItemGaps(t)>0&&"lineWithArea"!=V.getSeriesType(t,i))return V.getBackgroundColor(t,!0);if(z.isBubble(t)&&!o.isSkyrosSkin(t)&&"gradient"!=V.getSeriesEffect(t)){var n=V.getMarkerColor(t,i,r);if(n)return e.ColorUtils.adjustHSL(n,0,.15,-.25)}return null},V.getBorderColor=function(e,t,i,r){var a=H.getNestedDataItem(e,t,i,r);if(a&&a.borderColor)return a.borderColor;var s=H.getDataItem(e,t,i);if(s&&s.borderColor)return s.borderColor;var n=H.getSeriesItem(e,t);if(n&&n.borderColor)return n.borderColor;var o=e.getOptions().styleDefaults;return"auto"!=o.borderColor?o.borderColor:null},V.getBorderWidth=function(e,t,i,r){var a=H.getNestedDataItem(e,t,i,r);if(a&&null!=a.borderWidth)return a.borderWidth;var s=H.getDataItem(e,t,i);if(s&&null!=s.borderWidth)return s.borderWidth;var n=H.getSeriesItem(e,t);if(n&&null!=n.borderWidth)return n.borderWidth;var o=e.getOptions().styleDefaults;return"auto"!=o.borderWidth?o.borderWidth:z.isScatterBubble(e)||z.isLineArea(e)?1.25:1},V.getMarkerColor=function(e,t,i,r){if(!V.isMarkerDisplayed(e,t,i,r))return V.getColor(e,t,i);var a=H.getNestedDataItem(e,t,i,r);if(a&&a.color)return a.color;var s=H.getDataItem(e,t,i);if(s&&s.color)return s.color;var n=H.getSeriesItem(e,t);if(n&&n.markerColor)return n.markerColor;var o=e.getOptions().styleDefaults.markerColor;return o||V.getColor(e,t,i)},V.getMarkerShape=function(e,t,i,r){var a=e.getOptions(),s=a.styleDefaults.markerShape,n=H.getSeriesItem(e,t);n&&n.markerShape&&(s=n.markerShape);var o=H.getDataItem(e,t,i);o&&o.markerShape&&(s=o.markerShape);var l=H.getNestedDataItem(e,t,i,r);if(l&&l.markerShape&&(s=l.markerShape),"auto"==s)if(z.isBubble(e)||"boxPlot"==V.getSeriesType(e,t)||V.isRangeSeries(e,t))s="circle";else{var h=H.getSeriesStyleIndex(e,t),u=a.styleDefaults.shapes;s=u[h%u.length]}return s},V.getMarkerSize=function(e,t,i,r){var a,s=H.getNestedDataItem(e,t,i,r);if(s&&null!=s.markerSize)a=Number(s.markerSize);else{var n=H.getDataItem(e,t,i);if(n&&null!=n.markerSize)a=Number(n.markerSize);else{var o=H.getSeriesItem(e,t);a=o&&null!=o.markerSize?Number(o.markerSize):Number(e.getOptions().styleDefaults.markerSize)}}return z.isOverview(e)&&(a=Math.ceil(.6*a)),a},V.isMarkerDisplayed=function(e,t,i,r){var a,s=H.getNestedDataItem(e,t,i,r);if(s&&null!=s.markerDisplayed)a=s.markerDisplayed;else{var n=H.getDataItem(e,t,i);if(n&&null!=n.markerDisplayed)a=n.markerDisplayed;else{var o=H.getSeriesItem(e,t);a=o&&null!=o.markerDisplayed?o.markerDisplayed:e.getOptions().styleDefaults.markerDisplayed}}return"on"==a||"off"!=a&&(z.isScatterBubble(e)||"boxPlot"==V.getSeriesType(e,t)||"none"==V.getLineType(e,t))},V.getImageSource=function(e,t,i,r,a){var s=H.getNestedDataItem(e,t,i,r);if(s&&s[a])return s[a];var n=H.getDataItem(e,t,i);if(n&&n[a])return n[a];var o=H.getSeriesItem(e,t);return o&&o[a]?o[a]:void 0},V.getLineWidth=function(e,t){var i,r=H.getSeriesItem(e,t),a=e.getOptions();return i=r&&r.lineWidth?r.lineWidth:a.styleDefaults.lineWidth?a.styleDefaults.lineWidth:"lineWithArea"==V.getSeriesType(e,t)?2:3,z.isOverview(e)&&(i=Math.ceil(.6*i)),i},V.getLineStyle=function(e,t){var i=H.getSeriesItem(e,t);return i&&i.lineStyle?i.lineStyle:e.getOptions().styleDefaults.lineStyle},V.getLineType=function(e,t){var i,r=H.getSeriesItem(e,t);return"auto"==(i=r&&r.lineType?r.lineType:e.getOptions().styleDefaults.lineType)&&(i=z.isScatterBubble(e)?"none":"straight"),(z.isPolar(e)||z.isScatterBubble(e))&&("centeredSegmented"==i&&(i="segmented"),"centeredStepped"==i&&(i="stepped")),i},V.getBarSpacing=function(e){return e.getOptions().__sparkBarSpacing},V.getBarGapRatio=function(e){var t=e.getCache().getFromCache("barGapRatio");if(t)return t;if("string"==typeof(t=e.getOptions().styleDefaults.barGapRatio)&&"%"==t.slice(-1)&&(t=Number(t.slice(0,-1))/100),null!=t&&!isNaN(t))return t;var i=H.getStackCategories(e,"bar"),r=i.y.length,a=i.y2.length,s=z.isSplitDualY(e)?Math.max(r,a):r+a;return t=z.isPolar(e)?1==s?0:.25:1==s?.37+.26/H.getViewportGroupCount(e):.25,e.getCache().putToCache("barGapRatio",t),t},V.getMaxBarWidth=function(e){var t=e.getOptions().styleDefaults.maxBarWidth;return null==t||z.isPolar(e)?1/0:t},V.getBarWidth=function(e,t,i){e.getOptionsCache().getFromCache("hasConstantZValue")&&(t=0,i=0);var r=e.getCache().getFromCachedMap2D("barWidth",t,i);if(null!=r)return r;var a=H.getZValue(e,t,i,1)/e.getOptions()._averageGroupZ;return r=Math.min(a*V.getGroupWidth(e),V.getMaxBarWidth(e)),e.getCache().putToCachedMap2D("barWidth",t,i,r),r},V.getBarStackWidth=function(e,t,i,r){e.getOptionsCache().getFromCache("hasConstantZValue")&&(i=0);var a=r?"y2BarStackWidth":"yBarStackWidth",s=e.getCache().getFromCachedMap2D(a,t,i);if(null!=s)return s;var n=H.getBarCategoryZ(e,t,i,r)/e.getOptions()._averageGroupZ;return s=Math.min(n*V.getGroupWidth(e),V.getMaxBarWidth(e)),e.getCache().putToCachedMap2D(a,t,i,s),s},V.getBarCategoryOffsetMap=function(e,t){e.getOptionsCache().getFromCache("hasConstantZValue")&&(t=0);var i=e.getCache().getFromCachedMap("barCategoryOffsetMap",t);if(i)return i;var r,a=z.isStacked(e),s=H.getStackCategories(e,"bar"),n=N.isMixedFrequency(e),o=z.isSplitDualY(e),l={},h={},u=0,g=0;if(a){for(c=0;c<s.y.length;c++)r=V.getBarStackWidth(e,s.y[c],t,!1),n?l[s.y[c]]=-.5*r:(l[s.y[c]]=u,u+=r);for(o||(g=u),c=0;c<s.y2.length;c++)r=V.getBarStackWidth(e,s.y2[c],t,!0),n?h[s.y2[c]]=-.5*r:(h[s.y2[c]]=g,g+=r);o||(u=g)}else for(var d=H.getSeriesCount(e),c=0;c<d;c++){var p=V.getSeriesType(e,c);if(("bar"==p||"candlestick"==p||"boxPlot"==p)&&V.isSeriesRendered(e,c)){var _=H.isAssignedToY2(e,c),f=H.getStackCategory(e,c);r=V.getBarWidth(e,c,t),_?n?h[f]=-.5*r:(h[f]=g,g+=r):n?l[f]=-.5*r:(l[f]=u,u+=r)}}for(var f in l)l[f]-=o||a?u/2:(u+g)/2;for(var f in h)h[f]-=o||a?g/2:(u+g)/2-u;return i={y:l,y2:h},e.getCache().putToCachedMap("barCategoryOffsetMap",t,i),i},V.getDataItemGaps=function(e){var t=e.getOptionsCache().getFromCache("dataItemGaps");if(null!=t)return t;var i=e.getOptions();if(z.isFunnel(e)&&"on"==i.styleDefaults.funnelSliceGaps)t=1;else if(null!=i.styleDefaults.sliceGaps)t=i.styleDefaults.sliceGaps;else{var r=i.styleDefaults.dataItemGaps;"auto"==r&&(r="on"==i.styleDefaults.threeDEffect?"0%":"50%");var a=r&&r.indexOf?r.indexOf("%"):-1;t=a>=0?(r=r.substring(0,a))/100:0}return e.getOptionsCache().putToCache("dataItemGaps",t),t},V.isSelectable=function(e,t,i){var r=H.getSeriesItem(e,t);return(!r||"off"!=r._selectable)&&(e.isSelectionSupported()&&null!=t&&t>=0&&null!=i&&i>=0)},V.isSeriesRendered=function(t,i){var r=V.getHiddenCategories(t);return!(r.length>0&&e.ArrayUtils.hasAnyItem(r,H.getCategories(t,i)))},V.isDataItemRendered=function(t,i,r,a){var s,n=!isNaN(a)&&null!=a&&a>=0;if(!n&&void 0!==(s=t.getOptionsCache().getFromCachedMap2D("isDataItemRendered",i,r)))return s;if(s=!0,V.isSeriesRendered(t,i)){var o=V.getHiddenCategories(t);o.length>0&&((z.isPie(t)||z.isFunnel(t)||z.isPyramid(t))&&(r=0),e.ArrayUtils.hasAnyItem(o,H.getCategories(t,i,r))&&(s=!1),e.ArrayUtils.hasAnyItem(o,H.getCategories(t,i,r,a))&&(s=!1))}else s=!1;return n||t.getOptionsCache().putToCachedMap2D("isDataItemRendered",i,r,s),s},V.getAnimationOnDisplay=function(e){return e.getOptions().animationOnDisplay},V.getAnimationOnDataChange=function(e){return e.getOptions().animationOnDataChange},V.getAnimationDuration=function(t){return e.StyleUtils.getTimeMilliseconds(t.getOptions().styleDefaults.animationDuration)/1e3},V.getAnimationIndicators=function(e){return e.getOptions().styleDefaults.animationIndicators},V.getAnimationUpColor=function(e){return e.getOptions().styleDefaults.animationUpColor},V.getAnimationDownColor=function(e){return e.getOptions().styleDefaults.animationDownColor},V.getHiddenCategories=function(e){var t=e.getOptions();return t.hiddenCategories||(t.hiddenCategories=[]),t.hiddenCategories},V.getHighlightedCategories=function(e){var t=e.getOptions();return t.highlightedCategories||(t.highlightedCategories=[]),t.highlightedCategories},V.getSelectedInnerColor=function(e){return e.getOptions().styleDefaults.selectedInnerColor},V.getSelectedOuterColor=function(e){return e.getOptions().styleDefaults.selectedOuterColor},V.isSelectionHighlighted=function(e){var t=e.getOptions().styleDefaults.selectionEffect;return"highlight"==t||"highlightAndExplode"==t},V.isSelectionExploded=function(e){var t=e.getOptions().styleDefaults.selectionEffect;return"explode"==t||"highlightAndExplode"==t},V.getDataLabelStyle=function(t,i,r,a,s,n,o){var l,h=[];!s||"bar"!=V.getSeriesType(t,i)&&!z.isBubble(t)||"center"!=n&&"inBottom"!=n&&"inTop"!=n&&"inRight"!=n&&"inLeft"!=n?h.push(new e.CSSStyle("color: #333333;")):(l=null!=V.getPattern(t,i,r,a)?"#000000":e.ColorUtils.getContrastingTextColor(s),h.push(new e.CSSStyle("color: "+l+";"))),h.push(V._parseLowHighArray(t.getOptions().styleDefaults.dataLabelStyle,o));var u=H.getDataItem(t,i,r);u&&h.push(new e.CSSStyle(V._parseLowHighArray(u.labelStyle,o)));var g=H.getNestedDataItem(t,i,r,a);return g&&h.push(new e.CSSStyle(V._parseLowHighArray(g.labelStyle,o))),l&&e.Agent.isHighContrast()&&h.push(new e.CSSStyle("color: "+l+";")),e.CSSStyle.mergeStyles(h)},V.getDataLabelPosition=function(t,i,r,a,s,n){var o,l=H.getNestedDataItem(t,i,r,a),h=H.getDataItem(t,i,r);if(n)o="outsideBarEdge";else if((o=l&&l.labelPosition?l.labelPosition:h.labelPosition)||(o=t.getOptions().styleDefaults.dataLabelPosition),"none"==(o=V._parseLowHighArray(o,s)))return"none";var u=e.Agent.isRightToLeft(t.getCtx()),g=z.isHorizontal(t),d=z.isPolar(t);if(z.isFunnel(t)||z.isPyramid(t))return"center";if("bar"==V.getSeriesType(t,i)){if("center"==o||d)return"center";var c,p=z.isStacked(t);if("insideBarEdge"!=o){if(p&&!n)return"center";"outsideBarEdge"!=o&&(o="insideBarEdge")}if("insideBarEdge"==o&&!p){var _,f=t.getOptions().styleDefaults.dataLabelStyle,S=h.labelStyle?e.CSSStyle.mergeStyles([f,new e.CSSStyle(h.labelStyle)]):f;if(g){var C=H.getDataLabel(t,i,r,a,s);_=e.TextUtils.getTextStringWidth(t.getCtx(),C,S)}else _=e.TextUtils.getTextStringHeight(t.getCtx(),S);var m=H.getBarInfo(t,i,r);(m?Math.abs(m.baseCoord-m.yCoord):0)<=_&&(o="outsideBarEdge")}return c="low"==s?h.low<=h.high:"high"==s?h.high<h.low:H.getValue(t,i,r,a)<0,"outsideBarEdge"==o?g?!c&&!u||c&&u?"right":"left":c?"bottom":"top":g?!c&&!u||c&&u?"inRight":"inLeft":c?"inBottom":"inTop"}if("center"==o)return"center";if("belowMarker"==o)return"bottom";if("aboveMarker"==o)return"top";if("afterMarker"!=o&&"beforeMarker"!=o){if(z.isBubble(t))return"center";if("low"!=s||d)if("high"!=s||d)o="afterMarker";else{if(!g)return"top";o="afterMarker"}else{if(!g)return"bottom";o="beforeMarker"}}return!u&&"afterMarker"==o||u&&"beforeMarker"==o?"right":"left"},V._parseLowHighArray=function(e,t){return e instanceof Array?"high"==t?e[1]:e[0]:e},V.isOverviewRendered=function(e){var t=e.getOptions();return z.isOverviewSupported(e)&&"off"!=t.overview.rendered},V.getOverviewHeight=function(e){var t=e.getOptions().overview.height;return null==t&&(t=N.hasTimeAxis(e)?.25:.2),V.getSizeInPixels(t,e.getHeight())},V.getSizeInPixels=function(e,t){if("string"==typeof e){if("%"==e.slice(-1))return t*Number(e.slice(0,-1))/100;if("px"==e.slice(-2))return Number(e.slice(0,-2));e=Number(e)}return"number"==typeof e?e<=1?t*e:e:0},V.getBackgroundColor=function(e,t){var i=e.getOptions();return i.plotArea.backgroundColor?i.plotArea.backgroundColor:t?"#FFFFFF":null},V.getHoverBehaviorDelay=function(t){var i=t.getOptions().styleDefaults.hoverBehaviorDelay;return i?(i=e.StyleUtils.getTimeMilliseconds(i),z.isScatterBubble(t)||z.isLine(t)?.75*i:1.25*i):0},V.optimizeMarkerStroke=function(e){return z.isScatterBubble(e)||z.isBoxPlot(e)},V.getGroupWidth=function(e){var t=e.getCache().getFromCache("groupWidth");return null==t&&(t=e.xAxis.getInfo().getGroupWidth(),e.getCache().putToCache("groupWidth",t)),t},V.isStackLabelRendered=function(e){var t=e.getOptions();return!(!z.isStacked(e)||"on"!=t.stackLabel)},V.optimizeMarkerFill=function(e){return z.isLineArea(e)},V.getClassName=function(e,t,i){var r=H.getDataItem(e,t,i);if(r&&(r.className||r.svgClassName))return r.className||r.svgClassName;var a=H.getSeriesItem(e,t);return a&&(a.className||a.svgClassName)?a.className||a.svgClassName:null},V.getAreaClassName=function(e,t){var i=H.getSeriesItem(e,t);return i&&(i.areaClassName||i.areaSvgClassName)?i.areaClassName||i.areaSvgClassName:i&&(i.className||i.svgClassName)?i.className||i.svgClassName:null},V.getMarkerClassName=function(e,t,i,r){var a=H.getNestedDataItem(e,t,i,r);if(a&&(a.className||a.svgClassName))return a.className||a.svgClassName;var s=H.getDataItem(e,t,i);if(s&&(s.className||s.svgClassName))return s.className||s.svgClassName;var n=H.getSeriesItem(e,t);return n&&(n.markerClassName||n.markerSvgClassName)?n.markerClassName||n.markerSvgClassName:z.isScatterBubble(e)&&n&&(n.className||n.svgClassName)?n.className||n.svgClassName:null},V.getStyle=function(e,t,i){var r=H.getDataItem(e,t,i);if(r&&(r.style||r.svgStyle))return r.style||r.svgStyle;var a=H.getSeriesItem(e,t);return a&&(a.style||a.svgStyle)?a.style||a.svgStyle:null},V.getAreaStyle=function(e,t){var i=H.getSeriesItem(e,t);return i&&(i.areaStyle||i.areaSvgStyle)?i.areaStyle||i.areaSvgStyle:i&&(i.style||i.svgStyle)?i.style||i.svgStyle:null},V.getMarkerStyle=function(e,t,i,r){var a=H.getNestedDataItem(e,t,i,r);if(a&&(a.style||a.svgStyle))return a.style||a.svgStyle;var s=H.getDataItem(e,t,i);if(s&&(s.style||s.svgStyle))return s.style||s.svgStyle;var n=H.getSeriesItem(e,t);return n&&(n.markerStyle||n.markerSvgStyle)?n.markerStyle||n.markerSvgStyle:z.isScatterBubble(e)&&n&&(n.style||n.svgStyle)?n.style||n.svgStyle:null},V.getBoxPlotStyleOptions=function(t,i,r){var a=H.getDataItem(t,i,r),s=a&&a.boxPlot?a.boxPlot:{},n=H.getSeriesItem(t,i),o=n&&n.boxPlot?n.boxPlot:{},l=t.getOptions().styleDefaults.boxPlot,h=e.JsonUtils.merge(s,e.JsonUtils.merge(o,l)),u=V.getColor(t,i,r);h._color=u;var g=e.ColorUtils.getBrighter(u,.8);if(h.q2Color||(h.q2Color=g),h.q3Color||(h.q3Color=g),"pattern"==V.getSeriesEffect(t)){var d=V.getPattern(t,i,r);h._q2Pattern=d,h._q3Pattern=d}var c=V.getBorderColor(t,i,r);h.borderColor=c||u,h.borderWidth=V.getBorderWidth(t,i,r);var p=e.ColorUtils.getDarker(u,.1);return V._setBoxPlotDefaultLineColor(h,"whisker",p),V._setBoxPlotDefaultLineColor(h,"whiskerEnd",p),V._setBoxPlotDefaultLineColor(h,"median",p),h},V._setBoxPlotDefaultLineColor=function(t,i,r){var a=e.JsonUtils.merge(t[i+"Style"],t[i+"SvgStyle"]);t[i+"SvgStyle"]=a,t[i+"Style"]=null,a.stroke||t[i+"ClassName"]||t[i+"SvgClassName"]||(t[i+"SvgStyle"].stroke=r)};var j=new Object;e.Obj.createSubclass(j,e.Obj),j.createText=function(t,i,r,a,s,n,o,l){var h=new e.OutputText(i.getCtx(),r,s,n);return h.setCSSStyle(a),e.TextUtils.fitText(h,o,l,i)?(t.associate(h,new e.SimpleObjPeer(h.getUntruncatedTextString())),h):null},j.areTitlesRendered=function(e){var t=e.getOptions();return t.title.text||t.subtitle.text||t.footnote.text};var W=new Object;e.Obj.createSubclass(W,e.Obj),W.getDatatipColor=function(e,t,i,r){return z.isStock(e)?V.getColor(e,0,i):null!=r&&r>=0?V.getMarkerColor(e,t,i,r):V.getColor(e,t,i)},W.getDatatip=function(e,t,i,r,a){if(z.isSpark(e)||z.isOverview(e))return null;if(t<0||i<0)return null;var s=H.getDataItem(e,t,i),n=e.getOptions().tooltip,o=n?n.renderer:null;if(a&&o){var l=e.getCtx().getTooltipManager(W.isDataCursorEnabled(e)?v.TOOLTIP_ID:null),h=H.getDataContext(e,t,i,r);if(z.isPie(e)){var u=Z.getSliceBySeriesIndex(e,t);h.label=u.getSliceLabelString()}else h.label=H.getDataLabel(e,t,i,r);return l.getCustomTooltip(o,h)}if(s&&null!=s.shortDesc)return s.shortDesc;var g="";return z.isStock(e)?g+=W.getStockDatatip(e,0,i,a):(g=W._addSeriesDatatip(g,e,t,i,a),g=W._addGroupDatatip(g,e,t,i,a),g=W._addValueDatatip(g,e,t,i,r,a)),W._processDatatip(g,e,a)},W.getOtherSliceDatatip=function(t,i,r){var a=e.Bundle.getTranslatedString(e.Bundle.CHART_PREFIX,"LABEL_OTHER",null),s=t.getOptions().tooltip,n=s?s.renderer:null;if(r&&n){var o=Z.getSliceBySeriesIndex(t,null),l=H.getDataContext(t,null,0);return l.label=o.getSliceLabelString(),t.getCtx().getTooltipManager().getCustomTooltip(n,l)}var h="";return h=W._addDatatipRow(h,t,"series","SERIES",a,r),h=W._addGroupDatatip(h,t,0,0,r),h=W._addDatatipRow(h,t,"value","VALUE",i,r),W._processDatatip(h,t,r)},W._processDatatip=function(t,i,r){return""===t?null:r?e.HtmlTooltipManager.createStartTag("table",i.getOptions().styleDefaults._tooltipStyle)+t+"</table>":t},W.getRefObjTooltip=function(e,t,i,r){var a=e.getOptions().tooltip,s=a?a.renderer:null;if(s&&null!=t.id){var n=e.getCtx().getTooltipManager(W.isDataCursorEnabled(e)?v.TOOLTIP_ID:null),o={id:U.getId(t),label:t.text,data:e.getRawOptions()[i].referenceObjects[r],value:t.value,low:U.getLowValue(t),high:U.getHighValue(t),color:U.getColor(t)};return n.getCustomTooltip(s,o)}return t.shortDesc},W.getStockDatatip=function(e,t,i,r){var a=H.getDataItem(e,t,i),s=W._addGroupDatatip("",e,t,i,r);return a&&(s=W._addDatatipRow(s,e,"open","OPEN",a.open,r),s=W._addDatatipRow(s,e,"close","CLOSE",a.close,r),s=W._addDatatipRow(s,e,"high","HIGH",a.high,r),s=W._addDatatipRow(s,e,"low","LOW",a.low,r),s=W._addDatatipRow(s,e,"volume","VOLUME",a.volume,r)),s},W._addSeriesDatatip=function(e,t,i,r,a){var s=H.getSeriesLabel(t,i);return W._addDatatipRow(e,t,"series","SERIES",s,a)},W._addGroupDatatip=function(t,i,r,a,s){var n;if(N.hasTimeAxis(i)){var o=W.getValueFormat(i,"group"),l=H.getXValue(i,r,a);null==(n=W.formatDateValue(o,new Date(l)))&&(n=i.xAxis.getInfo().formatLabel(l))}else n=H.getGroupLabel(i,a);var h=H.getNumLevels(i),u="GROUP";if(1!=h&&e.ArrayUtils.isArray(n))for(var g=h-1;g>=0;g--)t=W._addDatatipRow(t,i,"group",u,n[g],s,g),n[g]&&(u=null);else t=W._addDatatipRow(t,i,"group",u,n,s);return t},W._addValueDatatip=function(e,t,i,r,a,s){var n=H.getValue(t,i,r,a),o=H.getXValue(t,i,r),l=H.getZValue(t,i,r),h=H.getLowValue(t,i,r),u=H.getHighValue(t,i,r),g=null!=a&&a>=0;if(z.isScatterBubble(t))e=W._addDatatipRow(e,t,"x","X",o,s),e=W._addDatatipRow(e,t,"y","Y",n,s),z.isBubble(t)&&(e=W._addDatatipRow(e,t,"z","Z",l,s));else if(z.isPie(t)||z.isPyramid(t))e=W._addDatatipRow(e,t,"value","VALUE",n,s);else if(z.isFunnel(t)){e=W._addDatatipRow(e,t,"value","VALUE",n,s);var d=H.getTargetValue(t,i);null!=d&&(e=W._addDatatipRow(e,t,"targetValue","TARGET_VALUE",d,s))}else if("boxPlot"!=V.getSeriesType(t,i)||g){if(z.isBLAC(t)){var c=H.isAssignedToY2(t,i)?"y2":"y";null==h&&null==u||g?null==l||g?e=W._addDatatipRow(e,t,c,"VALUE",n,s):(e=W._addDatatipRow(e,t,c,"Y",n,s),e=W._addDatatipRow(e,t,"z","Z",l,s)):(e=W._addDatatipRow(e,t,"high","HIGH",u,s),e=W._addDatatipRow(e,t,"low","LOW",h,s),null!=l&&(e=W._addDatatipRow(e,t,"z","Z",l,s)))}}else{var p=H.getDataItem(t,i,r);e=W._addDatatipRow(e,t,"high","HIGH",u,s),e=W._addDatatipRow(e,t,"q3","Q3",p.q3,s),e=W._addDatatipRow(e,t,"q2","Q2",p.q2,s),e=W._addDatatipRow(e,t,"q1","Q1",p.q1,s),e=W._addDatatipRow(e,t,"low","LOW",h,s),null!=l&&(e=W._addDatatipRow(e,t,"z","Z",l,s))}return e},W._addDatatipRow=function(t,i,r,a,s,n,o){if(null==s||""===s)return t;var l,h=i.getOptions().styleDefaults,u=W.getValueFormat(i,r),g=u.tooltipDisplay;if(g&&"auto"!=g||"group"==r&&(z.isPie(i)||z.isFunnel(i))&&(g="off"),"off"==g)return t;if("string"==typeof u.tooltipLabel?l=u.tooltipLabel:e.ArrayUtils.isArray(u.tooltipLabel)&&(l=u.tooltipLabel[o||0]),null==l&&(l=null==a?"":"GROUP"==a&&N.hasTimeAxis(i)?e.Bundle.getTranslation(i.getOptions(),"labelDate",e.Bundle.CHART_PREFIX,"LABEL_GROUP"):e.Bundle.getTranslatedString(e.Bundle.CHART_PREFIX,"LABEL_"+a,"")),"series"!=r&&"group"!=r&&(s=W.formatValue(i.getCtx(),u,s)),n){var d=e.Agent.isRightToLeft(i.getCtx());return h.tooltipLabelStyle.setStyle(e.CSSStyle.TEXT_ALIGN,d?"left":"right"),h.tooltipValueStyle.setStyle(e.CSSStyle.TEXT_ALIGN,d?"right":"left"),t+"<tr>"+e.HtmlTooltipManager.createStartTag("td",h.tooltipLabelStyle)+l+"</td>"+e.HtmlTooltipManager.createStartTag("td",h.tooltipValueStyle)+s+"</td></tr>"}return t.length>0&&(t+="<br>"),t+e.Bundle.getTranslatedString(e.Bundle.UTIL_PREFIX,"COLON_SEP_LIST",[l,s])},W.getValueFormat=function(e,t){var i=e.getOptions().valueFormats;if(!i)return{};if(i instanceof Array){for(var r={},a=0;a<i.length;a++){var s=i[a];r[s.type]=s}e.getOptions().valueFormats=r,i=r}return i[t]?i[t]:"group"==t&&N.hasTimeAxis(e)?W.getValueFormat(e,"x"):"y"!=t&&"y2"!=t&&"min"!=t&&"max"!=t||!z.isBLAC(e)?{}:W.getValueFormat(e,"value")},W.formatValue=function(t,i,r,a,s,n){var o,l="auto",h="on";i.scaling&&(l=i.scaling),i.autoPrecision&&(h=i.autoPrecision),i.converter&&(o=i.converter),a=null!=a?a:r,s=null!=s?s:r,n=null!=n?n:0;var u=new e.LinearScaleAxisValueFormatter(t,a,s,n,l,h);return o&&(o.getAsString||o.format)?u.format(r,o):u.format(r)},W.formatDateValue=function(e,t){var i=e.converter;return i?i.getAsString?i.getAsString(t):i.format?i.format(t):null:null},W.isDataCursorEnabled=function(t){if(z.isPie(t)||z.isFunnel(t)||z.isPolar(t)||z.isPyramid(t))return!1;var i=t.getOptions();return"on"==i.dataCursor||"off"!=i.dataCursor&&(e.Agent.isTouchDevice()&&z.isLineArea(t))},W.getDataCursorBehavior=function(e){var t=e.getOptions().dataCursorBehavior;return"snap"==t?v.BEHAVIOR_SNAP:"smooth"==t?v.BEHAVIOR_SMOOTH:z.isLineArea(e)?v.BEHAVIOR_SMOOTH:v.BEHAVIOR_SNAP};var z=new Object;e.Obj.createSubclass(z,e.Obj),z._SUPPORTED_TYPES=["bar","line","area","lineWithArea","combo","pie","bubble","scatter","funnel","pyramid","stock","boxPlot"],z.isValidType=function(t){return e.ArrayUtils.getIndex(z._SUPPORTED_TYPES,t.getType())>=0},z.isSpark=function(e){return e.getOptions().__spark},z.isOverview=function(e){return e.getOptions()._isOverview},z.isVertical=function(e){return!z.isHorizontal(e)&&!z.isPolar(e)},z.isHorizontal=function(e){return"horizontal"==e.getOptions().orientation&&!z.isPolar(e)&&!z.isStock(e)&&(z.isBLAC(e)||z.isFunnel(e))},z.isPolar=function(e){return"polar"==e.getOptions().coordinateSystem&&!z.isStock(e)&&!z.isBoxPlot(e)},z.isStacked=function(e){return!("on"!=e.getOptions().stack||N.isMixedFrequency(e)||H.getSeriesCount(e)<2)&&z.isBLAC(e)},z.isCombo=function(e){return"combo"==e.getType()},z.isBar=function(e){return"bar"==e.getType()},z.isLine=function(e){return"line"==e.getType()},z.isLineWithArea=function(e){return"lineWithArea"==e.getType()},z.isArea=function(e){return"area"==e.getType()},z.isStock=function(e){return"stock"==e.getType()},z.isBoxPlot=function(e){return"boxPlot"==e.getType()},z.isScatter=function(e){return"scatter"==e.getType()},z.isBubble=function(e){return"bubble"==e.getType()},z.isPie=function(e){return"pie"==e.getType()},z.isFunnel=function(e){return"funnel"==e.getType()},z.isPyramid=function(e){return"pyramid"==e.getType()},z.isDualY=function(e){return!(!z.hasAxes(e)||z.isScatterBubble(e)||z.isPolar(e))},z.isSplitDualY=function(e){return!(!z.isStock(e)||!H.hasVolumeSeries(e)||z.isOverview(e))||"on"==e.getOptions().splitDualY&&z.hasY2Data(e)&&!z.hasY2DataOnly(e)},z.isBLAC=function(e){var t=e.getType();return"bar"==t||"line"==t||"area"==t||"lineWithArea"==t||"combo"==t||"stock"==t||"boxPlot"==t},z.isScatterBubble=function(e){var t=e.getType();return"scatter"==t||"bubble"==t},z.isLineArea=function(e){var t=e.getType();return"line"==t||"area"==t||"lineWithArea"==t},z.isScrollSupported=function(e){return!(z.isPie(e)||z.isFunnel(e)||z.isPolar(e)||z.isPyramid(e))},z.isOverviewSupported=function(e){return z.isBLAC(e)&&z.isVertical(e)},z.isHorizScrollbarSupported=function(e){var t=G.getZoomDirection(e);return!z.isPolar(e)&&(z.isBLAC(e)&&z.isVertical(e)||z.isScatterBubble(e)&&"y"!=t)},z.isVertScrollbarSupported=function(e){var t=G.getZoomDirection(e);return!z.isPolar(e)&&(z.isBLAC(e)&&z.isHorizontal(e)||z.isScatterBubble(e)&&"x"!=t)},z.hasAxes=function(e){return!("pie"==e.getType()||"funnel"==e.getType()||"pyramid"==e.getType())},z.hasY2DataOnly=function(e){return!!z.isDualY(e)&&H.getY2SeriesCount(e,null,!0)==H.getSeriesCount(e)},z.hasY2Data=function(e,t){return!!z.isDualY(e)&&H.getY2SeriesCount(e,null,!0)>0},z.hasY2BarData=function(e){return z.hasY2Data(e,"bar")},z.hasBarSeries=function(e){return z._hasSeriesType(e,"bar")},z.hasLineSeries=function(e){return z._hasSeriesType(e,"line")},z.hasAreaSeries=function(e){return z._hasSeriesType(e,"area")},z.hasLineWithAreaSeries=function(e){return z._hasSeriesType(e,"lineWithArea")},z.hasCandlestickSeries=function(e){return z._hasSeriesType(e,"candlestick")},z.hasBoxPlotSeries=function(e){return z._hasSeriesType(e,"boxPlot")},z._hasSeriesType=function(e,t){if(z.isBLAC(e))for(var i=H.getSeriesCount(e),r=0;r<i;r++)if(V.isSeriesRendered(e,r)&&V.getSeriesType(e,r)==t)return!0;return!1},z.hasCenteredSeries=function(e){if(!z.isBLAC(e))return!1;for(var t=H.getSeriesCount(e),i=0;i<t;i++)if(V.isSeriesRendered(e,i)&&"bar"!=V.getSeriesType(e,i)){var r=V.getLineType(e,i);if("centeredSegmented"==r||"centeredStepped"==r)return!0}return!1},z.hasUncenteredSeries=function(e){if(!z.isBLAC(e))return!1;for(var t=H.getSeriesCount(e),i=0;i<t;i++)if(V.isSeriesRendered(e,i)&&"bar"!=V.getSeriesType(e,i)){var r=V.getLineType(e,i);if("segmented"==r||"stepped"==r)return!0}return!1},z.isStandalonePlotArea=function(e){var t=e.getOptions();return!j.areTitlesRendered(e)&&("off"==t.legend.rendered&&(!N.isAxisRendered(e,"x")&&(!N.isAxisRendered(e,"y")&&!N.isAxisRendered(e,"y2"))))},z.isStandaloneXAxis=function(e){var t=e.getOptions();return!j.areTitlesRendered(e)&&("off"==t.legend.rendered&&("off"==t.plotArea.rendered&&(!N.isAxisRendered(e,"y")&&!N.isAxisRendered(e,"y2"))))},z.isStandaloneYAxis=function(e){var t=e.getOptions();return!j.areTitlesRendered(e)&&("off"==t.legend.rendered&&(!N.isAxisRendered(e,"x")&&("off"==t.plotArea.rendered&&!N.isAxisRendered(e,"y2"))))},z.isStandaloneY2Axis=function(e){var t=e.getOptions();return!j.areTitlesRendered(e)&&("off"==t.legend.rendered&&(!N.isAxisRendered(e,"x")&&(!N.isAxisRendered(e,"y")&&"off"==t.plotArea.rendered)))};var X=new Object;e.Obj.createSubclass(X,e.Obj),X._MIN_BUBBLE_SIZE=6,X._MAX_BUBBLE_SIZE_RATIO=.5,X.calcBubbleSizes=function(t,i){for(var r,a,s=H.getMinMaxValue(t,"z"),n=s.min,o=s.max,l=X._MIN_BUBBLE_SIZE,h=X._MAX_BUBBLE_SIZE_RATIO*Math.min(i.w,i.h),u=H.getSeriesCount(t),g="withoutRescale"==G.getHideAndShowBehavior(t),d=0;d<u;d++)if(g||V.isSeriesRendered(t,d))for(var c=H.getSeriesItem(t,d),p=c.items?c.items.length:0,_=0;_<p;_++){var f=c.items[_];if(f){var S=e.LayoutUtils.getBubbleSize(f.z,n,o,l,h);f.markerSize=S}}z.isPolar(t)?(r=1/0,a=t.getRadius()):(r=i.w-2.4*N.getTickLabelHeight(t,"y"),a=i.h-1.6*N.getTickLabelHeight(t,"x")),r-=.5*h,a-=.5*h;var C=t.getCache(),m=X._getAxisValueRange(t,"x");C.putToCache("_xAxisBubbleRatio",m/r);var y=X._getAxisValueRange(t,"y");C.putToCache("_yAxisBubbleRatio",y/a)},X.getBubbleAxisRadius=function(e,t,i){if(!i)return 0;var r="x"==t?"_xAxisBubbleRatio":"_yAxisBubbleRatio";return i/2*e.getCache().getFromCache(r)},X._getAxisValueRange=function(t,i){var r=t.getOptions()[i+"Axis"],a=N.isLog(t,i),s=!a&&"zero"==N.getBaselineScaling(t,i),n=H.getMinMaxValue(t,i,!0),o=r.min;null==o&&(o=s?Math.min(0,n.min):n.min);var l=r.max;return null==l&&(l=s?Math.max(0,n.max):n.max),a&&l>0&&o>0?l==o?6:e.Math.log10(l/o):l==o?60:l-o},X.sortMarkers=function(e){e.sort(X._compareSize)},X.sortMarkerInfos=function(e){e.sort(X._compareInfoSize)},X._compareSize=function(e,t){return t.getSize()-e.getSize()},X._compareInfoSize=function(e,t){return t.size-e.size},X.checkPixelMap=function(e,t,i,r){var a=r/2,s=Math.max(Math.floor(t-a),0),n=Math.max(Math.floor(i-a),0),o=Math.max(Math.ceil(t+a),0),l=Math.max(Math.ceil(i+a),0);return e.isObscured(s,n,o,l)},X.updatePixelMap=function(e,t,i,r,a){var s=.4*r,n=Math.max(Math.round(t-s),0),o=Math.max(Math.round(t+s),0),l=Math.max(Math.round(i-s),0),h=Math.max(Math.round(i+s),0);e.obscure(n,l,o,h,a)};var Z=new Object;e.Obj.createSubclass(Z,e.Obj),Z.OTHER_SLICE_SERIES_ID="_dvtOther",Z.getSliceId=function(e,t){var i=H.getDataItem(e,t,0),r=i?i.id:null,a=H.getSeries(e,t),s=H.getGroup(e,0);return new n(r,a,s,e.getCtx())},Z.getOtherSliceId=function(e){var t=H.getGroup(e,0);return new n(null,Z.OTHER_SLICE_SERIES_ID,t,e.getCtx())},Z.getRenderedSeriesIndices=function(e){return Z._getSeriesIndicesArrays(e).rendered},Z.hasOtherSeries=function(e){return Z._getSeriesIndicesArrays(e).other.length>0},Z.getOtherValue=function(e){for(var t=Z._getSeriesIndicesArrays(e).other,i=0,r=0;r<t.length;r++){var a=t[r];if(V.isSeriesRendered(e,a)){var s=H.getValue(e,a,0);s>0&&(i+=s)}}return i},Z.getOtherSliceIds=function(e){for(var t=Z._getSeriesIndicesArrays(e).other,i=[],r=0;r<t.length;r++){var a=t[r];i.push(Z.getSliceId(e,a))}return i},Z.isOtherSliceSelected=function(e,t){for(var i=Z.getOtherSliceIds(e),r=0;r<i.length;r++){for(var a=i[r],s=!1,n=0;n<t.length;n++)if(t[n].id&&a.getId()===t[n].id||a.getSeries()===t[n].series&&a.getGroup()===t[n].group){s=!0;break}if(!s)return!1}return!0},Z._getSeriesIndicesArrays=function(e){for(var t=[],i=[],r=H.getSeriesCount(e),a=e.getOptions(),s=a.otherThreshold*Z.getTotalValue(e),n=0;n<r;n++){var o=H.getValue(e,n,0);s>0&&o<s?i.push(n):t.push(n)}return"ascending"==a.sorting?t.sort(function(t,i){return H.getValue(e,t,0)-H.getValue(e,i,0)}):"on"!=a.sorting&&"descending"!=a.sorting||t.sort(function(t,i){return H.getValue(e,i,0)-H.getValue(e,t,0)}),{rendered:t,other:i}},Z.getTotalValue=function(e){for(var t=H.getSeriesCount(e),i=0,r=0;r<t;r++){var a=H.getValue(e,r,0);a>0&&(i+=a)}return i},Z.getSliceExplode=function(e,t){var i=H.getSeriesItem(e,t);return i&&i.pieSliceExplode?i.pieSliceExplode:0},Z.getOtherSliceShowPopupBehaviors=function(e){var t=Z.getOtherSliceIds(e);if(t&&t.length>=1){var i=t[0],r=H.getSeriesIndex(e,i.getSeries()),a=H.getDataItem(e,r,0)._id;return e.getShowPopupBehaviors(a)}},Z.getSliceBySeriesIndex=function(e,t){for(var i=e.pieChart.__getSlices(),r=0;r<i.length;r++)if(i[r].getSeriesIndex()==t)return i[r];return null};var K=function(){};e.Obj.createSubclass(K,e.Obj),K.TWOD="2D",K.THREED="3D",K.CRUST="CRUST",K.SIDE="SIDE",K.BORDER="BORDER",K.SURFACE_CRUST=0,K.SURFACE_LEFT=1,K.SURFACE_RIGHT=2,K.SURFACE_TOP=3,K.reflectAngleOverYAxis=function(t,i,r,a,s){var n=e.Math.degreesToRads(360-t);return{x:i+Math.cos(n)*a,y:r+Math.sin(n)*s}},K.getGradientColors=function(t,i,r){if(r&&r!=e.CSSStyle.SKIN_SKYROS){if(i==K.TWOD||i==K.THREED)return[e.ColorUtils.adjustHSL(t,0,-.04,-.05),e.ColorUtils.adjustHSL(t,0,-.09,.04)];if(i==K.CRUST)return[e.ColorUtils.adjustHSL(t,0,-.04,-.05),e.ColorUtils.adjustHSL(t,0,0,-.14)];if(i==K.SIDE)return[e.ColorUtils.adjustHSL(t,0,-.1,.06),e.ColorUtils.adjustHSL(t,0,-.04,-.05)]}else{if(i==K.TWOD){var a=[];return a[0]=e.ColorUtils.getRGB(e.ColorUtils.getBrighter(t,.1)),a[1]=a[0],a[2]=e.ColorUtils.getRGB(e.ColorUtils.getDarker(t,.1)),a}if(i==K.BORDER)return["#FFFFFF","#000000","#000000"];var s=e.ColorUtils.getRGB(e.ColorUtils.getDarker(t,.12)),n=e.ColorUtils.getRGB(e.ColorUtils.getBrighter(t,.05)),o=e.ColorUtils.getRGB(e.ColorUtils.getBrighter(t,.15)),l=e.ColorUtils.getRGB(e.ColorUtils.getBrighter(t,.35));if(i==K.CRUST)return[s,o,l,s];if("SIDE"==i)return[s,l];if("3D"==i)return[l,o,s,n,l]}},K.getGradientAlphas=function(e,t){var i=null==e||isNaN(e)||0==e?1:e;return t==K.TWOD?[i,i,i]:t==K.BORDER?[i/1.59375,i/5.3125,i/(255/96)]:t==K.THREED?[i,i,i,i,i]:t==K.CRUST?[i,i,i,i]:t==K.SIDE?[i,i]:void 0},K.getGradientRatios=function(t,i){return i&&i!=e.CSSStyle.SKIN_SKYROS?[0,1]:t==K.TWOD?[.2,.5,1]:t==K.BORDER?[0,.5,1]:t==K.THREED?[0,.29,.55,.84,1]:t==K.CRUST?[0,.43,.91,1]:t==K.SIDE?[0,1]:void 0},K.createTopSurface=function(t,i){var r=t.getPieChart(),a=r.getCtx(),s=t.getCenter(),n=t.getInnerRadius(),o=r.is3D()||t.getSliceGaps()>Math.sin(e.Math.degreesToRads(t.getAngleExtent()))*t._radiusX+1?null:t.getSliceGaps(),l=new h(a,s.x,s.y,t._radiusX,t._radiusY,t.getAngleStart(),t.getAngleExtent(),o,n),u=V.getSelectedInnerColor(r.chart),g=V.getSelectedOuterColor(r.chart),d=new e.SolidStroke(t.getStrokeColor(),null,t.getBorderWidth()),c=t.getSeriesIndex(),p=V.getClassName(r.chart,c,0),_=V.getStyle(r.chart,c,0);l.setStyleProperties(i,d,t.getFillColor(),u,g,p,_);var f=[l];if(!t.getStrokeColor()&&r.getSkin()==e.CSSStyle.SKIN_SKYROS&&r.is3D()&&t.getDepth()>0&&"gradient"==V.getSeriesEffect(r.chart)&&(t.getAngleStart()>=180||t.getAngleStart()+t.getAngleExtent()>=180||360==t.getAngleExtent())){var S=K._createGradientPieBorder(t,i);S.setTranslate(t.__getExplodeOffsetX(),t.__getExplodeOffsetY()),f.push(S)}return K.associate(t,f),f},K.associate=function(e,t){if(t)for(var i=0;i<t.length;i++)e.getPieChart().chart.getEventManager().associate(t[i],e)},K._createGradientPieBorder=function(t,i){var r=K.BORDER,a=K.getGradientColors(null,r),s=K.getGradientAlphas(null,r),n=K.getGradientRatios(r),o=i.getBounds(),l=new e.LinearGradientStroke(120,a,s,n,o);l.setWidth(1);var h=t.getAngleStart(),u=h<180?180-h:0,g=u>0?180:h,d=t.getAngleExtent()-u;g+d>360&&(d=360-g);var c=t.getPieChart(),p=t.getCenter(),_=new e.Arc(c.getCtx(),p.x,p.y,c.getRadiusX(),c.getRadiusY(),g,d,e.Arc.OPEN);return _.setStroke(l),_},K.createLateralSurface=function(t,i,r){if(0==t.getAngleExtent())return[];var a=[];if(e.ColorUtils.getAlpha(t.getFillColor())>0)if(i==K.SURFACE_LEFT||i==K.SURFACE_RIGHT)a.push(K._generateLateralShape(t,i,null,r));else if(i==K.SURFACE_CRUST)for(var s=K._createCrustPathCommands(t),n=s.length,o=0;o<n;o++)a.push(K._generateLateralShape(t,i,s[o],r));return K.associate(t,a),a},K.generateLateralGradientFill=function(t,i){var r=t.getPieChart(),a=r.getSkin(),s=i==K.CRUST?t.getDepth():0,n=a==e.CSSStyle.SKIN_SKYROS?0:270,o=K.getGradientColors(e.ColorUtils.getRGB(t.getFillColor()),i,a),l=K.getGradientAlphas(e.ColorUtils.getAlpha(t.getFillColor()),i),h=K.getGradientRatios(i,a),u=null;return a==e.CSSStyle.SKIN_SKYROS&&(u=[Math.floor(t.getCenter().x-r.getRadiusX()),Math.floor(t.getCenter().y-r.getRadiusY())+s,Math.ceil(2*r.getRadiusX()),Math.ceil(2*r.getRadiusY())]),new e.LinearGradientFill(n,o,l,h,u)},K._generateLateralShape=function(t,i,r,a){var s=t.getPieChart().getCtx();if(i==K.SURFACE_LEFT||i==K.SURFACE_RIGHT){for(var n=t.getAngleStart(),o=t.getAngleExtent(),l=t.getCenter().x,h=t.getCenter().y,u=t._radiusX,g=t._radiusY,d=t.getDepth(),c=i==K.SURFACE_LEFT?K.reflectAngleOverYAxis(n+o,l,h,u,g):K.reflectAngleOverYAxis(n,l,h,u,g),p=K._generateInnerPoints(l,h,c.x,c.y,d),_=[],f=0;f<p.length;f++)_.push(p[f].x,p[f].y);var S=new e.Polygon(s,_);return S.setFill(a),t.getStrokeColor()&&S.setSolidStroke(t.getStrokeColor()),S}if(r){var C=new e.Path(s,null);return C.setCmds(r),C.setTranslate(t.__getExplodeOffsetX(),t.__getExplodeOffsetY()),C.setFill(a),t.getStrokeColor()&&C.setSolidStroke(t.getStrokeColor()),C}return null},K._createCrustPathCommands=function(e){var t=e.getAngleStart(),i=e.getAngleExtent(),r=t+i,a=e.getCenter().x,s=e.getCenter().y,n=e._radiusX,o=e._radiusY,l=e.getDepth(),h=[];return t<180&&r>360?(h.push(K._makeOuterPath(a,s,n,o,l,t,180-t)),h.push(K._makeOuterPath(a,s,n,o,l,360,r-360)),h.push(K._makeOuterPath(a,s,n,o,l,180,180))):r>360?(h.push(K._makeOuterPath(a,s,n,o,l,t,360-t)),h.push(K._makeOuterPath(a,s,n,o,l,360,r-360))):t<180&&r>180?(h.push(K._makeOuterPath(a,s,n,o,l,t,180-t)),h.push(K._makeOuterPath(a,s,n,o,l,180,r-180))):h.push(K._makeOuterPath(a,s,n,o,l,t,i)),h},K._makeOuterPath=function(t,i,r,a,s,n,o){var l=e.Math.degreesToRads(o),h=-(e.Math.degreesToRads(n)+l),u=K.reflectAngleOverYAxis(n,t,i,r,a),g=t+Math.cos(h)*r,d=i+Math.sin(h)*a,c=e.PathUtils.moveTo(u.x,u.y);return c+=e.PathUtils.arcTo(r,a,l,0,g,d),c+=e.PathUtils.lineTo(g,d+s),c+=e.PathUtils.arcTo(r,a,l,1,u.x,u.y+s),c+=e.PathUtils.lineTo(u.x,u.y)},K._generateInnerPoints=function(e,t,i,r,a){var s=[];return s.push({x:e,y:t}),s.push({x:i,y:r}),s.push({x:i,y:r+a}),s.push({x:e,y:t+a}),s};var q=function(){this._init()};e.Obj.createSubclass(q,e.Obj),q.prototype._init=function(){this._sliceLabel=null,this._slice=null,this._angle=-1,this._position=-1,this._width=-1,this._height=-1,this._x=-1,this._y=-1,this._initialNumLines=-1,this._hasFeeler=!1,this._maxY=-1,this._minY=-1},q.prototype.getAngle=function(){return this._angle},q.prototype.setAngle=function(e){this._angle=e},q.prototype.getHeight=function(){return this._height},q.prototype.setHeight=function(e){this._height=e},q.prototype.getInitialNumLines=function(){return this._initialNumLines},q.prototype.setInitialNumLines=function(e){this._initialNumLines=e},q.prototype.getMaxY=function(){return this._maxY},q.prototype.setMaxY=function(e){this._maxY=e},q.prototype.getMinY=function(){return this._minY},q.prototype.setMinY=function(e){this._minY=e},q.prototype.boundY=function(e){return this._minY<=this._maxY&&(e=Math.max(e,this._minY),e=Math.min(e,this._maxY)),e},q.prototype.hasFeeler=function(){return this._hasFeeler},q.prototype.setHasFeeler=function(e){this._hasFeeler=e},q.prototype.getPosition=function(){return this._position},q.prototype.setPosition=function(e){this._position=e},q.prototype.getSlice=function(){return this._slice},q.prototype.setSlice=function(e){this._slice=e},q.prototype.getSliceLabel=function(){return this._sliceLabel},q.prototype.setSliceLabel=function(e){this._sliceLabel=e},q.prototype.getWidth=function(){return this._width},q.prototype.setWidth=function(e){this._width=e},q.prototype.getX=function(){return this._x},q.prototype.setX=function(e){this._x=e},q.prototype.getY=function(){return this._y},q.prototype.setY=function(e){this._y=e};var Q=function(){};e.Obj.createSubclass(Q,e.Obj),Q._MAX_LINES_PER_LABEL=3,Q._COLLISION_MARGIN=1,Q._LEFT_SIDE_LABELS=1,Q._RIGHT_SIDE_LABELS=2,Q._OUTSIDE_LABEL_DISTANCE=1.04,Q._FEELER_RAD_MINSIZE=.1,Q._FEELER_HORIZ_MINSIZE=.1,Q._LABEL_TO_FEELER_OFFSET=.5,Q._LABEL_TO_FEELER_DISTANCE=3,Q._NO_COLLISION=0,Q._HALF_COLLISION=1,Q._ALL_COLLISION=2,Q.layoutLabelsAndFeelers=function(e){var t=e.getLabelPosition();Q._layoutInsideLabels(e,"auto"==t),Q._layoutOutsideLabelsAndFeelers(e)},Q._layoutInsideLabels=function(t,i){for(var r=t.__getSlices(),a=0;a<r.length;a++){var s=r[a],n=t.getSeriesLabelPosition(s.getSeriesIndex());if("none"!=n&&"outsideSlice"!=n&&!Q._skipSliceLabel(t,s)){var o=s.getAngleStart()+s.getAngleExtent()/2,l=s.getInnerRadius(),h=s.getCenter(),u=0,g=0,d=Q._createLabel(s,!0);if(1==r.length)u=h.x,g=h.y;else{var c=Math.max(.45,.65-.45*l/Math.max(s.getRadiusY(),.001)),p=K.reflectAngleOverYAxis(o,h.x,h.y,l+(s.getRadiusX()-l)*c,l+(s.getRadiusY()-l)*c);u=p.x,g=p.y}d.setX(u),d.setY(g),d.alignMiddle(),d.alignCenter();for(var _=d.getDimensions(),f=u,S=u,C=g-_.h/2,m=g+_.h/2;s.contains(f,C)&&s.contains(f,m);)f--;for(;s.contains(S,C)&&s.contains(S,m);)S++;f=Math.ceil(f+3),S=Math.floor(S-3);var y=2*Math.min(u-f,S-u);if(y<_.w&&(d.setX((f+S)/2),y=S-f),i&&"center"!=n){d.getDimensions().w<y?s.setSliceLabel(d):s.setSliceLabel(null)}else{var v=t.getCtx().getStage(),A=Q._isTextLabel(t,s)?null:d.getTextString().length;e.TextUtils.fitText(d,y,_.h,v,A)&&(v.removeChild(d),s.setSliceLabel(d))}null!=s.getSliceLabel()&&s.setNoOutsideFeeler()}}},Q._layoutOutsideLabelsAndFeelers=function(e){var t,i,r=Q._generateInitialLayout(e);t=r[0],i=r[1];var a=Q._refineInitialLayout(e,t,Q._LEFT_SIDE_LABELS),s=Q._refineInitialLayout(e,i,Q._RIGHT_SIDE_LABELS);a==Q._HALF_COLLISION&&s!=Q._NO_COLLISION&&Q._columnLabels(e,t,!0,!0,!0),a!=Q._NO_COLLISION&&s==Q._HALF_COLLISION&&Q._columnLabels(e,i,!1,!0,!0),Q._setLabelsAndFeelers(e,t,Q._LEFT_SIDE_LABELS),Q._setLabelsAndFeelers(e,i,Q._RIGHT_SIDE_LABELS)},Q._createLabel=function(t,i){var r=t.getPieChart(),a=r.getCtx(),s=i?new e.OutputText(a):new e.MultilineText(a),n=r.getOptions().styleDefaults,o=[n.dataLabelStyle],l=H.getDataItem(r.chart,t.getSeriesIndex(),0);l&&o.push(new e.CSSStyle(l.labelStyle));var h=e.CSSStyle.mergeStyles(o),u=null!=h.getStyle("color");if(!i||u&&!e.Agent.isHighContrast())u||h.setStyle("color",n._defaultSliceLabelColor);else{var g=e.ColorUtils.getContrastingTextColor(t.getFillColor());h.setStyle("color",g)}s.setCSSStyle(h);var d=Q.generateSliceLabelString(t,n.sliceLabelType);return s.setTextString(d),t.setSliceLabelString(d),s},Q.createPieCenter=function(t){var i=t.getOptions(),r=t.getCtx(),a=Q.getPieCenterOptions(i),s=a.label,n=a.renderer,o=t.getLabelPosition(),l=i.tooltip,h=l?l.renderer:null,u=t.getCenter(),g=t.getInnerRadius();if(s||n){var d=t.getRadiusX(),c=(g=g>0?g:"outsideSlice"==o?.9*d:.5*d)*Math.sqrt(2);if(s){var p=new e.MultilineText(r),_=a.labelStyle;if(p.setCSSStyle(_),"number"==typeof s&&(s=W.formatValue(r,a,s,s,s,0)),p.setTextString(s),e.TextUtils.fitText(p,c,c,t)){var f=p.getDimensions();p.setY(u.y-f.h/2),p.setX(u.x),p.alignCenter(),h||t.chart.getEventManager().associate(p,new e.SimpleObjPeer(p.getTextString(),null,null,{type:"pieCenterLabel"})),t.addChild(p),t.setCenterLabel(p)}}if(h){var S=new e.Circle(r,u.x,u.y,g);S.setInvisibleFill(),t.addChild(S);var C=t.getCtx().getTooltipManager();t.chart.getEventManager().associate(S,new e.CustomDatatipPeer(C,h,"#4b4b4b",{component:i._widgetConstructor,label:s}))}if(n){var m={outerBounds:{x:u.x-g,y:u.y-g,width:2*g,height:2*g},innerBounds:{x:u.x-c/2,y:u.y-c/2,width:c,height:c},label:s,component:i._widgetConstructor},y=r.getContainer(),v=t.chart.pieCenterDiv;v&&y.removeChild(v);var A=n(m);if(!A)return;var x=r.createOverlayDiv();x.appendChild(A),t.chart.pieCenterDiv=x,y.appendChild(x);var b=r.getOverlayAttachedCallback();b&&b(x)}}},Q.generateSliceLabelString=function(e,t){var i,r=Q.getDefaultSliceLabelString(e,t),a=e.getPieChart().getOptions().dataLabel;if(a){var s=H.getDataContext(e._chart,e.getSeriesIndex(),0);if(s.label=r,"number"==typeof(i=a(s))){var n=W.getValueFormat(e.getPieChart().chart,"label");i=W.formatValue(e.getPieChart().getCtx(),n,i)}}return i||r},Q.getDefaultSliceLabelString=function(e,t){var i=e.getPieChart(),r=e.getCustomLabel(),a=W.getValueFormat(i.chart,"label");return null!=r?"number"==typeof r?W.formatValue(i.getCtx(),a,r):r:"percent"==t?Q.generateSlicePercentageString(e):"number"==t?W.formatValue(i.getCtx(),a,e.getValue()):"text"==t?e.getSeriesLabel():"textAndPercent"==t?e.getSeriesLabel()+", "+Q.generateSlicePercentageString(e):null},Q.generateSlicePercentageString=function(e){var t=e.getPieChart(),i=t.getTotalValue(),r=0==i?0:e.getValue()/i,a=r<.01?3:r<.1?2:r<1?1:0;2*t.getRadiusX()<150&&(a=Math.max(a-1,0));var s=t.getCtx().getNumberConverter({style:"percent",maximumFractionDigits:a,minimumFractionDigits:a}),n="";return s&&s.getAsString?n=s.getAsString(r):s&&s.format?n=s.format(r):(r*=100,n=W.formatValue(t.getCtx(),{},r,null,null,100==r?1:Math.pow(10,-1*a))+"%"),n},Q._refineInitialLayout=function(e,t,i){if(t&&t.length>0){for(var r,a=e.__getFrame().y,s=!1,n=!1,o=!1,l=0,h=!1,u=h,g=i==Q._LEFT_SIDE_LABELS,d=0;d<t.length;d++)u=h,(r=t[d]).getPosition()>90&&(h=!0),l=r.getY()+r.getHeight(),a-r.getY()>Q._COLLISION_MARGIN&&(h?h&&!u?n=!0:o=!0:s=!0),l>a&&(a=l);return s&&o||n?(Q._columnLabels(e,t,g,!0,!0),Q._ALL_COLLISION):s?(Q._columnLabels(e,t,g,!0,!1),Q._HALF_COLLISION):o?(Q._columnLabels(e,t,g,!1,!0),Q._HALF_COLLISION):Q._NO_COLLISION}},Q._setLabelsAndFeelers=function(t,i,r){if(!(null==i||i.length<=0)){var a,s,n,o,l,h=r==Q._LEFT_SIDE_LABELS,u=t.__getFrame(),g=1/0;for(a=0;a<i.length;a++)if(s=(o=i[a]).getSlice(),o.hasFeeler()){l=Q._calculateFeeler(o,s,h);var d=e.TextUtils.getTextStringHeight(t.getCtx(),o.getSliceLabel().getCSSStyle()),c=o.getWidth(),p=Q._isTextLabel(t,s)?Math.min(2*d,c):c;if(Q.getMaxLabelWidth(t,o.getX(),h)+l<p||0==o.getWidth()){o.setSliceLabel(null),s.setNoOutsideFeeler();continue}g=Math.min(g,l)}else s.setNoOutsideFeeler();for(a=0;a<i.length;a++)s=(o=i[a]).getSlice(),(n=o.getSliceLabel())&&(o.hasFeeler()&&(h?o.setX(o.getX()+g):o.setX(o.getX()-g),Q._calculateFeeler(o,s,h)),n.setY(o.getY()),n.setX(o.getX()),o.getY()<u.y||o.getY()+o.getHeight()>u.y+u.h?(s.setSliceLabel(null),s.setNoOutsideFeeler()):(Q._truncateSliceLabel(t,s,o,h),0==o.getWidth()||0==o.getHeight()?(s.setSliceLabel(null),s.setNoOutsideFeeler()):s.setSliceLabel(n)))}},Q._calculateFeeler=function(t,i,r){var a,s=t.getX(),n=t.getY()+t.getHeight()*Q._LABEL_TO_FEELER_OFFSET,o=Q._FEELER_HORIZ_MINSIZE*i.getRadiusX(),l={x:r?(s+=Q._LABEL_TO_FEELER_DISTANCE)+o:(s-=Q._LABEL_TO_FEELER_DISTANCE)-o,y:n},h={x:s,y:n},u=t.getAngle(),g=Q._adjustForDepth(u,i.getDepth());a=K.reflectAngleOverYAxis(u,i.getCenter().x,i.getCenter().y+g,i.getRadiusX(),i.getRadiusY());var d=e.Math.degreesToRads(t.getPosition()),c=Math.abs(Math.atan2(l.x-a.x,a.y-l.y)),p=(a.y-l.y)*Math.tan(d);return(d>Math.PI/2&&c>Math.PI/2&&c<d||d<Math.PI/2&&c<Math.PI/2&&c>d)&&(l.x=r?a.x-p:a.x+p),i.setOutsideFeelerPoints(a,l,h),Math.abs(h.x-l.x)-o},Q._adjustForDepth=function(e,t){var i=0;return e>189&&e<351&&(i=t),i},Q._getMiddleLabel=function(e){for(var t=91,i=-1,r=0;r<e.length;r++){var a=e[r].getPosition();Math.abs(a-90)<t&&(t=Math.abs(a-90),i=r)}return i},Q._setOptimalLabelPosition=function(t,i,r,a){i.setX(r);var s=t.getRadiusY()*(1+Q._FEELER_RAD_MINSIZE),n=e.Math.degreesToRads(i.getPosition()),o=s*Math.cos(n),l=Q._adjustForDepth(i.getAngle(),t.getDepth()),h=t.getCenter().y-o-i.getHeight()*Q._LABEL_TO_FEELER_OFFSET+l;i.setY(i.boundY(h))},Q._getRadFeelerAngle=function(e,t,i){var r=e.getSlice(),a=r.getCenter(),s=e.getAngle(),n=Q._adjustForDepth(s,r.getDepth()),o=K.reflectAngleOverYAxis(s,a.x,a.y+n,r.getRadiusX(),r.getRadiusY());return Math.atan2(Math.abs(t-o.x),o.y-i)},Q._columnLabels=function(t,i,r,a,s){var n,o,l,h=t.__getFrame(),u=h.y,g=h.y+h.h,d=0,c=t.getCenter().x,p=t.getRadiusX()*(1+Q._FEELER_RAD_MINSIZE+Q._FEELER_HORIZ_MINSIZE);for(l=r?(c-=p)+t.getRadiusX()*Q._FEELER_HORIZ_MINSIZE:(c+=p)-t.getRadiusX()*Q._FEELER_HORIZ_MINSIZE,n=0;n<i.length;n++)o=i[n],d=e.Math.degreesToRads(o.getPosition()),Q._getRadFeelerAngle(o,l,u)-d>.45*Math.PI||Q._skipSliceLabel(t,o.getSlice())?(i.splice(n,1),n--):(i[n].setMinY(u),u+=i[n].getHeight());for(n=i.length-1;n>=0;n--)o=i[n],(d=e.Math.degreesToRads(o.getPosition()))-Q._getRadFeelerAngle(o,l,g)>.45*Math.PI||Q._skipSliceLabel(t,o.getSlice())?i.splice(n,1):(g-=i[n].getHeight(),i[n].setMaxY(g));if(0!=i.length){var _=Q._getMiddleLabel(i),f=i[_];a&&!s&&f.getMinY()+f.getHeight()>t.getCenter().y&&(s=!0),s&&!a&&f.getMaxY()<t.getCenter().y&&(a=!0);var S=f.getPosition();(s&&a||S>90&&s||S<=90&&a)&&(Q._setOptimalLabelPosition(t,f,c,r),f.setHasFeeler(!0));var C,m,y=f.getY(),v=f.getY()+f.getHeight();if(a)for(n=_-1;n>=0;n--)m=(o=i[n]).getHeight(),Q._setOptimalLabelPosition(t,o,c,r),o.setHasFeeler(!0),(C=o.getY())+m<y?y=C:y-=m,o.setY(y);if(s)for(n=_+1;n<i.length;n++)m=(o=i[n]).getHeight(),Q._setOptimalLabelPosition(t,o,c,r),o.setHasFeeler(!0),(C=o.getY())>v?v=C+m:v+=m,o.setY(v-m)}},Q._truncateSliceLabel=function(e,t,i,r){var a,s,n=i.getSliceLabel(),o=n.getCSSStyle(),l=e.getNumChildren(),h=!1;e.contains(n)||(e.addChild(n),h=!0),n.setCSSStyle(o);var u=t.getSliceLabelString();return n.setTextString(u),h&&e.removeChildAt(l),a=Q.getMaxLabelWidth(e,i.getX(),r),s=Q._getTextDimension(e,t,n,a,i.getInitialNumLines()),i.setWidth(s.x),i.getHeight()!=s.y&&(i.setHeight(s.y),!0)},Q._generateInitialLayout=function(e){for(var t=new Array(2),i=[],r=[],a=e.__getSlices(),s=e.__getFrame(),n=0;n<a.length;n++){var o=a[n],l=e.getSeriesLabelPosition(o.getSeriesIndex());if(null==o.getSliceLabel()&&"none"!=l&&"center"!=l&&!Q._skipSliceLabel(e,o)){var h=Q._createLabel(o,!1),u=o.getAngleStart()+o.getAngleExtent()/2;u>360&&(u-=360),u<0&&(u+=360);var g=K.reflectAngleOverYAxis(u,e.getCenter().x,e.getCenter().y,e.getRadiusX()*Q._OUTSIDE_LABEL_DISTANCE,e.getRadiusY()*Q._OUTSIDE_LABEL_DISTANCE),d=u>=90&&u<270,c=Q.getMaxLabelWidth(e,g.x,d),p=Q._getTextDimension(e,o,h,c,Q._MAX_LINES_PER_LABEL);u<165&&u>15?g.y-=1*p.y:u<15||u>345?(g.y-=.5*p.y,g.x+=.2*p.y):u>165&&u<195&&(g.y-=.5*p.y,g.x-=.2*p.y);var _,f=Q._adjustForDepth(u,e.getDepth());if(g.y+=f,1==a.length&&(g.x-=p.x/2),!(g.y<s.y||g.y+p.y>s.y+s.h))u>=90&&u<270?(h.alignRight(),_=u-90,Q._createLabelInfo(o,h,u,_,p,g,i)):(_=u<=90?Math.abs(90-u):180-(u-270),Q._createLabelInfo(o,h,u,_,p,g,r))}}return t[0]=i,t[1]=r,t},Q._createLabelInfo=function(e,t,i,r,a,s,n){for(var o,l=-1,h=t,u=0;u<n.length;u++)if((o=n[u]).getPosition()>r){l=u;break}-1==l&&(l=n.length),(o=new q).setPosition(r),o.setAngle(i),o.setSliceLabel(h),o.setSlice(e),o.setWidth(a.x),o.setHeight(a.y),o.setX(s.x),o.setY(s.y),o.setInitialNumLines(h.getLineCount()),n.splice(l,0,o)},Q._getTextDimension=function(t,i,r,a,s){r.setMaxLines(s);var n=Q._isTextLabel(t,i)?null:r.getTextString().length;if(e.TextUtils.fitText(r,a,1/0,t,n)){t.addChild(r);var o=r.getDimensions();return t.removeChild(r),{x:o.w,y:o.h}}return{x:0,y:0}},Q._isTextLabel=function(e,t){var i=t.getCustomLabel(),r=null!=e.getOptions().dataLabel;return-1!=e.getOptions().styleDefaults.sliceLabelType.indexOf("text")||null!=i&&"number"!=typeof i||r},Q.getMaxLabelWidth=function(e,t,i){var r=e.__getFrame();return i?t-r.x:r.x+r.w-t},Q.getPieCenterOptions=function(t){var i=e.JsonUtils.clone(t.pieCenter),r=t.pieCenterLabel;if(r){var a=r.style,s=r.text;s&&(i.label=s),a&&(i.labelStyle=new e.CSSStyle(a))}return i},Q._skipSliceLabel=function(e,t){return t.getAngleExtent()<3&&H.getSeriesCount(e.chart)>120};var J=new Object;e.Obj.createSubclass(J,e.Obj),J._BUTTON_SIZE=16,J._BUTTON_PADDING=5,J._BUTTON_CORNER_DIST=4,J._BUTTON_OPACITY=.8,J._MOUSE_WHEEL_ZOOM_RATE_SLOW=.05,J._MOUSE_WHEEL_ZOOM_RATE_FAST=.2,J.render=function(e,t,i){if(J._renderBackground(e,t,i),H.hasInvalidData(e))J.renderEmptyText(e,t,i);else{z.isOverview(e)||(e.getOptions()._maxOverflowCoord=i.x+i.w,e.getOptions()._minOverflowCoord=i.x),J._addOuterGaps(e,i);var r=i.clone();J._renderTitles(e,t,i),J._adjustAvailSpace(i),ee.render(e,t,i),J._adjustAvailSpace(i);var a=J._prerenderHorizScrollbar(e,t,i),s=J._prerenderVertScrollbar(e,t,i);J._adjustAvailSpace(i),e.__setAxisSpace(i.clone()),$.render(e,t,i),J._adjustAvailSpace(i),J._positionLegend(e.legend,i),e.__setPlotAreaSpace(i.clone()),J._setEventHandlers(e),J._renderScrollbars(e,a,s),J._updateTitles(e,t,r,i),J._renderPlotArea(e,t,i),z.isPolar(e)&&t.addChild(e.yAxis),J._renderDragButtons(e,t)}},J._setEventHandlers=function(t){var i=t.getOptions(),r=t.getEventManager();if(z.hasAxes(t)&&!z.isOverview(t)){var a,s,n=new e.Rectangle(0,0,t.getWidth(),t.getHeight()),o=t.__getPlotAreaSpace(),l=t.__getAxisSpace(),h=new e.Rectangle(o.x,l.y,o.w,l.h),u=new e.Rectangle(l.x,o.y,l.w,o.h),g=new e.SolidFill(i.styleDefaults.marqueeColor),d=new e.SolidStroke(i.styleDefaults.marqueeBorderColor);if(G.isScrollable(t)){var c=G.isDelayedScroll(t)?J._MOUSE_WHEEL_ZOOM_RATE_FAST:J._MOUSE_WHEEL_ZOOM_RATE_SLOW;if((s=new e.PanZoomHandler(t,o,n,c)).setPanCursor(i._resources.panCursorUp,i._resources.panCursorDown),r.setPanZoomHandler(s),G.isZoomable(t)){var p=G.getZoomDirection(t);a=z.isHorizontal(t)||"y"==p?new e.MarqueeHandler(t,o,n,g,d,!1,!0,null,u):z.isBLAC(t)||"x"==p?new e.MarqueeHandler(t,o,n,g,d,!0,!1,h,null):new e.MarqueeHandler(t,o,n,g,d,!0,!0,h,u),r.setMarqueeZoomHandler(a)}}"multiple"==i.selectionMode&&(a=new e.MarqueeHandler(t,o,n,g,d,!0,!0,h,u),r.setMarqueeSelectHandler(a))}},J.rerenderAxisAndPlotArea=function(e,t){if(!H.hasInvalidData(e)){var i=e.__getAxisSpace().clone(),r=e.getSelectionHandler();if(r)var a=r.getSelectedIds();var s=e.__cacheChartFocus();e.__cleanUpAxisAndPlotArea(),$.render(e,t,i),J._adjustAvailSpace(i),e.__setPlotAreaSpace(i.clone()),J._renderPlotArea(e,t,i),r&&r.processInitialSelections(a,e.getChartObjPeers()),e.getEventManager().autoToggleZoomButton(),J.positionDragButtons(e),e.highlight(V.getHighlightedCategories(e)),e.__restoreChartFocus(s)}},J._renderBackground=function(t,i,r){var a=new e.Rect(t.getCtx(),r.x,r.y,r.w,r.h);a.setInvisibleFill(),i.addChild(a)},J._addOuterGaps=function(e,t){var i=e.getOptions(),r=o.getGapWidth(e,i.layout.outerGapWidth),a=o.getGapHeight(e,i.layout.outerGapHeight);("none"==i.styleDefaults.padding||z.isStandalonePlotArea(e)||z.isStandaloneXAxis(e)||z.isStandaloneYAxis(e)||z.isStandaloneY2Axis(e))&&(r=Math.min(r,1),a=Math.min(a,1)),t.x+=r,t.w-=2*r,t.y+=a,t.h-=2*a},J._renderTitles=function(t,i,r){var a=t.getOptions();if(a.title.text){var s,n,l=j.createText(t.getEventManager(),i,a.title.text,a.title.style,r.x,r.y,r.w,r.h),h=null!=a.title.hAlign?a.title.hAlign:a.title.halign,u="plotArea"==h.substring(0,8);if(l?(s=(n=l.getDimensions()).h,l.setAriaProperty("hidden",null)):(s=0,n=new e.Rectangle(0,0,0,0)),a.subtitle.text){var g=new e.OutputText(t.getCtx(),a.subtitle.text,r.x,r.y);if(g){g.setCSSStyle(a.subtitle.style),i.addChild(g);var d=g.getDimensions(),c=o.getGapWidth(t,a.layout.titleSubtitleGapWidth),p=n.w+c+d.w;if(p>r.w||u)c=o.getGapHeight(t,a.layout.titleSubtitleGapHeight),g.setY(r.y+s+c),e.TextUtils.fitText(g,r.w,r.h,i)&&(s+=(d=g.getDimensions()).h+c,e.Agent.isRightToLeft(t.getCtx())&&(g&&g.setX(r.w-d.w),l&&l.setX(r.w-n.w)));else{var _=n.h-d.h;g.setY(_+r.y),l&&(e.LayoutUtils.align(r,h,l,p),e.Agent.isRightToLeft(t.getCtx())?(g.setX(l.getX()),l&&l.setX(l.getX()+d.w+c)):g.setX(l.getX()+p-d.w))}g.setAriaProperty("hidden",null),t.getEventManager().associate(g,new e.SimpleObjPeer(g.getUntruncatedTextString()))}}else e.LayoutUtils.align(r,h,l,n.w);u&&(t.getCache().putToCache("title",l),t.getCache().putToCache("subtitle",g));var f="on"==a.titleSeparator.rendered?a.layout.titleSeparatorGap:a.layout.titlePlotAreaGap;if(r.y+=s+o.getGapHeight(t,f),r.h-=s+o.getGapHeight(t,f),"on"==a.titleSeparator.rendered){var S=new e.Line(t.getCtx(),r.x,r.y,r.x+r.w,r.y),C=new e.Line(t.getCtx(),r.x,r.y+1,r.x+r.w,r.y+1);S.setSolidStroke(a.titleSeparator.upperColor),C.setSolidStroke(a.titleSeparator.lowerColor),i.addChild(S),i.addChild(C);var m=2+o.getGapHeight(t,a.layout.titlePlotAreaGap);r.y+=m,r.h-=m}}if(a.footnote.text){var y=j.createText(t.getEventManager(),i,a.footnote.text,a.footnote.style,r.x,0,r.w,r.h),v=null!=a.footnote.hAlign?a.footnote.hAlign:a.footnote.halign,A="plotArea"==v.substring(0,8);if(y){var x=y.getDimensions();y.setY(r.y+r.h-x.h),r.h-=x.h+o.getGapHeight(t,a.layout.footnoteGap),e.LayoutUtils.align(r,v,y,x.w),y.setAriaProperty("hidden",null)}A&&t.getCache().putToCache("footnote",y)}},J._updateTitles=function(e,t,i,r){var a=e.getOptions(),s=null!=a.title.hAlign?a.title.hAlign:a.title.halign,n=null!=a.footnote.hAlign?a.footnote.hAlign:a.footnote.halign,o=a.title.text&&"plotArea"==s.substring(0,8),l=a.footnote.text&&"plotArea"==n.substring(0,8);if(i.x=r.x,i.w=r.w,o){var h,u=e.getCache().getFromCache("title"),g=e.getCache().getFromCache("subtitle"),d=u.getDimensions();J._alignTextToPlotArea(t,i,s,u,d.w),g&&(h=g.getDimensions(),J._alignTextToPlotArea(t,i,s,g,h.w))}if(l){var c=e.getCache().getFromCache("footnote"),p=c.getDimensions();J._alignTextToPlotArea(t,i,n,c,p.w)}},J._alignTextToPlotArea=function(t,i,r,a,s){e.TextUtils.fitText(a,i.w,i.h,t)&&("plotAreaStart"==r?e.LayoutUtils.align(i,"start",a,s):"plotAreaCenter"==r?e.LayoutUtils.align(i,"center",a,s):"plotAreaEnd"==r&&e.LayoutUtils.align(i,"end",a,s))},J._renderPlotArea=function(t,i,r){if(z.hasAxes(t)){var a=new e.Container(t.getCtx());a.setTranslate(r.x,r.y),i.addChild(a),t.setPlotArea(a),t.getEventManager().associate(a,new e.SimpleObjPeer(null,null,null,{type:"plotArea"}));var s=new e.Rectangle(0,0,r.w,r.h);te.render(t,a,s)}else if(z.isPie(t)){var n=new b(t,r);n.__getSlices().length>0?(i.addChild(n),t.setPlotArea(n),n.render()):J.renderEmptyText(t,i,r)}else z.isFunnel(t)?ie.render(t,i,r):z.isPyramid(t)&&re.render(t,i,r);r.w=0,r.h=0},J.renderEmptyText=function(t,i,r){var a=t.getOptions();if(H.hasInvalidTimeData(t)&&H.hasData(t))var s=e.Bundle.getTranslation(a,"labelInvalidData",e.Bundle.UTIL_PREFIX,"INVALID_DATA");else(s=a.emptyText)||(s=e.Bundle.getTranslation(a,"labelNoData",e.Bundle.UTIL_PREFIX,"NO_DATA"));e.TextUtils.renderEmptyText(i,s,new e.Rectangle(r.x,r.y,r.w,r.h),t.getEventManager(),a._statusMessageStyle)},J._prerenderHorizScrollbar=function(t,i,r){var a=r.w,s=0;return G.isScrollable(t)&&z.isHorizScrollbarSupported(t)?V.isOverviewRendered(t)?(s=Math.min(V.getOverviewHeight(t),r.h))>0&&(t.overview=new C(t),i.addChild(t.overview),e.LayoutUtils.position(r,"bottom",t.overview,a,s,10)):(s=t.getOptions().styleDefaults._scrollbarHeight,t.xScrollbar=new e.SimpleScrollbar(t.getCtx(),t.processEvent,t),i.addChild(t.xScrollbar),e.LayoutUtils.position(r,"bottom",t.xScrollbar,a,s,8),t.overview=null):t.overview=null,new e.Dimension(a,s)},J._prerenderVertScrollbar=function(t,i,r){var a=0,s=r.h;if(G.isScrollable(t)&&z.isVertScrollbarSupported(t)){a=t.getOptions().styleDefaults._scrollbarHeight;var n=new e.SimpleScrollbar(t.getCtx(),t.processEvent,t);i.addChild(n),e.LayoutUtils.position(r,e.Agent.isRightToLeft(t.getCtx())?"right":"left",n,a,s,8),z.isHorizontal(t)?t.xScrollbar=n:t.yScrollbar=n}return new e.Dimension(a,s)},J._renderScrollbars=function(t,i,r){var a=t.getOptions(),s={color:a.styleDefaults._scrollbarHandleColor,backgroundColor:a.styleDefaults._scrollbarTrackColor},n=t.__getPlotAreaSpace();if(t.xScrollbar&&(s.min=t.xAxis.getLinearGlobalMin(),s.max=t.xAxis.getLinearGlobalMax(),z.isHorizontal(t)?(s.isHorizontal=!1,s.isReversed=!1,t.xScrollbar.setTranslateY(n.y),t.xScrollbar.render(s,r.w,n.h)):(s.isHorizontal=!0,s.isReversed=e.Agent.isRightToLeft(t.getCtx()),t.xScrollbar.setTranslateX(n.x),t.xScrollbar.render(s,n.w,i.h)),t.xScrollbar.setViewportRange(t.xAxis.getLinearViewportMin(),t.xAxis.getLinearViewportMax())),t.yScrollbar&&(s.min=t.yAxis.getLinearGlobalMin(),s.max=t.yAxis.getLinearGlobalMax(),s.isHorizontal=!1,s.isReversed=!0,t.yScrollbar.setTranslateY(n.y),t.yScrollbar.render(s,r.w,n.h),t.yScrollbar.setViewportRange(t.yAxis.getLinearViewportMin(),t.yAxis.getLinearViewportMax())),t.overview){var o={xMin:t.xAxis.getLinearGlobalMin(),xMax:t.xAxis.getLinearGlobalMax(),x1:t.xAxis.getLinearViewportMin(),x2:t.xAxis.getLinearViewportMax(),minimumWindowSize:t.xAxis.getInfo().getMinimumExtent(),chart:e.JsonUtils.clone(a)};G.isZoomable(t)||(o.featuresOff="zoom"),o.chart._minOverflowCoord=a._minOverflowCoord-n.x,o.chart._maxOverflowCoord=a._maxOverflowCoord-n.x,t.overview.setTranslateX(n.x),t.overview.render(o,n.w,i.h),t.overview.setViewportRange(t.xAxis.getLinearViewportMin(),t.xAxis.getLinearViewportMax())}},J._positionLegend=function(e,t){if(e){var i=e.getDimensions(),r=e.getOptions().orientation;"vertical"==r&&i.h<=t.h?e.setTranslateY(Math.round(t.y+t.h/2-i.h/2)):"horizontal"==r&&i.w<=t.w&&e.setTranslateX(Math.round(t.x+t.w/2-i.w/2))}},J._renderDragButtons=function(t,r){var a=J._BUTTON_SIZE+2*(J._BUTTON_PADDING+J._BUTTON_CORNER_DIST),s=t.__getPlotAreaSpace();if(!(!z.hasAxes(t)||z.isOverview(t)||s.w<a||s.h<a)){var n=t.getOptions(),o=t.getEventManager(),l=n.dragMode;if("user"==l){var h,u,g=e.Agent.isTouchDevice(),d=G.isScrollable(t);t.dragButtons=new e.Container(t.getCtx());var c="multiple"==n.selectionMode&&(g||d),p=d&&g,_=d&&!g&&G.isZoomable(t)&&z.isScatterBubble(t);c&&(u=p||_?"end":"solo",o.selectButton=J._createDragButton(t,t.dragButtons,"select",o.onSelectButtonClick,o,u),h=e.Bundle.getTranslation(n,"tooltipSelect",e.Bundle.CHART_PREFIX,"MARQUEE_SELECT"),o.selectButton.setTooltip(h),o.associate(o.selectButton,o.selectButton)),p&&(u=c?"start":"solo",o.panButton=J._createDragButton(t,t.dragButtons,"pan",o.onPanButtonClick,o,u),h=e.Bundle.getTranslation(n,"tooltipPan",e.Bundle.CHART_PREFIX,"PAN"),o.panButton.setTooltip(h),o.associate(o.panButton,o.panButton)),_&&(u=c?"start":"solo",o.zoomButton=J._createDragButton(t,t.dragButtons,"zoom",o.onZoomButtonClick,o,u),h=e.Bundle.getTranslation(n,"tooltipZoom",e.Bundle.CHART_PREFIX,"MARQUEE_ZOOM"),o.zoomButton.setTooltip(h),o.associate(o.zoomButton,o.zoomButton)),J.positionDragButtons(t),o.setDragMode(null),t.dragButtons.getNumChildren()>0&&(t.addChild(t.dragButtons),g?d&&(o.panButton.setToggled(!0),o.onPanButtonClick(null)):t.hideDragButtons(),t.dragButtons.setCursor("default"))}else"pan"==l?o.setDragMode(i.DRAG_MODE_PAN):"zoom"==l?o.setDragMode(i.DRAG_MODE_ZOOM):"select"==l?o.setDragMode(i.DRAG_MODE_SELECT):o.setDragMode(i.DRAG_MODE_OFF)}},J._positionDragButton=function(t,i,r){var a;e.Agent.isRightToLeft(t.getCtx())?(a=r.x+J._BUTTON_PADDING,r.x+=J._BUTTON_SIZE+2*J._BUTTON_PADDING):a=r.x+r.w-J._BUTTON_SIZE-J._BUTTON_PADDING,r.w-=J._BUTTON_SIZE+2*J._BUTTON_PADDING,i.setTranslate(a,r.y+J._BUTTON_PADDING)},J.positionDragButtons=function(e){var t=e.__getPlotAreaSpace().clone();t.x+=J._BUTTON_CORNER_DIST,t.w-=2*J._BUTTON_CORNER_DIST,t.y+=J._BUTTON_CORNER_DIST;var i=e.getEventManager();i.selectButton&&J._positionDragButton(e,i.selectButton,t),i.panButton&&J._positionDragButton(e,i.panButton,t),i.zoomButton&&J._positionDragButton(e,i.zoomButton,t)},J._createDragButtonBackground=function(t,i,r){var a=2,s=2,n=e.Agent.isRightToLeft(t);"start"==i?n?a=0:s=0:"end"==i&&(n?s=0:a=0);var o=a,l=s,h=-J._BUTTON_PADDING,u=J._BUTTON_SIZE+2*J._BUTTON_PADDING,g=e.PathUtils.roundedRectangle(h,h,u,u,o,s,l,a),d=new e.Path(t,g);return e.Agent.getDevicePixelRatio()>1?(d.setSolidStroke(r,J._BUTTON_OPACITY,1),d.setPixelHinting(!0)):d.setSolidStroke(r,J._BUTTON_OPACITY,1),d},J._createDragButton=function(t,i,r,a,s,n){var o=t.getCtx(),l=t.getOptions()._resources,h=J._createDragButtonBackground(o,n,"#C4CED7"),u=l[r+"Up"];h.setFill(new e.LinearGradientFill(270,["#FFFFFF","#F1F3F4","#E8EBED","#E4E8EA"],[J._BUTTON_OPACITY,J._BUTTON_OPACITY,J._BUTTON_OPACITY,J._BUTTON_OPACITY],[0,.0364,.5,1])),h.addChild(new e.Image(o,u,0,0,J._BUTTON_SIZE,J._BUTTON_SIZE));var g=J._createDragButtonBackground(o,n,"#C4CED7"),d=l[r+"UpHover"]?l[r+"UpHover"]:u;g.setSolidFill("#F7F8F9",J._BUTTON_OPACITY),g.addChild(new e.Image(o,d,0,0,J._BUTTON_SIZE,J._BUTTON_SIZE));var c=J._createDragButtonBackground(o,n,"#0572CE"),p=l[r+"Down"];c.setSolidFill("#0572CE",J._BUTTON_OPACITY),c.addChild(new e.Image(o,p,0,0,J._BUTTON_SIZE,J._BUTTON_SIZE));var _=J._createDragButtonBackground(o,n,"#0572CE"),f=l[r+"DownHover"]?l[r+"DownHover"]:p;_.setSolidFill("#0572CE",J._BUTTON_OPACITY),_.addChild(new e.Image(o,f,0,0,J._BUTTON_SIZE,J._BUTTON_SIZE));var S=new e.Button(o,h,g,c,null,null,a,s);if(S.setOverDownState(_),S.setToggleEnabled(!0),i.addChild(S),S.addEvtListener(e.MouseEvent.MOUSEDOWN,function(e){e.stopPropagation()}),e.Agent.isTouchDevice()){var C,m=e.Agent.isRightToLeft(o),y=2*J._BUTTON_PADDING;(C="solo"==n?new e.Rect(o,-y,-y,J._BUTTON_SIZE+2*y,J._BUTTON_SIZE+2*y):"start"==n&&!m||"end"==n&&m?new e.Rect(o,-y,-y,J._BUTTON_SIZE+1.5*y,J._BUTTON_SIZE+2*y):new e.Rect(o,-.5*y,-y,J._BUTTON_SIZE+1.5*y,J._BUTTON_SIZE+2*y)).setInvisibleFill(),S.addChild(C)}return S},J._adjustAvailSpace=function(e){e.x=Math.round(e.x),e.y=Math.round(e.y),e.w=Math.round(e.w),e.h=Math.round(e.h)},J.renderDataCursor=function(e){var t=null,i=e.getOptions(),r=e.getEventManager();if(W.isDataCursorEnabled(e)){(t=new v(e.getCtx(),i.styleDefaults.dataCursor,z.isHorizontal(e))).setBehavior(W.getDataCursorBehavior(e)),e.addChild(t);var a=new l(e,t);r.setDataCursorHandler(a),e.positionDataCursor(i.dataCursorPosition)}else r.setDataCursorHandler(null);return t};var $=new Object;e.Obj.createSubclass($,e.Obj),$._DEFAULT_AXIS_MAX_SIZE=.33,$.render=function(e,t,i){z.hasAxes(e)&&(N.applyInitialZooming(e,i),z.isBubble(e)&&X.calcBubbleSizes(e,i),z.isPolar(e)?$._renderPolar(e,t,i):$._renderCartesian(e,t,i))},$._renderCartesian=function(t,i,r){var a=t.getOptions(),s=z.isHorizontal(t),n=z.isSplitDualY(t),o=r.clone(),l=N.getYAxisPosition(t),h=N.getY2AxisPosition(t);$._addAxisGaps(t,r),n&&l==h&&(a.yAxis._skipHighestTick=s,a.y2Axis._skipHighestTick=!s);var u=$._createYAxis(t,i,r,o),g=$._createY2Axis(t,i,r,o),d=!n&&"on"==a.y2Axis.alignTickMarks&&null==a.y2Axis.step;d&&u&&g&&($._alignYAxes(t,u,g),s||(g.dim=$._getPreferredSize(t,g.axis,t.y2Axis,g.options,"y2",r,o)));var c,p=N.getTickLabelGapSize(t,"y"),_=N.getTickLabelGapSize(t,"y2");n&&l==h?(s?(c=Math.max(u.dim.h+p,g.dim.h+_),u.dim.h=c-p,g.dim.h=c-_):(c=Math.max(u.dim.w+p,g.dim.w+_),u.dim.w=c-p,g.dim.w=c-_),$._positionAxis(r.clone(),u,p),$._positionAxis(r,g,_)):($._positionAxis(r,u,p),$._positionAxis(r,g,_));var f=H.getGroupCount(t);if("pixel"==V.getBarSpacing(t)&&z.isBar(t)&&r.w>f){var S=Math.floor(r.w/f)*f;r.x+=(r.w-S)/2,r.w=S}var C=$._createXAxis(t,i,r,o);C.axis.render(C.options,C.dim.w,C.dim.h),$._positionAxis(r,C,N.getTickLabelGapSize(t,"x"));var m=V.getSplitterPosition(t),y=e.Agent.isRightToLeft(t.getCtx()),v=$._getSplitAvailSpace(r,m,s,s&&y),A=$._getSplitAvailSpace(r,1-m,s,!s||!y);s?(u&&(u.axis.setTranslateX(r.x),n?u.axis.render(u.options,v.w,u.dim.h,v.x,0):u.axis.render(u.options,r.w,u.dim.h)),d&&u&&g&&$._alignYAxes(t,u,g),g&&(g.axis.setTranslateX(r.x),n?g.axis.render(g.options,A.w,g.dim.h,A.x,0):g.axis.render(g.options,r.w,g.dim.h)),$._setOverflow(r,u,C)):(u&&(n?u.axis.render(u.options,u.dim.w,v.h,0,v.y):u.axis.render(u.options,u.dim.w,r.h)),d&&u&&g&&$._alignYAxes(t,u,g),g&&(n?g.axis.render(g.options,g.dim.w,A.h,0,A.y):g.axis.render(g.options,g.dim.w,r.h)),$._setOverflow(r,C,u,g)),$._storeAxes(t,C,u,g)},$._renderPolar=function(e,t,i){var r=$._createXAxis(e,t,i,i);r.axis.setTranslateX(i.x),r.axis.setTranslateY(i.y),r.axis.render(r.options,i.w,i.h);var a=$._createYAxis(e,t,i,i);a.axis.setTranslateX(i.x),a.axis.setTranslateY(i.y),a.axis.render(a.options,i.w,i.h),$._storeAxes(e,r,a)},$._createXAxis=function(t,i,r,a){var s=t.getOptions(),n=N.getXAxisPosition(t),o=e.JsonUtils.clone(s.xAxis);o.position=n,o.isStandalone=z.isStandaloneXAxis(t),o.groupSeparators=s.styleDefaults.groupSeparators,$._addCommonAxisAttributes(o,"x",t),o.groups=s.groups,o._groupWidthRatios=N.getGroupWidthRatios(t),o.timeAxisType=N.getTimeAxisType(t),o._environment=s._environment,o._locale=s._locale,o.drilling=s.drilling,o._isGroupAxis=N.hasGroupAxis(t);var l="top"==n||"bottom"==n,h=N.isGridShifted(t);if("tangential"==n&&N.hasGroupAxis(t))h?(o.startGroupOffset=.5,o.endGroupOffset=.5):o.endGroupOffset=1;else{var u=N.getAxisOffset(t);if(o.startGroupOffset=u,o.endGroupOffset=u,z.hasUncenteredSeries(t)&&(o.endGroupOffset+=1),!G.isScrollable(t)&&!z.isOverview(t)){var d=H.getGroupCount(t);N.isAxisRendered(t,"y")&&N.isTickLabelInside(t,"y")&&(o[(l?"start":"end")+"GroupOffset"]+=.04*d),N.isAxisRendered(t,"y2")&&N.isTickLabelInside(t,"y2")&&(o[(l?"end":"start")+"GroupOffset"]+=.04*d)}}o.leftBuffer=l?r.x-a.x:0,o.rightBuffer=l?a.w+a.x-(r.w+r.x):0,o._renderGridAtLabels=!h||N.hasTimeAxis(t);var c=new g(t.getCtx(),t.processEvent,t);i.addChild(c);var p=$._getPreferredSize(t,c,t.xAxis,o,"x",r,a);return o._minOverflowCoord=s._minOverflowCoord-r.x,o._maxOverflowCoord=s._maxOverflowCoord-r.x,{axis:c,options:o,dim:p}},$._createYAxis=function(t,i,r,a){var s=t.getOptions();if(z.hasY2DataOnly(t))return null;var n=e.JsonUtils.clone(s.yAxis);n.position=N.getYAxisPosition(t),n.isStandalone=z.isStandaloneYAxis(t),$._addCommonAxisAttributes(n,"y",t),$._addCommonYAxisAttributes(n,t);var o=new g(t.getCtx(),t.processEvent,t);i.addChild(o);var l=$._getPreferredSize(t,o,t.yAxis,n,"y",r,a);return $._adjustYAxisForLabels(o,n,t,"y"),s.yAxis.min=n.min,s.yAxis.max=n.max,{axis:o,options:n,dim:l}},$._createY2Axis=function(t,i,r,a){var s=t.getOptions();if(z.hasY2Data(t)){var n=e.JsonUtils.clone(s.y2Axis);n.position=N.getY2AxisPosition(t),n.isStandalone=z.isStandaloneY2Axis(t),$._addCommonAxisAttributes(n,"y2",t),$._addCommonYAxisAttributes(n,t);var o=new g(t.getCtx(),t.processEvent,t);i.addChild(o);var l=$._getPreferredSize(t,o,t.y2Axis,n,"y2",r,a);return $._adjustYAxisForLabels(o,n,t,"y2"),s.y2Axis.min=n.min,s.y2Axis.max=n.max,{axis:o,options:n,dim:l}}},$._addCommonAxisAttributes=function(e,t,i){var r=i.getOptions();if(e.skin=r.skin,e.tickLabel.position=N.isTickLabelInside(i,t)?"inside":"outside",e.baselineScaling=N.getBaselineScaling(i,t),(N.isTickLabelInside(i,t)||"tangential"==e.position)&&(e._skipHighestTick=!0),e.zoomAndScroll=z.isPolar(i)?"off":r.zoomAndScroll,e._isOverview=z.isOverview(i),e._duringZoomAndScroll=r._duringZoomAndScroll,"x"!=t||!N.hasGroupAxis(i)){var a=H.getMinMaxValue(i,t);e.dataMin=null!=e.dataMin?e.dataMin:a.min,e.dataMax=null!=e.dataMax?e.dataMax:a.max}z.isPolar(i)&&(e.polarGridShape=N.isGridPolygonal(i)?"polygon":"circle",e._radius=i.getRadius()),e.dnd=r.dnd},$._addCommonYAxisAttributes=function(t,i){if(t.timeAxisType="disabled",G.isLiveScroll(i)&&z.isBLAC(i)&&!z.isPolar(i)&&(t._continuousExtent="on"),t.isStandalone)t.leftBuffer=0,t.rightBuffer=0;else if(z.isSplitDualY(i))t.leftBuffer=1/0,t.rightBuffer=1/0;else{var r=e.Agent.isRightToLeft(i.getCtx());t.leftBuffer=r?0:e.Axis.MINIMUM_AXIS_BUFFER,t.rightBuffer=r?e.Axis.MINIMUM_AXIS_BUFFER:0}},$._adjustYAxisForLabels=function(t,i,r,a){var s=r.getOptions();if(N.isYAdjustmentNeeded(r)){var n=s.styleDefaults.dataLabelStyle,o=s.styleDefaults.stackLabelStyle,l=t.getInfo(),h=V.isStackLabelRendered(r),u=e.TextUtils.getTextStringHeight(r.getCtx(),h?o:n),g=0;if("log"==i.scale){g=t.getUnboundedValueAt(t.getUnboundedCoordAt(l.getDataMax())-u)-l.getDataMax()}else{var d=1;z.isSplitDualY(r)&&(d="y"==a?V.getSplitterPosition(r):1-V.getSplitterPosition(r));var c=Math.abs(l.getEndCoord()-l.getStartCoord())*d;g=Math.abs(l.getViewportMax()-l.getViewportMin())/c*u}z.isHorizontal(r)?g*=4:g*=2,l.getDataMin()-l.getGlobalMin()<=g&&l.getDataMin()<0&&(i.dataMin-=g),l.getGlobalMax()-l.getDataMax()<=g&&l.getDataMax()>0&&(i.dataMax+=g)}},$._getPreferredSize=function(t,i,r,a,s,n,o){var l=a.isStandalone,h=a.position,u="top"==h||"bottom"==h,g=N.getTickLabelGapSize(t,s),d=a.maxSize,c=a.size,p=n.w,_=n.h;if("radial"==h||"tangential"==h)p=0,_=0;else if("off"==a.rendered)u?_=0:p=0;else if(l)u?_=n.h-g:p=n.w-g;else if(null!=c)u?(_=V.getSizeInPixels(c,o.h)-g,null!=d&&(_=Math.min(_,V.getSizeInPixels(d,o.h)-g))):(p=V.getSizeInPixels(c,o.w)-g,null!=d&&(p=Math.min(p,V.getSizeInPixels(d,o.w)-g)));else{if(!t.getOptions()._duringZoomAndScroll||!r)return d=null==d?$._DEFAULT_AXIS_MAX_SIZE:d,u?i.getPreferredSize(a,n.w,V.getSizeInPixels(d,o.h)-g):i.getPreferredSize(a,V.getSizeInPixels(d,o.w)-g,n.h);if(u){var f=e.Agent.isRightToLeft(t.getCtx());a._startOverflow=f?r.getRightOverflow():r.getLeftOverflow(),a._endOverflow=f?r.getLeftOverflow():r.getRightOverflow(),_=r.getHeight()}else p=r.getWidth()}return N.isYAdjustmentNeeded(t)&&i.getPreferredSize(a,p,_),new e.Dimension(p,_)},$._addAxisGaps=function(e,t){var i=z.isHorizontal(e),r=N.getYAxisPosition(e),a=N.getY2AxisPosition(e),s=N.isAxisRendered(e,"x"),n=N.isAxisRendered(e,"y"),o=N.isAxisRendered(e,"y2"),l=e.getOptions().layout.verticalAxisGap;l*=i?N.getGapScalingFactor(e,"x"):Math.max(N.getGapScalingFactor(e,"y"),N.getGapScalingFactor(e,"y2")),l=Math.ceil(l),(!i||"top"==r&&n||"top"==a&&o)&&i||(t.y+=l,t.h-=l),(!i||"bottom"==r&&n||"bottom"==a&&o)&&(i||s)||(t.h-=l)},$._positionAxis=function(t,i,r){i&&e.LayoutUtils.position(t,i.options.position,i.axis,i.dim.w,i.dim.h,r)},$._alignYAxes=function(e,t,i){var r=t.axis.getInfo();if(r){var a=r.getMajorTickCount(),s=r.getMinorTickCount(),n=i.options,o=i.axis.getInfo();o&&N.isLog(e,"y")&&N.isLog(e,"y2")&&a<o.getMajorTickCount()&&(n._logScaleUnit=o.alignLogScaleToTickCount(o.getLogScaleUnit(),a)),n._majorTickCount=a,n._minorTickCount=s}},$._getSplitAvailSpace=function(e,t,i,r){var a=e.clone();return i?(a.w=e.w*t,a.x=r?e.w*(1-t):0):(a.h=e.h*t,a.y=r?e.h*(1-t):0),a},$._setOverflow=function(e,t,i,r){if(t){var a=t.axis.getLeftOverflow(),s=t.axis.getRightOverflow();e.x+=a,e.w-=a+s,i&&i.axis.setTranslateX(i.axis.getTranslateX()+("left"==i.options.position?a:-s)),r&&r.axis.setTranslateX(r.axis.getTranslateX()+("left"==r.options.position?a:-s))}},$._storeAxes=function(e,t,i,r){e.xAxis&&(e.xAxis.destroy(),e.removeChild(e.xAxis)),e.yAxis&&(e.yAxis.destroy(),e.removeChild(e.yAxis)),e.y2Axis&&(e.y2Axis.destroy(),e.removeChild(e.y2Axis)),e.xAxis=t.axis,e.yAxis=i?i.axis:null,e.y2Axis=r?r.axis:null};var ee=new Object;e.Obj.createSubclass(ee,e.Obj),ee._DEFAULT_LINE_WIDTH_WITH_MARKER=2,ee._DEFAULT_MAX_SIZE=.3,ee._PIE_SIZE_RATIO=1.2,ee.render=function(t,i,r){var a=t.getOptions(),s=a.legend.position;if(!("off"==a.legend.rendered||"auto"==a.legend.rendered&&t.getOptionsCache().getFromCache("hasLargeSeriesCount"))){var n=e.JsonUtils.clone(a.legend);delete n.position,n.skin=a.skin,n.hideAndShowBehavior=G.getHideAndShowBehavior(t),n.hoverBehavior=G.getHoverBehavior(t),n.hoverBehaviorDelay=V.getHoverBehaviorDelay(t),n.hiddenCategories=V.getHiddenCategories(t),n.highlightedCategories=V.getHighlightedCategories(t),n.dnd=a.dnd,n._dropColor=a._dropColor,"auto"==s&&(s=r.w>=r.h?"end":"bottom");var l="top"==s||"bottom"==s;if(n.orientation=l?"horizontal":"vertical","start"==s&&(n.halign="end"),"start"!=s&&"end"!=s||(n.valign="middle"),"top"==s&&(n.valign="bottom"),"top"!=s&&"bottom"!=s||(n.halign="center"),ee._addLegendData(t,n),0!=n.sections.length){var h,u=e.Legend.newInstance(t.getCtx(),t.processEvent,t);if(null!=t.getId()&&u.setId(t.getId()+"legend"),i.addChild(u),null!=n.size)h=l?new e.Dimension(r.w,V.getSizeInPixels(n.size,r.h)):new e.Dimension(V.getSizeInPixels(n.size,r.w),r.h);else{var g=n.maxSize;if(null==g&&(g=ee._DEFAULT_MAX_SIZE,z.isPie(t))){var d=1-ee._PIE_SIZE_RATIO*(l?r.w/r.h:r.h/r.w);g=Math.max(g,d)}var c=l?r.w:V.getSizeInPixels(g,r.w),p=l?V.getSizeInPixels(g,r.h):r.h;h=u.getPreferredSize(n,c,p)}u.render(n,h.w,h.h);var _=l?o.getGapHeight(t,a.layout.legendGapHeight):o.getGapWidth(t,a.layout.legendGapWidth);e.LayoutUtils.position(r,s,u,h.w,h.h,_);var f=Object.keys(n.dnd.drag.series).length>0,S=u.getCache().getFromCache("background");f&&S&&S.setClassName("oj-draggable");var C=u.__getBounds(),m=u.localToStage(new e.Point(C.x,C.y));if(!z.isOverview(t)){var y=e.Agent.isRightToLeft(t.getCtx());"end"==s?y?a._minOverflowCoord=m.x+C.w+_/2:a._maxOverflowCoord=m.x-_/2:"start"==s&&(y?a._maxOverflowCoord=m.x-_/2:a._minOverflowCoord=m.x+C.w+_/2)}t.legend&&(t.legend.destroy(),i.removeChild(t.legend)),t.legend=u}}},ee._addLegendData=function(e,t){var i=ee._getSeriesItems(e,"vertical"==t.orientation);if(i.length>0){var r=t.seriesSection;r.items=i,t.sections.unshift(r),delete t.seriesSection}var a=ee._getRefObjItems(e);if(a.length>0){var s=t.referenceObjectSection;s.items=a,t.sections.push(s),delete t.referenceObjectSection}},ee._getSeriesItems=function(t,i){var r,a,s=[];if("pie"==t.getType()||"pyramid"==t.getType()||"funnel"==t.getType()){var n=Z.getRenderedSeriesIndices(t);"pyramid"==t.getType()&&i&&(n=n.reverse());for(var o=0;o<n.length;o++){a=n[o];var l=H.getValue(t,a,0);l>=0&&null!=l&&(r=ee._createLegendItem(t,a))&&s.push(r)}Z.hasOtherSeries(t)&&(r={id:Z.OTHER_SLICE_SERIES_ID,text:e.Bundle.getTranslation(t.getOptions(),"labelOther",e.Bundle.CHART_PREFIX,"LABEL_OTHER"),categoryVisibility:e.ArrayUtils.getIndex(V.getHiddenCategories(t),Z.OTHER_SLICE_SERIES_ID)>=0?"hidden":"visible",symbolType:"marker",color:t.getOptions().styleDefaults.otherColor,borderColor:t.getOptions().styleDefaults.borderColor},s.push(r))}else{var h={},u={},g=H.getSeriesCount(t);for(a=0;a<g;a++)if(r=ee._createLegendItem(t,a)){var d=H.getStackCategory(t,a);H.isAssignedToY2(t,a)?u[d]?u[d].push(r):u[d]=[r]:h[d]?h[d].push(r):h[d]=[r]}var c=H.getStackCategories(t,null,!0),p=z.isStacked(t)&&z.isVertical(t)&&i;s=ee._getSeriesItemsForAxis(h,c.y,p,s),s=ee._getSeriesItemsForAxis(u,c.y2,p,s)}return s},ee._getSeriesItemsForAxis=function(e,t,i,r){for(var a,s=0;s<t.length;s++)(a=e[t[s]])&&(r=i?r.concat(a.reverse()):r.concat(a));return r},ee._createLegendItem=function(t,i){var r=H.getSeriesItem(t,i),a=t.getType(),s=V.getSeriesType(t,i),n=V.getLineType(t,i),o=r.displayInLegend;if(!r||"off"==o)return null;if("on"!=o&&(z.isFunnel(t)||z.isPyramid(t)||z.isStock(t)))return null;if("on"!=o&&!H.hasSeriesData(t,i))return null;var l=H.getSeriesLabel(t,i);if("on"!=o&&(null==l||"string"==typeof l&&e.StringUtils.trim(l).length<=0))return null;var h={id:H.getSeries(t,i),text:l,categories:H.getCategories(t,i),categoryVisibility:V.isSeriesRendered(t,i)?"visible":"hidden",_dataContext:H.getDataContext(t,i,-1)};if("line"==s||"lineWithArea"==s||"scatter"==a||"bubble"==a)if(h.lineStyle=V.getLineStyle(t,i),h.lineWidth=V.getLineWidth(t,i),V.isMarkerDisplayed(t,i)){var u=V.getImageSource(t,i,null,null,"source");u?(h.symbolType="image",h.source=u):(h.symbolType="none"==n?"marker":"lineWithMarker","lineWithMarker"==h.symbolType&&(h.lineWidth=Math.min(ee._DEFAULT_LINE_WIDTH_WITH_MARKER,h.lineWidth)),h.markerShape=V.getMarkerShape(t,i),h.markerColor=V.getMarkerColor(t,i))}else h.symbolType="line";else if("boxPlot"==s){var g=V.getBoxPlotStyleOptions(t,i);g.q2Color!=g.q3Color?(h.symbolType=z.isHorizontal(t)?"_horizontalBoxPlot":"_verticalBoxPlot",h._boxPlot=g):h.symbolType="marker"}else h.symbolType="marker","none"==V.getLineType(t,i)&&(h.markerShape=V.getMarkerShape(t,i));return h.color=V.getColor(t,i),h.borderColor=V.getBorderColor(t,i),h.pattern=V.getPattern(t,i),h.svgStyle="area"==s?V.getAreaStyle(t,i):V.getStyle(t,i),h.svgClassName="area"==s?V.getAreaClassName(t,i):V.getClassName(t,i),h.markerSvgStyle=V.getMarkerStyle(t,i),h.markerSvgClassName=V.getMarkerClassName(t,i),h.action=r.action,h._spb=t.getShowPopupBehaviors(r._id),h.drilling=G.isSeriesDrillable(t,i)?"on":"off",h.shortDesc=r.shortDesc,h},ee._getRefObjItems=function(e){var t=U.getRefObjs(e);if(t.length<=0)return[];for(var i=[],r=0;r<t.length;r++){var a=t[r];if(a&&"on"==a.displayInLegend&&a.text){var s=U.getType(a);i.push({symbolType:"area"==s?"square":"line",text:a.text,color:U.getColor(a),lineStyle:a.lineStyle,lineWidth:U.getLineWidth(a),categories:U.getRefObjCategories(a),categoryVisibility:U.isObjectRendered(e,a)?"visible":"hidden",shortDesc:a.shortDesc,svgStyle:a.style||a.svgStyle,svgClassName:a.className||a.svgClassName})}}return i};var te=new Object;e.Obj.createSubclass(te,e.Obj),te._MIN_TOUCH_MARKER_SIZE=16,te._MARKER_DATA_LABEL_GAP=4,te._MIN_CHARS_DATA_LABEL=3,te.FILTER_THRESHOLD_SCATTER_BUBBLE=1e4,te.render=function(e,t,i){"off"==e.getOptions().plotArea.rendered?te._renderAxisLines(e,t,i):i.w>0&&i.h>0&&(e._currentMarkers=new Array,e._currentAreas=new Array,te._renderBackgroundObjects(e,t,i),te._renderTicks(e,t,i),te._renderForegroundObjects(e,t,i))},te._renderBackgroundObjects=function(t,i,r){var a=t.getOptions(),s=te._getBackgroundShape(t,r),n=V.getBackgroundColor(t);if(n?s.setSolidFill(n):s.setInvisibleFill(),i.addChild(s),t.getCache().putToCache("plotAreaBackground",s),G.isPlotAreaDraggable(t)&&s.setClassName("oj-draggable"),a.xAxis.referenceObjects||a.yAxis.referenceObjects||a.y2Axis.referenceObjects){var o=te.createClippedGroup(t,i,r);ae.renderBackgroundObjects(t,o,r)}if(z.isBLAC(t)){var l=new e.Container(t.getCtx());i.addChild(l),t.__setAreaContainer(l),z.hasAreaSeries(t)&&te._renderAreas(t,l,r,!1)}},te._getBackgroundShape=function(t,i){var r,a=t.getCtx();if(z.isPolar(t)){var s=i.x+i.w/2,n=i.y+i.h/2;if(N.isGridPolygonal(t)){var o=e.PolygonUtils.getRegularPolygonPoints(s,n,H.getGroupCount(t),t.getRadius(),0);r=new e.Polygon(a,o)}else r=new e.Circle(a,s,n,t.getRadius())}else r=new e.Rect(a,i.x,i.y,i.w,i.h);return r},te._renderTicks=function(e,t,i){e.xAxis&&N.isMinorTickRendered(e,"x")&&te._renderMinorTicks(e,t,e.xAxis,i),e.yAxis&&N.isMinorTickRendered(e,"y")&&te._renderMinorTicks(e,t,e.yAxis,i),e.y2Axis&&N.isMinorTickRendered(e,"y2")&&te._renderMinorTicks(e,t,e.y2Axis,i),e.xAxis&&N.isMajorTickRendered(e,"x")&&te._renderMajorTicks(e,t,e.xAxis,i),e.yAxis&&N.isMajorTickRendered(e,"y")&&te._renderMajorTicks(e,t,e.yAxis,i),e.y2Axis&&N.isMajorTickRendered(e,"y2")&&te._renderMajorTicks(e,t,e.y2Axis,i)},te._renderAxisLines=function(e,t,i){e.xAxis&&e.yAxis&&N.isAxisLineRendered(e,"x")&&te._renderAxisLine(e,t,e.xAxis,e.yAxis,i),e.xAxis&&e.y2Axis&&N.isAxisLineRendered(e,"x")&&(e.yAxis&&!z.isSplitDualY(e)||te._renderAxisLine(e,t,e.xAxis,e.y2Axis,i)),e.yAxis&&e.xAxis&&N.isAxisLineRendered(e,"y")&&te._renderAxisLine(e,t,e.yAxis,e.xAxis,i),e.y2Axis&&e.xAxis&&N.isAxisLineRendered(e,"y2")&&te._renderAxisLine(e,t,e.y2Axis,e.xAxis,i)},te._renderMajorTicks=function(e,t,i,r){te._renderGridlines(e,t,i.getOptions().majorTick,i.getPosition(),i.getMajorTickCoords(),i.getBaselineCoord(),r)},te._renderMinorTicks=function(e,t,i,r){te._renderGridlines(e,t,i.getOptions().minorTick,i.getPosition(),i.getMinorTickCoords(),null,r)},te._renderAxisLine=function(e,t,i,r,a){var s=i.getOptions(),n=s.position,o="bottom"==n||"right"==n||"tangential"==n?r.getMaxCoord():r.getMinCoord();te._renderGridlines(e,t,s.axisLine,r.getPosition(),[o],null,a)},te._renderGridlines=function(t,i,r,a,s,n,o){var l=r.lineColor,h=new e.SolidStroke(l,1,r.lineWidth);r.lineStyle&&h.setStyle(e.Stroke.convertTypeString(r.lineStyle));var u,g=h.clone();"inherit"!=r.baselineColor&&(u="auto"==r.baselineColor?e.ColorUtils.getDarker(l,.6):r.baselineColor,g.setColor(u));g.setWidth(null!=r.baselineWidth?r.baselineWidth:r.lineWidth),g.setStyle(e.Stroke.convertTypeString(r.baselineStyle?r.baselineStyle:r.lineStyle));for(var d="",c=0;c<s.length;c++){var p=null!=n&&s[c]==n;"radial"==a||"tangential"==a||p?te._renderGridline(t,i,a,s[c],p?g:h,o):d+="top"==a||"bottom"==a?e.PathUtils.moveTo(s[c],o.y)+e.PathUtils.verticalLineTo(o.y+o.h):e.PathUtils.moveTo(o.x,s[c])+e.PathUtils.horizontalLineTo(o.x+o.w)}if(""!=d){var _=new e.Path(t.getCtx(),d);(!e.Agent.isTouchDevice()||e.Agent.getDevicePixelRatio()>1)&&_.setPixelHinting(!0),_.setStroke(h),_.setMouseEnabled(!1),i.addChild(_)}},te._renderGridline=function(t,i,r,a,s,n){var o,l=i.getCtx(),h=!e.Agent.isTouchDevice()||e.Agent.getDevicePixelRatio()>1;if("radial"==r){if(N.isGridPolygonal(t)){var u=e.PolygonUtils.getRegularPolygonPoints(0,0,H.getGroupCount(t),a,0);o=new e.Polygon(l,u)}else o=new e.Circle(l,0,0,a);o.setInvisibleFill(),o.setTranslate(n.x+n.w/2,n.y+n.h/2)}else if("tangential"==r){o=new e.Line(l,0,0,t.getRadius()*Math.sin(a),-t.getRadius()*Math.cos(a));var g=a%(Math.PI/2);(g<.001||g>Math.PI/2-.001)&&h&&o.setPixelHinting(!0),o.setTranslate(n.x+n.w/2,n.y+n.h/2)}else o="top"==r||"bottom"==r?new e.Line(l,a,n.y,a,n.y+n.h):new e.Line(l,n.x,a,n.x+n.w,a),h&&o.setPixelHinting(!0);o.setStroke(s),o.setMouseEnabled(!1),i.addChild(o)},te._renderForegroundObjects=function(e,t,i){var r=e.getOptions(),a=te.createClippedGroup(e,t,i);te._renderAxisLines(e,t,i);var s=r.plotArea.borderColor,n=r.plotArea.borderWidth;if(s&&0!=n){var o=te._getBackgroundShape(e,i);o.setInvisibleFill(),o.setSolidStroke(s,null,n),o.setMouseEnabled(!1),t.addChild(o)}z.isBLAC(e)?(z.hasLineWithAreaSeries(e)&&te._renderAreas(e,t,i,!0),z.hasBarSeries(e)&&te._renderBars(e,a,i),z.hasCandlestickSeries(e)&&te._renderStock(e,a,i),z.hasBoxPlotSeries(e)&&te._renderBoxPlot(e,a,i),z.hasLineSeries(e)&&te._renderLines(e,t,a,i)):z.isScatterBubble(e)&&te._renderScatterBubble(e,t,a,!0,i),(r.xAxis.referenceObjects||r.yAxis.referenceObjects||r.y2Axis.referenceObjects)&&(a=te.createClippedGroup(e,t,i),ae.renderForegroundObjects(e,a,i));var l=H.getInitialSelection(e);G.setInitialSelection(e,l),e.highlight(V.getHighlightedCategories(e))},te._renderDataLabel=function(t,i,r,a,s,n,o,l,h,u){if(!z.isOverview(t)){var g="bar"==V.getSeriesType(t,a),d=z.isHorizontal(t),c={width:d?r.w:u,height:d?u:r.h};g&&t.getOptionsCache().putToCachedMap2D("barDims",a,s,c);var p=H.getDataLabel(t,a,s,n,l,h);if(null!=p){var _=V.getDataLabelPosition(t,a,s,n,l,h);if("none"!=_){var f=new e.OutputText(t.getCtx(),p,0,0);f.setMouseEnabled(!1);var S=h?t.getOptions().styleDefaults.stackLabelStyle:V.getDataLabelStyle(t,a,s,n,o,_,l);f.setCSSStyle(S),f.setY(r.y+r.h/2),f.setX(r.x+r.w/2),f.alignCenter(),f.alignMiddle();var C=f.getDimensions();if("left"==_)f.setX(r.x-C.w/2-te._MARKER_DATA_LABEL_GAP);else if("right"==_)f.setX(r.x+r.w+C.w/2+te._MARKER_DATA_LABEL_GAP);else if("top"==_)f.setY(r.y-C.h/2);else if("bottom"==_)f.setY(r.y+r.h+C.h/2+te._MARKER_DATA_LABEL_GAP/2);else{if(g){if(C.w>c.width||C.h>c.height)return;"inLeft"==_?f.setX(r.x+C.w/2+te._MARKER_DATA_LABEL_GAP):"inRight"==_?f.setX(r.x+r.w-C.w/2-te._MARKER_DATA_LABEL_GAP):"inTop"==_?f.setY(r.y+C.h/2+te._MARKER_DATA_LABEL_GAP):"inBottom"==_&&f.setY(r.y+r.h-C.h/2-te._MARKER_DATA_LABEL_GAP/2)}else if(z.isBubble(t)){r.x+=te._MARKER_DATA_LABEL_GAP,r.y+=te._MARKER_DATA_LABEL_GAP,r.h-=2*te._MARKER_DATA_LABEL_GAP,r.w-=2*te._MARKER_DATA_LABEL_GAP;var m=e.TextUtils.getOptimalFontSize(f.getCtx(),f.getTextString(),f.getCSSStyle(),r);if(f.setFontSize(m),!e.TextUtils.fitText(f,r.w,r.h,i,te._MIN_CHARS_DATA_LABEL))return}if(null!=V.getPattern(t,a,s)){var y=.15*(C=f.getDimensions()).h,v=e.PathUtils.roundedRectangle(C.x-y,C.y,C.w+2*y,C.h,2,2,2,2),A=new e.Path(t.getCtx(),v);A.setSolidFill("#FFFFFF",.9),i.addChild(A)}}if(z.isBar(t)){var x,b=f.getDimensions(),I=!1,T=t.getPlotArea().getDimensions();if("left"==_&&b.x<0)I=!0,x=r.x-te._MARKER_DATA_LABEL_GAP;else if("right"==_&&b.x+b.w>T.w+te._MARKER_DATA_LABEL_GAP)I=!0,x=T.w-r.w-te._MARKER_DATA_LABEL_GAP;else{if("top"==_&&b.y<0)return;if("bottom"==_&&b.y+b.h>T.y+T.h+te._MARKER_DATA_LABEL_GAP)return}if(I){if(!isNaN(p))return;if(!e.TextUtils.fitText(f,x,r.h,i,1))return;C=f.getDimensions(),"left"==_?f.setX(r.x-C.w/2-te._MARKER_DATA_LABEL_GAP):"right"==_&&f.setX(r.x+r.w+C.w/2+te._MARKER_DATA_LABEL_GAP)}}V.optimizeMarkerStroke(t)&&f.setSolidStroke("none"),i.addChild(f),t.addDataLabel(f)}}}},te._renderDataLabelForMarker=function(t,i,r){var a=t.getEventManager().getLogicalObject(r);if(a){var s=a.getSeriesIndex(),n=a.getGroupIndex(),o=a.getNestedDataItemIndex();if(r instanceof e.SimpleMarker){var l=new e.Rectangle(r.getCx()-r.getWidth()/2,r.getCy()-r.getHeight()/2,r.getWidth(),r.getHeight());te._renderDataLabel(t,i,l,s,n,o,r.getDataColor())}else r instanceof y&&(te._renderDataLabel(t,i,r.getBoundingBox1(),s,n,o,r.getDataColor(),"low"),te._renderDataLabel(t,i,r.getBoundingBox2(),s,n,o,r.getDataColor(),"high"))}},te._renderScatterBubble=function(t,i,r,a,s){var n,o=te._filterScatterBubble(t,a,s),l=H.getSeriesCount(t);for(n=0;n<l;n++)"none"!=V.getLineType(t,n)&&te._renderLinesForSeries(t,r,n,s);var h=V.getMarkerBorderColor(t),u=V.getBorderWidth(t),g=new e.SolidStroke(h,null,u),d=[];if(o)for(var c=V.optimizeMarkerStroke(t),p=c?g.getColor():null,_=c?g.getWidth():null,f=0;f<o.length;f++){var S=o[f],C=te._createMarker(t,S,p,_);d.push(C)}else{for(n=0;n<l;n++){var m=te._getMarkersForSeries(t,n,s,g);d=d.concat(m)}a&&X.sortMarkers(d)}z.isBubble(t)?te._addMarkersToContainer(t,r,d,g):te._addMarkersToContainer(t,i,d,g)},te._renderMarkersForSeries=function(t,i,r,a){var s,n=V.getMarkerBorderColor(t,r),o=V.getBorderWidth(t,r),l=new e.SolidStroke(n,null,o);s=V.isRangeSeries(t,r)?te._getRangeMarkersForSeries(t,r,a):te._getMarkersForSeries(t,r,a,l),te._addMarkersToContainer(t,i,s,l)},te._addMarkersToContainer=function(t,i,r,a){var s=i,n=V.optimizeMarkerStroke(t),o=V.optimizeMarkerFill(t);(n||o)&&(s=new e.Container(t.getCtx()),n?s.setStroke(a):s.setInvisibleFill(),i.addChild(s));for(var l=0;l<r.length;l++)s.addChild(r[l]),te._renderDataLabelForMarker(t,s,r[l]);t._currentMarkers.push(r)},te._getMarkerInfo=function(t,i,r,a,s){var n=t.getOptions(),o=H.getValue(t,i,r,a);if(null==o||isNaN(o))return null;if(H.isDataItemFiltered(t,i,r))return null;var l=H.getGroupCount(t),h=V.isMarkerDisplayed(t,i,r,a);if(!h&&(null==a||a<0))if("jet"!=n._environment&&N.isMixedFrequency(t))l<2&&(h=!0);else{var u=l-1,g=z.isPolar(t),d=g&&u>0&&0==r?u:r-1,c=g&&u>0&&r==u?0:r+1,p=H.getValue(t,i,d),_=H.getValue(t,i,c);null!=p&&!isNaN(p)||null!=_&&!isNaN(_)||(h=!0)}if(!h){if(z.isSpark(t))return null;if((n._duringZoomAndScroll||z.isOverview(t))&&!H.isDataSelected(t,i,r,a))return null}if(!V.isDataItemRendered(t,i,r,a))return!1;var f=!0,S=H.getMarkerPosition(t,i,r,a,s),C=V.getMarkerSize(t,i,r,a);return s&&S&&C&&(f=s.intersects(new e.Rectangle(S.x-C/2,S.y-C/2,C,C))),S&&f?{seriesIndex:i,groupIndex:r,itemIndex:a,x:S.x,y:S.y,size:C,markerDisplayed:h}:null},te._getScatterBubbleMarkerInfo=function(e,t,i,r){if(!V.isDataItemRendered(e,t,i))return!1;var a=H.getScatterBubbleMarkerPosition(e,t,i);if(!a)return null;var s=V.getMarkerSize(e,t,i);return s?{seriesIndex:t,groupIndex:i,x:a.x,y:a.y,size:s}:null},te._getMarkersForSeries=function(e,t,i,r){if(!V.isSeriesRendered(e,t))return[];for(var a=V.optimizeMarkerStroke(e),s=a?r.getColor():null,n=a?r.getWidth():null,o=[],l=H.getGroupCount(e),h=0;h<l;h++){var u=te._getMarkerInfo(e,t,h,null,i);if(u){var g=te._createMarker(e,u,s,n);null!=g&&o.push(g)}}return o},te._createMarker=function(t,i,r,s){var n,o=e.Agent.isTouchDevice(),l=t.getCtx(),h=V.optimizeMarkerStroke(t),u=V.optimizeMarkerFill(t),g=i.seriesIndex,d=i.groupIndex,c=i.itemIndex,p=V.getMarkerColor(t,g,d,c),_=V.getMarkerShape(t,g,d,c),f=i.markerDisplayed;if(null==f&&(f=V.isMarkerDisplayed(t,g,d,c)),f){var C=V.getImageSource(t,g,d,c,"source");if(C){var m=V.getImageSource(t,g,d,c,"sourceSelected"),y=V.getImageSource(t,g,d,c,"sourceHover"),v=V.getImageSource(t,g,d,c,"sourceHoverSelected");n=new e.ImageMarker(l,i.x,i.y,i.size,i.size,null,C,m,y,v)}else{(n=new e.SimpleMarker(l,_,t.getSkin(),i.x,i.y,i.size,i.size,null,null,!0)).setFill(Y.getMarkerFill(t,g,d,c));var A=V.getMarkerBorderColor(t,g,d,c),x=V.getBorderWidth(t,g,d,c);A==r&&x==s||n.setSolidStroke(A,null,x),n.setDataColor(p,!0);var b=e.SelectionEffectUtils.getHoverBorderColor(p),I=V.getSelectedInnerColor(t),T=V.getSelectedOuterColor(t);n.setHoverStroke(new e.SolidStroke(I,1,1),new e.SolidStroke(b,1,3.5)),n.setSelectedStroke(new e.SolidStroke(I,1,1.5),new e.SolidStroke(T,1,4.5)),n.setSelectedHoverStroke(new e.SolidStroke(I,1,1.5),new e.SolidStroke(b,1,4.5)),n.setClassName(V.getMarkerClassName(t,g,d,c)),n.setStyle(V.getMarkerStyle(t,g,d,c))}V.isSelectable(t,g,d)&&n.setCursor(e.SelectionEffectUtils.getSelectingCursor()),o&&i.size<te._MIN_TOUCH_MARKER_SIZE&&te._addMarkerHitArea(n,i.x,i.y,h)}else V.isSelectable(t,g,d)?((n=new S(l,_,i.x,i.y,i.size,h)).setCursor(e.SelectionEffectUtils.getSelectingCursor()),o&&te._addMarkerHitArea(n,i.x,i.y,h)):(o&&(i.size=te._MIN_TOUCH_MARKER_SIZE),n=new S(l,e.SimpleMarker.SQUARE,i.x,i.y,i.size,h)),null!=n&&(u||n.setInvisibleFill(),n.setDataColor(p));return null!=n&&a.associate(n,t,g,d,c,i),n},te._addMarkerHitArea=function(t,i,r,a){var s=new e.Rect(t.getCtx(),i-te._MIN_TOUCH_MARKER_SIZE/2,r-te._MIN_TOUCH_MARKER_SIZE/2,te._MIN_TOUCH_MARKER_SIZE,te._MIN_TOUCH_MARKER_SIZE);a&&s.setSolidStroke("none"),s.setInvisibleFill(),t.addChild(s)},te._getRangeMarkersForSeries=function(t,i,r){if(!V.isSeriesRendered(t,i))return[];for(var s=e.Agent.isTouchDevice(),n=t.getCtx(),o=t.xAxis,l=H.isAssignedToY2(t,i)?t.y2Axis:t.yAxis,h=t.getOptions(),u=H.getGroupCount(t),g=[],d=0;d<u;d++)if(!H.isDataItemFiltered(t,i,d)&&V.isDataItemRendered(t,i,d)){var c=o.getCoordAt(H.getXValue(t,i,d)),p=l.getUnboundedCoordAt(H.getLowValue(t,i,d)),_=l.getUnboundedCoordAt(H.getHighValue(t,i,d));if(null!=c&&null!=p&&null!=_){var f=V.isMarkerDisplayed(t,i,d);if(!f){var S=u-1,C=z.isPolar(t),m=C&&S>0&&0==d?S:d-1,v=C&&S>0&&d==S?0:d+1,A=H.getLowValue(t,i,m),x=H.getHighValue(t,i,m),b=H.getLowValue(t,i,v),I=H.getHighValue(t,i,m);null==A&&null==x&&null==b&&null==I&&(f=!0)}if(!(h._duringZoomAndScroll||z.isOverview(t)||z.isSpark(t))||f||H.isDataSelected(t,i,d)){var T=te.convertAxisCoord(t,new e.Point(c,p),r),E=te.convertAxisCoord(t,new e.Point(c,_),r),D=new e.Point((T.x+E.x)/2,(T.y+E.y)/2),O=V.getMarkerSize(t,i,d),P=new y(n,T.x,T.y,E.x,E.y,O,!f),M=Y.getMarkerFill(t,i,d),R=V.getMarkerBorderColor(t,i,d),w=V.getBorderWidth(t,i,d),L=new e.SolidStroke(R,null,w),B=V.getMarkerColor(t,i,d),F=V.getSelectedInnerColor(t),k=V.getSelectedOuterColor(t);P.setStyleProperties(M,L,B,F,k),V.isSelectable(t,i,d)&&P.setCursor(e.SelectionEffectUtils.getSelectingCursor());var N=new e.Line(n,T.x,T.y,E.x,E.y);N.setSolidStroke("rgba(0,0,0,0)",null,s?Math.max(O,te._MIN_TOUCH_MARKER_SIZE):O),P.addChild(N),g.push(P),a.associate(P,t,i,d,null,D)}}}return g},te._renderBars=function(t,i,r){for(var s=z.isHorizontal(t),n=z.isPolar(t),o=z.isStock(t),l="pixel"==V.getBarSpacing(t),h=e.Agent.isRightToLeft(t.getCtx()),u=V.isStackLabelRendered(t),g=z.isStacked(t),c=V.getSelectedInnerColor(t),p=V.getSelectedOuterColor(t),_=t.getOptions()._duringZoomAndScroll,f=V.getGroupWidth(t),S={},C=0;C<H.getSeriesCount(t);C++)if("bar"==V.getSeriesType(t,C)){te._filterPointsForSeries(t,C);for(var y="",v=t.getOptionsCache().getFromCachedMap("itemStyleSet",C),A=H.getStackCategory(t,C)||"",x=H.isAssignedToY2(t,C),b=H.getViewportMinMaxGroupIndex(t,C),I=b.min-1;I<=b.max+1;I++)if(!H.isDataItemFiltered(t,C,I)&&V.isDataItemRendered(t,C,I)&&0!=H.getZValue(t,C,I)){var T=H.getBarInfo(t,C,I,r);if(null!=T){var E=T.yCoord,D=T.baseCoord,O=T.axisCoord,P=T.x1,M=T.x2,R=T.barWidth;if(g){var w=""+I+A+x+(H.getValue(t,C,I)<0);if(Math.abs(D-E)<.5&&Math.abs(E-S[w])<.5&&!H.isOutermostBar(t,C,I))continue;S[w]&&(D=S[w]),S[w]=E}var L,B=!1;if(Math.abs(E-D)<1&&(V.isRangeSeries(t,C)?E--:g&&!H.isOutermostBar(t,C,I)||(B=!0,E=E>D||s&&!h&&E==D?D+3:D-3)),n)L=new m(t,O,D,E,P,M,r);else{var F=_&&f<5&&!v;if(L=new d(t,O,D,E,P,M,F),F){var k=L.getBoundingBox();y+=e.PathUtils.moveTo(k.x,k.y)+e.PathUtils.horizontalLineTo(k.x+k.w)+e.PathUtils.verticalLineTo(k.y+k.h)+e.PathUtils.horizontalLineTo(k.x)+e.PathUtils.closePath();continue}}i.addChild(L),V.isSelectable(t,C,I)&&L.setCursor(e.SelectionEffectUtils.getSelectingCursor());var N,G=null;if(B)N=e.SolidFill.invisibleFill();else{N=Y.getBarFill(t,C,I,R);var U=V.getBorderColor(t,C,I),j=V.getBorderWidth(t,C,I);U&&(G=new e.SolidStroke(U,null,j))}var W=V.getColor(t,C,I),X=V.getClassName(t,C,I),Z=V.getStyle(t,C,I);L.setStyleProperties(N,G,W,c,p,X,Z),l&&L.setPixelHinting(!0),a.associate(L,t,C,I,null,T.dataPos),V.isRangeSeries(t,C)?(te._renderDataLabel(t,i,L.getBoundingBox(),C,I,null,W,"low",!1,L.getOriginalBarSize()),te._renderDataLabel(t,i,L.getBoundingBox(),C,I,null,W,"high",!1,L.getOriginalBarSize())):te._renderDataLabel(t,i,L.getBoundingBox(),C,I,null,W,null,!1,L.getOriginalBarSize());var K=new Array;K.push(L),o&&0!=C||t._currentMarkers.push(K),u&&H.isOutermostBar(t,C,I)&&te._renderDataLabel(t,i,L.getBoundingBox(),C,I,null,null,null,!0,L.getOriginalBarSize())}}if(y){var q=new e.Path(t.getCtx(),y),Q=V.getColor(t,C);q.setSolidFill(Q);var J=V.getBorderColor(t,C);if(J){var $=V.getBorderWidth(t,C);q.setSolidStroke(J,null,$)}var ee=V.getClassName(t,C),ie=V.getStyle(t,C);q.setClassName(ee).setStyle(ie),l&&q.setPixelHinting(!0),i.addChild(q)}}},te._renderStock=function(t,i,r){var s=t.getOptions(),n=t.xAxis,o=t.yAxis;if("candlestick"==V.getSeriesType(t,0))for(var l=H.getViewportMinMaxGroupIndex(t,0),h=l.min-1;h<=l.max+1;h++)if(V.isDataItemRendered(t,0,h)){var u=H.getDataItem(t,0,h);if(u){var g=u.open,d=u.close,c=u.low,_=u.high,f=null!=c&&null!=_;if(null!=g&&null!=d){var S,C=H.getXValue(t,0,h),m=n.getUnboundedCoordAt(C),y=V.getBarWidth(t,0,h),v=o.getBoundedCoordAt(g),A=o.getBoundedCoordAt(d),x=null;f&&(S=o.getBoundedCoordAt(c),x=o.getBoundedCoordAt(_));var b=new p(t.getCtx(),m,y,v,A,S,x);i.addChild(b),V.isSelectable(t,0,h)&&b.setCursor(e.SelectionEffectUtils.getSelectingCursor());var I=Y.getBarFill(t,0,h,y),T=null,E=V.getBorderColor(t,0,h),D=V.getBorderWidth(t,0,h);E?T=new e.SolidStroke(E,null,D):I instanceof e.PatternFill&&(T=new e.SolidStroke(I.getColor(),null,D));var O=V.getColor(t,0,h),P=V.getSelectedInnerColor(t),M=V.getSelectedOuterColor(t),R=s.styleDefaults.stockRangeColor;b.setChangeStyle(I,T,O,P,M),b.setRangeStyle(new e.SolidFill(R),T,R,M);var w=new e.Point(m,(v+A)/2);a.associate(b,t,0,h,null,w);var L=new Array;L.push(b._changeShape),t._currentMarkers.push(L)}}}},te._renderBoxPlot=function(t,i,r){for(var s=t.xAxis,n=0;n<H.getSeriesCount(t);n++)for(var o=H.getViewportMinMaxGroupIndex(t,n),l=o.min-1;l<=o.max+1;l++)if(V.isDataItemRendered(t,n,l)&&"boxPlot"==V.getSeriesType(t,n)){var h=H.getDataItem(t,n,l);if(h){var u=h.low,g=h.q1,d=h.q2,p=h.q3,_=h.high;if(null!=u&&null!=g&&null!=d&&null!=p&&null!=_){var f=V.getBarWidth(t,n,l),S=V.getBarCategoryOffsetMap(t,l),C=H.isAssignedToY2(t,n),m=H.getStackCategory(t,n),y=S[C?"y2":"y"][m]+f/2;e.Agent.isRightToLeft(t.getCtx())&&z.isVertical(t)&&(y*=-1);var v=H.getXValue(t,n,l),A=s.getUnboundedCoordAt(v)+y,x=C?t.y2Axis:t.yAxis,b=x.getBoundedCoordAt(u),I=x.getBoundedCoordAt(g),T=x.getBoundedCoordAt(d),E=x.getBoundedCoordAt(p),D=x.getBoundedCoordAt(_),O=V.getBoxPlotStyleOptions(t,n,l),P=new c(t,A,f,b,I,T,E,D,O);i.addChild(P),V.isSelectable(t,n,l)&&P.setCursor(e.SelectionEffectUtils.getSelectingCursor());var M=te.convertAxisCoord(t,new e.Point(A,T),r);a.associate(P,t,n,l,null,M),te._renderBoxPlotMarkers(t,i,n,l,r,A),t._currentMarkers.push([P._medianLine])}}}},te._renderBoxPlotMarkers=function(t,i,r,a,s,n){for(var o=V.getMarkerBorderColor(t,r,a),l=V.getBorderWidth(t,r,a),h=new e.SolidStroke(o,null,l),u=[],g=H.getNestedDataItemCount(t,r,a),d=0;d<g;d++){var c=te._getMarkerInfo(t,r,a,d,s);if(c){z.isHorizontal(t)?c.y=n:c.x=n;var p=te._createMarker(t,c,o,l);null!=p&&u.push(p)}}te._addMarkersToContainer(t,i,u,h)},te._renderLines=function(e,t,i,r){var a,s=[],n=H.getSeriesCount(e);for(a=0;a<n;a++)V.isSeriesRendered(e,a)&&"line"==V.getSeriesType(e,a)&&s.push(a);for(var o=0;o<s.length;o++)a=s[o],"none"!=V.getLineType(e,a)&&(te._filterPointsForSeries(e,a),te._renderLinesForSeries(e,i,a,r));for(o=0;o<s.length;o++)te._renderMarkersForSeries(e,t,s[o],r)},te._renderAreas=function(e,t,i,r){for(var a=H.getSeriesCount(e),s=r?"lineWithArea":"area",n=[],o=[],l=0;l<a;l++)V.isSeriesRendered(e,l)&&V.getSeriesType(e,l)==s&&(H.isAssignedToY2(e,l)?o.push(l):n.push(l));n.length>0&&te._renderAreasForAxis(e,t,n,e.yAxis.getBaselineCoord(),i,r),o.length>0&&te._renderAreasForAxis(e,t,o,e.y2Axis.getBaselineCoord(),i,r)},te._renderAreasForAxis=function(t,i,r,s,n,o){for(var l=z.isStacked(t),h=te.createClippedGroup(t,i,n),u={},g={},d={},c={},p=[],S=H.getGroupCount(t),C=0;C<S;C++)p.push(new _(null,s,s,C,H.getGroup(t,C),!0));for(var m=0;m<r.length;m++){var y=r[m],v=H.getStackCategory(t,y),A=H.isSeriesNegative(t,y),x=u[v],b=g[v],I=d[v],T=c[v];if("none"!=V.getLineType(t,y)){var E,D,O,P=Y.getAreaFill(t,y),M=V.getBorderColor(t,y),R=V.getBorderWidth(t,y),w=V.getAreaClassName(t,y),L=V.getAreaStyle(t,y),B=M?new e.SolidStroke(M,null,R):null,F=V.getLineType(t,y);te._filterPointsForSeries(t,y),V.isRangeSeries(t,y)?(E=te._getCoordsForSeries(t,y,n,"high"),D=te._getCoordsForSeries(t,y,n,"low"),O=F):A?(E=te._getAreaCoordsForSeries(t,y,n,I||p),D=I||[],O=T):(E=te._getAreaCoordsForSeries(t,y,n,x||p),D=x||[],O=b);var k=new f(t,!0,n,s,L,w,P,B,F,E,O,D);h.addChild(k),t._currentAreas.push(k),a.associate(k,t,y),A?(d[v]=E,c[v]=F):(u[v]=E,g[v]=F),l||((o||V.getDataItemGaps(t)>0&&!M)&&te._renderLinesForSeries(t,h,y,n,!o),o||te._renderMarkersForSeries(t,i,y,n),m+1<r.length&&(h=te.createClippedGroup(t,i,n)))}else te._renderMarkersForSeries(t,i,y,n)}for(m=0;m<r.length;m++)if(y=r[m],"none"!=V.getLineType(t,y)){var N=V.getBorderColor(t,y)||V.getBorderColor(t,y+1);l&&(o||V.getDataItemGaps(t)>0&&!N)&&te._renderLinesForSeries(t,h,y,n,!o),(l||o)&&te._renderMarkersForSeries(t,i,y,n)}},te._getAreaCoordsForSeries=function(e,t,i,r){for(var a=te._getCoordsForSeries(e,t,i),s=[],n=0;n<r.length;n++)s.push(r[n].clone());var o=a.length-1,l=z.isPolar(e);for(n=0;n<a.length;n++)if(null!=a[n].x){var h=s[a[n].groupIndex],u=l&&0==n?o:n-1,g=l&&n==o?0:n+1;u>=0&&null!=a[u].x&&(h.y1=a[n].y1),g<=o&&null!=a[g].x&&(h.y2=a[n].y2),h.x=a[n].x,h.filtered=h.y1==h.y2&&a[n].filtered}return s},te._renderLinesForSeries=function(t,i,r,s,n){var o;if(n){var l=2.5*V.getDataItemGaps(t);o=new e.SolidStroke(V.getBackgroundColor(t,!0),1,l)}else{var h=V.getColor(t,r),u=V.getLineWidth(t,r),g=e.Stroke.convertTypeString(V.getLineStyle(t,r));(o=new e.SolidStroke(h,1,u)).setStyle(g)}var d=H.isAssignedToY2(t,r)?t.y2Axis.getBaselineCoord():t.yAxis.getBaselineCoord(),c=V.getLineType(t,r),p=V.getClassName(t,r),_=V.getStyle(t,r),S=function(e){var n=te._getCoordsForSeries(t,r,s,e),l=new f(t,!1,s,d,_,p,null,o,c,n);i.addChild(l),a.associate(l,t,r)};V.isRangeSeries(t,r)?(S("high"),S("low")):S("value")},te._filterScatterBubble=function(t,i,r){var a,s=H.getSeriesCount(t),n=H.getGroupCount(t);if(s*n<te.FILTER_THRESHOLD_SCATTER_BUBBLE)return null;for(var o=[],l=0;l<s;l++)if(V.isSeriesRendered(t,l))for(var h=0;h<n;h++)null!=(a=te._getScatterBubbleMarkerInfo(t,l,h,r))&&o.push(a);if(o.length<te.FILTER_THRESHOLD_SCATTER_BUBBLE)return null;i&&X.sortMarkerInfos(o);for(var u=new e.PixelMap(25,new e.PixelMap(5,new e.PixelMap)),g=[],d=o.length-1;d>=0;d--){if(a=o[d],!X.checkPixelMap(u,a.x,a.y,a.size)){var c=V.getColor(t,a.seriesIndex,a.groupIndex),p=V.isMarkerDisplayed(t,l,h)?e.ColorUtils.getAlpha(c):0;p>0&&(X.updatePixelMap(u,a.x,a.y,a.size,p),g.push(a))}}return t.getCache().putToCache("dataFiltered",!0),g.reverse(),g},te._filterPointsForSeries=function(e,t){if(!z.isPolar(e)&&!V.isRangeSeries(e,t)){var i=e.__getPlotAreaSpace().w,r=H.getSeriesItem(e,t).items,a="bar"==V.getSeriesType(e,t),s=e.xAxis.getInfo(),n=(s.getDataMax()-s.getDataMin())/(s.getViewportMax()-s.getViewportMin()),o=a?.5:2,l=n?Math.round(o*(r.length/n)/i):1;if(l<(a?2:3))for(var h=0;h<r.length;h++)(p=r[h])&&(p._filtered=!1);else{var u,g,d,c,p,_,f=!1;for(h=0;h<r.length;h+=l){u=-1,g=-1/0,d=-1,c=1/0;for(var S=h;S<Math.min(h+l,r.length);S++)_=H.getCumulativeValue(e,t,S),p=r[S],null!=_&&null!=p&&((!a||_>0)&&_>g&&(u=S,g=_),(!a||_<0)&&_<c&&(d=S,c=_),p._filtered=!0,f=!0);for(S=h;S<Math.min(h+l,r.length);S++)null!=(p=r[S])&&(S!=u&&S!=d||(p._filtered=!1))}e.getCache().putToCache("dataFiltered",f)}}},te._getCoordsForSeries=function(e,t,i,r){var a=e.xAxis,s=e.yAxis;H.isAssignedToY2(e,t)&&(s=e.y2Axis);for(var n=[],o=H.getViewportMinMaxGroupIndex(e,t),l=o.min-1;l<=o.max+1;l++){var h=H.getGroup(e,l);if(null!=h){var u=H.getXValue(e,t,l),g=null;if("low"==r?g=H.getLowValue(e,t,l):"high"==r?g=H.getHighValue(e,t,l):null!=H.getValue(e,t,l)&&(g=H.getCumulativeValue(e,t,l)),null!=g&&!isNaN(g)&&V.isDataItemRendered(e,t,l)){z.isPolar(e)&&(g=Math.max(g,s.getInfo().getViewportMin()));var d=a.getUnboundedCoordAt(u),c=s.getUnboundedCoordAt(g);if(null!=d&&null!=c){var p=new _(d,c,c,l,h,H.isDataItemFiltered(e,t,l));n.push(p)}else n.push(new _(null,null,null,l,h,!1))}else n.push(new _(null,null,null,l,h,!1))}}return n},te.createClippedGroup=function(t,i,r){var a=new e.Container(i.getCtx());i.addChild(a);var s=new e.ClipPath(t.getId()),n=te._extendClipGroup(t);if(z.isPolar(t)){var o=r.x+r.w/2,l=r.y+r.h/2;if(N.isGridPolygonal(t)){var h=e.PolygonUtils.getRegularPolygonPoints(o,l,H.getGroupCount(t),t.getRadius(),0);s.addPolygon(h)}else s.addCircle(o,l,t.getRadius())}else z.isHorizontal(t)?s.addRect(r.x-n,r.y,r.w+2*n,r.h):s.addRect(r.x,r.y-n,r.w,r.h+2*n);return a.setClipPath(s),a},te.polarToCartesian=function(t,i,r){var a=r.x+r.w/2+t*Math.sin(i),s=r.y+r.h/2-t*Math.cos(i);return new e.Point(a,s)},te.convertAxisCoord=function(t,i,r){if(z.isPolar(t)){var a=te.polarToCartesian(i.y,i.x,r);return new e.Point(a.x,a.y)}return z.isHorizontal(t)?new e.Point(i.y,i.x):new e.Point(i.x,i.y)},te._extendClipGroup=function(e){if((z.hasLineSeries(e)||z.hasLineWithAreaSeries(e))&&!z.isSpark(e)){var t=V.getLineWidth(e),i=function(e){var i=e.getInfo(),r=i.getCoordAt(i.getGlobalMax()),a=i.getCoordAt(i.getDataMax()),s=i.getCoordAt(i.getGlobalMin()),n=i.getCoordAt(i.getDataMin());return null!=r&&null!=a&&a-r<=t/2||null!=s&&null!=n&&s-n<=t/2};if(e.yAxis&&i(e.yAxis)||e.y2Axis&&i(e.y2Axis))return Math.ceil(t/2)}return 0};var ie=new Object;e.Obj.createSubclass(ie,e.Obj),ie._DEFAULT_3D_GAP_RATIO=1/36,ie._DEFAULT_2D_GAP_RATIO=1/70,ie._MAX_WIDTH_FOR_GAPS=.25,ie._GROUP_INDEX=0,ie._SLICE_VALUE_THRESHOLD=1e-4,ie.render=function(t,i,r){var a=new e.Container(t.getCtx());a.setTranslate(r.x,r.y),i.addChild(a),t.setPlotArea(a);var s,n=z.isHorizontal(t);if(n)s=new e.Rectangle(0,0,r.w,r.h);else{var o=new e.Matrix,l=e.Agent.isRightToLeft(t.getCtx())?-1:1;o.translate(-r.h/2,-r.w/2),o.rotate(l*Math.PI/2),o.translate(r.x+r.w/2,r.y+r.h/2),s=new e.Rectangle(0,0,r.h,r.w),a.setMatrix(o)}G.addPlotAreaDnDBackground(t,a,r,n),ie._renderFunnelSlices(t,a,s)||J.renderEmptyText(t,i,r);var h=H.getInitialSelection(t);G.setInitialSelection(t,h),t.highlight(V.getHighlightedCategories(t))},ie._renderFunnelSlices=function(e,t,i){for(var r=e.getOptions(),s=H.getSeriesCount(e),n=V.getDataItemGaps(e),o=("on"==r.styleDefaults.threeDEffect?ie._DEFAULT_3D_GAP_RATIO:ie._DEFAULT_2D_GAP_RATIO)*i.w,l=n*Math.min(ie._MAX_WIDTH_FOR_GAPS*i.w/(s-1),o),h=0,u=0,g=0,d=0;d<s;d++){if(V.isDataItemRendered(e,d))null==(p=H.getTargetValue(e,d))&&(p=H.getValue(e,d,ie._GROUP_INDEX)),p<=0||(h+=p)}if(0==h)return!1;for(d=s-1;d>=0;d--)if(V.isDataItemRendered(e,d)){var c,p=H.getValue(e,d,ie._GROUP_INDEX),_=H.getTargetValue(e,d);if(!(p<=0&&null==_||null!=_&&_<=0))if(!((null!=_?_:p)<ie._SLICE_VALUE_THRESHOLD*h))null!=_?(g+=_/h,c=new A(e,d,u,i.w,i.h,1-g,_/h,p/_,l)):(g+=p/h,c=new A(e,d,u,i.w,i.h,1-g,p/h,null,l)),u++,t.addChild(c),a.associate(c,e,d,ie._GROUP_INDEX)}return!0};var re=new Object;e.Obj.createSubclass(re,e.Obj),re._DEFAULT_GAP_RATIO=1/70,re._MAX_HEIGHT_FOR_GAPS=.25,re._GROUP_INDEX=0,re.render=function(t,i,r){var a=new e.Container(t.getCtx());a.setTranslate(r.x,r.y),i.addChild(a),t.setPlotArea(a);var s=new e.Rectangle(0,0,r.w,r.h);G.addPlotAreaDnDBackground(t,a,r,!0),re._renderPyramidSlices(t,a,s)||J.renderEmptyText(t,i,r);var n=H.getInitialSelection(t);G.setInitialSelection(t,n),t.highlight(V.getHighlightedCategories(t))},re._renderPyramidSlices=function(e,t,i){for(var r=H.getSeriesCount(e),s=V.getDataItemGaps(e),n=re._DEFAULT_GAP_RATIO*i.h,o=s*Math.min(re._MAX_HEIGHT_FOR_GAPS*i.h/(r-1),n),l=0,h=0,u=0,g=0;g<r;g++){if(V.isDataItemRendered(e,g))(d=H.getValue(e,g,re._GROUP_INDEX))<=0||(l+=d)}if(0==l)return!1;for(g=0;g<r;g++){var d;if(V.isDataItemRendered(e,g))if(!((d=H.getValue(e,g,re._GROUP_INDEX))<=0)){var c=new x(e,g,h,i.w,i.h,u,d/l,o);u+=d/l,h++,t.addChild(c),a.associate(c,e,g,re._GROUP_INDEX)}}return!0};var ae=new Object;e.Obj.createSubclass(ae,e.Obj),ae.renderBackgroundObjects=function(e,t,i){ae._renderObjects(e,t,i,"back")},ae.renderForegroundObjects=function(e,t,i){ae._renderObjects(e,t,i,"front")},ae._renderObjects=function(e,t,i,r){ae._renderObjectsForAxis(e,t,i,r,e.xAxis,U.getAxisRefObjs(e,"x")),ae._renderObjectsForAxis(e,t,i,r,e.yAxis,U.getAxisRefObjs(e,"y")),ae._renderObjectsForAxis(e,t,i,r,e.y2Axis,U.getAxisRefObjs(e,"y2"))},ae._renderObjectsForAxis=function(e,t,i,r,a,n){if(n&&a)for(var o=0;o<n.length;o++){var l=n[o];if(U.isObjectRendered(e,l)&&(l&&U.getLocation(l)==r)){var h,u=U.getType(l);if("area"==u?h=ae._createReferenceArea(l,e,i,a):"line"==u&&(h=ae._createReferenceLine(l,e,i,a)),null!=h){var g=a==e.xAxis?"xAxis":a==e.yAxis?"yAxis":"y2Axis",d=new s(e,[h],l,o,g);e.registerObject(d),e.getEventManager().associate(h,d),t.addChild(h)}}}},ae._createReferenceArea=function(t,i,r,a){var s,n=i.getCtx(),o=a.getPosition(),l="top"==o||"bottom"==o,h="radial"==o,u=U.getColor(t),g=U.getLineType(t),d=t.style||t.svgStyle,c=t.className||t.svgClassName;if(null==t.items||a!=i.yAxis&&a!=i.y2Axis){var p=U.getLowValue(t),S=U.getHighValue(t);null!=p&&p!=-1/0||(p=a.getInfo().getGlobalMin()),null!=S&&S!=1/0||(S=a.getInfo().getGlobalMax());var C=ae._getAxisCoord(i,a,p),m=ae._getAxisCoord(i,a,S);if(z.isPolar(i)){var y,v=r.x+r.w/2,A=r.y+r.h/2;if(h)if(N.isGridPolygonal(i)){var x=H.getGroupCount(i),b=e.PolygonUtils.getRegularPolygonPoints(v,A,x,m,0,1),I=e.PolygonUtils.getRegularPolygonPoints(v,A,x,C,0,0);y=e.PathUtils.polyline(b)+e.PathUtils.polyline(I)+e.PathUtils.closePath()}else y=e.PathUtils.moveTo(v,A-m)+e.PathUtils.arcTo(m,m,Math.PI,1,v,A+m)+e.PathUtils.arcTo(m,m,Math.PI,1,v,A-m)+e.PathUtils.moveTo(v,A-C)+e.PathUtils.arcTo(C,C,Math.PI,0,v,A+C)+e.PathUtils.arcTo(C,C,Math.PI,0,v,A-C)+e.PathUtils.closePath();else{var T=i.getRadius(),E=te.polarToCartesian(T,C,r),D=te.polarToCartesian(T,m,r);y=e.PathUtils.moveTo(v,A)+e.PathUtils.lineTo(E.x,E.y)+e.PathUtils.arcTo(T,T,m-C,e.Agent.isRightToLeft(n)?0:1,D.x,D.y)+e.PathUtils.lineTo(D.x,D.y)+e.PathUtils.closePath()}s=new e.Path(n,y)}else{var O;O=l?[C,0,m,0,m,r.h,C,r.h]:[0,C,0,m,r.w,m,r.w,C],s=new e.Polygon(n,O)}s.setSolidFill(u),s.setStyle(d).setClassName(c)}else{var P=t.items,M=[],R=[];if(i.xAxis.isGroupAxis())for(;P.length<H.getGroupCount(i);)P.push(null);for(var w=0;w<P.length;w++){var L=P[w],B=U.getLowValue(L),F=U.getHighValue(L);if(null!=B&&null!=F){var k=a.getUnboundedCoordAt(B),G=a.getUnboundedCoordAt(F),Y=i.xAxis.getUnboundedCoordAt(U.getXValue(i,P,w));M.push(new _(Y,G,G)),R.push(new _(Y,k,k))}else M.push(new _),R.push(new _)}s=new f(i,!0,r,null,d,c,new e.SolidFill(u),null,g,M,g,R)}return s},ae._createReferenceLine=function(t,i,r,a){var s=a.getPosition(),n="top"==s||"bottom"==s,o="radial"==s,l="tangential"==s,h=U.getLineWidth(t),u=U.getLineType(t),g=U.getColor(t),d=new e.SolidStroke(g,1,h),c=t.style||t.svgStyle,p=t.className||t.svgClassName;t.lineStyle&&d.setStyle(e.Stroke.convertTypeString(t.lineStyle));var S,C=i.getCtx();if(null==t.items||a!=i.yAxis&&a!=i.y2Axis){if(!t.value)return null;var m=ae._getAxisCoord(i,a,t.value);if(null==m||m==1/0||m==-1/0)return null;var y=r.x+r.w/2,v=r.y+r.h/2;if(o){if(N.isGridPolygonal(i)){x=e.PolygonUtils.getRegularPolygonPoints(y,v,H.getGroupCount(i),m,0);S=new e.Polygon(C,x)}else S=new e.Circle(C,y,v,m);S.setFill(null)}else if(l){var A=te.polarToCartesian(i.getRadius(),m,r);S=new e.Line(C,y,v,A.x,A.y)}else(S=n?new e.Line(C,m,0,m,r.h):new e.Line(C,0,m,r.w,m)).setPixelHinting(!0);S.setStroke(d),S.setStyle(c).setClassName(p)}else{var x,b=t.items;if([].push(x=[]),i.xAxis.isGroupAxis())for(;b.length<H.getGroupCount(i);)b.push(null);for(var I=[],T=0;T<b.length;T++){var E=b[T],D=null;if(null!=E&&("object"!=typeof E?D=E:null!=E.value&&(D=E.value)),null!=D){var O=a.getUnboundedCoordAt(D),P=i.xAxis.getUnboundedCoordAt(U.getXValue(i,b,T));I.push(new _(P,O,O))}else I.push(new _)}S=new f(i,!1,r,null,c,p,null,d,u,I)}return S},ae._getAxisCoord=function(e,t,i){if(t.isGroupAxis()){var r=H.getGroupIndex(e,i);if(r>=0)return t.getUnboundedCoordAt(r)}return isNaN(i)?null:t.getUnboundedCoordAt(i)},e.SparkChart=function(){},e.Obj.createSubclass(e.SparkChart,e.BaseComponent),e.SparkChart.newInstance=function(t,i,r){var a=new e.SparkChart;return t.getStage().setCursor(""),a.Init(t,i,r),a},e.SparkChart.getDefaults=function(e){return(new ne).getDefaults(e)},e.SparkChart.prototype.Init=function(t,i,r){e.SparkChart.superclass.Init.call(this,t,i,r),this.Defaults=new ne(t),this.EventManager=new oe(this),this.EventManager.addListeners(this),this._chart=e.Chart.newInstance(t,this._onRenderEnd,this),this.addChild(this._chart),e.Agent.isTouchDevice()||this.EventManager.setKeyboardHandler(new e.KeyboardHandler(this.EventManager,this)),this._tooltipMask=new e.Rect(t),this.addChild(this._tooltipMask),this.setId("sparkChart1000"+Math.floor(1e9*Math.random()))},e.SparkChart.prototype.SetOptions=function(t){t?(this.Options=this.Defaults.calcOptions(t),e.Agent.isEnvironmentTest()&&(this.Options.animationOnDisplay="none",this.Options.animationOnDataChange="none")):this.Options||(this.Options=this.GetDefaults())},e.SparkChart.prototype.setId=function(t){e.SparkChart.superclass.setId.call(this,t),this._chart&&this._chart.setId(t+"chart")},e.SparkChart.prototype.render=function(t,i,r){this.SetOptions(t),isNaN(i)||isNaN(r)||(this.Width=i,this.Height=r),this._eventReceived=!1,this._isDoneRendering=!1,le.render(this,this.Width,this.Height);var a=this.Options.shortDesc;this._tooltipMask.setWidth(this.Width),this._tooltipMask.setHeight(this.Height),this._tooltipMask.setInvisibleFill();var s=this.Options.tooltip,n=s?s.renderer:null,o=this.Options.color;if(n){var l={component:this.Options._widgetConstructor,color:o};this._peer=new e.CustomDatatipPeer(this.getCtx().getTooltipManager(),n,o,l),this.EventManager.associate(this._tooltipMask,this._peer)}else a?(this._peer=new e.SimpleObjPeer(null,a,o),this.EventManager.associate(this._tooltipMask,this._peer)):this._peer=null;this.Options._selectingCursor&&this.setCursor(e.SelectionEffectUtils.getSelectingCursor()),this.UpdateAriaAttributes(),this._eventReceived&&this.RenderComplete(),this._isDoneRendering=!0},e.SparkChart.prototype._onRenderEnd=function(e){this._eventReceived=!0,"ready"==e.type&&this._isDoneRendering&&this.RenderComplete()},e.SparkChart.prototype.__getChart=function(){return this._chart},e.SparkChart.prototype.getAutomation=function(){return new se(this)},e.SparkChart.prototype.GetComponentDescription=function(){return e.Bundle.getTranslation(this.getOptions(),"componentName",e.Bundle.UTIL_PREFIX,"CHART")},e.SparkChart.prototype.UpdateAriaAttributes=function(){var t=e.Displayable.generateAriaLabel(e.StringUtils.processAriaLabel(this.GetComponentDescription()),this.Options.shortDesc?[this.Options.shortDesc]:null);this.IsParentRoot()?(this.getCtx().setAriaRole("img"),this.getCtx().setAriaLabel(e.Bundle.getTranslatedString(e.Bundle.UTIL_PREFIX,"COLON_SEP_LIST",[e.Bundle.getTranslatedString(e.Bundle.UTIL_PREFIX,"DATA_VISUALIZATION"),t]))):(this.setAriaRole("img"),this.setAriaProperty("label",t))},e.SparkChart.prototype.__getLogicalObject=function(){return this._peer};var se=function(e){this._sparkChart=e};e.Obj.createSubclass(se,e.Automation),se.prototype.getDataItem=function(e){var t=this._sparkChart.__getChart().getAutomation().getDataItem(0,e);return t?{borderColor:t.borderColor,color:t.color,date:t.x,low:t.low,high:t.high,value:null==t.low||null==t.high?t.value:t.high-t.low}:null};var ne=function(e){this.Init({skyros:ne.VERSION_1,alta:ne.SKIN_ALTA},e)};e.Obj.createSubclass(ne,e.BaseComponentDefaults),ne.SKIN_ALTA={skin:e.CSSStyle.SKIN_ALTA,color:"#267db3"},ne.VERSION_1={skin:e.CSSStyle.SKIN_SKYROS,type:"line",animationOnDisplay:"none",animationOnDataChange:"none",areaSvgClassName:"",emptyText:null,color:"#666699",firstColor:"",lastColor:"",highColor:"",lowColor:"",visualEffects:"auto",baselineScaling:"min",barSpacing:"auto",lineWidth:1,lineStyle:"solid",lineType:"straight",markerSize:5,markerShape:"auto",barGapRatio:.25,referenceObjects:[],svgClassName:"",_statusMessageStyle:new e.CSSStyle("font-size: 12px; color: #404259;")},ne.prototype.getAnimationDuration=function(e){return e.animationDuration};var oe=function(e){this.Init(e.getCtx(),e.dispatchEvent,e),this._sparkChart=e};e.Obj.createSubclass(oe,e.EventManager),oe.prototype.ProcessKeyboardEvent=function(t){if(!this.KeyboardHandler)return!1;if(t.keyCode==e.KeyboardEvent.TAB){var i=this._sparkChart.getCtx().getStageAbsolutePosition();this.ProcessObjectTooltip(t,i.x,i.y,this._sparkChart.__getLogicalObject(),this._sparkChart)}return!1},oe.prototype.OnBlur=function(e){oe.superclass.OnBlur.call(this,e),this.hideTooltip()};var le=new Object;e.Obj.createSubclass(le,e.Obj),le.render=function(e,t,i){var r=e.__getChart(),a=le._convertOptionsObj(e),s=e.getOptions();if("area"==s.type||"line"==s.type||"lineWithArea"==s.type){var n=le._getDataItems(e),o=!1;if(s.firstColor||s.lastColor||s.highColor||s.lowColor)o=!0;else for(var l=0;l<n.length;l++)if(n[l]&&"on"==n[l].markerDisplayed){o=!0;break}if(o&&n.length>0||"none"==s.lineType){var h=s.markerSize/2;t-=2*h,i-=2*h,r.setTranslate(h,h)}}r.render(a,t,i)},le._getDataItems=function(e){var t=e.getOptions();return t&&t.items?t.items:[]},le._convertOptionsObj=function(t){var i=t.getOptions(),r={styleDefaults:{},xAxis:{},yAxis:{},groups:[]};r.translations=i.translations;for(var a=[],s=-1,n=-1,o=-1/0,l=1/0,h=le._getDataItems(t),u=0;u<h.length;u++){var g=h[u],d={};g instanceof Object?(d.value=g.value,d.low=g.low,d.high=g.high,g.date&&(r.timeAxisType="enabled",r.groups.push(g.date)),"on"==g.markerDisplayed&&(d.markerDisplayed="on"),g.color&&(d.color=g.color),g.borderColor&&(d.borderColor=g.borderColor),g.markerShape&&(d.markerShape=g.markerShape),g.markerSize&&(d.markerSize=g.markerSize),(g.className||g.svgClassName)&&(d.svgClassName=g.className||g.svgClassName),(g.style||g.svgStyle)&&(d.svgStyle=g.style||g.svgStyle)):d.value=g,a.push(d);var c=null!=d.value?d.value:Math.max(d.low,d.high);o<c&&(o=c,s=u);var p=null!=d.value?d.value:Math.min(d.low,d.high);l>p&&(l=p,n=u)}i.highColor&&s>=0&&(a[s].markerDisplayed="on",a[s].color||(a[s].color=i.highColor)),i.lowColor&&n>=0&&(a[n].markerDisplayed="on",a[n].color||(a[n].color=i.lowColor)),i.firstColor&&a.length>0&&(a[0].markerDisplayed="on",a[0].color||(a[0].color=i.firstColor)),i.lastColor&&a.length>0&&(a[a.length-1].markerDisplayed="on",a[a.length-1].color||(a[a.length-1].color=i.lastColor)),r.series=[{items:a,areaColor:i.areaColor,svgClassName:i.className||i.svgClassName,svgStyle:i.style||i.svgStyle,areaSvgClassName:i.areaClassName||i.areaSvgClassName,areaStyle:i.areaStyle||i.areaSvgStyle}],i.referenceObjects&&i.referenceObjects.length>0&&(r.yAxis.referenceObjects=i.referenceObjects),r.__spark=!0;var _=i.barSpacing;"auto"==_&&(_=e.Agent.getDevicePixelRatio()>1?"subpixel":"pixel"),r.__sparkBarSpacing=_,r.type=i.type,r.animationOnDataChange=i.animationOnDataChange,r.animationOnDisplay=i.animationOnDisplay,r.emptyText=i.emptyText,i.color&&(r.styleDefaults.colors=[i.color]),r.styleDefaults.animationDuration=i.animationDuration,r.styleDefaults.animationIndicators="none",r.styleDefaults.lineWidth=i.lineWidth,r.styleDefaults.lineStyle=i.lineStyle,r.styleDefaults.lineType=i.lineType,r.styleDefaults.markerSize=i.markerSize,r.styleDefaults.markerShape=i.markerShape,r.styleDefaults.barGapRatio=i.barGapRatio,r.styleDefaults.dataItemGaps="0%",r.xAxis.rendered="off",r.yAxis.rendered="off";var f="zero"==i.baselineScaling,S=o!=l?.1*(o-l):.1*Math.abs(o);return r.yAxis.min=f&&l>=0?0:l-S,r.yAxis.max=f&&o<=0?0:o+S,"none"==i.visualEffects||"area"!=i.type&&"lineWithArea"!=i.type?r.styleDefaults.seriesEffect="color":r.styleDefaults.seriesEffect="gradient",r.layout={gapWidthRatio:0,gapHeightRatio:0},r.legend={rendered:"off"},r._statusMessageStyle=i._statusMessageStyle,r},e.exportProperty(e,"Chart",e.Chart),e.exportProperty(e.Chart,"newInstance",e.Chart.newInstance),e.exportProperty(e.Chart.prototype,"destroy",e.Chart.prototype.destroy),e.exportProperty(e.Chart.prototype,"getAutomation",e.Chart.prototype.getAutomation),e.exportProperty(e.Chart.prototype,"getDefaults",e.Chart.prototype.getDefaults),e.exportProperty(e.Chart.prototype,"getValuesAt",e.Chart.prototype.getValuesAt),e.exportProperty(e.Chart.prototype,"highlight",e.Chart.prototype.highlight),e.exportProperty(e.Chart.prototype,"positionDataCursor",e.Chart.prototype.positionDataCursor),e.exportProperty(e.Chart.prototype,"render",e.Chart.prototype.render),e.exportProperty(e.Chart.prototype,"select",e.Chart.prototype.select),e.exportProperty(t.prototype,"getDomElementForSubId",t.prototype.getDomElementForSubId),e.exportProperty(t.prototype,"getDataItem",t.prototype.getDataItem),e.exportProperty(t.prototype,"getGroup",t.prototype.getGroup),e.exportProperty(t.prototype,"getSeries",t.prototype.getSeries),e.exportProperty(t.prototype,"getGroupCount",t.prototype.getGroupCount),e.exportProperty(t.prototype,"getSeriesCount",t.prototype.getSeriesCount),e.exportProperty(t.prototype,"getTitle",t.prototype.getTitle),e.exportProperty(t.prototype,"getLegend",t.prototype.getLegend),e.exportProperty(t.prototype,"getPlotArea",t.prototype.getPlotArea),e.exportProperty(t.prototype,"getXAxis",t.prototype.getXAxis),e.exportProperty(t.prototype,"getYAxis",t.prototype.getYAxis),e.exportProperty(t.prototype,"getY2Axis",t.prototype.getY2Axis),e.exportProperty(n.prototype,"getId",n.prototype.getId),e.exportProperty(n.prototype,"getSeries",n.prototype.getSeries),e.exportProperty(n.prototype,"getGroup",n.prototype.getGroup),e.exportProperty(e,"SparkChart",e.SparkChart),e.exportProperty(e.SparkChart,"newInstance",e.SparkChart.newInstance),e.exportProperty(e.SparkChart.prototype,"destroy",e.SparkChart.prototype.destroy),e.exportProperty(e.SparkChart.prototype,"getAutomation",e.SparkChart.prototype.getAutomation),e.exportProperty(e.SparkChart.prototype,"getDefaults",e.SparkChart.prototype.getDefaults),e.exportProperty(e.SparkChart.prototype,"render",e.SparkChart.prototype.render),e.exportProperty(se.prototype,"getDataItem",se.prototype.getDataItem)}(dvt);
  return dvt;
});
