/**
 * @license
 * Copyright (c) 2014, 2019, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
define(["ojs/ojcore","jquery","ojs/ojthemeutils","ojs/ojlogger","promise","ojs/ojcomponentcore"],function(t,i,n,e){t.AnimationUtils={};t.AnimationUtils;return t.AnimationUtils._getName=function(i,n){if(!t.AnimationUtils._nameMap){t.AnimationUtils._nameMap={};var e=t.AnimationUtils._nameMap,a=i.style;e.backfaceVisibility=void 0!==a.webkitBackfaceVisibility?"webkitBackfaceVisibility":"backfaceVisibility",e.transform=void 0!==a.webkitTransform?"webkitTransform":"transform",e.transformOrigin=void 0!==a.webkitTransformOrigin?"webkitTransformOrigin":"transformOrigin",e.transition=void 0!==a.webkitTransition?"webkitTransition":"transition",e.transitionend=void 0!==a.webkitTransition?"webkitTransitionEnd":"transitionend"}return t.AnimationUtils._nameMap[n]||n},t.AnimationUtils._getElementStyle=function(i,n){return i.style[t.AnimationUtils._getName(i,n)]},t.AnimationUtils._setElementStyle=function(i,n,e){i.style[t.AnimationUtils._getName(i,n)]=e},t.AnimationUtils._animate=function(n,e,a,s,o,r){var l=[].concat(o),m=function(i,m){var f=function(i){var n=0===i.propertyName.indexOf("-webkit-")?i.propertyName.substr(8):i.propertyName;n=t.AnimationUtils._getCamelCasePropName(n);var e=l.indexOf(n);e>-1&&(l.length>1?l.splice(e,1):p())},c=0,d=!1;function p(){d||(c&&(window.cancelAnimationFrame(c),c=0),n.removeEventListener(t.AnimationUtils._getName(n,"transitionend"),f),i&&i(!0),d=!0)}null==a&&(a={}),null==a.css&&(a.css={}),a.css.transition=t.AnimationUtils._createTransitionValue(n,o,s);var u=t.AnimationUtils._saveStyle(n,e,a,s,r||o);t.AnimationUtils._applyState(n,e,u>1),n.addEventListener(t.AnimationUtils._getName(n,"transitionend"),f);var A=s.duration,g=s.delay,U=s._skipPromise;function _(){c=0,t.AnimationUtils._applyState(n,a,u>1)}null==e?_():(s._noReflow||(t.AnimationUtils._x=n.offsetWidth),c=window.requestAnimationFrame(_));var v=t.AnimationUtils._getTotalTiming(A,g);U||setTimeout(p,v+100)};return s._skipPromise?(m(null),null):new Promise(m).then(function(){e&&e.addClass&&i(n).removeClass(e.addClass),a&&a.addClass&&i(n).removeClass(a.addClass),t.AnimationUtils._restoreStyle(n)})},t.AnimationUtils._saveCssValues=function(i,n,e,a){for(var s=Object.keys(n),o=Object.prototype.hasOwnProperty,r=0;r<s.length;r++){var l=s[r];o.call(e,l)||a&&-1!==a.indexOf(l)||(e[l]=t.AnimationUtils._getElementStyle(i,l))}},t.AnimationUtils._saveStyle=function(i,n,e,a,s){var o=i._ojSavedStyle||{},r=n&&n.css?n.css:{},l=e&&e.css?e.css:{},m=s;a&&"all"===a.persist||(m=null),t.AnimationUtils._saveCssValues(i,r,o,m),t.AnimationUtils._saveCssValues(i,l,o,m),i._ojSavedStyle=o;var f=i._ojEffectCount||0;return f+=1,i._ojEffectCount=f,f},t.AnimationUtils._restoreStyle=function(i){var n=i,e=n._ojEffectCount;if(e>1)n._ojEffectCount=e-1;else{var a=n._ojSavedStyle;if(a){for(var s=Object.keys(a),o=0;o<s.length;o++){var r=s[o];t.AnimationUtils._setElementStyle(n,r,a[r])}delete n._ojSavedStyle,delete n._ojEffectCount}}},t.AnimationUtils._getCamelCasePropName=function(t){if(t.indexOf("-")>=0){for(var i="",n=t.split("-"),e=0;e<n.length;e++){var a=n[e];a&&(i?i+=a.charAt(0).toUpperCase()+a.slice(1):i=a)}return i}return t},t.AnimationUtils._getHyphenatedPropName=function(t){var i=t.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase();return 0===i.indexOf("webkit")&&(i="-"+i),i},t.AnimationUtils._concatMultiValue=function(i,n,e,a,s){if(n.css[e]){var o=t.AnimationUtils._getElementStyle(i,e);o&&0!==o.indexOf(a)&&(n.css[e]=o+s+n.css[e])}},t.AnimationUtils._splitTransform=function(t){var i=[];if(t&&"none"!==t)for(var n=t,e=n.indexOf(")");e>0;){var a=n.substr(0,e+1);i.push(a.trim()),e=(n=n.slice(e+1)).indexOf(")")}return i},t.AnimationUtils._getTransformFuncName=function(t){var i=t.indexOf("(");return i>=1?t.substr(0,i):t},t.AnimationUtils._applyTransform=function(i,n){for(var e=t.AnimationUtils._getElementStyle(i,"transform"),a=t.AnimationUtils._splitTransform(e),s=t.AnimationUtils._splitTransform(n),o=[],r=0;r<s.length;r++){var l=t.AnimationUtils._getTransformFuncName(s[r]),m=!1;if(l)for(var f=0;f<a.length;f++)0===a[f].indexOf(l+"(")&&(a[f]=s[r],m=!0);m||o.push(s[r])}return(a=a.concat(o)).join(" ")},t.AnimationUtils._applyState=function(n,e,a){if(e){if(e.css){a&&t.AnimationUtils._concatMultiValue(n,e,"transition","all",", "),e.css.transform&&(e.css.transform=t.AnimationUtils._applyTransform(n,e.css.transform));for(var s=e.css,o=Object.keys(s),r=0;r<o.length;r++){var l=o[r];t.AnimationUtils._setElementStyle(n,l,s[l])}}e.addClass&&i(n).addClass(e.addClass),e.removeClass&&i(n).removeClass(e.removeClass)}},t.AnimationUtils._getTimingValue=function(t){var i=parseFloat(t);return isNaN(i)?0:t.indexOf("ms")>-1?i:1e3*i},t.AnimationUtils._getTotalTiming=function(i,n){var e=t.AnimationUtils._getTimingValue(i);return e>0?e+(n?t.AnimationUtils._getTimingValue(n):0):0},t.AnimationUtils._calcCssTime=function(i,n,e){for(var a=i.split(","),s=n.split(","),o=e.split(","),r=a.length,l=s.length,m=o.length,f=0,c=0;c<r;c++){var d=o[c%m],p=s[c%l],u=t.AnimationUtils._getTotalTiming(d,p);f=Math.max(f,u)}return f},t.AnimationUtils._calcEffectTime=function(i){var n,e,a,s=window.getComputedStyle(i);n=s.animationName||s.webkitAnimationName,e=s.animationDelay||s.webkitAnimationDelay,a=s.animationDuration||s.webkitAnimationDuration;var o=t.AnimationUtils._calcCssTime(n,e,a);n=s.transitionProperty||s.webkitTransitionProperty,e=s.transitionDelay||s.webkitTransitionDelay,a=s.transitionDuration||s.webkitTransitionDuration;var r=t.AnimationUtils._calcCssTime(n,e,a);return Math.max(o,r)},t.AnimationUtils._fillEmptyOptions=function(t,i){t.delay=t.delay||i.delay,t.duration=t.duration||i.duration,t.timingFunction=t.timingFunction||i.timingFunction,t.persist=t.persist||i.persist},t.AnimationUtils._triggerEvent=function(t,i,n,e){var a;if(e&&e._trigger)a=!e._trigger(i,null,n);else{var s="oj"+i.substr(0,1).toUpperCase()+i.substr(1),o=new CustomEvent(s,{detail:n,bubbles:!0,cancelable:!0}),r=e||t;r.dispatchEvent&&r.dispatchEvent(o),a=o.defaultPrevented}return a},t.AnimationUtils.startAnimation=function(n,e,a,s){return n=i(n)[0],new Promise(function(o,r){var l=i(n),m="oj-animate-"+e,f=m+"-active",c=!1,d=!1,p=function(){if(c&&d){l.removeClass(m),l.removeClass(f),t.AnimationUtils._restoreStyle(n),o(!0);var i={action:e,element:n};t.AnimationUtils._triggerEvent(n,"animateEnd",i,s)}},u=function(){c=!0,p()},A=function(){d=!0,p()};t.AnimationUtils._saveStyle(n,null,null,null,null);var g={action:e,element:n,endCallback:u};if(!t.AnimationUtils._triggerEvent(n,"animateStart",g,s)){for(var U=[].concat(a),_=[],v={},h=0;h<U.length;h++){var y,x=U[h],b="";null!=x&&"none"!==x&&("string"==typeof x?(b=x,y={}):"object"==typeof x&&(b=x.effect,y=i.extend({},x)),t.AnimationUtils._fillEmptyOptions(y,v),v=i.extend({},y)),b&&t.AnimationUtils[b]&&_.push(t.AnimationUtils[b](n,y))}_.length?Promise.all(_).then(u):u()}l.addClass(m);var w=window.requestAnimationFrame(function(){w=0,l.addClass(f);var i=t.AnimationUtils._calcEffectTime(n);i>0?setTimeout(A,i+100):A()});setTimeout(function(){w&&(window.cancelAnimationFrame(w),w=0,A())},1e3)})},t.AnimationUtils._mergeOptions=function(e,a){return null==t.AnimationUtils._defaultOptions&&(t.AnimationUtils._defaultOptions=n.parseJSONFromFontFamily("oj-animation-effect-default-options")),i.extend({duration:"400ms"},t.AnimationUtils._defaultOptions?t.AnimationUtils._defaultOptions[e]:null,a)},t.AnimationUtils._createTransitionValue=function(i,n,e){var a="";if(n)for(var s=0;s<n.length;s++){var o=t.AnimationUtils._getName(i,n[s]);a+=(s>0?", ":"")+t.AnimationUtils._getHyphenatedPropName(o)+" "+e.duration,e.timingFunction&&(a+=" "+e.timingFunction),e.delay&&(a+=" "+e.delay)}return a},t.AnimationUtils._fade=function(i,n,e,a,s){var o=t.AnimationUtils._mergeOptions(e,n),r={css:{opacity:a}},l={css:{opacity:s}};return o&&(o.startOpacity&&(r.css.opacity=o.startOpacity),o.endOpacity&&(l.css.opacity=o.endOpacity)),t.AnimationUtils._animate(i,r,l,o,["opacity"])},t.AnimationUtils.fadeIn=function(i,n){return t.AnimationUtils._fade(i,n,"fadeIn",0,1)},t.AnimationUtils.fadeOut=function(i,n){return t.AnimationUtils._fade(i,n,"fadeOut",1,0)},t.AnimationUtils.expand=function(i,n){return t.AnimationUtils._expandCollapse(i,n,!0)},t.AnimationUtils.collapse=function(i,n){return t.AnimationUtils._expandCollapse(i,n,!1)},t.AnimationUtils._wrapRowContent=function(t,i){var n,e,a=[],s=t.children,o=[],r=[];for(t._ojSavedHeight=t.style.height,e=0;e<s.length;e++){n=s[e];var l=window.getComputedStyle(n);o.push(l.padding),r.push(l.textAlign),n._ojSavedPadding=n.style.padding}for(e=0;e<s.length;e++){n=s[e];var m=document.createElement("div");m.style.overflow="hidden;";var f=document.createElement("div");for(f.style.display="table-cell",f.style.verticalAlign="middle",f.style.boxSizing="border-box",f.style.height=i,f.style.padding=o[e],f.style.textAlign=r[e],m.appendChild(f);n.firstChild;)f.appendChild(n.firstChild);n.appendChild(m),n.style.padding="0",a.push(m)}return t.style.height="0",a},t.AnimationUtils._unwrapRowContent=function(t){for(var i=t.children,n=0;n<i.length;n++){var e=i[n],a=e.children[0];if(a){var s=a.children[0];if(s)for(;s.firstChild;)e.appendChild(s.firstChild);e.removeChild(a)}e.style.padding=e._ojSavedPadding,delete e._ojSavedPadding}t.style.height=t._ojSavedHeight,delete t._ojSavedHeight},t.AnimationUtils._expandCollapseRow=function(n,e,a){var s,o=n.offsetHeight+"px",r=t.AnimationUtils._wrapRowContent(n,o),l=i.extend({},e);if(a?l.endMaxHeight||(l.endMaxHeight=o):l.startMaxHeight||(l.startMaxHeight=o),l.persist="all",l._noReflow=!0,r.length)for(var m=0;m<r.length;m++)0===m?(l._skipPromise=!1,s=t.AnimationUtils._expandCollapse(r[m],l,a)):(l._skipPromise=!0,t.AnimationUtils._expandCollapse(r[m],l,a));else s=Promise.resolve();return s.then(function(){null!=e&&"all"===e.persist||t.AnimationUtils._unwrapRowContent(n)})},t.AnimationUtils._getSizeLimit=function(t,i,n,e,a){var s=n;if(!s)if(e)s="0";else{var o=a?i.maxWidth:i.maxHeight;s="none"!==o?o:(a?t.offsetWidth:t.offsetHeight)+"px"}return s},t.AnimationUtils._expandCollapse=function(i,n,e){if(i&&"TR"===i.tagName)return t.AnimationUtils._expandCollapseRow(i,n,e);var a=t.AnimationUtils._mergeOptions(e?"expand":"collapse",n),s={css:{}},o={css:{}},r=a.direction||"height",l=s.css,m=o.css,f=window.getComputedStyle(i),c=[];if("both"===r||"height"===r){var d=t.AnimationUtils._getSizeLimit(i,f,a.startMaxHeight,e,!1),p=t.AnimationUtils._getSizeLimit(i,f,a.endMaxHeight,!e,!1);l.maxHeight=d,m.maxHeight=p,c.push("maxHeight")}if("both"===r||"width"===r){var u=t.AnimationUtils._getSizeLimit(i,f,a.startMaxWidth,e,!0),A=t.AnimationUtils._getSizeLimit(i,f,a.endMaxWidth,!e,!0);l.maxWidth=u,m.maxWidth=A,c.push("maxWidth")}l.overflow=a.overflow?a.overflow:"hidden";var g=[].concat(c);return g.push("overflow"),t.AnimationUtils._animate(i,s,o,a,c,g)},t.AnimationUtils.zoomIn=function(i,n){return t.AnimationUtils._zoom(i,n,!0)},t.AnimationUtils.zoomOut=function(i,n){return t.AnimationUtils._zoom(i,n,!1)},t.AnimationUtils._zoom=function(i,n,e){var a,s=t.AnimationUtils._mergeOptions(e?"zoomIn":"zoomOut",n),o={css:{}},r={css:{}},l=s.axis||"both";a="both"===l?"scale":"x"===l?"scaleX":"scaleY";var m=o.css,f=r.css;return m.transform=a+"("+(e?0:1)+") translateZ(0)",f.transform=a+"("+(e?1:0)+") translateZ(0)",m.transformOrigin=s.transformOrigin||"center",t.AnimationUtils._animate(i,o,r,s,["transform"])},t.AnimationUtils.slideIn=function(i,n){return t.AnimationUtils._slide(i,n,!0)},t.AnimationUtils.slideOut=function(i,n){return t.AnimationUtils._slide(i,n,!1)},t.AnimationUtils._slide=function(i,n,e){var a=t.AnimationUtils._mergeOptions(e?"slideIn":"slideOut",n),s={css:{}},o={css:{}},r=a.direction||"start",l="0",m="0",f=s.css,c=o.css;if(a.offsetX||a.offsetY)a.offsetX&&(l=a.offsetX),a.offsetY&&(m=a.offsetY);else{var d="rtl"===t.DomUtils.getReadingDirection();switch(r){case"left":l=(e?i.offsetWidth:-i.offsetWidth)+"px";break;case"right":l=(e?-i.offsetWidth:i.offsetWidth)+"px";break;case"top":m=(e?i.offsetHeight:-i.offsetHeight)+"px";break;case"bottom":m=(e?-i.offsetHeight:i.offsetHeight)+"px";break;case"end":l=(e?-i.offsetWidth:i.offsetWidth)*(d?-1:1)+"px";break;default:l=(e?i.offsetWidth:-i.offsetWidth)*(d?-1:1)+"px"}}return e?(f.transform="translate("+l+","+m+") translateZ(0)",c.transform="translate(0,0) translateZ(0)"):(f.transform="translate(0,0) translateZ(0)",c.transform="translate("+l+","+m+") translateZ(0)"),t.AnimationUtils._animate(i,s,o,a,["transform"])},t.AnimationUtils.ripple=function(n,e){var a=t.AnimationUtils._mergeOptions("ripple",e),s={css:{}},o={css:{}},r=n.offsetWidth,l=n.offsetHeight,m=i("<div style='position:absolute; overflow:hidden'>"),f=i("<div class='oj-animation-effect-ripple oj-animation-rippler'>"),c="static"===window.getComputedStyle(n).position?{left:n.offsetLeft,top:n.offsetTop}:{left:0,top:0};n.insertBefore(m[0],n.firstChild),m.css({left:c.left+"px",top:c.top+"px",width:r+"px",height:l+"px"}),m.prepend(f);var d=s.css,p=o.css;return t.AnimationUtils._setRippleOptions(d,f,m,a),d.transform="scale(0) translateZ(0)",d.opacity=a.startOpacity||f.css("opacity"),p.transform="scale(1) translateZ(0)",p.opacity=a.endOpacity||0,a.persist="all",t.AnimationUtils._animate(f[0],s,o,a,["transform","opacity"]).then(function(){m.remove()})},t.AnimationUtils._setRippleOptions=function(i,n,e,a){var s=i,o=n.width(),r=e.width(),l=e.height();if(a.diameter){var m=a.diameter,f=parseInt(m,10);isNaN(f)||(o="%"===m.charAt(m.length-1)?Math.floor(Math.min(r,l)*(f/100)):f,s.width=o+"px",s.height=o+"px")}var c,d="static"===e.css("position")?e.position():{left:0,top:0};null!=(c=t.AnimationUtils._calcRippleOffset(a.offsetX,o,r,d.left))&&(s.left=c+"px"),null!=(c=t.AnimationUtils._calcRippleOffset(a.offsetY,o,l,d.top))&&(s.top=c+"px"),a.color&&(s.backgroundColor=a.color)},t.AnimationUtils._calcRippleOffset=function(t,i,n,e){var a,s=t||"50%",o=parseInt(s,10);return isNaN(o)||(a="%"===s.charAt(s.length-1)?n*(o/100)-i/2:o-i/2,a=Math.floor(a+e)),a},t.AnimationUtils._removeRipple=function(n,a){var s=a||{},o=s.removeEffect||"fadeOut",r=i(".oj-animation-rippler",n);if(0!==r.length)return o in{fadeOut:1,collapse:1,zoomOut:1,slideOut:1}?t.AnimationUtils[o](r,s).then(function(){r.remove()}):r.remove();e.warn("No rippler so returning")},t.AnimationUtils._calcBackfaceAngle=function(t){var i,n=t.match(/^([+-]?\d*\.?\d*)(.*)$/),a=parseFloat(n[1]),s=n[2];switch(s){case"deg":i=a-180+s;break;case"grad":i=a-200+s;break;case"rad":i=a-3.1416+s;break;case"turn":i=a-.5+s;break;default:e.error("Unknown angle unit in flip animation: "+s)}return i},t.AnimationUtils._flip=function(n,e,a,s,o){if(e&&"children"===e.flipTarget){var r,l=[],m=i(n).children(),f=i.extend({},e);delete f.flipTarget;var c=i.extend({},f);c.startAngle=t.AnimationUtils._calcBackfaceAngle(e.startAngle||s),c.endAngle=t.AnimationUtils._calcBackfaceAngle(e.endAngle||o);for(var d=0;d<m.length;d++)r=i(m[d]).hasClass("oj-animation-backface")?c:f,l.push(t.AnimationUtils._flip(m[d],r,a,s,o));return Promise.all(l)}var p,u={},A={},g={css:u},U={css:A},_="rotateY(",v="2000px",h="hidden",y="center";(e=t.AnimationUtils._mergeOptions(a,e))&&("x"===e.axis&&(_="rotateX("),e.startAngle&&(s=e.startAngle),e.endAngle&&(o=e.endAngle),e.perspective&&(v=e.perspective),e.backfaceVisibility&&(h=e.backfaceVisibility),e.transformOrigin&&(y=e.transformOrigin)),p="perspective("+v+") "+_;return u.transform=p+s+")",u.backfaceVisibility=h,u.transformOrigin=y,A.transform=p+o+")",t.AnimationUtils._animate(n,g,U,e,["transform"],["transform","backfaceVisibility","transformOrigin"])},t.AnimationUtils.flipIn=function(i,n){return t.AnimationUtils._flip(i,n,"flipIn","-180deg","0deg")},t.AnimationUtils.flipOut=function(i,n){return t.AnimationUtils._flip(i,n,"flipOut","0deg","180deg")},t.AnimationUtils.addTransition=function(i,n){var e=t.AnimationUtils._mergeOptions("addTransition",n);return t.AnimationUtils._animate(i,null,null,e,e.transitionProperties)},t.AnimationUtils});