/**
 * @license
 * Copyright (c) 2014, 2019, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
define(["require","promise","ojs/ojlogger"],function(t,e,n){e.polyfill();var r={};"undefined"!=typeof window?r=window:"undefined"!=typeof self&&(r=self);var s=r.oj,i={version:"6.2.0",revision:"2019-03-07_18-03-40",noConflict:function(){r.oj=s}};r.oj=i,i.Assert={};i.Assert.forceDebug=function(){i.Assert.DEBUG=!0},i.Assert.clearDebug=function(){i.Assert.DEBUG=!1},i.Assert.isDebug=function(){return!0===i.Assert.DEBUG},i.Assert.assert=function(t,e){if(i.Assert.DEBUG&&!t){var n=e||"";if(arguments.length>2){n+="(";for(var r=2;r<arguments.length;r+=1)n+=arguments[r];n+=")"}i.Assert.assertionFailed(n,1)}},i.Assert.failedInAbstractFunction=function(){i.Assert.DEBUG&&i.Assert.assertionFailed("Abstract function called",1)},i.Assert.assertPrototype=function(t,e,n){if(i.Assert.DEBUG){var r=e.prototype;if(null!=t)i.Assert.assertType(e,"function",null,1,!1),Object.prototype.isPrototypeOf.call(r,t)||i.Assert.assertionFailed("object '"+t+"' doesn't match prototype "+r,1,n);else i.Assert.assertionFailed("null object doesn't match prototype "+r,1,n)}},i.Assert.assertPrototypeOrNull=function(t,e,n){if(i.Assert.DEBUG&&null!=t){i.Assert.assertType(e,"function",null,1,!1);var r=e.prototype;Object.prototype.isPrototypeOf.call(r,t)||i.Assert.assertionFailed("object '"+t+"' doesn't match prototype "+r,1,n)}},i.Assert.assertPrototypes=function(t,e,n,r){if(i.Assert.DEBUG){var s=e.prototype,o=n.prototype,a=Object.prototype.isPrototypeOf;a.call(s,t)||a.call(o,t)||i.Assert.assertionFailed("object '"+t+"' doesn't match prototype "+s+" or "+o,1,r)}},i.Assert.assertDomNodeOrNull=function(t,e){i.Assert.DEBUG&&t&&void 0===t.nodeType&&i.Assert.assertionFailed(t+" is not a DOM Node",e+1)},i.Assert.assertDomNode=function(t,e){i.Assert.DEBUG&&(t&&void 0!==t.nodeType||i.Assert.assertionFailed(t+" is not a DOM Node",e+1))},i.Assert.assertDomElement=function(t,e){i.Assert.DEBUG&&(i.Assert.assertDomNode(t,1),1!==t.nodeType?i.Assert.assertionFailed(t+" is not a DOM Element",1):e&&t.nodeName!==e&&i.Assert.assertionFailed(t+" is not a "+e+" Element",1))},i.Assert.assertDomElementOrNull=function(t,e){i.Assert.DEBUG&&null!=t&&(i.Assert.assertDomNode(t,1),1!==t.nodeType?i.Assert.assertionFailed(t+" is not a DOM Element",1):e&&t.nodeName!==e&&i.Assert.assertionFailed(t+" is not a "+e+" Element",1))},i.Assert.assertType=function(t,e,n,r,s){if(i.Assert.DEBUG&&!(null==t&&s||typeof t===e)){var o=t+" is not of type "+e;n&&(o=n+o),r||(r=0),i.Assert.assertionFailed(o,r+1)}},i.Assert.assertObject=function(t,e){i.Assert.DEBUG&&i.Assert.assertType(t,"object",e,1,!1)},i.Assert.assertObjectOrNull=function(t,e){i.Assert.DEBUG&&i.Assert.assertType(t,"object",e,1,!0)},i.Assert.assertNonEmptyString=function(t,e){i.Assert.DEBUG&&(i.Assert.assertType(t,"string",e,1,!1),i.Assert.assert(t.length>0,"empty string"))},i.Assert.assertString=function(t,e){i.Assert.DEBUG&&i.Assert.assertType(t,"string",e,1,!1)},i.Assert.assertStringOrNull=function(t,e){i.Assert.DEBUG&&i.Assert.assertType(t,"string",e,1,!0)},i.Assert.assertFunction=function(t,e){i.Assert.DEBUG&&i.Assert.assertType(t,"function",e,1,!1)},i.Assert.assertFunctionOrNull=function(t,e){i.Assert.DEBUG&&i.Assert.assertType(t,"function",e,1,!0)},i.Assert.assertBoolean=function(t,e){i.Assert.DEBUG&&i.Assert.assertType(t,"boolean",e,1,!1)},i.Assert.assertNumber=function(t,e){i.Assert.DEBUG&&i.Assert.assertType(t,"number",e,1,!1)},i.Assert.assertNumberOrNull=function(t,e){i.Assert.DEBUG&&i.Assert.assertType(t,"number",e,1,!0)},i.Assert.assertArray=function(t,e){i.Assert.DEBUG&&(Array.isArray(t)||(void 0===e&&(e=t+" is not an array"),i.Assert.assertionFailed(e,1)))},i.Assert.assertArrayOrNull=function(t,e){i.Assert.DEBUG&&null!=t&&(Array.isArray(t)||(void 0===e&&(e=t+" is not an array"),i.Assert.assertionFailed(e,1)))},i.Assert.assertNonNumeric=function(t,e){i.Assert.DEBUG&&(isNaN(t)||(void 0===e&&(e=t+" is convertible to a number"),i.Assert.assertionFailed(e,1)))},i.Assert.assertNumeric=function(t,e){i.Assert.DEBUG&&isNaN(t)&&(void 0===e&&(e=t+" is not convertible to a number"),i.Assert.assertionFailed(e,1))},i.Assert.assertInSet=function(t,e,n){if(null==t||void 0===e[t.toString()]){if(void 0===n){for(var r=" is not in set: {",s=Object.keys(e),o=0;o<s.length;o++){r+=s[o],r+=","}n=t+(r+="}")}i.Assert.assertionFailed(n,1)}},i.Assert.assertionFailed=function(t,e,n){e||(e=0);var r="Assertion";throw n&&(r+=" ("+n+")"),r+=" failed: ",void 0!==t&&(r+=t),new Error(r)};var o,a,l,c,u,f,p=r.__oj_Assert_DEBUG;void 0!==p&&(i.Assert.DEBUG=p),i.CollectionUtils={},i.CollectionUtils.copyInto=function(t,e,n,r,s){return i.CollectionUtils._copyIntoImpl(t,e,n,r,s,0)},i.CollectionUtils.isPlainObject=function(t){if(null!==t&&"object"==typeof t)try{var e=Object.prototype.hasOwnProperty;if(t.constructor&&e.call(t.constructor.prototype,"isPrototypeOf"))return!0}catch(t){}return!1},i.CollectionUtils._copyIntoImpl=function(t,e,n,r,s,o){var a;if(null==s&&(s=Number.MAX_VALUE),t&&e&&t!==e)for(var l=Object.keys(e),c=0;c<l.length;c++){var u=l[c];a=n?n(u):u;var f=e[u],p=!1;if(r&&o<s){var d=t[a];i.CollectionUtils.isPlainObject(f)&&(null==d||i.CollectionUtils.isPlainObject(d))&&(p=!0,t[a]=d||{},i.CollectionUtils._copyIntoImpl(t[a],f,n,!0,s,o+1))}p||(t[a]=f)}return t},i.Object=function(){this.Init()},i.Object.superclass=null,i.Object._typeName="oj.Object",i.Object._GET_FUNCTION_NAME_REGEXP=/function\s+([\w$][\w$\d]*)\s*\(/,i.Object.prototype={},i.Object.prototype.constructor=i.Object,i.Object.createSubclass=function(t,e,n){i.Assert.assertFunction(t),i.Assert.assertFunctionOrNull(e),i.Assert.assertStringOrNull(n),void 0===e&&(e=i.Object),i.Assert.assert(t!==e,"Class can't extend itself");var r=i.Object._tempSubclassConstructor;r.prototype=e.prototype,t.prototype=new r,t.prototype.constructor=t,t.superclass=e.prototype,n&&(t._typeName=n)},i.Object.copyPropertiesForClass=function(t,e){i.Assert.assertFunction(t),i.Assert.assert(null!=e,"source object cannot be null");for(var n=Object.keys(e),r=0;r<n.length;r++){var s=n[r];t.prototype[s]=e[s]}},i.Object._tempSubclassConstructor=function(){},i.Object.prototype.getClass=function(t){if(void 0===t)t=this;else if(null===t)return null;return t.constructor},i.Object.prototype.clone=function(){var t=new this.constructor;return i.CollectionUtils.copyInto(t,this),t},i.Object.prototype.toString=function(){return this.toDebugString()},i.Object.prototype.toDebugString=function(){return this.getTypeName()+" Object"},i.Object.getTypeName=function(t){i.Assert.assertFunction(t);var e=t._typeName;if(null==e){var n=t.toString(),r=i.Object._GET_FUNCTION_NAME_REGEXP.exec(n);e=r?r[1]:"anonymous",t._typeName=e}return e},i.Object.prototype.getTypeName=function(){return i.Object.getTypeName(this.constructor)},i.Object.prototype.Init=function(){i.Assert.isDebug()&&i.Assert.assert(this.getTypeName,"Not an oj.Object");var t=this.constructor;t._initialized||i.Object._initClasses(t)},i.Object.ensureClassInitialization=function(t){i.Assert.assertFunction(t),t._initialized||i.Object._initClasses(t)},i.Object.prototype.equals=function(t){return this===t},i.Object.createCallback=function(t,e){return i.Assert.assertFunction(e),e.bind(t)},i.Object._initClasses=function(t){i.Assert.isDebug()&&(i.Assert.assertFunction(t),i.Assert.assert(!t._initialized)),t._initialized=!0;var e=t.superclass;if(e){var n=e.constructor;n&&!n._initialized&&i.Object._initClasses(n)}var r=t.InitClass;r&&r.call(t)},i.Object.compareValues=function(t,e){if(t===e)return!0;if(typeof t!==typeof e)return!1;if(null===t||null===e)return!1;if(t.constructor===e.constructor){if(Array.isArray(t))return i.Object._compareArrayValues(t,e);if(t.constructor===Object)return i.Object.__innerEquals(t,e);if(t.valueOf&&"function"==typeof t.valueOf)return t.valueOf()===e.valueOf()}return!1},i.Object._compareArrayValues=function(t,e){if(t.length!==e.length)return!1;for(var n=0,r=t.length;n<r;n++)if(!i.Object.compareValues(t[n],e[n]))return!1;return!0},i.Object._compareIdIndexObject=function(t,e){if("number"==typeof t&&"number"==typeof e||"string"==typeof t&&"string"==typeof e)return t===e;if("object"==typeof t&&"object"==typeof e){if(t.id&&e.id)return t.id===e.id&&(!t.index||!e.index||t.index===e.index);if(t.index&&e.index)return t.index===e.index}return!1},i.Object._compareArrayIdIndexObject=function(t,e){if(!t)return!e||0===e.length;if(!e)return!t||0===t.length;if(t.length!==e.length)return!1;for(var n=0;n<t.length;n++){for(var r=!1,s=0;s<e.length;s++)if(i.Object._compareIdIndexObject(t[n],e[s])){r=!0;break}if(!r)return!1}return!0},i.Object.__innerEquals=function(t,e){if(t===e)return!0;if(!(t instanceof Object&&e instanceof Object))return!1;if(t.constructor!==e.constructor)return!1;var n,r,s=Object.prototype.hasOwnProperty,o=Object.keys(t);for(r=0;r<o.length;r++)if(n=o[r],s.call(t,n)){if(!s.call(e,n))return!1;if(t[n]!==e[n]){if("object"!=typeof t[n])return!1;if(!i.Object.__innerEquals(t[n],e[n]))return!1}}var a=Object.keys(e);for(r=0;r<a.length;r++)if(n=a[r],s.call(e,n)&&!s.call(t,n))return!1;return 0!==o.length||0!==a.length||JSON.stringify(t)===JSON.stringify(e)},i.Object.isEmpty=function(t){var e;if(null==t)return!0;for(e in t)if(t.hasOwnProperty(e))return!1;return!0},i.__isAmdLoaderPresent=function(){return"function"==typeof define&&define.amd},i.StringUtils={},i.StringUtils._TRIM_ALL_RE=/^\s*|\s*$/g,i.StringUtils.isEmpty=function(t){return null===t||0===i.StringUtils.trim(t).length},i.StringUtils.isEmptyOrUndefined=function(t){return!(void 0!==t&&!i.StringUtils.isEmpty(t))},i.StringUtils.isString=function(t){return null!==t&&("string"==typeof t||t instanceof String)},i.StringUtils.trim=function(t){return i.StringUtils.isString(t)?t.replace(i.StringUtils._TRIM_ALL_RE,""):t},i.StringUtils.hashCode=function(t){var e=0;if(0===t.length)return e;for(var n=0;n<t.length;n++){e=(e<<5)-e+t.charCodeAt(n),e&=e}return e},String.prototype.startsWith||(String.prototype.startsWith=function(t,e){return e=e||0,this.substr(e,t.length)===t}),String.prototype.endsWith||(String.prototype.endsWith=function(t,e){var n=this.toString();("number"!=typeof e||!isFinite(e)||Math.floor(e)!==e||e>n.length)&&(e=n.length),e-=t.length;var r=n.lastIndexOf(t,e);return-1!==r&&r===e}),i.AgentUtils=function(){},i.AgentUtils.BROWSER={IE:"ie",FIREFOX:"firefox",SAFARI:"safari",CHROME:"chrome",EDGE:"edge",UNKNOWN:"unknown"},i.AgentUtils.ENGINE={TRIDENT:"trident",WEBKIT:"webkit",GECKO:"gecko",BLINK:"blink",EDGE_HTML:"edgehtml",UNKNOWN:"unknown"},i.AgentUtils.OS={WINDOWS:"Windows",SOLARIS:"Solaris",MAC:"Mac",UNKNOWN:"Unknown",ANDROID:"Android",IOS:"IOS",WINDOWSPHONE:"WindowsPhone",LINUX:"Linux"},i.AgentUtils.DEVICETYPE={PHONE:"phone",TABLET:"tablet",OTHERS:"others"},i.AgentUtils.getAgentInfo=function(t){i.StringUtils.isEmptyOrUndefined(t)&&(t=navigator.userAgent),t=t.toLowerCase();var e=i.StringUtils.hashCode(t),n=i.AgentUtils._currAgentInfo;if(n&&n.hashCode===e)return{os:n.os,browser:n.browser,browserVersion:n.browserVersion,deviceType:n.deviceType,engine:n.engine,engineVersion:n.engineVersion,hashCode:n.hashCode};var r=i.AgentUtils.OS.UNKNOWN,s=i.AgentUtils.BROWSER.UNKNOWN,o=0,a=i.AgentUtils.DEVICETYPE.OTHERS,l=i.AgentUtils.ENGINE.UNKNOWN,c=0;return t.indexOf("iphone")>-1||t.indexOf("ipad")>-1?r=i.AgentUtils.OS.IOS:t.indexOf("mac")>-1?r=i.AgentUtils.OS.MAC:t.indexOf("sunos")>-1?r=i.AgentUtils.OS.SOLARIS:t.indexOf("android")>-1?r=i.AgentUtils.OS.ANDROID:t.indexOf("linux")>-1?r=i.AgentUtils.OS.LINUX:t.indexOf("windows phone")>-1?r=i.AgentUtils.OS.WINDOWSPHONE:t.indexOf("win")>-1&&(r=i.AgentUtils.OS.WINDOWS),r===i.AgentUtils.OS.ANDROID?a=t.indexOf("mobile")>-1?i.AgentUtils.DEVICETYPE.PHONE:i.AgentUtils.DEVICETYPE.TABLET:r===i.AgentUtils.OS.IOS&&(a=t.indexOf("iphone")>-1?i.AgentUtils.DEVICETYPE.PHONE:i.AgentUtils.DEVICETYPE.TABLET),t.indexOf("msie")>-1?(s=i.AgentUtils.BROWSER.IE,o=i.AgentUtils._parseFloatVersion(t,/msie (\d+[.]\d+)/),t.indexOf("trident")&&(l=i.AgentUtils.ENGINE.TRIDENT,c=i.AgentUtils._parseFloatVersion(t,/trident\/(\d+[.]\d+)/))):t.indexOf("trident")>-1?(s=i.AgentUtils.BROWSER.IE,o=i.AgentUtils._parseFloatVersion(t,/rv:(\d+[.]\d+)/),t.indexOf("trident")&&(l=i.AgentUtils.ENGINE.TRIDENT,c=i.AgentUtils._parseFloatVersion(t,/trident\/(\d+[.]\d+)/))):t.indexOf("edge")>-1?(s=i.AgentUtils.BROWSER.EDGE,o=c=i.AgentUtils._parseFloatVersion(t,/edge\/(\d+[.]\d+)/),l=i.AgentUtils.ENGINE.EDGE_HTML):t.indexOf("chrome")>-1?(s=i.AgentUtils.BROWSER.CHROME,(o=i.AgentUtils._parseFloatVersion(t,/chrome\/(\d+[.]\d+)/))>=28?(l=i.AgentUtils.ENGINE.BLINK,c=o):(l=i.AgentUtils.ENGINE.WEBKIT,c=i.AgentUtils._parseFloatVersion(t,/applewebkit\/(\d+[.]\d+)/))):t.indexOf("safari")>-1?(s=i.AgentUtils.BROWSER.SAFARI,o=i.AgentUtils._parseFloatVersion(t,/version\/(\d+[.]\d+)/),l=i.AgentUtils.ENGINE.WEBKIT,c=i.AgentUtils._parseFloatVersion(t,/applewebkit\/(\d+[.]\d+)/)):t.indexOf("firefox")>-1&&(s=i.AgentUtils.BROWSER.FIREFOX,o=i.AgentUtils._parseFloatVersion(t,/rv:(\d+[.]\d+)/),l=i.AgentUtils.ENGINE.GECKO,c=i.AgentUtils._parseFloatVersion(t,/gecko\/(\d+)/)),n={hashCode:e,os:r,browser:s,browserVersion:o,deviceType:a,engine:l,engineVersion:c},i.AgentUtils._currAgentInfo=n,{os:n.os,browser:n.browser,browserVersion:n.browserVersion,deviceType:n.deviceType,engine:n.engine,engineVersion:n.engineVersion,hashCode:n.hashCode}},i.AgentUtils._parseFloatVersion=function(t,e){var n=t.match(e);if(n){var r=n[1];if(r)return parseFloat(r)}return 0},o=/(^array)|(\|array)/,a=/(^object)|(\|object)/,l=/\s*\[[^]*\]\s*/,c=/\s*\{[^]*\}\s*/,u=/^(?:\{\{)([^]+)(?:\}\})$/,f=/^(?:\[\[)([^]+)(?:\]\])$/,i.__AttributeUtils={},i.__AttributeUtils.getExpressionInfo=function(t){var e={};if(t){var n=t.trim(),r=u.exec(n);(r=r?r[1]:null)||(e.downstreamOnly=!0,r=(r=f.exec(n))?r[1]:null),e.expr=r}return e},i.__AttributeUtils.attributeToPropertyName=function(t){return t.toLowerCase().replace(/-(.)/g,function(t,e){return e.toUpperCase()})},i.__AttributeUtils.propertyNameToAttribute=function(t){return t.replace(/([A-Z])/g,function(t){return"-"+t.toLowerCase()})},i.__AttributeUtils.eventTypeToEventListenerProperty=function(t){return"on"+t.substr(0,1).toUpperCase()+t.substr(1)},i.__AttributeUtils.eventListenerPropertyToEventType=function(t){return/^on[A-Z]/.test(t)?t.substr(2,1).toLowerCase()+t.substr(3):null},i.__AttributeUtils.propertyNameToChangeEventType=function(t){return t+"Changed"},i.__AttributeUtils.eventTriggerToEventType=function(t){return"oj"+t.substr(0,1).toUpperCase()+t.substr(1)},i.__AttributeUtils.coerceValue=function(t,e,n,r){if(!r)throw new Error("Unable to parse "+e+"='"+n+"' for "+t+" with id "+t.id+" . This attribute only supports data bound values. Check the API doc for supported types");var s=r.toLowerCase(),i=l.test(n),u=c.test(n);if(o.test(s)&&i||a.test(s)&&u||"any"===s&&(i||u))try{return JSON.parse(n)}catch(r){throw new Error("Unable to parse "+e+"='"+n+"' for "+t.tagName+" with id "+t.id+" to a JSON Object. Check the value for correct JSON syntax, e.g. double quoted strings. "+r)}else if("boolean"===s){if(null==n||"true"===n||""===n||n.toLowerCase()===e)return!0;if("false"===n)return!1}else if("number"===s){if(!isNaN(n))return Number(n)}else if(-1!==r.split("|").indexOf("string")||"any"===s)return n;throw new Error("Unable to parse "+e+"='"+n+"' for "+t+" with id "+t.id+" to a "+r+".")},"undefined"!=typeof window&&window.Element&&!Element.prototype.closest&&(Element.prototype.closest=function(t){var e,n=(this.document||this.ownerDocument).querySelectorAll(t),r=this;do{for(e=n.length;--e>=0&&n.item(e)!==r;);}while(e<0&&(r=r.parentElement));return r}),i.EventSource=function(){this.Init()},i.Object.createSubclass(i.EventSource,i.Object,"oj.EventSource"),i.EventSource.prototype.Init=function(){this._eventHandlers=[],i.EventSource.superclass.Init.call(this)},i.EventSource.prototype.on=function(t,e){for(var n=!1,r=0;r<this._eventHandlers.length;r++)if(this._eventHandlers[r].eventType===t&&this._eventHandlers[r].eventHandlerFunc===e){n=!0;break}n||this._eventHandlers.push({eventType:t,eventHandlerFunc:e})},i.EventSource.prototype.off=function(t,e){for(var n=this._eventHandlers.length-1;n>=0;n--)if(this._eventHandlers[n].eventType===t&&this._eventHandlers[n].eventHandlerFunc===e){this._eventHandlers.splice(n,1);break}},i.EventSource.prototype.handleEvent=function(t,e){for(var n=0;n<this._eventHandlers.length;n++){var r=this._eventHandlers[n];if(r.eventType===t&&!1===r.eventHandlerFunc.apply(this,Array.prototype.slice.call(arguments).slice(1)))return!1}return!0},i.KeyUtils={},i.KeyUtils.equals=function(t,e){return i.Object.compareValues(t,e)},function(){if("undefined"!=typeof window){var t;if(!((t=document.createEvent("Event")).initEvent("foo",!0,!0),t.preventDefault(),t.defaultPrevented)){var e=Event.prototype.preventDefault;Event.prototype.preventDefault=function(){this.cancelable&&(e.call(this),Object.defineProperty(this,"defaultPrevented",{get:function(){return!0},configurable:!0}))}}"function"!=typeof window.CustomEvent&&(n.prototype=window.Event.prototype,window.CustomEvent=n)}function n(t,e){e=e||{bubbles:!1,cancelable:!1,detail:void 0};var n=document.createEvent("CustomEvent");return n.initCustomEvent(t,e.bubbles,e.cancelable,e.detail),n}}(),function(){var t,e;"undefined"!=typeof window&&!window.setImmediate&&window.postMessage&&(window.setImmediate=function(){var r=arguments[0],s=Array.prototype.slice.call(arguments,1);"function"!=typeof r&&(r=new Function(r.toString()));var i=(isNaN(e)&&(e=0),e+=1);return t||(t=new Map),t.set(i,{callback:r,args:s}),1===t.size&&window.addEventListener("message",n),window.postMessage({id:i,message:"oj-setImmediate"},"*"),i},window.clearImmediate=r);function n(e){var n=e.data;if(n&&"oj-setImmediate"===n.message){var s=n.id,i=t.get(s);if(r(s),i){var o=i.callback,a=i.args;o.apply(window,a)}}}function r(e){t&&(t.delete(e),t.size<1&&(window.removeEventListener("message",n),t=null))}}(),function(){if("undefined"!=typeof window&&!window.__extends){var t,e=this&&this.__extends||(t=Object.setPrototypeOf,function(e,n){function r(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)});window.__extends=e}}(),"undefined"!=typeof window&&(window.Symbol?(window.Symbol.asyncIterator||(window.Symbol.asyncIterator="asyncIterator"),window.Symbol.iterator||(window.Symbol.iterator="iterator")):(window.Symbol={},window.Symbol.asyncIterator="asyncIterator",window.Symbol.iterator="iterator"));var d=r.__ojCheckpointManager;return i.CHECKPOINT_MANAGER={},i.CHECKPOINT_MANAGER.startCheckpoint=function(t,e){d&&d.startCheckpoint(t,e)},i.CHECKPOINT_MANAGER.endCheckpoint=function(t){d&&d.endCheckpoint(t)},i.CHECKPOINT_MANAGER.getRecord=function(t){return d?d.getRecord(t):void 0},i.CHECKPOINT_MANAGER.matchRecords=function(t){return d?d.matchRecords(t):[]},i.CHECKPOINT_MANAGER.dump=function(t){n.info(function(){for(var e="Checkpoint Records:",n=i.CHECKPOINT_MANAGER.matchRecords(t),r=0;r<n.length;r++){var s=n[r];e=e+"\n"+s.name;var o=s.description;null!=o&&(e=e+" ("+o+")"),e=(e+=":\n")+"start: "+s.start+"\tduration: "+s.duration}return e})},i});