/**
 * @license
 * Copyright (c) 2014, 2019, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
define(["ojs/ojcore","jquery","hammerjs","ojs/ojtranslation","ojs/ojcontext","ojs/ojthemeutils","ojs/ojcomponentcore","ojs/ojanimation","ojs/ojmessaging","ojs/ojvalidation-base","ojs/ojlogger","ojs/ojjquery-hammer","promise","ojs/ojpopup","ojs/ojlabel"],function(t,e,i,s,n,a,o,r,l,u,p){t.EditableValueUtils={},t.EditableValueUtils.validationContext={COMPONENT_CREATE:1,CONVERTER_OPTION_CHANGE:2,DISABLED_OPTION_CHANGE:3,READONLY_OPTION_CHANGE:4,REFRESH_METHOD:5,REQUIRED_OPTION_CHANGE:6,RESET_METHOD:7,USER_ACTION:8,VALIDATE_METHOD:9,VALIDATORS_OPTION_CHANGE:10,VALUE_OPTION_CHANGE:11},t.EditableValueUtils.validateMethodOptions={doValueChangeCheck:!1,validationContext:t.EditableValueUtils.validationContext.VALIDATE_METHOD},t.EditableValueUtils.converterOptionOptions={doValueChangeCheck:!1,doNotClearMessages:!0,validationContext:t.EditableValueUtils.validationContext.CONVERTER_OPTION_CHANGE},t.EditableValueUtils.disabledOptionOptions={doValueChangeCheck:!1,doNotClearMessages:!0,validationContext:t.EditableValueUtils.validationContext.DISABLED_OPTION_CHANGE},t.EditableValueUtils.requiredOptionOptions={doValueChangeCheck:!1,doNotClearMessages:!0,validationContext:t.EditableValueUtils.validationContext.REQUIRED_OPTION_CHANGE},t.EditableValueUtils.readOnlyOptionOptions={doValueChangeCheck:!1,doNotClearMessages:!0,validationContext:t.EditableValueUtils.validationContext.READONLY_OPTION_CHANGE},t.EditableValueUtils.refreshMethodOptions={doValueChangeCheck:!1,doNotClearMessages:!0,validationContext:t.EditableValueUtils.validationContext.REFRESH_METHOD},t.EditableValueUtils.validatorsOptionOptions={doValueChangeCheck:!1,doNotClearMessages:!0,validationContext:t.EditableValueUtils.validationContext.VALIDATORS_OPTION_CHANGE};t.EditableValueUtils.CUSTOM_LABEL_ELEMENT_ID="|label",t.EditableValueUtils.VALIDATE_VALUES={VALID:"valid",INVALID:"invalid"},t.EditableValueUtils.getAttributeValue=function(t,e){var i,s={};if(t&&e){var n=t[0];switch(e){case"disabled":i=n.hasAttribute("disabled")?!!n.disabled:void 0;break;case"pattern":i=n.pattern||void 0;break;case"placeholder":i=n.placeholder||void 0;break;case"readonly":i=n.hasAttribute("readonly")?!!n.readOnly:void 0;break;case"required":if(n.hasAttribute("required")){var a=n.required;i=void 0===a||!!a}else i=void 0;break;case"title":i=n.hasAttribute("title")?n.title:void 0;break;case"value":i=t.val()||void 0;break;case"min":case"max":default:i=n.getAttribute(e)||void 0}}return void 0!==i?(s.fromDom=!0,s.value=i):s.fromDom=!1,s},t.EditableValueUtils.initializeOptionsFromDom=function(e,i,s,n){for(var a={},o=0;o<e.length;o++){var r,l,u=e[o],p=u.attribute,g=u.option||p,d=u.coerceDomValue,_=u.validateOption,h=s.element,c=s.options[g];void 0===i[g]&&(c=s.options[g],(l=t.EditableValueUtils.getAttributeValue(h,p)).fromDom&&(r=l.value,d&&("boolean"==typeof d?r=t.EditableValueUtils.coerceDomValueForOption(g,r):"function"==typeof d&&(r=d.call(s,r))),a[g]=r));var E=g in a?a[g]:c;_&&"boolean"==typeof _&&t.EditableValueUtils.validateValueForOption(g,E)}null!=n&&n(a),s.option(a,{_context:{writeback:!0,internalSet:!0}})},t.EditableValueUtils.validateValueForOption=function(t,e){var i=!1;switch(t){case"required":null!==e&&"boolean"!=typeof e&&(i=!0);break;case"readOnly":case"disabled":null!==e&&"boolean"!=typeof e&&(i=!0)}if(i)throw new Error("Option '"+t+"' has invalid value set: "+e)},t.EditableValueUtils.coerceDomValueForOption=function(t,e){var i=e;switch(t){case"required":i=!!e}return i},t.EditableValueUtils.setPickerAttributes=function(t,e){if(t&&e){var i=e.class;if(i)for(var s=i.split(" "),n=0,a=s.length;n<a;++n)t[0].classList.add(s[n]);var o=e.style;if(o){var r=t[0],l=r.getAttribute("style");l?r.setAttribute("style",l+";"+o):r.setAttribute("style",o)}}},t.EditableValueUtils.getOjLabelId=function(e,i){var s,n,a,o,r,l,u;if(this.hasNoLabelFlag(e))return null;var p=e[0];if(s=p.id,a=0===(n=Array.prototype.filter.call(p.parentNode.children,function(t){return t!==p&&t.getAttribute("for")===s})).length?document.querySelector("oj-label[for='"+s+"']"):n[0]){if(u=a.getAttribute("label-id"))return u;if(o=a.id)return o+t.EditableValueUtils.CUSTOM_LABEL_ELEMENT_ID;if((r=a.querySelector("label"))&&(l=r.id),l)return l;if(i)return a.setAttribute("label-id",i),i}return null},t.EditableValueUtils.hasNoLabelFlag=function(t){return t[0].hasAttribute("data-oj-no-labelledby")},t.EditableValueUtils.validate=function(){var t;if(t=this._SetValue(this._GetDisplayValue(),null,this._VALIDATE_METHOD_OPTIONS),this._IsCustomElement()){if(t instanceof Promise)return t.then(function(t){return Promise.resolve(t?"valid":"invalid")});t=Promise.resolve(t?"valid":"invalid")}return t},t.EditableValueUtils.setSubIdForCustomLabelFor=function(t,e){t.setAttribute("id",e+"|input")},t.EditableValueUtils._updateLabelledBy=function(e,i,s){var n=t.EditableValueUtils.CUSTOM_LABEL_ELEMENT_ID;this._IsCustomElement()&&(e&&(e+=n),i&&(i+=n),e&&t.EditableValueUtils._removeAriaLabelledBy(s,e),i&&t.EditableValueUtils._addAriaLabelledBy(s,i))},t.EditableValueUtils._refreshRequired=function(t){var e,i,s,n=this._AriaRequiredUnsupported();this._refreshTheming("required",t),n||(i=this._GetContentElement(),(s=t)&&i?i[0].setAttribute("aria-required",s):i[0].removeAttribute("aria-required")),this._IsCustomElement()||(this.$label||this._createOjLabel(),this.$label&&(this.$label.ojLabel("option","showRequired",t),n&&(e=this._getAriaLabelledById(this.element))&&(t?this._addAriaDescribedBy(e+"_requiredIcon"):this._removeAriaDescribedBy(e+"_requiredIcon"))))},t.EditableValueUtils._AfterSetOptionRequired=function(e){this._refreshRequired(this._IsRequired()),this._runMixedValidationAfterSetOption(t.EditableValueUtils.requiredOptionOptions)},t.EditableValueUtils._AfterSetOptionValidators=function(){var e;this._ResetAllValidators(),this._hasInvalidMessagesShowing()&&(this._clearComponentMessages(),e=this._GetDisplayValue(),this._SetValue(e,null,t.EditableValueUtils.validatorsOptionOptions))},t.EditableValueUtils._AfterSetOptionAsyncValidators=function(){this._AfterSetOptionValidators()},t.EditableValueUtils._AfterSetOptionConverter=function(e){var i;this._ResetConverter(),this._hasInvalidMessagesShowing()?(this._clearComponentMessages(),i=this._GetDisplayValue(),this._SetValue(i,null,t.EditableValueUtils.converterOptionOptions)):this._Refresh("converter",this.options[e],!0)},t.EditableValueUtils._ResetConverter=function(){this._converter=null,this._getComponentMessaging().update(this._getMessagingContent(this._MESSAGING_CONTENT_UPDATE_TYPE.CONVERTER_HINT))},t.EditableValueUtils._GetNormalizedValidatorsFromOption=function(){var e,i,s,n,a,o,r=!0,l=[];if(s=this.options.validators)for(e=0;e<s.length;e++)"object"==typeof(i=s[e])?(i.validate&&"function"==typeof i.validate||(r=!1),r||(o=i.type)&&"string"==typeof o&&((a=u.Validation.validatorFactory(o))?((n=t.CollectionUtils.copyInto({},i.options)||{}).converter=n.converter||this._GetConverter(),n.label=n.label||this._getLabelText(),i=a.createValidator(n)):p.error("Unable to locate a validatorFactory for the requested type: "+o)),l.push(i)):p.error("Unable to parse the validator provided:"+i);return l},t.EditableValueUtils._GetNormalizedAsyncValidatorsFromOption=function(){var t,e,i,s=[];for(i=this.options.asyncValidators,t=0;t<i.length;t++)"object"==typeof(e=i[t])?e.validate&&"function"==typeof e.validate&&s.push(e):p.error("Unable to parse the validator provided:"+e);return s},t.EditableValueUtils._GetConverter=function(){var t;return this._converter||(t=this.options.converter,this._converter=u.IntlConverterUtils.getConverterInstance(t)),this._converter||null},t.EditableValueUtils._SetBusyState=function(t){void 0===this._resolveBusyStateAsyncMap&&(this._resolveBusyStateAsyncMap=new Map);var e=this._resolveBusyStateAsyncMap.get(t);if(!e){var i=this.element[0],s=n.getContext(i).getBusyContext(),a="The page is waiting for async validators for displayValue "+t;i&&i.id&&(a+=' for "'+i.id+'" '),a+="to finish.",e=s.addBusyState({description:a}),this._resolveBusyStateAsyncMap.set(t,e)}},t.EditableValueUtils._ClearBusyState=function(t){var e;void 0!==this._resolveBusyStateAsyncMap&&(e=this._resolveBusyStateAsyncMap.get(t))&&(e(),this._resolveBusyStateAsyncMap.delete(t))},t.EditableValueUtils._SetBusyStateAsyncValidatorHint=function(t){void 0===this._resolveBusyStateAsyncValidatorHintMap&&(this._resolveBusyStateAsyncValidatorHintMap=new Map);var e=this._resolveBusyStateAsyncValidatorHintMap.get(t);if(!e){var i=this.element[0],s=n.getContext(i).getBusyContext(),a="The page is waiting for async validator hint for counter "+t;i&&i.id&&(a+=' for "'+i.id+'" '),a+="to finish.",e=s.addBusyState({description:a}),this._resolveBusyStateAsyncValidatorHintMap.set(t,e)}},t.EditableValueUtils._ClearBusyStateAsyncValidatorHint=function(t){var e;void 0!==this._resolveBusyStateAsyncValidatorHintMap&&(e=this._resolveBusyStateAsyncValidatorHintMap.get(t))&&(e(),this._resolveBusyStateAsyncValidatorHintMap.delete(t))},t.EditableValueUtils._addAriaLabelledBy=function(t,e){t.each(function(){var t,i=this.getAttribute("aria-labelledby");t=i?i.split(/\s+/):[],-1===t.indexOf(e)&&t.push(e),null==(i=t.join(" ").trim())?this.removeAttribute("aria-labelledBy"):this.setAttribute("aria-labelledBy",i)})},t.EditableValueUtils._removeAriaLabelledBy=function(t,e){var i;t.each(function(){var t,s;-1!==(t=(s=(i=this.getAttribute("aria-labelledby"))?i.split(/\s+/):[]).indexOf(e))&&s.splice(t,1),(i=s.join(" ").trim())?this.setAttribute("aria-labelledby",i):this.removeAttribute("aria-labelledby")})},t.EditableValueUtils._SetInputType=function(e){var i="text",s=t.AgentUtils.getAgentInfo();s.os!==t.AgentUtils.OS.ANDROID&&s.os!==t.AgentUtils.OS.IOS&&s.os!==t.AgentUtils.OS.WINDOWSPHONE||e.indexOf(this.options.virtualKeyboard)>=0&&(i=this.options.virtualKeyboard),null==i?this.element[0].removeAttribute("type"):this.element[0].setAttribute("type",i)};var g="invalidShown";t.__registerWidget("oj.editableValue",e.oj.baseComponent,{widgetEventPrefix:"oj",options:{describedBy:null,disabled:!1,displayOptions:{},help:void 0,helpHints:{definition:"",source:""},labelHint:"",messagesCustom:[],messagesHidden:void 0,messagesShown:void 0,title:"",valid:void 0,value:void 0,animateStart:null,animateEnd:null},getNodeBySubId:function(t){var e;if(!(e=this._super(t))&&!this._IsCustomElement()&&"oj-label-help-icon"===t.subId){var i=this._GetLabelElement();i&&(e=i.parent().find(".oj-label-help-icon"))}return e||null},getSubIdByNode:function(t){var i,s,n,a=null;return null!=t&&null!=(i=e(t).closest("a.oj-label-help-icon"))&&null!=(s=i.closest(".oj-label"))&&(n=s.find("label")[0])&&n===this._GetLabelElement()[0]&&(a={subId:"oj-label-help-icon"}),a},isValid:function(){return void 0===this._valid&&(this._valid=!this._hasInvalidMessages()),this._valid},refresh:function(){this._super(),this._doRefresh()},reset:function(){this._clearAllMessages(),this._runDeferredValidation(this._VALIDATION_CONTEXT.RESET_METHOD),this._refreshComponentDisplayValue(this.options.value,!0)},showMessages:function(){var e,i,s,n=[],a=this.options.messagesHidden,o=a.length>0;for(e=0;e<a.length;e++)(i=a[e])instanceof t.ComponentMessage?(i._forceDisplayToShown(),s=i.clone()):s=new l(i.summary,i.detail,i.severity),n.push(s);o&&(this._clearMessages("messagesHidden"),this._updateMessagesOption("messagesShown",n),this._setValidOption(g,null))},_VALIDATION_MODE:{FULL:1,VALIDATORS_ONLY:2,REQUIRED_VALIDATOR_ONLY:3},_VALIDATION_CONTEXT:t.EditableValueUtils.validationContext,_VALIDATE_METHOD_OPTIONS:t.EditableValueUtils.validateMethodOptions,_InitOptions:function(t,e){this._super(t,e)},_ComponentCreate:function(){var t=this.element,e=this._GetSavedAttributes(t);if(this._super(),this.options.messagesCustom=this.options.messagesCustom||[],this.options.messagesHidden=[],this.options.messagesShown=this.options.messagesCustom.length>0?this._cloneMessagesBeforeSet(this.options.messagesCustom):[],this._SetDisabledDom(t),this._HasPlaceholderSet()&&(this._SetPlaceholder(this.options.placeholder),this._customPlaceholderSet=!0),e&&!this._IsCustomElement()){var i=t[0].tagName.toLowerCase();"input"!==i&&"textarea"!==i||["required","title","pattern"].forEach(function(i){i in e&&t.removeAttr(i)})}},_AfterCreate:function(){var t;this._super(),this._refreshTheming("disabled",this.options.disabled),this.widget()[0].classList.add("oj-form-control"),this._IsCustomElement()?(void 0===this.customOjLabelElement&&(this.customOjLabelElement=this._getCustomOjLabelElement()),this.customOjLabelElement&&this.customOjLabelElement.classList.add(this._GetDefaultStyleClass()+"-label")):this._createOjLabel(),(t=this.options.describedBy)&&this._addAriaDescribedBy(t),this._initComponentMessaging(),this._runDeferredValidation(this._VALIDATION_CONTEXT.COMPONENT_CREATE),this.options.messagesShown.length>0&&this._setMessagesOption("messagesShown",this.options.messagesShown,null,!0),this._Refresh("value",this.options.value,!1)},_SaveAttributes:function(t){this._IsCustomElement()||this._SaveAllAttributes(t)},_RestoreAttributes:function(t){this._IsCustomElement()||this._RestoreAllAttributes(t)},_AfterSetOption:function(e,i){switch(e){case"disabled":this._AfterSetOptionDisabledReadOnly(e,t.EditableValueUtils.disabledOptionOptions);break;case"displayOptions":this._initComponentMessaging();break;case"help":this._IsCustomElement()?this._getComponentMessaging().update(this._getMessagingContent(this._MESSAGING_CONTENT_UPDATE_TYPE.TITLE)):this._Refresh(e,this.options[e]);break;case"messagesCustom":this._messagesCustomOptionChanged(i),this._setValidOption(this._determineValidFromMessagesOptions(),null);break;case"placeholder":this._placeholderOptionChanged(i);break;case"title":this._IsCustomElement()||this._getComponentMessaging().update(this._getMessagingContent(this._MESSAGING_CONTENT_UPDATE_TYPE.TITLE));break;case"translations":this.refresh();break;case"value":this._AfterSetOptionValue(e,i)}},_AfterSetOptionDisabledReadOnly:function(t,e){var i=!this.options[t];this._Refresh(t,this.options[t]),i&&this._runMixedValidationAfterSetOption(e)},_AfterSetOptionValue:function(t,e){var i,s=e?e._context:null,n=!1;s&&(n=!!s.originalEvent,i=s.doNotClearMessages||!1),n||(i||this._clearAllMessages(null),this._runDeferredValidation(this._VALIDATION_CONTEXT.VALUE_OPTION_CHANGE)),this._Refresh(t,this.options[t],!0)},_CanSetValue:function(){return!(this.options.disabled||!1)},_destroy:function(){var t,i,s=this._super();if(this._clearAllMessages(null,!0),this._getComponentMessaging().deactivate(),this.$label)for(i=this.$label.length,t=0;t<i;t++)this.$label[t]&&null!=o.__GetWidgetConstructor(this.$label[t])&&e(this.$label[t]).ojLabel("destroy");return s},GetFocusElement:function(){return this._GetContentElement()[0]},_setOption:function(t,e,i){var s,n,a,o=!1;if("string"==typeof t&&void 0!==e)switch(t){case"messagesHidden":case"messagesShown":case"rawValue":o=!0;break;case"describedBy":a=e,(n=this.options.describedBy)&&this._removeAriaDescribedBy(n),a&&this._addAriaDescribedBy(a)}return o?(p.error(t+" option cannot be set"),this):(s=this._superApply(arguments),this._AfterSetOption(t,i),s)},_GetContentElement:function(){return this.element},_GetLabelElement:function(){var i;if(this.$label)return this.$label;if(t.EditableValueUtils.hasNoLabelFlag(this.widget()))return null;var s=this._getAriaLabelledByElement(this.element);if(null!==s&&0!==s.length)return s;var n=this.element[0].id;return void 0!==n&&0!==(s=e("label[for='"+n+"']")).length?s:0!==(i=this.element.closest("[aria-labelledby]")).length&&null!==(s=this._getAriaLabelledByElement(i))&&0!==s.length?s:null},_GetElementValue:function(){return this.element.val()},_GetMessagingLauncherElement:function(){return this._GetContentElement()},_GetConverter:function(){return null},_GetImplicitSyncValidators:function(){return this._implicitSyncValidators||(this._implicitSyncValidators={}),this._implicitSyncValidators},_GetImplicitAsyncValidators:function(){return this._implicitAsyncValidators||(this._implicitAsyncValidators={}),this._implicitAsyncValidators},_GetDisplayValue:function(t){return this._GetContentElement().val()},_GetNormalizedValidatorsFromOption:function(){return[]},_GetNormalizedAsyncValidatorsFromOption:function(){return[]},_GetAllSyncValidators:function(){var t,e,i,s,n;if(!this._allValidators){t=[],i=this._GetImplicitSyncValidators(),s=[];var a,o=Object.keys(i),r=o.length;if(r>0){for(e=0;e<r;e++)a=o[e],s.push(i[a]);t=t.concat(s)}(n=this._GetNormalizedValidatorsFromOption()).length>0&&(t=t.concat(n)),this._allValidators=t}return this._allValidators||[]},_ResetAllValidators:function(){this._allValidators&&(this._allValidators.length=0),this._allValidators=null,this._allAsyncValidators&&(this._allAsyncValidators.length=0),this._allAsyncValidators=null,this._IsCustomElement()?this._updateValidatorMessagingHint():this._getComponentMessaging().update(this._getMessagingContent(this._MESSAGING_CONTENT_UPDATE_TYPE.VALIDATOR_HINTS))},_getAllAsyncValidators:function(){var t,e,i,s,n;if(!this._allAsyncValidators){t=[],e=this._GetImplicitAsyncValidators(),i=[];var a,o=Object.keys(e),r=o.length;if(r>0){for(s=0;s<r;s++)a=o[s],i.push(e[a]);t=t.concat(i)}(n=this._GetNormalizedAsyncValidatorsFromOption()).length>0&&(t=t.concat(n)),this._allAsyncValidators=t}return this._allAsyncValidators||[]},_getAllAsyncValidatorsWithHint:function(){var t,e,i=this._getAllAsyncValidators(),s=[];if(i.length>0)for(t=0;t<i.length;t++)"hint"in(e=i[t])&&s.push(e);return s},_initAsyncValidatorMessagingHint:function(){var t,e,i=this._getAllAsyncValidatorsWithHint(),s=this;this._asyncValidatorHintCounter=0,i.length>0&&(e=s._getMessagingContent(s._MESSAGING_CONTENT_UPDATE_TYPE.VALIDATOR_HINTS),t=this._asyncValidatorHintCounter,this._setBusyStateAsyncValidatorHint(t),this._addAsyncValidatorsHintsMessagingContent(i,e).then(function(){s._clearBusyStateAsyncValidatorHint(t)}))},_updateValidatorMessagingHint:function(){var t,e=this._getAllAsyncValidatorsWithHint(),i=this._getComponentMessaging(),s=this,n=this._getMessagingContent(this._MESSAGING_CONTENT_UPDATE_TYPE.VALIDATOR_HINTS);e.length>0?(this._asyncValidatorHintCounter+=1,t=this._asyncValidatorHintCounter,this._setBusyStateAsyncValidatorHint(t),this._addAsyncValidatorsHintsMessagingContent(e,n).then(function(){s._clearBusyStateAsyncValidatorHint(t)})):i.update(n)},_addAsyncValidatorsHintsMessagingContent:function(t,e){var i,s=this._asyncValidatorHintCounter,n=this._getComponentMessaging(),a=[],o=this,r=[];for(i=0;i<t.length;i++)r.push(t[i].hint);function l(t){return t.then(function(t){var i,r={};return o._asyncValidatorHintCounter===s?(null!==t&&(a.push(t),r.validatorHint=e.validatorHint.concat(a),n.update(r)),i="resolved"):i="ignore",{v:t,status:i}},function(t){return{e:t,status:"rejected"}})}return new Promise(function(t){Promise.all(r.map(l)).then(function(){t(a)})})},_IsRequired:function(){return!1},_HandleChangeEvent:function(t){var e=this._GetDisplayValue();this._SetValue(e,t)},_SetRawValue:function(t,e){var i={};i._context={originalEvent:e,writeback:!0,internalSet:!0,readOnly:!0},this._CompareOptionValues("rawValue",this.options.rawValue,t)||this.option("rawValue",t,i)},_Refresh:function(t,e,i){var s,n;switch(t){case"converter":var a=this.options.value;this._refreshComponentDisplayValue(a,i);break;case"disabled":this._refreshTheming("disabled",this.options.disabled);break;case"help":this._IsCustomElement()||this.$label&&(s=this.options.help.definition,n=this.options.help.source,this.$label.ojLabel("option","help",{definition:s,source:n}),this._refreshDescribedByForLabel());break;case"value":this._refreshComponentDisplayValue(e,i)}},_NotifyHidden:function(){this._superApply(arguments),this._getComponentMessaging().close()},_NotifyDetached:function(){this._superApply(arguments),this._getComponentMessaging().close()},_ResetComponentState:function(){this.$label&&this.$label.ojLabel("refresh"),this._implicitReqValidator=null,this._converter=null,this._ResetAllValidators()},_SetDisplayValue:function(t){var e=this._GetContentElement();e.val()!==t&&e.val(t)},_SetDisabledDom:function(t){"boolean"==typeof this.options.disabled&&(t[0].disabled=this.options.disabled)},_SetPlaceholder:function(t){var e=this._GetContentElement()[0];e&&(null==t?e.removeAttribute("placeholder"):e.setAttribute("placeholder",t))},_SetPlaceholderOption:function(t){this.options.placeholder=t},_HasPlaceholderSet:function(){return this.options.placeholder},_ClearPlaceholder:function(){this._SetPlaceholderOption(""),this._SetPlaceholder("")},_SetValue:function(t,e,i){var s,n,a,o=!i||"boolean"!=typeof i.doValueChangeCheck||i.doValueChangeCheck,r=this,l=!1;return void 0===t?(p.warn("Attempt to set a value of undefined"),!1):(o&&t===r._getLastDisplayValue()?p.level>p.LEVEL_WARN&&p.info((t.toString,t.toString())):(s=t+"_"+(this._asyncValidatorValidateCounter+1),(n=this._AsyncValidate(t,e,i,s))instanceof Promise?l=n.then(function(t){return a=t,r._afterAsyncValidateUpdateValue(t,e,i)}).then(function(){return r._clearBusyState(s),void 0!==a}):(this._afterAsyncValidateUpdateValue(n,e,i),l=void 0!==n)),l)},_ParseValueShowErrors:function(t,e){var i;this._clearAllMessages(e);try{return this._parseValue(t,e)}catch(t){i=this._processValidationErrors(t),this._updateMessagesOption("messagesShown",i,e),this._setValidOption(g,e)}},_AsyncValidate:function(t,e,i,s){var n,a,o,r=i&&i.validationMode?i.validationMode:this._VALIDATION_MODE.FULL,l=i&&i.validationContext?i.validationContext:this._VALIDATION_CONTEXT.USER_ACTION,u=i&&i.doNotClearMessages||!1;if(void 0!==t){if(this._CanSetValue()){u||this._clearAllMessages(e);try{return this._asyncValidatorValidateCounter+=1,r===this._VALIDATION_MODE.FULL?(this._setLastDisplayValue(t),a=this._parseValue(t,e,!0)):a=t,(o=this._asyncValidateValue(a,e,l))instanceof Promise?(this._setBusyState(s),o.then(function(t){if("valid"===t)return a})):o}catch(t){n=this._processValidationErrors(t,l),this._updateMessagesOption("messagesShown",n,e),this._setValidOption(g,e)}}else p.level>p.LEVEL_WARN&&p.info("Validation skipped and value option not set as component state does not  allow setting value. For example if the component is readonly or disabled.");return o}p.warn("Attempt to set a value of undefined")},_afterAsyncValidateUpdateValue:function(t,e,i){var s,n=!1;return void 0!==t&&(i&&!0===i.doNotClearMessages?this.isValid()||!this._hasInvalidComponentMessagesShowing():this.isValid())&&(i&&i._context&&(s=i._context),this._updateValueOption(t,e,i&&i.validationContext,s,i),n=!0),n},_CompareOptionValues:function(e,i,s){return"value"===e||"rawValue"===e?t.Object.compareValues(i,s):0===e.indexOf("messages")?this._messagesEquals(i,s):this._superApply(arguments)},_GetDefaultStyleClass:function(){return t.Assert.failedInAbstractFunction(),""},_MESSAGING_CONTENT_UPDATE_TYPE:{ALL:1,VALIDITY_STATE:2,CONVERTER_HINT:3,VALIDATOR_HINTS:4,TITLE:5},_OPTION_TO_CSS_MAPPING:{disabled:"oj-disabled",required:"oj-required"},_clearAllMessages:function(t,e){e?(this.options.messagesHidden=[],this.options.messagesShown=[],this.options.messagesCustom=[]):(this._clearMessages("messagesHidden",t),this._clearMessages("messagesShown",t),this._clearMessages("messagesCustom",t))},_clearComponentMessages:function(){var e,i=this.options.messagesShown;e=i.length,this._clearMessages("messagesHidden");for(var s=e-1;s>=0;s--)i[s]instanceof t.ComponentMessage&&i.splice(s,1);i.length!==e&&this._setMessagesOption("messagesShown",i,null,!0)},_setMessagesOption:function(t,e,i,s){var n={},a=0===e.length&&0===this.options[t].length;!s&&a||(n._context={originalEvent:i,writeback:!0,internalSet:!0},"messagesCustom"!==t&&(n._context.readOnly=!0),n.changed=s||!a,this._resetValid(),this.option(t,e,n),this._updateMessagingContent())},_setValidOption:function(t,e){var i={};"pending"===t&&"valid"!==this._determineValidFromMessagesOptions()||(i._context={originalEvent:e,writeback:!0,internalSet:!0,readOnly:!0},this.option("valid",t,i))},_clearMessages:function(t,e){this._setMessagesOption(t,[],e)},_cloneMessagesBeforeSet:function(t){var e,i,s,n=[];if(t&&t.length>0)for(e=0;e<t.length;e++)s=t[e],i=new l(s.summary,s.detail,s.severity),i=Object.freeze?Object.freeze(i):i,n.push(i);return n},_createOjLabel:function(){var t,e;this._IsCustomElement()||(this.$label=this._GetLabelElement(),this.$label&&(t=this.options.help.definition,e=this.options.help.source,this.$label.ojLabel({rootAttributes:{class:this._GetDefaultStyleClass()+"-label"},help:{definition:t,source:e}}),this._createDescribedByForLabel()))},_createDescribedByForLabel:function(){var t,e=this.options.help.definition;if(null!=this.options.help.source||null!=e){var i=this.$label[0];i&&(t=i.id),t&&this._addAriaDescribedBy(t+"_helpIcon")}},_refreshDescribedByForLabel:function(){var t,e=this.options.help.definition,i=this.options.help.source,s=this.$label[0];s&&(t=s.id),t&&(null!=i||null!=e?this._addAriaDescribedBy(t+"_helpIcon"):this._removeAriaDescribedBy(t+"_helpIcon"))},_doRefresh:function(){var e,i=!1;this._ResetComponentState(),this._initComponentMessaging(),this._Refresh("disabled",this.options.disabled),this._hasInvalidMessagesShowing()&&(i=!0),this._clearComponentMessages(),i?(e=this._GetDisplayValue(),this._SetValue(e,null,t.EditableValueUtils.refreshMethodOptions)):(this._IsRequired()&&this._runDeferredValidation(t.EditableValueUtils.refreshMethodOptions.validationContext),this._Refresh("value",this.options.value,!0))},_getLastModelValue:function(){return this._oj_lastModelValue},_getLastDisplayValue:function(){return void 0===this._oj_lastElementValue&&(this._oj_lastElementValue=""),this._oj_lastElementValue},_getAriaLabelledByElement:function(t){var i=t[0].getAttribute("aria-labelledby");return void 0!==i?e("label[id='"+i+"']"):null},_getAriaLabelledById:function(t){var e=null,i=this._getAriaLabelledByElement(t);return null!==i&&0!==i.length&&(e=i[0].getAttribute("id")),e},_addAriaDescribedBy:function(t){this._GetContentElement().each(function(){var e,i=this.getAttribute("aria-describedby");e=i?i.split(/\s+/):[],-1===e.indexOf(t)&&e.push(t),null==(i=e.join(" ").trim())?this.removeAttribute("aria-describedby"):this.setAttribute("aria-describedby",i)})},_removeAriaDescribedBy:function(t){this._GetContentElement().each(function(){var e,i,s;-1!==(i=(s=(e=this.getAttribute("aria-describedby"))?e.split(/\s+/):[]).indexOf(t))&&s.splice(i,1),(e=s.join(" ").trim())?this.setAttribute("aria-describedby",e):this.removeAttribute("aria-describedby")})},_getMessages:function(){return this.options.messagesShown.concat(this.options.messagesHidden)},_getCustomOjLabelElement:function(){var e,i,s=null,n=this.options.labelledBy,a=this.widget();if(n&&(s=document.getElementById(n)),null===s&&!t.EditableValueUtils.hasNoLabelFlag(a)){var o=a[0];(i=o.id)&&(s=0===(e=Array.prototype.filter.call(o.parentNode.children,function(t){return t!==o&&t.getAttribute("for")===i})).length?document.querySelector("[for='"+i+"']"):e[0])}return s},_getLabelText:function(){return this.$label?this.$label[0].textContent:(void 0===this.customOjLabelElement&&(this.customOjLabelElement=this._getCustomOjLabelElement()),this.customOjLabelElement?this.customOjLabelElement.textContent:null)},_getValidityState:function(){return this._validityState?this._validityState:(this._validityState=new t.ComponentValidity(this.isValid(),this._getMessages()),this._validityState)},_hasInvalidMessages:function(){return!l.isValid(this._getMessages())},_hasInvalidMessagesShowing:function(){return!this.isValid()&&this.options.messagesShown.length>0},_hasInvalidComponentMessagesShowing:function(){for(var e,i,s=this.options.messagesShown,n=0;n<s.length;n++)(i=s[n])instanceof t.ComponentMessage&&i._isMessageAddedByComponent()&&(e=e||[]).push(i);return void 0!==e&&!l.isValid(e)},_initComponentMessaging:function(){var t=this._getComponentMessaging(),e=this._GetMessagingLauncherElement(),i=this._GetContentElement(),s=this._getMessagingContent(this._MESSAGING_CONTENT_UPDATE_TYPE.ALL);this._customPlaceholderSet||this._ClearPlaceholder(),t.activate(e,i,s),this._IsCustomElement()&&(this._initAsyncValidatorMessagingHint(),this._asyncValidatorValidateCounter=0)},_messagesCustomOptionChanged:function(e){var i,s,n=e?e._context:null,a=this.options.messagesCustom,o=this.options.messagesShown,r=[];for(i=0;i<o.length;i++)(s=o[i])instanceof t.ComponentMessage&&s._isMessageAddedByComponent()&&r.push(s);for(i=0;i<a.length;i++)r.push(a[i]);this._setMessagesOption("messagesShown",r,n?n.originalEvent:null,e&&e.changed)},_placeholderOptionChanged:function(t){var e=!(t&&t._context||{}).internalMessagingSet,i=this.options.placeholder;this._SetPlaceholder(i),e?(this._customPlaceholderSet=!0,this._GetConverter()&&this._initComponentMessaging()):this._customPlaceholderSet=!1},_setLastModelValue:function(t){this._oj_lastModelValue=t},_setLastDisplayValue:function(t){this._oj_lastElementValue=t},_updateMessagesOption:function(t,e,i){var s,n,a;if("object"==typeof e&&Array.isArray(e))for(a=this.options[t],n=e.length,s=0;s<n;s++)a.push(e[s]);this._setMessagesOption(t,a,i,!0)},_updateMessagingContent:function(){this._getComponentMessaging().update(this._getMessagingContent(this._MESSAGING_CONTENT_UPDATE_TYPE.VALIDITY_STATE))},_updateValueOption:function(t,e,i,s,n){var a,o,r=s||{};switch(e&&(r.originalEvent=e),i){case this._VALIDATION_CONTEXT.CONVERTER_OPTION_CHANGE:case this._VALIDATION_CONTEXT.DISABLED_OPTION_CHANGE:case this._VALIDATION_CONTEXT.READONLY_OPTION_CHANGE:case this._VALIDATION_CONTEXT.REFRESH_METHOD:case this._VALIDATION_CONTEXT.REQUIRED_OPTION_CHANGE:case this._VALIDATION_CONTEXT.VALIDATE_METHOD:case this._VALIDATION_CONTEXT.VALIDATORS_OPTION_CHANGE:r.writeback=!0,r.doNotClearMessages=!0}if(r.internalSet=!0,n&&n.targetOptions){a={},o=!1;for(var l=0;l<n.targetOptions.length;l++)a[n.targetOptions[l]]=t,o=o||"value"===n.targetOptions[l]}else a={value:t},o=!0;this.option(a,{_context:r}),o&&this._AfterSetOptionValue("value",{_context:r})},_resetValid:function(){this._valid=void 0},_determineValidFromMessagesOptions:function(){var t=this.options.messagesHidden,e=this.options.messagesShown,i="valid";return e&&0!==e.length&&!l.isValid(e)?i=g:t&&0!==t.length&&!l.isValid(t)&&(i="invalidHidden"),i},_formatValue:function(t){var e=t,i=this._GetConverter();return i&&"object"==typeof i&&(i.format&&"function"==typeof i.format?e=i.format(t):p.level>p.LEVEL_WARN&&p.info("converter does not support the format method.")),e},_getComponentMessaging:function(){return this._componentMessaging||(this._componentMessaging=new t.ComponentMessaging(this)),this._componentMessaging},_getHintsForAllValidators:function(t){var e,i,s=[],n="";for(this._IsRequired()&&(i=this._getImplicitRequiredValidator()).getHint&&"function"==typeof i.getHint&&(n=i.getHint())&&s.push(n),e=0;e<t.length;e++)n="","object"==typeof(i=t[e])&&i.getHint&&"function"==typeof i.getHint&&(n=i.getHint())&&s.push(n);return s},_getImplicitRequiredValidator:function(){var e,i,s={};return null==this._implicitReqValidator&&(i={hint:(s=this.options.translations&&this.options.translations.required||{}).hint||null,label:this._getLabelText(),messageSummary:s.messageSummary||null,messageDetail:s.messageDetail||null},e=u.Validation.validatorFactory(t.ValidatorFactory.VALIDATOR_TYPE_REQUIRED),this._implicitReqValidator=e?e.createValidator(i):null),this._implicitReqValidator},_getMessagingContent:function(t){var e,i,s,n={},a="",o=[];if((t=t||this._MESSAGING_CONTENT_UPDATE_TYPE.VALIDITY_STATE)!==this._MESSAGING_CONTENT_UPDATE_TYPE.ALL&&t!==this._MESSAGING_CONTENT_UPDATE_TYPE.VALIDITY_STATE||(s=this._getMessages(),this._getValidityState().update(this.isValid(),s),n.validityState=this._getValidityState()),t!==this._MESSAGING_CONTENT_UPDATE_TYPE.ALL&&t!==this._MESSAGING_CONTENT_UPDATE_TYPE.CONVERTER_HINT||((i=this._GetConverter())&&"object"==typeof i&&i.getHint&&"function"==typeof i.getHint&&(a=i.getHint()||""),n.converterHint=a),t!==this._MESSAGING_CONTENT_UPDATE_TYPE.ALL&&t!==this._MESSAGING_CONTENT_UPDATE_TYPE.VALIDATOR_HINTS||(e=this._GetAllSyncValidators(),o=this._getHintsForAllValidators(e)||[],n.validatorHint=o),t===this._MESSAGING_CONTENT_UPDATE_TYPE.ALL||t===this._MESSAGING_CONTENT_UPDATE_TYPE.TITLE){var r;if(this._IsCustomElement()){var l=this.options.help;null!=l&&(r=l.instruction)}else r=this.options.title;n.title=r||""}return n},_messagesEquals:function(t,i){var s,n=-1,a=!0,o=e.extend([],t),r=e.extend([],i);return o.length===r.length&&(o.forEach(function(t){t instanceof l?s=t:(s=new l(t.summary,t.detail,t.severity),s=Object.freeze?Object.freeze(s):s),n=-1,r.forEach(function(t,e){l.getSeverityLevel(s.severity)===l.getSeverityLevel(t.severity)&&s.summary===t.summary&&s.detail===t.detail&&(n=e)}),n>-1?r.splice(n,1):a=!1}),a)},_parseValue:function(t,e,i){var s=this._GetConverter(),n=t;if(s&&"object"==typeof s)if(s.parse&&"function"==typeof s.parse)try{i&&this._setValidOption("pending",e),n=s.parse(t)}catch(t){throw t}else p.level>p.LEVEL_WARN&&p.info("converter does not support the parse method.");return n},_addValidationError:function(e,i){var n,a,o,r;e instanceof t.ConverterError||e instanceof t.ValidatorError?(a=(o=e.getMessage()).severity||l.SEVERITY_LEVEL.ERROR,r=o.summary||s.getTranslatedString("oj-message.error"),n=o.detail||s.getTranslatedString("oj-converter.detail")):e.summary||e.detail?(a=l.SEVERITY_LEVEL.ERROR,r=e.summary||s.getTranslatedString("oj-message.error"),n=e.detail||s.getTranslatedString("oj-converter.detail")):(a=l.SEVERITY_LEVEL.ERROR,r=s.getTranslatedString("oj-message.error"),n=e.message||s.getTranslatedString("oj-converter.detail")),i.push({summary:r,detail:n,severity:a})},_processValidationErrors:function(e,i,s){var n,a=[],o=e._messages||[],r={};r.context=i||0,r.display=s||t.ComponentMessage.DISPLAY.SHOWN,0===o.length&&this._addValidationError(e,o);for(var l=0;l<o.length;l++)n=o[l],a.push(this._createComponentMessage(n.summary,n.detail,n.severity,r));return a||null},_createComponentMessage:function(e,i,s,n){var a;return a=new t.ComponentMessage(e,i,s,n),a=Object.seal?Object.seal(a):a},_refreshComponentDisplayValue:function(t,e){var i;return(e||t!==this._getLastModelValue())&&(i=this._UpdateElementDisplayValue(t)),i},_refreshTheming:function(t,e){-1!==Object.keys(this._OPTION_TO_CSS_MAPPING).indexOf(t)&&(e?this.widget()[0].classList.add(this._OPTION_TO_CSS_MAPPING[t]):this.widget()[0].classList.remove(this._OPTION_TO_CSS_MAPPING[t]))},_runDeferredValidation:function(t){this._CanSetValue()?this._validateValueForRequiredOnly(this.options.value,t):p.level>p.LEVEL_WARN&&p.info("Deferred validation skipped as component is readonly or disabled."),this._setValidOption(this._determineValidFromMessagesOptions(),null)},_runMixedValidationAfterSetOption:function(t){var e,i=!1;this._hasInvalidMessagesShowing()&&(i=!0),this._clearComponentMessages(),i&&(e=this._GetDisplayValue(),this._SetValue(e,null,t)),!i&&this._IsRequired()?this._runDeferredValidation(t.validationContext):this._setValidOption(this._determineValidFromMessagesOptions(),null)},_UpdateElementDisplayValue:function(t,e){var i,s;i=t;try{i=this._formatValue(t);try{this._setLastModelValue(t),this._afterConverterFormat(i)}catch(t){throw t}s=i}catch(n){e||this._afterConverterFormatFailure(n),this._setLastModelValue(t),this._afterConverterFormat(i),s=void 0}return s},_afterConverterFormat:function(t){var e;this._SetDisplayValue(t),e=this._GetDisplayValue(),this._setLastDisplayValue(e),this._SetRawValue(e,null)},_afterConverterFormatFailure:function(t){var e;e=this._processValidationErrors(t),this._updateMessagesOption("messagesShown",e),this._setValidOption(g,null)},_validateValueForRequiredOnly:function(e,i){var s,n;if(this._IsRequired()){n=this._getImplicitRequiredValidator();try{this._setValidOption("pending",null),n.validate(t.StringUtils.trim(e))}catch(e){(s=this._processValidationErrors(e,i,t.ComponentMessage.DISPLAY.HIDDEN))&&this._updateMessagesOption("messagesHidden",s)}}},_validateValue:function(e,i,s){var n,a,o,r,l=this._GetAllSyncValidators(),u=this._IsRequired(),d=!1,_=[];if((u||l.length>0)&&this._setValidOption("pending",i),u){o=this._getImplicitRequiredValidator();try{o.validate(t.StringUtils.trim(e))}catch(t){this._addValidationError(t,_),this._setValidOption(g,i),d=!0}}for(n=0;n<l.length;n++)if("object"==typeof(o=l[n]))if(o.validate&&"function"==typeof o.validate)try{o.validate(e)}catch(t){this._addValidationError(t,_),d||(this._setValidOption(g,i),d=!0)}else p.level>p.LEVEL_WARN&&p.info("validator does not support the validate method.");return _.length>0&&((r=new Error)._messages=_,a=this._processValidationErrors(r,s),this._updateMessagesOption("messagesShown",a,i)),0===_.length},_asyncValidateValue:function(e,i,s){var n,a,o,r,l=this._getAllAsyncValidators(),u=!1,d=l.length>0,_=this,h=this._asyncValidatorValidateCounter;if(d&&this._setValidOption("pending",i),r=this._validateValue(e,i,s),!d)return r&&this._setValidOption(_._determineValidFromMessagesOptions(),i),r?e:void 0;var c=[];for(n=0;n<l.length;n++)c.push(l[n].validate(t.StringUtils.trim(e)));function E(t){return t.then(function(t){var i;return _._asyncValidatorValidateCounter===h?i="resolved":(p.level>p.LEVEL_WARN&&p.info("Validate ignored because new value came in before async validator finished for "+e),i="ignore"),{v:t,status:i}},function(t){var n;return _._asyncValidatorValidateCounter===h?(o=_._processValidationErrors(t,s),_._updateMessagesOption("messagesShown",o,i),u||(_._setValidOption(g,i),u=!0),n="rejected"):(p.level>p.LEVEL_WARN&&p.info("Validate ignored because new value came in before async validator finished for "+e),n="ignore"),{e:t,status:n}})}return new Promise(function(t){Promise.all(c.map(E)).then(function(e){e.filter(function(t){return"ignore"===t.status}).length>0?a="ignoreValidation":(a=u?g:"valid",_._setValidOption(_._determineValidFromMessagesOptions(),i)),t(a)})})},_setBusyState:t.EditableValueUtils._SetBusyState,_clearBusyState:t.EditableValueUtils._ClearBusyState,_setBusyStateAsyncValidatorHint:t.EditableValueUtils._SetBusyStateAsyncValidatorHint,_clearBusyStateAsyncValidatorHint:t.EditableValueUtils._ClearBusyStateAsyncValidatorHint},!0),o.setDefaultOptions({editableValue:{displayOptions:o.createDynamicPropertyGetter(function(t){var e={messages:t.containers.indexOf("ojDataGrid")>=0||t.containers.indexOf("ojTable")>=0?["notewindow"]:["inline"],converterHint:["placeholder","notewindow"],validatorHint:["notewindow"]};return e[t.isCustomElement?"helpInstruction":"title"]=["notewindow"],e}),help:o.createDynamicPropertyGetter(function(t){return t.isCustomElement?{instruction:""}:{definition:null,source:null}})}}),t.InlineMessagingStrategy=function(t){this.Init(t)},t.ComponentMessaging.registerMessagingStrategy(t.ComponentMessaging._DISPLAY_TYPE.INLINE,t.InlineMessagingStrategy),t.Object.createSubclass(t.InlineMessagingStrategy,t.MessagingStrategy,"oj.InlineMessagingStrategy"),t.InlineMessagingStrategy.prototype.reactivate=function(e){t.InlineMessagingStrategy.superclass.reactivate.call(this,e),this._updateInlineMessage()},t.InlineMessagingStrategy.prototype.shouldUpdate=function(t){return!(!t||void 0===t.validityState)},t.InlineMessagingStrategy.prototype.update=function(){t.InlineMessagingStrategy.superclass.update.call(this),this._updateInlineMessage()},t.InlineMessagingStrategy.prototype.deactivate=function(){this._removeMessagingContentRootDom(),t.InlineMessagingStrategy.superclass.deactivate.call(this)},t.InlineMessagingStrategy.prototype._getDefaultAnimation=function(){if(!t.InlineMessagingStrategy._defaultAnimation){var e=(a.parseJSONFromFontFamily("oj-messaging-inline-option-defaults")||{}).animation;e=e||{},t.InlineMessagingStrategy._defaultAnimation=e}return t.InlineMessagingStrategy._defaultAnimation},t.InlineMessagingStrategy.prototype._replaceAnimationOptions=function(e,i){var s,n;t.StringUtils.isString(e)?(n=!0,s=e+""):(n=!1,s=JSON.stringify(e));for(var a=Object.keys(i),o=0;o<a.length;o++){var r=a[o];s=s.replace(new RegExp(r,"g"),i[r])}return n?s:JSON.parse(s)},t.InlineMessagingStrategy.prototype._determineAnimation=function(t,e){var i,s,n,a=this._getDefaultAnimation();if(a){var o,r=t[0],l=r.innerHTML,u=r.offsetHeight;r.innerHTML=e,o=r.offsetHeight,r.innerHTML=l,"noanimation"!==(i=o>u?"open":o<u?"close":"noanimation")&&(s=a[i])&&(n=this._replaceAnimationOptions(s,{"#oldHeight":u+"px","#newHeight":o+"px"}))}return{action:i,effect:n}},t.InlineMessagingStrategy.prototype._setBusyState=function(){if(!this._resolveBusyState){var t=this.GetComponent(),e=t?t.element:null,i=e?e[0]:null,s=n.getContext(i).getBusyContext(),a="The page is waiting for inline message ";i&&i.id&&(a+='for "'+i.id+'" '),a+="to open/close",this._resolveBusyState=s.addBusyState({description:a})}},t.InlineMessagingStrategy.prototype._clearBusyState=function(){this._resolveBusyState&&(this._resolveBusyState(),this._resolveBusyState=null)},t.InlineMessagingStrategy.prototype._queueAction=function(t){var e=this,i=this.$messagingContentRoot;e._inInlineMessagingAnimation?this._currentContentToShow=t:(this._currentContentToShow=null,this._setBusyState(),this._timeoutId&&clearTimeout(this._timeoutId),this._timeoutId=setTimeout(function(){if(e._timeoutId=null,i&&i[0]){var s=e._determineAnimation(i,t),n=s.action,a=s.effect;"noanimation"===n?(i[0].innerHTML=t,e._clearBusyState()):("close"===n?i[0].setAttribute("aria-live","off"):i[0].setAttribute("aria-live","polite"),"open"===n&&(i[0].innerHTML=t),e._inInlineMessagingAnimation=!0,r.startAnimation(i[0],"inline-"+n,a,e.GetComponent()).then(function(){var s;e._inInlineMessagingAnimation=!1,"close"===n&&(i[0].setAttribute("aria-live","polite"),i[0].innerHTML=t),null!==e._currentContentToShow?(s=e._currentContentToShow,e._currentContentToShow=null,e._queueAction(s)):e._clearBusyState()}))}else e._clearBusyState()},0))},t.InlineMessagingStrategy.prototype._updateInlineMessage=function(){var t;(t=this._buildInlineHtml())&&null==this.$messagingContentRoot&&this._createInlineMessage(),this.$messagingContentRoot&&this.$messagingContentRoot[0]&&(this.GetComponent()._IsCustomElement()?this._queueAction(t):t?this.$messagingContentRoot[0].innerHTML=t:this._removeMessagingContentRootDom())},t.InlineMessagingStrategy.prototype._createInlineMessage=function(){this.$messagingContentRoot=e(this._getInlineContentHtml()),this._addAriaDescribedBy(this.$messagingContentRoot),this._addAriaLive(this.$messagingContentRoot),this.GetComponent().widget()[0].appendChild(this.$messagingContentRoot[0])},t.InlineMessagingStrategy.prototype._getInlineContentHtml=function(){return"<div class='oj-messaging-inline-container'></div>"},t.InlineMessagingStrategy.prototype._removeMessagingContentRootDom=function(){if(null!=this.$messagingContentRoot){var t=this.$messagingContentRoot[0];this._removeAriaDescribedBy(this.$messagingContentRoot),t.parentNode.removeChild(t),this.$messagingContentRoot=null}},t.InlineMessagingStrategy.prototype._addAriaDescribedBy=function(i){var s,n,a,o,r=(n=this.GetLauncher())[0];t.Assert.assertPrototype(n,e),t.Assert.assertPrototype(i,e),a=i.uniqueId()[0].getAttribute("id"),(o=(s=r.getAttribute("aria-describedby"))?s.split(/\s+/):[]).push(a),null==(s=o.join(" ").trim())?r.removeAttribute("aria-describedby"):r.setAttribute("aria-describedby",s)},t.InlineMessagingStrategy.prototype._addAriaLive=function(i){t.Assert.assertPrototype(i,e),i[0].setAttribute("aria-live","polite")},t.InlineMessagingStrategy.prototype._removeAriaDescribedBy=function(i){var s,n,a,o,r;a=this.GetLauncher(),t.Assert.assertPrototype(a,e),t.Assert.assertPrototype(i,e),o=i[0].getAttribute("id"),-1!==(n=(r=(s=a[0].getAttribute("aria-describedby"))?s.split(/\s+/):[]).indexOf(o))&&r.splice(n,1),(s=r.join(" ").trim())?a[0].setAttribute("aria-describedby",s):a[0].removeAttribute("aria-describedby")},t.InlineMessagingStrategy.prototype._buildInlineHtml=function(){var t;return this.ShowMessages()?(t=this.GetComponent().document[0],this._buildMessagesHtml(t)):""},t.InlineMessagingStrategy.prototype._buildMessagesHtml=function(e){var i,s,n="";return this.HasMessages()&&(s=this.GetMessages(),i=this.GetMaxSeverity(),n=t.PopupMessagingStrategyUtils.buildMessagesHtml(e,s,i,!0)),n},t.PopupMessagingStrategy=function(t){this.Init(t)},t.ComponentMessaging.registerMessagingStrategy(t.ComponentMessaging._DISPLAY_TYPE.NOTEWINDOW,t.PopupMessagingStrategy),t.Object.createSubclass(t.PopupMessagingStrategy,t.MessagingStrategy,"oj.PopupMessagingStrategy"),t.PopupMessagingStrategy._DEFAULTS_BY_COMPONENT={ojRadioset:{position:"launcher",events:{open:"focusin mouseenter press",close:"mouseleave"}},ojCheckboxset:{position:"launcher",events:{open:"focusin mouseenter press",close:"mouseleave"}},ojInputText:{position:"launcher",events:{open:"focusin"}},ojTextArea:{position:"launcher",events:{open:"focusin"}},ojInputPassword:{position:"launcher",events:{open:"focusin"}},ojSwitch:{position:"launcher",events:{open:"focusin mouseenter",close:"mouseleave"}},ojSlider:{position:"launcher",events:{open:"focusin mouseenter",close:"mouseleave"}},ojColorSpectrum:{position:"launcher",events:{open:"focusin mouseenter",close:"mouseleave"}},ojColorPalette:{position:"launcher",events:{open:"focusin mouseenter",close:"mouseleave"}},default:{position:"launcher-wrapper",events:{open:"focusin"}}},t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT="oj-form-control-hint",t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT_CONVERTER="oj-form-control-hint-converter",t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT_VALIDATOR="oj-form-control-hint-validator",t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT_TITLE="oj-form-control-hint-title",t.PopupMessagingStrategy._OPEN_NAMESPACE=".ojPopupMessagingOpen",t.PopupMessagingStrategy._CLOSE_NAMESPACE=".ojPopupMessagingClose",t.PopupMessagingStrategy.prototype.activate=function(e){t.PopupMessagingStrategy.superclass.activate.call(this,e),this._initMessagingPopup()},t.PopupMessagingStrategy.prototype.reactivate=function(e){t.PopupMessagingStrategy.superclass.reactivate.call(this,e),this._updatePopupIfOpenOrComponentHasFocus()},t.PopupMessagingStrategy.prototype.update=function(){t.PopupMessagingStrategy.superclass.update.call(this),this._updatePopupIfOpenOrComponentHasFocus()},t.PopupMessagingStrategy.prototype.deactivate=function(){this._unregisterLauncherEvents(),this._destroyTooltip(),t.PopupMessagingStrategy.superclass.deactivate.call(this)},t.PopupMessagingStrategy.prototype.close=function(){this._closePopup()},t.PopupMessagingStrategy.prototype._closePopup=function(){this._queueAction(function(t){if(this._isPopupInitialized())return t&&this._setActionResolver(this.$messagingContentRoot,"close",t),void this.$messagingContentRoot.ojPopup("close");t&&t(!0)}.bind(this))},t.PopupMessagingStrategy.prototype._initMessagingPopup=function(){this._openPopupCallback||this._registerLauncherEvents()},t.PopupMessagingStrategy.prototype._addAnimateEventListeners=function(t){var e=function(t,e,i){var s=this.GetComponent();s&&s._trigger&&(e.stopPropagation(),s._trigger(t,null,i)||e.preventDefault())};t.on("ojanimatestart.notewindow",e.bind(this,"animateStart")),t.on("ojanimateend.notewindow",e.bind(this,"animateEnd"))},t.PopupMessagingStrategy.prototype._removeAnimateEventListeners=function(t){t.off("ojanimatestart.notewindow"),t.off("ojanimateend.notewindow")},t.PopupMessagingStrategy.prototype._setBusyState=function(t){var e=this.GetComponent(),i=e?e.element:null,s=i?i[0]:null,a=n.getContext(s).getBusyContext(),o="The page is waiting for note window ";return s&&s.id&&(o+='for "'+s.id+'" '),o+="to "+t,a.addBusyState({description:o})},t.PopupMessagingStrategy.prototype._setActionResolver=function(t,e,i){var s;this._actionCount>1&&(s=t.ojPopup("option","animation"),t.ojPopup("option","animation",null));var n=this._setBusyState(e);t.one("oj"+e,function(){s&&t.ojPopup("option","animation",s),n(),i(!0)})},t.PopupMessagingStrategy.prototype._queueAction=function(t){if(this.GetComponent()._IsCustomElement()){var e=this,i=function(t){var i=new Promise(t);return i.then(function(){e._actionCount-=1}),i};this._actionCount?(this._actionCount+=1,this._actionPromise=this._actionPromise.then(function(){return i(t)})):(this._actionCount=1,this._actionPromise=i(t))}else t(null)},t.PopupMessagingStrategy.prototype._openPopup=function(e){this._queueAction(function(i){var s,n,a;if(this._canOpenPopup()&&(n=this._buildPopupHtml(),!t.StringUtils.isEmptyOrUndefined(n))){var o=this._getPopupElement(),r=o.ojPopup("isOpen");if((s=t.PopupMessagingStrategyPoolUtils.getPopupContentNode(o)).innerHTML="",s.innerHTML=n,!r)return a=this.GetLauncher(),e&&"press"===e.type&&this._openPopupOnPressEvent(a),i&&this._setActionResolver(o,"open",i),void o.ojPopup("open",a);r&&o.ojPopup("refresh")}i&&i(!0)}.bind(this))},t.PopupMessagingStrategy.prototype._openPopupOnPressEvent=function(t){this._inPressEvent=!0,t[0].addEventListener("click",this._eatChangeAndClickOnPress,!0),t[0].addEventListener("change",this._eatChangeAndClickOnPress,!0),t.one("touchend",function(){setTimeout(function(){this._inPressEvent=!1},50)})},t.PopupMessagingStrategy.prototype._eatChangeAndClickOnPress=function(t){this._inPressEvent&&(t.preventDefault(),t.stopPropagation(),"click"===t.type&&(this._inPressEvent=!1))},t.PopupMessagingStrategy.prototype._canOpenPopup=function(){var t=this.GetComponent().options,e=t.disabled||!1,i=t.readOnly||!1;return!(e||i)},t.PopupMessagingStrategy.prototype._updatePopupIfOpenOrComponentHasFocus=function(){var e,i,s,n;e=this._buildPopupHtml(),null!=this.GetLauncher()&&(s=this.GetLauncher()[0].contains(document.activeElement),this._isPopupInitialized()?(n=this._getPopupElement()).ojPopup("isOpen")&&(e?((i=t.PopupMessagingStrategyPoolUtils.getPopupContentNode(n)).innerHTML="",i.innerHTML=e,n.ojPopup("refresh")):n.ojPopup("close")):s&&e&&this._openPopup(void 0))},t.PopupMessagingStrategy.prototype._unregisterLauncherEvents=function(){var e=this.GetLauncher();e.off(t.PopupMessagingStrategy._OPEN_NAMESPACE),e.off(t.PopupMessagingStrategy._CLOSE_NAMESPACE),e[0].removeEventListener("click",this._eatChangeAndClickOnPress,!0),e[0].removeEventListener("change",this._eatChangeAndClickOnPress,!0),t.DomUtils.isTouchSupported()&&(e.ojHammer().off("press"),e.ojHammer("destroy"),e.off("contextmenu",this._eatContextMenuOnOpenPopupListener),this._eatContextMenuOnOpenPopupListener=null,this._inPressEvent=null),this._openPopupCallback=null,this._closePopupCallback=null},t.PopupMessagingStrategy.prototype._registerLauncherEvents=function(){var e,s,n,a,o,r,l,u,p=this.GetLauncher();(a=(n=t.PopupMessagingStrategy._DEFAULTS_BY_COMPONENT[this.GetComponent().widgetName])?n.events:t.PopupMessagingStrategy._DEFAULTS_BY_COMPONENT.default.events).open&&((l=this._openPopupCallback)||(l=this._openPopup.bind(this),this._openPopupCallback=l),u=a.open.indexOf("press"),r=this._getNamespacedEvents(a.open.replace("press",""),t.PopupMessagingStrategy._OPEN_NAMESPACE),p.on(r,l),t.DomUtils.isTouchSupported()&&-1!==u&&(this._eatContextMenuOnOpenPopupListener=function(){return!1},p.on("contextmenu",this._eatContextMenuOnOpenPopupListener),o={recognizers:[[i.Press,{time:750}]]},p.ojHammer(o).on("press",l))),a.close&&((s=this._closePopupCallback)||(s=this._closePopup.bind(this),this._closePopupCallback=s),e=this._getNamespacedEvents(a.close,t.PopupMessagingStrategy._CLOSE_NAMESPACE),p.on(e,s))},t.PopupMessagingStrategy.prototype._getNamespacedEvents=function(t,e){var i,s,n;if(""===t||""===e)return t;n=(i=t.split(" ")).length,s=[];for(var a=0;a<n;a++)i[a]&&s.push(i[a]+e);return s.join(" ")},t.PopupMessagingStrategy.prototype._getPopupPosition=function(){var e,i,s;return(e=(i=t.PopupMessagingStrategy._DEFAULTS_BY_COMPONENT[this.GetComponent().widgetName])?i.position:t.PopupMessagingStrategy._DEFAULTS_BY_COMPONENT.default.position)&&("launcher"===e?s=this.GetLauncher():"launcher-wrapper"===e&&(s=this.GetLauncher().parent())),s||(s=this.GetComponent().widget()),{my:"start bottom",at:"end top",collision:"flipcenter",of:s}},t.PopupMessagingStrategy.prototype._getPopupElement=function(){var e,i;if(this.$messagingContentRoot)return this.$messagingContentRoot;if(e=t.PopupMessagingStrategyPoolUtils.getNextFreePopup(),i=this._getPopupPosition(),e.ojPopup("option","position",i),e.ojPopup("option","beforeClose",this._popupBeforeCloseCallback.bind(this)),e.ojPopup("option","close",this._popupCloseCallback.bind(this)),e.ojPopup("option","open",this._popupOpenCallback.bind(this)),this.GetComponent()._IsCustomElement()){var s=(a.parseJSONFromFontFamily("oj-messaging-popup-option-defaults")||{}).animation;s.actionPrefix="notewindow",e.ojPopup("option","animation",s),this._addAnimateEventListeners(e)}else e.ojPopup("option","animation",null);return this.$messagingContentRoot=e,this.$messagingContentRoot},t.PopupMessagingStrategy.prototype._popupOpenCallback=function(t){var i=e(t.target),s=this;window.setTimeout(function(){o.isComponentInitialized(i,"ojPopup")?i.ojPopup("option","autoDismiss","focusLoss"):delete s.$messagingContentRoot},10)},t.PopupMessagingStrategy.prototype._popupBeforeCloseCallback=function(){this._resolveBusyState=this._setBusyState("close")},t.PopupMessagingStrategy.prototype._popupCloseCallback=function(i){var s=this.GetLauncher(),n=e(i.target);this._removeAnimateEventListeners(n),o.isComponentInitialized(n,"ojPopup")&&(n.ojPopup("option","autoDismiss","none"),n.ojPopup("option","open",null),n.ojPopup("option","close",null),n.ojPopup("option","beforeClose",null)),s&&s[0]&&(s[0].removeEventListener("click",this._eatChangeAndClickOnPress,!0),s[0].removeEventListener("change",this._eatChangeAndClickOnPress,!0)),this.$messagingContentRoot=null,this._inPressEvent=null,t.PopupMessagingStrategyPoolUtils.getPopupContentNode(n).innerHTML="",this._resolveBusyState&&(this._resolveBusyState(),this._resolveBusyState=null)},t.PopupMessagingStrategy.prototype._destroyTooltip=function(){this._closePopup(),t.PopupMessagingStrategyPoolUtils.destroyFreePopup()},t.PopupMessagingStrategy.prototype._buildPopupHtml=function(){var e=!1,i=this.GetComponent().document[0],s=[],n="";return this.ShowMessages()&&s.push(this._buildMessagesHtml(i)),(this.ShowConverterHint()||this.ShowValidatorHint()||this.ShowTitle())&&s.push(this._buildHintsHtml(i)),s.forEach(function(s){s&&(e?n=n.concat(t.PopupMessagingStrategyUtils.getSeparatorHtml(i)):e=!0,n=n.concat(s))}),n},t.PopupMessagingStrategy.prototype._buildMessagesHtml=function(e){var i,s="",n=this.GetMaxSeverity();return this.HasMessages()&&(i=this.GetMessages(),s=t.PopupMessagingStrategyUtils.buildMessagesHtml(e,i,n,!1)),s},t.PopupMessagingStrategy.prototype._buildHintsHtml=function(e){var i,s,n=[],a="";if(this.ShowConverterHint()&&(i=(n=this.GetConverterHint()).length?n[0]:"",a+=t.PopupMessagingStrategyUtils.buildHintHtml(e,t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT_CONVERTER,i,!1,t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT)),this.ShowValidatorHint())for(n=this.GetValidatorHints(),s=0;s<n.length;s++)a+=t.PopupMessagingStrategyUtils.buildHintHtml(e,t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT_VALIDATOR,n[s],!1,t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT);return this.ShowTitle()&&(a+=t.PopupMessagingStrategyUtils.buildHintHtml(e,t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT_TITLE,this.GetTitle(),!0,t.PopupMessagingStrategy._SELECTOR_FORMCONTROL_HINT)),a?"<div class='oj-form-control-hints'>"+a+"</div>":""},t.PopupMessagingStrategy.prototype._isPopupInitialized=function(){return!!this.$messagingContentRoot&&o.isComponentInitialized(this.$messagingContentRoot,"ojPopup")},t.PopupMessagingStrategyUtils={},t.PopupMessagingStrategyUtils.buildHintHtml=function(e,i,s,n,a){var o;if(s){o=e.createElement("div");for(var r=a.split(" "),l=0,u=r.length;l<u;++l)o.classList.add(r[l]);o.classList.add(i),t.PopupMessagingStrategyUtils._appendTextDom(o,t.PopupMessagingStrategyUtils._getTextDom(e,s,n))}return o?o.outerHTML:""},t.PopupMessagingStrategyUtils.getSeverityTranslatedString=function(t){var e;switch(t){case l.SEVERITY_LEVEL.FATAL:e=s.getTranslatedString("oj-message.fatal");break;case l.SEVERITY_LEVEL.ERROR:e=s.getTranslatedString("oj-message.error");break;case l.SEVERITY_LEVEL.WARNING:e=s.getTranslatedString("oj-message.warning");break;case l.SEVERITY_LEVEL.INFO:e=s.getTranslatedString("oj-message.info");break;case l.SEVERITY_LEVEL.CONFIRMATION:e=s.getTranslatedString("oj-message.confirmation")}return e},t.PopupMessagingStrategyUtils.getSeparatorHtml=function(t){var i;return(i=e(t.createElement("hr")))?i.get(0).outerHTML:""},t.PopupMessagingStrategyUtils.buildMessagesHtml=function(e,i,s,n){var a,o,r,u,p,g,d,_,h="",c=[],E={};for(o=0;o<i.length;o++)p=(u=i[o])instanceof l?u:new l(u.summary,u.detail,u.severity),E[g=l.getSeverityLevel(p.severity)]||(E[g]=[]),E[g].push(p);for(o=s;o>=l.SEVERITY_LEVEL.CONFIRMATION;o--)for(c=E[o]||[],r=0;r<c.length;r++)u=c[r],g=l.getSeverityLevel(u.severity),d=t.PopupMessagingStrategyUtils.getSeverityTranslatedString(g),_=u.summary||d,a=u.detail||"",h=h.concat(t.PopupMessagingStrategyUtils.buildMessageHtml(e,_,a,g,n));return h},t.PopupMessagingStrategyUtils.buildMessageHtml=function(e,i,s,n,a){var o,r,l,u,p,g=t.PopupMessagingStrategyUtils.getSeverityTranslatedString(n);if((l=e.createElement("div")).classList.add(t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE),a)for(var d=t.PopupMessagingStrategyUtils._getSeveritySelector(n).split(" "),_=0,h=d.length;_<h;++_)l.classList.add(d[_]);u=e.createElement("span");for(var c=t.PopupMessagingStrategyUtils._getSeverityIconSelector(n).split(" "),E=0,S=c.length;E<S;++E)u.classList.add(c[E]);if(null==g?u.removeAttribute("title"):u.setAttribute("title",g),u.setAttribute("role","img"),l.appendChild(u),(o=e.createElement("span")).classList.add(t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_CONTENT),(p=e.createElement("div")).classList.add(t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_SUMMARY),p.textContent=i,o.appendChild(p),s){var m=t.PopupMessagingStrategyUtils._getTextDom(e,s,!0);(r=e.createElement("div")).classList.add(t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_DETAIL),t.PopupMessagingStrategyUtils._appendTextDom(r,m),o.appendChild(r)}return l.appendChild(o),l.outerHTML},t.PopupMessagingStrategyUtils._getSeverityIconSelector=function(e){var i;switch(e){case l.SEVERITY_LEVEL.FATAL:case l.SEVERITY_LEVEL.ERROR:i=t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_ERROR_ICON;break;case l.SEVERITY_LEVEL.WARNING:i=t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_WARNING_ICON;break;case l.SEVERITY_LEVEL.INFO:i=t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_INFO_ICON;break;case l.SEVERITY_LEVEL.CONFIRMATION:i=t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_CONFIRMATION_ICON}return t.PopupMessagingStrategyUtils._DEFAULT_STATUS_ICON_SELECTORS+i},t.PopupMessagingStrategyUtils._getSeveritySelector=function(e){var i;switch(e){case l.SEVERITY_LEVEL.FATAL:case l.SEVERITY_LEVEL.ERROR:i=t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_ERROR;break;case l.SEVERITY_LEVEL.WARNING:i=t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_WARNING;break;case l.SEVERITY_LEVEL.INFO:i=t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_INFO;break;case l.SEVERITY_LEVEL.CONFIRMATION:default:i=t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_CONFIRMATION}return i},t.PopupMessagingStrategyUtils._getTextDom=function(e,i,s){var n=null;return t.StringUtils.isString(i)&&(s&&t.DomUtils.isHTMLContent(i)?n=t.DomUtils.cleanHtml(i.substring(6,i.length-7)):(n=e.createElement("span")).textContent=i),n},t.PopupMessagingStrategyUtils._appendTextDom=function(e,i){t.StringUtils.isString(i)?e.innerHTML=i:e.appendChild(i)},t.PopupMessagingStrategyUtils._DEFAULT_STATUS_ICON_SELECTORS="oj-component-icon oj-message-status-icon ",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE="oj-message",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_SUMMARY="oj-message-summary",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_DETAIL="oj-message-detail",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_CONTENT="oj-message-content",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_ERROR_ICON="oj-message-error-icon",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_WARNING_ICON="oj-message-warning-icon",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_INFO_ICON="oj-message-info-icon",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_CONFIRMATION_ICON="oj-message-confirmation-icon",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_ERROR="oj-message-error",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_WARNING="oj-message-warning",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_INFO="oj-message-info",t.PopupMessagingStrategyUtils._SELECTOR_MESSAGE_CONFIRMATION="oj-message-confirmation",t.PopupMessagingStrategyPoolUtils={},t.PopupMessagingStrategyPoolUtils.getNextFreePopup=function(){var i,s=t.PopupMessagingStrategyPoolUtils._getPool(),n=s.find("."+t.PopupMessagingStrategyPoolUtils._SELECTOR_MESSAGING);if(0===n.length){(i=e(t.PopupMessagingStrategyPoolUtils._getPopupContentHtml()))[0].style.display="none",i.appendTo(s);i.ojPopup({initialFocus:"none",tail:"simple",autoDismiss:"none",modality:"modeless",animation:{open:null,close:null}})}else i=e(n[0]);return i},t.PopupMessagingStrategyPoolUtils.getPopupContentNode=function(e){return e.find("."+t.PopupMessagingStrategyPoolUtils._SELECTOR_MESSAGING_CONTAINER)[0]},t.PopupMessagingStrategyPoolUtils.destroyFreePopup=function(){var e;if(t.PopupMessagingStrategyPoolUtils._getFreePoolCount()>0){var i=(e=t.PopupMessagingStrategyPoolUtils.getNextFreePopup())[0];e.ojPopup("destroy"),i.parentNode.removeChild(i)}},t.PopupMessagingStrategyPoolUtils._getPool=function(){var i=e("#"+t.PopupMessagingStrategyPoolUtils._MESSAGING_POPUP_POOL_ID);if(i.length>0)return i;var s=(i=e("<div>"))[0];return s.setAttribute("id",t.PopupMessagingStrategyPoolUtils._MESSAGING_POPUP_POOL_ID),s.setAttribute("role","presentation"),document.body.appendChild(s),i},t.PopupMessagingStrategyPoolUtils._getFreePoolCount=function(){return t.PopupMessagingStrategyPoolUtils._getPool().find("."+t.PopupMessagingStrategyPoolUtils._SELECTOR_MESSAGING).length},t.PopupMessagingStrategyPoolUtils._getPopupContentHtml=function(){return'<div class="'+t.PopupMessagingStrategyPoolUtils._SELECTOR_MESSAGING+'"><div class="'+t.PopupMessagingStrategyPoolUtils._SELECTOR_MESSAGING_CONTAINER+'"></div></div>'},t.PopupMessagingStrategyPoolUtils._SELECTOR_MESSAGING_CONTAINER="oj-messaging-popup-container",t.PopupMessagingStrategyPoolUtils._SELECTOR_MESSAGING="oj-messaging-popup",t.PopupMessagingStrategyPoolUtils._MESSAGING_POPUP_POOL_ID="__oj_messaging_popup_pool"});