/**
 * @license
 * Copyright (c) 2014, 2019, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
define(["ojs/ojcore","jquery","ojs/ojlogger","ojs/ojdatasource-common"],function(e,t,r){e.JsonNodeSet=function(t,r,n,i,o){e.Assert.assertNumber(t,null),e.Assert.assertNumber(r,null),this.m_depth=o,this.m_key=i,this.m_startNode=t,this.m_endNode=r,this.m_nodes=n},e.JsonNodeSet.prototype.getParent=function(){return this.m_key},e.JsonNodeSet.prototype.getStart=function(){return this.m_startNode},e.JsonNodeSet.prototype.getCount=function(){return Math.max(0,this.m_endNode-this.m_startNode)},e.JsonNodeSet.prototype.getData=function(t){e.Assert.assert(t<=this.m_endNode&&t>=this.m_startNode);var r=t-this.m_startNode;return this.m_nodes[r]?this.m_nodes[r].attr:null},e.JsonNodeSet.prototype.getMetadata=function(t){var r={leaf:!1,depth:-1};e.Assert.assert(t<=this.m_endNode&&t>=this.m_startNode);var n=t-this.m_startNode;return r.key=this.m_nodes[n].id?this.m_nodes[n].id:this.m_nodes[n].attr.id,r.leaf=this.m_nodes[n].leaf,r.depth=this.m_nodes[n].depth,null==r.leaf&&(this.m_nodes[n].children&&this.m_nodes[n].children.length>0?r.leaf=!1:r.leaf=!0),r},e.JsonNodeSet.prototype._updateDepth=function(e,t){var r;if(t+=1,e.depth=t,e.children&&0!==e.children.length)for(r=0;r<e.children.length;r++)this._updateDepth(e.children[r],t)},e.JsonNodeSet.prototype.getChildNodeSet=function(t){e.Assert.assert(t<=this.m_endNode&&t>=this.m_startNode);var r=t-this.m_startNode,n=this.m_nodes[r].depth,i=this.m_nodes[r].children;if(null==i||0===i.length)return null;for(var o=this.m_nodes[r].id?this.m_nodes[r].id:this.m_nodes[r].attr.id,a=0;a<i.length;a++)this._updateDepth(i[a],n);return new e.JsonNodeSet(0,i.length,i,o,0)},e._JsonTreeNodeDataSource=function(){this.id=null,this.depth=0,this.parent=null,this.children=null,this.title=null,this.attr=null,this.leaf=null},e._JsonTreeNodeDataSource.prototype._ascending=function(e){return function(t,r){return null!=t.attr&&null!=r.attr&&null!=t.attr[e]&&null!=r.attr[e]?t.attr[e]<r.attr[e]?-1:t.attr[e]===r.attr[e]?0:1:t[e]<r[e]?-1:t[e]===r[e]?0:1}},e._JsonTreeNodeDataSource.prototype._descending=function(e){return function(t,r){return null!=t.attr&&null!=r.attr&&null!=t.attr[e]&&null!=r.attr[e]?t.attr[e]<r.attr[e]?1:t.attr[e]===r.attr[e]?0:-1:t[e]<r[e]?1:t[e]===r[e]?0:-1}},e._JsonTreeNodeDataSource.prototype._sortRecursive=function(e){var t=e.key;if(null==this.children)return this;"ascending"===e.direction?this.children.sort(this._ascending(t)):"descending"===e.direction&&this.children.sort(this._descending(t));for(var r=0,n=this.children.length;r<n;r++)this.children[r]._sortRecursive(e);return this},e.JsonTreeDataSource=function(t){var r=new e._JsonTreeNodeDataSource;null==t.id&&(r.id="root"),this.data=this._createTreeDataSource({count:0},r,t,0),e.JsonTreeDataSource.superclass.constructor.call(this,r)},e.Object.createSubclass(e.JsonTreeDataSource,e.TreeDataSource,"oj.JsonTreeDataSource"),e.JsonTreeDataSource.prototype.Init=function(){e.JsonTreeDataSource.superclass.Init.call(this)},e.JsonTreeDataSource.prototype._createTreeDataSource=function(t,r,n,i){for(var o in n)if("children"===o||0===i&&n instanceof Array){var a;a=0===i&&n instanceof Array?n:n[o],r.children=[],i+=1;for(var l=0;l<a.length;l++){var s,d=a[l],h=new e._JsonTreeNodeDataSource;for(var c in null==d.id&&(t.count+=1,null==d.attr?h.id="rid_"+t.count:null==d.attr.id&&(d.attr.id="rid_"+t.count)),d)for(s in h)c===s&&"children"!==c&&(h[s]=d[c]),"depth"===s&&(h[s]=i);for(s in r.children.push(h),d)"children"===s&&this._createTreeDataSource(t,r.children[l],d,i)}}return r},e.JsonTreeDataSource.prototype.getChildCount=function(e){var t;return null==e&&(e=this.data.id),(t=this._searchTreeById(this.data,e)).children?t.children.length:0},e.JsonTreeDataSource.prototype.fetchChildren=function(t,r,n,i){var o,a,l=[];null==t&&(t=this.data.id);var s=this._searchTreeById(this.data,t),d=null!=s.children?s.children.length:0;r||((r=[]).start=0,r.count=d),r.count||(r.count=d),r.start||(r.start=0),o=r.start,a=Math.min(d,o+r.count);for(var h=o;h<a;h+=1){var c=new e._JsonTreeNodeDataSource;null!=s.children[h].attr&&(c.attr=s.children[h].attr),null!=s.children[h].id&&(c.id=s.children[h].id),null!=s.children[h].depth&&(c.depth=s.children[h].depth),null!=s.children[h].title&&(c.title=s.children[h].title),null!=s.children[h].parent&&(c.parent=s.children[h].parent),null!=s.children[h].children?c.leaf=!1:c.leaf=!0,l.push(c)}var u=new e.JsonNodeSet(o,a,l,t,s.depth);null!=n&&null!=n.success&&n.success.call(null,u)},e.JsonTreeDataSource.prototype.fetchDescendants=function(t,r,n){var i,o,a=[];null==t&&(t=this.data.id);var l=this._searchTreeById(this.data,t),s=null!=l.children?l.children.length:0,d=[];d.start=0,d.count=s,i=d.start,o=Math.min(s,i+d.count);for(var h=i;h<o;h+=1)null!=l.children[h].children?l.children[h].leaf=!1:l.children[h].leaf=!0,a.push(l.children[h]);var c=new e.JsonNodeSet(0,a.length,a,t,l.depth);null!=r&&null!=r.success&&r.success.call(null,c)},e.JsonTreeDataSource.prototype.moveOK=function(e,t,r){return"valid"},e.JsonTreeDataSource.prototype.move=function(e,t,n,i){var o=n,a=e,l=t;if(null==l||l===this.data.id){if("inside"!==o)return void r.log("Error: root can not be the reference node if position equals to "+o);l||(l=this.data.id)}var s=this._searchTreeById(null,a);if(this._searchTreeById(s,l))r.log("Error: the node to move contains the reference node as its sub-tree.");else{var d,h=this._searchTreeById(null,l),c=this._getParentById(l);this._removeFromTree(s),"inside"===o?(this._updateDepth(s,s.depth-(h.depth+1)),null==h.children&&(h.children=[]),h.children.push(s)):"before"===o?(this._updateDepth(s,s.depth-h.depth),(d=c.children.indexOf(h))>-1&&(0!==d?c.children.splice(d,0,s):c.children.unshift(s))):"after"===o?(this._updateDepth(s,s.depth-h.depth),(d=c.children.indexOf(h))>-1&&c.children.splice(d+1,0,s)):"first"===o?(this._updateDepth(s,s.depth-h.depth),c.children.unshift(s)):"last"===o&&(this._updateDepth(s,s.depth-h.depth),c.children.push(s)),null!=i&&null!=i.success&&i.success.call(null,this.data)}},e.JsonTreeDataSource.prototype.sort=function(e,t){var r=this.data.id,n=this._searchTreeById(this.data,r);n._sortRecursive(e),null!=t&&null!=t.success&&t.success.call(null,n)},e.JsonTreeDataSource.prototype.getSortCriteria=function(){return{key:null,direction:"none"}},e.JsonTreeDataSource.prototype._getParentById=function(e,t){var r,n=null,i=!1;if(e===this.data.id)return null;if(null==t&&(t=this.data),t.children&&t.children.length>0){for(r=0;r<t.children.length;r++)if(t.children[r].id&&t.children[r].id===e||t.children[r].attr&&t.children[r].attr.id===e)return i=!0,t;if(!i)for(r=0;r<t.children.length;r++)if(n=this._getParentById(e,t.children[r]))return i=!0,n}return n},e.JsonTreeDataSource.prototype._searchTreeById=function(e,t){var r=null;if(null==e&&(e=this.data),e.id&&e.id===t||e.attr&&e.attr.id===t)return e;if(null!=e.children){for(var n=0;n<e.children.length;n++){if(r)return r;r=e.children[n].id&&e.children[n].id===t||e.children[n].attr&&e.children[n].attr.id===t?e.children[n]:this._searchTreeById(e.children[n],t)}return r}return r},e.JsonTreeDataSource.prototype._updateDepth=function(e,t){if(e.depth-=t,e.children&&0!==e.children.length)for(var r=0;r<e.children.length;r++)this._updateDepth(e.children[r],t)},e.JsonTreeDataSource.prototype._removeFromTree=function(e){var t;null!=e.id?t=e.id:null!=e.attr&&(t=e.attr.id);var r=this._getParentById(t);r||(r=this.data);var n=r.children.indexOf(e);n>-1&&r.children.splice(n,1)},e.JsonTreeDataSource.prototype.getCapability=function(e){return"fetchDescendants"===e?"enable":"sort"===e?"default":"batchFetch"===e?"disable":"move"===e?"full":null}});