/**
 * @license
 * Copyright (c) 2014, 2019, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
define(["ojs/ojcore","jquery","ojs/ojcontext","ojs/ojconfig","ojs/ojtranslation","ojs/ojthemeutils","ojs/ojcomponentcore","ojs/ojanimation","ojs/ojmessaging","ojs/ojlogger","promise","ojdnd","ojs/ojdomscroller","ojs/ojeditablevalue","ojs/ojinputnumber","ojs/ojmenu","ojs/ojpopup","ojs/ojbutton","ojs/ojdatasource-common","ojs/ojdataprovideradapter","ojs/ojlistdataproviderview","touchr"],function(e,t,l,o,i,s,n,a,r,_){var h={properties:{accessibility:{type:"object",properties:{rowHeader:{type:"string"}}},as:{type:"string",value:""},columns:{type:"Array<Object>",writeback:!0},columnsDefault:{type:"object",properties:{className:{type:"string"},field:{type:"string"},footerClassName:{type:"string"},footerRenderer:{type:"function"},footerStyle:{type:"string"},footerTemplate:{type:"string"},headerClassName:{type:"string"},headerRenderer:{type:"function"},headerStyle:{type:"string"},headerTemplate:{type:"string"},headerText:{type:"string"},renderer:{type:"function"},resizable:{type:"string",enumValues:["disabled","enabled"],value:"disabled"},sortProperty:{type:"string"},sortable:{type:"string",enumValues:["auto","disabled","enabled"],value:"auto"},style:{type:"string"},template:{type:"string"},width:{type:"number"}}},currentRow:{type:"object",writeback:!0},data:{type:"oj.DataProvider|oj.TableDataSource"},display:{type:"string",enumValues:["grid","list"],value:"list"},dnd:{type:"object",properties:{drag:{type:"object",properties:{rows:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},dragStart:{type:"function"},drag:{type:"function"},dragEnd:{type:"function"}}}}},drop:{type:"object",properties:{columns:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},dragEnter:{type:"function"},dragOver:{type:"function"},dragLeave:{type:"function"},drop:{type:"function"}}},rows:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},dragEnter:{type:"function"},dragOver:{type:"function"},dragLeave:{type:"function"},drop:{type:"function"}}}}},reorder:{type:"object",properties:{columns:{type:"string",enumValues:["disabled","enabled"],value:"disabled"}}}}},editMode:{type:"string",enumValues:["none","rowEdit"],value:"none"},firstSelectedRow:{type:"object",writeback:!0,readOnly:!0,value:{key:null,data:null}},horizontalGridVisible:{type:"string",enumValues:["auto","disabled","enabled"],value:"auto"},rowRenderer:{type:"function"},scrollPolicy:{type:"string",enumValues:["auto","loadMoreOnScroll"],value:"auto"},scrollPolicyOptions:{type:"object",properties:{fetchSize:{type:"number",value:25},maxCount:{type:"number",value:500}}},scrollPosition:{type:"object",writeback:!0,value:{x:0,y:0},properties:{x:{type:"number"},y:{type:"number"},columnIndex:{type:"number"},rowIndex:{type:"number"},columnKey:{type:"any"},rowKey:{type:"any"},offsetX:{type:"number"},offsetY:{type:"number"}}},selection:{type:"Array<Object>",writeback:!0,value:[]},selectionMode:{type:"Object<string, string>",properties:{column:{type:"string",enumValues:["multiple","single"]},row:{type:"string",enumValues:["multiple","single"]}}},selectionRequired:{type:"boolean",value:!1},translations:{type:"object",value:{},properties:{labelAccSelectionAffordanceBottom:{type:"string"},labelAccSelectionAffordanceTop:{type:"string"},labelDisableNonContiguousSelection:{type:"string"},labelEditRow:{type:"string"},labelEnableNonContiguousSelection:{type:"string"},labelResize:{type:"string"},labelResizePopupSpinner:{type:"string"},labelResizePopupSubmit:{type:"string"},labelSelectAndEditRow:{type:"string"},labelSelectColum:{type:"string"},labelSelectRow:{type:"string"},labelSort:{type:"string"},labelSortAsc:{type:"string"},labelSortDsc:{type:"string"},msgColumnResizeWidthValidation:{type:"string"},msgFetchingData:{type:"string"},msgInitializing:{type:"string"},msgNoData:{type:"string"},msgScrollPolicyMaxCountDetail:{type:"string"},msgScrollPolicyMaxCountSummary:{type:"string"},msgStatusSortAscending:{type:"string"},msgStatusSortDescending:{type:"string"}}},verticalGridVisible:{type:"string",enumValues:["auto","disabled","enabled"],value:"auto"}},methods:{getContextByNode:{},getDataForVisibleRow:{},refresh:{},refreshRow:{},setProperty:{},getProperty:{},setProperties:{},getNodeBySubId:{},getSubIdByNode:{}},events:{ojAnimateStart:{},ojAnimateEnd:{},ojBeforeCurrentRow:{},ojBeforeRowEdit:{},ojBeforeRowEditEnd:{},ojSort:{}},extension:{}};e.__registerWidget("oj.ojTable",t.oj.baseComponent,{version:"1.0.0",defaultElement:"<table>",widgetEventPrefix:"oj",options:{accessibility:null,animateStart:null,animateEnd:null,as:"",currentRow:null,data:null,display:"list",dnd:{drag:null,drop:null,reorder:{columns:"disabled"}},editMode:"none",emptyText:null,horizontalGridVisible:"auto",rowRenderer:null,scrollPolicy:"auto",scrollPolicyOptions:{fetchSize:25,maxCount:500},scrollPosition:{x:0,y:0},firstSelectedRow:{key:null,data:null},selection:[],selectionMode:null,selectionRequired:!1,verticalGridVisible:"auto",columns:[{renderer:null,className:null,field:null,footerClassName:null,footerRenderer:null,footerStyle:null,footerTemplate:null,headerClassName:null,headerRenderer:null,headerStyle:null,headerTemplate:null,headerText:null,id:null,resizable:"disabled",sortable:"auto",sortProperty:null,style:null,template:null,width:null}],columnsDefault:{renderer:null,className:null,field:null,footerClassName:null,footerRenderer:null,footerStyle:null,footerTemplate:null,headerClassName:null,headerRenderer:null,headerStyle:null,headerTemplate:null,headerText:null,resizable:"disabled",sortable:"auto",sortProperty:null,style:null,template:null,width:null},beforeCurrentRow:null,beforeRowEdit:null,beforeRowEditEnd:null,ready:null,sort:null},_BUNDLE_KEY:{_MSG_FETCHING_DATA:"msgFetchingData",_MSG_NO_DATA:"msgNoData",_MSG_INITIALIZING:"msgInitializing",_MSG_STATUS_SORT_ASC:"msgStatusSortAscending",_MSG_STATUS_SORT_DSC:"msgStatusSortDescending",_LABEL_SELECT_COLUMN:"labelSelectColumn",_LABEL_SELECT_ROW:"labelSelectRow",_LABEL_EDIT_ROW:"labelEditRow",_LABEL_SELECT_AND_EDIT_ROW:"labelSelectAndEditRow"},_LOGGER_MSG:{_ERR_PRECURRENTROW_ERROR_SUMMARY:"Did not change current row due to error.",_ERR_PRECURRENTROW_ERROR_DETAIL:"Error detail: {error}.",_ERR_CURRENTROW_UNAVAILABLE_INDEX_SUMMARY:"Did not change current row due to unavailable row index.",_ERR_CURRENTROW_UNAVAILABLE_INDEX_DETAIL:"Unavailable row index: {rowIdx}.",_ERR_REFRESHROW_INVALID_INDEX_SUMMARY:"Invalid row index value.",_ERR_REFRESHROW_INVALID_INDEX_DETAIL:"Row index: {rowIdx}.",_ERR_DATA_INVALID_TYPE_SUMMARY:"Invalid data type.",_ERR_DATA_INVALID_TYPE_DETAIL:"Please specify the appropriate data type.",_ERR_ELEMENT_INVALID_TYPE_SUMMARY:"Invalid element type.",_ERR_ELEMENT_INVALID_TYPE_DETAIL:"Only a <table> element can be specified for ojTable.",_ERR_WIDTH_INVALID_TYPE_SUMMARY:"Invalid data type for column width.",_ERR_WIDTH_INVALID_TYPE_DETAIL:"Please specify a valid number (not a string)."},_FIELD_ID:"id",_CONST_ATTRIBUTE:"attribute",_CONST_DATA:"data",_CONST_METADATA:"metadata",_CONST_INDEXES:"indexes",_CONST_INDEX:"index",_CONST_KEY:"key",_CONST_KEYS:"keys",_CONST_AFTERKEYS:"afterKeys",_CONST_ADDBEFOREKEYS:"addBeforeKeys",_CONST_STARTINDEX:"startIndex",_CONST_ENDINDEX:"endIndex",_CONST_PAGESIZE:"size",_CONST_OFFSET:"offset",_CONST_COLUMN:"column",_CONST_ROW:"row",_CONST_VALUE:"value",_CONST_SORTCRITERIA:"sortCriteria",_COLUMN_HEADER_ID:"_headerColumn",_COLUMN_HEADER_TEXT_ID:"_headerColumnText",_COLUMN_HEADER_ASC_ID:"_headerColumnAsc",_COLUMN_HEADER_DSC_ID:"_headerColumnDsc",_COLUMN_HEADER_ID_PREFIX:"_hdrCol",_FOCUS_CALLED:"_focusedCalled",_ROW_TEMPLATE:"rowTemplate",_CELL_TEMPLATE:"template",_HEADER_TEMPLATE:"headerTemplate",_FOOTER_TEMPLATE:"footerTemplate",_OPTION_AUTO:"auto",_OPTION_ENABLED:"enabled",_OPTION_DISABLED:"disabled",_OPTION_EDIT_MODE:{_NONE:"none",_ROW_EDIT:"rowEdit"},_OPTION_SELECTION_MODES:{_SINGLE:"single",_MULTIPLE:"multiple"},_OPTION_SCROLL_POLICY:{_AUTO:"auto",_LOADMORE_ON_SCROLL:"loadMoreOnScroll"},_COLUMN_SORT_ORDER:{_ASCENDING:"ascending",_DESCENDING:"descending"},_DND_REORDER_TABLE_ID_DATA_KEY:"oj-table-dnd-reorder-table-id",_KEYBOARD_CODES:{_KEYBOARD_CODE_SPACEBAR:32,_KEYBOARD_CODE_ENTER:13,_KEYBOARD_CODE_UP:38,_KEYBOARD_CODE_DOWN:40,_KEYBOARD_CODE_LEFT:37,_KEYBOARD_CODE_RIGHT:39,_KEYBOARD_CODE_HOME:36,_KEYBOARD_CODE_END:35,_KEYBOARD_CODE_TAB:9,_KEYBOARD_CODE_ESC:27,_KEYBOARD_CODE_F2:113,_KEYBOARD_MODIFIER_SHIFT:"shiftKey"},getContextByNode:function(e){var t=this.getSubIdByNode(e,!0);if(t&&"oj-table-cell"===t.subId){var l=t.rowIndex,o=this._getRowKeyForRowIdx(l);t.key=o}return t},getDataForVisibleRow:function(e){var l=this._getTableDomUtils().getTableBodyRow(e);return null!=l?{key:t(l).data("rowKey"),data:t(l).data("rowData"),index:e}:null},getNodeBySubId:function(t){if(null==t)return this.element?this.element[0]:null;var l,o=t.subId;if("oj-table-cell"===o){var i=parseInt(t.rowIndex,10);return l=parseInt(t.columnIndex,10),this._getTableDomUtils().getTableBodyLogicalCells(i)[l]}if("oj-table-header"===o||"oj-table-sort-ascending"===o||"oj-table-sort-descending"===o){l=t.index;var s=this._getTableDomUtils().getTableHeaderLogicalColumns()[l];if(null!=s){if("oj-table-header"===o)return s;if("oj-table-sort-ascending"===o){var n=s.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_LINK_CLASS);if(n.length>0)return n[0]}else{var a=s.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_LINK_CLASS);if(a.length>0)return a[0]}}}else if("oj-table-footer"===o){l=t.index;var r=this._getTableDomUtils().getTableFooterLogicalCells()[l];if(null!=r)return r}return null},getSubIdByNode:function(l,o){var i=t(l).closest("."+e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_CLASS);if(i.length>0)return{subId:"oj-table-cell",rowIndex:this._getTableDomUtils().getElementRowIdx(i[0]),columnIndex:this._getTableDomUtils().getElementColumnIdx(i[0])};var s=t(l).closest("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_LINK_CLASS);if(s.length>0)return{subId:o?"oj-table-header":"oj-table-sort-ascending",index:this._getTableDomUtils().getElementColumnIdx(s[0])};var n=t(l).closest("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_LINK_CLASS);if(n.length>0)return{subId:o?"oj-table-header":"oj-table-sort-descending",index:this._getTableDomUtils().getElementColumnIdx(n[0])};var a=t(l).closest("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CELL_CLASS);if(a.length>0)return{subId:"oj-table-header",index:this._getTableDomUtils().getElementColumnIdx(a[0])};var r=t(l).closest("."+e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CELL_CLASS);return r.length>0?{subId:"oj-table-footer",index:this._getTableDomUtils().getElementColumnIdx(r[0])}:null},refresh:function(){this._super(),this._refresh()},refreshRow:function(e){return this._refreshRow(e,!0)},_refreshRow:function(e,l){var o=this._getData();if(!o)return Promise.resolve(!1);var s=this._getTableDomUtils().getTableBodyRows();if(isNaN(e)||e<0||null!=s&&e>=s.length||null==s||0===s.length){var n=this._LOGGER_MSG._ERR_REFRESHROW_INVALID_INDEX_SUMMARY,a=i.applyParameters(this._LOGGER_MSG._ERR_REFRESHROW_INVALID_INDEX_DETAIL,{rowIdx:e.toString()});throw new RangeError(n+"\n"+a)}var r=this._getRowKeyForRowIdx(e),_=this;return _._queueTask(function(){return o.fetchByKeys({keys:[r]}).then(function(o){if(null==o||null==o.results||0===o.results.size)return Promise.resolve(!1);var i=_._getTableDomUtils().getTableBodyRow(e);return l=l&&t.contains(i,document.activeElement),_._refreshTableBodyRow(e,{data:o.results.get(r).data,index:e,key:r}),l&&_._getTableDomUtils().getTable().focus(),i=_._getTableDomUtils().getTableBodyRow(e),_._waitForAllComponentsToResolve(i)})})},widget:function(){var e=this._getTableDomUtils().getTableContainer();return null!=e?t(e):this.element},_ComponentCreate:function(){if(this._super(),this._initTemplateEngine(),this._draw(),this._registerCustomEvents(),this._on(this._events),this._isTouchDevice()){var e=this._getTableDomUtils().getTableContainer();this._on(t(e),this._eventsContainer)}this._registerDomEventListeners(),this._cachedOptions=t.extend(!0,{},this.options),this._setEditableRowIdx(null)},_AfterCreate:function(){this._super(),this._getTableDomUtils().createContextMenu(this._handleContextMenuSelect.bind(this)),this._isInitFetch=!0},_SetupResources:function(){this._super(),this._registerResizeListener(),this._registerDataSourceEventListeners(),this._isInitFetch?(this._initFetch(),this._isInitFetch=!1):this._invokeDataFetchRows(null,!1)},_ReleaseResources:function(){this._super(),this._unregisterDataSourceEventListeners(),this._unregisterResizeListener()},_NotifyAttached:function(){this._super(),this._getTableDomUtils().refreshTableDimensions()},_NotifyShown:function(){this._super(),this._getTableDomUtils().refreshTableDimensions()},_VerifyConnectedForSetup:function(){return!0},_GetDefaultContextMenu:function(){return this._defaultContextMenu},_NotifyContextMenuGesture:function(e,t,l){var o={};if(this._contextMenuEvent=t.originalEvent,!(this._isNodeEditable(this._contextMenuEvent.target)||this._isNodeClickable(this._contextMenuEvent.target)||"touch"===l&&this._isNodeDraggable(this._contextMenuEvent.target))){var i=this._getTableDomUtils().getFirstAncestor(this._contextMenuEvent.target,"oj-table-column-header-cell");i=null==i?this._getTableDomUtils().getTableHeaderColumn(this._activeColumnIndex):i,this._contextMenuEventHeaderColumn=i;var s=this._getTableDomUtils().getFirstAncestor(this._contextMenuEvent.target,"oj-table-data-cell");if(null!=s){var n=this._getTableDomUtils().getElementColumnIdx(s);i=this._getTableDomUtils().getTableHeaderColumn(n)}if("keydown"===this._contextMenuEvent.type){var a=this._tableDomUtils.getTable();if(this._contextMenuEvent.target===a)if(null!=i)o.position={my:"start top",at:"start bottom",of:i};else{var r=this._getFocusedRowIdx();if(r>=0){var _=this._getTableDomUtils().getTableBodyRow(r);o.position={my:"start top",at:"start bottom",of:_}}else o.position={my:"start top",at:"start bottom",of:this._contextMenuEvent.target}}else o.position={my:"start top",at:"start bottom",of:this._contextMenuEvent.target}}var h,u,d,S=e.element?e.element[0]:e;i&&i.getAttribute("data-oj-sortable")===this._OPTION_ENABLED?((h=S.querySelectorAll("[data-oj-command=oj-table-sortAsc]")).length>0&&(h=h[0]).classList.remove("oj-disabled"),(u=S.querySelectorAll("[data-oj-command=oj-table-sortDsc]")).length>0&&(u=u[0]).classList.remove("oj-disabled")):((h=S.querySelectorAll("[data-oj-command=oj-table-sortAsc]")).length>0&&(h=h[0]).classList.add("oj-disabled"),(u=S.querySelectorAll("[data-oj-command=oj-table-sortDsc]")).length>0&&(u=u[0]).classList.remove("oj-disabled")),i&&i.getAttribute("data-oj-resizable")===this._OPTION_ENABLED?(d=S.querySelectorAll("[data-oj-command=oj-table-resize]")).length>0&&(d=d[0]).classList.remove("oj-disabled"):(d=S.querySelectorAll("[data-oj-command=oj-table-resize]")).length>0&&(d=d[0]).classList.add("oj-disabled"),this._OpenContextMenu(t,l,o)}},_destroy:function(){t(this._getTableDomUtils().getTableBody()).removeAttr(n._OJ_CONTAINER_ATTR),this.element.children().remove("."+e.TableDomUtils.CSS_CLASSES._TABLE_HEADER_CLASS),this.element.children().remove("."+e.TableDomUtils.CSS_CLASSES._TABLE_BODY_CLASS),this.element.children().remove("."+e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CLASS),this.element.children().remove("."+e.TableDomUtils.CSS_CLASSES._TABLE_STATUS_MESSAGE_CLASS),this.element.children().remove("."+e.TableDomUtils.CSS_CLASSES._TABLE_BODY_MESSAGE_ROW_CLASS),e.DomUtils.unwrap(this.element,t(this._getTableDomUtils().getTableContainer())),this.element[0].classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_CLASS),this._readyResolveFunc&&(this._readyResolveFunc(),this._readyResolveFunc=null),this._dataResolveFunc&&(this._dataResolveFunc(),this._dataResolveFunc=null),this._scrollPosResolveFunc&&(this._scrollPosResolveFunc(),this._scrollPosResolveFunc=null),this._focusoutResolveFunc&&(this._focusoutResolveFunc(),this._focusoutResolveFunc=null),this._data instanceof e.TableDataSourceAdapter&&this._data.destroy(),(this._hasHeaderTemplate||this._hasCellTemplate||this._hasFooterTemplate)&&this._cleanTemplateNodes(this.element[0]),this._componentDestroyed=!0},_draw:function(){if(this._setFinalTask(function(){if(this._getTableDomUtils().refreshTableDimensions(),this._setSelection(this.options.selection),this._setSelectionDefault(),this._hasEditableRow()){var t=this._getEditableRowIdx(),l=this._getTableDomUtils().getTableBodyRow(t);null!=l&&l.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_EDIT_CLASS)}this._isLoadMoreOnScroll()&&!this._dataFetching&&this._domScroller?this._domScroller.checkViewport().then(this._domScrollerSuccessFunc,null):this._syncScrollPosition()}),!this.element.is("table")){var t=this._LOGGER_MSG._ERR_ELEMENT_INVALID_TYPE_SUMMARY,l=this._LOGGER_MSG._ERR_ELEMENT_INVALID_TYPE_DETAIL;throw new RangeError(t+"\n"+l)}this.element[0].classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_ELEMENT_CLASS),this._getTableDomUtils().createInitialTable(this._isTableHeaderless(),this._isTableFooterless()),this._getTableDomUtils().styleInitialTable();var o=this;this._queueTask(function(){o._refreshTableHeader(),o._refreshTableFooter(),o._refreshTableBody(),o._processSlottedChildren()}),this.options.disabled&&this.disable()},_events:{focusout:function(l){var o=this;this._focusoutTimeout&&clearTimeout(this._focusoutTimeout),this._focusoutResolveFunc||(this._focusoutResolveFunc=this._addComponentBusyState("handling focusout")),this._focusoutTimeout=setTimeout(function(){for(var i=o._getTableDomUtils().getTable(),s=e.ZOrderUtils.findOpenPopups(),n=0;n<s.length;n++){var a=e.DomUtils.getLogicalParent(t(s[n]).children());if(t(i).has(a.get(0)).length>0)return void(o._focusoutResolveFunc&&(o._focusoutResolveFunc(),o._focusoutResolveFunc=null))}o._focusOutHandler(t(i)),o._focusOutHandler(t(o._getTableDomUtils().getTableContainer())),o._clearKeyboardKeys(),o._clearFocusedHeaderColumn(),o._clearFocusedRow(!1),o._getTableResizeUtils().clearTableHeaderColumnsResize(),o._setTableEditable(!1,!1,0,!0,l),o._setTableActionableMode(!1),o._focusoutResolveFunc&&(o._focusoutResolveFunc(),o._focusoutResolveFunc=null)},100)},"blur .oj-table-data-cell":function(t){var l=this._getEventTargetElement(t);l.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_EDIT_CLASS)&&l.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_EDIT_CLASS)},focus:function(e){this._checkRowOrHeaderColumnFocus(e)},focusin:function(e){this._focusoutTimeout&&(clearTimeout(this._focusoutTimeout),this._focusoutTimeout=null),this._focusoutResolveFunc&&(this._focusoutResolveFunc(),this._focusoutResolveFunc=null),this._focusInHandler(t(this._getTableDomUtils().getTable())),this._focusInHandler(t(this._getTableDomUtils().getTableContainer()));var l=this._getTableDomUtils().getTableBody();if(t(l).has(e.target).length>0){var o=this._getFocusedRowIdx(),i=this._getFocusedHeaderColumnIdx();if(!(this._isNodeEditable(e.target)||this._isNodeClickable(e.target)||this._isTableActionableMode()||this._hasEditableRow()||this._temporaryTableChildElementFocus||null!=o||null!=i)){var s=this;setTimeout(function(){s._getTableDomUtils().getTable().focus()},0)}}},"focus .oj-table-column-header-acc-asc-link":function(e){var t=this;setTimeout(function(){t._checkRowOrHeaderColumnFocus(e),t=null},0)},"focus .oj-table-data-cell":function(t){var l=this._getEventTargetElement(t);this._getTableDomUtils().getElementRowIdx(l)===this._getEditableRowIdx()&&l.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_EDIT_CLASS)},"click .oj-table-checkbox-acc-select-column":function(e){var l=this._getEventTargetElement(e),o=this._getTableDomUtils().getElementColumnIdx(l),i=t(l).is(":checked");i&&this._setHeaderColumnFocus(o,!0,!0,null,null),this._setHeaderColumnSelection(o,i,l,e,!0),e.stopPropagation()},"click .oj-table-checkbox-acc-select-row":function(e){var l=this._getEventTargetElement(e),o=this._getTableDomUtils().getElementRowIdx(l),i=t(l).is(":checked"),s=!1;i?s=this._setRowFocus(o,!0,!0,null,e,!0):this._setTableEditable(!1,!1,0,!0,e),s&&(this._setRowSelection(o,i,l,e,!0),this._setTableEditable(!0,!1,0,!0,e)),e.stopPropagation()},keydown:function(e){this._addKeyboardKey(e.keyCode);var l=this._getKeyboardKeys()[0];l!==this._KEYBOARD_CODES._KEYBOARD_CODE_ESC&&l!==this._KEYBOARD_CODES._KEYBOARD_CODE_ENTER&&l!==this._KEYBOARD_CODES._KEYBOARD_CODE_F2&&l!==this._KEYBOARD_CODES._KEYBOARD_CODE_TAB&&(this._isNodeEditable(e.target)||null!=this._getTableDomUtils().getTableFooter()&&t(this._getTableDomUtils().getTableFooter()).has(e.target).length>0)||(1===this._getKeyboardKeys().length||2===this._getKeyboardKeys().length&&e[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT])&&((this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_UP)||this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_DOWN)||this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_SPACEBAR)||this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_HOME)||this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_END))&&(e.preventDefault(),e.stopPropagation()),this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_UP)||this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_DOWN)?this._handleKeydownUpDown(e):this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_LEFT)||this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_RIGHT)?this._handleKeydownLeftRight(e):this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_TAB)?this._handleKeydownTab(e):l===this._KEYBOARD_CODES._KEYBOARD_CODE_F2?this._handleKeydownF2(e):l===this._KEYBOARD_CODES._KEYBOARD_CODE_SPACEBAR?this._handleKeydownSpacebar(e):l===this._KEYBOARD_CODES._KEYBOARD_CODE_ENTER?this._handleKeydownEnter(e):l===this._KEYBOARD_CODES._KEYBOARD_CODE_HOME?this._handleKeydownHome(e):l===this._KEYBOARD_CODES._KEYBOARD_CODE_END?this._handleKeydownEnd(e):l===this._KEYBOARD_CODES._KEYBOARD_CODE_ESC&&this._handleKeydownEsc(e))},keyup:function(e){if(1===this._getKeyboardKeys().length){var l=this._getKeyboardKeys()[0];if(this._isNodeEditable(e.target)||null!=this._getTableDomUtils().getTableFooter()&&t(this._getTableDomUtils().getTableFooter()).has(e.target).length>0)return void this._removeKeyboardKey(l);this._removeKeyboardKey(l)}this._removeKeyboardKey(e.keyCode)},"mouseleave .oj-table-element":function(){this._getTableResizeUtils().clearTableHeaderColumnsResize()},"mousedown .oj-table-body":function(t){if(this._mouseDownRowIdx=this._getTableDomUtils().getElementRowIdx(t.target),null!=this._mouseDownRowIdx){var l=this._getTableDomUtils().getTableBodyRow(this._mouseDownRowIdx);if(null!=l&&l.draggable)this._mouseDownRowIdx=null;else if(null!=this._mouseDownRowIdx&&!t[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT]&&!e.DomUtils.isMetaKeyPressed(t)&&1===t.which){if(this._getRowSelection(this._mouseDownRowIdx)&&1===this._getSelectedRowIdxs().length)return;this._nonContiguousSelection||this._clearSelectedRows(!0)}}},"mouseup .oj-table-body":function(){this._mouseDownRowIdx=null},"mouseenter .oj-table-body-row":function(t){var l=this._getEventTargetElement(t);l.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._HOVER);var o=this._getTableDomUtils().getElementRowIdx(l);this._updateRowStateCellsClass(o,{hover:!0}),this._handleMouseEnterSelection(t.target)},"mouseleave .oj-table-body-row":function(t){var l=this._getEventTargetElement(t);l.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._HOVER);var o=this._getTableDomUtils().getElementRowIdx(l);this._updateRowStateCellsClass(o,{hover:!1})},"mousedown .oj-table-column-header-cell":function(e){if(1===e.which&&!this._getTableResizeUtils().handleHeaderColumnResizeStart(e)){var l=this._getTableDomUtils().getElementColumnIdx(this._getEventTargetElement(e));this._setHeaderColumnFocus(l,!0,!0,e,null),t(e.target).data(this._FOCUS_CALLED,!0)}},"mouseenter .oj-table-column-header-cell":function(t){if(!this._getTableResizeUtils().setResizeCursor(t)){var l=this._getEventTargetElement(t);l.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._HOVER);var o=this._getTableDomUtils().getElementColumnIdx(l);this._showTableHeaderColumnSortLink(o)}},"mousemove .oj-table-header":function(e){this._getTableResizeUtils().setResizeCursor(e)},"mousemove .oj-table-column-header-cell":function(t){var l=this._getEventTargetElement(t);this._getTableResizeUtils().setResizeCursor(t)?l.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._HOVER):l.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._HOVER)},"mouseleave .oj-table-column-header-cell":function(t){var l=this._getEventTargetElement(t);l.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._HOVER);var o=this._getTableDomUtils().getElementColumnIdx(l);this._hideTableHeaderColumnSortLink(o,!0),this._hideTableHeaderColumnSortLink(o,!1)},"mouseup .oj-table-column-header-cell":function(e){this._getTableResizeUtils().handleHeaderColumnResizeEnd(e)},"mousedown .oj-table-data-cell":function(e){var l=this._getEventTargetElement(e),o=this._getTableDomUtils().getElementRowIdx(l);this._setRowFocus(o,!0,!0,l,e),t(e.target).data(this._FOCUS_CALLED,!0)},"mouseup .oj-table-data-cell":function(e){this._getTableResizeUtils().handleHeaderColumnResizeEnd(e)},"click .oj-table-column-header-asc-link":function(e){var l=this._getTableDomUtils().getElementColumnIdx(e.target),o=this._getTableDomUtils().getTableHeaderColumn(l);o&&(t(o).data("sorted")===this._COLUMN_SORT_ORDER._ASCENDING?this._handleSortTableHeaderColumn(l,!1,e):this._handleSortTableHeaderColumn(l,!0,e),e.preventDefault(),e.stopPropagation())},"click .oj-table-column-header-acc-asc-link":function(e){if(this._getKeyboardKeys().length>0&&this._getKeyboardKeys()[0]===this._KEYBOARD_CODES._KEYBOARD_CODE_ENTER)return e.preventDefault(),void e.stopPropagation();var l=this._getTableDomUtils().getElementColumnIdx(e.target),o=this._getTableDomUtils().getTableHeaderColumn(l);o&&(t(o).data("sorted")===this._COLUMN_SORT_ORDER._DESCENDING?this._handleSortTableHeaderColumn(l,!0,e):this._handleSortTableHeaderColumn(l,!1,e),e.preventDefault(),e.stopPropagation())},"click .oj-table-column-header-dsc-link":function(e){var l=this._getTableDomUtils().getElementColumnIdx(e.target),o=this._getTableDomUtils().getTableHeaderColumn(l);o&&(t(o).data("sorted")===this._COLUMN_SORT_ORDER._DESCENDING?this._handleSortTableHeaderColumn(l,!0,e):this._handleSortTableHeaderColumn(l,!1,e),e.preventDefault(),e.stopPropagation())},"click .oj-table-column-header-acc-dsc-link":function(e){if(this._getKeyboardKeys().length>0&&this._getKeyboardKeys()[0]===this._KEYBOARD_CODES._KEYBOARD_CODE_ENTER)return e.preventDefault(),void e.stopPropagation();var l=this._getTableDomUtils().getElementColumnIdx(e.target),o=this._getTableDomUtils().getTableHeaderColumn(l);o&&(t(o).data("sorted")===this._COLUMN_SORT_ORDER._DESCENDING?this._handleSortTableHeaderColumn(l,!0,e):this._handleSortTableHeaderColumn(l,!1,e),e.preventDefault(),e.stopPropagation())},"click .oj-table-data-cell":function(l){var o,i=this._getEventTargetElement(l),s=this._getTableDomUtils().getElementRowIdx(i);if(!t(l.target).data(this._FOCUS_CALLED)){var n=this._setRowFocus(s,!0,!0,i,l);if(t(l.target).data(this._FOCUS_CALLED,!1),!n)return}if(l[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT]){var a=this._getLastRowSelection();if(null!=a)if(window.getSelection().removeAllRanges(),s<a)for(o=s;o<=a;o++)this._setRowSelection(o,!0,i,l,!0);else for(o=a;o<=s;o++)this._setRowSelection(o,!0,i,l,!0)}else if(e.DomUtils.isMetaKeyPressed(l))this._setRowSelection(s,!this._getRowSelection(s),i,l,!0),this._lastSelectedRowIdxArray&&this._lastSelectedRowIdxArray.indexOf(s)>-1&&(this._selectionAnchorIdx=s);else if(0===this._getKeyboardKeys().length){var r=this._getRowSelection(s);this._setRowSelection(s,!r,i,l,!0),this._lastSelectedRowIdxArray&&this._lastSelectedRowIdxArray.indexOf(s)>-1&&(this._selectionAnchorIdx=s),this._isTouchDevice()&&this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._MULTIPLE&&!r&&this._getTableDomUtils().createTableBodyRowTouchSelectionAffordance(s)}},"dblclick .oj-table-data-cell":function(e){var t=this._getTableDomUtils().getElementColumnIdx(e.target);this._setTableEditable(!0,!1,t,!0,e)},"contextmenu .oj-table-data-cell":function(e){var t=this._getTableDomUtils().getElementRowIdx(this._getEventTargetElement(e)),l=this._getRowKeyForRowIdx(t);this._setCurrentRow({rowKey:l},e,!1)},"click .oj-table-column-header-cell":function(l){var o,i=this._getEventTargetElement(l);if("col-resize"!==i.style.cursor){var s=this._getTableDomUtils().getElementColumnIdx(i);if(t(l.target).data(this._FOCUS_CALLED)||(this._setHeaderColumnFocus(s,!0,!0,l,null),t(l.target).data(this._FOCUS_CALLED,!1)),l[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT]){var n=this._getLastHeaderColumnSelection();if(null!=n)if(s<n)for(o=s;o<=n;o++)this._setHeaderColumnSelection(o,!0,i,l,!0);else for(o=n;o<=s;o++)this._setHeaderColumnSelection(o,!0,i,l,!0)}else if(e.DomUtils.isMetaKeyPressed(l))this._setHeaderColumnSelection(s,!this._getHeaderColumnSelection(s),i,l,!0);else if(0===this._getKeyboardKeys().length){var a=this._getSelectedHeaderColumnIdxs();null!=a&&a.length>0&&(-1===a.indexOf(s)||a.length>1)&&this._clearSelectedHeaderColumns(),this._setHeaderColumnSelection(s,!this._getHeaderColumnSelection(s),i,l,!0),this._getTableDndContext().setTableHeaderColumnDraggable(s,!0)}}},"dragstart .oj-table-column-header-cell":function(e){if("col-resize"!==this._getEventTargetElement(e).style.cursor)return this._getTableDndContext().handleColumnDragStart(e)},"dragenter .oj-table-column-header-cell":function(e){return this._getTableDndContext().handleColumnDragEnter(e)},"dragover .oj-table-column-header-cell":function(e){return this._getTableDndContext().handleColumnDragOver(e)},"dragleave .oj-table-column-header-cell":function(e){return this._getTableDndContext().handleColumnDragLeave(e)},"drop .oj-table-column-header-cell":function(e){return this._getTableDndContext().handleColumnDrop(e)},"dragend .oj-table-column-header-cell":function(e){return this._getTableDndContext().handleColumnDragEnd(e)},"dragstart .oj-table-body-row":function(e){return this._getTableDndContext().handleRowDragStart(e)},"drag .oj-table-body-row":function(e){return this._getTableDndContext().handleRowDrag(e)},"dragend .oj-table-body-row":function(e){return this._getTableDndContext().handleRowDragEnd(e)},"dragenter .oj-table-body":function(e){return this._getTableDndContext().handleRowDragEnter(e)},"dragover .oj-table-body":function(e){return this._getTableDndContext().handleRowDragOver(e)},"dragleave .oj-table-body":function(e){return this._getTableDndContext().handleRowDragLeave(e)},"drop .oj-table-body":function(e){return this._getTableDndContext().handleRowDrop(e)}},_eventsContainer:{"touchstart .oj-table-body-row-touch-selection-affordance-touch-area":function(l){1===l.originalEvent.touches.length&&this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._MULTIPLE&&(l.target.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOP_CLASS)||l.target.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOP_ICON_CLASS)?(l.preventDefault(),this._mouseDownRowIdx=t(this._getTableDomUtils().getTableBodyRowTouchSelectionAffordanceBottom()).data("rowIdx")):(l.target.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_BOTTOM_CLASS)||l.target.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_BOTTOM_ICON_CLASS))&&(l.preventDefault(),this._mouseDownRowIdx=t(this._getTableDomUtils().getTableBodyRowTouchSelectionAffordanceTop()).data("rowIdx")))},"touchstart .oj-table-column-header-cell":function(e){1===e.originalEvent.touches.length&&this._isTableColumnsResizable()&&this._getTableResizeUtils().handleHeaderColumnResizeStart(e)&&e.preventDefault()},"touchmove .oj-table-header":function(e){this._isTableColumnsResizable()&&this._getTableResizeUtils().setResizeCursor(e)},"touchmove .oj-table-body-row-touch-selection-affordance-touch-area":function(e){if(null!=this._mouseDownRowIdx){e.preventDefault();var t=this._getEventTargetElement(e);this._handleMouseEnterSelection(t)}},touchend:function(e){if(null!=this._mouseDownRowIdx){var t=this._getEventTargetElement(e);this._handleMouseEnterSelection(t)}this._mouseDownRowIdx=null,this._getTableResizeUtils().handleHeaderColumnResizeEnd(e)&&e.preventDefault()},"touchend .oj-table-body":function(e){var t,l=this;this._touchEventDoubleTapFunction(e,(t=e,function(){var e=l._getEventTargetElement(t),o=l._getTableDomUtils().getElementColumnIdx(e);l._setTableEditable(!0,!1,o,!0,t),t.preventDefault()}))},touchcancel:function(){this._mouseDownRowIdx=null,this._getTableResizeUtils().clearTableHeaderColumnsResize()}},_refresh:function(){var e=!1;this._dataOption!==this.options[this._CONST_DATA]&&(this._clearCachedDataMetadata(),null==this._data&&(e=!0));var t=this._GetContextMenu();if(null!=t&&t!==this._getTableDomUtils().getContextMenu()&&this._getTableDomUtils().createContextMenu(this._handleContextMenuSelect.bind(this)),this._getTableDomUtils().clearCachedDom(),this._getTableDomUtils().refreshContextMenu(),this._refreshTableStatusMessage(),e)return this._initFetch();var l=this;return this._queueTask(function(){var e=l._invokeDataFetchRows(null,!1);return l=null,e})},_setOption:function(e,t){"selection"===e?(this._clearSelectedRows(),this._clearSelectedHeaderColumns(),this._setSelection(t),this._setSelectionDefault(),this._superApply(arguments)):"currentRow"===e?this._setCurrentRow(t,null,!0)&&this._superApply(arguments):"scrollPosition"===e?this._syncScrollPosition(t):(this._superApply(arguments),this._isTableRefreshNeeded(e,t)&&("columns"===e?(this._clearCachedMetadata(),this._refreshTableHeader()):"data"===e&&this._adjustScrollPositionOnRefresh(),this._refresh()))},_adjustScrollPositionOnRefresh:function(){var e=null==this.options.scrollPosition?{}:this.options.scrollPosition;if(!isNaN(e.rowIndex)&&void 0!==e.rowKey){var t=this._getSelectedRowIdxs();null!=t&&t.length>0&&(this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._SINGLE||this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._MULTIPLE)?(!isNaN(this._selectionAnchorIdx)&&t.indexOf(this._selectionAnchorIdx)>-1?e.rowKey=this._getRowKeyForRowIdx(this._selectionAnchorIdx):e.rowKey=this._getRowKeyForRowIdx(t[0]),delete e.rowIndex):(e.y=0,e.rowIndex=0,delete e.rowKey),e.x=0,e.columnKey=null,e.columnIndex=0,e.offsetX=0,e.offsetY=0,this.option("scrollPosition",e,{_context:{internalSet:!0},changed:!1})}},_findRowElementByKey:function(l){var o=this._getTableDomUtils().getTableBodyRows();if(null!=o&&o.length>0)for(var i=o.length,s=0;s<i;s++)if(e.Object.compareValues(t(o[s]).data("rowKey"),l))return o[s];return null},_validateKeys:function(e){for(var t=0;t<e.length;t++)if(null!=this._findRowElementByKey(e[t]))return Promise.resolve(!0);var l=this._getData();return l&&l.containsKeys?new Promise(function(t){var o=new Set;e.forEach(function(e){o.add(e)}),l.containsKeys({keys:o}).then(function(e){t(e.results.size>0)},function(){t(!1)})}):null},_syncScrollPosition:function(e,t){if(this._IsCustomElement()&&!this._noDataMessageShown&&(this._isScrollableX()||this._isScrollableY())){null!=this._scrollPosition?e=this._scrollPosition:void 0===e&&(e=this.options.scrollPosition),null==this._scrollPosResolveFunc&&(this._scrollPosResolveFunc=this._addComponentBusyState("handling scroll position"));var l=this;if((t=void 0===t||t)&&e.rowKey){var o=this._validateKeys([e.rowKey]);if(o)return void o.then(function(t){t||delete e.rowKey,l._syncScrollPosition(e,!1)})}var i=this._getScrollCoordinates(e),s=i.x,n=i.y;if(isNaN(s)&&isNaN(n))return null!=this._scrollPosition&&(this.option("scrollPosition",this._getCurrentScrollPosition(),{_context:{originalEvent:null,internalSet:!0}}),this._scrollPosition=null),this._scrollPosResolveFunc(),void(this._scrollPosResolveFunc=null);var a=isNaN(this._scrollTop)?0:this._scrollTop,r=isNaN(this._scrollLeft)?0:this._scrollLeft;if(!isNaN(s)&&isNaN(n)||!isNaN(s)&&n===a&&s!==r){if(!this._isScrollableX())return;this._setScrollX(s);var _=this.options.scrollPosition,h=this._getCurrentHorizontalScrollPosition(s);h.y=_.y,h.rowIndex=_.rowIndex,h.rowKey=_.rowKey,h.offsetY=_.offsetY,this.option("scrollPosition",h,{_context:{originalEvent:null,internalSet:!0}})}else if(n!==a){if(!this._isScrollableY())return void(isNaN(s)||s===r||(delete e.y,this._syncScrollPosition(e,t)));if(this._setScrollY(-1===n?this._getScrollHeight()-this._getClientHeight():n),isNaN(s)||s===r||this._setScrollX(s),-1===n)return void(this._scrollPosition=e);this.option("scrollPosition",this._getCurrentScrollPosition(s,n),{_context:{originalEvent:null,internalSet:!0}})}else e&&(null==e.rowKey||isNaN(e.rowIndex))&&this.option("scrollPosition",this._getCurrentScrollPosition(s,n),{_context:{originalEvent:null,internalSet:!0}});null!=this._scrollPosition&&(this._scrollPosition=null),this._scrollPosResolveFunc&&(this._scrollPosResolveFunc(),this._scrollPosResolveFunc=null)}},_isScrollableX:function(){return Math.abs(this._getScrollWidth()-this._getClientWidth())>1},_isScrollableY:function(){return Math.abs(this._getScrollHeight()-this._getClientHeight())>1},_getScrollWidth:function(){return null==this._scrollWidth&&(this._scrollWidth=this._getTableDomUtils().getScroller().scrollWidth),this._scrollWidth},_getScrollHeight:function(){return null==this._scrollHeight&&(this._scrollHeight=this._getTableDomUtils().getScroller().scrollHeight),this._scrollHeight},_getClientWidth:function(){return null==this._clientWidth&&(this._clientWidth=this._getTableDomUtils().getScroller().clientWidth),this._clientWidth},_getClientHeight:function(){return null==this._clientHeight&&(this._clientHeight=this._getTableDomUtils().getScroller().clientHeight),this._clientHeight},_setScrollX:function(t){var l=this._getTableDomUtils().getScroller();this._skipScrollUpdate=!0,e.DomUtils.setScrollLeft(l,t)},_setScrollY:function(e){var t=this._getTableDomUtils().getScroller();this._skipScrollUpdate=!0,t.scrollTop=e},_getScrollTopByIndex:function(e){if(0===e)return 0;if(!(this._isLoadMoreOnScroll()&&e>this.options.scrollPolicyOptions.maxCount)){var t=this._getTableDomUtils().getTableBodyRows()[e];return null!=t?t.offsetTop:this._hasMoreToFetch()?-1:void 0}},_getScrollTopByKey:function(e){var t=this._findRowElementByKey(e);if(null!=t){var l=this._getTableDomUtils().getTableBodyRows();return null!=l&&l.length>0?Math.max(0,t.offsetTop-l[0].offsetTop):void 0}if(this._hasMoreToFetch())return-1},_getScrollLeftByIndex:function(e){if(0===e)return 0;var t=this._getTableDomUtils().getTableHeaderColumn(e);return null!=t?t.offsetLeft:void 0},_getScrollLeftByKey:function(e){var t=this._getColumnIdxForColumnKey(e);return this._getScrollLeftByIndex(t)},_getScrollCoordinates:function(e){var t,l,o=e.rowKey;isNaN(t)&&null!=o&&(t=this._getScrollTopByKey(o));var i=e.columnKey;isNaN(l)&&null!=i&&(l=this._getScrollLeftByKey(i));var s=e.rowIndex;isNaN(t)&&!isNaN(s)&&(t=this._getScrollTopByIndex(s));var n=e.columnIndex;isNaN(l)&&!isNaN(n)&&(l=this._getScrollLeftByIndex(n));var a=e.offsetX;!isNaN(l)&&!isNaN(a)&&l>=0&&(l+=a);var r=e.offsetY;return!isNaN(t)&&!isNaN(r)&&t>=0&&(t+=r),isNaN(l)&&!isNaN(e.x)&&(l=Math.max(0,e.x)),isNaN(t)&&!isNaN(e.y)&&(t=e.y>this._getScrollHeight()?this._hasMoreToFetch()?-1:this._getScrollHeight()-this._getClientHeight():Math.max(0,e.y)),{x:l,y:t}},_getCurrentHorizontalScrollPosition:function(e){var t={};t.x=void 0===e?this._scrollLeft:e;var l=this.option("scrollPosition"),o=Math.abs(l.x-t.x);if(o<1&&null!=l.columnKey&&!isNaN(l.columnIndex))return t.columnKey=l.columnKey,t.columnIndex=l.columnIndex,t.offsetX=l.offsetX+o,t;var i=this._getColumnLocations();if(i&&i.length>0){var s,n=i.length-1;for(s=0;s<i.length-1;s++)if(t.x>=i[s]&&t.x<i[s+1]){n=s;break}t.columnKey=this._getColumnDefs()[n].id,t.columnIndex=n,t.offsetX=t.x-i[n]}return t},_getCurrentVerticalScrollPosition:function(e){var t={};t.y=void 0===e?this._scrollTop:e;var l=this.option("scrollPosition");if(!isNaN(this._rowHeight)&&this._rowHeight>0){var o;Math.abs(l.y-e)<this._rowHeight&&null!=l.rowKey&&!isNaN(l.rowIndex)&&(o=l.rowIndex),isNaN(o)&&(o=Math.floor(t.y/this._rowHeight));var i=this._findClosestElementToTop(o,t.y);null!=i&&(t.rowIndex=i.index,t.rowKey=this._getRowKeyForRowIdx(i.index),t.offsetY=i.offset)}return t},_getCurrentScrollPosition:function(e,t){var l=this._getCurrentHorizontalScrollPosition(e),o=this._getCurrentVerticalScrollPosition(t);return Object.keys(o).forEach(function(e){l[e]=o[e]}),l},_getColumnLocations:function(){if(null==this._columnOffsets){this._columnOffsets=[];var e,t,l=this._getTableDomUtils().getTableHeaderColumns();if(l&&l.length>0)for(e=l[0].offsetLeft,this._columnOffsets.push(0),t=1;t<l.length;t++)this._columnOffsets.push(l[t].offsetLeft-e)}return this._columnOffsets},_findClosestElementToTop:function(e,t){var l=!1,o=this._getTableDomUtils().getTableBodyRows();if(!(null==o||0===o.length||e>=o.length)){var i,s=o[e],n=t-(i=0===e?0:s.offsetTop-o[0].offsetTop),a={index:e,elem:s,offsetTop:i,offset:n};if(Math.abs(n)<1)return a;var r,_=n>0;for(_?e+=1:e-=1;!l&&e>=0&&e<o.length;){if(r=i,i=(s=o[e]).offsetTop,l=(n=Math.abs(t-i))<1||(_?t<=i:t>=i)){a=n<1||!_?{index:e,elem:s,offsetTop:i,offset:n}:{index:e-1,elem:o[e-1],offsetTop:r,offset:t-r};break}_?e+=1:e-=1}return a}},_hasMoreToFetch:function(){return!!this._isLoadMoreOnScroll()&&!this._noMoreData},_addKeyboardKey:function(e){for(var t=!1,l=Object.keys(this._KEYBOARD_CODES),o=0;o<l.length;o++){var i=l[o];this._KEYBOARD_CODES[i]===e&&(t=!0)}if(t){for(var s=this._getKeyboardKeys(),n=!1,a=s.length,r=0;r<a;r++)if(s[r]===e){n=!0;break}n||s.push(e)}},_addComponentBusyState:function(e){var t=l.getContext(this.element[0]).getBusyContext(),o={description:"The component identified by '"+this._getTableDomUtils().getTableId()+"' "+e};return t.addBusyState(o)},_addSingleTableBodyRow:function(e,t,l,o){var i=this._getTableDomUtils().createTableBodyRow(e,t[this._CONST_KEY]);return this._getTableDomUtils().styleTableBodyRow(i,!0),this._getTableDomUtils().insertTableBodyRow(e,i,t,l),i=this._refreshTableBodyRow(e,t,i,l,o,!0),l||n.subtreeAttached(i),i},_animateVisibleRows:function(e,t,l){if(l=null==this._animationActionOverride?l:this._animationActionOverride,!this._hasPendingTasks()){this._animationActionOverride=null;var o,i=this._getVisibleRowIdxs(),s=[];for(o=0;o<t.length;o++)-1===i.indexOf(t[o])&&s.push(t[o]);for(s.sort(function(e,t){return e-t}),o=s.length-1;o>=0;o--)e.splice(s[o],1);this._unregisterResizeListener();var n=this;return this._getTableAnimationUtils().animateTableBodyRows(e,l).then(function(){n._registerResizeListener()})}return this._animationActionOverride="update",Promise.resolve()},_checkRowOrHeaderColumnFocus:function(e){var t=this._getFocusedRowIdx(),l=this._getFocusedHeaderColumnIdx();if(null==t&&null==l){var o=null,i=this._getCurrentRow(),s=null!=i?i.rowKey:null;null!=s&&(o=this._getRowIdxForRowKey(s)),null==o?this._isTableHeaderless()?this._setRowFocus(0,!0,!0,null,e):this._setHeaderColumnFocus(0,!0,!1,e,!0):this._setRowFocus(o,!0,!0,null,e)}},_cleanTemplateNodes:function(e){var t=this._getTemplateEngine();null!=t&&t.clean(e)},_clearCachedMetadata:function(){this._columnDefArray=null,this._columnOffsets=null,this._setTableActionableMode(!1)},_clearCachedDataMetadata:function(){null!=this._data&&this._unregisterDataSourceEventListeners(),this._data=null},_clearCachedDimensions:function(){this._clientWidth=null,this._clientHeight=null,this._scrollWidth=null,this._scrollHeight=null},_clearDataWaitingState:function(){this._hideInlineMessage(),this._hideStatusMessage(),this._dataFetching=!1,this._dataResolveFunc&&(this._dataResolveFunc(),this._dataResolveFunc=null)},_clearKeyboardKeys:function(){this._keyboardKeys=[]},_clearFocusedHeaderColumn:function(){var e=this._getFocusedHeaderColumnIdx();null!=e&&this._setHeaderColumnFocus(e,!1,!1,null,null),this._activeColumnIndex=-1},_clearFocusedRow:function(e){null!=this._getFocusedRowIdx()&&this._setRowFocus(-1,!0,e,null,null)},_clearSelectedHeaderColumns:function(){for(var e=this._getSelectedHeaderColumnIdxs(),t=e.length,l=0;l<t;l++)this._setHeaderColumnSelection(e[l],!1,null,null,!1,!0)},_clearSelectedRows:function(){for(var e=this._getSelectedRowIdxs(),t=e.length,l=0;l<t;l++)this._setRowSelection(e[l],!1,null,null,!1,!0);this._isTouchDevice()&&this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._MULTIPLE&&this._getTableDomUtils().removeTableBodyRowTouchSelectionAffordance(),this._selectionAnchorIdx=null},_clearSortedHeaderColumn:function(l){var o=this._getSortedTableHeaderColumnIdx();if(null!=o){var i=this._getTableDomUtils().getTableHeaderColumn(o),s=t(i).data("sorted");if(t(i).data("sorted",null),null==l||o!==l)this._hideTableHeaderColumnSortLink(o,s===this._COLUMN_SORT_ORDER._ASCENDING);else{var n=i.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_LINK_CLASS);n.length>0&&(n=n[0]).classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED);var a=i.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_LINK_CLASS);a.length>0&&(a=a[0]).classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)}}},_executeTableBodyRowsAdd:function(e){var t=this;this._queueTask(function(){var l=t._getRowsFromEventDetailAdd(e);if(0!==l.length){var o,i,s=!1,a=[],r=[];if(l.length>1){i=l.length;var _=!0;for(o=0;o<i;o++)0!==o&&l[o-1].rowIdx!==l[o].rowIdx-1&&(_=!1),r.push(l[o].rowIdx);if(_){var h=t._getTableDomUtils().getTableBody(),u=document.createDocumentFragment();for(i=l.length,o=0;o<i;o++)a.push(t._addSingleTableBodyRow(l[o].rowIdx,l[o].row,u,l[0].rowIdx));if(0===l[0].rowIdx)h.insertBefore(u,h.firstChild);else{var d=t._getTableDomUtils().getTableBodyRow(l[0].rowIdx);null!=d?h.insertBefore(u,d):h.appendChild(u,null)}t._getTableDomUtils().clearCachedDomRowData(),n.subtreeAttached(h),s=!0}}if(!s)for(i=l.length,o=0;o<i;o++)a.push(t._addSingleTableBodyRow(l[o].rowIdx,l[o].row));return t._getTableDomUtils().clearCachedDomRowData(),t._refreshTableFooter(),t._IsCustomElement()?t._animateVisibleRows(a,r,"add").then(function(){return t._waitForAllComponentsToResolve(a)}):t._waitForAllComponentsToResolve(a)}})},_executeTableBodyRowsChange:function(e,t){var l=this;this._queueTask(function(){var t=l._getRowsFromEventDetailChange(e);if(0!==t.length){for(var o=t.length,i=[],s=[],n=0;n<o;n++){var a=l._refreshTableBodyRow(t[n].rowIdx,t[n].row);i.push(a),s.push(t[n].rowIdx)}return l._refreshTableFooter(),l._IsCustomElement()?l._animateVisibleRows(i,s,"update").then(function(){return l._waitForAllComponentsToResolve(i)}):l._waitForAllComponentsToResolve(i)}})},_executeTableBodyRowsRemove:function(e){var l=this;this._queueTask(function(){var o=l._getRowsFromEventDetailRemove(e);if(0!==o.length){o.sort(function(e,t){return t.rowIdx-e.rowIdx});var i,s,n,a=l._getCurrentRow(),r=null!=a?a.rowIndex:0,_=null!=a?a.rowKey:null,h=[],u=[],d=[],S=o.length,T=!1,c=l._getTableDomUtils().getTableBodyRows();if(null!=c&&c.length>0){for(n=0;n<c.length;n++)h.push(n);for(n=0;n<S;n++){s=o[n].rowIdx,u.push(s);for(var m=0;m<h.length;m++)if(h[m]===s){i=this._getTableDomUtils().getTableBodyRow(s),d.push(i),h.splice(m,1);break}}0===h.length&&(T=!0)}var C=this._getTableDomUtils().getTableBody(),E=t.contains(C,document.activeElement),D=!1;if(T)E&&(D=!0),l._setSelection(null),l.option("selection",null,{_context:{writeback:!0,internalSet:!0}});else for(n=0;n<S;n++)if(s=o[n].rowIdx,i=this._getTableDomUtils().getTableBodyRow(s),E&&null!=i&&t.contains(i,document.activeElement)){D=!0,E=!1;break}if(!T)return new Promise(function(e){l._IsCustomElement()?l._animateVisibleRows(d,u,"remove").then(function(){b(),g(),e(!0)}):(b(),g(),e(!0))});l._getTableDomUtils().removeAllTableBodyRows(),g()}function b(){for(var e=0;e<S;e++){var t=o[e].rowIdx;l._getTableDomUtils().removeTableBodyRow(t)}}function g(){l._refreshTableFooter(),null!=(c=l._getTableDomUtils().getTableBodyRows())&&0!==c.length||l._showNoDataMessage(),null!=_&&(null==c||T||r>=c.length?l._setCurrentRow(null,null,!1):l._setCurrentRow({rowIndex:r,rowKey:null},null,!1)),D&&l._getTableDomUtils().getTable().focus()}})},_getAllBusyContextsForElement:function(e){if(!e)return null;var t=e.querySelectorAll("[data-oj-context]");if(t.length>0){for(var o=[],i=0;i<t.length;i++)o.push(l.getContext(t[i]).getBusyContext());return o}return null},_getColumnDefs:function(){return this._columnDefArray||(this._columnDefArray=this._getColumnMetadata()),this._columnDefArray},_getColumnMetadata:function(){var e=this.options.columns,l=this.options.columnsDefault;if((0===e.length||1===e.length&&null==e[0].id&&null==e[0].headerText&&null==e[0].field)&&null==l.headerText&&null==l.field)return[];var o,i=[],s=e.length;for(o=0;o<s;o++)i[o]=t.extend({},l,e[o]);var n=[],a=i.length;for(o=0;o<a;o++)n.push(i[o]);var r=this._getData(),_=!1;for(null!=r&&null!=r.getCapability("sort")&&(_=!0),o=0;o<a;o++)null==n[o][this._FIELD_ID]&&(n[o][this._FIELD_ID]=this._COLUMN_HEADER_ID_PREFIX+o),null!=n[o].sortable&&n[o].sortable!==this._OPTION_AUTO||!_||(n[o].sortable=this._OPTION_ENABLED);return n},_getColumnIdxForColumnKey:function(t){var l=this._getColumnDefs();if(null!=l)for(var o=l.length,i=0;i<o;i++){var s=l[i];if(e.Object.compareValues(s.id,t))return i}return null},_getColumnIdxsForElementsWithStyleClass:function(e){var t=this._getTableDomUtils().getTable().querySelectorAll(e),l=[];if(t&&t.length>0)for(var o=t.length,i=0;i<o;i++){for(var s=this._getTableDomUtils().getElementColumnIdx(t[i]),n=!1,a=l.length,r=0;r<a;r++)l[r]===s&&(n=!0);n||l.push(s)}return l},_getColumnKeyForColumnIdx:function(e){var t=this._getColumnDefs();return null!=t&&e<t.length?t[e][this._FIELD_ID]:null},_getColumnRenderer:function(e,t){var l=this._getColumnDefs()[e],o=null;return"cell"===t?o=l.renderer:"footer"===t?o=l.footerRenderer:"header"===t&&(o=l.headerRenderer),this._WrapCustomElementRenderer(o)},_getCurrentRow:function(){return this._getData()?this._currentRow:null},_getData:function(){if(!this._data&&null!=this.options.data){var t=this.options.data;if(e.TableDataSource&&t instanceof e.TableDataSource||e.PagingTableDataSource&&t instanceof e.PagingTableDataSource)this._data=new e.TableDataSourceAdapter(t);else{if(!e.DataProviderFeatureChecker.isDataProvider(t)){var l=this._LOGGER_MSG._ERR_DATA_INVALID_TYPE_SUMMARY,o=this._LOGGER_MSG._ERR_DATA_INVALID_TYPE_DETAIL;throw new Error(l+"\n"+o)}t instanceof e.ListDataProviderView?this._data=t:this._data=new e.ListDataProviderView(t)}this._dataOption=this.options.data,this._registerDataSourceEventListeners()}return this._data},_getFocusedHeaderColumnIdx:function(){return this._getColumnIdxsForElementsWithStyleClass("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CELL_CLASS+"."+e.TableDomUtils.MARKER_STYLE_CLASSES._FOCUS_HIGHLIGHT+",."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CELL_CLASS+"."+e.TableDomUtils.MARKER_STYLE_CLASSES._FOCUS)[0]},_getFocusedRowIdx:function(){return this._getRowIdxsForElementsWithStyleClass("."+e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS+"."+e.TableDomUtils.MARKER_STYLE_CLASSES._FOCUS_HIGHLIGHT+",."+e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS+"."+e.TableDomUtils.MARKER_STYLE_CLASSES._FOCUS)[0]},_getHeaderColumnSelection:function(t){return this._getTableDomUtils().getTableHeaderColumn(t).classList.contains(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)},_getColumnSelectionMode:function(){return null==this.options.selectionMode?null:this.options.selectionMode[this._CONST_COLUMN]},_getKeyboardKeys:function(){return this._keyboardKeys||(this._keyboardKeys=[]),this._keyboardKeys.reverse()},_getLastHeaderColumnSelection:function(){return null!=this._lastSelectedColumnIdxArray&&this._lastSelectedColumnIdxArray.length>0?this._lastSelectedColumnIdxArray[0]:null},_getLastRowSelection:function(){return null!=this._lastSelectedRowIdxArray&&this._lastSelectedRowIdxArray.length>0?this._lastSelectedRowIdxArray[0]:null},_getRowIdxRowArray:function(e,t){var l=[];if(null!=e)for(var o=e[this._CONST_INDEXES].length,i=0;i<o;i++)l.push({row:{data:e[this._CONST_DATA][i],metadata:e[this._CONST_METADATA]?e[this._CONST_METADATA][i]:null,key:e[this._CONST_KEYS][i],index:e[this._CONST_INDEXES][i]},rowIdx:t+i});return l},_getRowIdxForRowKey:function(l){var o=this._getTableDomUtils().getTableBodyRows();if(null!=o&&o.length>0)for(var i=o.length,s=0;s<i;s++)if(e.Object.compareValues(t(o[s]).data("rowKey"),l))return s;return null},_getDataSourceRowIndexForRowKey:function(l){var o=this._getTableDomUtils().getTableBodyRows();if(null!=o&&o.length>0)for(var i=o.length,s=0;s<i;s++)if(e.Object.compareValues(t(o[s]).data("rowKey"),l)){var n=this._getData(),a=0;return this._isPagingModelDataProvider()&&(a=n.getStartItemIndex()),s+a}return null},_getEditableRowIdx:function(){var e=null;return null!=this._getEditableRowKey()&&null!==(e=this._getRowIdxForRowKey(this._getEditableRowKey()))?e:this._editableRowIdx},_getEditableRowKey:function(){return this._editableRowKey},_getEventTargetElement:function(e){return 0===e.type.indexOf("touch")?this._getTouchEventTargetElement(e):e.currentTarget},_getRowIdxsForElementsWithStyleClass:function(e){var t=this._getTableDomUtils().getTable().querySelectorAll(e),l=[];if(t&&t.length>0)for(var o=t.length,i=0;i<o;i++){for(var s=this._getTableDomUtils().getElementRowIdx(t[i]),n=!1,a=l.length,r=0;r<a;r++)l[r]===s&&(n=!0);n||l.push(s)}return l},_getRowKeyForDataSourceRowIndex:function(e){var l=this._getTableDomUtils().getTableBodyRows();if(null!=l&&l.length>0){var o=this._getData(),i=0;this._isPagingModelDataProvider()&&(i=o.getStartItemIndex());for(var s=l.length,n=0;n<s;n++)if(i+n===e)return t(l[n]).data("rowKey")}return null},_getRowKeyForRowIdx:function(e){var l=this._getTableDomUtils().getTableBodyRow(e);return null!=l?t(l).data("rowKey"):null},_getRowRenderer:function(){return this._WrapCustomElementRenderer(this.options.rowRenderer)},_getRowSelection:function(t){return this._getTableDomUtils().getTableBodyRow(t).classList.contains(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)},_getRowSelectionMode:function(){return null==this.options.selectionMode?null:this.options.selectionMode[this._CONST_ROW]},_getSelectedHeaderColumnIdxs:function(){return this._getColumnIdxsForElementsWithStyleClass("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CELL_CLASS+"."+e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)},_getSelectedRowIdxs:function(){return this._getRowIdxsForElementsWithStyleClass("."+e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS+"."+e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)},_getSelection:function(){var e=this._getSelectedRowIdxs(),t=this._getSelectedHeaderColumnIdxs(),l=null,o=!0;if(null!=e&&e.length>0)l=e;else{if(!(null!=t&&t.length>0))return[];l=t,o=!1}for(var i,s,n,a=[],r=0,_=null,h=l.length,u=0;u<h;u++){var d=l[u];0===u?((i={})[this._CONST_STARTINDEX]={},i[this._CONST_ENDINDEX]={},i.startKey={},i.endKey={},o?(n=this._getRowKeyForRowIdx(d),s=this._getDataSourceRowIndexForRowKey(n),i.startKey[this._CONST_ROW]=n,i.endKey[this._CONST_ROW]=n,i[this._CONST_STARTINDEX][this._CONST_ROW]=s,i[this._CONST_ENDINDEX][this._CONST_ROW]=s):(i[this._CONST_STARTINDEX][this._CONST_COLUMN]=d,i[this._CONST_ENDINDEX][this._CONST_COLUMN]=d,n=this._getColumnKeyForColumnIdx(d),i.startKey[this._CONST_COLUMN]=n,i.endKey[this._CONST_COLUMN]=n),a[0]=i):(i=a[r],o?(n=this._getRowKeyForRowIdx(d),s=this._getDataSourceRowIndexForRowKey(n),i.endKey[this._CONST_ROW]=n,i[this._CONST_ENDINDEX][this._CONST_ROW]=s):(i[this._CONST_ENDINDEX][this._CONST_COLUMN]=d,n=this._getColumnKeyForColumnIdx(d),i.endKey[this._CONST_COLUMN]=n),d!==_+1&&(o?(n=this._getRowKeyForRowIdx(_),s=this._getDataSourceRowIndexForRowKey(n),i.endKey[this._CONST_ROW]=n,i[this._CONST_ENDINDEX][this._CONST_ROW]=s,(i={})[this._CONST_STARTINDEX]={},i[this._CONST_ENDINDEX]={},i.startKey={},i.endKey={},n=this._getRowKeyForRowIdx(d),s=this._getDataSourceRowIndexForRowKey(n),i.startKey[this._CONST_ROW]=n,i.endKey[this._CONST_ROW]=n,i[this._CONST_STARTINDEX][this._CONST_ROW]=s,i[this._CONST_ENDINDEX][this._CONST_ROW]=s):(i[this._CONST_ENDINDEX][this._CONST_COLUMN]=_,n=this._getColumnKeyForColumnIdx(_),i.endKey[this._CONST_COLUMN]=n,(i={})[this._CONST_STARTINDEX]={},i[this._CONST_ENDINDEX]={},i.startKey={},i.endKey={},i[this._CONST_STARTINDEX][this._CONST_COLUMN]=d,i[this._CONST_ENDINDEX][this._CONST_COLUMN]=d,n=this._getColumnKeyForColumnIdx(d),i.startKey[this._CONST_COLUMN]=n,i.endKey[this._CONST_COLUMN]=n),a[r+=1]=i)),_=d}return a},_getSlotTemplate:function(t){if(this._IsCustomElement()&&t){var l=e.BaseCustomElementBridge.getSlotMap(this._getRootElement())[t];if(l&&l.length>0&&"template"===l[0].tagName.toLowerCase())return l[0]}return null},_getSortedTableHeaderColumnIdx:function(){for(var e=this._getTableDomUtils().getTableHeaderColumns(),l=e?e.length:0,o=0;o<l;o++)if(null!=t(e[o]).data("sorted"))return o;return null},_getTabbableElements:function(e,l){var o=null;return null!=(o=l?t(e).find(":tabbable"):t(e).find(":tabbable").not(".oj-helper-hidden-accessible"))&&o.length>0?o.toArray():null},_getTableAnimationUtils:function(){return this._tableAnimationUtils||(this._tableAnimationUtils=new e.TableAnimationUtils(this)),this._tableAnimationUtils},_getTableDndContext:function(){return this._tableDndContext||(this._tableDndContext=new e.TableDndContext(this)),this._tableDndContext},_getTableDomUtils:function(){return this._tableDomUtils||(this._tableDomUtils=new e.TableDomUtils(this)),this._tableDomUtils},_getTableResizeUtils:function(){return this._tableResizeUtils||(this._tableResizeUtils=new e.TableResizeUtils(this)),this._tableResizeUtils},_getTemplateEngine:function(){return this._templateEngine},_getTouchEventTargetElement:function(e){var t=e.originalEvent.changedTouches[0];return document.elementFromPoint(t.clientX,t.clientY)},_getVisibleRowIdxs:function(){var e=[],l=this._getTableDomUtils().getTableBody(),o=this._getTableDomUtils().getTableBodyRows();if(null!=o&&o.length>0){var i,s=t(window).height(),n=l.getBoundingClientRect();if(n.top>s)return e;var a=n.left>=0?n.left+1:n.right-1,r=n.top>=0?n.top:0,_=document.elementFromPoint(a,r),h=null;null!=_&&(h=this._getTableDomUtils().getElementRowIdx(_));var u,d,S=null!=h?h:0;if(n.bottom>s)h=null,null!=(d=document.elementFromPoint(a,s-1))&&(u=this._getTableDomUtils().getElementRowIdx(d));else{var T=parseInt(window.getComputedStyle(l).borderBottomWidth,10),c=n.bottom>=0?n.bottom-T-1:0;null!=(d=document.elementFromPoint(a,c))&&(u=this._getTableDomUtils().getElementRowIdx(d))}for(null==u&&(u=o.length-1),i=S;i<=u;i++)e.push(i)}return e},_handleContextMenuSelect:function(e,l){var o,i=(o=l?l.item:t(e.target)).attr("data-oj-command"),s=this._getTableDomUtils().getFirstAncestor(this._contextMenuEvent.target,"oj-table-column-header-cell");s=null==s?this._contextMenuEventHeaderColumn:s;var n=this._getTableDomUtils().getFirstAncestor(this._contextMenuEvent.target,"oj-table-data-cell"),a=null;if(null!=s&&(a=this._getTableDomUtils().getElementColumnIdx(s)),null!=n&&(a=this._getTableDomUtils().getElementColumnIdx(n)),null!==a)if("oj-table-sortAsc"===i)this._handleSortTableHeaderColumn(a,!0,e);else if("oj-table-sortDsc"===i)this._handleSortTableHeaderColumn(a,!1,e);else if("oj-table-enableNonContiguousSelection"===i)this._nonContiguousSelection=!0,o.attr("data-oj-command","oj-table-disableNonContiguousSelection"),o.children().first().text(this.getTranslatedString("labelDisableNonContiguousSelection"));else if("oj-table-disableNonContiguousSelection"===i)this._nonContiguousSelection=!1,o.attr("data-oj-command","oj-table-enableNonContiguousSelection"),o.children().first().text(this.getTranslatedString("labelEnableNonContiguousSelection"));else if("oj-table-resize"===i){var r=this._getTableDomUtils().getContextMenuResizePopup();r.setAttribute("data-oj-columnIdx",a);var _=s||n,h=_.getBoundingClientRect().width,u=window.getComputedStyle(_);h=h-parseFloat(u["border-left-width"])-parseFloat(u["border-right-width"]);var d,S=document.getElementById(this._getTableDomUtils().getTableId()+"_resize_popup_spinner");t(S).ojInputNumber("option","value",Math.round(h)),d=null!=s?s:null!=n?n:this.getTable(),t(r).ojPopup("open",d)}},_handleContextMenuResizePopup:function(){var e=document.getElementById(this._getTableDomUtils().getTableId()+"_resize_popup_spinner"),l=t(e).ojInputNumber("option","value"),o=this._getTableDomUtils().getContextMenuResizePopup(),i=parseInt(o.getAttribute("data-oj-columnIdx"),10);t(o).ojPopup("close");for(var s=[],n=this.options.columns.length,a=0;a<n;a++)s[a]=t.extend({},{},this.options.columns[a]);s[i].width=l,this.option("columns",s,{_context:{writeback:!0,internalSet:!0}}),this._clearCachedMetadata();var r=this;this._refresh().then(function(){r._getTableDomUtils().getTable().focus()})},_handleDataFetchStart:function(){this._setDataWaitingState()},_handleDataRefresh:function(){try{if(this._dataFetching)return;var e=this;this._queueTask(function(){e._adjustScrollPositionOnRefresh();var t=e._invokeDataFetchRows({});return e=null,t})}catch(e){_.error(e)}finally{this._clearDataWaitingState()}},_handleDataRowMutate:function(e){this._dataFetching||(null!=e.detail.remove&&this._handleDataRowRemove(e.detail.remove),null!=e.detail.add&&this._handleDataRowAdd(e.detail.add),null!=e.detail.update&&this._handleDataRowChange(e.detail.update))},_getRowsFromEventDetailAdd:function(t){var l=this._getData(),o=t[this._CONST_DATA],i=t[this._CONST_INDEXES],s=[];t[this._CONST_KEYS].forEach(function(e){s.push(e)});var n=[],a=t[this._CONST_ADDBEFOREKEYS]?t[this._CONST_ADDBEFOREKEYS]:t[this._CONST_AFTERKEYS];null!=a&&a.forEach(function(e){n.push(e)}),o instanceof Array||(o=[o]);var r=0;this._isPagingModelDataProvider()&&(r=l.getStartItemIndex());var _=null;l instanceof e.TableDataSourceAdapter&&(e.FlattenedTreeTableDataSource&&l.tableDataSource instanceof e.FlattenedTreeTableDataSource?_=l.tableDataSource:e.PagingTableDataSource&&l.tableDataSource instanceof e.PagingTableDataSource&&e.FlattenedTreeTableDataSource&&l.tableDataSource.dataSource instanceof e.FlattenedTreeTableDataSource&&(_=l.tableDataSource.dataSource));var h,u,d,S,T=[],c=null,m=this._getTableDomUtils().getTableBodyRows(),C=null!=m?m.length:0,E=o.length;for(S=0;S<E;S++)d=null!=n?n[S]:"",u=null!=(h=this._getRowIdxForRowKey(d))&&h>=0?h+r:i[S]>=0?i[S]:0===S?C:i[S-1]+1,i[S]=u;for(S=0;S<E;S++){h=i[S]-r,_&&(c=_._getMetadata(h));var D={data:o[S],metadata:c,key:s[S],index:i[S]};T.push({row:D,rowIdx:h})}return T},_handleDataRowAdd:function(e){try{this._executeTableBodyRowsAdd(e)}catch(e){_.error(e)}finally{this._clearDataWaitingState()}},_getRowsFromEventDetailChange:function(e){var t=e[this._CONST_DATA],l=[];e[this._CONST_KEYS].forEach(function(e){l.push(e)}),t instanceof Array||(t=[t]);for(var o=[],i=t.length,s=0;s<i;s++){var n=this._getRowIdxForRowKey(l[s]);if(void 0!==n){var a={data:t[s],key:l[s],index:n};o.push({row:a,rowIdx:n})}}return o},_handleDataRowChange:function(e){try{this._executeTableBodyRowsChange(e)}catch(e){_.error(e)}finally{this._clearDataWaitingState()}},_getRowsFromEventDetailRemove:function(e){var t=e[this._CONST_DATA],l=[];e[this._CONST_KEYS].forEach(function(e){l.push(e)}),t instanceof Array||(t=[t]);for(var o=[],i=t.length,s=0;s<i;s++){var n=this._getRowIdxForRowKey(l[s]);if(void 0!==n){var a={data:t[s],key:l[s],index:n};o.push({row:a,rowIdx:n})}}return o},_handleDataRowRemove:function(e){try{this._executeTableBodyRowsRemove(e)}catch(e){_.error(e)}finally{this._clearDataWaitingState()}},_handleKeydownEnd:function(e){if(!this._isTableActionableMode()){var t=this._getFocusedHeaderColumnIdx();if(null!=t&&t!==this._getColumnDefs().length-1)this._setHeaderColumnFocus(this._getColumnDefs().length-1,!0,!1,null,!1);else if(!this._hasEditableRow()){var l=this._getFocusedRowIdx(),o=this._getTableDomUtils().getTableBodyRows(),i=null!=o?o.length:0;null!=l&&l!==i-1&&i>0&&this._setRowFocus(i-1,!0,!0,null,e)}}},_handleKeydownEnter:function(e){if(!this._isTableActionableMode()){var l=this._getFocusedHeaderColumnIdx();if(null!=l&&this._getColumnDefs()[l].sortable===this._OPTION_ENABLED){var o=this._getTableDomUtils().getTableHeaderColumn(l),i=t(o).data("sorted");null==i||i===this._COLUMN_SORT_ORDER._DESCENDING?this._handleSortTableHeaderColumn(l,!0,e):this._handleSortTableHeaderColumn(l,!1,e)}else{var s=this._getCurrentRow();if((s=s||{}).rowIndex>=0)if(this._isTableEditMode()){if(!this._hasEditableRow())return void this._setTableEditable(!0,!1,0,!0,e);var n=this._getTableDomUtils().getElementColumnIdx(e.target);e[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT]?this._setPreviousRowEditable(n,e):this._setNextRowEditable(n,e)}else this._setTableActionableMode(!0)}}},_handleKeydownEsc:function(e){this._isTableEditMode()&&this._hasEditableRow()?(e.preventDefault(),e.stopPropagation(),this._setTableEditable(!1,!0,0,!0,e),this._getTableDomUtils().getTable().focus()):this._isTableActionableMode()&&(e.preventDefault(),e.stopPropagation(),this._setTableActionableMode(!1),this._getTableDomUtils().getTable().focus()),this._getTableResizeUtils().clearTableHeaderColumnsResize()},_handleKeydownF2:function(e){e.preventDefault(),e.stopPropagation(),this._isTableEditMode()?this._hasEditableRow()?this._setTableEditable(!1,!1,0,!0,e):this._setTableEditable(!0,!1,0,!0,e):this._isTableActionableMode()?this._setTableActionableMode(!1):this._setTableActionableMode(!0)},_handleKeydownHome:function(e){if(!this._isTableActionableMode()){var t=this._getFocusedHeaderColumnIdx();if(null!=t&&0!==t)this._setHeaderColumnFocus(0,!0,!1,null,!0);else if(!this._hasEditableRow()){var l=this._getFocusedRowIdx();null!=l&&0!==l&&this._setRowFocus(0,!0,!0,null,e)}}},_handleKeydownLeftRight:function(e){if(!this._isTableActionableMode()){var t=this._getFocusedHeaderColumnIdx(),l=this._getColumnDefs();if(null!=t){var o=t;if(this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_LEFT)?o=t>0?t-1:t:this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_RIGHT)&&(o=t<l.length-1?t+1:t),o!==t&&(this._setHeaderColumnFocus(o,!0,!1,null,this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_RIGHT)),e[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT])){var i=this._getHeaderColumnSelection(o);this._setHeaderColumnSelection(o,!i,null,e,!0),i&&this._getHeaderColumnSelection(t)&&this._setHeaderColumnSelection(t,!1,null,e,!0)}}}},_handleKeydownSpacebar:function(e){if(!this._isTableActionableMode()){var t=this._getFocusedRowIdx();if(null!=t)this._setRowSelection(t,!this._getRowSelection(t),null,e,!0);else if(!this._hasEditableRow()){var l=this._getFocusedHeaderColumnIdx();null!=l&&(this._clearSelectedRows(),this._setHeaderColumnSelection(l,!this._getHeaderColumnSelection(l),null,e,!0))}}},_handleKeydownTab:function(l){var o,i,s=!1,n=this._getFocusedRowIdx(),a=this._getFocusedHeaderColumnIdx();if((null!=n||null!=a)&&(this._isTableActionableMode()||this._hasEditableRow())){var r=document.activeElement,_=this._getTableDomUtils().getTableBody(),h=this._getTableDomUtils().getTableHeader();if(this._getEditableRowIdx()===n){var u=this._getTableDomUtils().getTableBodyRow(n),d=this._getTabbableElements(u),S=null!=d?d.length:0,T=t(d).index(r);if(T===S-1&&!l[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT])return this._setNextRowEditable(0,l),l.preventDefault(),void l.stopPropagation();if(0!==T||!l[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT])return;var c=this._getTableDomUtils().getTableHeaderColumns();if(c){var m=c.length;return this._setPreviousRowEditable(m-1,l),l.preventDefault(),void l.stopPropagation()}}else if(t.contains(_,r)||t.contains(h,r)){var C;if(i=null,t.contains(_,r)?i=this._getTableDomUtils().getTableBodyRow(n):t.contains(h,r)&&(i=this._getTableDomUtils().getTableHeader()),(o=this._getTabbableElements(i)).length>0){if(o.length>1){if(l[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT]){if(r===o[0])t(o[o.length-1]).focus(),l.preventDefault(),l.stopPropagation();else for(C=0;C<o.length;C++)if(r===o[C]){o[C-1].focus(),l.preventDefault(),l.stopPropagation();break}}else if(r===o[o.length-1])t(o[0]).focus(),l.preventDefault(),l.stopPropagation();else for(C=0;C<o.length;C++)if(r===o[C]){o[C+1].focus(),l.preventDefault(),l.stopPropagation();break}}else l.preventDefault(),l.stopPropagation();return}}if((null!=n&&!this._hasEditableRow()||null!=a)&&!l[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT]){if(s=!0,i=null,null!=n?i=this._getTableDomUtils().getTableBodyRow(n):null!=a&&(i=this._getTableDomUtils().getTableHeaderColumn(a)),null!=(o=this._getTabbableElements(i)))t(o[0]).focus();else if(null!=n){var E=this._getTabbableElements(_);t(E[0]).focus()}else if(null!=a){var D=this._getTabbableElements(h);t(D[0]).focus()}l.preventDefault(),l.stopPropagation()}}if(s)this._removeKeyboardKey(l.keyCode);else{this._clearKeyboardKeys(),this._clearFocusedHeaderColumn(),this._clearFocusedRow(!1),this._setTableActionableMode(!1);var b=this._getTableDomUtils().getTable(),g=this._getTabbableElements(b,!0),A=null!=g?g.length:0,R=b;if(!l[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT]&&A>0)if(this._getTableDomUtils()._isFF()){var L=this._getTableDomUtils().getTableContainer();(R=document.createElement(e.TableDomUtils.DOM_ELEMENT._A)).setAttribute(e.TableDomUtils.DOM_ATTR._TABINDEX,"0"),R.setAttribute(e.TableDomUtils.DOM_ATTR._HREF,"#"),R.classList.add(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS),L.appendChild(R),this._temporaryFocusForFF=R}else R=g[A-1];this._temporaryTableChildElementFocus=!0,R.focus();var f=this;setTimeout(function(){f._temporaryTableChildElementFocus=!1,f._temporaryFocusForFF&&(t(f._temporaryFocusForFF).remove(),f._temporaryFocusForFF=null)},0)}},_handleKeydownUpDown:function(e){if(!this._isTableActionableMode()){var t=this._getFocusedRowIdx(),l=this._getFocusedHeaderColumnIdx();if(null==t||this._hasEditableRow())null!=l&&this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_DOWN)&&this._setRowFocus(0,!0,!0,null,e);else{var o=this._getTableDomUtils().getTableBodyRows(),i=null!=o?o.length:0,s=t;if(this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_UP)?t>0?s=t-1:this._hasEditableRow()||(s=t):this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_DOWN)&&(s=t<i-1?t+1:t),s!==t){if(!this._setRowFocus(s,!0,!0,null,e))return;if(this._getTableDomUtils().getTable().focus(),e[this._KEYBOARD_CODES._KEYBOARD_MODIFIER_SHIFT]){var n=this._getRowSelection(s);this._setRowSelection(s,!n,null,e,!0),n&&this._getRowSelection(t)&&this._setRowSelection(t,!1,null,e,!0)}}else s===t&&0===t&&this._isKeyboardKeyPressed(this._KEYBOARD_CODES._KEYBOARD_CODE_UP)&&this._setHeaderColumnFocus(0,!0,!1,null,!0)}}},_handleMouseEnterSelection:function(e){var t,l=this._getTableDomUtils().getElementRowIdx(e);if(null!=l&&null!=this._mouseDownRowIdx&&this._mouseDownRowIdx!==l){var o=this._mouseDownRowIdx,i=this._getSelectedRowIdxs();if(l<o){for(t=0;t<i.length;t++)(i[t]<l||i[t]>o)&&this._setRowSelection(i[t],!1,e,null,!0);for(t=o;t>=l;t--)this._setRowSelection(t,!0,e,null,!0),this._getTableDomUtils().moveTableBodyRowTouchSelectionAffordanceTop(t)}else{for(t=0;t<i.length;t++)(i[t]>l||i[t]<o)&&this._setRowSelection(i[t],!1,e,null,!0);for(t=o;t<=l;t++)this._setRowSelection(t,!0,e,null,!0),this._getTableDomUtils().moveTableBodyRowTouchSelectionAffordanceBottom(t)}}},_handleScrollerMaxRowCount:function(){var e=this.getTranslatedString("msgScrollPolicyMaxCountSummary"),t=this.getTranslatedString("msgScrollPolicyMaxCountDetail");this._showInlineMessage(e,t,r.SEVERITY_LEVEL.WARNING)},_handleScrollerScrollLeft:function(t){this._scrollLeft=t;var l=this._getTableDomUtils().getTableHeaderRow();l&&("rtl"===this._GetReadingDirection()?l.style[e.TableDomUtils.CSS_PROP._RIGHT]="-"+t+e.TableDomUtils.CSS_VAL._PX:l.style[e.TableDomUtils.CSS_PROP._LEFT]="-"+t+e.TableDomUtils.CSS_VAL._PX);var o=this._getTableDomUtils().getTableFooterRow();o&&("rtl"===this._GetReadingDirection()?o.style[e.TableDomUtils.CSS_PROP._RIGHT]="-"+t+e.TableDomUtils.CSS_VAL._PX:o.style[e.TableDomUtils.CSS_PROP._LEFT]="-"+t+e.TableDomUtils.CSS_VAL._PX)},_handleScrollerScrollTop:function(e){this._scrollTop=e},_handleSortTableHeaderColumn:function(e,t,l){this._clearSortedHeaderColumn(e);var o=this._getColumnDefs()[e],i=null==o.sortProperty?o.field:o.sortProperty;this._invokeDataSort(i,t,l),this._sortColumn=o,this._refreshSortTableHeaderColumn(i,t)},_hasEditableRow:function(){return!!this._isTableEditMode()&&null!==this._getEditableRowIdx()},_hasRowOrCellRendererOrTemplate:function(e){if(null!=this._getRowRenderer())return!0;var t=null,l=null,o=this._getColumnDefs();if(null!=e)t=this._getColumnRenderer(e,"cell"),l=this._getSlotTemplate(o[e][this._CELL_TEMPLATE]);else for(var i=o.length,s=0;s<i&&null==(t=this._getColumnRenderer(s,"cell"))&&null==(l=this._getSlotTemplate(o[s][this._CELL_TEMPLATE]));s++);return null!=t||null!=l},_hideInlineMessage:function(){if(this._inlineMessageShown){var t=this._getTableDomUtils().getTableInlineMessage();this._getTableDomUtils().getTableContainer().classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._WARNING),t.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._WARNING),t.style[e.TableDomUtils.CSS_PROP._BOTTOM]="",t.style[e.TableDomUtils.CSS_PROP._DISPLAY]=e.TableDomUtils.CSS_VAL._NONE,this._inlineMessageShown=!1}},_hideNoDataMessage:function(){if(this._noDataMessageShown){var e=this._getTableDomUtils().getTableBodyMessageRow();null!=e&&t(e).remove(),this._noDataMessageShown=!1}},_hideStatusMessage:function(){this._showStatusTimeout&&(clearTimeout(this._showStatusTimeout),this._showStatusTimeout=null),this._statusMessageShown&&(this._getTableDomUtils().getTableStatusMessage().style[e.TableDomUtils.CSS_PROP._DISPLAY]=e.TableDomUtils.CSS_VAL._NONE,this._statusMessageShown=!1)},_hideTableHeaderColumnSortLink:function(l,o){if(this._getColumnDefs()[l].sortable===this._OPTION_ENABLED){var i=this._getTableDomUtils().getTableHeaderColumn(l),s=t(i).data("sorted");if(!o||null!=s&&s!==this._COLUMN_SORT_ORDER._DESCENDING){if(!o&&(null==s||s===this._COLUMN_SORT_ORDER._ASCENDING)){var n=i.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_LINK_CLASS);n.length>0&&((n=n[0]).classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED),n.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._ENABLED),n.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED))}}else{var a=i.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_LINK_CLASS);a.length>0&&((a=a[0]).classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED),a.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._ENABLED),a.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED))}}},_initFetch:function(t,l){t=t||{};var o=this,i=this._getData();return null==i||!e.DataProviderFeatureChecker.isDataProvider(i)||this._isPagingModelDataProvider()&&!l?null==i?this._queueTask(function(){return Promise.resolve()}):void 0:this._queueTask(function(){return o._getTableDomUtils().getScroller().scrollTop=0,i instanceof e.TableDataSourceAdapter&&(t.fetchType="init",o._isLoadMoreOnScroll()&&(t[o._CONST_OFFSET]=0)),o._invokeDataFetchRows(t,!0)})},_initTemplateEngine:function(){var e=this;this._queueTask(function(){var t;try{t=o.__getTemplateEngine().then(function(t){e._templateEngine=t},function(e){_.warn(e)})}catch(e){_.warn(e),t=Promise.resolve(null)}return t})},_invokeDataFetchRows:function(t,l){!(t=t||{})[this._CONST_PAGESIZE]&&this._isLoadMoreOnScroll()?t[this._CONST_PAGESIZE]=this.options.scrollPolicyOptions.fetchSize:t[this._CONST_PAGESIZE]=-1;var o=this._getData();if(null!=o){var i=this;return new Promise(function(s){i._noMoreData=!1,i._setDataWaitingState(),i._dataProviderAsyncIterator=o.fetchFirst(t)[Symbol.asyncIterator](),i._dataProviderAsyncIterator.next().then(function(t){var n=t[i._CONST_VALUE],a=n[i._CONST_DATA],r=n.metadata.map(function(e){return e[i._CONST_KEY]}),_=0;o instanceof e.TableDataSourceAdapter&&(_=o[i._CONST_OFFSET]);var h=0;i._isPagingModelDataProvider()&&(h=o.getStartItemIndex());for(var u=[],d=a.length,S=0;S<d;S++)u[S]=_+h+S;null!=i._domScroller&&i._domScroller.destroy(),i._refreshAll({data:a,metadata:[],keys:r,indexes:u},_,l,l).then(function(){i._clearDataWaitingState(),i._processFetchSort(n),i._isLoadMoreOnScroll()&&i._registerDomScroller(),i=null,s(t)})},function(){i._clearDataWaitingState();var e=i._getTableDomUtils().getTableBodyRows();null!=e&&0!==e.length||i._showNoDataMessage(),s(null)})})}return Promise.resolve(null)},_invokeDataSort:function(e,t,l){if(this._getData()){this._showStatusMessage();var o=[],i={};i[this._CONST_ATTRIBUTE]=e,i.direction=t?this._COLUMN_SORT_ORDER._ASCENDING:this._COLUMN_SORT_ORDER._DESCENDING,o.push(i),this._trigger("sort",l,{header:o[0][this._CONST_ATTRIBUTE],direction:o[0].direction}),this._adjustScrollPositionOnRefresh(),this._initFetch({sortCriteria:o},!0)}},_isColumnMetadataUpdated:function(){if(null!=this._columnDefArray){var e=this._getColumnMetadata();if(this._columnDefArray.length!==e.length)return!0;for(var t=e.length,l=0;l<t;l++)for(var o=Object.keys(e[l]),i=0;i<o.length;i++){var s=o[i];if(e[l][s]!==this._columnDefArray[l][s]&&("id"!==s||null==e[l][s]||0!==e[l][s].indexOf(this._COLUMN_HEADER_ID_PREFIX)||null==this._columnDefArray[l][s]||0!==this._columnDefArray[l][s].indexOf(this._COLUMN_HEADER_ID_PREFIX)))return!0}return!1}return!0},_isKeyboardKeyPressed:function(e){for(var t=this._getKeyboardKeys(),l=t.length,o=0;o<l;o++)if(t[o]===e)return!0;return!1},_isLoadMoreOnScroll:function(){return this.options.scrollPolicy===this._OPTION_SCROLL_POLICY._LOADMORE_ON_SCROLL},_isNodeEditable:function(e){return this._isNodeType(e,/^INPUT|TEXTAREA/)},_isNodeClickable:function(e){return this._isNodeType(e,/SELECT|OPTION|BUTTON|^A\b/)},_isNodeDraggable:function(e){return t(e).closest("[draggable='true']").length>0},_isNodeType:function(t,l){for(var o=this._getTableDomUtils().getTable();null!=t&&t!==o;){var i=t.nodeName;if(i===e.TableDomUtils.DOM_ELEMENT._TD||i===e.TableDomUtils.DOM_ELEMENT._TH)break;if(3!==t.nodeType&&i.match(l)&&-1!==t.getAttribute(e.TableDomUtils.DOM_ATTR._TABINDEX))return!0;t=t.parentNode}return!1},_isPagingModelDataProvider:function(){var e=this._getData();return null!=e.getStartItemIndex&&null!==e.getStartItemIndex()&&e.getStartItemIndex()>=0},_isStatusMessageShown:function(){return this._statusMessageShown},_isTableActionableMode:function(){return this._tableActionableMode},_isTableEditMode:function(){return this.options.editMode===this._OPTION_EDIT_MODE._ROW_EDIT},_isTableFooterless:function(){for(var e=this._getColumnDefs(),t=e.length,l=0;l<t;l++){var o=this._getColumnRenderer(l,"footer"),i=this._getSlotTemplate(e[l][this._FOOTER_TEMPLATE]);if(null!=o)return!1;if(null!=i)return!1}return!0},_isTableHeaderless:function(){for(var e=this._getColumnDefs(),t=e.length,l=0;l<t;l++){var o=this._getSlotTemplate(e[l][this._HEADER_TEMPLATE]);if(null!=e[l].headerText||null!=e[l].headerStyle||null!=e[l].sortable&&e[l].sortable!==this._OPTION_DISABLED||null!=e[l].sortProperty||null!=e[l].headerRenderer||null!=o)return!1}return!0},_isTableHeaderColumnsRendered:function(){return!0===this._renderedTableHeaderColumns},_isTableRefreshNeeded:function(l,o){var i=this._cachedOptions,s=!1;return"contextMenu"===l&&o==="#"+this._getTableDomUtils().getTableId()+"_contextmenu"?s=!1:"columns"!==l||this._isColumnMetadataUpdated()?"selection"===l||"currentRow"===l||e.Object.compareValues(o,i[l])||(s=!0):s=!1,this._cachedOptions=t.extend(!0,{},this.options),s},_isTableSortable:function(){for(var e=this._getColumnDefs(),t=e.length,l=0;l<t;l++)if(e[l].sortable===this._OPTION_ENABLED)return!0;return!1},_isTableColumnsResizable:function(){for(var e=this._getColumnDefs(),t=e.length,l=0;l<t;l++)if(e[l].resizable===this._OPTION_ENABLED)return!0;return!1},_isTableColumnsWidthSet:function(){for(var e=this._getColumnDefs(),t=e.length,l=0;l<t;l++)if(null!==e[l].width)return!0;return!1},_isTouchDevice:function(){if(null==this._isTouch){var e=navigator.userAgent.toLowerCase();-1!==e.indexOf("mobile")||-1!==e.indexOf("android")?this._isTouch=!0:this._isTouch=!1}return this._isTouch},_processFetchSort:function(t){try{var l=this,o=t.fetchParameters,i=this._getColumnDefs(),s=o[this._CONST_SORTCRITERIA];if(null!=s&&s.length>0){var n=s[0];this._refreshSortTableHeaderColumn(n.attribute,n.direction===this._COLUMN_SORT_ORDER._ASCENDING);var a=this.options.selection;if(null!=a){var r=!1;if(a.length>1)r=!0;else if(null!=a[0]){var h=a[0][this._CONST_STARTINDEX],u=a[0][this._CONST_ENDINDEX];e.Object.compareValues(h,u)||null==u||(r=!0)}r&&(this._setSelection(null),this.option("selection",[],{_context:{writeback:!0,internalSet:!0}}))}this._setCurrentRow(this.options.currentRow,null,!1);for(var d=null,S=i.length,T=0;T<S;T++){var c=i[T],m=null==c.sortProperty?c.field:c.sortProperty;if(n.attribute===m){d=T;break}}null!=d&&setTimeout(function(){l._scrollColumnIntoViewport(d),l=null,d=null},0)}else this._clearSortedHeaderColumn()}catch(e){_.error(e)}},_processSlottedChildren:function(){var l=this._getTableDomUtils().getTableBottomSlot();null!=l&&t(l).remove();for(var o=e.BaseCustomElementBridge.getSlotMap(this._getRootElement()),i=Object.keys(o),s=0;s<i.length;s++){var n=i[s];if("bottom"===n){var a=o[n];if(null!=a){l=this._getTableDomUtils().createTableBottomSlot();for(var r=0;r<a.length;r++)l.appendChild(a[r])}}}},_refreshAll:function(t,l,o,i){if((this._isColumnMetadataUpdated()||!this._isTableHeaderColumnsRendered()&&!this._isTableHeaderless())&&(this._clearCachedMetadata(),this._refreshTableHeader(),null!=this._sortColumn)){var s=!1,n=this._getColumnDefs();if(null!=n){for(var a=n.length,r=0;r<a;r++){var _=n[r];if(e.Object.compareValues(_,this._sortColumn)){s=!0;break}}s||this._initFetch(null,!0)}}return this._clearCachedDimensions(),this._refreshTableFooter(),this._refreshTableBody(t,l,o,i)},_refreshSortTableHeaderColumn:function(l,o){for(var i,s,n=this._getColumnDefs(),a=null,r=n.length,_=0;_<r;_++){var h=n[_];if(l===(null==h.sortProperty?h.field:h.sortProperty)){a=_;break}}if(null!=a){this._clearSortedHeaderColumn(a);var u=this._getTableDomUtils().getTableHeaderColumn(a);if(null!=u){var d=t(u).data("sorted");if(o&&d!==this._COLUMN_SORT_ORDER._ASCENDING){t(u).data("sorted",this._COLUMN_SORT_ORDER._ASCENDING);var S=u.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_LINK_CLASS);S.length>0&&((S=S[0]).classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._ENABLED),S.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED)),(i=u.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_CLASS)).length>0&&(i=i[0]).classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED),(s=u.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_CLASS)).length>0&&(s=s[0]).classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED),this._hideTableHeaderColumnSortLink(a,!o)}else if(!o&&d!==this._COLUMN_SORT_ORDER._DESCENDING){t(u).data("sorted",this._COLUMN_SORT_ORDER._DESCENDING);var T=u.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_LINK_CLASS);T.length>0&&((T=T[0]).classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._ENABLED),T.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED)),(s=u.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_CLASS)).length>0&&(s=s[0]).classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED),(i=u.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_CLASS)).length>0&&(i=i[0]).classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED)}}}},_refreshTableBody:function(e,l,o,i){var s=this._getTableDomUtils().getTableBody();if(null==s)return Promise.resolve();var a,r,_,h=this._getRowIdxRowArray(e,l),u=t.contains(s,document.activeElement),d=!1;if(0===l)u&&(d=!0),this._getTableDomUtils().removeAllTableBodyRows();else if(null!=(a=this._getTableDomUtils().getTableBodyRows())&&a.length>0)for(_=a.length-1;_>=l;_--)u&&null!=(r=this._getTableDomUtils().getTableBodyRow(_))&&t.contains(r,document.activeElement)&&(d=!0,u=!1),this._getTableDomUtils().removeTableBodyRow(_);if(d&&this._getTableDomUtils().getTable().focus(),this._getTableDomUtils().clearCachedDomRowData(),this._hideNoDataMessage(),a=s.children,0!==h.length||null!=a&&0!==a.length){var S=document.createDocumentFragment(),T=h.length;for(_=0;_<T;_++){var c=h[_].row,m=h[_].rowIdx;null!=c&&(r=this._getTableDomUtils().createTableBodyRow(m,c[this._CONST_KEY]),this._getTableDomUtils().styleTableBodyRow(r,!0),this._getTableDomUtils().insertTableBodyRow(m,r,c,S),this._refreshTableBodyRow(m,c,r,S,l,!0))}return s.appendChild(S),this._getTableDomUtils().clearCachedDomRowData(),this._getTableDomUtils().refreshTableDimensions(null,null,o,i,!0),this._hasRowOrCellRendererOrTemplate()&&n.subtreeAttached(s),s.rows.length>1&&(this._rowHeight=s.rows[1].offsetHeight),this._waitForAllComponentsToResolve(s)}return this._showNoDataMessage(),Promise.resolve()},_refreshTableBodyRow:function(l,o,i,s,n,a){var r=this._getRowRenderer(),h=this._getTableDomUtils().getTableBody();(isNaN(l)||l<0)&&_.error("Error: Invalid rowIdx value: "+l);var u=this._getTableDomUtils().hashCode(o[this._CONST_KEY]);if(null==i){if(!(i=this._getTableDomUtils().getTableBodyRow(l)))return null;t(i).empty(),this._getTableDomUtils().createTableBodyCellAccSelect(l,o[this._CONST_KEY],u,i,!0)}this._hideNoDataMessage();var d=this._getCurrentRow();d=d||{};var S=e.TableRendererUtils.getRendererContextObject(this,i,{row:o,isCurrentRow:d.rowIndex===l}),T={rowContext:S,row:o[this._CONST_DATA],componentElement:S.componentElement,parentElement:S.parentElement,data:o[this._CONST_DATA]};if(null!=r){var c=r(T);null!=c?i.appendChild(c):(null==s?i=h.children[l]:(n=null==n?0:n,i=s.children?s.children[l-n]:t(s).children()[l-n]),this._getTableDomUtils().clearCachedDomRowData(),this._getTableDomUtils().setTableBodyRowAttributes(o,i),this._getTableDomUtils().styleTableBodyRow(i,!1)),this._getTableDomUtils().createTableBodyCellAccSelect(l,o[this._CONST_KEY],u,i,!1);var m,C,E=i.getElementsByTagName(e.TableDomUtils.DOM_ELEMENT._TD),D=E.length;for(m=1;m<D;m++)C=E[m],this._getTableDomUtils().setTableBodyCellAttributes(l,o[this._CONST_KEY],u,m-1,C),this._getTableDomUtils().styleTableBodyCell(m-1,C,!1);if(null!=this._columnsDestMap)for(m=0;m<this._columnsDestMap.length-1;m++)if(this._columnsDestMap[m]>m){var b=E[this._columnsDestMap[m]+1],g=E[m+1];b.parentNode.insertBefore(b,g),E=i.getElementsByTagName(e.TableDomUtils.DOM_ELEMENT._TD)}}else e.TableRendererUtils.tableBodyRowDefaultRenderer(this,l,o,T);return i},_refreshTableFooter:function(){var l=this._getColumnDefs(),o=this._getTableDomUtils().getTableFooter();if(!o){if(this._isTableFooterless())return;o=this._getTableDomUtils().createTableFooter(),this._getTableDomUtils().styleTableFooter(o)}var i=this._getTableDomUtils().getTableFooterRow();if(this._hasFooterTemplate&&(this._cleanTemplateNodes(i),this._hasFooterTemplate=!1),t(i).empty(),l&&l.length>0){this._getTableDomUtils().createTableFooterAccSelect(i);for(var s=l.length,n=0;n<s;n++){var a=l[n],r=this._getColumnRenderer(n,"footer"),_=this._getTableDomUtils().createTableFooterCell(n,this._getColumnSelectionMode());if(this._getTableDomUtils().styleTableFooterCell(n,_),this._getTableDomUtils().insertTableFooterCell(n,_),r){var h=e.TableRendererUtils.getRendererContextObject(this,_,{}),u=r({footerContext:h,columnIndex:n,componentElement:h.componentElement,parentElement:h.parentElement});null!=u?(_.empty(),_.appendChild(u)):(_=t(i).children(":not(."+e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS+")")[n],this._getTableDomUtils().styleTableFooterCell(n,_,this._getColumnSelectionMode()))}else{var d=this._getSlotTemplate(a[this._FOOTER_TEMPLATE]);if(d){var S=this._getRootElement(),T=this._getTemplateEngine();if(null!=T){var c=e.TableRendererUtils.getSlotTemplateContextObject(this),m=T.execute(S,d,c,this.options.as);m instanceof Array||(m=[m]),m.map(function(e){_.appendChild(e)}),this._hasFooterTemplate=!0}}}}}},_refreshTableHeader:function(){var l=this,o=this._getColumnDefs(),i=this._getTableDomUtils().getTableHeader();if(!i){if(this._isTableHeaderless())return;i=this._getTableDomUtils().createTableHeader(),this._getTableDomUtils().styleTableHeader(i)}var s=this._getTableDomUtils().getTableHeaderRow();if(this._unregisterChildStateListeners(s),this._hasHeaderTemplate&&(this._cleanTemplateNodes(s),this._hasHeaderTemplate=!1),t(s).empty(),o&&o.length>0){var n=this._getTableDomUtils().createTableHeaderAccSelectRowColumn();s.appendChild(n);for(var a=o.length,r=0;r<a;r++){var _=o[r],h=this._getColumnRenderer(r,"header"),u=this._getTableDomUtils().createTableHeaderColumn(r,this._getColumnSelectionMode());if(h){var d=e.TableRendererUtils.getRendererContextObject(this,u,{}),S={headerContext:d,columnIndex:r,data:_.headerText,componentElement:d.componentElement,parentElement:d.parentElement};_.sortable===e.TableDomUtils._OPTION_ENABLED?S.columnHeaderSortableIconRenderer=function(t,o){e.TableRendererUtils.columnHeaderSortableIconRenderer(l,this,t,o)}:S.columnHeaderDefaultRenderer=function(t,o){e.TableRendererUtils.columnHeaderDefaultRenderer(l,this,t,o)};var T=h(S);null!=T?(t(u).empty(),t(u).append(T)):(u=t(s).children(":not(."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ACC_SELECT_ROW_CLASS+")")[r],this._getTableDomUtils().setTableHeaderColumnAttributes(r,u),this._getTableDomUtils().styleTableHeaderColumn(r,u,this._getColumnSelectionMode(),!1))}else{var c=this._getSlotTemplate(_[this._HEADER_TEMPLATE]);if(c){var m=this._getRootElement(),C=this._getTemplateEngine();if(null!=C){u&&t(u).empty();var E=e.TableRendererUtils.getHeaderSlotTemplateContextObject(this,_.headerText,r),D=C.execute(m,c,E,this.options.as);D instanceof Array||(D=[D]),D.map(function(e){u.appendChild(e)}),this._hasHeaderTemplate=!0}}}this._getTableDomUtils().createTableHeaderColumnAccSelect(r,this._getColumnSelectionMode())}this._renderedTableHeaderColumns=!0}},_refreshTableStatusMessage:function(){var e=this._getTableDomUtils().getTableStatusMessage();null!=e&&t(e).remove(),this._getTableDomUtils().createTableStatusMessage()},_registerCustomEvents:function(){var e=t.event.special;e.ojtablebeforecurrentrow={handle:function(e){return e.handleObj.handler.apply(this,[e,arguments[1]])}},e.ojtablesort={handle:function(e){return e.handleObj.handler.apply(this,[e,arguments[1]])}}},_registerDataSourceEventListeners:function(){var e=this._getData();if(null!=e){this._unregisterDataSourceEventListeners(),this._dataProviderEventHandlers=[],this._dataProviderEventHandlers.push({eventType:"mutate",eventHandler:this._handleDataRowMutate.bind(this)}),this._dataProviderEventHandlers.push({eventType:"refresh",eventHandler:this._handleDataRefresh.bind(this)});for(var t=this._dataProviderEventHandlers.length,l=0;l<t;l++){var o=e.addEventListener(this._dataProviderEventHandlers[l].eventType,this._dataProviderEventHandlers[l].eventHandler);o&&(this._dataProviderEventHandlers[l].eventHandler=o)}}},_registerDomEventListeners:function(){var e=this._getTableDomUtils().getScroller();null!=e&&(null==this._scrollEventListener&&(this._scrollEventListener=function(e){this._handleScrollerScrollLeft(this._getTableDomUtils().getScrollLeft(e.target)),this._handleScrollerScrollTop(e.target.scrollTop);var t=this;t._skipScrollUpdate||t._ticking||(window.requestAnimationFrame(function(){t.option("scrollPosition",t._getCurrentScrollPosition(),{_context:{originalEvent:e,internalSet:!0}}),t._ticking=!1}),this._ticking=!0),this._skipScrollUpdate=!1}.bind(this)),t(e).off("scroll",this._scrollEventListener),t(e).on("scroll",this._scrollEventListener))},_registerDomScroller:function(){var t=this;null!=this._domScroller&&this._domScroller.destroy(),this._domScrollerSuccessFunc=function(e){if(t._clearDataWaitingState(),null!=e)if(t._noMoreData=!1,e.maxCountLimit)t._noMoreData=!0,e.maxCountLimit&&t._handleScrollerMaxRowCount(),t._syncScrollPosition();else{var l=e[t._CONST_VALUE],o=l[t._CONST_DATA],i=l.metadata.map(function(e){return e[t._CONST_KEY]});i=i.filter(function(e,l){return null===t._getRowIdxForRowKey(e)||(o.splice(l,1),!1)}),t._queueTask(function(){for(var l=this._getTableDomUtils().getTableBodyRows(),s=null!=l?l.length:0,n=[],a=0;a<o.length;a++)n[a]=s+a;return t._refreshAll({data:o,keys:i,indexes:n},s).then(function(){e.done&&(t._noMoreData=!0,t._syncScrollPosition())})})}else t._syncScrollPosition()};var l=this._getTableDomUtils().getTableBodyRows(),o=null!=l?l.length:0;this._domScroller=new e.DomScroller(this._getTableDomUtils().getScroller(),this._getData(),{asyncIterator:this._dataProviderAsyncIterator,fetchSize:this.options.scrollPolicyOptions.fetchSize,maxCount:this.options.scrollPolicyOptions.maxCount,initialRowCount:o,success:this._domScrollerSuccessFunc.bind(this),request:this._handleDataFetchStart.bind(this),fetchTrigger:1})},_registerResizeListener:function(){var o=this._getTableDomUtils().getTableContainer();if(!this._resizeListener){var i=this;this._resizeListener=function(){l.getContext(i.element[0]).getBusyContext().whenReady().then(function(){i._clearCachedDimensions();var e=t(i._getTableDomUtils().getTableContainer()).outerHeight(),l=t(i._getTableDomUtils().getTableContainer()).outerWidth();i._getTableDomUtils().refreshTableDimensions(l,e)})}}this._isResizeListenerAdded||(e.DomUtils.addResizeListener(o,this._resizeListener,50),this._isResizeListenerAdded=!0)},_removeKeyboardKey:function(e){for(var t=this._getKeyboardKeys(),l=t.length,o=0;o<l;o++)t[o]===e&&t.splice(o,1)},_scrollColumnIntoViewport:function(e){var l,o="rtl"===this._GetReadingDirection(),i=this._getTableDomUtils().getTableBody(),s=this._getTableDomUtils().getTableHeaderColumn(e);if(s){var n=this._getTableDomUtils().getScrollbarWidth(),a=s.getBoundingClientRect(),r=i.getBoundingClientRect(),_=!1;o?(a.left<r.left+n&&(l=r.left-a.left+n,this._getTableDomUtils()._isIE()||(l*=-1),t(i).scrollLeft(t(i).scrollLeft()+l),_=!0),a.right>r.right&&!_&&(l=a.right-r.right,this._getTableDomUtils()._isIE()||(l*=-1),t(i).scrollLeft(t(i).scrollLeft()-l))):(a.left<r.left&&(l=r.left-a.left,t(i).scrollLeft(t(i).scrollLeft()-l),_=!0),a.right>r.right-n&&!_&&(l=a.right-r.right+n,t(i).scrollLeft(t(i).scrollLeft()+l)))}},_scrollRowIntoViewport:function(e){var l,o=this._getTableDomUtils().getTableBodyRow(e),i=this._getTableDomUtils().getScrollbarHeight(),s=o.getBoundingClientRect(),n=this._getTableDomUtils().getScroller(),a=n.getBoundingClientRect(),r=!1;s.bottom>a.bottom-i&&(l=s.bottom-a.bottom+i,t(n).scrollTop(t(n).scrollTop()+l),r=!0),s.top<a.top&&!r&&(l=a.top-s.top,t(n).scrollTop(t(n).scrollTop()-l))},_setCurrentRow:function(t,l,o){var s,n,a,r,h,u,d,S,T=this._currentRow,c=!0,m=this;if(null==t){if(null!=T){try{c=this._trigger("beforeCurrentRow",l,{currentRow:null,previousCurrentRow:this._currentRow})}catch(e){return h=this._LOGGER_MSG._ERR_PRECURRENTROW_ERROR_SUMMARY,u=i.applyParameters(this._LOGGER_MSG._ERR_PRECURRENTROW_ERROR_DETAIL,{error:e.toString()}),_.info(h+"\n"+u),!1}if(!c)return!1;if(n=T.rowIndex,a=this._getRowKeyForDataSourceRowIndex(n),r=this._getRowIdxForRowKey(a),!1===this._setTableEditable(!1,!1,0,!0,l))return this._currentRow=T,d=document.activeElement,S=this._getTableDomUtils().getElementColumnIdx(d),this._queueTask(function(){var e=r,t=S;null!=e&&null!=t?setTimeout(function(){m._setCellFocus(e,t)},0):null!=e&&setTimeout(function(){m._setRowFocus(e,!0,!1,null,null)},0)}),!1;this._currentRow=null,this.option("currentRow",null,{_context:{writeback:!0,originalEvent:l,internalSet:!0}}),null==l&&this._setRowFocus(-1,!0,!1,null,l),null!=(s=this._getTableDomUtils().getTableBodyRow(r))&&s.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CURRENT_ROW_CLASS)}return!0}var C=this._getData(),E=t.rowIndex,D=t.rowKey;null==D&&(D=this._getRowKeyForDataSourceRowIndex(E)),E=this._getDataSourceRowIndexForRowKey(D);var b=this._getRowIdxForRowKey(D);if(t={rowIndex:E,rowKey:D},-1!==b&&(!C||b<-1||null===b||null===D)){if(h=this._LOGGER_MSG._ERR_CURRENTROW_UNAVAILABLE_INDEX_SUMMARY,u=i.applyParameters(this._LOGGER_MSG._ERR_CURRENTROW_UNAVAILABLE_INDEX_DETAIL,{rowIdx:b}),o)throw new Error(h+"\n"+u);return _.info(h+"\n"+u),!1}var g=this._getFocusedRowIdx(),A=!e.Object.compareValues(this._currentRow,t);if(A){try{c=this._trigger("beforeCurrentRow",l,{currentRow:{rowIndex:E,rowKey:D},previousCurrentRow:this._currentRow})}catch(e){return h=this._LOGGER_MSG._ERR_PRECURRENTROW_ERROR_SUMMARY,u=i.applyParameters(this._LOGGER_MSG._ERR_PRECURRENTROW_ERROR_DETAIL,{error:e.toString()}),_.info(h+"\n"+u),!1}if(!c)return!1;if(this._currentRow={rowIndex:E,rowKey:D},null!=T&&(n=T.rowIndex,a=this._getRowKeyForDataSourceRowIndex(n),r=this._getRowIdxForRowKey(a)),!1===this._setTableEditable(!1,!1,0,!0,l))return this._currentRow=T,d=document.activeElement,S=this._getTableDomUtils().getElementColumnIdx(d),this._queueTask(function(){var e=r,t=S;null!=e&&null!=t?setTimeout(function(){m._setCellFocus(e,t)},0):null!=e&&setTimeout(function(){m._setRowFocus(e,!0,!1,null,null)},0)}),!1;this.option("currentRow",this._currentRow,{_context:{writeback:!0,originalEvent:l,internalSet:!0}}),null!=(s=this._getTableDomUtils().getTableBodyRow(b))&&s.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CURRENT_ROW_CLASS),null!=T&&null!=(s=this._getTableDomUtils().getTableBodyRow(r))&&s.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CURRENT_ROW_CLASS)}return(A||g!==t.rowIndex)&&null==l&&this._setRowFocus(b,!0,!1,null,l),!0},_setDataWaitingState:function(){this._showStatusMessage(),this._hideNoDataMessage(),this._dataFetching=!0,this._dataResolveFunc||(this._dataResolveFunc=this._addComponentBusyState("is waiting for data."))},_setCellFocus:function(e,l){var o=this._getTableDomUtils().getTableBodyCell(e,l);if(!o)return!1;for(var i=!1,s=o.querySelectorAll("*"),n=0;n<s.length;n++)i||t(s[n]).is(":focusable")&&(t(s[n]).focus(),i=t(s[n]).is(":focus")||s[n]===document.activeElement);return i},_setCellInRowFocus:function(e,t,l){if(!this._setCellFocus(e,t)){var o=this._getTableDomUtils().getTableBodyCells(e);if(o)for(var i=o.length,s=0;s<i;s++){var n=s;if(l||(n=i-s-1),this._setCellFocus(e,n))return}}},_setComponentNotReady:function(){this._readyResolveFunc||(this._readyResolveFunc=this._addComponentBusyState("is being loaded."))},_setComponentReady:function(){this._readyResolveFunc&&(this._readyResolveFunc(),this._readyResolveFunc=null)},_setEditableRowIdx:function(e){this._editableRowKey=this._getRowKeyForRowIdx(e),this._editableRowIdx=e},_setFocusInHandler:function(e){this._focusInHandler=e},_setFocusOutHandler:function(e){this._focusOutHandler=e},_setHeaderColumnFocus:function(e,t,l,o,i){var s,n=null;if(null!=o&&(n=this._getEventTargetElement(o)),t){this._clearFocusedRow(!0),l&&this._clearSelectedRows();var a=this._getFocusedHeaderColumnIdx(),r=this._getColumnDefs();if(null!==i)if(i){for(;e<=r.length-1&&!((s=this._getTableDomUtils().getTableHeaderColumn(e))&&s.clientWidth>0);)e+=1;e>r.length-1&&(e=null!==a?a:r.length-1)}else{for(;e>=0&&!((s=this._getTableDomUtils().getTableHeaderColumn(e))&&s.clientWidth>0);)e-=1;e<0&&(e=null!==a?a:0)}null!==a&&a!==e&&this._setHeaderColumnFocus(a,!1,!1,o,null),this._scrollColumnIntoViewport(e),this._activeColumnIndex=e}this._setHeaderColumnState(e,{focused:t},n)},_setHeaderColumnSelection:function(t,l,o,i,s,n){if(this._getColumnSelectionMode()===this._OPTION_SELECTION_MODES._SINGLE||this._getColumnSelectionMode()===this._OPTION_SELECTION_MODES._MULTIPLE){if((isNaN(t)||t<0)&&_.error("Error: Invalid column selection value: "+t),!n&&"true"===String(this.options.selectionRequired).toLowerCase()&&!l){var a=this._getSelectedHeaderColumnIdxs();if(null!=a&&1===a.length)return}this._getColumnSelectionMode()===this._OPTION_SELECTION_MODES._SINGLE&&l&&this._clearSelectedHeaderColumns(),this._setHeaderColumnState(t,{selected:l},o,i),this._setLastHeaderColumnSelection(t,l),this._getTableDomUtils().getTableHeaderColumnAccSelect(t).getElementsByClassName(e.TableDomUtils.CSS_CLASSES._CHECKBOX_ACC_SELECT_COLUMN_CLASS)[0].checked=l}if(s){var r=this._getSelection();this.option("selection",r,{_context:{writeback:!0,internalSet:!0}}),l&&this.option("firstSelectedRow",{key:null,data:null},{_context:{writeback:!0,internalSet:!0}})}},_setHeaderColumnState:function(l,o,i,s){var n=this._getTableDomUtils().getTableHeaderColumn(l);if(n){var a=o.focused,r=o.selected;null!=r&&n.classList.contains(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)!==r&&(r?n.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED):n.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)),null!=a&&(a?(this._focusInHandler(t(n)),this._showTableHeaderColumnSortLink(l)):(this._focusOutHandler(t(n)),this._hideTableHeaderColumnSortLink(l,!0),this._hideTableHeaderColumnSortLink(l,!1))),this._updateHeaderColumnStateCellsClass(l)}},_setLastHeaderColumnSelection:function(e,t){this._lastSelectedColumnIdxArray||(this._lastSelectedColumnIdxArray=[]);for(var l=this._lastSelectedColumnIdxArray.length,o=0;o<l;o++)if(this._lastSelectedColumnIdxArray[o]===e){this._lastSelectedColumnIdxArray.splice(o,1);break}t&&this._lastSelectedColumnIdxArray.push(e)},_setLastRowSelection:function(e,t){this._lastSelectedRowIdxArray||(this._lastSelectedRowIdxArray=[]);for(var l=this._lastSelectedRowIdxArray.length,o=0;o<l;o++)if(this._lastSelectedRowIdxArray[o]===e){this._lastSelectedRowIdxArray.splice(o,1);break}t&&this._lastSelectedRowIdxArray.push(e)},_setNextRowEditable:function(e,t){var l=this._getTableDomUtils().getTableBodyRows(),o=null!=l?l.length:0,i=this._getEditableRowIdx();i>=0&&i<o-1?(this._setTableEditable(!1,!1,e,!0,t),this._setCurrentRow({rowIndex:i+1},t,!1),this._setTableEditable(!0,!1,e,!0,t)):i===o-1&&(this._setTableEditable(!1,!1,e,!0,t),this._getTableDomUtils().getTable().focus())},_setPreviousRowEditable:function(e,t){var l=this._getEditableRowIdx();l>=1?(this._setTableEditable(!1,!1,e,!1,t),this._setCurrentRow({rowIndex:l-1},t,!1),this._setTableEditable(!0,!1,e,!1,t)):0===l&&(this._setTableEditable(!1,!1,e,!1,t),this._getTableDomUtils().getTable().focus())},_setRowFocus:function(e,l,o,i,s){var n;if(-1===e)return null!=(n=this._getFocusedRowIdx())&&this._setRowFocus(n,!1,o,null,null),!(o&&!this._setCurrentRow(null,s,!1));var a=this._getTableDomUtils().getTableBodyRow(e);if(!a)return!1;if(l){if(null!=(n=this._getFocusedRowIdx())&&n!==e&&this._setRowFocus(n,!1,o,i,null),o){var r=this._getRowKeyForRowIdx(e);if(!this._setCurrentRow({rowKey:r},s,!1))return!1}this._focusInHandler(t(a)),this._scrollRowIntoViewport(e),this._updateRowStateCellsClass(e,{focused:!0,hover:!1}),this._clearFocusedHeaderColumn(),this._clearSelectedHeaderColumns(),this._setTableActionableMode(!1)}else this._focusOutHandler(t(a)),this._updateRowStateCellsClass(e,{focused:!1});return!0},_setRowSelection:function(t,l,o,i,s,n){if(this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._SINGLE||this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._MULTIPLE){if((isNaN(t)||t<0)&&_.error("Error: Invalid row selection value: "+t),!n&&"true"===String(this.options.selectionRequired).toLowerCase()&&!l){var a=this._getSelectedRowIdxs();if(null!=a&&1===a.length)return}this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._SINGLE&&l&&this._clearSelectedRows();var r=this._getTableDomUtils().getTableBodyRow(t);if(null!=r){var h=!1;if(r.classList.contains(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)!==l){l?r.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED):r.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED),h=!0;var u=this.options.dnd.drag;u&&("rows"===u||u.rows)&&(r.draggable=l)}if(h&&(l?this._updateRowStateCellsClass(t,{hover:!1,focused:!1,selected:!0}):this._updateRowStateCellsClass(t,{selected:!1})),this._setLastRowSelection(t,l),this._getTableDomUtils().getTableBodyCellAccSelect(r).getElementsByClassName(e.TableDomUtils.CSS_CLASSES._CHECKBOX_ACC_SELECT_ROW_CLASS)[0].checked=l,s){var d=this._getSelection();if(this.option("selection",d,{_context:{writeback:!0,internalSet:!0}}),null!=d&&d.length>0){var S=d[0].startKey;if(null!=S&&null!=S[this._CONST_ROW]){var T=this.getDataForVisibleRow(this._getRowIdxForRowKey(S[this._CONST_ROW]));if(T)return void this.option("firstSelectedRow",{key:T[this._CONST_KEY],data:T[this._CONST_DATA]},{_context:{writeback:!0,internalSet:!0}})}}this.option("firstSelectedRow",{key:null,data:null},{_context:{writeback:!0,internalSet:!0}})}}}},_setSelection:function(e){if(null==e)return this._clearSelectedRows(),void this._clearSelectedHeaderColumns();for(var t,l=e.length,o=0;o<l;o++){var i=e[o];if(null==i.startKey&&null==i[this._CONST_STARTINDEX]||null==i.endKey&&null==i[this._CONST_ENDINDEX])return void _.error("Error: Invalid range object in selection. Both start and end objects must be specified");var s=null,n=null,a=null,r=null,h=null,u=null,d=null,S=null,T=!1;if(null!=i.startKey&&null!=i.startKey[this._CONST_ROW]&&(a=this._getDataSourceRowIndexForRowKey(i.startKey[this._CONST_ROW]),null!=i[this._CONST_STARTINDEX]&&null!=i[this._CONST_STARTINDEX][this._CONST_ROW]&&a!==i[this._CONST_STARTINDEX][this._CONST_ROW]&&(T=!0)),null!=i.endKey&&null!=i.endKey[this._CONST_ROW]&&(r=this._getDataSourceRowIndexForRowKey(i.endKey[this._CONST_ROW]),null!=i[this._CONST_ENDINDEX]&&null!=i[this._CONST_ENDINDEX][this._CONST_ROW]&&r!==i[this._CONST_ENDINDEX][this._CONST_ROW]&&(T=!0)),null!=i.startKey&&null!=i.startKey[this._CONST_COLUMN]&&(d=this._getColumnIdxForColumnKey(i.startKey[this._CONST_COLUMN]),null!=i[this._CONST_STARTINDEX]&&null!=i[this._CONST_STARTINDEX][this._CONST_COLUMN]&&d!==i[this._CONST_STARTINDEX][this._CONST_COLUMN]&&(T=!0)),null!=i.endKey&&null!=i.endKey[this._CONST_COLUMN]&&(S=this._getColumnIdxForColumnKey(i.endKey[this._CONST_COLUMN]),null!=i[this._CONST_ENDINDEX]&&null!=i[this._CONST_ENDINDEX][this._CONST_COLUMN]&&S!==i[this._CONST_ENDINDEX][this._CONST_COLUMN]&&(T=!0)),null==a&&null!=i[this._CONST_STARTINDEX]&&(a=i[this._CONST_STARTINDEX][this._CONST_ROW]),null==r&&null!=i[this._CONST_ENDINDEX]&&(r=i[this._CONST_ENDINDEX][this._CONST_ROW]),null==d&&null!=i[this._CONST_STARTINDEX]&&(d=i[this._CONST_STARTINDEX][this._CONST_COLUMN]),null==S&&null!=i[this._CONST_ENDINDEX]&&(S=i[this._CONST_ENDINDEX][this._CONST_COLUMN]),null!=a&&null!=r&&null!=d&&null!=S)return void _.error("Error: Invalid range object in selection - Can only support row or column selection. Not both");if(null!=a&&a>=0&&null!=r&&r>=0)for(s=this._getRowKeyForDataSourceRowIndex(a),n=this._getRowKeyForDataSourceRowIndex(r),h=this._getRowIdxForRowKey(s),u=this._getRowIdxForRowKey(n),t=h;t<=u;t++)try{this._setRowSelection(t,!0,null,null,T)}catch(e){_.error("Error: "+e)}else{if(null==d||null==S)return void _.error("Error: Invalid range object in selection - \n start row: "+a+"\nend row: "+r+"\nstart column: "+d+"\nend column: "+S);for(t=d;t<=S;t++)try{this._setHeaderColumnSelection(t,!0,null,null,T)}catch(e){_.error("Error: "+e)}}}},_setSelectionDefault:function(){if("true"===String(this.options.selectionRequired).toLowerCase())if(this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._MULTIPLE||this._getRowSelectionMode()===this._OPTION_SELECTION_MODES._SINGLE){var e=this._getSelectedRowIdxs();null!=e&&0!==e.length||this._setRowSelection(0,!0,null,null,!0)}else if(this._getColumnSelectionMode()===this._OPTION_SELECTION_MODES._MULTIPLE||this._getColumnSelectionMode()===this._OPTION_SELECTION_MODES._SINGLE){var t=this._getSelectedHeaderColumnIdxs();null!=t&&0!==t.length||this._setHeaderColumnSelection(0,!0,null,null,!0)}},_setTableActionableMode:function(e){if(this._isTableEditMode())this._tableActionableMode=!1;else if(!(null!=this._tableActionableMode&&this._tableActionableMode===e||null==this._tableActionableMode&&!1===e))if(e){var l=this._getFocusedRowIdx(),o=this._getFocusedHeaderColumnIdx();if(null!=l||null!=o){var i=null;if(null!=(i=null!=l?this._getTableDomUtils().getTableBodyRow(l):this._getTableDomUtils().getTableHeaderColumn(o))){var s=this._getTabbableElements(i);null!=s&&s.length>0&&(this._tableActionableMode=e,s[0].focus())}}}else{this._tableActionableMode=e;var n=this._getTableDomUtils().getTableBody();t.contains(n,document.activeElement)&&this._getTableDomUtils().getTable().focus()}},_setTableEditable:function(t,l,o,i,s){if(this._isTableEditMode()){var n=this._getCurrentRow();if(null!=n){var a,r,_,h=n.rowKey,u=this._getRowIdxForRowKey(h);try{if(t&&!this._hasEditableRow())a=this._getTableDomUtils().getTableBodyRow(u),r=e.TableRendererUtils.getRendererContextObject(this,a,{row:{key:h,index:n.rowIndex},isCurrentRow:!0}),_=this._trigger("beforeRowEdit",s,{rowContext:r});else{if(t||!this._hasEditableRow())return;a=this._getTableDomUtils().getTableBodyRow(this._getEditableRowIdx()),h=this._getRowKeyForRowIdx(this._getEditableRowIdx()),r=e.TableRendererUtils.getRendererContextObject(this,a,{row:{key:h,index:this._getDataSourceRowIndexForRowKey(h)},isCurrentRow:!0}),_=this._trigger("beforeRowEditEnd",s,{rowContext:r,cancelEdit:l})}}catch(e){return!1}if(!_)return!1;var d=this._getEditableRowIdx(),S=this;t?(this._setEditableRowIdx(u),this._refreshRow(u,!1).then(function(){S._queueTask(function(){var e=u,t=o,l=i;S._setCellInRowFocus(e,t,l)})})):(this._setEditableRowIdx(null),this._getTableDomUtils().getTable().focus()),null!=d&&null!=this._getTableDomUtils().getTableBodyRow(d)&&this._refreshRow(d,!1).then(function(){S._queueTask(function(){var t=d,l=this._getTableDomUtils().getTableBodyRow(t);null!=l&&l.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_EDIT_CLASS)})})}}},_showInlineMessage:function(t,l,o){if(!this._inlineMessageShown){this._getTableDomUtils().setTableInlineMessage(t,l,o);var i=this._getTableDomUtils().getTableInlineMessage(),s=this._getTableDomUtils().getTableContainer();o===r.SEVERITY_LEVEL.WARNING&&(s.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._WARNING),i.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._WARNING)),i.style[e.TableDomUtils.CSS_PROP._DISPLAY]=e.TableDomUtils.CSS_VAL._BLOCK,i.style[e.TableDomUtils.CSS_PROP._WIDTH]="100%",i.style[e.TableDomUtils.CSS_PROP._BOX_SIZING]=e.TableDomUtils.CSS_VAL._BORDER_BOX,this._inlineMessageShown=!0}},_showNoDataMessage:function(){if(!this._noDataMessageShown){var e=this._getTableDomUtils().getTableBodyMessageRow(),t=this._getData(),l=null;l=null!=this.options.emptyText?this.options.emptyText:this.getTranslatedString(this._BUNDLE_KEY._MSG_NO_DATA);var o=null!=t?l:this.getTranslatedString(this._BUNDLE_KEY._MSG_INITIALIZING);null==e?this._getTableDomUtils().createTableBodyMessageRow(this._getColumnDefs().length,o):this._getTableDomUtils().setTableBodyMessage(o),this._noDataMessageShown=!0}},_showStatusMessage:function(){if(!this._showStatusTimeout&&!this._statusMessageShown){var t=this._getTableDomUtils().getTableStatusMessage(),l=this;this._showStatusTimeout=setTimeout(function(){t.style[e.TableDomUtils.CSS_PROP._DISPLAY]=e.TableDomUtils.CSS_VAL._INLINE,l._statusMessageShown=!0,l._getTableDomUtils().refreshTableStatusPosition()},this._getShowStatusDelay())}},_getShowStatusDelay:function(){null==this._defaultOptions&&(this._defaultOptions=s.parseJSONFromFontFamily("oj-table-option-defaults"));var e=parseInt(this._defaultOptions.showIndicatorDelay,10);return isNaN(e)?0:e},_showTableHeaderColumnSortLink:function(l){if(this._getColumnDefs()[l].sortable===this._OPTION_ENABLED){var o=this._getTableDomUtils().getTableHeaderColumn(l);if(!o)return;if(null==t(o).data("sorted")){var i=o.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_LINK_CLASS);i.length>0&&((i=i[0]).classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._ENABLED),i.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED));var s=o.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_CLASS);s.length>0&&(s=s[0]).classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED);var n=o.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_CLASS);n.length>0&&(n=n[0]).classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED)}}},_touchEventDoubleTapFunction:function(e,l){var o=t(e.target);null!=this._lastTapTime&&(new Date).getTime()-this._lastTapTime<250&&this._lastTapTarget[0]===o[0]?(this._lastTapTime=null,this._lastTapTarget=null,l()):(this._lastTapTarget=o,this._lastTapTime=(new Date).getTime())},_unregisterChildStateListeners:function(e){var t,l=this,o=e.querySelectorAll("*");for(t=0;t<o.length;t++)l._UnregisterChildNode(o[t]);l=null},_unregisterDataSourceEventListeners:function(){var e=this._getData();if(null!=this._dataProviderEventHandlers&&null!=e)for(var t=this._dataProviderEventHandlers.length,l=0;l<t;l++)e.removeEventListener(this._dataProviderEventHandlers[l].eventType,this._dataProviderEventHandlers[l].eventHandler)},_unregisterResizeListener:function(){var t=this._getTableDomUtils().getTableContainer();e.DomUtils.removeResizeListener(t,this._resizeListener),this._isResizeListenerAdded=!1},_updateHeaderColumnStateCellsClass:function(t,l){var o=this._getHeaderColumnSelection(t),i=this._getSelectedRowIdxs(),s=this._getTableDomUtils().getTableBodyRows();if(null!=s&&s.length>0)for(var n=s.length,a=0;a<n;a++){var r=this._getTableDomUtils().getTableBodyCell(a,t);if(o)r.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED);else{for(var _=!1,h=i.length,u=0;u<h;u++)if(a===i[u]){_=!0;break}_||r.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)}}},_updateRowStateCellsClass:function(l,o,i){var s,n=this._getTableDomUtils().getTableBodyCells(l),a=o.focused,r=o.selected,_=o.hover;if(n){var h=n.length;if(null!=_)for(s=0;s<h;s++)_?n[s].classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._HOVER):n[s].classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._HOVER);if(null!=a)for(s=0;s<h;s++)a?this._focusInHandler(t(n[s])):this._focusOutHandler(t(n[s]));if(null!=r)for(s=0;s<h;s++)r?n[s].classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED):n[s].classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._SELECTED)}},_waitForAllComponentsToResolve:function(e){var t=this;if(e instanceof Array||(e=[e]),this._hasRowOrCellRendererOrTemplate()){var l=[];if(null!=e&&e.length>0&&e.forEach(function(e){var o=t._getAllBusyContextsForElement(e);null!=o&&o.forEach(function(e){l.push(e)})}),l.length>0){var o=[];return l.forEach(function(e){o.push(e.whenReady())}),Promise.all(o)}}return Promise.resolve()},_setFinalTask:function(e){this._finalTask=e?e.bind(this):void 0},_hasPendingTasks:function(){return this._taskCount>1},_queueTask:function(e){var t=this;return this._pendingTasks||(this._taskCount=0,this._pendingTasks=Promise.resolve(),this._setComponentNotReady()),this._taskCount+=1,this._pendingTasks=this._pendingTasks.then(function(){if(!t._componentDestroyed)return e.bind(t)()}).then(function(e){if(t._taskCount-=1,0===t._taskCount){t._pendingTasks=void 0;try{t._componentDestroyed||(t._finalTask&&t._finalTask(),t._trigger("ready"))}catch(e){_.error(e)}t._setComponentReady(),t=null}return e},function(e){return t._taskCount-=1,0===t._taskCount&&(t._pendingTasks=void 0,_.error(e),t._setComponentReady(),t=null),Promise.reject(e)}),this._pendingTasks},_CompareOptionValues:function(t,l,o){switch(t){case"columns":case"currentRow":case"selection":return e.Object.compareValues(l,o);default:return this._super(t,l,o)}}}),n.setDefaultOptions({ojTable:{display:n.createDynamicPropertyGetter(function(){return(s.parseJSONFromFontFamily("oj-table-option-defaults")||{}).display})}}),e.TableAnimationUtils=function(e){this.component=e,this.options=e.options,this.Init()},e.Object.createSubclass(e.TableAnimationUtils,e.Object,"oj.TableAnimationUtils"),e.TableAnimationUtils.prototype.Init=function(){e.TableAnimationUtils.superclass.Init.call(this)},e.TableAnimationUtils.prototype.animateTableBodyRow=function(e,t){if(this._isAnimationDisabled(t))return Promise.resolve(!1);var l=this;return new Promise(function(o){l._startAnimation(e,t).then(function(){o(!0)})})},e.TableAnimationUtils.prototype.animateTableBodyRows=function(e,t){if(this._isAnimationDisabled(t))return Promise.resolve(!1);for(var l,o=this,i=[],s=0;s<e.length;s++){var n=e[s];i.push((l=n,o.animateTableBodyRow(l,t)))}return i.length>0?Promise.all(i):Promise.resolve(!1)},e.TableAnimationUtils.prototype._getAnimationEffect=function(e){var t;return null==this.defaultAnimations&&(t=s.parseJSONFromFontFamily("oj-table-option-defaults"),this.defaultAnimations=t.animation||{}),this.defaultAnimations[e]},e.TableAnimationUtils.prototype._isAnimationDisabled=function(e){var t=this._getAnimationEffect(e);return null==t||0===t.length},e.TableAnimationUtils.prototype._startAnimation=function(e,t,l){return null==l&&(l=this._getAnimationEffect(t)),a.startAnimation(e,t,l,this.component)},e.TableDndContext=function(e){this.component=e,this.options=e.options,this.Init()},e.Object.createSubclass(e.TableDndContext,e.Object,"oj.TableDndContext"),e.TableDndContext.prototype.Init=function(){e.TableDndContext.superclass.Init.call(this)},e.TableDndContext.prototype._addDragMarkerClass=function(t){this._getTableDomUtils().getTableHeaderColumn(t).classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DRAG),this._getTableDomUtils().setTableColumnCellsClass(t,!0,e.TableDomUtils.MARKER_STYLE_CLASSES._DRAG)},e.TableDndContext.prototype._removeDragMarkerClass=function(){var t=this._getTableDomUtils().getTableHeader().querySelectorAll("."+e.TableDomUtils.MARKER_STYLE_CLASSES._DRAG);if(null!=t&&t.length>0)for(var l=t.length,o=0;o<l;o++)t[o].classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._DRAG);this._getTableDomUtils().setTableColumnCellsClass(null,!1,e.TableDomUtils.MARKER_STYLE_CLASSES._DRAG)},e.TableDndContext.prototype._cloneTableContainer=function(l){var o,i=l.querySelectorAll(e.TableDomUtils.DOM_ELEMENT._TBODY)[0],s=t(i).scrollLeft(),n=t(i).scrollTop(),a=(o=l.cloneNode(!0)).querySelectorAll(e.TableDomUtils.DOM_ELEMENT._TBODY)[0];return a.style[e.TableDomUtils.CSS_PROP._OVERFLOW]=e.TableDomUtils.CSS_VAL._HIDDEN,a.style[e.TableDomUtils.CSS_PROP._OVERFLOW_X]=e.TableDomUtils.CSS_VAL._HIDDEN,a.style[e.TableDomUtils.CSS_PROP._OVERFLOW_Y]=e.TableDomUtils.CSS_VAL._HIDDEN,a.style[e.TableDomUtils.CSS_PROP._BACKGROUND_COLOR]=e.TableDomUtils.CSS_VAL._TRANSPARENT,a.style[e.TableDomUtils.CSS_PROP._WIDTH]=t(i).width()+e.TableDomUtils.CSS_VAL._PX,a.style[e.TableDomUtils.CSS_PROP._HEIGHT]=t(i).height()+e.TableDomUtils.CSS_VAL._PX,o.style[e.TableDomUtils.CSS_PROP._POSITION]=e.TableDomUtils.CSS_VAL._ABSOLUTE,o.style[e.TableDomUtils.CSS_PROP._TOP]=-1e4+e.TableDomUtils.CSS_VAL._PX,t(a).scrollLeft(1*s),t(a).scrollTop(1*n),document.body.appendChild(o),o},e.TableDndContext.prototype._destroyDragImage=function(){this._dragImage&&(t(this._dragImage).remove(),this._dragImage=null)},e.TableDndContext.prototype._getEventColumnIndex=function(e){return this._getTableDomUtils().getElementColumnIdx(e.currentTarget)},e.TableDndContext.prototype._getOverRowIndex=function(l){var o,i=t(l.target).closest(e.TableDomUtils.DOM_ELEMENT._TR),s=t(l.target).closest("."+e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_CLASS);if(s.length>0){var n=this._getTableDomUtils().getFirstAncestor(s[0],e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS);null!=n&&(o=t(n).index())}else if(i&&i.hasClass(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_DRAG_INDICATOR_BEFORE_CLASS))o=this._dropRowIndex;else{var a=this._getTableDomUtils().getTableBodyRows();o=a?a.length:0}return o},e.TableDndContext.prototype._getTableDomUtils=function(){return this.component._getTableDomUtils()},e.TableDndContext.prototype.handleColumnDragStart=function(e){if(this._isColumnReorderEnabled()){var t=this._getEventColumnIndex(e);return this._dragStartColumnIdx=t,this._setReorderColumnsDataTransfer(e,t),this.component._setSelection(null),this.component.option("selection",null,{_context:{writeback:!0,internalSet:!0}}),setTimeout(function(){window.getSelection().removeAllRanges()},0),this._addDragMarkerClass(t),!0}},e.TableDndContext.prototype.handleColumnDragEnd=function(e){this._isColumnReorderEnabled()&&(this.setTableHeaderColumnDraggable(null,!1),this._dragStartColumnIdx=null,this._getTableDomUtils().removeDragOverIndicatorColumn(),this._getTableDomUtils().removeTableHeaderColumnDragImage(),this._removeDragMarkerClass())},e.TableDndContext.prototype.handleColumnDragEnter=function(e){if(!this._isColumnReordering()){var t=this._getEventColumnIndex(e);return this._invokeDropCallback("columns","dragEnter",e,{columnIndex:t})}},e.TableDndContext.prototype.handleColumnReorderDragOver=function(e){var t=this._getEventColumnIndex(e),l=this._dragStartColumnIdx;null!=l&&l!==t&&(this._currentDropColumnBefore=this._isDragOverBeforeColumn(e),this._currentDropColumnBefore&&l===t-1||!this._currentDropColumnBefore&&l===t+1||this._getTableDomUtils().displayDragOverIndicatorColumn(t,this._currentDropColumnBefore),e.preventDefault())},e.TableDndContext.prototype.handleColumnDragOver=function(e){if(this._isColumnReordering())return this.handleColumnReorderDragOver(e);var t=this._getEventColumnIndex(e);this._currentDropColumnBefore=this._isDragOverBeforeColumn(e);var l=this._invokeDropCallback("columns","dragOver",e,{columnIndex:t});return(!1===l||e.isDefaultPrevented())&&this._getTableDomUtils().displayDragOverIndicatorColumn(t,this._isDragOverBeforeColumn(e)),l},e.TableDndContext.prototype.handleColumnDragLeave=function(e){if(!this._isColumnReordering()){this._getTableDomUtils().removeDragOverIndicatorColumn();var t=this._getEventColumnIndex(e);return this._invokeDndCallback("drop","columns","dragLeave",e,{columnIndex:t})}},e.TableDndContext.prototype.handleColumnReorderDrop=function(e){var t=this._getEventColumnIndex(e);this._currentDropColumnBefore||(t+=1),this.component._columnsDestMap=this._getTableDomUtils().moveTableHeaderColumn(this._dragStartColumnIdx,t,e),e.preventDefault()},e.TableDndContext.prototype.handleColumnDrop=function(e){if(this._isColumnReordering())return this.handleColumnReorderDrop(e);this._getTableDomUtils().removeDragOverIndicatorColumn();var t=this._getEventColumnIndex(e);return this._currentDropColumnBefore||(t+=1),this._invokeDropCallback("columns","drop",e,{columnIndex:t})},e.TableDndContext.prototype.handleRowDragStart=function(e){var t=this.options.dnd.drag;if(t&&t.rows){var l=this._setDragRowsDataTransfer(e,t.rows.dataTypes,this.component._getSelectedRowIdxs());return!!l&&this._invokeDndCallback("drag","rows","dragStart",e,l)}},e.TableDndContext.prototype.handleRowDrag=function(e){return this._invokeDndCallback("drag","rows","drag",e)},e.TableDndContext.prototype.handleRowDragEnd=function(e){return this._destroyDragImage(),this._invokeDndCallback("drag","rows","dragEnd",e)},e.TableDndContext.prototype.handleRowDragEnter=function(e){var t=this._getOverRowIndex(e),l=this._invokeDropCallback("rows","dragEnter",e,{rowIndex:t});return(!1===l||e.isDefaultPrevented())&&this._updateDragRowsState(e,t),l},e.TableDndContext.prototype.handleRowDragOver=function(e){return this._invokeDropCallback("rows","dragOver",e,{rowIndex:this._dropRowIndex})},e.TableDndContext.prototype.handleRowDragLeave=function(e){var t=this._invokeDndCallback("drop","rows","dragLeave",e,{rowIndex:this._dropRowIndex});return this._isDndEventInElement(e,e.currentTarget)||(this._getTableDomUtils().removeDragOverIndicatorRow(),this._dropRowIndex=null),t},e.TableDndContext.prototype.handleRowDrop=function(e){var t=this._dropRowIndex;return this._getTableDomUtils().removeDragOverIndicatorRow(),this._dropRowIndex=null,this._invokeDropCallback("rows","drop",e,{rowIndex:t})},e.TableDndContext.prototype._hideUnselectedRows=function(t,l){for(var o=null,i=t.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS),s=i.length-1;s>=0;s--)-1===l.indexOf(s)?i[s].style[e.TableDomUtils.CSS_PROP._VISIBILITY]=e.TableDomUtils.CSS_VAL._HIDDEN:o=s;var n=t.querySelectorAll(e.TableDomUtils.DOM_ELEMENT._THEAD);null!=n&&n.length>0&&(n[0].style[e.TableDomUtils.CSS_PROP._VISIBILITY]=e.TableDomUtils.CSS_VAL._HIDDEN);var a=t.querySelectorAll(e.TableDomUtils.DOM_ELEMENT._TFOOT);return null!=a&&a.length>0&&(a[0].style[e.TableDomUtils.CSS_PROP._VISIBILITY]=e.TableDomUtils.CSS_VAL._HIDDEN),o},e.TableDndContext.prototype._invokeDndCallback=function(e,t,l,o,i){var s,n=this.options.dnd[e];if(n&&n[t]){var a=n[t][l];if(a&&"function"==typeof a)try{this.component._IsCustomElement()?a(o.originalEvent,i):(o.dataTransfer=o.originalEvent.dataTransfer,s=a(o,i))}catch(e){_.error("Error: "+e)}}return s},e.TableDndContext.prototype._invokeDropCallback=function(e,t,l,o){var i=this._invokeDndCallback("drop",e,t,l,o);return void 0===i&&this._matchDragDataType(l,e)&&l.preventDefault(),i},e.TableDndContext.prototype._isColumnReorderEnabled=function(){var e=this.options.dnd;return!(!e||!e.reorder||e.reorder.columns!==this.component._OPTION_ENABLED)},e.TableDndContext.prototype._isColumnReordering=function(){return null!=this._dragStartColumnIdx},e.TableDndContext.prototype._isDndEventInElement=function(e,t){var l=t.getBoundingClientRect(),o=e.originalEvent;return o.clientX>=Math.ceil(l.left)&&o.clientX<Math.floor(l.right)&&o.clientY>=Math.ceil(l.top)&&o.clientY<Math.floor(l.bottom)},e.TableDndContext.prototype._isDragOverBeforeColumn=function(t){var l=t.currentTarget.getBoundingClientRect();if(null!=t.originalEvent.clientX){var o=l.right-t.originalEvent.clientX<(l.right-l.left)/2;return"rtl"===e.DomUtils.getReadingDirection()?o:!o}return!1},e.TableDndContext.prototype._matchDragDataType=function(e,t){var l=e.originalEvent.dataTransfer.types,o=this.options.dnd.drop;if(o&&o[t]&&o[t].dataTypes)for(var i=o[t].dataTypes,s="string"==typeof i?[i]:i,n=0;n<l.length;n++)if(s.indexOf(l[n])>=0)return!0;return!1},e.TableDndContext.prototype._setHeaderColumnDraggable=function(t,l){t.draggable=l,l&&(t.style[e.TableDomUtils.CSS_PROP._CURSOR]=e.TableDomUtils.CSS_VAL._MOVE,t.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DRAGGABLE))},e.TableDndContext.prototype._clearHeaderColumnDraggable=function(t){t.draggable="",t.style[e.TableDomUtils.CSS_PROP._CURSOR]=e.TableDomUtils.CSS_VAL._AUTO,t.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._DRAGGABLE)},e.TableDndContext.prototype._setDragRowsData=function(e,t,l){if(t){var o=e.dataTransfer,i=JSON.stringify(l);if("string"==typeof t)o.setData(t,i);else for(var s=0;s<t.length;s++)o.setData(t[s],i)}},e.TableDndContext.prototype._setDragRowsDataTransfer=function(l,o,i){for(var s=[],n=0;n<i.length;n++){var a=this.component.getDataForVisibleRow(i[n]);a&&s.push(a)}return s.length?(this._setDragRowsData(l.originalEvent,o,s),this._destroyDragImage(),this._dragImage=this._setDragRowsImage(l.originalEvent,t(l.currentTarget).closest(e.TableDomUtils.DOM_ELEMENT._TABLE).parent()[0],i),{rows:s}):null},e.TableDndContext.prototype._setDragRowsImage=function(l,o,i){var s=this._cloneTableContainer(o);this._hideUnselectedRows(s,i);var n=o.getBoundingClientRect(),a=o.querySelectorAll(e.TableDomUtils.DOM_ELEMENT._TBODY)[0],r=t(a).scrollLeft(),_=t(a).scrollTop(),h=l.clientX-n.left+r,u=l.clientY-n.top+_;return l.dataTransfer.setDragImage(s,h,u),s},e.TableDndContext.prototype._setReorderColumnsDataTransfer=function(e,t){var l=e.originalEvent.dataTransfer,o=this._getTableDomUtils().hashCode(this._getTableDomUtils().getTableUID());l.setData("Text",this.component._DND_REORDER_TABLE_ID_DATA_KEY+":"+o+":"+t);var i=this._getTableDomUtils().createTableHeaderColumnDragImage(t);try{l.setDragImage(i,0,0)}catch(e){}},e.TableDndContext.prototype.setTableHeaderColumnDraggable=function(e,t){if(this._isColumnReorderEnabled()){var l,o=this._getTableDomUtils().getTableHeaderColumns();if(null!=o&&o.length>0)for(l=0;l<o.length;l++){var i=o[l];null!=e&&l===e?this._setHeaderColumnDraggable(i,t):this._clearHeaderColumnDraggable(i)}}},e.TableDndContext.prototype._updateDragRowsState=function(l,o){if(this._dropRowIndex!==o){var i=t(l.target).closest(e.TableDomUtils.DOM_ELEMENT._TR)[0];this._dropRowIndex=o,this._getTableDomUtils().displayDragOverIndicatorRow(this._dropRowIndex,!0,i)}},e.TableDomUtils=function(e){this.component=e,this.options=e.options,this.element=e.element[0],this.OuterWrapper=e.OuterWrapper,this.Init(),this._cacheDomDimensions={}},e.Object.createSubclass(e.TableDomUtils,e.Object,"oj.TableDomUtils"),e.TableDomUtils.prototype.Init=function(){e.TableDomUtils.superclass.Init.call(this)},e.TableDomUtils.prototype.clearCachedDom=function(){this.clearCachedDomRowData(),this._clearCachedDom(null),this._tableDimensions=null},e.TableDomUtils.prototype.clearCachedDomRowData=function(){this._cachedDomTableBodyRows=null},e.TableDomUtils.prototype.createContextMenu=function(l){var o=this.component._GetContextMenu(),i=!!this.component._isTouchDevice()&&this.component._getRowSelectionMode()===this.component._OPTION_SELECTION_MODES._MULTIPLE;if(o){var s=o.querySelectorAll("[data-oj-command]");if(null!=s&&s.length>0){var n,a,r;for(a=0;a<s.length;a++)"OJ-OPTION"!==s[a].tagName&&0!==s[a].getElementsByTagName(e.TableDomUtils.DOM_ELEMENT._A).length||(n=s[a].getAttribute("data-oj-command").split("-"),r=this.createContextMenuItem(n[n.length-1],this.component._IsCustomElement()),"OJ-OPTION"===s[a].tagName?s[a].innerHTML=r.innerHTML:t(s[a]).replaceWith(r));this._menuContainer=o,t(o).data("oj-ojMenu")&&(this.component._IsCustomElement()?o.refresh():t(o).ojMenu("refresh")),this.component._IsCustomElement()?o.addEventListener("ojAction",l):t(o).on("ojselect",l)}}else if(this.component._isTableSortable()||i||this.component._isTableColumnsResizable()){if((o=document.createElement(e.TableDomUtils.DOM_ELEMENT._UL)).style[e.TableDomUtils.CSS_PROP._DISPLAY]=e.TableDomUtils.CSS_VAL._NONE,o.setAttribute(e.TableDomUtils.DOM_ATTR._ID,this.getTableId()+"_contextmenu"),this.getTableContainer().appendChild(o),this.component._isTableSortable()){var _=this.createContextMenuItem("sort");o.appendChild(_)}if(i){var h=this.createContextMenuItem("enableNonContiguousSelection");o.appendChild(h)}if(this.component._isTableColumnsResizable()){var u=this.createContextMenuItem("resize");o.appendChild(u)}t(o).ojMenu(),this._menuContainer=o,t(o).on("ojselect",l),this.component.option("contextMenu","#"+o.getAttribute(e.TableDomUtils.DOM_ATTR._ID),{_context:{internalSet:!0}}),this.component._defaultContextMenu=o}return o},e.TableDomUtils.prototype.createContextMenuItem=function(t,l){if("sort"===t){var o=this.createContextMenuListItem(t,l),i=document.createElement(e.TableDomUtils.DOM_ELEMENT._UL);return o.appendChild(i),i.appendChild(this.createContextMenuListItem("sortAsc",l)),i.appendChild(this.createContextMenuListItem("sortDsc",l)),o}return"sortAsc"===t?this.createContextMenuListItem(t,l):"sortDsc"===t?this.createContextMenuListItem(t,l):"enableNonContiguousSelection"===t?this.createContextMenuListItem(t,l):"disableNonContiguousSelection"===t?this.createContextMenuListItem(t,l):"resize"===t?(this.createContextMenuResizePopup(0),this.createContextMenuListItem(t)):null},e.TableDomUtils.prototype.createContextMenuListItem=function(e,t){var l=document.createElement(t?"oj-option":"li");return l.setAttribute("data-oj-command","oj-table-"+e),l.appendChild(this.createContextMenuLabel(e,t)),l},e.TableDomUtils.prototype.createContextMenuLabel=function(t,l){var o=null;"sort"===t?o=this.component.getTranslatedString("labelSort"):"sortAsc"===t?o=this.component.getTranslatedString("labelSortAsc"):"sortDsc"===t?o=this.component.getTranslatedString("labelSortDsc"):"enableNonContiguousSelection"===t?o=this.component.getTranslatedString("labelEnableNonContiguousSelection"):"disableNonContiguousSelection"===t?o=this.component.getTranslatedString("labelDisableNonContiguousSelection"):"resize"===t&&(o=this.component.getTranslatedString("labelResize"));var i=document.createTextNode(o);if(l)return i;var s=document.createElement(e.TableDomUtils.DOM_ELEMENT._A);return s.setAttribute(e.TableDomUtils.DOM_ATTR._HREF,"#"),s.appendChild(i),s},e.TableDomUtils.prototype.createContextMenuResizePopup=function(l){l=Math.round(l);var o,i=this.getContextMenuResizePopup();if(null==i){var s=this.getTableContainer();(i=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV)).setAttribute("id",this.getTableId()+"_resize_popup"),i.setAttribute("data-oj-context",""),s.appendChild(i);var n=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV),a=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);i.appendChild(n),i.appendChild(a),(o=document.createElement(e.TableDomUtils.DOM_ELEMENT._INPUT)).setAttribute("id",this.getTableId()+"_resize_popup_spinner");var r=document.createElement(e.TableDomUtils.DOM_ELEMENT._LABEL);r.setAttribute("for",this.getTableId()+"_resize_popup_spinner"),r.textContent=this.component.getTranslatedString("labelResizePopupSpinner");var _=document.createElement(e.TableDomUtils.DOM_ELEMENT._BUTTON);_.setAttribute("id",this.getTableId()+"_resize_popup_popupsubmit"),n.appendChild(r),n.appendChild(o),a.appendChild(_),t(_).ojButton({component:"ojButton",label:this.component.getTranslatedString("labelResizePopupSubmit")}),t(_).on("click",this.component._handleContextMenuResizePopup.bind(this.component)),t(o).ojInputNumber({component:"ojInputNumber",max:1e4,min:10,step:1,value:l,validators:[{type:"regExp",options:{pattern:"^[1-9][0-9]*$",messageDetail:this.component.getTranslatedString("msgColumnResizeWidthValidation")}}]}),t(i).ojPopup({modality:"modal",position:{my:"start top",at:"start bottom",collision:"flipfit"}}),this._cacheDomElement(this.getTableId()+"_resize_popup",i)}else o=document.getElementById(this.getTableId()+"_resize_popup_spinner"),t(o).ojInputNumber("option","value",l);return i},e.TableDomUtils.prototype.createInitialTable=function(e,t){var l=this.getTable();return this.createTableContainer(),e||this.createTableHeader(),t||this.createTableFooter(),this.createTableBody(),this.createTableStatusMessage(),this.createTableInlineMessage(),this.createTableStatusAccNotification(),l},e.TableDomUtils.prototype.createTableBody=function(){var t=this.getTable(),l=document.createElement(e.TableDomUtils.DOM_ELEMENT._TBODY);return t.appendChild(l),this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_BODY_CLASS,l),l},e.TableDomUtils.prototype.createTableBodyCell=function(t,l){return document.createElement(e.TableDomUtils.DOM_ELEMENT._TD)},e.TableDomUtils.prototype.createTableBodyCellAccSelect=function(t,l,o,i,s){var n=null;if(s||(n=this.getTableBodyCellAccSelect(i)),null!=n)return n;var a=null!=l?l.toString():t.toString(),r=null==o?this.hashCode(a):o;if((n=document.createElement(e.TableDomUtils.DOM_ELEMENT._TD)).classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_ACC_SELECT_CLASS),n.style.padding="0",n.style.border="0",!this.component._isTableHeaderless()){var _=this.options.accessibility,h=null;h=null!=_&&null!=_.rowHeader?_.rowHeader:this.component._getColumnDefs()[0].id;var u=this.getTableId()+":"+h+"_"+r;n.setAttribute(e.TableDomUtils.DOM_ATTR._HEADERS,this.getTableId()+":"+e.TableDomUtils._COLUMN_HEADER_ROW_SELECT_ID+" "+u)}var d=document.createElement(e.TableDomUtils.DOM_ELEMENT._INPUT);d.setAttribute(e.TableDomUtils.DOM_ATTR._ID,this.getTableId()+":acc_sel_row_"+r),d.setAttribute(e.TableDomUtils.DOM_ATTR._TYPE,"checkbox"),d.setAttribute(e.TableDomUtils.DOM_ATTR._TABINDEX,"-1");var S=null,T=this.options.editMode,c=null!=this.component._getRowSelectionMode();return S=T===this.component._OPTION_EDIT_MODE._ROW_EDIT?c?this.component.getTranslatedString(this.component._BUNDLE_KEY._LABEL_SELECT_AND_EDIT_ROW):this.component.getTranslatedString(this.component._BUNDLE_KEY._LABEL_EDIT_ROW):this.component.getTranslatedString(this.component._BUNDLE_KEY._LABEL_SELECT_ROW),d.setAttribute(e.TableDomUtils.DOM_ATTR._TITLE,S),d.classList.add(e.TableDomUtils.CSS_CLASSES._CHECKBOX_ACC_SELECT_ROW_CLASS),d.classList.add(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS),this.component._getEditableRowIdx()===t?d.checked=!0:d.checked=!1,n.appendChild(d),i.insertBefore(n,i.firstChild),n},e.TableDomUtils.prototype.createTableBodyMessageCell=function(t,l,o){var i=document.createElement(e.TableDomUtils.DOM_ELEMENT._TD);return i.setAttribute(e.TableDomUtils.DOM_ATTR._COLSPAN,l+1),i.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_BODY_MESSAGE_CLASS),i.appendChild(document.createTextNode(o)),t.appendChild(i),i},e.TableDomUtils.prototype.createTableBodyMessageRow=function(t,l){var o=this.getTableBody(),i=document.createElement(e.TableDomUtils.DOM_ELEMENT._TR);return i.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_BODY_MESSAGE_ROW_CLASS),this.createTableBodyMessageCell(i,t,l),o.appendChild(i),i},e.TableDomUtils.prototype.createTableBodyRow=function(t,l){var o=document.createElement(e.TableDomUtils.DOM_ELEMENT._TR);return this.createTableBodyCellAccSelect(t,l,null,o,!0),o},e.TableDomUtils.prototype.createTableBodyRowTouchSelectionAffordance=function(l){var o=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);o.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOP_CLASS),o.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOUCH_AREA_CLASS),t(o).data("rowIdx",l);var i=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);i.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOP_ICON_CLASS),i.setAttribute(e.TableDomUtils.DOM_ATTR._ROLE,"button"),i.setAttribute(e.TableDomUtils.DOM_ATTR._ARIA_LABEL,this.component.getTranslatedString("labelAccSelectionAffordanceTop")),t(i).data("rowIdx",l),o.appendChild(i);var s=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);s.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_BOTTOM_CLASS),s.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOUCH_AREA_CLASS),t(s).data("rowIdx",l);var n=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);n.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_BOTTOM_ICON_CLASS),n.setAttribute(e.TableDomUtils.DOM_ATTR._ROLE,"button"),n.setAttribute(e.TableDomUtils.DOM_ATTR._ARIA_LABEL,this.component.getTranslatedString("labelAccSelectionAffordanceBottom")),t(n).data("rowIdx",l),s.appendChild(n);var a=this.getTableContainer();a.appendChild(o),a.appendChild(s),this.moveTableBodyRowTouchSelectionAffordanceTop(l),this.moveTableBodyRowTouchSelectionAffordanceBottom(l)},e.TableDomUtils.prototype.createTableBottomSlot=function(){var t=this.getTableContainer(),l=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);return l.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_BOTTOM_SLOT_CLASS),t.appendChild(l),this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_BOTTOM_SLOT_CLASS,l),l},e.TableDomUtils.prototype.createTableContainer=function(){var t;return this.OuterWrapper?t=this.OuterWrapper:(t=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV),this.element.parentNode.replaceChild(t,this.element),t.insertBefore(this.element,t.firstChild)),this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_CONTAINER_CLASS,t),t},e.TableDomUtils.prototype.createTableFooter=function(){var t=this.getTable(),l=document.createElement(e.TableDomUtils.DOM_ELEMENT._TFOOT),o=document.createElement(e.TableDomUtils.DOM_ELEMENT._TR);this.createTableFooterAccSelect(o),l.appendChild(o);var i=this.getTableHeader();if(null!=i)i.parentNode.insertBefore(l,i.nextSibling);else{var s=this.getTableBody();null!=s?s.parentNode.insertBefore(l,s):t.appendChild(l)}return this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CLASS,l),l},e.TableDomUtils.prototype.createTableFooterAccSelect=function(t){var l=t.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS);return null!=l&&l.length>0?l[0]:((l=document.createElement(e.TableDomUtils.DOM_ELEMENT._TD)).classList.add(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS),l.setAttribute(e.TableDomUtils.DOM_ATTR._TABINDEX,"-1"),t.insertBefore(l,t.firstChild),l)},e.TableDomUtils.prototype.createTableFooterCell=function(t){return document.createElement(e.TableDomUtils.DOM_ELEMENT._TD)},e.TableDomUtils.prototype.createTableHeader=function(){var t=this.getTable(),l=document.createElement(e.TableDomUtils.DOM_ELEMENT._THEAD),o=document.createElement(e.TableDomUtils.DOM_ELEMENT._TR);l.appendChild(o);var i=this.getTableFooter();if(null!=i)i.parentNode.insertBefore(l,i);else{var s=this.getTableBody();null!=s?s.parentNode.insertBefore(l,s):t.appendChild(l)}return this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_HEADER_ROW_CLASS,o),this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_HEADER_CLASS,l),l},e.TableDomUtils.prototype.createTableHeaderAccSelectRowColumn=function(){var t,l=document.createElement(e.TableDomUtils.DOM_ELEMENT._TH);l.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ACC_SELECT_ROW_CLASS),l.setAttribute(e.TableDomUtils.DOM_ATTR._ID,this.getTableId()+":"+e.TableDomUtils._COLUMN_HEADER_ROW_SELECT_ID);var o=this.options.editMode,i=null!=this.component._getRowSelectionMode();t=o===this.component._OPTION_EDIT_MODE._ROW_EDIT?i?this.component.getTranslatedString(this.component._BUNDLE_KEY._LABEL_SELECT_AND_EDIT_ROW):this.component.getTranslatedString(this.component._BUNDLE_KEY._LABEL_EDIT_ROW):this.component.getTranslatedString(this.component._BUNDLE_KEY._LABEL_SELECT_ROW),l.setAttribute(e.TableDomUtils.DOM_ATTR._TITLE,t),l.style.padding="0",l.style.border="0";var s=document.createElement(e.TableDomUtils.DOM_ELEMENT._SPAN);return s.appendChild(document.createTextNode(t)),s.classList.add(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS),l.appendChild(s),l},e.TableDomUtils.prototype.createTableHeaderColumn=function(t,l){var o=this.component._getColumnDefs()[t],i=document.createElement(e.TableDomUtils.DOM_ELEMENT._TH);this.styleTableHeaderColumn(t,i,l,!0),i.setAttribute("abbr",o.headerText),i.setAttribute(e.TableDomUtils.DOM_ATTR._TITLE,o.headerText),this.insertTableHeaderColumn(t,i);var s={columnIndex:t,headerContext:{component:this.component,parentElement:i}};return o.resizable===e.TableDomUtils._OPTION_ENABLED&&i.setAttribute("data-oj-resizable",e.TableDomUtils._OPTION_ENABLED),o.sortable===e.TableDomUtils._OPTION_ENABLED?(i.setAttribute("data-oj-sortable",e.TableDomUtils._OPTION_ENABLED),e.TableRendererUtils.columnHeaderSortableIconRenderer(this.component,s,null,null)):e.TableRendererUtils.columnHeaderDefaultRenderer(this.component,s,null,null),i},e.TableDomUtils.prototype.createTableHeaderColumnDragImage=function(t){var l=this.getTableHeaderColumn(t).cloneNode(!0);return l.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._DRAG),l.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._FOCUS),l.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._FOCUS_HIGHLIGHT),l.classList.remove(e.TableDomUtils.MARKER_STYLE_CLASSES._HOVER),l.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_IMAGE),l.style[e.TableDomUtils.CSS_PROP._POSITION]=e.TableDomUtils.CSS_VAL._ABSOLUTE,l.style[e.TableDomUtils.CSS_PROP._TOP]="0",l.style[e.TableDomUtils.CSS_PROP._LEFT]="-999em",l.style[e.TableDomUtils.CSS_PROP._ZINDEX]="-999",document.body.appendChild(l),l},e.TableDomUtils.prototype.createTableHeaderColumnAccSelect=function(t,l){if(l!==e.TableDomUtils._OPTION_SELECTION_MODES._SINGLE&&l!==e.TableDomUtils._OPTION_SELECTION_MODES._MULTIPLE)return null;var o=this.getTableHeaderColumn(t),i=this.getTableHeaderColumnAccSelect(t);if(null!=i)return i;(i=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV)).classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ACC_SELECT_COLUMN_CLASS),i.classList.add(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS);var s=document.createElement(e.TableDomUtils.DOM_ELEMENT._INPUT);s.setAttribute(e.TableDomUtils.DOM_ATTR._ID,this.getTableId()+":acc_sel_col"+t),s.setAttribute(e.TableDomUtils.DOM_ATTR._TYPE,"checkbox"),s.setAttribute(e.TableDomUtils.DOM_ATTR._TABINDEX,"-1");var n=this.component.getTranslatedString(this.component._BUNDLE_KEY._LABEL_SELECT_COLUMN);return s.setAttribute(e.TableDomUtils.DOM_ATTR._TITLE,n),s.classList.add(e.TableDomUtils.CSS_CLASSES._CHECKBOX_ACC_SELECT_COLUMN_CLASS),i.appendChild(s),o.insertBefore(i,o.firstChild),i},e.TableDomUtils.prototype.createTableHeaderColumnResizeIndicator=function(){var t=this.getTableHeaderColumnResizeIndicator();if(!t){var l=this.getTableContainer();t=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV),l.appendChild(t),t.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_RESIZE_INDICATOR_CLASS),this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_RESIZE_INDICATOR_CLASS,t)}return t},e.TableDomUtils.prototype.createTableInlineMessage=function(){var t=this.getTableContainer(),l=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);return l.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_INLINE_MESSAGE_CLASS),l.style[e.TableDomUtils.CSS_PROP._DISPLAY]=e.TableDomUtils.CSS_VAL._NONE,t.appendChild(l),this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_INLINE_MESSAGE_CLASS,l),l},e.TableDomUtils.prototype.createTableStatusAccNotification=function(){var t=this.getTableContainer(),l=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);return l.setAttribute(e.TableDomUtils.DOM_ATTR._ROLE,"status"),l.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_STATUS_ACC_NOTIFICATION_CLASS),l.classList.add(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS),t.appendChild(l),this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_STATUS_ACC_NOTIFICATION_CLASS,l),l},e.TableDomUtils.prototype.createTableStatusMessage=function(){var t=this.getTableContainer(),l=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);l.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_STATUS_MESSAGE_CLASS),l.style[e.TableDomUtils.CSS_PROP._DISPLAY]=e.TableDomUtils.CSS_VAL._NONE;var o=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);return o.classList.add(e.TableDomUtils.CSS_CLASSES._ICON_CLASS),o.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_LOADING_ICON_CLASS),o.setAttribute("aria-label",this.component.getTranslatedString(this.component._BUNDLE_KEY._MSG_FETCHING_DATA)),l.appendChild(o),t.appendChild(l),this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_STATUS_MESSAGE_CLASS,l),l},e.TableDomUtils.prototype.displayDragOverIndicatorColumn=function(t,l){this.removeDragOverIndicatorColumn();var o=this.getTableHeaderRow(),i=this.getTableHeaderColumn(t);if(null!=i)l?i.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_INDICATOR_BEFORE_CLASS):i.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_INDICATOR_AFTER_CLASS);else{var s=this.component._getColumnDefs();null!=s&&0!==s.length||(l?o.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_INDICATOR_BEFORE_CLASS):o.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_INDICATOR_AFTER_CLASS))}},e.TableDomUtils.prototype.displayDragOverIndicatorRow=function(l,o,i){this.removeDragOverIndicatorRow();var s=document.createElement(e.TableDomUtils.DOM_ELEMENT._TR);o?s.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_DRAG_INDICATOR_BEFORE_CLASS):s.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_DRAG_INDICATOR_AFTER_CLASS),i&&t(s).height(parseInt(t(i).height(),10));var n=document.createElement(e.TableDomUtils.DOM_ELEMENT._TD),a=this.component._getColumnDefs();n.setAttribute(e.TableDomUtils.DOM_ATTR._COLSPAN,a.length+1),s.appendChild(n);var r=this.getTableBodyRow(l);if(null!=r)o?r.parentNode.insertBefore(s,r):r.parentNode.insertBefore(s,r.nextSibling);else{var _=this.getTableBodyRows();null!=_&&0!==_.length||this.component._hideNoDataMessage(),this.getTableBody().appendChild(s)}},e.TableDomUtils.prototype.getContextMenu=function(){return this._menuContainer},e.TableDomUtils.prototype.getContextMenuResizePopup=function(){var e=this.getTableId()+"_resize_popup";if(!this._isCachedDomElement(e)){var t=document.getElementById(e);this._cacheDomElement(e,t)}return this._getCachedDomElement(e)},e.TableDomUtils.prototype.getElementColumnIdx=function(l){var o=this.getFirstAncestor(l,e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_CLASS);if(null!=o)return t(o.parentNode).children("."+e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_CLASS).index(o);var i=this.getFirstAncestor(l,e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CELL_CLASS);if(null!=i)return t(i.parentNode).children("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CELL_CLASS).index(i);var s=this.getFirstAncestor(l,e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CELL_CLASS);return null!=s?t(s.parentNode).children("."+e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CELL_CLASS).index(s):null},e.TableDomUtils.prototype.getElementRowIdx=function(l){var o=this.getFirstAncestor(l,e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS);if(null!=o){var i=this.getTableBodyRows();return t(i).index(o)}return null},e.TableDomUtils.prototype.getFirstAncestor=function(e,l){var o;if(null==e)return null;if(this._isIE()){if(this.hasClass(e,l))return e}else if(e.classList.contains(l))return e;return 0!==(o=t(e).parents("."+l)).length?o[0]:null},e.TableDomUtils.prototype.hasClass=function(e,t){return(" "+e.className+" ").indexOf(" "+t+" ")>-1},e.TableDomUtils.prototype.getScrollbarHeight=function(){var e=this.getScroller();return e.clientHeight>0?e.offsetHeight-e.clientHeight:0},e.TableDomUtils.prototype.getScrollbarWidth=function(){var e=this.getScroller();return e.clientWidth>0?e.offsetWidth-e.clientWidth:0},e.TableDomUtils.prototype.getScroller=function(){return this.getTableBody()},e.TableDomUtils.prototype.getScrollLeft=function(e){var t=e.scrollLeft;"rtl"===this.component._GetReadingDirection()&&(t=Math.abs(t),this._isWebkit()&&(t=e.scrollWidth-e.clientWidth-t));return t},e.TableDomUtils.prototype.getTable=function(){return this.element},e.TableDomUtils.prototype.getTableBody=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_BODY_CLASS,!0)},e.TableDomUtils.prototype.getTableBodyCell=function(e,t,l){var o=this.getTableBodyCells(e,l);return o&&o.length>t?o[t]:null},e.TableDomUtils.prototype.getTableBodyCellAccSelect=function(t){if(null!=t){var l=t.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_ACC_SELECT_CLASS);if(null!=l&&l.length>0)return l[0]}return null},e.TableDomUtils.prototype.getTableBodyLogicalCells=function(e,t){var l=this.getTableBodyCells(e,t);return l?this._getColspanLogicalElements(l):null},e.TableDomUtils.prototype.getTableBodyCells=function(t,l){if(l||(l=this.getTableBodyRow(t)),!l)return null;var o=l.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_CLASS);return null!=o&&o.length>0?o:null},e.TableDomUtils.prototype.getTableBodyMessageCell=function(){var t=this.getTableBody();if(t){var l=t.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._TABLE_BODY_MESSAGE_CLASS);if(l&&l.length>0)return l[0]}return null},e.TableDomUtils.prototype.getTableBodyMessageRow=function(){var t=this.getTableBody();if(t){var l=t.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_BODY_MESSAGE_ROW_CLASS);if(l&&l.length>0)return l[0]}return null},e.TableDomUtils.prototype.getTableBodyRow=function(e){var t=this.getTableBodyRows();return t?null==e?null:t.length>e?t[e]:null:null},e.TableDomUtils.prototype.getTableBodyRows=function(){if(!this._cachedDomTableBodyRows){var t=this.getTableBody();if(null!=t){var l=t.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS);null!=l&&l.length>0&&(this._cachedDomTableBodyRows=l)}}return this._cachedDomTableBodyRows},e.TableDomUtils.prototype.getTableBodyRowTouchSelectionAffordanceTop=function(){var t=this.getTableContainer().getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOP_CLASS);return null!=t&&t.length>0?t=t[0]:null},e.TableDomUtils.prototype.getTableBodyRowTouchSelectionAffordanceBottom=function(){var t=this.getTableContainer().getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_BOTTOM_CLASS);return null!=t&&t.length>0?t=t[0]:null},e.TableDomUtils.prototype.getTableBottomSlot=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_BOTTOM_SLOT_CLASS,!0)},e.TableDomUtils.prototype.getTableContainer=function(){return this._isCachedDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_CONTAINER_CLASS)||this._cacheDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_CONTAINER_CLASS,this.element.parentNode),this._getCachedDomElement(e.TableDomUtils.CSS_CLASSES._TABLE_CONTAINER_CLASS)},e.TableDomUtils.prototype.getTableFooter=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CLASS,!0)},e.TableDomUtils.prototype.getTableFooterCell=function(e){var t=this.getTableFooterCells();return null!=t&&t.length>e?t[e]:null},e.TableDomUtils.prototype.getTableFooterCells=function(){var t=this.getTableFooterRow(),l=null!=t?t.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CELL_CLASS):null;return null!=l&&l.length>0?l:null},e.TableDomUtils.prototype.getTableFooterLogicalCells=function(){var e=this.getTableFooterCells();return e?this._getColspanLogicalElements(e):null},e.TableDomUtils.prototype.getTableFooterRow=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_ROW_CLASS)},e.TableDomUtils.prototype.getTableHeader=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_HEADER_CLASS,!0)},e.TableDomUtils.prototype.getTableHeaderColumn=function(e){var t=this.getTableHeaderColumns();return t&&t.length>e&&e>=0?t[e]:null},e.TableDomUtils.prototype.getTableHeaderColumnAccSelect=function(t){var l=this.getTableHeaderColumn(t);if(null!=l){var o=l.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ACC_SELECT_COLUMN_CLASS);if(null!=o&&o.length>0)return o[0]}return null},e.TableDomUtils.prototype.getTableHeaderColumnResizeIndicator=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_RESIZE_INDICATOR_CLASS,!0)},e.TableDomUtils.prototype.getTableHeaderColumns=function(){var t=this.getTableHeaderRow();if(null!=t){var l=t.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CELL_CLASS);if(null!=l&&l.length>0)return l}return null},e.TableDomUtils.prototype.getTableHeaderLogicalColumns=function(){var e=this.getTableHeaderColumns();return e?this._getColspanLogicalElements(e):null},e.TableDomUtils.prototype.getTableHeaderRow=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_HEADER_ROW_CLASS)},e.TableDomUtils.prototype.getTableId=function(){if(!this._tableId){var t=this.component._IsCustomElement()?this.getTableContainer():this.getTable();this._tableId=t.getAttribute(e.TableDomUtils.DOM_ATTR._ID)}return this._tableId},e.TableDomUtils.prototype.getTableInlineMessage=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_INLINE_MESSAGE_CLASS,!0)},e.TableDomUtils.prototype.getTableStatusAccNotification=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_STATUS_ACC_NOTIFICATION_CLASS,!0)},e.TableDomUtils.prototype.getTableStatusMessage=function(){return this._getTableElementByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_STATUS_MESSAGE_CLASS,!0)},e.TableDomUtils.prototype.getTableUID=function(){if(!this._tableUID){var e=this.getTableId();null==e&&(e=(1e32*Math.random()).toString(36)),this._tableUID=e}return this._tableUID},e.TableDomUtils.prototype.hashCode=function(e){"string"!==t.type(e)&&(e=e.toString());var l=0;if(0===e.length)return l;for(var o=e.length,i=0;i<o;i++){l=(l<<5)-l+e.charCodeAt(i),l&=l}return l},e.TableDomUtils.prototype.insertTableBodyCell=function(t,l,o,i,s,n,a){if(this.setTableBodyCellAttributes(t,l,o,i,s),a)return n.appendChild(s),s;if(0===i){var r=n.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_ACC_SELECT_CLASS);null!=r&&r.length>0?(r=r[0]).parentNode.insertBefore(s,r.nextSibling):n.insertBefore(s,n.firstChild)}else{var _=n.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_CLASS);if(_.length>=i){var h=_[i-1];h.parentNode.insertBefore(s,h.nextSibling)}else n.appendChild(s)}return s},e.TableDomUtils.prototype.insertTableBodyRow=function(t,l,o,i){if(this.setTableBodyRowAttributes(o,l),null==i){var s=this.getTableBody(),n=s.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS);if(0===t)s.insertBefore(l,s.firstChild);else if(n.length>=t){var a=n[t-1];a.parentNode.insertBefore(l,a.nextSibling)}else s.appendChild(l)}else i.appendChild(l);this.clearCachedDomRowData()},e.TableDomUtils.prototype.insertTableFooterCell=function(t,l){var o=this.getTableFooterRow(),i=o.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CELL_CLASS);if(0===t){var s=o.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS);null!=s&&s.length>0?(s=s[0]).parentNode.insertBefore(l,s.nextSibling):o.insertBefore(l,o.firstChild)}else if(o.length>=t){var n=i[t-1];n.parentNode.insertBefore(l,n.nextSibling)}else o.appendChild(l);return l},e.TableDomUtils.prototype.insertTableHeaderColumn=function(l,o){var i=this.getTableHeaderRow(),s=this.getTableHeaderColumns();this.setTableHeaderColumnAttributes(l,o);var n=this.getTableHeaderColumn(l);if(n)t(n).replaceWith(t(o));else if(0===l){var a=i.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ACC_SELECT_ROW_CLASS);null!=a&&a.length>0?(a=a[0]).parentNode.insertBefore(o,a.nextSibling):i.insertBefore(o,i.firstChild)}else if(s&&s.length>=l){var r=s[l-1];r.parentNode.insertBefore(o,r.nextSibling)}else i.appendChild(o)},e.TableDomUtils.prototype.isTableContainerScrollable=function(){var e=this.getTableContainer(),t=this.getTable(),l=this.component._isStatusMessageShown();l&&this.component._hideStatusMessage();var o=[];return e.clientHeight>0?t.clientHeight>e.clientHeight?o[0]=1:e.clientHeight-t.clientHeight>1?o[0]=-1:o[0]=0:o[0]=0,e.clientWidth>0?t.clientWidth>e.clientWidth?o[1]=1:e.clientWidth-t.clientWidth>1?o[1]=-1:o[1]=0:o[1]=0,l&&this.component._showStatusMessage(),o},e.TableDomUtils.prototype.moveTableBodyRowTouchSelectionAffordanceTop=function(l){var o=this.getTableBodyRowTouchSelectionAffordanceTop();if(null!=o){t(o).data("rowIdx",l),t(o.children[0]).data("rowIdx",l);var i=this.getTableBody(),s=this.getTableBodyRow(l).getBoundingClientRect(),n=this.getTableContainer().getBoundingClientRect();o.style[e.TableDomUtils.CSS_PROP._TOP]=s.top-n.top-o.clientHeight/2+e.TableDomUtils.CSS_VAL._PX,o.style[e.TableDomUtils.CSS_PROP._LEFT]=i.clientWidth/2+e.TableDomUtils.CSS_VAL._PX}},e.TableDomUtils.prototype.moveTableBodyRowTouchSelectionAffordanceBottom=function(l){var o=this.getTableBodyRowTouchSelectionAffordanceBottom();if(null!=o){t(o).data("rowIdx",l),t(o.children[0]).data("rowIdx",l);var i=this.getTableBody(),s=this.getTableBodyRow(l).getBoundingClientRect(),n=this.getTableContainer().getBoundingClientRect();o.style[e.TableDomUtils.CSS_PROP._TOP]=s.top-n.top+s.height-o.clientHeight/2+e.TableDomUtils.CSS_VAL._PX,o.style[e.TableDomUtils.CSS_PROP._LEFT]=i.clientWidth/2+e.TableDomUtils.CSS_VAL._PX}},e.TableDomUtils.prototype.moveTableHeaderColumn=function(l,o,i){var s=this.component._getColumnDefs(),n=this.getTableHeaderColumn(l),a=this.getTableFooterCell(l),r=null,_=null,h=null,u=null,d=null,S=!1;o===s.length&&(o-=1,S=!0),null!=n&&(d=n.getAttribute(e.TableDomUtils.DOM_ATTR._COLSPAN),null==(_=this.getTableHeaderColumn(o))||null!=d&&1!==d||(S?_.parentNode.insertBefore(n,_.nextSibling):_.parentNode.insertBefore(n,_))),null!=a&&(d=a.getAttribute(e.TableDomUtils.DOM_ATTR._COLSPAN),null==(h=this.getTableFooterCell(o))||null!=d&&1!==d||(S?h.parentNode.insertBefore(a,h.nextSibling):h.parentNode.insertBefore(a,h)));var T,c=this.getTableBodyRows();if(null!=c)for(T=0;T<c.length;T++)null!=(r=this.getTableBodyCell(T,l,null))&&(u=this.getTableBodyCell(T,o,null),d=r.getAttribute(e.TableDomUtils.DOM_ATTR._COLSPAN),null==u||null!=d&&1!==d||(S?u.parentNode.insertBefore(r,u.nextSibling):u.parentNode.insertBefore(r,u)));var m=[],C=this.options.columns.length;for(T=0;T<C;T++)m[T]=t.extend({},{},this.options.columns[T]);var E=l<o&&!S?o-1:o,D=m.splice(l,1);m.splice(E,0,D[0]);var b=this.component._columnDefArray.splice(l,1);if(this.component._columnDefArray.splice(E,0,b[0]),!this._columnsDestMap)for(this._columnsDestMap=[],T=0;T<m.length;T++)this._columnsDestMap[T]=T;var g=this._columnsDestMap.splice(l,1);return this._columnsDestMap.splice(E,0,g[0]),this.component.option("columns",m,{_context:{writeback:!0,originalEvent:i,internalSet:!0}}),this.component._queueTask(function(){}),this._columnsDestMap},e.TableDomUtils.prototype.refreshContextMenu=function(){var l=this._menuContainer;if(l){var o,i=l.querySelectorAll("[data-oj-command]");for(o=0;o<i.length;o++){var s=t(i[o]).children(e.TableDomUtils.DOM_ELEMENT._A);if(s.length>0){var n,a=i[o].getAttribute("data-oj-command").split("-");"sort"===(a=a[a.length-1])?n=this.component.getTranslatedString("labelSort"):"sortAsc"===a?n=this.component.getTranslatedString("labelSortAsc"):"sortDsc"===a?n=this.component.getTranslatedString("labelSortDsc"):"resize"===a&&(n=this.component.getTranslatedString("labelResize")),s.contents().filter(function(){return 3===this.nodeType})[0].nodeValue=n}}}},e.TableDomUtils.prototype.refreshTableDimensions=function(e,t,l,o,i){this._refreshTableDimensions(e,t,l,o,i),this.component._setCurrentRow(this.options.currentRow,null)},e.TableDomUtils.prototype.removeDragOverIndicatorColumn=function(){var t=this.getTable().querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_INDICATOR_BEFORE_CLASS+",."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_INDICATOR_AFTER_CLASS),l=0;if(t&&t.length>0){var o=t.length;for(l=0;l<o;l++)t[l].classList.remove(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_INDICATOR_BEFORE_CLASS),t[l].classList.remove(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_INDICATOR_AFTER_CLASS)}},e.TableDomUtils.prototype.removeDragOverIndicatorRow=function(){var l,o=this.getTableBody(),i=o.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_DRAG_INDICATOR_BEFORE_CLASS),s=o.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_DRAG_INDICATOR_AFTER_CLASS);if(i&&i.length>0){var n=i.length;for(l=0;l<n;l++)t(i[l]).remove()}if(s&&s.length>0){var a=s.length;for(l=0;l<a;l++)t(s[l]).remove()}var r=this.getTableBodyRows();null!=r&&0!==r.length||this.component._showNoDataMessage()},e.TableDomUtils.prototype.removeTableBodyRow=function(e){var l=this.getTableBodyRow(e);null!=l&&(n.subtreeDetached(l),this.component._hasCellTemplate&&this.component._cleanTemplateNodes(l),t(l).remove(),this.clearCachedDomRowData())},e.TableDomUtils.prototype.removeAllTableBodyRows=function(){var e=this.getTableBodyRows();if(null!=e&&e.length>0){var l=this.getTableBody();null!=l&&(n.subtreeDetached(l),this.component._hasCellTemplate&&(this.component._cleanTemplateNodes(l),this.component._hasCellTemplate=!1,this.component._registerDomEventListeners()),t(l).empty()),this.clearCachedDomRowData()}},e.TableDomUtils.prototype.removeTableBodyRowTouchSelectionAffordance=function(){var l,o=this.getTableContainer().getElementsByClassName(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOUCH_AREA_CLASS);if(null!=o&&o.length>0)for(l=0;l<o.length;l++)t(o[l]).remove()},e.TableDomUtils.prototype.removeTableHeaderColumnDragImage=function(){var l=this.getTableContainer().querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DRAG_IMAGE);if(l&&l.length>0)for(var o=l.length,i=0;i<o;i++)t(l[i]).remove()},e.TableDomUtils.prototype.removeTableHeaderColumnResizeIndicator=function(){var l=this.getTableHeaderColumnResizeIndicator();l&&(t(l).remove(),this._clearCachedDom(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_RESIZE_INDICATOR_CLASS))},e.TableDomUtils.prototype.setScrollLeft=function(e,t){"rtl"===this.component._GetReadingDirection()&&(t=Math.abs(t),this._isWebkit()?t=e.scrollWidth-e.clientWidth-t:this._isFF()&&(t*=-1));e.scrollLeft!==t&&(e.scrollLeft=t)},e.TableDomUtils.prototype.setTableBodyCellAttributes=function(t,l,o,i,s){var n=s.getAttribute(e.TableDomUtils.DOM_ATTR._ID);if(!(null!=n&&n.length>0)){var a=this.options.accessibility,r=this.component._getColumnDefs()[i];if(null!=r){var _=null,h=this.component._isTableHeaderless();_=null!=a&&null!=a.rowHeader?a.rowHeader:this.component._getColumnDefs()[0].id;var u=null!=l?l.toString():t.toString(),d=null==o?this.hashCode(u):o,S=this.getTableId()+":"+_+"_"+d,T=this.getTableId()+":"+r.id;_===r.id?(n=S,h&&(T="")):(n=S+"_"+i,T=h?S:T+" "+S),s.setAttribute(e.TableDomUtils.DOM_ATTR._ID,n),s.getAttribute(e.TableDomUtils.DOM_ATTR._HEADERS)||s.setAttribute(e.TableDomUtils.DOM_ATTR._HEADERS,T)}}},e.TableDomUtils.prototype.setTableBodyRowAttributes=function(e,l){t(l).data("rowKey",e.key),t(l).data("rowData",e.data)},e.TableDomUtils.prototype.setTableHeaderColumnAttributes=function(t,l){var o=this.component._getColumnDefs()[t];l.getAttribute(e.TableDomUtils.DOM_ATTR._ID)||l.setAttribute(e.TableDomUtils.DOM_ATTR._ID,this.getTableId()+":"+o.id)},e.TableDomUtils.prototype.setTableColumnCellsClass=function(e,t,l){var o,i=this.getTableBodyRows();if(null!=i&&i.length>0)if(null===e){var s=null;if(null!=(s=t?this.getTableBody().querySelectorAll("[td]"):this.getTableBody().querySelectorAll("."+l))&&s.length>0){var n=s.length;for(o=0;o<n;o++)t?s[o].classList.add(l):s[o].classList.remove(l)}}else{var a=i.length;for(o=0;o<a;o++){var r=this.getTableBodyCell(o,e,null);t?r.classList.add(l):r.classList.remove(l)}}},e.TableDomUtils.prototype.setTableBodyMessage=function(e){var l=this.getTableBodyMessageCell();t(l).empty(),l.appendChild(document.createTextNode(e))},e.TableDomUtils.prototype.setTableInlineMessage=function(l,o,i){var s=this.getTableInlineMessage();t(s).empty(),t(s).append(e.PopupMessagingStrategyUtils.buildMessageHtml(document,l,o,i,null))},e.TableDomUtils.prototype.setTableStatusAccNotification=function(e){var l=this.getTableStatusAccNotification();t(l).empty(),l.appendChild(document.createTextNode(e))},e.TableDomUtils.prototype.styleInitialTable=function(){var t=this.getTable(),l=t.getElementsByTagName(e.TableDomUtils.DOM_ELEMENT._THEAD);l=l.length>0?l[0]:null;var o=t.getElementsByTagName(e.TableDomUtils.DOM_ELEMENT._TFOOT);o=o.length>0?o[0]:null;var i=t.getElementsByTagName(e.TableDomUtils.DOM_ELEMENT._TBODY);i=i.length>0?i[0]:null,t.setAttribute(e.TableDomUtils.DOM_ATTR._TABINDEX,"0"),this.component._focusable({element:t,applyHighlight:!0,setupHandlers:this._focusSetupHandlers.bind(this)}),this.styleTableHeader(l),this.styleTableFooter(o),this.styleTableBody(i)},e.TableDomUtils.prototype.styleTableBody=function(t){t.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_BODY_CLASS),t.setAttribute(n._OJ_CONTAINER_ATTR,this.component.widgetName)},e.TableDomUtils.prototype.styleTableBodyCell=function(l,o,i){var s=this.component._getColumnDefs()[l];!i&&o.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_CLASS)||(o.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_CLASS),o.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATE_CELL_FORM_CONTROL_CLASS),null==s||null==s.style||!i&&o.getAttribute(e.TableDomUtils.DOM_ATTR._STYLE)===s.style||o.setAttribute(e.TableDomUtils.DOM_ATTR._STYLE,s.style),null==s||null==s.className||!i&&t(o).hasClass(s.className)||t(o).addClass(s.className)),this._isVerticalGridEnabled()&&(!i&&o.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_VGRID_LINES_CLASS)||o.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_VGRID_LINES_CLASS))},e.TableDomUtils.prototype.styleTableBodyRow=function(t,l){!l&&t.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS)||t.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_DATA_ROW_CLASS),this._isHorizontalGridEnabled()&&(!l&&t.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_HGRID_LINES_CLASS)||t.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_HGRID_LINES_CLASS))},e.TableDomUtils.prototype.styleTableContainer=function(t){t.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_CLASS),t.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_CONTAINER_CLASS),t.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._WIDGET),this.options.display===e.TableDomUtils._OPTION_DISPLAY._GRID?t.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_COMPACT_CLASS):t.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_COMPACT_CLASS);var l=this.options.editMode;null!=l&&l!==this.component._OPTION_EDIT_MODE._NONE?t.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_EDIT_CLASS):t.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_EDIT_CLASS)},e.TableDomUtils.prototype.styleTableFooter=function(t){t&&(t.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CLASS),t.getElementsByTagName(e.TableDomUtils.DOM_ELEMENT._TR)[0].classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_ROW_CLASS))},e.TableDomUtils.prototype.styleTableFooterCell=function(l,o){var i=this.component._getColumnDefs()[l];null!=i.footerStyle&&o.setAttribute(e.TableDomUtils.DOM_ATTR._STYLE,i.footerStyle),o.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CELL_CLASS)||o.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_FOOTER_CELL_CLASS),this._isVerticalGridEnabled()&&!o.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_VGRID_LINES_CLASS)&&o.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_VGRID_LINES_CLASS),i.footerClassName&&t(o).addClass(i.footerClassName)},e.TableDomUtils.prototype.styleTableHeader=function(t){if(t){t.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_HEADER_CLASS),t.style[e.TableDomUtils.CSS_PROP._DISPLAY]="table-header-group";var l=t.getElementsByTagName(e.TableDomUtils.DOM_ELEMENT._TR)[0];l.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_HEADER_ROW_CLASS),l.style[e.TableDomUtils.CSS_PROP._POSITION]=e.TableDomUtils.CSS_VAL._RELATIVE}},e.TableDomUtils.prototype.styleTableHeaderColumn=function(l,o,i,s){var n=this.component._getColumnDefs()[l];!s&&o.classList.contains(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CELL_CLASS)||(o.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CELL_CLASS),this._isVerticalGridEnabled()&&(!s&&o.classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_VGRID_LINES_CLASS)||o.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_VGRID_LINES_CLASS)),null==n.headerStyle||!s&&o.getAttribute(e.TableDomUtils.DOM_ATTR._STYLE)===n.headerStyle||o.setAttribute(e.TableDomUtils.DOM_ATTR._STYLE,n.headerStyle),null==n.headerClassName||!s&&t(o).hasClass(n.headerClassName)||t(o).addClass(n.headerClassName))},e.TableDomUtils.prototype._getColspanLogicalElements=function(t){for(var l=0,o=[],i=t.length,s=0;s<i;s++){var n=t[s].getAttribute(e.TableDomUtils.DOM_ATTR._COLSPAN);if(null!=n){n=parseInt(n,10);for(var a=0;a<n;a++)o[l+a]=t[s];l+=n}else o[l]=t[s],l+=1}return o},e.TableDomUtils.prototype._isHorizontalGridEnabled=function(){return this.options.horizontalGridVisible===e.TableDomUtils._OPTION_ENABLED||this.options.horizontalGridVisible===e.TableDomUtils._OPTION_AUTO},e.TableDomUtils.prototype._isVerticalGridEnabled=function(){return this.options.verticalGridVisible===e.TableDomUtils._OPTION_ENABLED||this.options.verticalGridVisible===e.TableDomUtils._OPTION_AUTO&&this.options.display===e.TableDomUtils._OPTION_DISPLAY._GRID},e.TableDomUtils.prototype._isFF=function(){return navigator.userAgent.toLowerCase().indexOf("firefox")>-1},e.TableDomUtils.prototype._isIE=function(){if(void 0===this._browserIsIE){var e=navigator.userAgent;if("Microsoft Internet Explorer"===navigator.appName){var t=new RegExp("MSIE ([0-9]{1,}[.0-9]{0,})").exec(e);null!=t&&(this._browserIsIE=parseFloat(t[1]))}else e.indexOf("Trident")>=0?this._browserIsIE=11:this._browserIsIE=null}return this._browserIsIE},e.TableDomUtils.prototype._isWebkit=function(){if(void 0===this._browserIsWebkit){var e=navigator.userAgent.toLowerCase();this._browserIsWebkit=/webkit/.test(e)&&!/edge/.test(e)}return this._browserIsWebkit},e.TableDomUtils.prototype._refreshTableDimensions=function(l,o,i,s,n){var a=this.getTable(),r=this.getTableContainer(),_=this.getTableBody();if(!n){if(null!=l&&l===this._cacheDomDimensions.tableContainerWidth&&null!=o&&o===this._cacheDomDimensions.tableContainerHeight)return;var h=_.scrollHeight,u=_.scrollWidth;if(null==o&&void 0!==this._cacheDomDimensions.tableBodyScrollHeight&&null!==this._cacheDomDimensions.tableBodyScrollHeight&&null==l&&void 0!==this._cacheDomDimensions.tableBodyScrollWidth&&null!==this._cacheDomDimensions.tableBodyScrollWidth){var d=Math.abs(h-this._cacheDomDimensions.tableBodyScrollHeight),S=Math.abs(u-this._cacheDomDimensions.tableBodyScrollWidth);if(d<=1&&S<=1)return;if(this._tableHeightConstrained&&d>1&&S<=1&&h>this._cacheDomDimensions.tableBodyScrollHeight)return}}var T=null,c=null;null!=this.component._scrollTop&&this.component._scrollTop>0&&(T=this.component._scrollTop),null!=this.component._scrollLeft&&this.component._scrollLeft>0&&(c=this.component._scrollLeft),this._removeTableDimensionsStyling(),this.styleTableContainer(r);var m=this.isTableContainerScrollable();if(1===m[0]?this._tableHeightConstrained=!0:this._tableHeightConstrained=!1,1===m[1]?this._tableWidthConstrained=!0:this._tableWidthConstrained=!1,null!=_){if(this._tableHeightConstrained||this._tableWidthConstrained){var C=this.getTableHeader(),E=this.getTableFooter(),D=this.getTableBottomSlot();r.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_SCROLL_CLASS),this._tableDimensions||(this._tableDimensions={}),l>0||o>0?(l>0&&this._tableWidthConstrained&&(this._tableDimensions[e.TableDomUtils.CSS_PROP._WIDTH]=l),o>0&&this._tableHeightConstrained&&(this._tableDimensions[e.TableDomUtils.CSS_PROP._HEIGHT]=o)):(this._tableHeightConstrained?this._tableDimensions[e.TableDomUtils.CSS_PROP._HEIGHT]=r.offsetHeight:this._tableDimensions[e.TableDomUtils.CSS_PROP._HEIGHT]=0,this._tableWidthConstrained?this._tableDimensions[e.TableDomUtils.CSS_PROP._WIDTH]=r.offsetWidth:this._tableDimensions[e.TableDomUtils.CSS_PROP._WIDTH]=0),null==this._tableBorderWidth&&(this._tableBorderWidth=t(r).outerWidth()-t(r).innerWidth()),null==this._tableBorderHeight&&(this._tableBorderHeight=t(r).outerHeight()-t(r).innerHeight());var b=0;this._tableHeightConstrained&&!this._tableWidthConstrained&&(r.style[e.TableDomUtils.CSS_PROP._OVERFLOW]=e.TableDomUtils.CSS_VAL._AUTO,b=r.offsetWidth-r.clientWidth,this._tableDimensions[e.TableDomUtils.CSS_PROP._WIDTH]>0?a.style[e.TableDomUtils.CSS_PROP._WIDTH]=r.clientWidth+e.TableDomUtils.CSS_VAL._PX:(a.style[e.TableDomUtils.CSS_PROP._WIDTH]=r.scrollWidth+b+e.TableDomUtils.CSS_VAL._PX,1===(m=this.isTableContainerScrollable())[1]&&(a.style[e.TableDomUtils.CSS_PROP._WIDTH]=r.clientWidth+e.TableDomUtils.CSS_VAL._PX)),r.style[e.TableDomUtils.CSS_PROP._OVERFLOW]="");var g=this._tableHeightConstrained&&!this.component._isTouchDevice()&&r.classList.contains(e.TableDomUtils.MARKER_STYLE_CLASSES._HIDE_VERTICAL_SCROLLBAR);g?(_.style[e.TableDomUtils.CSS_PROP._OVERFLOW_Y]="hidden",this._setColumnWidths(b)):this._setColumnWidths(),this._tableHeightConstrained&&r.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_SCROLL_VERTICAL_CLASS),this._tableWidthConstrained&&r.classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_SCROLL_HORIZONTAL_CLASS);var A=a.clientWidth;b>0&&!g&&(a.style[e.TableDomUtils.CSS_PROP._WIDTH]=r.offsetWidth+e.TableDomUtils.CSS_VAL._PX);var R=0,L=a.getElementsByTagName("caption");if(null!=L&&L.length>0&&(L=L[0],R=t(L).outerHeight(),L.style[e.TableDomUtils.CSS_PROP._DISPLAY]=e.TableDomUtils.CSS_VAL._INLINE,null!=C)){var f=window.getComputedStyle(r);C.style[e.TableDomUtils.CSS_PROP._BORDER_TOP]=f[e.TableDomUtils.CSS_PROP._BORDER_TOP]}var p=0;null!=C&&(p=t(C).outerHeight());var O,U=0,y=0;this._tableWidthConstrained?_.style[e.TableDomUtils.CSS_PROP._WIDTH]=this._tableDimensions[e.TableDomUtils.CSS_PROP._WIDTH]-this._tableBorderWidth+e.TableDomUtils.CSS_VAL._PX:b>0&&!g&&(_.style[e.TableDomUtils.CSS_PROP._WIDTH]=A-this._tableBorderWidth+b+e.TableDomUtils.CSS_VAL._PX),null!=E&&(U=t(E).outerHeight(),_.style[e.TableDomUtils.CSS_PROP._TOP]=-1*U+e.TableDomUtils.CSS_VAL._PX);var I=0,v=this.getTableInlineMessage();null!=v&&v.style[e.TableDomUtils.CSS_PROP._DISPLAY]!==e.TableDomUtils.CSS_VAL._NONE&&v.clientHeight>0&&(I=t(v).outerHeight());var N=0;if(null!=D&&D.style[e.TableDomUtils.CSS_PROP._DISPLAY]!==e.TableDomUtils.CSS_VAL._NONE&&D.clientHeight>0&&(N=t(D).outerHeight()),this._tableHeightConstrained?(y=this._tableDimensions[e.TableDomUtils.CSS_PROP._HEIGHT]-p-U-R-I-N-this._tableBorderHeight)>0&&(_.style[e.TableDomUtils.CSS_PROP._HEIGHT]=y+e.TableDomUtils.CSS_VAL._PX,_.style[e.TableDomUtils.CSS_PROP._MIN_HEIGHT]=y+e.TableDomUtils.CSS_VAL._PX):y=t(_).outerHeight(),O=this.getScrollbarWidth(),this._tableWidthConstrained){var w=this.getTableBodyRows();if(null!=w&&w.length>0){if(_.style[e.TableDomUtils.CSS_PROP._OVERFLOW_X]=e.TableDomUtils.CSS_VAL._AUTO,r.style[e.TableDomUtils.CSS_PROP._OVERFLOW_X]=e.TableDomUtils.CSS_VAL._HIDDEN,r.style[e.TableDomUtils.CSS_PROP._OVERFLOW_Y]=e.TableDomUtils.CSS_VAL._HIDDEN,null!=C){var M=this._tableDimensions[e.TableDomUtils.CSS_PROP._WIDTH]-this._tableBorderWidth;M>0&&(C.style[e.TableDomUtils.CSS_PROP._WIDTH]=O>0?M-O+e.TableDomUtils.CSS_VAL._PX:M+e.TableDomUtils.CSS_VAL._PX)}}else _.style[e.TableDomUtils.CSS_PROP._OVERFLOW_X]=e.TableDomUtils.CSS_VAL._HIDDEN,r.style[e.TableDomUtils.CSS_PROP._OVERFLOW_X]=e.TableDomUtils.CSS_VAL._AUTO,r.style[e.TableDomUtils.CSS_PROP._OVERFLOW_Y]=e.TableDomUtils.CSS_VAL._HIDDEN}null!=E&&(E.style[e.TableDomUtils.CSS_PROP._TOP]=y+e.TableDomUtils.CSS_VAL._PX),this._setHeaderColumnLastWidth()}else this.component._isTableColumnsWidthSet()&&this._setColumnWidths();if(this._setHeaderColumnOverflowWidths(),this._removeTableBodyRowBottomBorder(m[0]<0),this.refreshTableStatusPosition(),null==T||i)i&&(this.getScroller().scrollTop=0,t(this.getScroller()).scroll());else{var B=this.getScroller().scrollHeight-this.getScroller().clientHeight;T=T>B?B:T,this.component._isLoadMoreOnScroll()&&B===T&&(T-=1),this.component._skipScrollUpdate=!0,this.getScroller().scrollTop=T,t(this.getScroller()).scroll()}null==c||s?s&&(this.setScrollLeft(this.getScroller(),0),t(this.getScroller()).scroll()):(this.component._skipScrollUpdate=!0,this.setScrollLeft(this.getScroller(),c),t(this.getScroller()).scroll()),this._cacheDomDimensions.tableContainerHeight=t(r).outerHeight(),this._cacheDomDimensions.tableContainerWidth=t(r).outerWidth(),this._cacheDomDimensions.tableBodyScrollHeight=_.scrollHeight,this._cacheDomDimensions.tableBodyScrollWidth=_.scrollWidth}},e.TableDomUtils.prototype.refreshTableStatusPosition=function(){if(this.component._isStatusMessageShown()){var l=this.getTableContainer(),o=this.getTableBody(),i=this.getTableStatusMessage(),s=l;o.clientHeight>0&&(s=o),i.style[e.TableDomUtils.CSS_PROP._HEIGHT]=o.clientHeight+e.TableDomUtils.CSS_VAL._PX,i.style[e.TableDomUtils.CSS_PROP._WIDTH]=o.clientWidth+e.TableDomUtils.CSS_VAL._PX;var n=i.children[0],a="rtl"===this.component._GetReadingDirection(),r={my:"center",at:"center",collision:"none",of:s};r=e.PositionUtils.normalizeHorizontalAlignment(r,a),t(i).position(r);var _={my:"center",at:"center",collision:"none",of:i};_=e.PositionUtils.normalizeHorizontalAlignment(_,a),t(n).position(_)}},e.TableDomUtils.prototype._cacheDomElement=function(e,t){this._domCache||(this._domCache={}),this._domCache[e]=t},e.TableDomUtils.prototype._clearCachedDom=function(e){e&&this._domCache?delete this._domCache[e]:this._domCache={},this._cacheDomDimensions={}},e.TableDomUtils.prototype._getCachedDomElement=function(e){return this._domCache?this._domCache[e]:null},e.TableDomUtils.prototype._isCachedDomElement=function(e){return this._domCache||(this._domCache={}),-1!==Object.keys(this._domCache).indexOf(e)},e.TableDomUtils.prototype._getTableElementByClassName=function(e,t){if(!this._isCachedDomElement(e)){var l=this.getTableContainer();if(l)if(this._cacheDomElement(e,null),t){if(this._cacheDomElement(e,this._getChildElementByClassName(l,e)),null==this._getCachedDomElement(e)){var o=this.getTable();this._cacheDomElement(e,this._getChildElementByClassName(o,e))}}else{var i=l.getElementsByClassName(e);i&&i.length>0&&this._cacheDomElement(e,i[0])}}return this._getCachedDomElement(e)},e.TableDomUtils.prototype._getChildElementByClassName=function(e,t){if(null!=e.childNodes&&e.childNodes.length>0)for(var l=0;l<e.childNodes.length;l++)if(null!=e.childNodes[l].classList&&e.childNodes[l].classList.contains(t))return e.childNodes[l];return null},e.TableDomUtils.prototype._focusSetupHandlers=function(e,t){this.component._setFocusInHandler(e),this.component._setFocusOutHandler(t)},e.TableDomUtils.prototype._removeHeaderColumnAndCellColumnWidths=function(){var t,l=this.component._getColumnDefs().length;for(t=0;t<l;t++){var o=this.getTableHeaderColumn(t);null!=o&&(o.style[e.TableDomUtils.CSS_PROP._MIN_WIDTH]="")}var i=this.getTableBodyRows();if(null!=i&&i.length>0)for(t=0;t<l;t++){var s=this.getTableBodyCell(0,t,null);if(null!=s&&(s.style[e.TableDomUtils.CSS_PROP._MIN_WIDTH]="",null!=this._forcedWidthColumns&&this._forcedWidthColumns[t]))for(var n=0;n<i.length;n++)(s=this.getTableBodyCell(n,t,null)).style[e.TableDomUtils.CSS_PROP._MIN_WIDTH]="",s.style[e.TableDomUtils.CSS_PROP._WIDTH]="",s.style[e.TableDomUtils.CSS_PROP._MAX_WIDTH]=""}for(t=0;t<l;t++){var a=this.getTableFooterCell(t);null!=a&&(a.style[e.TableDomUtils.CSS_PROP._MIN_WIDTH]="")}},e.TableDomUtils.prototype._removeTableBodyRowBottomBorder=function(t){if(this._isHorizontalGridEnabled()){var l=this.getTableBodyRows();if(null!=l&&l.length>0){for(var o=l.length,i=0;i<o;i++)l[i].classList.contains(e.TableDomUtils.CSS_CLASSES._TABLE_HGRID_LINES_CLASS)||l[i].classList.add(e.TableDomUtils.CSS_CLASSES._TABLE_HGRID_LINES_CLASS);var s=l[l.length-1];t||s.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_HGRID_LINES_CLASS)}}},e.TableDomUtils.prototype._removeTableDimensionsStyling=function(){var t=this.getTable(),l=this.getTableContainer(),o=this.getTableHeader(),i=this.getTableHeaderRow(),s=this.getTableFooter(),n=this.getTableFooterRow(),a=this.getTableBody();if(l.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_SCROLL_CLASS),l.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_SCROLL_VERTICAL_CLASS),l.classList.remove(e.TableDomUtils.CSS_CLASSES._TABLE_SCROLL_HORIZONTAL_CLASS),l.style[e.TableDomUtils.CSS_PROP._OVERFLOW]=e.TableDomUtils.CSS_VAL._VISIBLE,null!=o){o.setAttribute(e.TableDomUtils.DOM_ATTR._STYLE,""),i.setAttribute(e.TableDomUtils.DOM_ATTR._STYLE,"");var r=i.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_TEXT_CLASS);if(r&&r.length>0)for(var _=r.length,h=0;h<_;h++)r[h].style[e.TableDomUtils.CSS_PROP._WIDTH]=""}null!=s&&(s.setAttribute(e.TableDomUtils.DOM_ATTR._STYLE,""),n.setAttribute(e.TableDomUtils.DOM_ATTR._STYLE,"")),t.style[e.TableDomUtils.CSS_PROP._DISPLAY]="",t.style[e.TableDomUtils.CSS_PROP._WIDTH]="",null!=a&&a.setAttribute(e.TableDomUtils.DOM_ATTR._STYLE,""),this._removeHeaderColumnAndCellColumnWidths()},e.TableDomUtils.prototype._getBoxStyle=function(t){return{boxSizing:t[e.TableDomUtils.CSS_PROP._BOX_SIZING],borderWidth:(parseFloat(t[e.TableDomUtils.CSS_PROP._BORDER_RIGHT_WIDTH])||0)+(parseFloat(t[e.TableDomUtils.CSS_PROP._BORDER_LEFT_WIDTH])||0),paddingWidth:(parseFloat(t[e.TableDomUtils.CSS_PROP._PADDING_RIGHT])||0)+(parseFloat(t[e.TableDomUtils.CSS_PROP._PADDING_LEFT])||0)}},e.TableDomUtils.prototype._applyColumnHeaderHeight=function(t){var l=t.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_TEXT_CLASS);if(l&&l.length>0){var o=l[0].clientHeight+e.TableDomUtils.CSS_VAL._PX,i=t.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CLASS);i&&i.length>0&&(i[0].style[e.TableDomUtils.CSS_PROP._MIN_HEIGHT]=o)}},e.TableDomUtils.prototype._getForcedColumnWidth=function(t,l){var o=t+("border-box"===l.boxSizing?l.borderWidth:-l.paddingWidth);return o+=e.TableDomUtils.CSS_VAL._PX},e.TableDomUtils.prototype._applyForcedColumnWidth=function(t,l){var o=t;o.style[e.TableDomUtils.CSS_PROP._MIN_WIDTH]=l,o.style[e.TableDomUtils.CSS_PROP._WIDTH]=l,o.style[e.TableDomUtils.CSS_PROP._MAX_WIDTH]=l},e.TableDomUtils.prototype._setColumnWidths=function(t){var l,o,s,n,a,r,h,u,d,S,T,c,m,C,E,D,b=[],g=[],A=[],R=this.component._getColumnDefs(),L=R.length,f=this.getTableBodyRows();for(this._forcedWidthColumns=[],l=0;l<L;l++)if((s=R[l].width)>0){if(this._forcedWidthColumns[l]=!0,"number"!=typeof s&&(E=this.component._LOGGER_MSG._ERR_WIDTH_INVALID_TYPE_SUMMARY,D=i.applyParameters(this.component._LOGGER_MSG._ERR_WIDTH_INVALID_TYPE_DETAIL,{width:s}),_.warn(E+"\n"+D),s=parseFloat(s)),b[l]=s,g[l]=s,A[l]=s,null!==(a=this.getTableHeaderColumn(l))&&(null!==this.component._getColumnRenderer(l,"header")?h=this._getBoxStyle(window.getComputedStyle(a)):(u||(u=this._getBoxStyle(window.getComputedStyle(a))),h=u),this._applyForcedColumnWidth(a,this._getForcedColumnWidth(s,h))),d=this.getTableBodyCell(0,l,null),null!==f&&null!==d)for(this.component._hasRowOrCellRendererOrTemplate(l)?S=this._getBoxStyle(window.getComputedStyle(d)):(T||(T=this._getBoxStyle(window.getComputedStyle(d))),S=T),C=this._getForcedColumnWidth(s,S),o=0;o<f.length;o++)this._applyForcedColumnWidth(this.getTableBodyCell(o,l,null),C);null!==(c=this.getTableFooterCell(l))&&(m=this._getBoxStyle(window.getComputedStyle(c)),this._applyForcedColumnWidth(c,this._getForcedColumnWidth(s,m)))}else this._forcedWidthColumns[l]=!1,b[l]=null,g[l]=null,A[l]=null;for(l=0;l<L;l++)this._forcedWidthColumns[l]||(null!==(a=this.getTableHeaderColumn(l))&&(r=window.getComputedStyle(a),s=parseFloat(r[e.TableDomUtils.CSS_PROP._WIDTH])||0,b[l]=s,null!==this.component._getColumnRenderer(l,"header")?h=this._getBoxStyle(r):(u||(u=this._getBoxStyle(r)),h=u)),d=this.getTableBodyCell(0,l,null),null!==f&&null!==d&&(this.component._hasRowOrCellRendererOrTemplate(l)?S=this._getBoxStyle(window.getComputedStyle(d)):(T||(T=this._getBoxStyle(window.getComputedStyle(d))),S=T),n=S.paddingWidth>h.paddingWidth?s-S.paddingWidth+h.paddingWidth:s+h.paddingWidth-S.paddingWidth,t&&l===L-1&&(n+=t),g[l]=n),null!==(c=this.getTableFooterCell(l))&&(n=(m=this._getBoxStyle(window.getComputedStyle(c))).paddingWidth>h.paddingWidth?s-m.paddingWidth+h.paddingWidth:s+h.paddingWidth-m.paddingWidth,A[l]=n));for(l=0;l<L;l++)this._forcedWidthColumns[l]?null!==(a=this.getTableHeaderColumn(l))&&this._applyColumnHeaderHeight(a):(null!==(a=this.getTableHeaderColumn(l))&&(a.style[e.TableDomUtils.CSS_PROP._MIN_WIDTH]=b[l]+e.TableDomUtils.CSS_VAL._PX,this._applyColumnHeaderHeight(a)),d=this.getTableBodyCell(0,l,null),null!==f&&null!==d&&(d.style[e.TableDomUtils.CSS_PROP._MIN_WIDTH]=g[l]+e.TableDomUtils.CSS_VAL._PX),null!==(c=this.getTableFooterCell(l))&&(c.style[e.TableDomUtils.CSS_PROP._MIN_WIDTH]=A[l]+e.TableDomUtils.CSS_VAL._PX))},e.TableDomUtils.prototype._setHeaderColumnLastWidth=function(){var t=this.getScrollbarWidth();if(t>0&&this.getScrollbarHeight()<=1){var l=this.component._getColumnDefs().length,o=this.getTableHeaderColumn(l-1),i=0;if(null!=o){for(var s=0;s<l;s++){var n=this.getTableHeaderColumn(s),a=window.getComputedStyle(n);i+=parseInt(a[e.TableDomUtils.CSS_PROP._WIDTH],10)||0}var r=this.getTableHeader(),_=window.getComputedStyle(r);if((parseInt(_[e.TableDomUtils.CSS_PROP._WIDTH],10)||0)>i){var h=window.getComputedStyle(o),u=parseInt(h[e.TableDomUtils.CSS_PROP._WIDTH],10)||0;o.style[e.TableDomUtils.CSS_PROP._MIN_WIDTH]=u+t+e.TableDomUtils.CSS_VAL._PX}}}},e.TableDomUtils.prototype._setHeaderColumnOverflowWidths=function(){for(var t=this.component._getColumnDefs(),l=t.length,o=0;o<l;o++){var i=t[o],s=this.getTableHeaderColumn(o);if(null!=s){var n=s.getElementsByClassName(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CLASS);if(n.length>0){n=n[0];var a=s.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_TEXT_CLASS);if(a&&a.length>0){var r=0;if(i.sortable===e.TableDomUtils._OPTION_ENABLED&&(r=s.querySelectorAll("."+e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_SORT_PACEHOLDER_CLASS)[0].clientWidth),n.clientWidth>0&&a[0].clientWidth+r>n.clientWidth){a[0].style[e.TableDomUtils.CSS_PROP._WIDTH]="";var _=a[0].clientWidth,h=s.clientWidth-r;_>h+1&&(a[0].style[e.TableDomUtils.CSS_PROP._WIDTH]=h+e.TableDomUtils.CSS_VAL._PX)}}}}}},e.TableDomUtils.CSS_CLASSES={_CHECKBOX_ACC_SELECT_COLUMN_CLASS:"oj-table-checkbox-acc-select-column",_CHECKBOX_ACC_SELECT_ROW_CLASS:"oj-table-checkbox-acc-select-row",_TABLE_CONTAINER_CLASS:"oj-table-container",_TABLE_SCROLLER_CLASS:"oj-table-scroller",_TABLE_CLASS:"oj-table",_TABLE_COMPACT_CLASS:"oj-table-grid-display",_TABLE_EDIT_CLASS:"oj-table-editable",_TABLE_SCROLL_CLASS:"oj-table-scroll",_TABLE_SCROLL_VERTICAL_CLASS:"oj-table-scroll-vertical",_TABLE_SCROLL_HORIZONTAL_CLASS:"oj-table-scroll-horizontal",_TABLE_ELEMENT_CLASS:"oj-table-element",_TABLE_FOOTER_CLASS:"oj-table-footer",_TABLE_FOOTER_ROW_CLASS:"oj-table-footer-row",_TABLE_HEADER_CLASS:"oj-table-header",_TABLE_HEADER_ROW_CLASS:"oj-table-header-row",_TABLE_BOTTOM_SLOT_CLASS:"oj-table-slot-bottom",_COLUMN_HEADER_CELL_CLASS:"oj-table-column-header-cell",_COLUMN_HEADER_DROP_EMPTY_CELL_CLASS:"oj-table-column-header-drop-empty-cell",_COLUMN_HEADER_ACC_SELECT_COLUMN_CLASS:"oj-table-column-header-acc-select-column",_COLUMN_HEADER_ACC_SELECT_ROW_CLASS:"oj-table-column-header-acc-select-row",_COLUMN_HEADER_ACC_SELECT_ROW_TEXT_CLASS:"oj-table-column-header-acc-select-row-text",_COLUMN_HEADER_CLASS:"oj-table-column-header",_COLUMN_HEADER_TEXT_CLASS:"oj-table-column-header-text",_COLUMN_HEADER_ASC_CLASS:"oj-table-column-header-asc",_COLUMN_HEADER_DSC_CLASS:"oj-table-column-header-dsc",_COLUMN_HEADER_SORT_PACEHOLDER_CLASS:"oj-table-column-header-sort-placeholder",_COLUMN_HEADER_ACC_ASC_LINK_CLASS:"oj-table-column-header-acc-asc-link",_COLUMN_HEADER_ACC_DSC_LINK_CLASS:"oj-table-column-header-acc-dsc-link",_COLUMN_HEADER_ASC_LINK_CLASS:"oj-table-column-header-asc-link",_COLUMN_HEADER_DSC_LINK_CLASS:"oj-table-column-header-dsc-link",_COLUMN_HEADER_ASC_ICON_CLASS:"oj-table-column-header-asc-icon",_COLUMN_HEADER_DSC_ICON_CLASS:"oj-table-column-header-dsc-icon",_COLUMN_HEADER_DRAG_INDICATOR_BEFORE_CLASS:"oj-table-column-header-drag-indicator-before",_COLUMN_HEADER_DRAG_INDICATOR_AFTER_CLASS:"oj-table-column-header-drag-indicator-after",_COLUMN_HEADER_DRAG_IMAGE:"oj-table-column-header-cell-drag-image",_COLUMN_HEADER_RESIZE_INDICATOR_CLASS:"oj-table-column-header-resize-indicator",_TABLE_BODY_CLASS:"oj-table-body",_TABLE_DATA_ROW_CLASS:"oj-table-body-row",_TABLE_DATA_ROW_DRAG_INDICATOR_BEFORE_CLASS:"oj-table-body-row-drag-indicator-before",_TABLE_DATA_ROW_DRAG_INDICATOR_AFTER_CLASS:"oj-table-body-row-drag-indicator-after",_TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOP_CLASS:"oj-table-body-row-touch-selection-affordance-top",_TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_BOTTOM_CLASS:"oj-table-body-row-touch-selection-affordance-bottom",_TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOP_ICON_CLASS:"oj-table-body-row-touch-selection-affordance-top-icon",_TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_BOTTOM_ICON_CLASS:"oj-table-body-row-touch-selection-affordance-bottom-icon",_TABLE_DATA_ROW_TOUCH_SELECTIOM_AFFORDANCE_TOUCH_AREA_CLASS:"oj-table-body-row-touch-selection-affordance-touch-area",_TABLE_DATA_ROW_EDIT_CLASS:"oj-table-body-row-edit",_TABLE_DATA_CURRENT_ROW_CLASS:"oj-table-body-current-row",_TABLE_DATA_CELL_CLASS:"oj-table-data-cell",_TABLE_DATA_CELL_ACC_SELECT_CLASS:"oj-table-data-cell-acc-select",_TABLE_DATA_CELL_EDIT_CLASS:"oj-table-data-cell-edit",_TABLE_DATE_CELL_FORM_CONTROL_CLASS:"oj-form-control-inherit",_TABLE_VGRID_LINES_CLASS:"oj-table-vgrid-lines",_TABLE_HGRID_LINES_CLASS:"oj-table-hgrid-lines",_TABLE_FOOTER_CELL_CLASS:"oj-table-footer-cell",_TABLE_FOOTER_DROP_EMPTY_CELL_CLASS:"oj-table-footer-drop-empty-cell",_TABLE_INLINE_MESSAGE_CLASS:"oj-table-inline-message",_TABLE_STATUS_ACC_NOTIFICATION_CLASS:"oj-table-status-acc-notification",_TABLE_STATUS_MESSAGE_CLASS:"oj-table-status-message",_TABLE_STATUS_MESSAGE_TEXT_CLASS:"oj-table-status-message-text",_TABLE_LOADING_ICON_CLASS:"oj-table-loading-icon",_TABLE_BODY_MESSAGE_CLASS:"oj-table-body-message",_TABLE_BODY_MESSAGE_ROW_CLASS:"oj-table-body-message-row",_ICON_CLASS:"oj-icon",_WIDGET_ICON_CLASS:"oj-component-icon",_HIDDEN_CONTENT_ACC_CLASS:"oj-helper-hidden-accessible"},e.TableDomUtils.CSS_PROP={_DISPLAY:"display",_VISIBILITY:"visibility",_POSITION:"position",_HEIGHT:"height",_WIDTH:"width",_TOP:"top",_BOTTOM:"bottom",_LEFT:"left",_RIGHT:"right",_PADDING_TOP:"padding-top",_PADDING_LEFT:"padding-left",_PADDING_RIGHT:"padding-right",_OVERFLOW:"overflow",_OVERFLOW_X:"overflow-x",_OVERFLOW_Y:"overflow-y",_MIN_WIDTH:"min-width",_MAX_WIDTH:"max-width",_MIN_HEIGHT:"min-height",_FLOAT:"float",_BORDER_TOP:"border-top",_BORDER_BOTTOM_WIDTH:"border-bottom-width",_BORDER_LEFT_WIDTH:"border-left-width",_BORDER_RIGHT_WIDTH:"border-right-width",_MARGIN_BOTTOM:"margin-bottom",_VERTICAL_ALIGN:"vertical-align",_CURSOR:"cursor",_ZINDEX:"z-index",_BACKGROUND_COLOR:"background-color",_BOX_SIZING:"box-sizing"},e.TableDomUtils.CSS_VAL={_NONE:"none",_BLOCK:"block",_INLINE_BLOCK:"inline-block",_RELATIVE:"relative",_ABSOLUTE:"absolute",_INLINE:"inline",_AUTO:"auto",_HIDDEN:"hidden",_VISIBLE:"visible",_LEFT:"left",_PX:"px",_MIDDLE:"middle",_MOVE:"move",_FIXED:"fixed",_TRANSPARENT:"transparent",_BORDER_BOX:"border-box"},e.TableDomUtils.DOM_ATTR={_STYLE:"style",_TABINDEX:"tabindex",_TYPE:"type",_ID:"id",_TITLE:"title",_HREF:"href",_HEADERS:"headers",_COLSPAN:"colspan",_ROLE:"role",_ARIA_LABEL:"aria-label",_ARIA_HIDDEN:"aria-hidden"},e.TableDomUtils.DOM_ELEMENT={_DIV:"div",_A:"a",_TR:"tr",_TD:"td",_TH:"th",_TABLE:"table",_TBODY:"tbody",_THEAD:"thead",_TFOOT:"tfoot",_INPUT:"input",_UL:"ul",_SPAN:"span",_BUTTON:"button",_LABEL:"label"},e.TableDomUtils.MARKER_STYLE_CLASSES={_WIDGET:"oj-component",_ACTIVE:"oj-active",_CLICKABLE_ICON:"oj-clickable-icon-nocontext",_DISABLED:"oj-disabled",_ENABLED:"oj-enabled",_FOCUS:"oj-focus",_FOCUS_HIGHLIGHT:"oj-focus-highlight",_HOVER:"oj-hover",_SELECTED:"oj-selected",_WARNING:"oj-warning",_DRAGGABLE:"oj-draggable",_DRAG:"oj-drag",_HIDE_VERTICAL_SCROLLBAR:"oj-table-hide-vertical-scrollbar"},e.TableDomUtils._COLUMN_HEADER_ROW_SELECT_ID="_hdrColRowSel",e.TableDomUtils._OPTION_AUTO="auto",e.TableDomUtils._OPTION_ENABLED="enabled",e.TableDomUtils._OPTION_DISABLED="disabled",e.TableDomUtils._OPTION_SELECTION_MODES={_SINGLE:"single",_MULTIPLE:"multiple"},e.TableDomUtils._OPTION_DISPLAY={_LIST:"list",_GRID:"grid"},e.TableRendererUtils={},e.TableRendererUtils.columnHeaderDefaultRenderer=function(l,o,i,s){var n=o.headerContext.parentElement,a=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);a.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CLASS),t(n).empty(),n.appendChild(a);var r=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);r.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_TEXT_CLASS),a.insertBefore(r,a.firstChild),null!=s?s(t(r)):this.columnHeaderDefaultTextRenderer(l,r,o)},e.TableRendererUtils.columnHeaderSortableIconRenderer=function(l,o,i,s){var n=o.columnIndex,a=l._getColumnDefs()[n],r=o.headerContext.parentElement,_=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);_.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_CLASS),t(r).empty(),r.appendChild(_),"rtl"===l._GetReadingDirection()?_.style[e.TableDomUtils.CSS_PROP._PADDING_LEFT]="0px":_.style[e.TableDomUtils.CSS_PROP._PADDING_RIGHT]="0px";var h=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);h.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_CLASS),_.appendChild(h);var u,d,S=document.createElement(e.TableDomUtils.DOM_ELEMENT._A);S.setAttribute(e.TableDomUtils.DOM_ATTR._ARIA_HIDDEN,"true"),S.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_LINK_CLASS),S.classList.add(e.TableDomUtils.CSS_CLASSES._WIDGET_ICON_CLASS),S.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ASC_ICON_CLASS),S.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED),S.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._CLICKABLE_ICON),l._AddHoverable(t(S)),h.appendChild(S),void 0!==e.TableRendererUtils._headerColumnAscWidth?(u=e.TableRendererUtils._headerColumnAscWidth,d=e.TableRendererUtils._headerColumnAscHeight):(u=t(h).width(),d=t(h).height(),u>0&&d>0&&(e.TableRendererUtils._headerColumnAscWidth=u,e.TableRendererUtils._headerColumnAscHeight=d));var T=document.createElement(e.TableDomUtils.DOM_ELEMENT._A);T.setAttribute(e.TableDomUtils.DOM_ATTR._TABINDEX,"0"),T.setAttribute(e.TableDomUtils.DOM_ATTR._HREF,"#"),T.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ACC_ASC_LINK_CLASS),T.classList.add(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS),T.setAttribute(e.TableDomUtils.DOM_ATTR._ARIA_LABEL,l.getTranslatedString("labelSortAsc")+" "+a.headerText),h.appendChild(T);var c=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);c.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_SORT_PACEHOLDER_CLASS),c.style[e.TableDomUtils.CSS_PROP._DISPLAY]=e.TableDomUtils.CSS_VAL._INLINE_BLOCK,c.style[e.TableDomUtils.CSS_PROP._VERTICAL_ALIGN]=e.TableDomUtils.CSS_VAL._MIDDLE,c.style[e.TableDomUtils.CSS_PROP._WIDTH]=u+e.TableDomUtils.CSS_VAL._PX,c.style[e.TableDomUtils.CSS_PROP._HEIGHT]=d+e.TableDomUtils.CSS_VAL._PX,_.appendChild(c);var m=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);m.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_CLASS),m.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED),_.appendChild(m);var C=document.createElement(e.TableDomUtils.DOM_ELEMENT._A);C.setAttribute(e.TableDomUtils.DOM_ATTR._ARIA_HIDDEN,"true"),C.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_LINK_CLASS),C.classList.add(e.TableDomUtils.CSS_CLASSES._WIDGET_ICON_CLASS),C.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_DSC_ICON_CLASS),C.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._DISABLED),C.classList.add(e.TableDomUtils.MARKER_STYLE_CLASSES._CLICKABLE_ICON),l._AddHoverable(t(C)),m.appendChild(C);var E=document.createElement(e.TableDomUtils.DOM_ELEMENT._A);E.setAttribute(e.TableDomUtils.DOM_ATTR._TABINDEX,"0"),E.setAttribute(e.TableDomUtils.DOM_ATTR._HREF,"#"),E.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_ACC_DSC_LINK_CLASS),E.classList.add(e.TableDomUtils.CSS_CLASSES._HIDDEN_CONTENT_ACC_CLASS),E.setAttribute(e.TableDomUtils.DOM_ATTR._ARIA_LABEL,l.getTranslatedString("labelSortDsc")+" "+a.headerText),m.appendChild(E);var D=document.createElement(e.TableDomUtils.DOM_ELEMENT._DIV);D.classList.add(e.TableDomUtils.CSS_CLASSES._COLUMN_HEADER_TEXT_CLASS),_.insertBefore(D,_.firstChild),null!=s?s(t(D)):this.columnHeaderDefaultTextRenderer(l,D,o)},e.TableRendererUtils.columnHeaderDefaultTextRenderer=function(e,t,l){var o=l.columnIndex,i=e._getColumnDefs()[o],s=null==i.headerText?"":i.headerText;t.appendChild(document.createTextNode(s))},e.TableRendererUtils.tableBodyRowDefaultRenderer=function(e,t,l,o){var i=o.rowContext.parentElement,s=e._getTableDomUtils().hashCode(l.key),n=e._getColumnDefs();e._getTableDomUtils().setTableBodyRowAttributes(l,i);for(var a=n.length,r=0;r<a;r++)this.tableBodyCellDefaultRenderer(e,t,r,l,s,o)},e.TableRendererUtils.tableBodyCellDefaultRenderer=function(l,o,i,s,n,a){var r=a.rowContext.parentElement,_=l._getColumnDefs()[i],h=l._getTableDomUtils().createTableBodyCell(o,i);l._getTableDomUtils().styleTableBodyCell(i,h,!0),l._getTableDomUtils().insertTableBodyCell(o,s.key,n,i,h,r,!0);var u=null;null!=_.field&&(u=e.TableRendererUtils._getObjectPath(s.data,_.field));var d=l._getColumnRenderer(i,"cell"),S=l._getSlotTemplate(_.template);if(d||S){var T=this.getRendererContextObject(l,h,{row:s}),c={cellContext:T,columnIndex:i,data:u,row:s.data,componentElement:T.componentElement,parentElement:T.parentElement};if(d){var m=d(c);null!=m?t(h).append(m):(h=t(r).children(":not(."+e.TableDomUtils.CSS_CLASSES._TABLE_DATA_CELL_ACC_SELECT_CLASS+")")[i],l._getTableDomUtils().setTableBodyCellAttributes(o,s.key,n,i,h),l._getTableDomUtils().styleTableBodyCell(i,h,!1))}else{var C=l._getRootElement(),E=l._getTemplateEngine();if(null!=E){var D=e.TableRendererUtils.getCellSlotTemplateContextObject(l,c),b=E.execute(C,S,D,l.options.as);b instanceof Array||(b=[b]),b.map(function(e){h.appendChild(e)}),l._hasCellTemplate=!0}}}else{var g=null==(u=e.TableRendererUtils._getVal(u))?"":u;h.appendChild(document.createTextNode(g))}},e.TableRendererUtils.getRendererContextObject=function(t,l,o){var i={};i.component=n.__GetWidgetConstructor(t.element,"ojTable");var s=t.options.data;if(e.PagingTableDataSource&&s instanceof e.PagingTableDataSource&&(s=s.getWrappedDataSource()),i.datasource=s,i.parentElement=l,null!=o.row){var a=o.row,r=a.key;if(i.status=this.getRendererStatusObject(t,a),t._hasEditableRow()){var _=t._getEditableRowKey();e.Object.compareValues(r,_)?i.mode="edit":i.mode="navigation"}else i.mode="navigation";this._copyMetadata(i,a,s)}return t._FixRendererContext(i)},e.TableRendererUtils.getRendererStatusObject=function(e,l){return{rowIndex:l.index,rowKey:l.key,currentRow:t.extend({},e._getCurrentRow())}},e.TableRendererUtils.getCellSlotTemplateContextObject=function(e,t){var l=this.getSlotTemplateContextObject(e),o=t.cellContext.status.rowIndex,i=t.cellContext.status.rowKey,s=t.columnIndex;return l[e._CONST_DATA]=t.data,l.row=t.row,l[e._CONST_INDEX]=o,l.columnIndex=s,l.mode=t.cellContext.mode,l[e._CONST_KEY]=i,l},e.TableRendererUtils.getHeaderSlotTemplateContextObject=function(e,t,l){var o=this.getSlotTemplateContextObject(e);return o[e._CONST_DATA]=t,o.columnIndex=l,o},e.TableRendererUtils.getSlotTemplateContextObject=function(e){return{componentElement:e._getRootElement()}},e.TableRendererUtils._copyMetadata=function(t,l,o){if(e.FlattenedTreeTableDataSource&&o instanceof e.FlattenedTreeTableDataSource){var i=l.metadata;null==i&&(i=o._getMetadata(l.index));for(var s=Object.keys(i),n=0;n<s.length;n++){var a=s[n];t[a]=i[a]}}},e.TableRendererUtils._getObjectPath=function(e,t){if(null!=e&&("string"==typeof t||t instanceof String)&&(-1!==t.indexOf(".")||-1!==t.indexOf("[")&&-1!==t.indexOf("]"))){var l=e,o=!1;if(t.split(".").map(function(e){if(null!=l&&-1!==e.indexOf("[")&&-1!==e.indexOf("]")){var t=e.substr(0,e.indexOf("[")),i=parseInt(e.substr(e.indexOf("[")+1,e.indexOf("]")-e.indexOf("[")-1),10);l=l[t][i],o=!0}else null!==l&&void 0!==l[e]&&(l=l[e],o=!0)}),o)return l}else if(null==e)return null;return e[t]},e.TableRendererUtils._getVal=function(e){return"function"==typeof e?e():e},e.TableResizeUtils=function(e){this.component=e,this.options=e.options,this.Init()},e.Object.createSubclass(e.TableResizeUtils,e.Object,"oj.TableResizeUtils"),e.TableResizeUtils.prototype.Init=function(){e.TableResizeUtils.superclass.Init.call(this)},e.TableResizeUtils.prototype.setResizeCursor=function(e){var t=this.component._getEventTargetElement(e),l=this.component._getTableDomUtils().getElementColumnIdx(t);if(null==l)return!1;if(this.component._getColumnDefs()[l].resizable===this.component._OPTION_DISABLED&&this._resizeStartColumnIdx!==l-1&&this._resizeStartColumnIdx!==l+1)return!1;if(null==this._resizeStartColumnIdx)return null!==this._isHeaderColumnResizeStart(e)?(t.style.cursor="col-resize",!0):(t.style.cursor="",!1);var o=this.component._getTableDomUtils().getTableHeaderColumns();if(!o)return!1;var i=o.length;if(l===this._resizeStartColumnIdx||this._resizeColumnStart&&l===this._resizeStartColumnIdx-1||!this._resizeColumnStart&&l===this._resizeStartColumnIdx+1){if(0===this._resizeStartColumnIdx&&this._resizeColumnStart)return!1;if(this._resizeStartColumnIdx===i-1&&!this._resizeColumnStart)return!1;var s=this.component._getTableDomUtils().getTableHeaderColumnResizeIndicator();if(null!=s){if("rtl"===this.component._GetReadingDirection()){var n=e.target.getBoundingClientRect();this._resizeColumnStart?s.style.left=this._getPageX(e)-n.left+n.width+"px":s.style.left=this._getPageX(e)-n.left+"px"}else s.style.left=this._getPageX(e)+"px";return!0}}return!1},e.TableResizeUtils.prototype.handleHeaderColumnResizeStart=function(e){var t=this.component._getEventTargetElement(e),l=this.component._getTableDomUtils().getElementColumnIdx(t);if(null!=l){var o=this.component._getColumnDefs()[l];if(this._resizeColumnStart=this._isHeaderColumnResizeStart(e),o.resizable===this.component._OPTION_ENABLED&&null!==this._resizeColumnStart)return this._resizeStartColumnIdx=l,this._resizeStartPageX=this._getPageX(e),this._setTableHeaderColumnsResizeStyling(),this._setTableHeaderColumnResizeIndicator(l),!0}return this._resizeStartColumnIdx=null,this._resizeStartPageX=null,!1},e.TableResizeUtils.prototype.handleHeaderColumnResizeEnd=function(e){var l=this.component._getEventTargetElement(e),o=this.component._getTableDomUtils().getElementColumnIdx(l);if(null!==o&&o===this._resizeStartColumnIdx||this._resizeColumnStart&&o===this._resizeStartColumnIdx-1||!this._resizeColumnStart&&o===this._resizeStartColumnIdx+1){var i=this.component._getTableDomUtils().getTableHeaderColumn(this._resizeStartColumnIdx);if(null!=i){var s,n=i.getBoundingClientRect().width;if(s=this._resizeColumnStart?this._resizeStartPageX-this._getPageX(e):this._getPageX(e)-this._resizeStartPageX,Math.abs(s)>2){for(var a=n+s,r=[],_=this.options.columns.length,h=0;h<_;h++)r[h]=t.extend({},{},this.options.columns[h]);if(r[this._resizeStartColumnIdx].width=a,this._resizeColumnStart){var u=this._resizeStartColumnIdx-1,d=this.component._getTableDomUtils().getTableHeaderColumn(u);if(d){var S=d.getBoundingClientRect().width;r[u].width=S-s}}return this.component.option("columns",r,{_context:{writeback:!0,internalSet:!0}}),this.component._clearCachedMetadata(),this.component._refresh(),this.clearTableHeaderColumnsResize(),!0}}}return this.clearTableHeaderColumnsResize(),!1},e.TableResizeUtils.prototype.clearTableHeaderColumnsResize=function(){this._resizeStartColumnIdx=null,this._resizeColumnStart=null,this._resizeStartPageX=null,this._clearTableHeaderColumnsResizeStyling(),this.component._getTableDomUtils().removeTableHeaderColumnResizeIndicator()},e.TableResizeUtils.prototype._getPageX=function(e){return void 0!==e.pageX?e.pageX:void 0!==e.changedTouches?e.changedTouches[0].pageX:0},e.TableResizeUtils.prototype._isHeaderColumnResizeStart=function(t){var l=null,o=this.component._getTableDomUtils().getElementColumnIdx(t.target),i=this.component._getTableDomUtils().getTableHeaderColumn(o);if(null!=i){var s=i.getBoundingClientRect(),n=Math.abs(this._getPageX(t)-s.left),a=Math.abs(this._getPageX(t)-s.right);n<=e.TableResizeUtils.RESIZE_OFFSET?l="rtl"!==this.component._GetReadingDirection():a<=e.TableResizeUtils.RESIZE_OFFSET&&(l="rtl"===this.component._GetReadingDirection())}return l},e.TableResizeUtils.prototype._setTableHeaderColumnResizeIndicator=function(e){var t=this.component._getTableDomUtils().getTableHeaderColumnResizeIndicator();null==t&&(t=this.component._getTableDomUtils().createTableHeaderColumnResizeIndicator());var l=this.component._getTableDomUtils().getTable().getBoundingClientRect(),o=this.component._getTableDomUtils().getTableHeaderColumn(e).getBoundingClientRect(),i=t.getBoundingClientRect();t.style.height=l.height+"px",this._resizeColumnStart?("rtl"===this.component._GetReadingDirection()?t.style.left=o.left-i.left+o.width+"px":t.style.left=-1*i.left+o.left+"px",t.style.borderLeftWidth="2px",t.style.borderRightWidth="0"):("rtl"===this.component._GetReadingDirection()?t.style.left=o.left-i.left+"px":t.style.left=-1*i.left+o.left+o.width+"px",t.style.borderRightWidth="2px",t.style.borderLeftWidth="0")},e.TableResizeUtils.prototype._setTableHeaderColumnsResizeStyling=function(){this.component._getTableDomUtils().getTable().classList.add(e.TableResizeUtils.CSS_CLASSES._COLUMN_HEADER_RESIZING_CLASS)},e.TableResizeUtils.prototype._clearTableHeaderColumnsResizeStyling=function(){var t,l=this.component._getTableDomUtils().getTableHeaderColumns();if(l)for(t=0;t<l.length;t++)l[t].style.cursor="";this.component._getTableDomUtils().getTable().classList.remove(e.TableResizeUtils.CSS_CLASSES._COLUMN_HEADER_RESIZING_CLASS)},e.TableResizeUtils.RESIZE_OFFSET=10,e.TableResizeUtils.CSS_CLASSES={_COLUMN_HEADER_RESIZING_CLASS:"oj-table-column-header-resizing"},h.extension._WIDGET_NAME="ojTable",h.extension._GLOBAL_TRANSFER_ATTRS=["aria-label"],h.extension._INNER_ELEM="table",e.CustomElementBridge.register("oj-table",{metadata:h})});