/**
 * @license
 * Copyright (c) 2014, 2019, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
define(["ojs/ojcore","jquery","ojs/ojconfig","ojs/ojtranslation","ojL10n!ojtranslations/nls/localeElements","ojs/ojlocaledata","ojs/ojvalidation-base","ojs/ojlogger"],function(e,r,t,n,i,a,o,s){e.NumberConverter=function(){this.Init()},e.Object.createSubclass(e.NumberConverter,e.Converter,"oj.NumberConverter"),e.NumberConverter.prototype.Init=function(r){e.NumberConverter.superclass.Init.call(this,r)},e.NumberConverter.prototype.format=function(r){return e.NumberConverter.superclass.format.call(this,r)},e.NumberConverter.prototype.parse=function(r){return e.NumberConverter.superclass.parse.call(this,r)},e.NumberRangeValidator=function(e){this.Init(e)},e.Object.createSubclass(e.NumberRangeValidator,e.Validator,"oj.NumberRangeValidator"),e.NumberRangeValidator.prototype.Init=function(r){e.NumberRangeValidator.superclass.Init.call(this),r&&(this._min=r.min,this._max=r.max,this._converter=o.IntlConverterUtils.getConverterInstance(r.converter),this._hint=r.hint||{},this._customMessageSummary=r.messageSummary||{},this._customMessageDetail=r.messageDetail||{})},e.NumberRangeValidator.prototype.validate=function(r){var t=r?r.toString():r,i=parseFloat(t),a=this._customMessageSummary,o=this._customMessageDetail,s=o.rangeOverflow,u=o.rangeUnderflow,l=o.exact,m=a.rangeOverflow,c=a.rangeUnderflow,g=void 0!==this._min?parseFloat(this._min):null,p=void 0!==this._max?parseFloat(this._max):null,v=g&&this._converter?this._converter.format(g):g,d=p&&this._converter?this._converter.format(p):p,f="",y="",h=null,b=n;if(null===r)return r;if(null!==g&&null!==p){if(i>=g&&i<=p||g>p)return t}else if(null!==g){if(i>=g)return t}else if(null===p||i<=p)return t;throw null!==p&&null!==g&&g===p?(h={value:r,num:d},y=l?b.applyParameters(l,h):b.getTranslatedString("oj-validator.range.number.messageDetail.exact",h),i>p?f=m||b.getTranslatedString("oj-validator.range.number.messageSummary.rangeOverflow"):i<g&&(f=m?c:b.getTranslatedString("oj-validator.range.number.messageSummary.rangeUnderflow"))):null!==p&&i>p?(h={value:r,max:d},f=m||b.getTranslatedString("oj-validator.range.number.messageSummary.rangeOverflow"),y=s?b.applyParameters(s,h):b.getTranslatedString("oj-validator.range.number.messageDetail.rangeOverflow",h)):(h={value:r,min:v},f=c||b.getTranslatedString("oj-validator.range.number.messageSummary.rangeUnderflow"),y=u?b.applyParameters(u,h):b.getTranslatedString("oj-validator.range.number.messageDetail.rangeUnderflow",h)),new e.ValidatorError(f,y)},e.NumberRangeValidator.prototype.getHint=function(){var e=null,r=this._hint,t=r.inRange,i=r.exact,a=r.min,o=r.max,s=n,u=void 0!==this._min?parseFloat(this._min):null,l=void 0!==this._max?parseFloat(this._max):null,m=u&&this._converter?this._converter.format(u):u,c=l&&this._converter?this._converter.format(l):l;return null!==u&&null!==l?e=u!==l?t?s.applyParameters(t,{min:m,max:c}):s.getTranslatedString("oj-validator.range.number.hint.inRange",{min:m,max:c}):i?s.applyParameters(i,{num:m}):s.getTranslatedString("oj-validator.range.number.hint.exact",{num:m}):null!==u?e=a?s.applyParameters(a,{min:m}):s.getTranslatedString("oj-validator.range.number.hint.min",{min:m}):null!==l&&(e=o?s.applyParameters(o,{max:c}):s.getTranslatedString("oj-validator.range.number.hint.max",{max:c})),e},e.NumberConverterFactory=function(){return{createConverter:function(r){return function(r){return new e.IntlNumberConverter(r)}(r)}}}(),o.Validation.__registerDefaultConverterFactory(e.ConverterFactory.CONVERTER_TYPE_NUMBER,e.NumberConverterFactory),e.NumberRangeValidatorFactory=function(){return{createValidator:function(r){return function(r){return new e.NumberRangeValidator(r)}(r)}}}(),o.Validation.__registerDefaultValidatorFactory(e.ValidatorFactory.VALIDATOR_TYPE_NUMBERRANGE,e.NumberRangeValidatorFactory);var u={};u.NumberConverter=e.NumberConverter,u.NumberRangeValidator=e.NumberRangeValidator,u.IntlNumberConverter=e.IntlNumberConverter,e.IntlNumberConverter=function(e){this.Init(e)},e.Object.createSubclass(e.IntlNumberConverter,e.NumberConverter,"oj.IntlNumberConverter"),e.IntlNumberConverter.prototype.Init=function(r){e.IntlNumberConverter.superclass.Init.call(this,r)},e.IntlNumberConverter.prototype._getWrapped=function(){return this._wrapped||(this._wrapped=l.getInstance()),this._wrapped},e.IntlNumberConverter.prototype.format=function(r){if(null==r||"string"==typeof r&&0===e.StringUtils.trim(""+r).length||"number"==typeof r&&isNaN(r))return o.IntlConverterUtils.__getNullFormattedValue();var n=t.getLocale(),i=a.__getBundle(),s=this.resolvedOptions();try{return this._getWrapped().format(r,i,s,n)}catch(e){throw this._processConverterError(e,r)}},e.IntlNumberConverter.prototype.getHint=function(){return null},e.IntlNumberConverter.prototype.getOptions=function(){return e.IntlNumberConverter.superclass.getOptions.call(this)},e.IntlNumberConverter.prototype.parse=function(r){var n,i,o;if(null==r||""===r)return null;n=t.getLocale(),i=a.__getBundle(),o=this.resolvedOptions();try{return this._getWrapped().parse(e.StringUtils.trim(r),i,o,n)}catch(e){throw this._processConverterError(e,r)}},e.IntlNumberConverter.prototype.resolvedOptions=function(){var r,n=t.getLocale();if(n!==this._locale||!this._resolvedOptions){r=e.LocaleData.__getBundle();try{if(!r)return s.error("locale bundle for the current locale %s is unavailable",n),{};this._resolvedOptions=this._getWrapped().resolvedOptions(r,this.getOptions(),n),this._locale=n}catch(e){throw this._processConverterError(e)}}return this._resolvedOptions},e.IntlNumberConverter.prototype._processConverterError=function(r,t){var i,a,s,u,l=r.errorInfo;if(l){var m=l.errorCode,c=l.parameterMap;switch(e.Assert.assertObject(c),m){case"optionTypesMismatch":case"optionTypeInvalid":case"optionOutOfRange":case"optionValueInvalid":i=o.IntlConverterUtils.__getConverterOptionError(m,c);break;case"decimalFormatMismatch":s="oj-converter.number.decimalFormatMismatch.summary";break;case"currencyFormatMismatch":s="oj-converter.number.currencyFormatMismatch.summary";break;case"percentFormatMismatch":s="oj-converter.number.percentFormatMismatch.summary";break;case"unsupportedParseFormat":u=n.getTranslatedString("oj-converter.number.shortLongUnsupportedParse.summary"),a=n.getTranslatedString("oj-converter.number.shortLongUnsupportedParse.detail"),i=new e.ConverterError(u,a)}s&&(u=n.getTranslatedString(s,{value:t||c.value,format:c.format}),a=n.getTranslatedString("oj-converter.hint.detail",{exampleValue:this._getHintValue()}),i=new e.ConverterError(u,a))}return i||(u=r.message,a=r.message,i=new e.ConverterError(u,a)),i},e.IntlNumberConverter.prototype._getHintValue=function(){var r="";try{r=this.format(12345.98765)}catch(t){t instanceof e.ConverterError&&(r="",s.error("error retrieving hint value in format"))}return r};var l=function(){var r,t=/^[+-]?infinity$/i,n=/^[+-]?\d*\.?\d*(e[+-]?\d+)?$/,i=/([^+-.0-9]*)([+-]?\d*\.?\d*(E[+-]?\d+)?).*$/,a=/([\^$.*+?|\[\](){}])/g,o=/(^0\.0*)([^0].*$)/,u=/^0+$/,l={trillion:[1e14,1e13,1e12],billion:[1e11,1e10,1e9],million:[1e8,1e7,1e6],thousand:[1e5,1e4,1e3]},m={trillion:1e12,billion:1e9,million:1e6,thousand:1e3},c={HALF_UP:"ceil",HALF_DOWN:"floor",DEFAULT:"round"},g=1024,p=1048576,v=1073741824,d=1099511627776;function f(e,r,t){var n;for(n=e.length;n<r;n+=1)e=t?"0"+e:e+"0";return e}function y(e,r,t,n,i){var a=e[r];return void 0!==a?(a=Number(a),(isNaN(a)||a<t||a>n)&&function(e,r,t,n){var i=new RangeError(e+" is out of range.  Enter a value between "+r+" and "+t+" for "+n),a={errorCode:"numberOptionOutOfRange",parameterMap:{value:e,minValue:r,maxValue:t,propertyName:n}};throw i.errorInfo=a,i}(a,t,n,r),Math.floor(a)):i}function h(e){var r=e||"en-US",t=r.indexOf("-u-nu-"),n="latn";return-1!==t&&(n=r.substr(t+6,4)),n}function b(r,t,n,i){var a,o=t,u=e.OraI18nUtils.getLocaleElementsMainNode(r),l=function(e,r){if(void 0===r)return"latn";var t=h(r),n="symbols-numberSystem-"+t;return void 0===e.numbers[n]&&(t="latn"),t}(u,i);o.numberingSystemKey=l,o.numberingSystem="symbols-numberSystem-"+l;var m=n.lenientParse;if(o.lenientParse=m||"full",o.style=n.style,void 0!==n.pattern&&n.pattern.length>0)a=n.pattern;else{var c;switch(o.style){case"decimal":c="decimalFormats-numberSystem-";break;case"currency":c="currencyFormats-numberSystem-";break;case"percent":c="percentFormats-numberSystem-";break;default:c="decimalFormats-numberSystem-"}c+=o.numberingSystemKey,a=u.numbers[c].standard;var g=n.decimalFormat;void 0===g&&(g=n.currencyFormat),void 0===g||"decimal"!==o.style&&"currency"!==o.style||(o.shortDecimalFormat=u.numbers["decimalFormats-numberSystem-latn"][g].decimalFormat)}var p=u.numbers[o.numberingSystem].decimal,v=u.numbers[o.numberingSystem].group,d=n.separators;if(void 0!==d){o.separators=d;var f=d.decimal,b=d.group;void 0!==f&&""!==f&&(p=d.decimal),void 0!==b&&(v=d.group)}var S=e.OraI18nUtils.getLocaleElementsMainNodeKey(r),I=S.split("-")[0];if(o.plurals=r.supplemental.plurals,o.lang=I,o.pat=a,o.minusSign=u.numbers[o.numberingSystem].minusSign,o.decimalSeparator=p,o.exponential=u.numbers[o.numberingSystem].exponential,o.groupingSeparator=v,o.currencyDisplay=n.currencyDisplay,void 0!==n.currency&&(o.currencyCode=n.currency.toUpperCase()),void 0!==n.unit&&(o.unit=n.unit.toLowerCase()),function(e,r,t,n){for(var i,a=n,o=!1,s=!1,u=0,l=0,m=!0,c=1;c>=0&&l<r.length;--c){var g=!1,p="",v="",d=-1,f=1,y=0,h=0,b=0,S=-1,I=-1,x=0;m=!0;for(var D=l;D<r.length;++D){var N=r.charAt(D);switch(x){case 0:case 2:if(g){if(N===H){D+1<r.length&&r.charAt(D+1)===H?(D+=1,m?p=p.concat("''"):v=v.concat("''")):g=!1;continue}}else{if(N===A||N===j||N===P||N===V){x=1,D-=1;continue}if(N===W){void 0===e.currency&&F("style"),a.style="currency";var O=D+1<r.length&&r.charAt(D+1)===W;O&&(D+=1),m?p=p.concat(O?"'¤¤":"'¤"):v=v.concat(O?"'¤¤":"'¤");continue}if(N===H){if(N===H){D+1<r.length&&r.charAt(D+1)===H?(D+=1,m?p=p.concat("''"):v=v.concat("''")):g=!0;continue}}else{if(N===L){0!==x&&0!==c||q(r),l=D+1,D=r.length;continue}if(N===R){a.style="percent",1!==f&&q(r),a.isPercent=!0,f=100,m?p=p.concat("'%"):v=v.concat("'%");continue}if(N===T){1!==f&&q(r),a.style="perMill",a.isPerMill=!0,f=1e3,m?p=p.concat("'‰"):v=v.concat("'‰");continue}if(N===k){m?p=p.concat("'-"):v=v.concat("'-");continue}}}m?p=p.concat(N):v=v.concat(N);break;case 1:if(1!==c){0===(u-=1)&&(x=2,m=!1);continue}if(u+=1,N===A)h>0?b+=1:y+=1,S>=0&&d<0&&(S+=1);else if(N===j)b>0&&q(r),h+=1,S>=0&&d<0&&(S+=1);else if(N===P)I=S,S=0;else{if(N!==V){if(Y=D,J=$,void 0,void 0,Q=r.substr(Y,J.length),null!==new RegExp(J,"i").exec(Q)){for(s&&q(r),s=!0,i=0,D+=$.length;D<r.length&&r.charAt(D)===j;)i+=1,u+=1,D+=1;(y+h<1||i<1)&&q(r),x=2,m=!1,D-=1;continue}x=2,m=!1,D-=1,u-=1;continue}d>=0&&q(r),d=y+h+b}}}if(0===h&&y>0&&d>=0){var _=d;0===_&&(_+=1),b=y-_,y=_-1,h=1}if((d<0&&b>0||d>=0&&(d<y||d>y+h)||0===S||g)&&q(r),1===c){E=w=p,M=U=v;var C=y+h+b,z=d>=0?d:C;a.minimumIntegerDigits=z-y,a.maximumIntegerDigits=s?y+a.minimumIntegerDigits:G,a.maximumFractionDigits=d>=0?C-d:0,a.minimumFractionDigits=d>=0?y+h-d:0,a.groupingSize=S>0?S:0,a.groupingSize0=I}else E=p,M=v,o=!0}var Y,J,Q;0===r.length&&(w="",U="",a.minimumIntegerDigits=0,a.maximumIntegerDigits=G,a.minimumFractionDigits=0,a.maximumFractionDigits=K);a.useExponentialNotation=s,a.minExponentDigits=i,(!o||0===E.localeCompare(w)&&0===M.localeCompare(U))&&("currency"===a.style&&"ar"===a.lang?(M=U+"'‏-",E=w):(M=U,E="'-"+w));!function(e,r){var t=r,n={};null!==w&&(t.positivePrefix=B(w,e,t,n));null!==U&&(t.positiveSuffix=B(U,e,t,n));null!==E&&(t.negativePrefix=B(E,e,t,n));null!==M&&(t.negativeSuffix=B(M,e,t,n));void 0!==n.name&&(t.positiveSuffix=" "+n.name,t.positivePrefix="","ar"===t.lang?(t.negativeSuffix=e.numbers[t.numberingSystem].minusSign+" "+n.name,t.negativePrefix=""):(t.negativeSuffix=" "+n.name,t.negativePrefix=e.numbers[t.numberingSystem].minusSign))}(t,a)}(n,a,u,o),void 0===n.pattern&&(o.minimumIntegerDigits=y(n,"minimumIntegerDigits",1,21,o.minimumIntegerDigits),void 0!==n.maximumFractionDigits&&(o.maximumFractionDigits=y(n,"maximumFractionDigits",0,20,o.maximumFractionDigits),o.maximumFractionDigits<o.minimumFractionDigits&&(o.minimumFractionDigits=o.maximumFractionDigits)),void 0!==n.minimumFractionDigits&&(o.minimumFractionDigits=y(n,"minimumFractionDigits",0,20,o.minimumFractionDigits)),o.maximumFractionDigits<o.minimumFractionDigits&&(o.maximumFractionDigits=o.minimumFractionDigits,s.info("maximumFractionDigits is less than minimumFractionDigits, so maximumFractionDigits will be set to minimumFractionDigits")),"currency"===o.style&&void 0===n.minimumFractionDigits)){var x=r.supplemental.currencyData.fractions[n.currency];if(void 0!==x){var D=parseInt(x._digits,10);o.minimumFractionDigits=D,o.maximumFractionDigits=D}}}function F(e){var r=new TypeError('The property "currency" is required when the property "'+e+'" is "currency". An accepted value is a three-letter ISO 4217 currency code.'),t={errorCode:"optionTypesMismatch",parameterMap:{propertyName:e,propertyValue:"currency",requiredPropertyName:"currency",requiredPropertyValueValid:"a three-letter ISO 4217 currency code"}};throw r.errorInfo=t,r}function S(r,t){var n=e.OraI18nUtils.getGetOption(r,t),i=n("style","string",["currency","decimal","percent","unit","perMill"],"decimal");if("decimal"===i||"currency"===i){var a="decimal"===i?"decimalFormat":"currencyFormat";i=n(a,"string",["standard","short","long"]),"OraNumberConverter.parse"===t&&void 0!==i&&"standard"!==i&&function(e){var r=new Error("long and short "+e+" are not supported for parsing"),t={errorCode:"unsupportedParseFormat",parameterMap:{shortFormats:e}};throw r.errorInfo=t,r}(a)}var o=n("currency","string");"currency"===i&&void 0===o&&F("style"),o=n("unit","string"),"unit"===i&&void 0===o&&function(e){var r=new TypeError('The property "unit" is required when the property "'+e+'" is "unit". An accepted value is "byte" or "bit".'),t={errorCode:"optionTypesMismatch",parameterMap:{propertyName:e,propertyValue:"unit",requiredPropertyName:"unit",requiredPropertyValueValid:"byte or bit"}};throw r.errorInfo=t,r}("style")}function I(e,r,t){var n=t.groupingSize,i=t.groupingSize0,a=t.decimalSeparator,o=e+"",s=o.split(/e/i),l=s.length>1?parseInt(s[1],10):0,m=(s=(o=s[0]).split(".")).length>1?s[1]:"",c=Math.min(t.maximumFractionDigits,m.length-l);s.length>1&&m.length>l&&(e=x(e,c,r.roundingMode||"DEFAULT"));l=(s=(o=e+"").split(/e/i)).length>1?parseInt(s[1],10):0,o=(s=(o=s[0]).split("."))[0],m=s.length>1?s[1]:"",l>0?(o+=(m=f(m,l,!1)).slice(0,l),m=m.substr(l)):l<0&&(m=(o=f(o,(l=-l)+1,!0)).slice(-l,o.length)+m,o=o.slice(0,-l)),c>0&&m.length>0?(m=m.length>c?m.slice(0,c):f(m,c,!1),!0===u.test(m)&&(m=m.slice(0,t.minimumFractionDigits)),m=a+m):m=t.minimumFractionDigits>0?a:"",m=f(m,a.length+t.minimumFractionDigits,!1);var g=t.groupingSeparator,p="";!1===r.useGrouping&&void 0===r.pattern&&(g="");var v=(o=f(o,t.minimumIntegerDigits,!0)).length-1;for(m=m.length>1?m:"";v>=0;){if(0===n||n>v)return o.slice(0,v+1)+(p.length?g+p+m:m);p=o.slice(v-n+1,v+1)+(p.length?g+p:""),v-=n,i>0&&(n=i)}return o.slice(0,v+1)+g+p+m}function x(e,r,t){var n=e.toString().split(".");if(void 0===n[1])return e;if("5"===n[1][r]&&"DEFAULT"!==t){var i=function(e,r,t){if("HALF_DOWN"===t||"HALF_EVEN"===t){var n=e.substr(r);(n=parseInt(n,10))>5&&(t="HALF_UP")}return t}(n[1],r,t);return function(e,r,t,n){if(0===r)return"5"===n[1][0]?Math[t](e):Math.round(e);var i=e.toString().split("e"),a=i[0],o=i[1],s=a+"e"+(o?parseInt(o,10)-r:-r),u=parseFloat(s),l=Math[t](u);return i=l.toString().split("e"),a=i[0],o=i[1],s=a+"e"+(o?parseInt(o,10)+r:r),u=parseFloat(s)}(e,-r,i=function(e,r,t){var n=c[r];if("HALF_EVEN"===r){var i;if(0===t){var a=e[0].length;i=parseInt(e[0][a-1],10)}else i=parseInt(e[1][t-1],10);n=i%2==0?c.HALF_DOWN:c.HALF_UP}return n}(n,i,r),n)}var a=Math.pow(10,r),o=Math.round(e*a)/a;return isFinite(o)?o:e}function D(r,t,n,i,a){var s=e.OraI18nUtils.getLocaleElementsMainNode(n);if(!isFinite(r))return r===1/0?s.numbers[i.numberingSystem].infinity:r===-1/0?s.numbers[i.numberingSystem].infinity:s.numbers[i.numberingSystem].nan;var u=Math.abs(r);!0===i.isPercent||"percent"===i.style?u*=100:!0===i.isPerMill&&(u*=1e3);var c=t.decimalFormat;void 0===c&&(c=t.currencyFormat);var y=i.style;u="decimal"!==y&&"currency"!==y||void 0===c||"standard"===c?!0===i.useExponentialNotation?function(e,r){var t=e+"",n=0,i=t.split(/e/i),a=i[0];o.lastIndex=0;var s=o.exec(a);null!==s?(n=s[1].length-1,a=s[2]):a=a.replace(".","");var u=i.length>1?parseInt(i[1],10):0,l=parseInt(a,10),m=r.minimumIntegerDigits+r.maximumFractionDigits;if(a.length>m){m-=a.length;var c=Math.pow(10,m);l=Math.round(l*c)}var g=r.minimumIntegerDigits+r.minimumFractionDigits;l=f(l+="",g,!1),-1!==t.indexOf(".")?u-=r.minimumIntegerDigits-t.indexOf(".")+n:u-=g-a.length-r.minimumFractionDigits;var p=Math.abs(u);p=f(p+"",r.minExponentDigits,!0),u<0&&(p=r.minusSign+p);var v=l.slice(0,r.minimumIntegerDigits);return l.slice(r.minimumIntegerDigits).length>0?v+=r.decimalSeparator+l.slice(r.minimumIntegerDigits)+r.exponential+p:v+=r.exponential+p,v}(u,i):"unit"===y?function(r,t,n,i){var a,o;r>=d?(a="digital-tera",o=r/d):r>=v?(a="digital-giga",o=r/v):r>=p?(a="digital-mega",o=r/p):r>=g?(a="digital-kilo",o=r/g):(a="digital-",o=r),a+=n.unit;var s=n.lang,u=n.plurals[s](o);u="unitPattern-count-"+u;var l=I(o,t,n),m=i.units.narrow[a][u];return l=e.OraI18nUtils.formatString(m,[l])}(u,t,i,s):I(u,t,i):function(e,r,t){var n,i,a,o=function(e){for(var r=Object.keys(l),t=0;t<r.length;t++)for(var n=r[t],i=l[n].length,a=0;a<i;a++)if(l[n][a]<=e)return[n,l[n][a]];return[e,null]}(e),s="";if(null!==o[1]){var u=t.lang,c=t.plurals[u](Math.floor(e/m[o[0]]));if(n=o[1]+"-count-"+c,void 0===(n=t.shortDecimalFormat[n])&&(c="other",n=o[1]+"-count-"+c,n=t.shortDecimalFormat[n]),a=(i=function(e){var r=0,t=0,n=0,i="";if("0"!==e[0]){for(;"0"!==e[r]&&r<e.length;)r+=1;i=e.substr(0,r),n=r}for(r=n;r<e.length&&"0"===e[r];r++)t+=1;return[i,t]}(n))[1],s=i[0],a<n.length){var g=1*Math.pow(10,a);e/=g=o[1]/g*10}}var p="";return void 0!==n&&(p=n.substr(a+i[0].length)),p=s+I(e,r,t)+(p=p.replace(/'\.'/g,"."))}(u,t,i);var b="";b+=r<0&&u-0!=0?i.negativePrefix+u+i.negativeSuffix:i.positivePrefix+u+i.positiveSuffix;var F=h(a);if(void 0===e.OraI18nUtils.numeringSystems[F]&&(F="latn"),"latn"!==F){var S,x=[];for(S=0;S<b.length;S++)b[S]>="0"&&b[S]<="9"?x.push(e.OraI18nUtils.numeringSystems[F][b[S]]):x.push(b[S]);return x.join("")}return b}function N(r,t){var n=t.groupingSeparator,a=t.decimalSeparator,o=t.minusSign,s="",u="",l=e.OraI18nUtils.toUpper(t.exponential),m=e.OraI18nUtils.toUpper(r),c=n;m=(m=m.split(l).join("E")).split(c).join("");var g=c.replace(/\u00A0/g," ");c!==g&&(m=m.split(g).join("")),"."===(m=m.split(a).join(".")).charAt(0)&&(m=m.substr(1),u="."),m=m.replace(o,"-");var p=u+i.exec(m)[2];return e.OraI18nUtils.startsWith(p,"-")?(p=p.substr("-".length),s="-"):e.OraI18nUtils.startsWith(m,"+")&&(p=p.substr("+".length),s="+"),[s,p]}function O(r,t,n,i){return isNaN(r)&&_(n.style,n,i),!0===n.isPercent||"percent"===n.style?r/=100:!0===n.isPerMill&&(r/=1e3),e.OraI18nUtils.getGetOption(t,"OraNumberConverter.parse")("roundDuringParse","boolean",[!0,!1],!1)&&(r=function(e,r,t){var n=r.maximumFractionDigits,i=e<0,a=t.roundingMode||"DEFAULT",o=x(Math.abs(e),n,a);return i?-o:o}(r,n,t)),r}function _(e,r,t){var n,i="Unparsable number "+t+" The expected number pattern is "+r.pat;switch(e){case"decimal":n="decimalFormatMismatch";break;case"currency":n="currencyFormatMismatch";break;case"percent":n="percentFormatMismatch"}var a=new Error(i),o={errorCode:n,parameterMap:{value:t,format:r.pat}};throw a.errorInfo=o,a}function C(r,i,o,s){var u=e.OraI18nUtils.getLocaleElementsMainNode(i),l={},m=function(r,t){var n,i=h(t);if(void 0===e.OraI18nUtils.numeringSystems[i])return r;var a=[];for(n=0;n<r.length;n++){var o=e.OraI18nUtils.numeringSystems[i].indexOf(r[n]);-1!==o?a.push(o):a.push(r[n])}return a.join("")}(r,s);b(i,l,o,s);var c=NaN,g=m.replace(/ /g,"");if(t.test(g))return c=parseFloat(m);var p=function(r,t,n,i){var o,s=e.OraI18nUtils.trimNumber(r),u="",l=!1,m=i.numbers[n.numberingSystem].plusSign,c=new RegExp("^"+m.replace(a,"\\$1"));s=s.replace(c,"");var g=e.OraI18nUtils.trimNumber(n.positivePrefix),p=e.OraI18nUtils.trimNumber(n.positiveSuffix),v=e.OraI18nUtils.trimNumber(n.negativePrefix),d=e.OraI18nUtils.trimNumber(n.negativeSuffix),f=new RegExp("^"+(g||"").replace(a,"\\$1")),y=new RegExp((p||"").replace(a,"\\$1")+"$"),h=new RegExp("^"+(v||"").replace(a,"\\$1")),b=new RegExp((d||"").replace(a,"\\$1")+"$");if(!0===h.test(s)&&!0===b.test(s))s=(s=s.replace(h,"")).replace(b,""),u="-",l=!0;else if(!0===f.test(s)&&!0===y.test(s))s=(s=s.replace(f,"")).replace(y,""),u="+",l=!0;else if("currency"===n.style){var F,S=n.currencyCode,I=S;if(void 0!==i.numbers.currencies[S]&&(I=i.numbers.currencies[S].symbol),void 0===n.currencyDisplay||"symbol"===n.currencyDisplay?F=I:"code"===n.currencyDisplay&&(F=S),void 0!==F){var x=(g||"").replace(F,""),D=(p||"").replace(F,""),O=(v||"").replace(F,""),C=(d||"").replace(F,"");f=new RegExp(("^"+x).replace(a,"\\$1")),y=new RegExp(D.replace(a,"\\$1")+"$"),h=new RegExp(("^"+O).replace(a,"\\$1")),b=new RegExp(C.replace(a,"\\$1")+"$"),!0===h.test(s)&&!0===b.test(s)?(s=(s=s.replace(h,"")).replace(b,""),u="-",l=!0):!0===f.test(s)&&!0===y.test(s)&&(s=(s=s.replace(f,"")).replace(y,""),u="+",l=!0)}}return l?o=[u,s]:"full"===n.lenientParse?(o=N(s,n))[2]=!0:_(n.style,n,r),o}(m,0,l,u),v=p[0],d=p[1];if(v=v||"+",p[2])return O(c=parseFloat(v+d),o,l,r);var f=function(r,t){var n,i,a={},o=t.decimalSeparator,s=t.groupingSeparator,u=r.replace(/ /g,""),l=t.exponential,m=u.indexOf(l.toLowerCase());m<0&&(m=u.indexOf(e.OraI18nUtils.toUpper(l))),m<0?(i=u,a.exponent=null):(i=u.substr(0,m),a.exponent=u.substr(m+l.length));var c=o,g=i.indexOf(c);g<0?(n=i,a.fraction=null):(n=i.substr(0,g),a.fraction=i.substr(g+c.length)),n=n.split(s).join("");var p=s.replace(/\u00A0/g," ");return s!==p&&(n=n.split(p).join("")),a.integer=n,a}(d,l),y=f.integer,F=f.fraction,S=f.exponent,I=v+y;if(null!==F&&(I+="."+F),null!==S){var x=function(r,t){var n,i=t.minusSign,a=t.plusSign,o=e.OraI18nUtils.trimNumber(r);return i=e.OraI18nUtils.trimNumber(i),a=e.OraI18nUtils.trimNumber(a),e.OraI18nUtils.startsWith(o,i)?n=["-",o.substr(i.length)]:e.OraI18nUtils.startsWith(o,e.OraI18nUtils.trimNumber(a))&&(n=["+",o.substr(a.length)]),n||["",o]}(S,l);I+="e"+(x[0]||"+")+x[1]}return n.test(I)?c=parseFloat(I):"full"===l.lenientParse?(I=N(m,l),c=parseFloat(I[0]+I[1])):_(l.style,l,r),O(c,o,l,r)}var w,U,E,M,j="0",P=",",V=".",R="%",T="‰",A="#",L=";",$="E",k="-",H="'",W="¤",G=2147483647,K=2147483647;function q(e){var r=new SyntaxError('Unexpected character(s) encountered in the pattern "'+e+' An example of a valid pattern is "#,##0.###".'),t={errorCode:"optionValueInvalid",parameterMap:{propertyName:"pattern",propertyValue:e,propertyValueHint:"#,##0.###"}};throw r.errorInfo=t,r}function B(e,r,t,n){for(var i="",a=0;a<e.length;){var o=e.charAt(a);if(a+=1,o!==H){switch(o){case W:var s=t.currencyCode,u=s,l=s;void 0!==r.numbers.currencies[s]&&(u=r.numbers.currencies[s].displayName,l=r.numbers.currencies[s].symbol),void 0===t.currencyDisplay||"symbol"===t.currencyDisplay?o=l:"code"===t.currencyDisplay?o=s:(o=u,n.name=o);break;case R:o=r.numbers[t.numberingSystem].percentSign;break;case T:o=r.numbers[t.numberingSystem].perMille;break;case k:o=r.numbers[t.numberingSystem].minusSign}i=i.concat(o)}}return i}function z(){return{format:function(e,r,t,n){(arguments.length<=2||void 0===t)&&(t={useGrouping:!0,style:"decimal"}),S(t,"OraNumberConverter.format");var i={};return b(r,i,t,n),D(e,t,r,i,n)},parse:function(e,r,t,n){return"number"==typeof e?e:"[object Number]"===Object.prototype.toString.call(e)?Number(e):((arguments.length<=2||void 0===t)&&(t={useGrouping:!0,style:"decimal"}),S(t,"OraNumberConverter.parse"),C(e,r,t,n))},resolvedOptions:function(r,t,n){return(arguments.length<3||void 0===n)&&(n=e.OraI18nUtils.getLocaleElementsMainNodeKey(r)),(arguments.length<2||void 0===t)&&(t={useGrouping:!0,style:"decimal"}),function(e,r,t){var n={locale:t,style:void 0===e.style?"decimal":e.style,useGrouping:void 0===r.useGrouping||r.useGrouping,numberingSystem:e.numberingSystemKey};n.minimumIntegerDigits=e.minimumIntegerDigits,n.minimumFractionDigits=e.minimumFractionDigits,n.maximumFractionDigits=e.maximumFractionDigits,"decimal"===e.style&&void 0!==r.decimalFormat&&(n.decimalFormat=r.decimalFormat),"currency"===e.style&&void 0!==r.currencyFormat&&(n.currencyFormat=r.currencyFormat),"currency"===e.style&&(n.currency=r.currency,n.currencyDisplay=void 0===r.currencyDisplay?"symbol":r.currencyDisplay),void 0!==r.unit&&(n.unit=r.unit),void 0!==r.pattern&&(n.pattern=r.pattern);var i=r.roundingMode,a=r.roundDuringParse;void 0!==i&&(n.roundingMode=i),void 0!==a&&(n.roundDuringParse=a);var o=e.lenientParse;void 0!==o&&(n.lenientParse=o);var s=e.separators;return void 0!==s&&(n.separators=s),n}(function(r,t,n){var i={};return S(t,"OraNumberConverter.resolvedOptions"),b(r,i,t,n),i.numberingSystemKey=h(n),void 0===e.OraI18nUtils.numeringSystems[i.numberingSystemKey]&&(i.numberingSystemKey="latn"),i}(r,t,n),t,n)}}}return{getInstance:function(){return r||(r=z()),r}}}();return u});